unit nes;

interface
uses sdl, m6502, windows, constantes, nes_ppu, forms, entradas, sysutils, zipforge, arcade_const, timers;

Type
TPalType = array[0..63, 1..3] of byte;

const
  Palette : TPalType =
    {Alex Krasivsky's Palette}
    (
    ($68,$68,$68),($00,$40,$80),($00,$00,$80),($40,$00,$80),
    ($80,$00,$80),($80,$00,$40),($80,$00,$00),($55,$00,$00),
    ($40,$40,$00),($33,$50,$00),($00,$50,$00),($00,$50,$00),
    ($00,$40,$40),($00,$00,$00),($00,$00,$00),($00,$00,$00),
    ($98,$98,$98),($00,$80,$C0),($40,$40,$C0),($80,$00,$C0),
    ($C0,$00,$C0),($C0,$00,$80),($C0,$20,$20),($C0,$40,$00),
    ($80,$80,$00),($55,$80,$00),($00,$80,$00),($33,$80,$33),
    ($00,$80,$80),($00,$00,$00),($00,$00,$00),($00,$00,$00),
    ($D0,$D0,$D0),($40,$C0,$FF),($80,$80,$FF),($C0,$40,$FF),
    ($FF,$00,$FF),($FF,$40,$C0),($FF,$50,$50),($FF,$80,$40),
    ($C0,$C0,$00),($80,$C0,$00),($00,$C0,$00),($55,$C0,$55),
    ($00,$C0,$C0),($33,$33,$33),($00,$00,$00),($00,$00,$00),
    ($FF,$FF,$FF),($80,$FF,$FF),($C0,$C0,$FF),($FF,$80,$FF),
    ($FF,$40,$FF),($FF,$80,$FF),($FF,$80,$80),($FF,$C0,$80),
    ($FF,$FF,$40),($C0,$FF,$40),($40,$FF,$40),($AA,$FF,$AA),
    ($40,$FF,$FF),($99,$99,$99),($00,$00,$00),($00,$00,$00)
    );

    SNDPERIOD  = 244;
    PSG_BASE = 111860;
    
var
  vrom:array[0..$3FFF] of byte;
  joy1,joy2,joy1_read,mapper:byte;
  nes_linea:word;
  color_fondo:cardinal;
  _hinst: HINST;

    { PSG register }
  SndFreq : array[0..3] of boolean;
  SndFreqVal : array[0..4] of word;
  SndLen : array[0..3] of integer;
  PSG    : array [0..$17] of byte;
  SndON  : array[0..4] of boolean;
  UPeriod,
  SndVolume,
  SndCount  : integer;

procedure Cargar_NES;
function iniciar_nes:boolean;pascal;
procedure nes_main;pascal;
function IORead(direccion:word): Byte; pascal;
procedure IOWrite(direccion:word;valor:byte);pascal;
procedure nes_cerrar;pascal;
procedure nes_reset;pascal;
procedure abrir_nes;pascal;
procedure nes_despues_instruccion;pascal;

implementation

uses principal, nes_sound;

procedure Cargar_NES;
begin
form1.Panel2.Visible:=true;
form1.BitBtn9.visible:=false;
form1.BitBtn10.Enabled:=true;
form1.imagelist2.GetBitmap(2,form1.BitBtn10.Glyph);
form1.BitBtn10.visible:=true;
form1.BitBtn10.OnClick:=form1.fLoadCartucho;
form1.BitBtn11.visible:=true;
form1.BitBtn12.visible:=false;
form1.BitBtn14.visible:=false;
form1.NES1.Checked:=true;
llamadas_maquina.caption:='NES';
llamadas_maquina.iniciar:=iniciar_nes;
llamadas_maquina.bucle_general:=nes_main;
llamadas_maquina.cerrar:=nes_cerrar;
llamadas_maquina.reset:=nes_reset;
llamadas_maquina.cartuchos:=abrir_nes;
llamadas_maquina.fps_max:=60;
llamadas_maquina.canales_usados:=0;
end;


function iniciar_nes:boolean;pascal;
var
  temp,f:byte;
  colores:tpaleta;
begin
p_final[0].x:=256;
p_final[0].y:=240;
iniciar_video;
getmem(main_6502,sizeof(reg_6502));
main_6502_ll.getbyte:=IORead;
main_6502_ll.putbyte:=IOWrite;
main_6502.numero_cpu:=0;
timer[0].cpu:=0;
timer[0].tiempo:=1;
timer[0].ejecutar:=nes_despues_instruccion;
timer[0].enabled:=true;
temp:=0;

for f:=0 to 63 do begin
  colores[f].r:=Palette[f, 1];
  colores[f].g:=Palette[f, 2];
  colores[f].b:=Palette[f, 3];
  end;

poner_paleta(colores,64);
abrir_nes;
_hinst:= getmodulehandle(nil);
SndON[0]:= true;
SndON[1]:= true;
SndON[2]:= true;
SndON[3]:= true;
SndON[4]:= true; //PCM
SndVolume:= 200; //volume
SetVolume(0, 200);
InitSound(_hinst, 44, 255); //inicia o som
iniciar_nes:=true;
end;

procedure eventos_nes;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then joy1_read:=joy1_read or $10 else joy1_read:=joy1_read and $EF;
  if (teclado[SDLK_DOWN] or joystick.abajo) then joy1_read:=joy1_read or $20 else joy1_read:=joy1_read and $DF;
  if (teclado[SDLK_LEFT] or joystick.izq) then joy1_read:=joy1_read or $40 else joy1_read:=joy1_read and $BF;
  if (teclado[SDLK_RIGHT] or joystick.der) then joy1_read:=joy1_read or $80 else joy1_read:=joy1_read and $7F;
  if teclado[SDLK_LCTRL] then joy1_read:=joy1_read or $1 else joy1_read:=joy1_read and $FE;
  if teclado[SDLK_LALT] then joy1_read:=joy1_read or $2 else joy1_read:=joy1_read and $FD;
  if teclado[SDLK_Z] then joy1_read:=joy1_read or $8 else joy1_read:=joy1_read and $F7;
  if teclado[SDLK_X] then joy1_read:=joy1_read or $4 else joy1_read:=joy1_read and $FB;
end;
end;

  { gestione suono }
Procedure Sound;
var
  ch,
  freq : integer;
  freqS : byte;
begin
  dec(SndCount);

  if SndCount<=0 then
  begin
    SndCount := SndPeriod;
    for ch := 0 to 3 do
    begin
      if (SndLen[ch]<>0) and (SndOn[ch]) then
      begin
        if SndFreq[ch] then
        begin
          freqS := (((PSG[ch * 4 + 1] shr 4) and $07)) * ((PSG[ch + 4 + 1] and $07));
          if (PSG[ch * 4 + 1] and $08)<>0 then
            dec(SndFreqVal[ch], freqS )
          else
            inc(SndFreqVal[ch], freqS);
          freq := PSG_BASE div (SndFreqVal[ch] + 1);
          SetFreq(ch, freq and $03FF);
        end;
        dec(SndLen[ch]);
        if SndLen[ch]=0 then
        begin
          SetVolume(ch, 0);
          PSG[$15] := PSG[$15] and not(1 shl ch);
        end;
      end;
    end;
  end;
end;

procedure nes_main;pascal;
begin
iniciar_entradas;
while EmuStatus=EsRuning do begin
  nes_linea:=0;
  while nes_linea<239 do begin
    run_6502(main_6502,main_6502_ll,114);
    dec(main_6502.contador,114);
    ppu_linea;
    inc(nes_linea);
  end;
  if (ppu_control1 and $80)=$80 then main_6502.pedir_nmi:=true;
  ppu_status:=ppu_status or $80;
  putsprites(false);
  //ejecutar vblank
  while nes_linea<261 do begin
    run_6502(main_6502,main_6502_ll,114);
    dec(main_6502.contador,114);
    inc(nes_linea);
  end;
  ppu_status:=ppu_status and $3f;
  actualiza_video;
  sound;
  //form1.statusbar1.Panels[2].Text:=inttostr(scroll_x)+' - '+inttostr(scroll_y);
  eventos_nes;
  sincronizar;
  evaluar_entradas;
end;
end;

function IORead(direccion:word): Byte; pascal;
begin
case direccion of
        $0..$1FFF:IORead:=memoria[direccion and $7FF];
        $2002:begin
                IORead:=ppu_status;
                //el bit de vblank y el de sptite hit
                //se elimina cuando se lee el registro
                ppu_status:=ppu_status and $3f;
                ppu_scroll_first:=true;
                ppu_dir_first:=true;
              end;
        $2007:begin
                if ppu_firstread then begin
                  ppu_firstread:=false;
                  IORead:=$FF;
                  exit;
                end;
                IORead:=vrom[ppu_adress.w];
                if (ppu_control1 and 4)<>0 then inc(ppu_adress.w,32)
                  else inc(ppu_adress.w);
                ppu_adress.w:=ppu_adress.w and $3fff;
                end;
        { PGS }
        $4000..$4013, $4015 : Result := PSG[direccion - $4001];
        $4016:begin
                case joy1 of
                  0..7:IORead:=(joy1_read shr joy1) and 1;
                end;
                joy1:=(joy1+1) mod 8;
              end;
         $4017:begin
                case joy2 of
                  0..7:IORead:=(joy1_read shr joy2) and 1;
                end;
                joy2:=(joy2+1) mod 8;
              end;
        $4018..$FFFF:IORead:=memoria[direccion];
end;
end;

procedure IOWrite(direccion:word;valor:byte);pascal;
var
  len : integer;
  freq,
  ch : WORD;
begin
  case direccion of
        0..$1FFF:memoria[direccion and $7FF]:=valor;
        $2000..$3FFF:case (direccion and 7) of
          0:begin
                ppu_control1:=valor;
                if (valor and $10)=$10 then pos_bg:=1
                  else pos_bg:=0;
                if (valor and $8)=$8 then pos_spt:=1
                  else pos_spt:=0;
                case (ppu_control1 and 3) of
                  0:begin
                      PPU[0]:=$2000;
                      PPU[1]:=$2400;
                      PPU[2]:=$2800;
                    end;
                  1:begin
                      PPU[0]:=$2400;
                      PPU[1]:=$2000;
                      PPU[2]:=$2c00;
                    end;
                  2:begin
                      PPU[0]:=$2800;
                      PPU[1]:=$2c00;
                      PPU[2]:=$2000;
                    end;
                  3:begin
                      PPU[0]:=$2c00;
                      PPU[1]:=$2800;
                      PPU[2]:=$2400;
                    end;
                end;
              end;
        1:ppu_control2:=valor;
        2:ppu_status:=valor;
        3:sprite_ram_pos:=valor;
        4:begin
                sprite_ram[sprite_ram_pos]:=valor;
                inc(sprite_ram_pos);
              end;
        5:if ppu_dir_first then begin
                  scroll_x2:=(valor and 7);
                  PPU_Adress.w:=(PPU_Adress.w And $FFE0) Or (valor div 8);
                  ppu_dir_first:=false;
                end else begin
                  PPU_Adress.w:=(PPU_Adress.w And $8C1F) Or (valor And $F8) * 4 Or (valor And 7) * $1000;
                  scroll_y:=valor;
                  if scroll_y>240 then scroll_y:=0;
                  ppu_dir_first:=true;
                end;
        6:if ppu_dir_first then begin
                ppu_adress.h:=valor;
                ppu_firstread:=true;
                ppu_dir_first:=false;
              end else begin
                ppu_adress.l:=valor;
                ppu_firstread:=true;
                ppu_dir_first:=true;
              end;
        7:begin
                ppu_write(ppu_adress.w,valor);
                if (ppu_control1 and $4)=$4 then inc(ppu_adress.w,32)
                  else inc(ppu_adress.w);
                ppu_adress.w:=ppu_adress.w and $3fff;
                ppu_firstread:=false;
              end;
        end;
 { PSG }
    $4000,
    $4004,
    $4008,
    $400C : begin
              PSG[direccion - $4000] := valor;
            end;
    $4001 : begin
              PSG[direccion - $4000] := valor;
              SndFreq[0] := (valor and $80)<>0;
            end;
    $4005 : begin
              PSG[direccion - $4000] := valor;
              SndFreq[1] := (valor and $80)<>0;
            end;
    $4009 : begin
              PSG[direccion - $4000] := valor;
              SndFreq[2] := (valor and $80)<>0;
            end;
    $400D : begin
              PSG[direccion - $4000] := valor;
              SndFreq[3] := (valor and $80)<>0;
            end;
    $4002,
    $4003 : begin
              direccion := direccion - $4000;
              PSG[direccion] := valor;
              SndFreqVal[0] := ((PSG[$03] and 7) shl 8) or PSG[$02];
              freq := SndFreqVal[0];
              freq := PSG_BASE div (freq + 1);
              len  := (PSG[$03] shr 3);
              SetFreq(0, freq);
              if (SndON[0]) then
                 SetVolume(0, SndVolume)
              else
                 SetVolume(0, 0);
              SndLen[0] := (len + 1) * 8;
            end;
    $4006,
    $4007 : begin
              direccion := direccion - $4000;
              PSG[direccion] := valor;
              SndFreqVal[1] := ((PSG[$07] and 7) shl 8) or PSG[$06];
              freq := SndFreqVal[1];
              freq := PSG_BASE div (freq + 1);
              len  := (PSG[$07] shr 3);
              SetFreq(1, freq);
              if (SndON[1]) then
                 SetVolume(1, SndVolume)
              else
                 SetVolume(1, 0);
              SndLen[1] := (len + 1) * 8;
            end;
    //Triangle
    $400A,
    $400B : begin
              direccion := direccion - $4000;
              PSG[direccion] := valor;
              SndFreqVal[2] := ((PSG[$0B] and 7) shl 8) or PSG[$0A];
              freq := SndFreqVal[2];
              freq := PSG_BASE div (freq + 1);
              len  := (PSG[$0B] shr 3);
              SetFreq(2, freq);
              if (SndON[2]) then
                SetVolume(2, SndVolume)
              else
                SetVolume(2, 0);
              SndLen[2] := len + 2;
            end;
    $400E,
    $400F : begin
              direccion := direccion - $4000;
              PSG[direccion] := valor;
              SndFreqVal[3] := ((PSG[$0F] and 7) shl 8) or PSG[$0E];
              freq := SndFreqVal[3];
              freq := PSG_BASE div (freq + 1);
              len  := (PSG[$0F] shr 3);
              SetFreq(3, freq);
              if (len<>0) or (SndON[3]) then
                 SetVolume(3, SndVolume)
              else
                 SetVolume(3, 0);
              SndLen[3] := len;
            end;
    { PCM }
    $4010,
    $4011,
    $4012,
    $4013 : begin
            PSG[direccion - $4000] := valor;
            SndFreqVal[4] := ((PSG[$0E] and 7) shl 8) or PSG[$00];
            freq := SndFreqVal[4];
            freq := PSG_BASE div (freq + 1);
            len  := (PSG[$00] shr 3);
            SetFreq(4, freq);
             if (len<>0) or (SndON[4]) then
                SetVolume(4, SndVolume)
              else
                SetVolume(4, 0);
            end;
        $4014:ppu_dma_spr(valor);
        $4016:joy1:=0;
        $4917:joy2:=0;
        $8000..$FFFF:exit;
  else memoria[direccion]:=valor;
end;
end;

procedure nes_reset;pascal;
begin
reset_6502(main_6502,main_6502_ll);
ppu_dir_first:=false;
reset_ppu;
joy1:=0;
joy2:=0;
ResetSnd;
end;

procedure nes_cerrar;pascal;
begin
cerrar_cpus;
TrashSound;
end;

procedure nes_despues_instruccion;pascal;
begin
if sprite_ram[4]=nes_linea then ppu_status:=ppu_status or $40
    else ppu_status:=ppu_status and $bf;
end;

procedure abrir_nes;pascal;
var
  fichero:file of byte;
  cabecera_nes:array[0..$F] of byte;
  mal:boolean;
  nombre, RomFile:string;
  datos,temp:pbyte;
  ArchiveItem: TZFArchiveItem;
  zip_obj:tzipforge;
begin
mal:=true;

  RomFile:= Form1.OpenRom(StNes);
  
  nombre:=extension_fichero(RomFile);
  if nombre='ZIP' then begin
    zip_obj:=tzipforge.Create(nil);
    zip_obj.CleanupInstance;
    zip_obj.FileName:=  RomFile;
    zip_obj.OpenArchive;
    zip_obj.FindFirst('*.nes',archiveitem);
    nombre:=archiveitem.FileName;
    getmem(datos,archiveitem.UncompressedSize);
    temp:=datos;
    zip_obj.ExtractTobuffer(archiveitem.FileName,temp^,archiveitem.UncompressedSize);
    temp:=datos;
    zip_obj.CloseArchive;
    zip_obj.Destroy;
  end else begin
    nombre:=extractfilename(RomFile);
    assignfile(fichero, RomFile);
    reset(fichero);
    getmem(datos,filesize(fichero));
    temp:=datos;
    blockread(fichero,temp^,filesize(fichero)-1);
    closefile(fichero);
  end;
  copymemory(@cabecera_nes[0],temp,$10);
  inc(temp,$10);
  if (cabecera_nes[6] and 1)<>1 then begin
    mhorizontal:=false;
    mvertical:=true;
  end else begin
    mhorizontal:=true;
    mvertical:=false;
  end;
  mapper:=(cabecera_nes[6] shr 4) or (cabecera_nes[7] and $f0);
  case mapper of
    0,64:begin
        copymemory(@memoria[$8000],temp,$4000);
        inc(temp,$4000);
        if cabecera_nes[4]=1 then copymemory(@memoria[$c000],@memoria[$8000],$4000)
          else begin
              copymemory(@memoria[$c000],temp,$4000);
              inc(temp,$4000);
          end;
        copymemory(@vrom[0],temp,$2000);
        mal:=false;
      end;
     else MessageBox(0,'Error: Mapper unknown!!!', 'ERROR', MB_OK or MB_ICONSTOP);
  end;
  freemem(datos);
  convertir_chars;

if not(mal) then begin
  child.Caption:='NES - '+nombre;
  nes_reset;
  reset_ppu;
  end;
end;


end.
