unit LoadRom;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Grids, Buttons;

type
  TFLoadRom = class(TForm)
    GroupBox1: TGroupBox;
    ImgPreview: TImage;
    gpxrominfo: TGroupBox;
    RomList: TStringGrid;
    BitBtn3: TBitBtn;
    BitBtn1: TBitBtn;
    procedure RomListDblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure RomListClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure BitBtn3Click(Sender: TObject);
  private
    procedure init_game_desc;
    { Private declarations }
  public
    Procedure dirs (Romd, Previewf: String);
    { Public declarations }
  end;

var
  FLoadRom: TFLoadRom;
  Rdir,Pdir:String;

implementation

uses init_games, principal;

{$R *.dfm}

procedure show_picture;
var
  dir:string;
begin
dir:=ChangeFileExt(Floadrom.RomList.Cells[1,Floadrom.RomList.Selection.Top], '.JPG'); //Modifiquei aqui, pois o salvamento padro do game esta pelo nome comercial e no pelo zip 
if FileExists(Pdir + '\'+dir) then
    Floadrom.ImgPreview.Picture.LoadFromFile(Pdir + '\'+dir)
      else Floadrom.ImgPreview.Picture.LoadFromFile(Pdir + '\preview.bmp');
end;

procedure TFLoadRom.FormKeyUp(Sender: TObject; var Key: Word;Shift: TShiftState);
begin
case key of
  13:begin
    Close;
    FLoadRom.RomListDblClick(nil);
  end;
  38,40:show_picture;
end;
end;

procedure TFLoadRom.FormShow(Sender: TObject);
begin
if not FileExists(Pdir+'\preview.BMP') then begin
   ImgPreview.Canvas.Brush.Color:=clBlue;
   ImgPreview.Canvas.Font.Color:=clwhite;
   ImgPreview.Canvas.Font.Size:=12;
   ImgPreview.Canvas.TextOut(70, 80, 'Image not Loaded!');
   ImgPreview.Picture.SaveToFile(Pdir + '\Preview.bmp');
end;
show_picture;
init_game_desc;
end;

procedure TFLoadRom.init_game_desc;
var
  f:word;
begin
with RomList do begin
  RowCount:=games_cont+1;
  Visible:=true;
  Cells[0,0]:='ROM';
  Cells[1,0]:='Driver Name';
  Cells[2,0]:='Year';
  Cells[3,0]:='Sound';
  Cells[4,0]:='Hi-Score';
  for f:=1 to games_cont do begin
    if fileexists(Rdir+'\'+games_desc[f].zip) then cells[0,f]:='OK'
      else cells[0,f]:='NO';
    Cells[1,f]:=games_desc[f].name;
    Cells[2,f]:=games_desc[f].year;
    if games_desc[f].snd then cells[3,f]:='OK'
      else cells[3,f]:='NO';
    if games_desc[f].hi then cells[4,f]:='OK'
      else cells[4,f]:='NO';
  end;
end;
end;

procedure TFLoadRom.BitBtn1Click(Sender: TObject);
begin
floadrom.close;
end;

procedure TFLoadRom.BitBtn3Click(Sender: TObject);
begin
FLoadRom.RomListDblClick(nil);
end;

procedure TFLoadRom.dirs(Romd, Previewf: String);
begin
Rdir:=Romd;
Pdir:=Previewf;
end;

procedure TFLoadRom.RomListDblClick(Sender: TObject);
begin
floadrom.close;
//Si es la misma maquina debe continuar, sino que ejecute la nueva
if tipo_maquina=games_grid[Floadrom.RomList.Selection.Top] then form1.ejecutar1click(nil)
  else load_game(RomList.Selection.Top);
end;

procedure TFLoadRom.RomListClick(Sender: TObject);
begin
show_picture;
end;

end.
