unit tap_tzx;  //version 3.1

interface
uses z80,Windows,Forms,dialogs,constantes,spectrum_misc,principal,grids,sysutils,zlibex,lenguaje,cargar_spec;

const tabla_tzx:array[1..8] of byte=(128,64,32,16,8,4,2,1);

type
      tipo_datos_tzx=record
           tipo_bloque:byte;
           lcabecera:word;
           lsinc1:word;
           lsinc2:word;
           lcero:word;
           luno:word;
           ltono_cab:word;
           lbyte:byte;
           lpausa:word;
           lbloque:integer;
           salta_bloque:smallint;
           datos:Pbyte;
           crc32:dword;
           checksum:byte;
           pulsos_sym:array[0..$FF,0..$1F] of word;
           inicial:byte;
          end;
       tipo_cinta_tzx=record
            es_tap:boolean;
            play_tape:boolean;
            cargada:boolean;
            play_once:boolean;
            en_pausa:boolean;
            datos_tzx:array[0..$2FFF] of tipo_datos_tzx;
          end;

var
 cinta_tzx:tipo_cinta_tzx;
 indice_saltos,indice_select:array[0..$2FFF] of word;
 indice_cinta,indice_vuelta,indice_llamadas:word;
 tzx_contador_datos,datos_totales:integer;
 grupo:boolean;
 tzx_estado_actual,tzx_bit_actual,tzx_ultimo_bit,tzx_contador_loop:byte;
 tzx_temp,tzx_pulsos:dword;
 estados_tzx,tzx_estados_necesarios:longword;
 tzx_datos_p:PByte;
 ear:byte;

procedure vaciar_cintas;
procedure play_cinta_tap(r:preg_z80);
procedure play_cinta_tzx;
procedure siguiente_bloque_tzx;
function abrir_tap(datos:pbyte;long:integer):boolean;
function abrir_tzx(data:pbyte;long:integer):boolean;
function abrir_csw(data:pbyte;long:integer):boolean;
function abrir_wav(data:pbyte;long:integer):boolean;
function abrir_pzx(data:pbyte;long:integer):boolean;

implementation

procedure play_cinta_tzx;
var
  temp_jump:smallint;
  ptemp:pbyte;
begin
if estados_tzx<=tzx_estados_necesarios then exit;
mensaje_general:='    '+leng[idioma].mensajes[1]+': '+inttostr(datos_totales);
dec(estados_tzx,tzx_estados_necesarios);
if cinta_tzx.en_pausa then begin
  inc(indice_cinta);
  if cinta_tzx.es_tap then rapido:=false;
  siguiente_bloque_tzx;
  cinta_tzx.en_pausa:=false;
  exit;
end;
if cinta_tzx.es_tap then begin
  cinta_tzx.es_tap:=false;
  rapido:=true;
end;
case cinta_tzx.datos_tzx[indice_cinta].tipo_bloque of
        $10,$11,$14:begin //cargas normal, turbo y datos puros
                   case tzx_estado_actual of
                        0:begin   {cabecera}
                            Ear:=Ear Xor 64;
                            If tzx_temp<cinta_tzx.datos_tzx[indice_cinta].ltono_cab  Then begin
                                tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].lcabecera;
                                inc(tzx_temp);
                            end else begin
                                tzx_temp:=0;
                                if tzx_datos_p<>nil then begin
                                  tzx_estado_actual:=1;
                                  tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].lsinc1;
                                end else tzx_estado_actual:=4;
                            end;
                          end;
                        1:begin  {sync 1}
                                Ear:=Ear Xor 64;
                                tzx_estado_actual:=2;
                                tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].lsinc2;
                          end;
                        2:begin  {sync 2}
                                Ear:=Ear Xor 64;
                                tzx_estado_actual:=3;
                                if (tzx_datos_p^ and 128)<>0 then tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].luno
                                        else tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].lcero;
                                tzx_bit_actual:=128;
                                tzx_pulsos:=2;
                                tzx_ultimo_bit:=1;
                          end;
                        3:begin  {datos}
                                Ear:=Ear Xor 64;
                                dec(tzx_pulsos); {hago la forma de la onda)}
                                if tzx_pulsos=0 then begin
                                  if tzx_bit_actual>tzx_ultimo_bit then begin {no estoy en el ultimo bit}
                                        tzx_bit_actual:=tzx_bit_actual shr 1; {pillo el siguiente}
                                        tzx_pulsos:=2;
                                        if (tzx_datos_p^ and tzx_bit_actual)<>0 then tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].luno
                                           else tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].lcero;
                                  end else begin {estoy en el ultimo bit}
                                      inc(tzx_contador_datos);
                                      inc(datos_totales);
                                      inc(tzx_datos_p); {incremento el byte en los datos}
                                      if tzx_contador_datos<cinta_tzx.datos_tzx[indice_cinta].lbloque then begin  {se ha acabado?}
                                        if tzx_contador_datos=(cinta_tzx.datos_tzx[indice_cinta].lbloque-1) then tzx_ultimo_bit:=tabla_tzx[cinta_tzx.datos_tzx[indice_cinta].lbyte] else tzx_ultimo_bit:=1;
                                        tzx_bit_actual:=128;
                                        tzx_pulsos:=2;
                                        if (tzx_datos_p^ and 128)<>0 then tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].luno
                                           else tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].lcero;
                                      end else begin   {pasar al otro bloque}
                                        tzx_estados_necesarios:= cinta_tzx.datos_tzx[indice_cinta].lpausa*(llamadas_maquina.velocidad_cpu div 1000);
                                        cinta_tzx.en_pausa:=true;
                                      end;
                                  end;
                                end else if (tzx_datos_p^ and tzx_bit_actual)<>0 then tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].luno
                                           else tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].lcero;
                                           {no ha completado la onda}
                          end;
                        4:cinta_tzx.en_pausa:=true;
                   end; {del estado_actual}
                 end;
        $12:begin //tono puro
                Ear:=Ear Xor 64;
                If tzx_temp<cinta_tzx.datos_tzx[indice_cinta].ltono_cab Then begin
                        tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].lcabecera;
                        inc(tzx_temp);
                end else begin
                  inc(indice_cinta);
                  siguiente_bloque_tzx;
                end;
            end;
         $13:begin //secuencia de pulsos
                Ear:=Ear Xor 64;
                if tzx_pulsos<cinta_tzx.datos_tzx[indice_cinta].lbloque then begin
                        inc(tzx_pulsos);
                        tzx_estados_necesarios:=tzx_datos_p^;
                        inc(tzx_datos_p);
                        tzx_estados_necesarios:=tzx_estados_necesarios+256*tzx_datos_p^;
                        inc(tzx_datos_p);
                end else begin
                  inc(indice_cinta);
                  siguiente_bloque_tzx;
                end;
            end;
        $15:case tzx_estado_actual of  //direct recording
            0:begin
                if tzx_bit_actual>tzx_ultimo_bit then begin {no estoy en el ultimo bit}
                  tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].luno;
                  tzx_bit_actual:=tzx_bit_actual shr 1; {pillo el siguiente}
                  if (tzx_datos_p^ and tzx_bit_actual)<>0 then ear:=64 else ear:=0;
                end else begin {estoy en el ultimo bit}
                  tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].luno;
                  inc(tzx_contador_datos);
                  inc(datos_totales);
                  inc(tzx_datos_p); {incremento el byte en los datos}
                  if tzx_contador_datos<cinta_tzx.datos_tzx[indice_cinta].lbloque then begin  {se ha acabado?}
                    if tzx_contador_datos=(cinta_tzx.datos_tzx[indice_cinta].lbloque-1) then tzx_ultimo_bit:=tabla_tzx[cinta_tzx.datos_tzx[indice_cinta].lbyte] else tzx_ultimo_bit:=1;
                    tzx_bit_actual:=128;
                    if (tzx_datos_p^ and 128)<>0 then ear:=64 else ear:=0;
                  end else begin   {pasar al otro bloque}
                    tzx_estados_necesarios:= cinta_tzx.datos_tzx[indice_cinta].lpausa*(llamadas_maquina.velocidad_cpu div 1000);
                    cinta_tzx.en_pausa:=true;
                  end;
                end;
               end;
            end;
        $19:begin  {datos especiales}
                Ear:=Ear Xor 64;
                dec(tzx_pulsos); {hago la forma de la onda)}
                if tzx_pulsos=0 then begin
                  if tzx_bit_actual>tzx_ultimo_bit then begin {no estoy en el ultimo bit}
                    tzx_bit_actual:=tzx_bit_actual shr 1; {pillo el siguiente}
                  if (tzx_datos_p^ and tzx_bit_actual)<>0 then begin
                    tzx_pulsos:=cinta_tzx.datos_tzx[indice_cinta].luno;
                    tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].pulsos_sym[1,tzx_pulsos];
                  end else begin
                    tzx_pulsos:=cinta_tzx.datos_tzx[indice_cinta].lcero;
                    tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].pulsos_sym[0,tzx_pulsos];
                  end;
                end else begin {estoy en el ultimo bit}
                    inc(tzx_contador_datos);
                    inc(datos_totales);
                    inc(tzx_datos_p); {incremento el byte en los datos}
                    if tzx_contador_datos<cinta_tzx.datos_tzx[indice_cinta].lbloque then begin  {se ha acabado?}
                    if tzx_contador_datos=(cinta_tzx.datos_tzx[indice_cinta].lbloque-1) then tzx_ultimo_bit:=tabla_tzx[cinta_tzx.datos_tzx[indice_cinta].lbyte] else tzx_ultimo_bit:=1;
                    tzx_bit_actual:=128;
                    if (tzx_datos_p^ and tzx_bit_actual)<>0 then begin
                      tzx_pulsos:=cinta_tzx.datos_tzx[indice_cinta].luno;
                      tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].pulsos_sym[1,tzx_pulsos];
                    end else begin
                      tzx_pulsos:=cinta_tzx.datos_tzx[indice_cinta].lcero;
                      tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].pulsos_sym[0,tzx_pulsos];
                    end;
                  end else begin  //bit final
                    tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].lpausa*(llamadas_maquina.velocidad_cpu div 1000);
                    cinta_tzx.en_pausa:=true;
                  end;
                end;
                end else if (tzx_datos_p^ and tzx_bit_actual)<>0 then tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].pulsos_sym[1,tzx_pulsos]
                  else tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].pulsos_sym[0,tzx_pulsos];
            end;
        $20,$21,$22,$28,$2a,$30,$31,$32,$33,$35,$5a:begin
              inc(indice_cinta);
              siguiente_bloque_tzx;
            end;
        $23:begin  //saltar a bloque
                inc(indice_cinta,cinta_tzx.datos_tzx[indice_cinta].salta_bloque);
                siguiente_bloque_tzx;
            end;
        $26:begin  //Call sequence
              if indice_llamadas<cinta_tzx.datos_tzx[indice_vuelta].lbloque then begin
                ptemp:=cinta_tzx.datos_tzx[indice_vuelta].datos;
                inc(ptemp,indice_llamadas*2);
                temp_jump:=smallint(sacar_word(ptemp));
                inc(indice_cinta,temp_jump);
                inc(indice_llamadas);
              end else inc(indice_cinta);
              siguiente_bloque_tzx;
            end;
        else siguiente_bloque_tzx;
end;  {del tipo}
end;

procedure siguiente_bloque_tzx;
var
        p:tgridrect;
        f:byte;
        cadena:string;
        ptemp:pbyte;
begin
if not(grupo) then begin
    datos_totales:=0;
    p:=form1.StringGrid1.Selection;
    form1.StringGrid1.cells[0,p.top]:='';
    p.top:=indice_saltos[indice_cinta];
    if ((form1.StringGrid1.Row>6) and (form1.StringGrid1.Row<(form1.StringGrid1.RowCount-6)) and (tzx_contador_loop=0)) then form1.StringGrid1.TopRow:=form1.StringGrid1.Row-4;
    p.Bottom:=p.top;
    //form1.StringGrid1.cells[0,p.top]:='=>';
    fila_dibujo:=p.top;
    form1.stringgrid1.Selection:=p;
end;
tzx_temp:=0;
tzx_datos_p:=cinta_tzx.datos_tzx[indice_cinta].datos;
tzx_contador_datos:=0;
  case cinta_tzx.datos_tzx[indice_cinta].tipo_bloque of
      $10,$11:begin //datos normal y turbo
                   tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].lcabecera;
                   tzx_estado_actual:=0;
                 end;
        $12:begin  //tono puro
                   tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].lcabecera;
                   tzx_temp:=1;
                 end;
        $13:begin  //secuencias de pulsos
                tzx_estados_necesarios:=tzx_datos_p^;
                inc(tzx_datos_p);
                tzx_estados_necesarios:=tzx_estados_necesarios+256*tzx_datos_p^;
                inc(tzx_datos_p);
                tzx_pulsos:=1;
            end;
        $14:begin //datos puros
                tzx_estado_actual:=3;
                if (tzx_datos_p^ and 128)<>0 then tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].luno
                        else tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].lcero;
                tzx_bit_actual:=128;
                tzx_pulsos:=2;
                if (cinta_tzx.datos_tzx[indice_cinta].lbloque-1)=0 then tzx_ultimo_bit:=tabla_tzx[cinta_tzx.datos_tzx[indice_cinta].lbyte] else tzx_ultimo_bit:=1;
            end;
        $15:begin //direct recording
                tzx_estado_actual:=0;
                tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].luno;
                tzx_bit_actual:=128;
                if (cinta_tzx.datos_tzx[indice_cinta].lbloque-1)=0 then tzx_ultimo_bit:=tabla_tzx[cinta_tzx.datos_tzx[indice_cinta].lbyte] else tzx_ultimo_bit:=1;
            end;
        $19:begin //datos especiales
                if (tzx_datos_p^ and 128)<>0 then begin
                  tzx_pulsos:=cinta_tzx.datos_tzx[indice_cinta].luno;
                  tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].pulsos_sym[1,tzx_pulsos];
                end else begin
                  tzx_pulsos:=cinta_tzx.datos_tzx[indice_cinta].lcero;
                  tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].pulsos_sym[0,tzx_pulsos];
                end;
                tzx_bit_actual:=128;
                if (cinta_tzx.datos_tzx[indice_cinta].lbloque-1)=0 then tzx_ultimo_bit:=tabla_tzx[cinta_tzx.datos_tzx[indice_cinta].lbyte] else tzx_ultimo_bit:=1;
            end;
        $20:begin //pausa
                tzx_estados_necesarios:= cinta_tzx.datos_tzx[indice_cinta].lpausa*(llamadas_maquina.velocidad_cpu div 1000);
                if tzx_estados_necesarios=0 then form1.fStopCinta(nil);
            end;
        $21:begin //inicio grupo
                grupo:=true;
                tzx_estados_necesarios:=0;
            end;
        $22:begin //fin grupo
                grupo:=false;
                tzx_estados_necesarios:=0;
            end;
        $28,$30,$32,$33,$35,$23,$5a:tzx_estados_necesarios:=0;
        $31:begin
              cadena:='';
              ptemp:=cinta_tzx.datos_tzx[indice_cinta].datos;
              for f:=0 to cinta_tzx.datos_tzx[indice_cinta].lbloque do begin
                cadena:=cadena+chr(ptemp^);
                inc(ptemp);
              end;
              MessageDlg(cadena, mtInformation,[mbOk], 0);
            end;
        $24:begin //loop start
                tzx_contador_loop:=cinta_tzx.datos_tzx[indice_cinta].lbloque;
                inc(indice_cinta);
                siguiente_bloque_tzx;
            end;
        $25:begin //loop end
                dec(tzx_contador_loop);
                if tzx_contador_loop>0 then begin
                  indice_cinta:=cinta_tzx.datos_tzx[indice_cinta].lbloque;
                  siguiente_bloque_tzx;
                end else begin
                  inc(indice_cinta);
                  siguiente_bloque_tzx;
                end;
            end;
        $26:begin
             indice_vuelta:=indice_cinta;
             indice_llamadas:=0;
             tzx_estados_necesarios:=0;
            end;
        $27:begin
              if cinta_tzx.datos_tzx[indice_cinta+1].tipo_bloque=$22 then grupo:=false;
              indice_cinta:=indice_vuelta;
              tzx_estados_necesarios:=0;
            end;
        $2a:if tipo_maquina=0 then form1.fStopCinta(nil) //stop if 48K
              else tzx_estados_necesarios:=0;
        $fe:begin //final de la cinta, la paro y me voy al principio
              indice_cinta:=0;
              form1.StringGrid1.TopRow:=0;
              siguiente_bloque_tzx;
              cinta_tzx.play_once:=true;
              form1.fStopCinta(nil);
            end;
      end;
end;

procedure play_cinta_tap(r:preg_z80);
var
        f:word;
        checksum,dato:byte;
        tam_bloque:word;
        ptemp:Pbyte;
        bt:band_z80;
begin
rapido:=true;
cinta_tzx.es_tap:=true;
ptemp:=cinta_tzx.datos_tzx[indice_cinta].datos;
checksum:=ptemp^;
inc(ptemp);
if checksum=r.a2 then begin
    if r.de.w>cinta_tzx.datos_tzx[indice_cinta].lbloque then tam_bloque:=cinta_tzx.datos_tzx[indice_cinta].lbloque else tam_bloque:=r.de.w;
    for f:=0 to (tam_bloque-1) do begin
        dato:=ptemp^;
        spec_llamadas.putbyte(r.ix.w+f,dato);
        checksum:=checksum xor dato;
        inc(ptemp);
    end;
    r.f.c:=checksum=cinta_tzx.datos_tzx[indice_cinta].checksum;
    inc(r.ix.w,tam_bloque);
    r.de.w:=0;
end;
inc(datos_totales,cinta_tzx.datos_tzx[indice_cinta].lbloque);
bt:=r.f;r.f:=r.f2;r.f2:=bt;
r.pc.w:=$05e2;
tzx_estados_necesarios:=cinta_tzx.datos_tzx[indice_cinta].lpausa*(llamadas_maquina.velocidad_cpu div 1000);
cinta_tzx.en_pausa:=true;
end;

procedure vaciar_cintas;
var
        temp:word;
begin
form1.GroupBox1.Visible:=false;
case tipo_maquina of
  0,1,2:arregla_pos(427,0);
  3,4,5:arregla_pos(468,0);
end;
if cinta_tzx.cargada then begin
  cinta_tzx.en_pausa:=false;
  cinta_tzx.cargada:=false;
  if cinta_tzx.play_tape then cinta_tzx.play_tape:=false;
  temp:=0;
  while cinta_tzx.datos_tzx[temp].datos<>nil do begin
        freemem(cinta_tzx.datos_tzx[temp].datos);
        cinta_tzx.datos_tzx[temp].tipo_bloque:=0;
        cinta_tzx.datos_tzx[temp].datos:=nil;
        inc(temp);
  end;
  zeromemory(@indice_saltos[0],$2FFF*2);
  zeromemory(@indice_select[0],$2FFF*2);
end;
cinta_tzx.es_tap:=false;
indice_cinta:=0;
for temp:=0 to form1.stringgrid1.RowCount do form1.StringGrid1.Cells[0,temp]:='';
form1.stringgrid1.RowCount:=0;
end;

procedure analizar_tzx;
var
  indice:integer;
begin
indice:=0;
//comprobar LensLok
form1.label2.caption:='';
sd_1:=false;
lenslok.activo:=false;
lenslok.indice:=255;
while cinta_tzx.datos_tzx[indice].tipo_bloque<>$fe do begin
  case cinta_tzx.datos_tzx[indice].crc32 of
   $92DC40D8:sd_1:=true; //Camelot Warriors con SD1
   $52BA05CC:begin
              lenslok.indice:=6;
              lenslok.activo:=true;
              break;  //TT RACER
             end;
   $8B28031E:begin
              lenslok.indice:=5;
              lenslok.activo:=true;
              break;  //TOMAHAWK
             end;
   $D6F54F87:begin
              lenslok.indice:=1;
              lenslok.activo:=true;
              break;    //ART STUDIO
             end;
   $FAA60847,$DC38C227:begin
              lenslok.indice:=2;  //ELITE
              lenslok.activo:=true;
              break;
             end;
   $F278B4A0,$1B81DD6D:begin
              lenslok.indice:=0;  //ACE
              lenslok.activo:=true;
              break;
             end;
  end;
inc(indice);
end;
if ((video<>2) and lenslok.activo) then arregla_pos(0,535)
  else arregla_pos(0,440);
form1.GroupBox2.Visible:=lenslok.activo;
form1.BitBtn1.Visible:=lenslok.activo;
form1.BitBtn18.Visible:=lenslok.activo;
if lenslok.activo then begin
  form1.GroupBox3.Visible:=false;
  form1.label2.caption:='LensLok Protection Active';
end;
if sd_1 then form1.label2.caption:='SD1 Protection Active';
//buscar pokes...
end;

function abrir_tap(datos:pbyte;long:integer):boolean;
var
        f,temp:word;
        cadena:string;
        nombre_tap:array[0..10] of char;
        longitud:integer;
        tipo_bloque:byte;
        ptemp:pbyte;
begin
abrir_tap:=false;
if datos=nil then exit;
vaciar_cintas;
temp:=0;       //posicion de la cinta
longitud:=0;   //longitud que llevo
while longitud<long do begin
        cinta_tzx.datos_tzx[temp].lbloque:=sacar_word(datos);
        inc(datos,2);inc(longitud,2);
        cinta_tzx.datos_tzx[temp].tipo_bloque:=$10;
        cinta_tzx.datos_tzx[temp].lpausa:=500;
        cinta_tzx.datos_tzx[temp].lcabecera:=2168;
        cinta_tzx.datos_tzx[temp].lsinc1:=667;
        cinta_tzx.datos_tzx[temp].lsinc2:=735;
        cinta_tzx.datos_tzx[temp].lcero:=855;
        cinta_tzx.datos_tzx[temp].luno:=1710;
        cinta_tzx.datos_tzx[temp].lbyte:=8;
        tipo_bloque:=datos^;
        if tipo_bloque=0 then cinta_tzx.datos_tzx[temp].ltono_cab:=8064 else cinta_tzx.datos_tzx[temp].ltono_cab:=3220;
        if cinta_tzx.datos_tzx[temp].lbloque>0 then getmem(cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque)
          else getmem(cinta_tzx.datos_tzx[temp].datos,1);
        copymemory(cinta_tzx.datos_tzx[temp].datos,datos,cinta_tzx.datos_tzx[temp].lbloque);
        cinta_tzx.datos_tzx[temp].crc32:=calcCRC32(cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque);
        inc(datos,cinta_tzx.datos_tzx[temp].lbloque-1);inc(longitud,cinta_tzx.datos_tzx[temp].lbloque-1);
        cinta_tzx.datos_tzx[temp].checksum:=datos^;
        inc(datos);inc(longitud);
        case tipo_bloque of
                $00:begin
                        cadena:=leng[idioma].cinta[0]+': '; //cabecera
                        ptemp:=cinta_tzx.datos_tzx[temp].datos;
                        inc(ptemp);
                        copymemory(@nombre_tap,ptemp,11);
                        for f:=1 to 10 do cadena:=cadena+nombre_tap[f];
                  end;
                $ff:cadena:=leng[idioma].cinta[1]; //bytes
                else cadena:=leng[idioma].cinta[2]; //datos
        end;
        form1.stringgrid1.Cells[1,temp]:=cadena;
        form1.stringgrid1.Cells[2,temp]:=inttostr(cinta_tzx.datos_tzx[temp].lbloque);
        form1.stringgrid1.Cells[3,temp]:=inttohex(cinta_tzx.datos_tzx[temp].crc32,8);
        inc(temp);
        indice_saltos[temp]:=temp;
        indice_select[temp]:=temp;
end;
cinta_tzx.datos_tzx[temp].tipo_bloque:=$fe;
cinta_tzx.datos_tzx[temp].lbloque:=1;
getmem(cinta_tzx.datos_tzx[temp].datos,1);
form1.stringgrid1.RowCount:=temp;
fila_dibujo:=0;
cinta_tzx.play_tape:=false;
cinta_tzx.cargada:=true;
abrir_tap:=true;
siguiente_bloque_tzx;
analizar_tzx;
end;

function abrir_wav(data:pbyte;long:integer):boolean;
var
    cadena:string;
    temp,vtemp,pos:byte;
    ltemp,samples,f:integer;
    fmt,datos,salir:boolean;
    ncanales,temp2,nbits:word;
    ptemp:pbyte;
begin
abrir_wav:=false;
fmt:=false;
datos:=false;
if data=nil then exit;
vaciar_cintas;
cadena:='';
for temp:=0 to 3 do begin
        cadena:=cadena+chr(data^);
        inc(data);
end;
if cadena<>'RIFF' then exit;
inc(data,4);
cadena:='';
for temp:=0 to 3 do begin
        cadena:=cadena+chr(data^);
        inc(data);
end;
if cadena<>'WAVE' then exit;
salir:=false;
while not(salir) do begin
cadena:='';
for temp:=0 to 3 do begin
        cadena:=cadena+chr(data^);
        inc(data);
        end;
  if cadena='fmt ' then begin
    inc(data,4);
    temp2:=sacar_word(data);
    inc(data,2);
    if temp2<>1 then exit;
    ncanales:=sacar_word(data);
    if ((ncanales<>1) and (ncanales<>2)) then exit;
    inc(data,2);
    samples:=sacar_word(data);
    inc(data,2);
    samples:=sacar_word(data)*65535+samples;
    inc(data,8);
    nbits:=sacar_word(data);
    if ((nbits<>8) and (nbits<>16)) then exit;
    inc(data,2);
    if temp2<>1 then begin
      ltemp:=sacar_word(data);
      inc(data,ltemp);
    end;
    fmt:=true;
  end;
  if cadena='data' then begin
    ltemp:=sacar_word(data);
    inc(data,2);
    ltemp:=sacar_word(data)*65535+ltemp;
    inc(data,2);
    if nbits=16 then ltemp:=ltemp div 2;
    if ncanales=2 then ltemp:=ltemp div 2;
    cinta_tzx.datos_tzx[0].tipo_bloque:=$15;
    cinta_tzx.datos_tzx[0].lpausa:=0;
    cinta_tzx.datos_tzx[0].luno:=llamadas_maquina.velocidad_cpu div samples;
    cinta_tzx.datos_tzx[0].lbloque:=(ltemp div 8)+1;
    cinta_tzx.datos_tzx[0].lbyte:=0;
    getmem(cinta_tzx.datos_tzx[0].datos,cinta_tzx.datos_tzx[0].lbloque);
    ptemp:=cinta_tzx.datos_tzx[0].datos;
    vtemp:=0;
    pos:=0;
    for f:=0 to ltemp do begin
      if nbits=8 then begin
        temp:=data^;inc(data);
        if ncanales=2 then begin
          temp:=(data^+temp) div 2;inc(data);
        end;
        if temp>$80 then inc(vtemp,tabla_tzx[pos+1]);
      end else begin
        temp2:=sacar_word(data);inc(data,2);
        if ncanales=2 then begin
          temp2:=(sacar_word(data)+temp2) div 2;inc(data,2);
        end;
        if temp2>$8000 then inc(vtemp,tabla_tzx[pos+1]);
      end;
      inc(pos);
      if pos=8 then begin
        ptemp^:=vtemp;
        inc(ptemp);
        vtemp:=0;
        pos:=0;
      end;
    end;
    datos:=true;
  end;
  if (fmt and datos) then salir:=true;
end;
if (not(fmt) or not(datos)) then exit;
form1.stringgrid1.Cells[1,0]:='Wave File';
//form1.stringgrid1.Cells[0,0]:='=>';
fila_dibujo:=0;
form1.stringgrid1.Cells[2,0]:=inttostr(cinta_tzx.datos_tzx[0].lbloque);
abrir_wav:=true;
form1.stringgrid1.RowCount:=1;
cinta_tzx.datos_tzx[1].tipo_bloque:=$fe;
cinta_tzx.datos_tzx[1].lbloque:=1;
getmem(cinta_tzx.datos_tzx[1].datos,1);
cinta_tzx.play_tape:=false;
cinta_tzx.cargada:=true;
siguiente_bloque_tzx;
end;

function abrir_csw(data:pbyte;long:integer):boolean;
var
  temp,pos_bit:byte;
  contador,f:word;
  cadena:string;
  longitud:integer;
  sample_rate:dword;
  tipo_compresion,polaridad,version:byte;
  punt1,punt2,final:pbyte;
  long_final:integer;
begin
abrir_csw:=false;
if data=nil then exit;
vaciar_cintas;
cadena:='';
longitud:=0;
pos_bit:=7;
for temp:=0 to 21 do begin
        cadena:=cadena+chr(data^);
        inc(data);inc(longitud);
end;
if cadena<>'Compressed Square Wave' then exit;
inc(data);
version:=data^;
inc(data,2);inc(longitud,3);
sample_rate:=sacar_word(data);
inc(data,2);
case version of
  1:begin
      tipo_compresion:=data^;
      inc(data);
      polaridad:=(data^ and 1);
      inc(data);inc(longitud,7);
    end;
  2:begin
      sample_rate:=sample_rate+(sacar_word(data)*65535);
      inc(data,6);
      //pulsos totales
      tipo_compresion:=data^;
      inc(data);
      polaridad:=(data^ and 1);
      inc(data);
      temp:=data^;
      //descripcion del software que ha hecho el CSW
      inc(data,temp+17);inc(longitud,temp+27);
    end;
end;
cinta_tzx.datos_tzx[0].tipo_bloque:=$15;
cinta_tzx.datos_tzx[0].lpausa:=0;
cinta_tzx.datos_tzx[0].luno:=llamadas_maquina.velocidad_cpu div sample_rate;
case tipo_compresion of
  $01:final:=data;
  $02:begin
        getmem(final,long-longitud*4);
        ZDecompress(pointer(data),long-longitud,pointer(final),long_final,long-longitud);
        longitud:=0;
        long:=long_final;
        data:=final;
      end;
end;
getmem(punt1,long*10);
punt2:=punt1;
temp:=0;
long_final:=0;
while longitud<long do begin
  contador:=final^;
  inc(final);inc(longitud);
  if contador=0 then begin
    contador:=sacar_word(final);
    inc(final,2);
    contador:=contador+(sacar_word(final)*65535);
    inc(final,2);inc(longitud,4);
  end;
  for f:=0 to (contador-1) do begin
    temp:=temp+(polaridad shl pos_bit);
    dec(pos_bit);
    if pos_bit=$FF then begin
      pos_bit:=7;
      punt2^:=temp;
      inc(punt2);
      temp:=0;
      inc(long_final);
    end;
  end;
  polaridad:=polaridad xor 1;
end;
if tipo_compresion=2 then begin
  final:=data;
  freemem(final);
end;
cinta_tzx.datos_tzx[0].lbyte:=(1 shl pos_bit);
cinta_tzx.datos_tzx[0].lbloque:=long_final;
getmem(cinta_tzx.datos_tzx[0].datos,cinta_tzx.datos_tzx[0].lbloque);
copymemory(cinta_tzx.datos_tzx[0].datos,punt1,cinta_tzx.datos_tzx[0].lbloque);
freemem(punt1);
form1.stringgrid1.Cells[1,0]:='Compressed Square Wave v'+inttostr(tipo_compresion)+'.0';
//form1.stringgrid1.Cells[0,0]:='=>';
fila_dibujo:=0;
form1.stringgrid1.Cells[2,0]:=inttostr(long_final);
abrir_csw:=true;
form1.stringgrid1.RowCount:=1;
cinta_tzx.datos_tzx[1].tipo_bloque:=$fe;
cinta_tzx.datos_tzx[1].lbloque:=1;
getmem(cinta_tzx.datos_tzx[1].datos,1);
cinta_tzx.play_tape:=false;
cinta_tzx.cargada:=true;
siguiente_bloque_tzx;
end;

function abrir_tzx(data:pbyte;long:integer):boolean;
var
        f,g,h,temp,contador,inicio_grupo:word;
        temp2:dword;
        nombre_tap:array[0..29] of char;
        long_final,punto_loop:integer;
        puntero:pbyte;
        cadena,cadena2,nombre_grupo:string;
        longitud:integer;
        selector:byte;
        fin_grupo:boolean;
        t1,t2,t3,t4,t5:byte;
        tmp1,tmp2,tmp3,crc_grupo:dword;
        pulsos:array[0..$FFFF] of word;
        simbolos:array[0..$1F,0..$FF] of word;
        pulsos_total:word;
begin
abrir_tzx:=false;
if data=nil then exit;
longitud:=0;  //longitud que llevo
cadena:='';
for temp:=0 to 6 do begin
        cadena:=cadena+chr(data^);
        inc(data);inc(longitud);
end;
inc(data,3);inc(longitud,3);
if cadena<>'ZXTape!' then exit;  //si no es una cinta TZX me salgo
vaciar_cintas;
long_final:=0; //longitud total del bloque
temp:=0;      //posicion saltos, siempre se incrementa
contador:=0;  //posicion cinta, solo se incrementa si no esta en un grupo
grupo:=false;  //indica si estoy dentro de un grupo
fin_grupo:=false; //corregir posicion cuando acaba el grupo
inicio_grupo:=0;
estados_tzx:=0;
while longitud<long do begin
        cinta_tzx.datos_tzx[temp].lbloque:=0;
        selector:=data^;
        inc(data);inc(longitud);
        case selector of
                $10:begin  {carga normal con cabecera}
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$10;
                          cinta_tzx.datos_tzx[temp].lpausa:=sacar_word(data);
                          inc(data,2);
                          cinta_tzx.datos_tzx[temp].lbloque:=sacar_word(data);
                          inc(data,2);inc(longitud,4);
                          getmem(cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque);
                          copymemory(cinta_tzx.datos_tzx[temp].datos,data,cinta_tzx.datos_tzx[temp].lbloque);
                          inc(data,cinta_tzx.datos_tzx[temp].lbloque-1);inc(longitud,cinta_tzx.datos_tzx[temp].lbloque);
                          cinta_tzx.datos_tzx[temp].checksum:=data^;
                          inc(data);
                          cinta_tzx.datos_tzx[temp].lcabecera:=2168;
                          cinta_tzx.datos_tzx[temp].lsinc1:=667;
                          cinta_tzx.datos_tzx[temp].lsinc2:=735;
                          cinta_tzx.datos_tzx[temp].lcero:=855;
                          cinta_tzx.datos_tzx[temp].luno:=1710;
                          cinta_tzx.datos_tzx[temp].lbyte:=8;
                          cadena:='Datos';
                          cinta_tzx.datos_tzx[temp].ltono_cab:=3220;
                          inc(long_final,cinta_tzx.datos_tzx[temp].lbloque);
                          if ((tipo_maquina=0) or (tipo_maquina=1) or (tipo_maquina=2)) then begin
                           puntero:=cinta_tzx.datos_tzx[temp].datos;
                           if cinta_tzx.datos_tzx[temp].datos<>nil then
                           case puntero^ of
                              $00:begin
                                    cinta_tzx.datos_tzx[temp].ltono_cab:=8064;
                                    cadena:=leng[idioma].cinta[0]+':             '; //cabecera
                                    inc(puntero,2);
                                    copymemory(@cadena[11],puntero,10);
                                  end;
                              $ff:cadena:=leng[idioma].cinta[1]; //bytes
                           end;
                          end;
                       end;
                    $11:begin {carga turbo con cabecera}
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$11;
                          cinta_tzx.datos_tzx[temp].lcabecera:=sacar_word(data);
                          inc(data,2);
                          cinta_tzx.datos_tzx[temp].lsinc1:=sacar_word(data);
                          inc(data,2);
                          cinta_tzx.datos_tzx[temp].lsinc2:=sacar_word(data);
                          inc(data,2);
                          cinta_tzx.datos_tzx[temp].lcero:=sacar_word(data);
                          inc(data,2);
                          cinta_tzx.datos_tzx[temp].luno:=sacar_word(data);
                          inc(data,2);
                          cinta_tzx.datos_tzx[temp].ltono_cab:=sacar_word(data);
                          inc(data,2);
                          cinta_tzx.datos_tzx[temp].lbyte:=data^;
                          inc(data);
                          cinta_tzx.datos_tzx[temp].lpausa:=sacar_word(data);
                          inc(data,2);
                          cinta_tzx.datos_tzx[temp].lbloque:=sacar_word(data);
                          inc(data,2);
                          inc(cinta_tzx.datos_tzx[temp].lbloque,data^*65536);
                          inc(data);inc(longitud,18);
                          getmem(cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque);
                          copymemory(cinta_tzx.datos_tzx[temp].datos,data,cinta_tzx.datos_tzx[temp].lbloque);
                          inc(data,cinta_tzx.datos_tzx[temp].lbloque);inc(longitud,cinta_tzx.datos_tzx[temp].lbloque);
                          cadena:=leng[idioma].cinta[3]; //bytes turbo
                          inc(long_final,cinta_tzx.datos_tzx[temp].lbloque);
                          if ((tipo_maquina=3) or (tipo_maquina=4) or (tipo_maquina=5)) then begin
                           puntero:=cinta_tzx.datos_tzx[temp].datos;
                           if cinta_tzx.datos_tzx[temp].datos<>nil then
                           if puntero^=$2c then begin //sync byte
                            cadena:=leng[idioma].cinta[0]+':                 ';
                            inc(puntero);
                            copymemory(@cadena[11],puntero,16);
                            for f:=1 to length(cadena) do begin
                              if cadena[f]=chr(0) then cadena[f]:=' ';
                            end;
                            inc(puntero,16);
                            cadena:=cadena+'('+chr(48+(puntero^ div 10))+chr(48+(puntero^ mod 10))+')';
                           end;
                          end;
                       end;
                    $12:begin  {tono puro}
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$12;
                          cinta_tzx.datos_tzx[temp].lcabecera:=sacar_word(data);
                          inc(data,2);
                          cinta_tzx.datos_tzx[temp].ltono_cab:=sacar_word(data);
                          inc(data,2);inc(longitud,4);
                          getmem(cinta_tzx.datos_tzx[temp].datos,1);
                          cadena:=leng[idioma].cinta[4]; //Tono Puro
                          cadena2:=' ';
                        end;
                    $13:begin {secuencia de pulsos}
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$13;
                          cinta_tzx.datos_tzx[temp].lbloque:=data^;
                          inc(data);inc(longitud);
                          getmem(cinta_tzx.datos_tzx[temp].datos,(cinta_tzx.datos_tzx[temp].lbloque*2));
                          copymemory(cinta_tzx.datos_tzx[temp].datos,data,(cinta_tzx.datos_tzx[temp].lbloque*2));
                          inc(data,(cinta_tzx.datos_tzx[temp].lbloque*2));inc(longitud,(cinta_tzx.datos_tzx[temp].lbloque*2));
                          cadena:=leng[idioma].cinta[5]; //Secuencia Pulsos
                          cadena2:=' ';
                        end;
                    $14:begin  {datos puros}
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$14;
                          cinta_tzx.datos_tzx[temp].lcero:=sacar_word(data);
                          inc(data,2);
                          cinta_tzx.datos_tzx[temp].luno:=sacar_word(data);
                          inc(data,2);
                          cinta_tzx.datos_tzx[temp].lbyte:=data^;
                          inc(data);
                          cinta_tzx.datos_tzx[temp].lpausa:=sacar_word(data);
                          inc(data,2);
                          cinta_tzx.datos_tzx[temp].lbloque:=sacar_word(data);
                          inc(data,2);
                          inc(cinta_tzx.datos_tzx[temp].lbloque,data^*65536);
                          inc(data);inc(longitud,10);
                          getmem(cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque);
                          copymemory(cinta_tzx.datos_tzx[temp].datos,data,cinta_tzx.datos_tzx[temp].lbloque);
                          inc(data,cinta_tzx.datos_tzx[temp].lbloque);inc(longitud,cinta_tzx.datos_tzx[temp].lbloque);
                          cadena:=leng[idioma].cinta[6]; //Datos Puros
                          inc(long_final,cinta_tzx.datos_tzx[temp].lbloque);
                        end;
                    $15:begin  //direct recording
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$15;
                          cinta_tzx.datos_tzx[temp].luno:=sacar_word(data);
                          inc(data,2);
                          cinta_tzx.datos_tzx[temp].lpausa:=sacar_word(data);
                          inc(data,2);
                          cinta_tzx.datos_tzx[temp].lbyte:=data^;
                          inc(data);
                          cinta_tzx.datos_tzx[temp].lbloque:=sacar_word(data);
                          inc(data,2);
                          inc(cinta_tzx.datos_tzx[temp].lbloque,data^*65536);
                          inc(data);inc(longitud,8);
                          getmem(cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque);
                          copymemory(cinta_tzx.datos_tzx[temp].datos,data,cinta_tzx.datos_tzx[temp].lbloque);
                          inc(data,cinta_tzx.datos_tzx[temp].lbloque);inc(longitud,cinta_tzx.datos_tzx[temp].lbloque);
                          cadena:=leng[idioma].cinta[7]; //Grabacion Directa
                          inc(long_final,cinta_tzx.datos_tzx[temp].lbloque);
                        end;
                    $19:begin
                          tmp3:=sacar_word(data);
                          inc(data,2);inc(longitud,2);
                          tmp3:=tmp3+(sacar_word(data)*65536);
                          inc(data,2);inc(longitud,2);
                          cinta_tzx.datos_tzx[temp].lpausa:=sacar_word(data);
                          inc(data,2);inc(longitud,2);
                          //totp
                          tmp1:=sacar_word(data);
                          inc(data,2);inc(longitud,2);
                          tmp1:=tmp1+(sacar_word(data)*65536);
                          inc(data,2);inc(longitud,2);
                          //npp
                          t1:=data^;
                          inc(data);inc(longitud);
                          //asp
                          t2:=data^;
                          inc(data);inc(longitud);
                          //totd
                          tmp2:=sacar_word(data);
                          inc(data,2);inc(longitud,2);
                          tmp2:=tmp2+(sacar_word(data)*65536);
                          inc(data,2);inc(longitud,2);
                          //npd
                          t3:=data^;
                          inc(data);inc(longitud);
                          //asd
                          t4:=data^;
                          inc(data);inc(longitud);
                          if t4<>2 then begin
                            MessageDlg('Simbolos de mas de 1 bit no soportado.', mtInformation,[mbOk], 0);
                            exit;
                          end;
                          //cojo los simbolos del alfabeto
                          for f:=1 to t2 do begin
                            //descarto el byte de inicio
                            inc(data);inc(longitud);
                            for g:=1 to t1 do begin
                              simbolos[f-1,g-1]:=sacar_word(data);
                              inc(data,2);inc(longitud,2);
                            end;
                          end;
                          //Y ahora relaciono repeticiones con simbolos
                          pulsos_total:=0;
                          for f:=1 to tmp1 do begin
                            //que simbolo es?
                            t5:=data^;
                            inc(data);inc(longitud);
                            //cuantas veces lo repito?
                            temp2:=sacar_word(data);
                            inc(data,2);inc(longitud,2);
                            for g:=1 to temp2 do begin
                              for h:=0 to (t1-1) do begin
                                pulsos[pulsos_total]:=simbolos[t5,h];
                                if pulsos[pulsos_total]<>0 then inc(pulsos_total);
                              end;
                            end;
                          end;
                          //Y ahora lo convierto en un bloque de pulsos
                          //Creo grupo
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$21;
                          getmem(cinta_tzx.datos_tzx[temp].datos,1);
                          nombre_grupo:=leng[idioma].cinta[10]+': Generalized Data';
                          inicio_grupo:=temp;
                          indice_saltos[temp]:=contador;
                          inc(temp);
                          getmem(cinta_tzx.datos_tzx[temp].datos,pulsos_total*2);
                          copymemory(cinta_tzx.datos_tzx[temp].datos,@pulsos[0],pulsos_total*2);
                          cinta_tzx.datos_tzx[temp].lbloque:=pulsos_total;
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$13;
                          cinta_tzx.datos_tzx[temp].crc32:=calcCRC32(cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque);
                          long_final:=pulsos_total;
                          indice_saltos[temp]:=contador;
                          inc(temp);
                          //Continuo con los datos
                          //Primero cambio la pausa
                          cinta_tzx.datos_tzx[temp].lpausa:=cinta_tzx.datos_tzx[temp-1].lpausa;
                          cinta_tzx.datos_tzx[temp-1].lpausa:=0;
                          //Pulsos de los simbolos
                          cinta_tzx.datos_tzx[temp].lcero:=t3;
                          cinta_tzx.datos_tzx[temp].luno:=t3;
                          //Simbolos de los datos
                          for f:=0 to (t4-1) do begin
                            cinta_tzx.datos_tzx[temp].inicial:=data^;
                            inc(data);inc(longitud);
                            for g:=1 to t3 do begin
                              cinta_tzx.datos_tzx[temp].pulsos_sym[f,g]:=sacar_word(data);
                              inc(data,2);inc(longitud,2);
                            end;
                          end;
                          cinta_tzx.datos_tzx[temp].lbloque:=tmp2 div 8;
                          t1:=tmp2 mod 8;
                          if t1=0 then cinta_tzx.datos_tzx[temp].lbyte:=8
                          else begin
                            inc(cinta_tzx.datos_tzx[temp].lbloque);
                            cinta_tzx.datos_tzx[temp].lbyte:=t1;
                          end;
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$19;
                          getmem(cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque);
                          copymemory(cinta_tzx.datos_tzx[temp].datos,data,cinta_tzx.datos_tzx[temp].lbloque);
                          inc(data,cinta_tzx.datos_tzx[temp].lbloque);
                          inc(longitud,cinta_tzx.datos_tzx[temp].lbloque);
                          long_final:=long_final+cinta_tzx.datos_tzx[temp].lbloque;
                          indice_saltos[temp]:=contador;
                          inc(temp);
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$22;
                          getmem(cinta_tzx.datos_tzx[temp].datos,1);
                          fin_grupo:=true;
                    end;
                    $20:begin {pausa}
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$20;
                          cinta_tzx.datos_tzx[temp].lcabecera:=0;
                          cinta_tzx.datos_tzx[temp].lpausa:=sacar_word(data);
                          inc(data,2);inc(longitud,2);
                          getmem(cinta_tzx.datos_tzx[temp].datos,1);
                          if not(grupo) then begin
                            if cinta_tzx.datos_tzx[temp].lpausa=0 then begin
                                cadena:=leng[idioma].cinta[8]; //STOP the tape
                                cadena2:=' ';
                            end else begin
                                cadena:=leng[idioma].cinta[9]; //Pausa
                                cadena2:=inttostr(cinta_tzx.datos_tzx[temp].lpausa)+'ms.';
                            end;
                          end;
                          end;
                    $21:begin   {inicio del grupo}
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$21;
                          cinta_tzx.datos_tzx[temp].lcabecera:=0;
                          cinta_tzx.datos_tzx[temp].lbloque:=data^;
                          inc(data);inc(longitud);
                          getmem(cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque);
                          copymemory(cinta_tzx.datos_tzx[temp].datos,data,cinta_tzx.datos_tzx[temp].lbloque);
                          inc(data,cinta_tzx.datos_tzx[temp].lbloque);inc(longitud,cinta_tzx.datos_tzx[temp].lbloque);
                          nombre_tap:='';
                          copymemory(@nombre_tap,cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque);
                          nombre_grupo:=leng[idioma].cinta[10]+': '+nombre_tap; //grupo
                          inicio_grupo:=temp;
                          grupo:=true;
                        end;
                    $22:begin {fin grupo}
                          cadena:=nombre_grupo;
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$22;
                          getmem(cinta_tzx.datos_tzx[temp].datos,1);
                          grupo:=false;
                          fin_grupo:=true;
                        end;
                    $23:begin //saltar a posicion
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$23;
                          getmem(cinta_tzx.datos_tzx[temp].datos,1);
                          cinta_tzx.datos_tzx[temp].salta_bloque:=smallint(sacar_word(data));
                          inc(data,2);inc(longitud,2);
                          cadena:=leng[idioma].cinta[11]+' '+inttostr(cinta_tzx.datos_tzx[temp].salta_bloque);
                          cadena2:=' ';
                        end;
                    $24:begin  {loop}
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$24;
                          cinta_tzx.datos_tzx[temp].lbloque:=sacar_word(data);
                          inc(data,2);inc(longitud,2);
                          getmem(cinta_tzx.datos_tzx[temp].datos,1);
                          punto_loop:=temp+1;
                          cadena:=leng[idioma].cinta[12]; //Loop
                          cadena2:=' ';
                         end;
                    $25:begin {loop next}
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$25;
                          getmem(cinta_tzx.datos_tzx[temp].datos,1);
                          cinta_tzx.datos_tzx[temp].lbloque:=punto_loop;
                          cadena:=leng[idioma].cinta[13];  //fin del loop
                          cadena2:=' ';
                        end;
                    $26:begin //Call sequence
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$26;
                          cinta_tzx.datos_tzx[temp].lbloque:=sacar_word(data);
                          inc(data,2);inc(longitud,2);
                          getmem(cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque);
                          copymemory(cinta_tzx.datos_tzx[temp].datos,data,cinta_tzx.datos_tzx[temp].lbloque*2);
                          inc(data,cinta_tzx.datos_tzx[temp].lbloque*2);inc(longitud,cinta_tzx.datos_tzx[temp].lbloque*2);
                          cadena:='Call Sequence';
                          cadena2:=' ';
                        end;
                    $27:begin //Return Call sequence
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$27;
                          getmem(cinta_tzx.datos_tzx[temp].datos,1);
                          cadena:='Return';
                          cadena2:=' ';
                        end;
                    $28:begin //select block
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$28;
                          cinta_tzx.datos_tzx[temp].lbloque:=sacar_word(data);
                          inc(data,2);inc(longitud,2);
                          getmem(cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque);
                          inc(data,cinta_tzx.datos_tzx[temp].lbloque);inc(longitud,cinta_tzx.datos_tzx[temp].lbloque);
                          cadena:='Select Block';
                          cadena2:=' ';
                        end;
                    $2a:begin  //stop the tape if 48k
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$2a;
                          getmem(cinta_tzx.datos_tzx[temp].datos,1);
                          inc(data,4);inc(longitud,4);
                          cadena:=leng[idioma].cinta[14];
                          cadena2:=' ';
                        end;
                    $30:begin
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$30;
                          cinta_tzx.datos_tzx[temp].lcabecera:=0;
                          cinta_tzx.datos_tzx[temp].lbloque:=data^;
                          inc(data);inc(longitud);
                          getmem(cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque);
                          copymemory(cinta_tzx.datos_tzx[temp].datos,data,cinta_tzx.datos_tzx[temp].lbloque);
                          inc(data,cinta_tzx.datos_tzx[temp].lbloque);inc(longitud,cinta_tzx.datos_tzx[temp].lbloque);
                          form1.StringGrid1.cells[0,contador]:='';
                          puntero:=cinta_tzx.datos_tzx[temp].datos;
                          cadena:=leng[idioma].cinta[15]+': ';
                          cadena2:=' ';
                          for f:=1 to cinta_tzx.datos_tzx[temp].lbloque do begin
                                cadena:=cadena+chr(puntero^);
                                inc(puntero);
                          end;
                        end;
                    $31:begin  //mensaje
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$31;
                          cinta_tzx.datos_tzx[temp].lpausa:=data^*1000;
                          inc(data);
                          cinta_tzx.datos_tzx[temp].lcabecera:=0;
                          cinta_tzx.datos_tzx[temp].lbloque:=data^;
                          inc(data);inc(longitud,2);
                          getmem(cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque);
                          copymemory(cinta_tzx.datos_tzx[temp].datos,data,cinta_tzx.datos_tzx[temp].lbloque);
                          inc(data,cinta_tzx.datos_tzx[temp].lbloque);inc(longitud,cinta_tzx.datos_tzx[temp].lbloque);
                          cadena:=leng[idioma].cinta[16];
                          cadena2:=' ';
                        end;
                    $32,$33:begin  //informacion
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=selector;
                          cinta_tzx.datos_tzx[temp].lcabecera:=0;
                          if selector=$32 then begin
                            cinta_tzx.datos_tzx[temp].lbloque:=sacar_word(data);
                            inc(data,2);inc(longitud,2);
                            cadena:=leng[idioma].cinta[17]; //Archivo
                          end else begin
                            cinta_tzx.datos_tzx[temp].lbloque:=data^*3;
                            inc(data);inc(longitud);
                            cadena:=leng[idioma].cinta[18]; //Hardware
                          end;
                          getmem(cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque);
                          copymemory(cinta_tzx.datos_tzx[temp].datos,data,cinta_tzx.datos_tzx[temp].lbloque);
                          inc(data,cinta_tzx.datos_tzx[temp].lbloque);inc(longitud,cinta_tzx.datos_tzx[temp].lbloque);
                          cadena2:=' ';
                        end;
                    $35:begin  //custom Data Block
                          cinta_tzx.datos_tzx[temp].tipo_bloque:=$35;
                          puntero:=data;
                          inc(data,$10);inc(longitud,$10);
                          tmp3:=sacar_word(data);
                          inc(data,2);inc(longitud,2);
                          tmp3:=tmp3+(sacar_word(data)*65536);
                          inc(data,2);inc(longitud,2);
                          cinta_tzx.datos_tzx[temp].lbloque:=tmp3;
                          cinta_tzx.datos_tzx[temp].lcabecera:=0;
                          getmem(cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque);
                          copymemory(cinta_tzx.datos_tzx[temp].datos,data,cinta_tzx.datos_tzx[temp].lbloque);
                          inc(data,cinta_tzx.datos_tzx[temp].lbloque);inc(longitud,cinta_tzx.datos_tzx[temp].lbloque);
                          cadena:='Custom Block: ''';
                          for tmp3:=0 to $f do begin
                            cadena:=cadena+char(puntero^);
                            inc(puntero);
                          end;
                          cadena:=cadena+'''';
                          cadena2:=' ';
                        end;
                    $5A:begin
                          getmem(cinta_tzx.datos_tzx[temp].datos,1);
                          inc(data,9);inc(longitud,9);
                          cadena:='Glue!';
                          cadena2:=' ';
                    end;
                    else begin
                            MessageDlg('Bloque TZX desconocido: '+inttostr(selector), mtInformation,[mbOk], 0);
                            exit;
                    end;
                end; {del case}
        indice_saltos[temp]:=contador;
        cinta_tzx.datos_tzx[temp].crc32:=calcCRC32(cinta_tzx.datos_tzx[temp].datos,cinta_tzx.datos_tzx[temp].lbloque);
        crc_grupo:=(crc_grupo+cinta_tzx.datos_tzx[temp].crc32) and $FFFFFFFF;
        if cadena2='' then form1.stringgrid1.Cells[2,contador]:=inttostr(long_final)
            else form1.stringgrid1.Cells[2,contador]:=cadena2;
        cadena2:='';
        if (not(grupo) and not(fin_grupo)) then begin
          indice_select[contador]:=temp;
          form1.stringgrid1.Cells[1,contador]:=cadena;
          form1.stringgrid1.Cells[3,contador]:=inttohex(cinta_tzx.datos_tzx[temp].crc32,8);
          inc(contador);
          long_final:=0;
        end;
        if fin_grupo then begin
          fin_grupo:=false;
          form1.stringgrid1.Cells[1,contador]:=nombre_grupo;
          form1.stringgrid1.Cells[3,contador]:=inttohex(crc_grupo,8);
          indice_select[contador]:=inicio_grupo;
          cinta_tzx.datos_tzx[temp].crc32:=crc_grupo;
          inc(contador);
          long_final:=0;
        end;
        inc(temp);
end; {del while not}
fila_dibujo:=0;
form1.stringgrid1.RowCount:=contador;
cinta_tzx.datos_tzx[temp].tipo_bloque:=$fe;
cinta_tzx.datos_tzx[temp].lbloque:=1;
getmem(cinta_tzx.datos_tzx[temp].datos,1);
cinta_tzx.play_tape:=false;
cinta_tzx.cargada:=true;
cinta_tzx.play_once:=false;
siguiente_bloque_tzx;
abrir_tzx:=true;
analizar_tzx;
end;

function abrir_pzx(data:pbyte;long:integer):boolean;
var
        f,temp,temp2,contador,contador2,puls_total:word;
        cadena,cadena2:string;
        longitud:integer;
        lbloque,temp3:dword;
        ptemp:pbyte;
        pulsos:array[0..$FFFF] of word;
begin
//inicio
abrir_pzx:=false;
if data=nil then exit;
longitud:=0;  //longitud que llevo
cadena:='';
grupo:=false;
for temp:=0 to 3 do begin
        cadena:=cadena+chr(data^);
        inc(data);inc(longitud);
end;
if cadena<>'PZXT' then exit;  //si no es una cinta PZX me salgo
lbloque:=sacar_word(data);
inc(data,2);inc(longitud,2);
lbloque:=lbloque+(sacar_word(data)*65536);
inc(data,2);inc(longitud,2);
inc(data,lbloque);inc(longitud,lbloque);
vaciar_cintas;
contador:=0; //posicion en la cinta
estados_tzx:=0;
//bucle
while longitud<long do begin
  zeromemory(@cinta_tzx.datos_tzx[contador],sizeof(tipo_datos_tzx));
  cadena:='';
  for temp:=0 to 3 do begin
        cadena:=cadena+chr(data^);
        inc(data);inc(longitud);
  end;
  lbloque:=sacar_word(data);
  inc(data,2);inc(longitud,2);
  lbloque:=lbloque+(sacar_word(data) shl 16);
  inc(data,2);inc(longitud,2);  //saco la longitud
  ptemp:=data;  //puntero a los datos del bloque
  inc(data,lbloque);inc(longitud,lbloque);  //La incremento
  if cadena='PULS' then begin
    temp2:=0;
    puls_total:=0;
    while temp2<>lbloque do begin
      temp3:=sacar_word(ptemp);
      inc(ptemp,2);inc(temp2,2);
      contador2:=1;
      if (temp3 and $8000)<>0 then begin
        contador2:=(temp3 and $7FFF);
        temp3:=sacar_word(ptemp);
        inc(ptemp,2);inc(temp2,2);
        if (temp3 and $8000)<>0 then begin
          temp3:=((temp3 and $7FFF) shl 16)+sacar_word(ptemp);
          inc(ptemp,2);inc(temp2,2);
        end;
      end;
      if temp3>65535 then begin
        MessageDlg('Secuencias de pulsos grandes no soportado.', mtInformation,[mbOk], 0);
        exit;
      end;
      for f:=1 to contador2 do begin
        pulsos[puls_total]:=temp3;
        inc(puls_total);
      end;
      if puls_total=0 then begin
        MessageDlg('Secuencias de pulsos grandes no soportado.', mtInformation,[mbOk], 0);
        exit;
      end;
    end;
    getmem(cinta_tzx.datos_tzx[contador].datos,puls_total*2);
    copymemory(cinta_tzx.datos_tzx[contador].datos,@pulsos[0],puls_total*2);
    cinta_tzx.datos_tzx[contador].lbloque:=puls_total;
    cinta_tzx.datos_tzx[contador].tipo_bloque:=$13;
    cadena:=leng[idioma].cinta[5]; //Secuencia Pulsos
    cadena2:=' ';
  end;
  if cadena='PAUS' then begin
    cinta_tzx.datos_tzx[contador].tipo_bloque:=$20;
    temp3:=sacar_word(ptemp);
    inc(ptemp,2);
    temp3:=((temp3+(sacar_word(ptemp)*65536)) and $7FFFFFFF) div (llamadas_maquina.velocidad_cpu div 1000);
    cinta_tzx.datos_tzx[contador].lpausa:=temp3;
    getmem(cinta_tzx.datos_tzx[contador].datos,1);
    cadena:=leng[idioma].cinta[9]; //Pausa
    cadena2:=inttostr(temp3)+'ms.';
  end;
  if cadena='DATA' then begin
    temp3:=sacar_word(ptemp);
    inc(ptemp,2);
    temp3:=temp3+(sacar_word(ptemp)*65536);
    if (temp3 and $80000000)<>0 then cinta_tzx.datos_tzx[contador].inicial:=3
      else cinta_tzx.datos_tzx[contador].inicial:=2;
    temp3:=temp3 and $7FFFFFFF;
    inc(ptemp,2);  //saco la longitud, en bits!!
    //cinta_tzx.datos_tzx[contador].tail:=sacar_word(ptemp);
    inc(ptemp,2); //tail
    temp:=ptemp^;
    inc(ptemp);  //cantidad para formar la longitud del 0
    temp2:=ptemp^;
    inc(ptemp);  //cantidad para formar la longitud del 1
    cinta_tzx.datos_tzx[contador].lcero:=temp;
    for f:=1 to temp do begin
      cinta_tzx.datos_tzx[contador].pulsos_sym[0,f]:=sacar_word(ptemp);
      inc(ptemp,2);
    end;
    cinta_tzx.datos_tzx[contador].luno:=temp2;
    for f:=1 to temp do begin
      cinta_tzx.datos_tzx[contador].pulsos_sym[1,f]:=sacar_word(ptemp);
      inc(ptemp,2);
    end;
    cinta_tzx.datos_tzx[contador].lbloque:=temp3 div 8;
    temp:=temp3 mod 8;
    if temp=0 then cinta_tzx.datos_tzx[contador].lbyte:=8
      else begin
        inc(cinta_tzx.datos_tzx[contador].lbloque);
        cinta_tzx.datos_tzx[contador].lbyte:=temp;
      end;
    cinta_tzx.datos_tzx[contador].tipo_bloque:=$19;
    getmem(cinta_tzx.datos_tzx[contador].datos,cinta_tzx.datos_tzx[contador].lbloque);
    copymemory(cinta_tzx.datos_tzx[contador].datos,ptemp,cinta_tzx.datos_tzx[contador].lbloque);
    cadena:=leng[idioma].cinta[6]; //Datos Puros
  end;
  if cadena='BRWS' then begin
    cinta_tzx.datos_tzx[contador].tipo_bloque:=$30;
    cinta_tzx.datos_tzx[contador].lbloque:=lbloque;
    getmem(cinta_tzx.datos_tzx[contador].datos,lbloque);
    copymemory(cinta_tzx.datos_tzx[contador].datos,ptemp,lbloque);
    form1.StringGrid1.cells[0,contador]:='';
    ptemp:=cinta_tzx.datos_tzx[contador].datos;
    cadena:=leng[idioma].cinta[15]+': ';
    cadena2:=' ';
    for f:=1 to cinta_tzx.datos_tzx[contador].lbloque do begin
      cadena:=cadena+chr(ptemp^);
      inc(ptemp);
    end;
  end;
  if cadena='STOP' then begin
    temp2:=sacar_word(ptemp);
    if temp2=1 then begin //Stop if 48K
      cinta_tzx.datos_tzx[contador].tipo_bloque:=$2a;
      cadena:=leng[idioma].cinta[14];
    end else begin //Stop the tape
      cinta_tzx.datos_tzx[contador].tipo_bloque:=$20;
      cadena:=leng[idioma].cinta[8];
    end;
    getmem(cinta_tzx.datos_tzx[contador].datos,1);
    cadena2:=' ';
  end;
  if cadena='PZXT' then begin
    cinta_tzx.datos_tzx[contador].tipo_bloque:=$5a;
    getmem(cinta_tzx.datos_tzx[contador].datos,1);
    cadena:='Glue!';
    cadena2:=' ';
  end;
  //Pongo descripcion
  indice_saltos[contador]:=contador;
  indice_select[contador]:=contador;
  cinta_tzx.datos_tzx[contador].crc32:=calcCRC32(cinta_tzx.datos_tzx[contador].datos,cinta_tzx.datos_tzx[contador].lbloque);
  if cadena2='' then form1.stringgrid1.Cells[2,contador]:=inttostr(cinta_tzx.datos_tzx[contador].lbloque)
    else form1.stringgrid1.Cells[2,contador]:=cadena2;
  cadena2:='';
  form1.stringgrid1.Cells[1,contador]:=cadena;
  inc(contador);
end; //fin del while
//final
fila_dibujo:=0;
form1.stringgrid1.RowCount:=contador;
cinta_tzx.datos_tzx[contador].tipo_bloque:=$fe;
cinta_tzx.datos_tzx[contador].lbloque:=1;
getmem(cinta_tzx.datos_tzx[contador].datos,1);
cinta_tzx.play_tape:=false;
cinta_tzx.cargada:=true;
cinta_tzx.play_once:=false;
siguiente_bloque_tzx;
abrir_pzx:=true;
analizar_tzx;
end;

end.
