unit bombjack;

interface
uses sdl,z80,constantes,Windows,entradas,ay_8910,arcade_const,timers;

procedure Cargar_BJ;
procedure bombjack_principal;pascal;
function bombjack_getbyte(direccion:word): Byte; pascal;
procedure bombjack_putbyte(direccion:word;valor:byte);pascal;
function sbj_getbyte(direccion:word): Byte; pascal;
procedure sbj_putbyte(direccion:word;valor:byte);pascal;
procedure sbj_outbyte(valor:byte;puerto:word);pascal;
function bombjack_iniciar:boolean;pascal;
procedure bombjack_reset;pascal;
procedure bombjack_cerrar;pascal;
procedure update_video_bombjack;
procedure eventos_bombjack;
procedure bj_despues_instruccion;pascal;
const
        bombjack_rom:array[0..5] of tipo_roms=(
        (n:'09_j01b.bin';l:$2000;p:0),(n:'10_l01b.bin';l:$2000;p:$2000),
        (n:'11_m01b.bin';l:$2000;p:$4000),(n:'12_n01b.bin';l:$2000;p:$6000),
        (n:'13.1r';l:$2000;p:$c000),(n:'';l:0;p:0));
        bombjack_char:array[0..3] of tipo_roms=(
        (n:'03_e08t.bin';l:$1000;p:0),(n:'04_h08t.bin';l:$1000;p:$1000),
        (n:'05_k08t.bin';l:$1000;p:$2000),(n:'';l:0;p:0));
        bombjack_char16:array[0..3] of tipo_roms=(
        (n:'06_l08t.bin';l:$2000;p:0),(n:'07_n08t.bin';l:$2000;p:$2000),
        (n:'08_r08t.bin';l:$2000;p:$4000),(n:'';l:0;p:0));
        bombjack_sprites:array[0..3] of tipo_roms=(
        (n:'16_m07b.bin';l:$2000;p:0),(n:'15_l07b.bin';l:$2000;p:$2000),
        (n:'14_j07b.bin';l:$2000;p:$4000),(n:'';l:0;p:0));
        bombjack_tiles:tipo_roms=(n:'02_p04t.bin';l:$1000;p:0);
        bombjack_sonido:tipo_roms=(n:'01_h03t.bin';l:$2000;p:0);

var
 memoria_fondo:array[0..$fff] of byte;
 numero_fondo,comando_sonido:byte;
 fondo_activo:boolean;
 nmi_vblank,nmi_audio:boolean;

implementation
uses principal;

procedure Cargar_BJ;
begin
form1.bombjack1.Checked:=true;
llamadas_maquina.caption:='Bomb Jack';
llamadas_maquina.iniciar:=bombjack_iniciar;
llamadas_maquina.bucle_general:=bombjack_principal;
llamadas_maquina.cerrar:=bombjack_cerrar;
llamadas_maquina.reset:=bombjack_reset;
llamadas_maquina.canales_usados:=3;
end;

procedure update_video_bombjack;
var
        x,y:byte;
        f,nchar,color:word;
        //340fps
begin
  {distribucion de los tiles
        256bytes-->numero del tile referidos al banco grafico
        256bytes-->atributos de color
        ---------->total 512bytes*8 tiles = 4096}
if fondo_activo then actualiza_trozo(0,0,256,256,2,0,0,256,256,1)
  else pintar_pantalla(1,0);
for f:=0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    x:=31-(f div 32);
    y:=f mod 32;
    color:=(gfx[0].valor[$400+f] and $f) shl 3;
    nchar:=gfx[0].valor[f]+(gfx[0].valor[$400+f] and $10) shl 4;
    put_gfx_trans(x*8,y*8,nchar,color,6,0);
    gfx[0].buffer[f]:=false;
  end;
end;
actualiza_trozo(0,0,256,256,6,0,0,256,256,1);
for f:=0 to 24 do begin
   x:=gfx[2].valor[$2+(f*4)];
   y:=gfx[2].valor[$3+(f*4)];
   nchar:=gfx[2].valor[f*4] and $7F;
   color:=(gfx[2].valor[$1+(f*4)] and $1f) shl 3;
   if (gfx[2].valor[f*4] and $80)=0 then begin
    put_gfx_sprite(nchar,color,gfx[2].valor[$1+(f*4)] and $80<>0,gfx[2].valor[$1+(f*4)] and $40<>0,2);
    actualiza_gfx_sprite(x,y,1,2);
   end else begin
    put_gfx_sprite(nchar and $1f,color,false,false,3);
    actualiza_gfx_sprite(x-1,y,1,3);
   end;
end;
actualiza_trozo(16,0,224,256,1,0,0,224,256,0);
end;

procedure bombjack_cerrar;pascal;
begin
AY8910_close(0);
AY8910_close(1);
AY8910_close(2);
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure bombjack_reset;pascal;
begin
reset_z80(main_z80);
reset_z80(snd_z80);
nmi_audio:=false;
nmi_vblank:=false;
fondo_activo:=false;
comando_sonido:=0;
numero_fondo:=0;
ay8910_reset(0);
ay8910_reset(1);
ay8910_reset(2);
in2:=0;
in0:=0;
end;

function bombjack_iniciar:boolean;pascal;
const
      pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
      pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
      ps_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			8*8+0, 8*8+1, 8*8+2, 8*8+3, 8*8+4, 8*8+5, 8*8+6, 8*8+7);
      ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			16*8, 17*8, 18*8, 19*8, 20*8, 21*8, 22*8, 23*8);
      pt_x:array[0..31] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			8*8+0, 8*8+1, 8*8+2, 8*8+3, 8*8+4, 8*8+5, 8*8+6, 8*8+7,
			32*8+0, 32*8+1, 32*8+2, 32*8+3, 32*8+4, 32*8+5, 32*8+6, 32*8+7,
			40*8+0, 40*8+1, 40*8+2, 40*8+3, 40*8+4, 40*8+5, 40*8+6, 40*8+7);
      pt_y:array[0..31] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			16*8, 17*8, 18*8, 19*8, 20*8, 21*8, 22*8, 23*8,
			64*8, 65*8, 66*8, 67*8, 68*8, 69*8, 70*8, 71*8,
			80*8, 81*8, 82*8, 83*8, 84*8, 85*8, 86*8, 87*8);
begin
bombjack_iniciar:=false;
iniciar_audio(1);
//pantallas:
//  0 -- principal
//  1 -- fondo
//  2 -- chars+sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[2].x:=256;
p_final[2].y:=256;
//Chars trans
p_final[6].x:=256;
p_final[6].y:=256;
p_final[6].trans:=true;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,4000000/llamadas_maquina.fps_max);
main_z80.daisy:=false;
main_z80_ll.getbyte:=bombjack_getbyte;
main_z80_ll.putbyte:=bombjack_putbyte;
main_z80_ll.outbyte:=nil;
main_z80_ll.inbyte:=nil;
//Sound CPU
init_cpu(z80_snd,1,3072000/llamadas_maquina.fps_max);
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=sbj_getbyte;
snd_z80_ll.putbyte:=sbj_putbyte;
snd_z80_ll.outbyte:=sbj_outbyte;
snd_z80_ll.inbyte:=nil;
//Sound Chip
AY8910_init(1500000,0,nil,nil,nil,nil);
AY8910_init(1500000,1,nil,nil,nil,nil);
AY8910_init(1500000,2,nil,nil,nil,nil);
//Timers
init_timer(0,1,3072000/44100,bj_despues_instruccion,true);
{cargar roms}
if not(cargar_roms(@memoria[0],@bombjack_rom[0],'\bombjack.zip',0)) then exit;
{cargar roms sonido}
if not(cargar_roms(@mem_snd[0],@bombjack_sonido,'\bombjack.zip',1)) then exit;
{informacion adicional de las tiles}
if not(cargar_roms(@memoria_fondo[0],@bombjack_tiles,'\bombjack.zip',1)) then exit;
{convertir chars}
if not(cargar_roms(@memoria_temp[0],@bombjack_char[0],'\bombjack.zip',0)) then exit;
init_gfx(0,8,8,512);
gfx[0].trans[0]:=true;
des_sprites.pos_planos[0]:=0*8;
des_sprites.pos_planos[1]:=512*8*8;
des_sprites.pos_planos[2]:=512*2*8*8;
des_sprites.bit_pixel:=3;
des_sprites.banks:=0;
des_sprites.long_sprites:=8*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
{convertir chars16}
if not(cargar_roms(@memoria_temp[0],@bombjack_char16[0],'\bombjack.zip',0)) then exit;
init_gfx(1,16,16,256);
gfx[1].trans[0]:=true;
des_sprites.pos_planos[1]:=1024*8*8;
des_sprites.pos_planos[2]:=1024*2*8*8;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
{sprites}
if not(cargar_roms(@memoria_temp[0],@bombjack_sprites[0],'\bombjack.zip',0)) then exit;
init_gfx(2,16,16,128);
gfx[2].trans[0]:=true;
convert_sprites(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
{sprites grandes}
init_gfx(3,32,32,32);
gfx[3].trans[0]:=true;
des_sprites.pos_planos[0]:=0*8+$1000*8;
des_sprites.pos_planos[1]:=1024*8*8+$1000*8;
des_sprites.pos_planos[2]:=2*1024*8*8+$1000*8;
des_sprites.long_sprites:=128*8;
convert_sprites(@gfx[3],0,@memoria_temp[0],@pt_x[0],@pt_y[0],true,false);
{final}
bombjack_reset;
bombjack_iniciar:=true;
end;

procedure bombjack_principal;pascal;
var
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_s:=0;
frame_m:=0;
while EmuStatus=EsRuning do begin
  frame_m:=frame_m+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame_m));
  main_z80.pedir_nmi:=nmi_vblank;
  frame_s:=frame_s+snd_z80.tframes;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  snd_z80.pedir_nmi:=nmi_audio;
  frame_m:=frame_m-main_z80.contador;
  main_z80.contador:=0;
  frame_s:=frame_s-snd_z80.contador;
  snd_z80.contador:=0;
  update_video_bombjack;
  actualiza_video;
  eventos_bombjack;
  sincronizar;
  evaluar_entradas;
end;
end;

procedure eventos_bombjack;
begin
if (evento.teclado or evento.joystick) then begin
  if teclado[SDLK_5] then in2:=in2 or 1 else in2:=in2 and $fe;
  if teclado[SDLK_6] then in2:=in2 or 2 else in2:=in2 and $fd;
  if teclado[SDLK_1] then in2:=in2 or 4 else in2:=in2 and $fb;
  if teclado[SDLK_2] then in2:=in2 or 8 else in2:=in2 and $f7;
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=in0 or 1 else in0:=in0 and $fe;
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=in0 or 2 else in0:=in0 and $fd;
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=in0 or 4 else in0:=in0 and $fb;
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=in0 or 8 else in0:=in0 and $f7;
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=in0 or $10 else in0:=in0 and $ef;
  if teclado[SDLK_F6] then pasar_pantalla_completa;
end;
end;

function bombjack_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
        $b000:bombjack_getbyte:=in0;
        $b002:bombjack_getbyte:=in2;
        else bombjack_getbyte:=memoria[direccion];
end;
end;

procedure cambiar_color(dir:word);
var
        tmp_color,bit0,bit1,bit2,bit3:byte;
        color:tcolor;
begin
  tmp_color:=memoria[dir];
  bit0:=(tmp_color and 1)*$0e;
  bit1:=((tmp_color shr 1) and 1)*$1f;
  bit2:=((tmp_color shr 2) and 1)*$43;
  bit3:=((tmp_color shr 3) and 1)*$8f;
  color.r:=bit0+bit1+bit2+bit3;
  bit0:=((tmp_color shr 4) and 1)*$0e;
  bit1:=((tmp_color shr 5) and 1)*$1f;
  bit2:=((tmp_color shr 6) and 1)*$43;
  bit3:=((tmp_color shr 7) and 1)*$8f;
  color.g:=bit0+bit1+bit2+bit3;
  tmp_color:=memoria[dir+1];
  bit0:=(tmp_color and 1)*$0e;
  bit1:=((tmp_color shr 1) and 1)*$1f;
  bit2:=((tmp_color shr 2) and 1)*$43;
  bit3:=((tmp_color shr 3) and 1)*$8f;
  color.b:=bit0+bit1+bit2+bit3;
  poner_color(color,addr(paleta[(dir-$9c00) shr 1]));
  fillmemory(@gfx[0].buffer,$3ff,1);
end;

procedure cambia_fondo(fondo:byte);
var
    base:word;
    x,y,color,nchar,f:byte;
begin
numero_fondo:=fondo;
base:=$200*fondo;
for f:=0 to $ff do begin
    x:=15-(f div 16);
    y:=f mod 16;
    nchar:=memoria_fondo[base+f];
    color:=memoria_fondo[base+$100+f] shl 3;
    put_gfx(16*x,16*y,nchar,color,2,1);
end;
end;

procedure bombjack_putbyte(direccion:word;valor:byte);pascal;
begin
if ((direccion<$8000) or ((direccion>=$c000) and (direccion<$e000))) then exit;
memoria[direccion]:=valor;
case direccion of
        $b000:nmi_vblank:=valor<>0;
        $b800:begin
                  comando_sonido:=valor;
                  nmi_audio:=valor<>0;
              end;
        $9000..$97ff:if gfx[0].valor[direccion and $7ff]<>valor then begin
                        gfx[0].buffer[direccion and $3ff]:=true;
                        gfx[0].valor[direccion and $7ff]:=valor;
                     end;
        $9820..$9884:gfx[2].valor[direccion-$9820]:=valor;
        $9c00..$9cff:if buffer_paleta[direccion and $ff]<>valor then begin
                          cambiar_color(direccion and $fffe);
                          buffer_paleta[direccion and $ff]:=valor;
                     end;
        $9e00:begin
                {byte 9e00 --> 76543210
                               XXXXbaaa
                   b--> fondo activo o no
                   aaa--> numero de tile del fondo}
                   fondo_activo:=(valor and $10)<>0;
                   if (fondo_activo and (numero_fondo<>(valor and 7))) then cambia_fondo(valor and 7);
              end;
end;
end;

function sbj_getbyte(direccion:word): Byte; pascal;
begin
if direccion=$6000 then begin
  sbj_getbyte:=comando_sonido;
  comando_sonido:=0;
  end else sbj_getbyte:=mem_snd[direccion];
end;

procedure sbj_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$2000 then exit;
mem_snd[direccion]:=valor;
end;

procedure sbj_outbyte(valor:byte;puerto:word);pascal;
begin
case (puerto and $FF) of
        $00:AYControl(valor,0);
        $01:AYWrite(valor,0);
        $10:AYControl(valor,1);
        $11:AYWrite(valor,1);
        $80:AYControl(valor,2);
        $81:AYWrite(valor,2);
end
end;

procedure bj_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=renderbyte(0)^;
  tsample[1][posicion_sonido]:=renderbyte(1)^;
  tsample[2][posicion_sonido]:=renderbyte(2)^;
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
