unit gberet;

interface
uses sdl,z80,constantes,windows,entradas,sn_76496,arcade_const,timers;

procedure Cargar_gberet;
procedure gberet_principal;pascal;
function gberet_getbyte(direccion:word): Byte; pascal;
procedure gberet_putbyte(direccion:word;valor:byte);pascal;
function iniciar_gberet:boolean;pascal;
procedure reset_gberet;pascal;
procedure cerrar_gberet;pascal;
procedure gberet_despues_instruccion;pascal;

const
        gberet_rom:array[0..3] of tipo_roms=(
        (n:'577l03.10c';l:$4000;p:0),(n:'577l02.8c';l:$4000;p:$4000),
        (n:'577l01.7c';l:$4000;p:$8000),(n:'';l:0;p:0));
        gberet_pal:array[0..3] of tipo_roms=(
        (n:'577h09.2f';l:$20;p:0),(n:'577h11.6f';l:$100;p:$20),
        (n:'577h10.5f';l:$100;p:$120),(n:'';l:0;p:0));
        gberet_char:tipo_roms=(n:'577l07.3f';l:$4000;p:0);
        gberet_sprites:array[0..4] of tipo_roms=((n:'577l06.5e';l:$4000;p:0),
        (n:'577l05.4e';l:$4000;p:$4000),(n:'577l08.4f';l:$4000;p:$8000),
        (n:'577l04.3e';l:$4000;p:$c000),(n:'';l:0;p:0));

var
 scroll_lineas:array[0..$3f] of word;
 irq_vblank,nmi_vblank:boolean;
 banco_sprites:word;

implementation
uses principal;

procedure Cargar_gberet;
begin
form1.gberet1.Checked:=true;
llamadas_maquina.caption:='Green Beret';
llamadas_maquina.iniciar:=iniciar_gberet;
llamadas_maquina.bucle_general:=gberet_principal;
llamadas_maquina.cerrar:=cerrar_gberet;
llamadas_maquina.reset:=reset_gberet;
llamadas_maquina.canales_usados:=1;
llamadas_maquina.fps_max:=30;
end;

procedure update_video_gberet;
var
        f:word;
        x,y:word;
        color,nchar,scroll:word;
        long_x:word;
begin
for f:=$7FF downto 0 do begin
  if gfx[0].buffer[f] then begin
    x:=f mod 64;
    y:=f div 64;
    //Color RAM
    //c000-c7ff --> Bits
    // 0-3 --> Color
    // 4 --> flip X
    // 5 --> Flip Y
    // 6 --> Numero Char
    color:=(memoria[f+$C000] and $F) shl 4;
    nchar:=memoria[f+$c800]+((memoria[f+$C000] and $40) shl 2);
    put_gfx_flip(x*8,y*8,nchar,color,1,0,(memoria[f+$C000] and $10)<>0,(memoria[f+$C000] and $20)<>0);
    gfx[0].buffer[f]:=false;
  end;
end;
//hacer el scroll independiente linea a linea
for f:=0 to 31 do begin
  scroll:=scroll_lineas[f]+scroll_lineas[f+$20]*256;
  if scroll>255 then long_x:=512-scroll else long_x:=256;
  actualiza_trozo(scroll,f*8,long_x,8,1,0,f*8,long_x,8,2);
  if long_x<256 then actualiza_trozo(0,f*8,scroll,8,1,long_x,f*8,long_x,8,2);
end;
//sprites
for f:=0 to $3F do begin
  nchar:=memoria[$d000+banco_sprites+(f*4)]+(memoria[$d001+banco_sprites+(f*4)] and $40) shl 2;
  color:=(memoria[$d001+banco_sprites+(f*4)] and $f) shl 4;
  x:=(memoria[$d002+banco_sprites+(f*4)]+(memoria[$d001+banco_sprites+(f*4)] and $80) shl 1);
  y:=memoria[$d003+banco_sprites+(f*4)];
  put_gfx_sprite_table(nchar,color,(memoria[$d001+banco_sprites+(f*4)] and $10)<>0,(memoria[$d001+banco_sprites+(f*4)] and $20)<>0,1,0);
  actualiza_gfx_sprite(x,y,2,1);
end;
actualiza_trozo(8,16,240,224,2,0,0,240,224,0);
end;

procedure eventos_gberet;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=(in0 and $F7) else in0:=(in0 or $8);
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=(in0 and $Fb) else in0:=(in0 or $4);
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in0:=(in0 and $df) else in0:=(in0 or $20);
  if teclado[SDLK_5] then in2:=(in2 and $fe) else in2:=(in2 or $1);
  if teclado[SDLK_1] then in2:=(in2 and $f7) else in2:=(in2 or $8);
  if teclado[SDLK_F6] then pasar_pantalla_completa;
end;
end;

procedure cerrar_gberet;pascal;
begin
save_hi('gberet.hi',@memoria[$d900],60);
SN76496_close(0);
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_gberet;pascal;
begin
 reset_z80(main_z80);
 zeromemory(@memoria[$c000],$3FFF);
 irq_vblank:=false;
 nmi_vblank:=false;
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 hi_score:=false;
 banco_sprites:=0;
end;

function iniciar_gberet:boolean;pascal;
var
      colores:tpaleta;
      f:word;
      ctemp1:byte;
const
      pc_x:array[0..7] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4);
      pc_y:array[0..7] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32);
      ps_x:array[0..15] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4,
		32*8+0*4, 32*8+1*4, 32*8+2*4, 32*8+3*4, 32*8+4*4, 32*8+5*4, 32*8+6*4, 32*8+7*4);
      ps_y:array[0..15] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32,
		64*8+0*32, 64*8+1*32, 64*8+2*32, 64*8+3*32, 64*8+4*32, 64*8+5*32, 64*8+6*32, 64*8+7*32);
begin
iniciar_gberet:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=240;
p_final[0].y:=224;
p_final[1].x:=512;
p_final[1].y:=256;
p_final[2].x:=512;
p_final[2].y:=256;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,3072000/llamadas_maquina.fps_max/32);
main_z80.daisy:=false;
main_z80_ll.getbyte:=gberet_getbyte;
main_z80_ll.putbyte:=gberet_putbyte;
main_z80_ll.outbyte:=nil;
main_z80_ll.inbyte:=nil;
//Sound Chips
SN76496_init(0,1536000);
//Timers
init_timer(0,0,3072000/44100,gberet_despues_instruccion,true);
{cargar roms}
if not(cargar_roms(@memoria[0],@gberet_rom[0],'\gberet.zip',0)) then exit;
//poner la paleta
if not(cargar_roms(@memoria_temp[0],@gberet_pal[0],'\gberet.zip',0)) then exit;
for f:=0 to 31 do begin
    ctemp1:=memoria_temp[f];
    colores[f].r:= $21*(ctemp1 and 1)+$47*((ctemp1 shr 1) and 1)+$97*((ctemp1 shr 2) and 1);
    colores[f].g:= $21*((ctemp1 shr 3) and 1)+$47*((ctemp1 shr 4) and 1)+$97*((ctemp1 shr 5) and 1);
    colores[f].b:= 0+$47*((ctemp1 shr 6) and 1)+$97*((ctemp1 shr 7) and 1);
end;
poner_paleta(colores,32);
//Poner el CLUT
for f:=0 to $FF do begin
  gfx[0].colores[f]:=memoria_temp[$20+f]+$10;
  gfx[1].colores[f]:=memoria_temp[$120+f] and $f;
end;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@gberet_char,'\gberet.zip',1)) then exit;
init_gfx(0,8,8,512);
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=1;
des_sprites.pos_planos[2]:=2;
des_sprites.pos_planos[3]:=3;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@gberet_sprites[0],'\gberet.zip',0)) then exit;
init_gfx(1,16,16,512);
des_sprites.long_sprites:=128*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//final
reset_gberet;
iniciar_gberet:=true;
end;

procedure gberet_principal;pascal;
var
  f:byte;
  frame_m:single;
begin
iniciar_entradas;
frame_m:=0;
while EmuStatus=EsRuning do begin
  for f:=0 to 31 do begin
    frame_m:=frame_m+main_z80.tframes;
    run_z80(main_z80,main_z80_ll,trunc(frame_m));
    if f=0 then main_z80.pedir_irq:=irq_vblank
      else if (f mod 2)=0 then main_z80.pedir_nmi:=nmi_vblank;
    frame_m:=frame_m-main_z80.contador;
    main_z80.contador:=0;
  end;
  update_video_gberet;
  actualiza_video;
  eventos_gberet;
  sincronizar;
  evaluar_entradas;
end;
end;

function gberet_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $f200:gberet_getbyte:=$4a;
  $f600:gberet_getbyte:=$ff;
  $f601:gberet_getbyte:=in1;
  $f602:gberet_getbyte:=in0;
  $f603:gberet_getbyte:=in2;
  else gberet_getbyte:=memoria[direccion];
end;
end;

procedure gberet_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$c000 then exit;
case direccion of
        $c000..$cfff:gfx[0].buffer[direccion and $7ff]:=true;
        $e000..$e01f:scroll_lineas[direccion and $1f]:=valor;
        $e020..$e03f:scroll_lineas[direccion and $3f]:=valor and 1;
        $e043:banco_sprites:=(valor and 8) shr 4;
        $e044:begin
                nmi_vblank:=(valor and 1)<>0;
                irq_vblank:=(valor and 4)<>0;
              end;
        $f400:SN76496Write(0,valor);
end;
memoria[direccion]:=valor;
end;

procedure gberet_despues_instruccion;pascal;
begin
if not(hi_score) then begin
  if ((memoria[$db06]=3) and (memoria[$db07]=$30) and (memoria[$db08]=0) and (memoria[$db0b]=$1c)) then begin
    load_hi('gberet.hi',@memoria[$d900],60);
    copymemory(@memoria[$db06],@memoria[$d900],3);
    hi_score:=true;
  end;
end;
if hay_sonido then begin
  tsample[0][posicion_sonido]:=SN76496Update(0);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
