unit mikie;

interface
uses sdl,m6809,z80,constantes,windows,entradas,sn_76496,arcade_const,timers;

procedure Cargar_mikie;
procedure mikie_principal;pascal;
function mikie_getbyte(direccion:word): Byte; pascal;
procedure mikie_putbyte(direccion:word;valor:byte);pascal;
function iniciar_mikie:boolean;pascal;
procedure reset_mikie;pascal;
procedure cerrar_mikie;pascal;
function sound_getbyte(direccion:word):Byte; pascal;
procedure sound_putbyte(direccion:word;valor:byte);pascal;
procedure sound_despues_instruccion;pascal;

const
        mikie_rom:array[0..3] of tipo_roms=(
        (n:'n14.11c';l:$2000;p:$6000),(n:'o13.12a';l:$4000;p:$8000),
        (n:'o17.12d';l:$4000;p:$c000),(n:'';l:0;p:0));
        mikie_sound:tipo_roms=(n:'n10.6e';l:$2000;p:0);
        mikie_char:tipo_roms=(n:'o11.8i';l:$4000;p:0);
        mikie_sprites:array[0..4] of tipo_roms=(
        (n:'001.f1';l:$4000;p:0),(n:'003.f3';l:$4000;p:$4000),
        (n:'005.h1';l:$4000;p:$8000),(n:'007.h3';l:$4000;p:$c000),
        (n:'';l:0;p:0));
        mikie_pal:array[0..5] of tipo_roms=(
        (n:'d19.1i';l:$100;p:$0),(n:'d21.3i';l:$100;p:$100),
        (n:'d20.2i';l:$100;p:$200),(n:'d22.12h';l:$100;p:$300),
        (n:'d18.f9';l:$100;p:$400),(n:'';l:0;p:0));

var
 banco_pal:byte;
 pedir_irq:boolean;
 sound_latch,sound_trq:byte;

implementation
uses principal;

procedure Cargar_mikie;
begin
form1.mikie1.Checked:=true;
llamadas_maquina.caption:='Mikie';
llamadas_maquina.iniciar:=iniciar_mikie;
llamadas_maquina.bucle_general:=mikie_principal;
llamadas_maquina.cerrar:=cerrar_mikie;
llamadas_maquina.reset:=reset_mikie;
llamadas_maquina.canales_usados:=2;
end;

function iniciar_mikie:boolean;pascal;
var
      colores:tpaleta;
      f:dword;
      ctemp1,ctemp2,ctemp3,ctemp4:byte;
const
  ps_x:array[0..15] of dword=(32*8+0, 32*8+1, 32*8+2, 32*8+3, 16*8+0, 16*8+1, 16*8+2, 16*8+3,
		0, 1, 2, 3, 48*8+0, 48*8+1, 48*8+2, 48*8+3);
  ps_y:array[0..15] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16,
		32*16, 33*16, 34*16, 35*16, 36*16, 37*16, 38*16, 39*16);
  pc_x:array[0..7] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4);
  pc_y:array[0..7] of dword=(0*4*8, 1*4*8, 2*4*8, 3*4*8, 4*4*8, 5*4*8, 6*4*8, 7*4*8);
begin
iniciar_mikie:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=256;
iniciar_video;
//Main CPU
init_cpu(m6809_main,0,1250000/llamadas_maquina.fps_max);
main_6809_ll.getbyte:=mikie_getbyte;
main_6809_ll.putbyte:=mikie_putbyte;
//Sound CPU
init_cpu(z80_snd,1,3579545/llamadas_maquina.fps_max);
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=sound_getbyte;
snd_z80_ll.putbyte:=sound_putbyte;
//Sound Chip
SN76496_init(0,1789772);
SN76496_init(1,3579545);
//Timers
init_timer(0,1,3579545/44100,sound_despues_instruccion,true);
{cargar roms}
if not(cargar_roms(@memoria[0],@mikie_rom[0],'\mikie.zip',0)) then exit;
//cargar rom sonido
if not(cargar_roms(@mem_snd[0],@mikie_sound,'\mikie.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@mikie_char,'\mikie.zip',1)) then exit;
init_gfx(0,8,8,512);
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=1;
des_sprites.pos_planos[2]:=2;
des_sprites.pos_planos[3]:=3;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@mikie_sprites[0],'\mikie.zip',0)) then exit;
init_gfx(1,16,16,512);
gfx[1].trans[0]:=true;
des_sprites.long_sprites:=128*8;
des_sprites.banks:=2;
for f:=0 to 1 do begin
  des_sprites.pos_planos[0]:=0+f*8;
  des_sprites.pos_planos[1]:=4+f*8;
  des_sprites.pos_planos[2]:=f*8+$8000*8+0;
  des_sprites.pos_planos[3]:=f*8+$8000*8+4;
  convert_sprites(@gfx[1],$100*f*16*16,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
end;
//paleta
if not(cargar_roms(@memoria_temp[0],@mikie_pal[0],'\mikie.zip',0)) then exit;
for f:=0 to 255 do begin
  ctemp1:=memoria_temp[0+f] and 1;
  ctemp2:=(memoria_temp[0+f] shr 1) and 1;
  ctemp3:=(memoria_temp[0+f] shr 2) and 1;
  ctemp4:=(memoria_temp[0+f] shr 3) and 1;
  colores[f].r:=$0e*ctemp1+$1f*ctemp2+$43*ctemp3+$8f*ctemp4;
  ctemp1:=memoria_temp[$100+f] and 1;
  ctemp2:=(memoria_temp[$100+f] shr 1) and 1;
  ctemp3:=(memoria_temp[$100+f] shr 2) and 1;
  ctemp4:=(memoria_temp[$100+f] shr 3) and 1;
  colores[f].g:=$0e*ctemp1+$1f*ctemp2+$43*ctemp3+$8f*ctemp4;
  ctemp1:=memoria_temp[$200+f] and 1;
  ctemp2:=(memoria_temp[$200+f] shr 1) and 1;
  ctemp3:=(memoria_temp[$200+f] shr 2) and 1;
  ctemp4:=(memoria_temp[$200+f] shr 3) and 1;
  colores[f].b:=$0e*ctemp1+$1f*ctemp2+$43*ctemp3+$8f*ctemp4;
end;
poner_paleta(colores,256);
//tabla_colores char
ctemp1:=0;
for ctemp2:=0 to 255 do begin
	for ctemp3:=0 to 7 do begin
		gfx[0].colores[ctemp2+ctemp3*256]:=(memoria_temp[ctemp1+$300] and $f)+(32*ctemp3)+16;
  end;
	inc(ctemp1);
end;
//tabla_colores sprites
ctemp1:=0;
for ctemp2:=0 to 255 do begin
	for ctemp3:=0 to 7 do begin
		gfx[1].colores[ctemp2+ctemp3*256]:=(memoria_temp[ctemp1+$400] and $f)+32*ctemp3;
  end;
	inc(ctemp1);
end;
//final
reset_mikie;
iniciar_mikie:=true;
end;

procedure cerrar_mikie;pascal;
begin
cerrar_cpus;
SN76496_close(0);
SN76496_close(1);
cerrar_audio;
cerrar_video;
end;

procedure reset_mikie;pascal;
begin
 reset_6809(main_6809,main_6809_ll);
 reset_z80(snd_z80);
 reset_audio;
 zeromemory(@memoria[0],$3FFF);
 banco_pal:=0;
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 pedir_irq:=false;
 sound_trq:=0;
end;

procedure update_video_mikie;
var
  x,y,f:word;
  color,nchar:word;
begin
for f:=$3ff downto 0 do begin
    if gfx[0].buffer[f] then begin
      y:=31-(f mod 32);
      x:=f div 32;
      color:=((memoria[$3800+f] and $f)+($10*banco_pal)) shl 4;
      nchar:=memoria[$3c00+f]+((memoria[$3800+f] and $20) shl 3);
      put_gfx_flip(x*8,y*8,nchar,color,1,0,(memoria[$3800+f] and $80)=0,(memoria[$3800+f] and $40)=0);
      gfx[0].buffer[f]:=false;
    end;
end;
actualiza_trozo(16,0,224,256,1,0,0,224,256,0);
for f:=0 to $23 do begin
  nchar:=((memoria[$2800+(f*4)] and $40) shl 1)+(memoria[$2802+(f*4)] and $3f)+((memoria[$2802+(f*4)] and $80) shr 1)+(memoria[$2802+(f*4)] and $40) shl 2;
  color:=((memoria[$2800+(f*4)] and $f)+($10*banco_pal)) shl 4;
  x:=228-memoria[$2801+(f*4)];
  y:=240-memoria[$2803+(f*4)];
  put_gfx_sprite(nchar,color,(memoria[$2800+(f*4)] and $20)=0,(memoria[$2800+(f*4)] and $10)<>0,1);
  actualiza_gfx_sprite(x,y,0,1);
end;
end;

procedure eventos_mikie;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_DOWN] or joystick.abajo) then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if (teclado[SDLK_UP] or joystick.arriba) then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if (teclado[SDLK_RIGHT] or joystick.der) then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if (teclado[SDLK_LEFT] or joystick.izq) then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 and $df) else in1:=(in1 or $20);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if teclado[SDLK_5] then in0:=(in0 and $fe) else in0:=(in0 or 1);
  if teclado[SDLK_1] then in0:=(in0 and $f7) else in0:=(in0 or 8);
  if teclado[SDLK_2] then in0:=(in0 and $ef) else in0:=(in0 or $10);
end;
end;

procedure mikie_principal;pascal;
var
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
  frame_m:=frame_m+main_6809.tframes;
  run_6809(main_6809,main_6809_ll,trunc(frame_m));
  main_6809.pedir_irq:=pedir_irq;
  frame_s:=frame_s+snd_z80.tframes;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_m:=frame_m-main_6809.contador;
  main_6809.contador:=0;
  frame_s:=frame_s-snd_z80.contador;
  snd_z80.contador:=0;
  update_video_mikie;
  actualiza_video;
  eventos_mikie;
  sincronizar;
  evaluar_entradas;
end;
end;

function mikie_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $2400:mikie_getbyte:=in0;
  $2401:mikie_getbyte:=in1;
  $2402:mikie_getbyte:=in2;
  $2403:mikie_getbyte:=0;
  $2500:mikie_getbyte:=$FF;
  $2501:mikie_getbyte:=$7b;
  else mikie_getbyte:=memoria[direccion];
end;
end;

procedure mikie_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion>$3FFF then exit;
memoria[direccion]:=valor;
case direccion of
  $2002:begin
          if ((sound_trq=0) and (valor=1)) then snd_z80.pedir_irq:=true;
          sound_trq:=valor;
        end;
  $2007:pedir_irq:=(valor<>0);
  $2200:banco_pal:=valor and $7;
  $2400:sound_latch:=valor;
  $3800..$3fff:gfx[0].buffer[direccion and $3ff]:=true;
end;
end;

function sound_getbyte(direccion:word):Byte; pascal;
begin
case direccion of
  $8003:sound_getbyte:=sound_latch;
  $8005:sound_getbyte:=snd_z80.contador shr 9;
    else sound_getbyte:=mem_snd[direccion];
end;
end;

procedure sound_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$2000 then exit;
case direccion of
  $8002:SN76496Write(0,valor);
  $8004:SN76496Write(1,valor);
  else mem_snd[direccion]:=valor;
end;
end;

procedure sound_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=SN76496Update(0);
  tsample[1][posicion_sonido]:=SN76496Update(1);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
