unit MysStone;

interface
uses m6502,constantes,sdl,windows,entradas,ay_8910,arcade_const,timers;

var
  scroll,soundlatch,last:byte;
  char_color:byte;

procedure Cargar_MS;
procedure principal_ms;pascal;
function getbyte_ms(direccion:word): Byte; pascal;
procedure putbyte_ms(direccion:word;valor:byte);pascal;
function iniciar_ms:boolean;pascal;
procedure cerrar_ms;pascal;
procedure reset_ms;pascal;
procedure ms_despues_instruccion;pascal;

const
        ms_rom:array[0..6] of tipo_roms=(
        (n:'rom6.bin';l:$2000;p:$4000),(n:'rom5.bin';l:$2000;p:$6000),
        (n:'rom4.bin';l:$2000;p:$8000),(n:'rom3.bin';l:$2000;p:$A000),
        (n:'rom2.bin';l:$2000;p:$C000),(n:'rom1.bin';l:$2000;p:$E000),
        (n:'';l:0;p:0));
        ms_char:array[0..6] of tipo_roms=(
        (n:'ms6';l:$2000;p:$0000),(n:'ms9';l:$2000;p:$2000),
        (n:'ms7';l:$2000;p:$4000),(n:'ms10';l:$2000;p:$6000),
        (n:'ms8';l:$2000;p:$8000),(n:'ms11';l:$2000;p:$A000),
        (n:'';l:0;p:0));
        ms_sprite:array[0..6] of tipo_roms=(
        (n:'ms12';l:$2000;p:$0000),(n:'ms13';l:$2000;p:$2000),
        (n:'ms14';l:$2000;p:$4000),(n:'ms15';l:$2000;p:$6000),
        (n:'ms16';l:$2000;p:$8000),(n:'ms17';l:$2000;p:$A000),
        (n:'';l:0;p:0));
        ms_pal:tipo_roms=(n:'ic61';l:$20;p:0);

implementation
uses principal;

procedure Cargar_MS;
begin
form1.misteriousstone1.Checked:=true;
llamadas_maquina.caption:='Mysterious Stones';
llamadas_maquina.iniciar:=iniciar_ms;
llamadas_maquina.bucle_general:=principal_ms;
llamadas_maquina.cerrar:=cerrar_ms;
llamadas_maquina.reset:=reset_ms;
llamadas_maquina.fps_max:=((12000000.0 / 256.0) / 3.0) / 272.0; //Como el MAME!
llamadas_maquina.canales_usados:=2;
end;

procedure update_video_ms;
var
  f,nchar,color:word;
  x,y:word;
begin
for f:=0 to $1ff do begin
  if gfx[2].buffer[f] then begin
    x:=f mod 32;
    y:=f div 32;
    nchar:=((memoria[$1a00+f] and $1) shl 8)+memoria[$1800+f];
    put_gfx_flip(x*16,y*16,nchar,16,1,2,(x and $10)<>0,false);
    gfx[2].buffer[f]:=false;
  end;
end;
actualiza_trozo(scroll,0,256,256,1,0,0,256,256,2);
//Sprites
for f:=0 to 23 do begin
  if (memoria[$780+(f*4)] and 1)<>0 then begin
    x:=240-memoria[$782+(f*4)];
    y:=memoria[$783+(f*4)];
    nchar:=memoria[$781+(f*4)]+((memoria[$780+(f*4)] and $10) shl 4);
    color:=(memoria[$780+(f*4)] and $8) shl 1;
    put_gfx_sprite(nchar,color,(memoria[$780+(f*4)] and 2)<>0,(memoria[$780+(f*4)] and 4)<>0,1);
    actualiza_gfx_sprite(x,y,2,1);
  end;
end;
for f:=0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    x:=f mod 32;
    y:=f div 32;
    nchar:=((memoria[$1400+f] and $07) shl 8)+memoria[$1000+f];
    put_gfx_trans(x*8,y*8,nchar,24+(char_color shl 3),6,0);
    gfx[0].buffer[f]:=false;
  end;
end;
actualiza_trozo(0,0,256,256,6,0,0,256,256,2);
actualiza_trozo(8,0,240,256,2,0,0,240,256,0);
end;

procedure eventos_ms;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=in0 and $fe else in0:=in0 or 1;
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=in0 and $fd else in0:=in0 or 2;
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=in0 and $fb else in0:=in0 or 4;
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=in0 and $f7 else in0:=in0 or 8;
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=in0 and $ef else in0:=in0 or $10;
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in0:=in0 and $df else in0:=in0 or $20;
  if teclado[SDLK_5] then begin
      in0:=(in0 and $bf);
      main_6502.pedir_nmi:=true;
  end else in0:=(in0 or $40);
  if teclado[SDLK_1] then in1:=in1 and $bf else in1:=in1 or $40;
end;
end;

procedure principal_ms;pascal;
var
  f:word;
  frame:single;
begin
iniciar_entradas;
frame:=0;
while EmuStatus=EsRuning do begin
 for f:=0 to 271 do begin
  frame:=frame+main_6502.tframes;
  run_6502(main_6502,main_6502_ll,trunc(frame));
  if f=248 then begin
    in2:=in2 or $80;
    update_video_ms;
    actualiza_video;
  end;
  if f=8 then in2:=in2 and $7F;
  if (f mod 16)=0 then main_6502.pedir_irq:=true;
  frame:=frame-main_6502.contador;
  main_6502.contador:=0;
 end;
 eventos_ms;
 sincronizar;
 evaluar_entradas;
end;
end;

function getbyte_ms(direccion:word): Byte; pascal;
begin
case direccion of
  $2000:getbyte_ms:=in0;
  $2010:getbyte_ms:=in1;
  $2020:getbyte_ms:=$fb;
  $2030:getbyte_ms:=in2;
  else getbyte_ms:=memoria[direccion];
end;
end;

procedure cambiar_color(valor,pos:byte);
var
  color:tcolor;
begin
  color.r:= $21*(valor and 1)+$47*((valor shr 1) and 1)+$97*((valor shr 2) and 1);
  color.g:= $21*((valor shr 3) and 1)+$47*((valor shr 4) and 1)+$97*((valor shr 5) and 1);
  color.b:= 0+$47*((valor shr 6) and 1)+$97*((valor shr 7) and 1);
  poner_color(color,addr(paleta[pos]));
  fillmemory(@gfx[2].buffer[0],$200,1);
end;

procedure putbyte_ms(direccion:word;valor:byte);pascal;
var
  temp:byte;
begin
if direccion>$3fff then exit;
memoria[direccion]:=valor;
case direccion of
  $1000..$17ff:gfx[0].buffer[direccion and $3ff]:=true;
  $1800..$1bFF:gfx[2].buffer[direccion and $1ff]:=true;
  $2000:begin
          temp:=((valor and $1) shl 1)+((valor and $2) shr 1);
          if char_color<>temp then begin
            fillmemory(@gfx[2].buffer[0],$3ff,1);
            char_color:=temp;
          end;
        end;
  $2020:scroll:=valor;
  $2030:soundlatch:=valor;
  $2040:begin
         if (((last and $20)=$20) and ((valor and $20)=0)) then begin
          if (last and $10)<>0 then AYControl(soundlatch,0)
            else AYWrite(soundlatch,0);
         end;
         if (((last and $80)=$80) and ((valor and $80)=0)) then begin
          if (last and $40)<>0 then AYControl(soundlatch,1)
          else AYWrite(soundlatch,1);
         end;
         last:=valor;
        end;
  $2060..$2077:if buffer_paleta[direccion and $1f]<>valor then begin
                  cambiar_color(valor,direccion and $1f);
                  buffer_paleta[direccion and $1f]:=valor;
               end;
end;
end;

function iniciar_ms:boolean;pascal;
var
        colores:tpaleta;
        ctemp1:byte;
        f:word;
const
    pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
    pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
    ps_x:array[0..15] of dword=(16*8+0, 16*8+1, 16*8+2, 16*8+3, 16*8+4, 16*8+5, 16*8+6, 16*8+7,
			0, 1, 2, 3, 4, 5, 6, 7);
    ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
begin
iniciar_ms:=false;
iniciar_audio(1);
p_final[0].x:=240;
p_final[0].y:=256;
p_final[1].x:=512;
p_final[1].y:=256;
p_final[2].x:=256;
p_final[2].y:=256;
//Chars trans
p_final[6].x:=256;
p_final[6].y:=256;
p_final[6].trans:=true;
iniciar_video;
//Main CPU
init_cpu(m6502_main,0,1500000/llamadas_maquina.fps_max/272);
main_6502_ll.getbyte:=getbyte_ms;
main_6502_ll.putbyte:=putbyte_ms;
//Sound Chip
AY8910_init(1500000,0,nil,nil,nil,nil);
AY8910_init(1500000,1,nil,nil,nil,nil);
//Timers
init_timer(0,0,1500000/44100,ms_despues_instruccion,true);
//cargar roms
if not(cargar_roms(@memoria[0],@ms_rom[0],'\mystston.zip',0)) then exit;
//Cargar chars
if not(cargar_roms(@memoria_temp[0],@ms_char[0],'\mystston.zip',0)) then exit;
init_gfx(0,8,8,2048);
gfx[0].trans[0]:=true;
des_sprites.pos_planos[0]:=$4000*8*2;
des_sprites.pos_planos[1]:=$4000*8;
des_sprites.pos_planos[2]:=0;
des_sprites.bit_pixel:=3;
des_sprites.banks:=0;
des_sprites.long_sprites:=8*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,true);
//sprites
init_gfx(1,16,16,512);
gfx[1].trans[0]:=true;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,true);
//Cargar sprites fondo
if not(cargar_roms(@memoria_temp[0],@ms_sprite[0],'\mystston.zip',0)) then exit;
init_gfx(2,16,16,512);
convert_sprites(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,true);
//poner la paleta
if not(cargar_roms(@memoria_temp[0],@ms_pal,'\mystston.zip',1)) then exit;
for f:=24 to 63 do begin
    ctemp1:=memoria_temp[f-24];
    colores[f].r:= $21*(ctemp1 and 1)+$47*((ctemp1 shr 1) and 1)+$97*((ctemp1 shr 2) and 1);
    colores[f].g:= $21*((ctemp1 shr 3) and 1)+$47*((ctemp1 shr 4) and 1)+$97*((ctemp1 shr 5) and 1);
    colores[f].b:= 0+$47*((ctemp1 shr 6) and 1)+$97*((ctemp1 shr 7) and 1);
end;
poner_paleta(colores,64);
//final
reset_ms;
iniciar_ms:=true;
end;

procedure cerrar_ms;pascal;
begin
AY8910_close(0);
AY8910_close(1);
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_ms;pascal;
begin
reset_6502(main_6502,main_6502_ll);
scroll:=0;
last:=0;
soundlatch:=0;
in0:=$ff;
in1:=$ff;
in2:=$9f;
end;

procedure ms_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=renderbyte(0)^;
  tsample[1][posicion_sonido]:=renderbyte(1)^;
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
