unit pacman;

interface
uses sdl,z80,constantes,windows,namco,entradas,arcade_const;

procedure Cargar_Pacman;
procedure pacman_principal;pascal;
function pacman_getbyte(direccion:word): Byte; pascal;
procedure pacman_putbyte(direccion:word;valor:byte);pascal;
procedure pacman_outbyte(valor:byte;puerto:word);pascal;
function iniciar_pacman:boolean;pascal;
procedure reset_pacman;pascal;
procedure cerrar_pacman;pascal;

const
        pacman_rom:array[0..4] of tipo_roms=(
        (n:'pacman.6e';l:$1000;p:0),(n:'pacman.6f';l:$1000;p:$1000),(n:'pacman.6h';l:$1000;p:$2000),
        (n:'pacman.6j';l:$1000;p:$3000),(n:'';l:0;p:0));
        pacman_pal:array[0..2] of tipo_roms=(
        (n:'82s123.7f';l:$20;p:0),(n:'82s126.4a';l:$100;p:$20),
        (n:'';l:0;p:0));
        pacman_char:tipo_roms=(n:'pacman.5e';l:$1000;p:0);
        pacman_sound:tipo_roms=(n:'82s126.1m';l:$100;p:0);
        pacman_sprites:tipo_roms=(n:'pacman.5f';l:$1000;p:0);
var
 irq_vblank:boolean;

implementation
uses principal;

procedure Cargar_Pacman;
begin
form1.pacman1.Checked:=true;
llamadas_maquina.caption:='Pacman';
llamadas_maquina.iniciar:=iniciar_pacman;
llamadas_maquina.bucle_general:=pacman_principal;
llamadas_maquina.cerrar:=cerrar_pacman;
llamadas_maquina.reset:=reset_pacman;
llamadas_maquina.fps_max:=60.6060606060;
llamadas_maquina.canales_usados:=3;
end;

procedure update_video_pacman;
var
        f,color,nchar:word;
        x,y:byte;
begin
for f:=0 to 31 do begin
        if gfx[0].buffer[$3df-f] then begin
                color:=((memoria[$47df-f]) and $1f) shl 2;
                nchar:=memoria[$43df-f];
                put_gfx(f*8,0,nchar,color,1,0);
                gfx[0].buffer[$3df-f]:=false;
        end;
        if gfx[0].buffer[$3ff-f] then begin
                color:=((memoria[$47ff-f]) and $1f) shl 2;
                nchar:=memoria[$43ff-f];
                put_gfx(f*8,8,nchar,color,1,0);
                gfx[0].buffer[$3ff-f]:=false;
        end;
        if gfx[0].buffer[$1f-f] then begin
                color:=((memoria[$441f-f]) and $1f) shl 2;
                nchar:=memoria[$401f-f];
                put_gfx(f*8,272,nchar,color,1,0);
                gfx[0].buffer[$1f-f]:=false;
        end;
        if gfx[0].buffer[$3f-f] then begin
                color:=((memoria[$443f-f]) and $1f) shl 2;
                nchar:=memoria[$403f-f];
                put_gfx(f*8,280,nchar,color,1,0);
                gfx[0].buffer[$3f-f]:=false;
        end;
end;
for f:=$40 to $3df do begin
  if gfx[0].buffer[f] then begin
    x:=31-(f div 32);
    y:=f mod 32;
    color:=((memoria[$4400+f]) and $1f) shl 2;
    put_gfx(x*8,y*8+16,memoria[$4000+f],color,1,0);
    gfx[0].buffer[f]:=false;
  end;
end;
actualiza_trozo(16,0,224,288,1,0,0,224,288,0);
//origen 0,16 y tamao 224x288
//sprites pacman posicion $5060
//byte 0 --> x
//Byte 1 --> y
//sprites pacman atributos $4FF0
//Byte 0
//      bit 0 --> flipy
//      bit 1 --> flipx
//      bits 2..7 --> numero char
for f:=7 downto 0 do begin
        nchar:=memoria[$4ff0+(f*2)] shr 2;
        color:=(memoria[$4ff1+(f*2)] and $1f) shl 2;
        x:=240-memoria[$5060+(f*2)]-1;
        y:=272-memoria[$5061+(f*2)];
        put_gfx_sprite_table(nchar,color,(memoria[$4ff0+(f*2)] and 2)<>0,(memoria[$4ff0+(f*2)] and 1)<>0,1,0);
        actualiza_gfx_sprite(x,y,0,1);
end;
//actualiza_trozo(16,0,224,288,2,0,0,224,288,0);
end;

procedure eventos_pacman;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=(in0 and $F7) else in0:=(in0 or $8);
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=(in0 and $Fb) else in0:=(in0 or $4);
  if teclado[SDLK_5] then in0:=(in0 and $df) else in0:=(in0 or $20);
  if teclado[SDLK_1] then in1:=(in1 and $df) else in1:=(in1 or $20);
  if teclado[SDLK_F12] then pasar_pantalla_completa;
  if (teclado[SDLK_LALT] or joystick.boton0) then begin
    if (memoria[$180b]<>$01) then begin
      memoria[$180b]:=$01;
      memoria[$1FFD]:=$BD;
    end
  end else begin
    if (memoria[$180b]<>$be) then begin
      memoria[$180b]:=$BE;
      memoria[$1FFD]:=$00;
    end
  end;
end;
end;

procedure cerrar_pacman;pascal;
begin
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_pacman;pascal;
begin
 reset_z80(main_z80);
 reset_audio;
 zeromemory(@memoria[$4000],$3FFF);
 irq_vblank:=false;
 in0:=$FF;
 in1:=$FF;
 in2:=$C9;
end;

function iniciar_pacman:boolean;pascal;
var
      colores:tpaleta;
      f:word;
      ctemp1:byte;
const
  ps_x:array[0..15] of dword=(8*8, 8*8+1, 8*8+2, 8*8+3, 16*8+0, 16*8+1, 16*8+2, 16*8+3,
			24*8+0, 24*8+1, 24*8+2, 24*8+3, 0, 1, 2, 3);
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			32*8, 33*8, 34*8, 35*8, 36*8, 37*8, 38*8, 39*8);
  pc_x:array[0..7] of dword=(8*8+0, 8*8+1, 8*8+2, 8*8+3, 0, 1, 2, 3);
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
begin
iniciar_pacman:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=288;
p_final[1].x:=256;
p_final[1].y:=288;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,43008); //3072000/llamadas_maquina.fps_max;
main_z80.daisy:=false;
main_z80_ll.getbyte:=pacman_getbyte;
main_z80_ll.putbyte:=pacman_putbyte;
main_z80_ll.outbyte:=pacman_outbyte;
main_z80_ll.inbyte:=nil;
//cargar roms
if not(cargar_roms(@memoria[0],@pacman_rom[0],'\pacman.zip',0)) then exit;
//cargar sonido
if not(cargar_roms(@onda_namco[0],@pacman_sound,'\pacman.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@pacman_char,'\pacman.zip',1)) then exit;
init_gfx(0,8,8,256);
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=4;
des_sprites.bit_pixel:=2;
des_sprites.banks:=0;
des_sprites.long_sprites:=16*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@pacman_sprites,'\pacman.zip',1)) then exit;
init_gfx(1,16,16,64);
des_sprites.long_sprites:=64*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
//poner la paleta
if not(cargar_roms(@memoria_temp[0],@pacman_pal[0],'\pacman.zip',0)) then exit;
for f:=0 to 15 do begin
    ctemp1:=memoria_temp[f];
    colores[f].r:= $21*(ctemp1 and 1)+$47*((ctemp1 shr 1) and 1)+$97*((ctemp1 shr 2) and 1);
    colores[f].g:= $21*((ctemp1 shr 3) and 1)+$47*((ctemp1 shr 4) and 1)+$97*((ctemp1 shr 5) and 1);
    colores[f].b:= 0+$47*((ctemp1 shr 6) and 1)+$97*((ctemp1 shr 7) and 1);
end;
for f:=0 to 255 do begin
  gfx[0].colores[f]:=memoria_temp[$20+f];
  gfx[1].colores[f]:=memoria_temp[$20+f];
end;
poner_paleta(colores,16);
//final
reset_pacman;
iniciar_pacman:=true;
end;

procedure pacman_principal;pascal;
var
  frame:single;
begin
iniciar_entradas;
frame:=0;
while EmuStatus=EsRuning do begin
  frame:=frame+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame));
  main_z80.pedir_irq:=irq_vblank;
  update_video_pacman;
  //Vblank
  frame:=frame-main_z80.contador+7680;
  run_z80(main_z80,main_z80_ll,trunc(frame));
  frame:=frame-7680;
  main_z80.contador:=0;
  actualiza_video;
  eventos_pacman;
  if hay_sonido then begin
      namco_playsound;
      play_sonido;
  end;
  sincronizar;
  evaluar_entradas;
end;
end;

function pacman_getbyte(direccion:word): Byte; pascal;
begin
direccion:=direccion and $7FFF;
case direccion of
        $5000:pacman_getbyte:=in0;
        $5040:pacman_getbyte:=in1;
        $5080:pacman_getbyte:=in2;
        else pacman_getbyte:=memoria[direccion];
end;
end;

procedure pacman_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$4000 then exit;
direccion:=direccion and $7FFF;
case direccion of
        $4000..$4fff:gfx[0].buffer[direccion and $3ff]:=true;
        $5000:irq_vblank:=valor<>0;
        $5040..$505f:registros_namco[direccion and $1f]:=valor;
end;
memoria[direccion]:=valor;
end;

procedure pacman_outbyte(valor:byte;puerto:word);pascal;
begin
if (puerto and $FF)=0 then main_z80.im2_lo:=valor;
end;

end.
