unit phoenix;

interface
uses sdl,z80,constantes,windows,entradas,arcade_const,tms36xx,timers,phoenix_audio_digital;

procedure Cargar_Phoenix;
procedure phoenix_principal;pascal;
function phoenix_getbyte(direccion:word): Byte; pascal;
procedure phoenix_putbyte(direccion:word;valor:byte);pascal;
function phoenix_iniciar:boolean;pascal;
procedure phoenix_reset;pascal;
procedure phoenix_cerrar;pascal;
procedure phoenix_sonido;pascal;

var
 isinc,banco_pal:byte;
 scroll:byte;

const
        phoenix_rom:array[0..8] of tipo_roms=(
        (n:'ic45';l:$800;p:0),(n:'ic46';l:$800;p:$800),(n:'ic47';l:$800;p:$1000),
        (n:'ic48';l:$800;p:$1800),(n:'ic49';l:$800;p:$2000),(n:'ic50';l:$800;p:$2800),
        (n:'ic51';l:$800;p:$3000),(n:'ic52';l:$800;p:$3800),
        (n:'';l:0;p:0));
        phoenix_char1:array[0..2] of tipo_roms=(
        (n:'ic23';l:$800;p:0),(n:'ic24';l:$800;p:$800),(n:'';l:0;p:0));
        phoenix_char2:array[0..2] of tipo_roms=(
        (n:'ic39';l:$800;p:0),(n:'ic40';l:$800;p:$800),(n:'';l:0;p:0));
        phoenix_pal:array[0..2] of tipo_roms=(
        (n:'ic40_b.bin';l:$100;p:0),(n:'ic41_a.bin';l:$100;p:$100),(n:'';l:0;p:0));

implementation
uses principal;

procedure Cargar_Phoenix;
begin
form1.phoenix1.Checked:=true;
llamadas_maquina.caption:='Phoenix';
llamadas_maquina.iniciar:=phoenix_iniciar;
llamadas_maquina.bucle_general:=phoenix_principal;
llamadas_maquina.cerrar:=phoenix_cerrar;
llamadas_maquina.reset:=phoenix_reset;
llamadas_maquina.canales_usados:=4;
end;

function phoenix_iniciar:boolean;pascal;
var
      colores:tpaleta;
      f:word;
      g,ctemp1,ctemp2:byte;
const
      pc_x:array[0..7] of dword=(7, 6, 5, 4, 3, 2, 1, 0);
      pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
      phoenix_dec:array[0..5] of extended=(0.5,0,0,1.05,0,0);
begin
phoenix_iniciar:=false;
iniciar_audio(1);
p_final[0].x:=208;
p_final[0].y:=248;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[2].x:=256;
p_final[2].y:=256;
//Chars
p_final[6].x:=256;
p_final[6].y:=256;
p_final[6].trans:=true;
iniciar_video;
//datos del scroll
scroll_data.long_y:=256;
scroll_data.ad_y:=256;
scroll_data.max_y:=256;
scroll_data.max_scr_y:=255;
//Main CPU
init_cpu(z80_main,0,36867.1875);
main_z80.daisy:=false;
main_z80_ll.getbyte:=phoenix_getbyte;
main_z80_ll.putbyte:=phoenix_putbyte;
main_z80_ll.outbyte:=nil;
main_z80_ll.inbyte:=nil;
//Chip sonido
tms36xx_start(0,372,0.21,@phoenix_dec[0]);
phoenix_audio_start;
//Timers
init_timer(0,0,2722500/44100,phoenix_sonido,true);
{cargar roms}
if not(cargar_roms(@memoria[0],@phoenix_rom[0],'\phoenix.zip',0)) then exit;
{poner paleta}
if not(cargar_roms(@memoria_temp[0],@phoenix_pal[0],'\phoenix.zip',0)) then exit;
for f:=0 to 255 do begin
    ctemp1:=memoria_temp[f];
    ctemp2:=memoria_temp[f+256];
    colores[f].r:= $55*(ctemp1 and 1)+$AA*(ctemp2 and 1);
    colores[f].g:= $55*((ctemp1 shr 2) and 1)+$AA*((ctemp2 shr 2) and 1);
    colores[f].b:= $55*((ctemp1 shr 1) and 1)+$AA*((ctemp2 shr 1) and 1);
end;
poner_paleta(colores,256);
for g:=0 to $3f do begin
        ctemp1:= ((g and  $1c) shr 2) or ((g and 3) shl 3) or ((g and $20) shl 1);
        gfx[0].colores[g]:= ctemp1;
        gfx[0].colores[g+$40]:= ctemp1+$20;
end;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@phoenix_char1[0],'\phoenix.zip',0)) then exit;
init_gfx(0,8,8,512);
gfx[0].trans[0]:=true;
des_sprites.pos_planos[0]:=256*8*8;
des_sprites.pos_planos[1]:=0;
des_sprites.bit_pixel:=2;
des_sprites.banks:=2;
des_sprites.long_sprites:=8*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//Segundo juego de chars
if not(cargar_roms(@memoria_temp[0],@phoenix_char2[0],'\phoenix.zip',0)) then exit;
convert_sprites(@gfx[0],256*8*8,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//final
phoenix_reset;
phoenix_iniciar:=true;
end;

procedure update_video_phoenix;
var
        x,y:byte;
        color,f:word;
begin
for f:=0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    x:=31-(f div 32);
    y:=f mod 32;
    color:=((memoria[$4800+f] and $e0) shr 3)+banco_pal;
    put_gfx(x*8,y*8,memoria[$4800+f],color,1,0);
    gfx[0].buffer[f]:=false;
  end;
  if gfx[1].buffer[f] then begin
    x:=31-(f div 32);
    y:=f mod 32;
    color:=((memoria[$4000+f] and $e0) shr 3)+banco_pal+64;
    put_gfx_trans(x*8,y*8,memoria[$4000+f]+256,color,6,0);
    gfx[1].buffer[f]:=true;
  end;
end;
scroll__y(1,2,scroll);
actualiza_trozo(0,0,256,256,6,0,0,256,256,2);
actualiza_trozo(48,0,208,248,2,0,0,208,248,0);
end;

procedure phoenix_reset;pascal;
begin
reset_z80(main_z80);
zeromemory(@memoria[$4000],$3FFF);
scroll:=0;
banco_pal:=0;
isinc:=0;
in0:=$FF;
phoenix_audio_reset;
end;

procedure phoenix_cerrar;pascal;
begin
cerrar_cpus;
cerrar_audio;
cerrar_video;
tms36xx_close(0);
phoenix_audio_cerrar;
end;

procedure eventos_phoenix;
begin
if (evento.teclado or evento.joystick) then begin
  if teclado[SDLK_5] then in0:=in0 and $FE else in0:=in0 or 1;
  if teclado[SDLK_1] then in0:=in0 and $FD else in0:=in0 or 2;
  if teclado[SDLK_2] then in0:=in0 and $FB else in0:=in0 or 4;
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=in0 and $DF else in0:=in0 or 32;
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=in0 and $BF else in0:=in0 or 64;
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=in0 and $7F else in0:=in0 or 128;
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=in0 and $EF else in0:=in0 or 16;
  if teclado[SDLK_F6] then pasar_pantalla_completa;
end;
end;

procedure phoenix_principal;pascal;
var
  frame:single;
begin
iniciar_entradas;
frame:=0;
while EmuStatus=EsRuning do begin
  frame:=frame+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame));
  main_z80.pedir_irq:=true;
  isinc:=$80;
  update_video_phoenix;
  //VBlank
  frame:=frame-main_z80.contador+8507.8125;
  run_z80(main_z80,main_z80_ll,trunc(frame));
  frame:=frame-8507.8125;
  main_z80.contador:=0;
  isinc:=0;
  actualiza_video;
  eventos_phoenix;
  sincronizar;
  evaluar_entradas;
end;
end;

function phoenix_getbyte(direccion:word): Byte; pascal;
begin
direccion:=direccion and $7FFF;
case direccion of
        $5000..$53ff:phoenix_getbyte:=banco_pal shr 4;
        $5800..$5bff:phoenix_getbyte:=scroll;
        $7000..$73FF:phoenix_getbyte:=in0;
        $7800..$7bff:phoenix_getbyte:=isinc;
        else phoenix_getbyte:=memoria[direccion];
end;
end;

procedure phoenix_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$4000 then exit;
direccion:=direccion and $7FFF;
case direccion of
  $4000..$43ff:gfx[1].buffer[direccion and $3ff]:=true;
  $4800..$4bff:gfx[0].buffer[direccion and $3ff]:=true;
  $5000..$53ff:banco_pal:=valor*16;  //selecciona la paleta
  $5800..$5bff:scroll:=valor;  //escribe el scroll
  $6000..$63ff:if sound_latch_a<>valor then begin
                  phoenix_wsound_a(valor);
                  sound_latch_a:=valor;
               end;
  $6800..$6bff:begin
                  phoenix_wsound_b(valor);
                  mm6221aa_tune_w(0,valor shr 6);  //Musica
               end;
end;
memoria[direccion]:=valor;
end;

procedure phoenix_sonido;pascal;
begin
if hay_sonido then begin
  tsample[2][posicion_sonido]:=tms36xx_sound_update(0);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then begin
    phoenix_audio_update;
    play_sonido;
  end;
end;
end;

end.
