unit shaolins;

interface
uses sdl,m6809,constantes,windows,entradas,sn_76496,arcade_const,timers;

procedure Cargar_shaolin;
procedure shaolin_principal;pascal;
function shaolin_getbyte(direccion:word): Byte; pascal;
procedure shaolin_putbyte(direccion:word;valor:byte);pascal;
function iniciar_shaolin:boolean;pascal;
procedure reset_shaolin;pascal;
procedure cerrar_shaolin;pascal;
procedure shaolin_despues_instruccion;pascal;

const
        shaolin_rom:array[0..3] of tipo_roms=(
        (n:'kikrd8.bin';l:$2000;p:$6000),(n:'kikrd9.bin';l:$4000;p:$8000),
        (n:'kikrd11.bin';l:$4000;p:$c000),(n:'';l:0;p:0));
        shaolin_char:array[0..2] of tipo_roms=((n:'shaolins.6';l:$2000;p:0),
        (n:'shaolins.7';l:$2000;p:$2000),(n:'';l:0;p:0));
        shaolin_sprites:array[0..2] of tipo_roms=(
        (n:'kikrh14.bin';l:$4000;p:0),(n:'kikrh13.bin';l:$4000;p:$4000),
        (n:'';l:0;p:0));
        shaolin_pal:array[0..5] of tipo_roms=(
        (n:'kicker.a12';l:$100;p:$0),(n:'kicker.a13';l:$100;p:$100),
        (n:'kicker.a14';l:$100;p:$200),(n:'kicker.b8';l:$100;p:$300),
        (n:'kicker.f16';l:$100;p:$400),(n:'';l:0;p:0));

var
 banco_pal,scroll:byte;
 pedir_nmi:boolean;

implementation
uses principal;

procedure Cargar_shaolin;
begin
form1.shaolin1.Checked:=true;
llamadas_maquina.caption:='Shaolin''s Road';
llamadas_maquina.iniciar:=iniciar_shaolin;
llamadas_maquina.bucle_general:=shaolin_principal;
llamadas_maquina.cerrar:=cerrar_shaolin;
llamadas_maquina.reset:=reset_shaolin;
llamadas_maquina.canales_usados:=2;
end;

function iniciar_shaolin:boolean;pascal;
var
      colores:tpaleta;
      f:word;
      ctemp1,ctemp2,ctemp3,ctemp4:byte;
const
    pc_x:array[0..7] of dword=(0, 1, 2, 3, 8*8+0, 8*8+1, 8*8+2, 8*8+3);
    pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
    ps_x:array[0..15] of dword=(0, 1, 2, 3, 8*8+0, 8*8+1, 8*8+2, 8*8+3,
			16*8+0, 16*8+1, 16*8+2, 16*8+3, 24*8+0, 24*8+1, 24*8+2, 24*8+3);
    ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			32*8, 33*8, 34*8, 35*8, 36*8, 37*8, 38*8, 39*8);
begin
iniciar_shaolin:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[2].x:=256;
p_final[2].y:=256;
iniciar_video;
//datos del scroll
scroll_data.long_x:=256;
scroll_data.ad_x:=256;
scroll_data.max_x:=256;
scroll_data.max_scr_x:=255;
//Main CPU
init_cpu(m6809_main,0,1536000/llamadas_maquina.fps_max/16);
main_6809_ll.getbyte:=shaolin_getbyte;
main_6809_ll.putbyte:=shaolin_putbyte;
//Sound Chip
SN76496_init(0,1536000);
SN76496_init(1,3072000);
//Timers
init_timer(0,0,1536000/44100,shaolin_despues_instruccion,true);
{cargar roms}
if not(cargar_roms(@memoria[0],@shaolin_rom[0],'\shaolins.zip',0)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@shaolin_char[0],'\shaolins.zip',0)) then exit;
init_gfx(0,8,8,512);
des_sprites.pos_planos[0]:=512*16*8+4;
des_sprites.pos_planos[1]:=512*16*8+0;
des_sprites.pos_planos[2]:=4;
des_sprites.pos_planos[3]:=0;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=16*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@shaolin_sprites[0],'\shaolins.zip',0)) then exit;
init_gfx(1,16,16,256);
gfx[1].trans[0]:=true;
des_sprites.pos_planos[0]:=256*64*8+4;
des_sprites.pos_planos[1]:=256*64*8+0;
des_sprites.pos_planos[2]:=4;
des_sprites.pos_planos[3]:=0;
des_sprites.long_sprites:=64*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
//paleta
if not(cargar_roms(@memoria_temp[0],@shaolin_pal[0],'\shaolins.zip',0)) then exit;
for f:=0 to 255 do begin
  ctemp1:=memoria_temp[0+f] and 1;
  ctemp2:=(memoria_temp[0+f] shr 1) and 1;
  ctemp3:=(memoria_temp[0+f] shr 2) and 1;
  ctemp4:=(memoria_temp[0+f] shr 3) and 1;
  colores[f].r:=$0e*ctemp1+$1f*ctemp2+$43*ctemp3+$8f*ctemp4;
  ctemp1:=memoria_temp[$100+f] and 1;
  ctemp2:=(memoria_temp[$100+f] shr 1) and 1;
  ctemp3:=(memoria_temp[$100+f] shr 2) and 1;
  ctemp4:=(memoria_temp[$100+f] shr 3) and 1;
  colores[f].g:=$0e*ctemp1+$1f*ctemp2+$43*ctemp3+$8f*ctemp4;
  ctemp1:=memoria_temp[$200+f] and 1;
  ctemp2:=(memoria_temp[$200+f] shr 1) and 1;
  ctemp3:=(memoria_temp[$200+f] shr 2) and 1;
  ctemp4:=(memoria_temp[$200+f] shr 3) and 1;
  colores[f].b:=$0e*ctemp1+$1f*ctemp2+$43*ctemp3+$8f*ctemp4;
end;
poner_paleta(colores,256);
//tabla_colores char
ctemp1:=0;
for ctemp2:=0 to 255 do begin
	for ctemp3:=0 to 7 do begin
		gfx[0].colores[ctemp2+ctemp3*256]:=(memoria_temp[ctemp1+$300] and $f)+32*ctemp3+16;
  end;
	inc(ctemp1);
end;
//tabla_colores sprites
ctemp1:=0;
for ctemp2:=0 to 255 do begin
	for ctemp3:=0 to 7 do begin
		gfx[1].colores[ctemp2+ctemp3*256]:=(memoria_temp[ctemp1+$400] and $f)+32*ctemp3;
  end;
	inc(ctemp1);
end;
//final
reset_shaolin;
iniciar_shaolin:=true;
end;

procedure cerrar_shaolin;pascal;
begin
cerrar_cpus;
SN76496_close(0);
SN76496_close(1);
cerrar_audio;
cerrar_video;
end;

procedure reset_shaolin;pascal;
begin
 reset_6809(main_6809,main_6809_ll);
 reset_audio;
 zeromemory(@memoria[0],$3FFF);
 banco_pal:=0;
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 pedir_nmi:=false;
end;

procedure update_video_shaolin;
var
  x,y,f:word;
  color,nchar:word;
begin
for f:=0 to $3ff do begin
    if gfx[0].buffer[f] then begin
      y:=f mod 32;
      x:=31-(f div 32);
      color:=((memoria[$3800+f] and $f)+($10*banco_pal)) shl 4;
      nchar:=memoria[$3c00+f]+((memoria[$3800+f] and $40) shl 2);
      put_gfx_flip(x*8,y*8,nchar,color,1,0,(memoria[$3800+f] and $20)<>0,(memoria[$3800+f] and $10)<>0);
      gfx[0].buffer[f]:=false;
    end;
end;
scroll__x(1,2,scroll);
actualiza_trozo(0,0,256,32,1,0,0,256,32,2);
for f:=$17 downto 0 do if ((memoria[$3100+(f*32)]<>0) and (memoria[$3106+(f*32)]<>0)) then begin
  color:=((memoria[$3109+(f*32)] and $f)+($10*banco_pal)) shl 4;
  x:=memoria[$3104+(f*32)]-8;
  y:=(240-memoria[$3106+(f*32)]) and $FF;
  put_gfx_sprite(memoria[$3108+(f*32)],color,(memoria[$3109+(f*32)] and $80)<>0,(memoria[$3109+(f*32)] and $40)=0,1);
  actualiza_gfx_sprite(x,y,2,1);
end;
actualiza_trozo(16,0,224,256,2,0,0,224,256,0);
end;

procedure eventos_shaolin;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_DOWN] or joystick.arriba) then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if (teclado[SDLK_UP] or joystick.abajo) then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if (teclado[SDLK_RIGHT] or joystick.izq) then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if (teclado[SDLK_LEFT] or joystick.der) then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $df) else in1:=(in1 or $20);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if teclado[SDLK_1] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if teclado[SDLK_5] then in0:=(in0 and $fe) else in0:=(in0 or 1);
  if teclado[SDLK_2] then in0:=(in0 and $ef) else in0:=(in0 or $10);
end;
end;

procedure shaolin_principal;pascal;
var
  f:byte;
  frame:single;
begin
iniciar_entradas;
frame:=0;
while EmuStatus=EsRuning do begin
 for f:=0 to 15 do begin
  frame:=frame+main_6809.tframes;
  run_6809(main_6809,main_6809_ll,trunc(frame));
  frame:=frame-main_6809.contador;
  main_6809.contador:=0;
  if f=0 then main_6809.pedir_irq:=true
    else if (f mod 2)=0 then main_6809.pedir_nmi:=pedir_nmi;
 end;
  update_video_shaolin;
  actualiza_video;
  eventos_shaolin;
  sincronizar;
  evaluar_entradas;
end;
end;

function shaolin_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $500:shaolin_getbyte:=$5a;
  $600:shaolin_getbyte:=$FF;
  $700:shaolin_getbyte:=in0;
  $701:shaolin_getbyte:=in1;
  $702:shaolin_getbyte:=in2;
  $703:shaolin_getbyte:=$ff;
  else shaolin_getbyte:=memoria[direccion];
end;
end;

procedure shaolin_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion>$3FFF then exit;
memoria[direccion]:=valor;
case direccion of
  $0:pedir_nmi:=((valor and $2)<>0);
  $0300:SN76496Write(0,valor);
  $0400:SN76496Write(1,valor);
  $1800:banco_pal:=valor and $7;
  $2000:scroll:=255-valor;
  $3800..$3fff:gfx[0].buffer[direccion and $3ff]:=true;
end;
end;

procedure shaolin_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=SN76496Update(0);
  tsample[1][posicion_sonido]:=SN76496Update(1);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
