unit asteroid;

interface
uses asteroids_audio,m6502,constantes,sdl,windows,entradas,arcade_const,timers,samples;
var
        testados_nmi:word;
        dibujar:boolean;
        x_actual,y_actual:integer;
        hay_samples:boolean=false;

procedure Cargar_as;
procedure principal_as;pascal;
function getbyte_as(direccion:word): Byte; pascal;
procedure putbyte_as(direccion:word;valor:byte);pascal;
function iniciar_as:boolean;pascal;
procedure cerrar_as;pascal;
procedure reset_as;pascal;
procedure as_despues_instruccion;pascal;
procedure as_snd_nmi;pascal;

const
        as_rom:array[0..4] of tipo_roms=(
        (n:'035145.02';l:$800;p:$6800),(n:'035144.02';l:$800;p:$7000),
        (n:'035143.02';l:$800;p:$7800),(n:'035127.02';l:$800;p:$5000),
        (n:'';l:0;p:0));
        as_samples:array[0..2] of tipo_nombre_samples=((nombre:'explode1.wav'),
        (nombre:'explode2.wav'),(nombre:'explode3.wav'));
var
  invertir_ram:boolean;
  ram:array[0..1,0..$ff] of byte;

implementation
uses principal;

procedure Cargar_as;
begin
form1.asteroids1.Checked:=true;
llamadas_maquina.caption:='Asteroids';
llamadas_maquina.iniciar:=iniciar_as;
llamadas_maquina.bucle_general:=principal_as;
llamadas_maquina.cerrar:=cerrar_as;
llamadas_maquina.reset:=reset_as;
llamadas_maquina.canales_usados:=2;
end;

procedure update_video_as;
var
  posicion:word;
  istack:array[0..9] of word;
  x,y,dx,dy:integer;
  pila:byte;
  salir,draw:boolean;
  opcode:parejas;
  i,iscale:integer;
  color:word;
begin
pila:=9;
posicion:=$4000;
salir:=false;
iscale:=0;
while not(salir) do begin
  opcode.l:=memoria[posicion];
  opcode.h:=memoria[posicion+1];
  inc(posicion,2);
  draw:=false;
  case (opcode.w and $F000) of
    0,$b000:salir:=true; //halt
    $1000,$2000,$3000,$4000,$5000,$6000,$7000,$8000,$9000:begin //vectores largos
            i:=((opcode.w shr 12)+iscale) and $f; // Scale factor */
            if i>9 then i:=-1;
            y:=opcode.w and $3ff;
            dy:=y shr (9-i);
            if (opcode.w and $400)<>0 then dy:=-dy; // Y sign bit */
            opcode.l:=memoria[posicion];
            opcode.h:=memoria[posicion+1];
            inc(posicion,2); // get second half of instruction */
            x:=opcode.w and $3ff;
            dx:=x shr (9-i); // Adjust for both scale factors *
            if (opcode.w and $400)<>0 then dx:=-dx; // X sign bit */
            color:=(opcode.w shr 12) and $ff;
            x:=x_actual;
            y:=y_actual;
            x_actual:=x_actual+dx;
            y_actual:=y_actual+dy;
            draw:=color<>0;
    end;
    $a000:begin //Posicion del haz y factor de escalado
            y_actual:=opcode.w and $fff; // Lower 12 bits are Y position */
            opcode.l:=memoria[posicion];
            opcode.h:=memoria[posicion+1];
            inc(posicion,2); // get second half of instruction */
            x_actual:=opcode.w and $fff; // Lower 12 bits are X position */
            iScale:=(opcode.w and $f000) shr 12;
            if (opcode.w and $8000)<>0 then iScale:=iScale-16; // divisor = negative shift
          end;
    $c000:begin  //Llamada subrutina
            if ((opcode.w and $1fff)=0) then salir:=true// Address of 0 same as HALT */
              else begin
                    iStack[pila]:=posicion; // push current position */
                    dec(pila);
                    posicion:=$4000+(opcode.w and $1fff)*2;
              end;
          end;
    $d000:begin //Vuelta de subrutina
            if pila=10 then begin
              salir:=true;
              pila:=0;
            end;
            inc(pila);
            posicion:=iStack[pila];
          end;
    $e000:begin //Saltar a posicion
            if ((opcode.w and $1fff)=0) then salir:=true // Address of 0 same as HALT */
             else posicion:=$4000+(opcode.w and $1fff)*2;
          end;
    $f000:begin //vector corto
            i:=((opcode.w shr 2) and $2)+((opcode.w shr 11) and $1);
            i:=((iScale+i) and $f);
            if i>7 then i:=-1;
            color:=((opcode.w shr 4) and $F);
            x:=(opcode.w and 3) shl 8;
            dx:=x shr (7-i);
            if (opcode.w and 4)<>0 then dx:=-dx;
            y:=opcode.w and $300;
            dy:=y shr (7-i);
            if (opcode.w and $400)<>0 then dy:=-dy;
            x:=x_actual;
            y:=y_actual;
            x_actual:=x_actual+dx;
            y_actual:=y_actual+dy;
            draw:=color<>0;
          end;
  end;
  if draw then linea(trunc(x/2.56),trunc((1024-y)/3.4133),trunc(x_actual/2.56),trunc((1024-y_actual)/3.4133),color);
  //Resolucion 400x300
end;
end;

procedure eventos_as;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_RIGHT] or joystick.der) then in1:=in1 or $40 else in1:=in1 and $bf;
  if (teclado[SDLK_LEFT] or joystick.izq) then in1:=in1 or $80 else in1:=in1 and $7F;
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=in0 or $10 else in0:=in0 and $ef;
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=in1 or $20 else in1:=in1 and $df;
  if (teclado[SDLK_LSHIFT] or joystick.boton2) then in0:=in0 or $8 else in0:=in0 and $f7;
  if teclado[SDLK_5] then in1:=in1 or 1 else in1:=in1 and $fe;
  if teclado[SDLK_1] then in1:=in1 or 8 else in1:=in1 and $f7;
end;
end;

procedure principal_as;pascal;
var
  frame:single;
begin
iniciar_entradas;
frame:=0;
while EmuStatus=EsRuning do begin
 frame:=frame+main_6502.tframes;
 run_6502(main_6502,main_6502_ll,trunc(frame));
 frame:=frame-main_6502.contador;
 main_6502.contador:=0;
 if dibujar then begin
  pintar_pantalla(0,0);
  update_video_as;
  actualiza_video;
  dibujar:=false;
 end;
 eventos_as;
 sincronizar;
 evaluar_entradas;
end;
end;

function getbyte_as(direccion:word):Byte; pascal;
var
  mascara:byte;
  res:boolean;
begin
direccion:=direccion and $7FFF;
case direccion of
  $200..$2ff:if invertir_ram then getbyte_as:=ram[1,direccion and $ff]
              else getbyte_as:=ram[0,direccion and $ff];
  $300..$3ff:if invertir_ram then getbyte_as:=ram[0,direccion and $ff]
              else getbyte_as:=ram[1,direccion and $ff];
  $2000..$2007:begin
    mascara:=1 shl (direccion-$2000);
    res:=(in0 and mascara)<>0;
    if res then getbyte_as:=$80
      else getbyte_as:=$7f;
  end;
  $2400..$2407:begin
    mascara:=1 shl (direccion-$2400);
    res:=(in1 and mascara)<>0;
    if res then getbyte_as:=$80
      else getbyte_as:=$7f;
  end;
  $2800:getbyte_as:=$FE;
  $2801:getbyte_as:=$FC;
  $2802:getbyte_as:=$FD;
  $2803:case idioma of
          1:getbyte_as:=$FC;
          3:getbyte_as:=$FE;
          4:getbyte_as:=$FD;
          else getbyte_as:=$FF;
        end;
  else getbyte_as:=memoria[direccion];
end;
end;

procedure putbyte_as(direccion:word;valor:byte);pascal;
begin
direccion:=direccion and $7FFF;
memoria[direccion]:=valor;
case direccion of
  $200..$2FF:if invertir_ram then ram[1,direccion and $ff]:=valor
              else ram[0,direccion and $ff]:=valor;
  $300..$3FF:if invertir_ram then ram[0,direccion and $ff]:=valor
              else ram[1,direccion and $ff]:=valor;
  $4000..$47ff:dibujar:=true;
  $3200:invertir_ram:=(valor and 4)<>0;
  $3600:if hay_samples then asteroid_explode_sam(valor)
          else asteroid_explode_w(valor);
  $3a00:asteroid_thump_w(valor);
  $3c00..$3c05:asteroid_sounds_w(direccion-$3c00,valor);
end;
end;

function iniciar_as:boolean;pascal;
var
        colores:tpaleta;
        f:byte;
begin
iniciar_as:=false;
iniciar_audio(1);
p_final[0].x:=400;
p_final[0].y:=300;
iniciar_video;
//Main CPU
init_cpu(m6502_main,0,1512000/llamadas_maquina.fps_max);
main_6502_ll.getbyte:=getbyte_as;
main_6502_ll.putbyte:=putbyte_as;
asteroid_sound_init;
//Timers
timer[0].cpu:=0;
timer[0].tiempo:=1512000 div 44100;
timer[0].ejecutar:=as_despues_instruccion;
timer[0].enabled:=true;
timer[1].cpu:=0;
timer[1].tiempo:=6144;
timer[1].ejecutar:=as_snd_nmi;
timer[1].enabled:=true;
//cargar roms
if not(cargar_roms(@memoria[0],@as_rom[0],'\asteroid.zip',0)) then exit;
//samples
hay_samples:=cargar_samples('\asteroid.zip',@as_samples[0],3);
//poner la paleta
for f:=0 to 14 do begin
  colores[f].r:=16*f;
  colores[f].g:=16*f;
  colores[f].b:=16*f;
end;
colores[15].r:=255;
colores[15].g:=255;
colores[15].b:=255;
poner_paleta(colores,16);
//final
reset_as;
iniciar_as:=true;
end;

procedure cerrar_as;pascal;
begin
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_as;pascal;
begin
reset_6502(main_6502,main_6502_ll);
testados_nmi:=0;
in0:=0;
in1:=0;
x_actual:=0;
y_actual:=0;
invertir_ram:=false;
end;

procedure as_snd_nmi;pascal;
begin
  main_6502.pedir_nmi:=true;
end;

procedure as_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=asteroid_sound_update;
  if hay_samples then tsample[1][posicion_sonido]:=play_samples;
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
