unit blktiger;

interface
uses sdl,z80,constantes,windows,entradas,ym_2203,arcade_const,timers;

procedure Cargar_blktiger;
procedure blktiger_principal;pascal;
function blktiger_getbyte(direccion:word): Byte; pascal;
procedure blktiger_putbyte(direccion:word;valor:byte);pascal;
function blksnd_getbyte(direccion:word): Byte; pascal;
procedure blksnd_putbyte(direccion:word;valor:byte);pascal;
function blktiger_inbyte(puerto:word):byte;pascal;
procedure blk_despues_instruccion;pascal;
procedure blktiger_outbyte(valor:byte;puerto:word);pascal;
function iniciar_blktiger:boolean;pascal;
procedure reset_blktiger;pascal;
procedure cerrar_blktiger;pascal;
procedure snd_irq(numchip:integer;irqstate:integer);pascal;

const
        blktiger_rom:array[0..5] of tipo_roms=(
        (n:'bdu-01a.5e';l:$8000;p:0),(n:'bdu-02a.6e';l:$10000;p:$8000),(n:'bdu-03a.8e';l:$10000;p:$18000),
        (n:'bd-04.9e';l:$10000;p:$28000),(n:'bd-05.10e';l:$10000;p:$38000),(n:'';l:0;p:0));
        blktiger_char: tipo_roms=(n:'bd-15.2n';l:$8000;p:0);
        blktiger_sprites:array[0..4] of tipo_roms=(
        (n:'bd-08.5a';l:$10000;p:0),(n:'bd-07.4a';l:$10000;p:$10000),(n:'bd-10.9a';l:$10000;p:$20000),
        (n:'bd-09.8a';l:$10000;p:$30000),(n:'';l:0;p:0));
        blktiger_tiles:array[0..4] of tipo_roms=(
        (n:'bd-12.5b';l:$10000;p:0),(n:'bd-11.4b';l:$10000;p:$10000),(n:'bd-14.9b';l:$10000;p:$20000),
        (n:'bd-13.8b';l:$10000;p:$30000),(n:'';l:0;p:0));
        blktiger_snd: tipo_roms=(n:'bd-06.1l';l:$8000;p:0);

var
 scroll_ram:array[0..$3FFF] of byte;
 sc_buffer:array[0..$3fff] of boolean;
 memoria_rom:array [0..$F,$0..$3FFF] of byte;
 banco_rom,soundlatch:byte;
 video_sw:boolean;
 scroll_x,scroll_y:parejas;
 scroll_x_mask,scroll_y_mask:byte;
 scroll_bank:word;

implementation
uses principal;

procedure Cargar_blktiger;
begin
form1.blacktiger1.Checked:=true;
llamadas_maquina.caption:='Black Tiger';
llamadas_maquina.iniciar:=iniciar_blktiger;
llamadas_maquina.bucle_general:=blktiger_principal;
llamadas_maquina.cerrar:=cerrar_blktiger;
llamadas_maquina.reset:=reset_blktiger;
llamadas_maquina.canales_usados:=2;
end;

procedure draw_fondo(posicion:word);
var
  numero_pant,atrib:byte;
  pos_x,pos_y,base,nchar,color:word;
const
  x_84:array[0..7] of word =(0,256,512,768,1024,1280,1536,1792);
  x_48:array[0..3] of word =(0,256,512,768);
  split_table:array[0..15] of byte=(3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
begin
numero_pant:=(posicion shr 9); //div $200
base:=(posicion and $1ff) shr 1;
if not(video_sw) then begin //4x8
  pos_x:=((base and $0F) shl 4)+x_48[numero_pant and 3];
  pos_y:=(base and $f0)+x_84[numero_pant shr 2]+(scroll_bank shr 3);
end else begin  //8x4
  pos_x:=((base and $0F) shl 4)+x_84[numero_pant and 7];
  pos_y:=(base and $f0)+x_48[numero_pant shr 3]+(scroll_bank shr 4);
end;
atrib:=scroll_ram[scroll_bank+posicion+1];
nchar:=scroll_ram[scroll_bank+posicion]+((atrib and $7) shl 8);
color:=(atrib and $78) shl 1;
put_gfx_flip(pos_x,pos_y,nchar,color+512,1,2,(atrib and $80)<>0,false);
if split_table[color shr 4]=0 then put_gfx_trans(pos_x,pos_y,0,0,7,2)
  else put_gfx_trans_flip(pos_x,pos_y,nchar,color+512,7,2,(atrib and $80)<>0,false);
end;

procedure update_video_blktiger;
var
    f,x,y,nchar,color:word;
begin
//atributo de las tiles
//$80 --> flip x
//$40 + $20 + $10 + $8 --> Color
// $4 + $2 + $1 --> Numero tile
for f:=0 to $7FF do if sc_buffer[scroll_bank+(f*2)] then begin
    draw_fondo(f*2);
    sc_buffer[scroll_bank+(f*2)]:=false;
end;
scroll_x_y(1,2,scroll_x.w,scroll_y.w);
//cuatro bytes
// 0 --> codigo sprite
// 1 --> Atributo
//          $80+$40+$20 resto codigo sprite
//          $10 posicion x
//          $8 flip x
//          $4+$2+$1 color sprite
// 2 --> Y
// 3 --> X
for f:=$7f downto 0 do begin
  nchar:=buffer_sprites[f*4]+(buffer_sprites[$1+(f*4)] and $e0) shl 3;
  color:=(buffer_sprites[$1+(f*4)] and $7) shl 4+256;
  x:=buffer_sprites[$3+(f*4)]+(buffer_sprites[$1+(f*4)] and $10) shl 4;
  y:=buffer_sprites[$2+(f*4)];
  put_gfx_sprite(nchar,color,(buffer_sprites[$1+(f*4)] and 8)<>0,false,1);
  actualiza_gfx_sprite(x,y,2,1);
end;
//Prioridad del fondo
scroll_x_y(7,2,scroll_x.w,scroll_y.w);
//Caracteres
for f:=$0 to $3ff do begin
 if gfx[0].buffer[f] then begin
    y:=f div 32;
    x:=f mod 32;
    color:=(memoria[$d400+f] and $1f) shl 2;
    nchar:=memoria[$d000+f]+(memoria[$d400+f] and $e0) shl 3;
    put_gfx_trans(x*8,y*8,nchar,color,6,0);
    gfx[0].buffer[f]:=false;
 end;
end;
actualiza_trozo(0,0,256,256,6,0,0,256,256,2);
actualiza_trozo(0,16,256,224,2,0,0,256,224,0);
end;

procedure eventos_blktiger;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if (teclado[SDLK_LEFT] or joystick.izq) then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if (teclado[SDLK_RIGHT] or joystick.der) then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $df) else in1:=(in1 or $20);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if teclado[SDLK_5] then in0:=(in0 and $7f) else in0:=(in0 or $80);
  if teclado[SDLK_1] then in0:=(in0 and $fe) else in0:=(in0 or 1);
  if teclado[SDLK_2] then in0:=(in0 and $fd) else in0:=(in0 or 2);
end;
end;

procedure cerrar_blktiger;pascal;
begin
save_hi('blktiger.hi',@memoria[$e200],80);
cerrar_cpus;
ym2203_close(0);
ym2203_close(1);
cerrar_audio;
cerrar_video;
end;

procedure reset_blktiger;pascal;
begin
 reset_z80(main_z80);
 reset_z80(snd_z80);
 ym2203_reset(0);
 ym2203_reset(1);
 reset_audio;
 banco_rom:=0;
 soundlatch:=0;
 scroll_bank:=0;
 scroll_x.w:=0;
 scroll_y.w:=0;
 video_sw:=false;
 in0:=$FF;
 in1:=$FF;
 hi_score:=false;
 fillmemory(@sc_buffer[0],$4000,1);
end;

function iniciar_blktiger:boolean;pascal;
var
      f:word;
const
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3);
  pc_y:array[0..7] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16);
  ps_x:array[0..15] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3,
			16*16+0, 16*16+1, 16*16+2, 16*16+3, 16*16+8+0, 16*16+8+1, 16*16+8+2, 16*16+8+3);
  ps_y:array[0..15] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16,
			8*16, 9*16, 10*16, 11*16, 12*16, 13*16, 14*16, 15*16);
begin
iniciar_blktiger:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=224;
//p_final[0].x:=2048;
//p_final[0].y:=2048;
p_final[1].x:=2048;
p_final[1].y:=2048;
p_final[2].x:=512;
p_final[2].y:=256;
p_final[6].x:=256;
p_final[6].y:=256;
p_final[6].trans:=true;
p_final[7].x:=2048;
p_final[7].y:=2048;
p_final[7].trans:=true;
iniciar_video;
//Datos scroll
scroll_data.max_x:=256;
scroll_data.max_y:=256;
//Main CPU
init_cpu(z80_main,0,6000000/llamadas_maquina.fps_max);
main_z80.daisy:=false;
main_z80_ll.getbyte:=blktiger_getbyte;
main_z80_ll.putbyte:=blktiger_putbyte;
main_z80_ll.outbyte:=blktiger_outbyte;
main_z80_ll.inbyte:=blktiger_inbyte;
//Sound CPU
init_cpu(z80_snd,1,3579545/llamadas_maquina.fps_max);
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=blksnd_getbyte;
snd_z80_ll.putbyte:=blksnd_putbyte;
snd_z80_ll.outbyte:=nil;
snd_z80_ll.inbyte:=nil;
//Sound Chip
ym2203_Init(0,3579545,1,nil,nil,nil,nil);
ym2203_Init(1,3579545,1,nil,nil,nil,nil);
ym2203_init_timers(3579545,1,0,snd_irq);
//Timers
init_timer(0,1,3579545/44100,blk_despues_instruccion,true);
//cargar roms
if not(cargar_roms(@memoria_temp[0],@blktiger_rom[0],'\blktiger.zip',0)) then exit;
//poner las roms y los bancos de rom
copymemory(@memoria[0],@memoria_temp[0],$8000);
for f:=0 to 15 do copymemory(@memoria_rom[f,0],@memoria_temp[$8000+(f*$4000)],$4000);
//sonido
if not(cargar_roms(@mem_snd[0],@blktiger_snd,'\blktiger.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@blktiger_char,'\blktiger.zip',1)) then exit;
init_gfx(0,8,8,2048);
gfx[0].trans[3]:=true;
des_sprites.pos_planos[0]:=4;
des_sprites.pos_planos[1]:=0;
des_sprites.bit_pixel:=2;
des_sprites.long_sprites:=16*8;
des_sprites.banks:=0;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@blktiger_sprites[0],'\blktiger.zip',0)) then exit;
init_gfx(1,16,16,2048);
gfx[1].trans[15]:=true;
des_sprites.bit_pixel:=4;
des_sprites.pos_planos[0]:=$20000*8+4;
des_sprites.pos_planos[1]:=$20000*8+0;
des_sprites.pos_planos[2]:=4;
des_sprites.pos_planos[3]:=0;
des_sprites.long_sprites:=32*16;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//tiles
if not(cargar_roms(@memoria_temp[0],@blktiger_tiles[0],'\blktiger.zip',0)) then exit;
init_gfx(2,16,16,2048);
gfx[2].trans[12]:=true;
gfx[2].trans[13]:=true;
gfx[2].trans[14]:=true;
gfx[2].trans[15]:=true;
convert_sprites(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//final
reset_blktiger;
iniciar_blktiger:=true;
end;

procedure blktiger_principal;pascal;
var
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
  frame_m:=frame_m+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame_m));
  main_z80.pedir_irq:=true;
  frame_s:=frame_s+snd_z80.tframes;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_m:=frame_m-main_z80.contador;
  main_z80.contador:=0;
  frame_s:=frame_s-snd_z80.contador;
  snd_z80.contador:=0;
  update_video_blktiger;
  actualiza_video;
  eventos_blktiger;
  sincronizar;
  evaluar_entradas;
  copymemory(@buffer_sprites[0],@memoria[$fe00],$200);
end;
end;

function blksnd_getbyte(direccion:word): Byte; pascal;
begin
  case direccion of
    $c800:blksnd_getbyte:=soundlatch;
    $e000:blksnd_getbyte:=ym2203_Read_Status(0);
    $e001:blksnd_getbyte:=ym2203_Read_Reg(0);
    $e002:blksnd_getbyte:=ym2203_Read_Status(1);
    $e003:blksnd_getbyte:=ym2203_Read_Reg(1);
    else blksnd_getbyte:=mem_snd[direccion];
  end;
end;

procedure blksnd_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$8000 then exit;
case direccion of
  $e000:ym2203_Control(0,valor);
  $e001:ym2203_Write_Reg(0,valor);
  $e002:ym2203_Control(1,valor);
  $e003:ym2203_Write_Reg(1,valor);
  else mem_snd[direccion]:=valor;
end;
end;

function blktiger_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $8000..$bfff:blktiger_getbyte:=memoria_rom[banco_rom,(direccion and $3fff)];
  $c000..$cfff:blktiger_getbyte:=scroll_ram[scroll_bank+(direccion and $fff)];
  else blktiger_getbyte:=memoria[direccion];
end;
end;

procedure cambiar_color(dir:word);
var
        tmp_color,bit0:byte;
        color:tcolor;
begin
  tmp_color:=memoria[dir];
  bit0:=tmp_color shr 4;
  color.r:=bit0+(bit0 shl 4);
  bit0:=tmp_color and $f;
  color.g:=bit0+(bit0 shl 4);
  tmp_color:=memoria[dir+$400] and $f;
  color.b:=tmp_color+(tmp_color shl 4);
  case dir of
    $d800..$d9ff:begin  //tiles
                    poner_color(color,addr(paleta[(dir and $1ff)+512]));
                    fillmemory(@sc_buffer[0],$4000,1);
                 end;
    $da00..$daff:poner_color(color,addr(paleta[(dir and $ff)+256]));
    $db00..$dbff:begin //chars
                    poner_color(color,addr(paleta[(dir and $ff)]));
                    fillmemory(@gfx[0].buffer[0],$400,1);
                 end;
  end;
end;

procedure blktiger_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$c000 then exit;
memoria[direccion]:=valor;
case direccion of
        $c000..$cfff:begin
                        scroll_ram[scroll_bank+(direccion and $fff)]:=valor;
                        sc_buffer[scroll_bank+(direccion and $fff)]:=true;
                     end;
        $d000..$d7ff:gfx[0].buffer[direccion and $3ff]:=true;
        $d800..$dfff:if buffer_paleta[direccion and $7ff]<>valor then begin
                        cambiar_color(direccion and $fbff);
                        buffer_paleta[direccion and $7ff]:=valor;
                     end;
end;
end;

function blktiger_inbyte(puerto:word):byte;pascal;
begin
case (puerto and $FF) of
  0:blktiger_inbyte:=in0;
  1:blktiger_inbyte:=in1;
  2:blktiger_inbyte:=$FF;
  3:blktiger_inbyte:=$FF;
  4:blktiger_inbyte:=$6F;
  5:blktiger_inbyte:=$1;
  7:blktiger_inbyte:=main_z80.de.h;  //Proteccion
  else blktiger_inbyte:=$FF;
end;
end;

procedure blktiger_outbyte(valor:byte;puerto:word);pascal;
begin
case (puerto and $FF) of
  0:soundlatch:=valor;
  1:banco_rom:= valor and $F;
  8:scroll_x.l:=valor;
  9:scroll_x.h:=valor and scroll_x_mask;
  $a:scroll_y.l:=valor;
  $b:scroll_y.h:=valor and scroll_y_mask;
  $d:scroll_bank:=(valor and 3) shl 12;
  $e:begin
      video_sw:=(valor and 1)=1;
      if video_sw then begin
        scroll_data.long_x:=2048;
        scroll_data.long_y:=1024;
        scroll_data.max_scr_x:=1791;
        scroll_data.max_scr_y:=767;
        scroll_x_mask:=$7;
        scroll_y_mask:=$3;
      end else begin
        scroll_data.long_x:=1024;
        scroll_data.long_y:=2048;
        scroll_data.max_scr_x:=767;
        scroll_data.max_scr_y:=1791;
        scroll_x_mask:=$3;
        scroll_y_mask:=$7;
      end;
     end;
end;
end;

procedure blk_despues_instruccion;pascal;
begin
if not(hi_score) then begin
  if ((memoria[$e204]=2) and (memoria[$e205]=0) and (memoria[$e206]=0)) then begin
    load_hi('blktiger.hi',@memoria[$e200],80);
    copymemory(@memoria[$e1e0],@memoria[$e200],8);
    hi_score:=true;
  end;
end;
if hay_sonido then begin
  tsample[0][posicion_sonido]:=ym2203UpdateOne(0);
  tsample[1][posicion_sonido]:=ym2203UpdateOne(1);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

procedure snd_irq(numchip:integer;irqstate:integer);pascal;
begin
  snd_z80.pedir_irq:=(irqstate=1);
end;

end.
