unit bubblebobble;
interface
uses sdl,z80,constantes,windows,entradas,arcade_const,timers,ym_2203,ym_3812;

procedure Cargar_bublbobl;
procedure bublbobl_principal;pascal;
function bublbobl_getbyte(direccion:word): Byte; pascal;
procedure bublbobl_putbyte(direccion:word;valor:byte);pascal;
function bb_misc_getbyte(direccion:word): Byte; pascal;
procedure bb_misc_putbyte(direccion:word;valor:byte);pascal;
function bbsnd_getbyte(direccion:word): Byte; pascal;
procedure bbsnd_putbyte(direccion:word;valor:byte);pascal;
procedure bb_despues_instruccion;pascal;
function iniciar_bublbobl:boolean;pascal;
procedure reset_bublbobl;pascal;
procedure cerrar_bublbobl;pascal;
procedure snd_irq(numchip:integer;irqstate:integer);pascal;

const
        bublbobl_rom:array[0..2] of tipo_roms=(
        (n:'a78-06-1.51';l:$8000;p:0),(n:'a78-05-1.52';l:$10000;p:$8000),
        (n:'';l:0;p:0));
        bublbobl_rom2:tipo_roms=(n:'a78-08.37';l:$8000;p:0);
        bublbobl_chars:array[0..12] of tipo_roms=(
        (n:'a78-09.12';l:$8000;p:0),(n:'a78-10.13';l:$8000;p:$8000),
        (n:'a78-11.14';l:$8000;p:$10000),(n:'a78-12.15';l:$8000;p:$18000),
        (n:'a78-13.16';l:$8000;p:$20000),(n:'a78-14.17';l:$8000;p:$28000),
        (n:'a78-15.30';l:$8000;p:$40000),(n:'a78-16.31';l:$8000;p:$48000),
        (n:'a78-17.32';l:$8000;p:$50000),(n:'a78-18.33';l:$8000;p:$58000),
        (n:'a78-19.34';l:$8000;p:$60000),(n:'a78-20.35';l:$8000;p:$68000),
        (n:'';l:0;p:0));
        bublbobl_snd: tipo_roms=(n:'a78-07.46';l:$8000;p:0);
        bublbobl_prom: tipo_roms=(n:'a71-25.41';l:$100;p:0);
        interleave=100;
var
 memoria_rom:array [0..3,$0..$3FFF] of byte;
 mem_misc:array[0..$FFFF] of byte;
 mem_prom:array[0..$ff] of byte;
 banco_rom,sound_status,sound_latch:byte;
 mcu_run,sound_nmi,pending_nmi:boolean;

implementation
uses principal;

procedure Cargar_bublbobl;
begin
form1.bubblebobble1.Checked:=true;
llamadas_maquina.caption:='Bubble Bobble';
llamadas_maquina.iniciar:=iniciar_bublbobl;
llamadas_maquina.bucle_general:=bublbobl_principal;
llamadas_maquina.cerrar:=cerrar_bublbobl;
llamadas_maquina.reset:=reset_bublbobl;
llamadas_maquina.canales_usados:=2;
llamadas_maquina.fps_max:=59.185606;
end;

procedure update_video_bublbobl;
var
    f,x,y,nchar,color,offs:integer;
    sx,sy:integer;
    gfx_num,gfx_code,yc,xc:integer;
    goffs:integer;
    gfx_offs:integer;
    flipx,flipy:boolean;
begin
for offs:=0 to $f do begin
    if ((memoria[$dd00+offs]=0) and (memoria[$dd00+offs+1]=0) and (memoria[$dd00+offs+2]=0) and (memoria[$dd00+offs+3]=0)) then continue;
		gfx_num:=memoria[$dd00+(4*offs + 1)];
		gfx_code:=memoria[$dd00+(4*offs + 3)];
		sx:= offs * 16;
		gfx_offs:= ((gfx_num and $3f) * $80);
		for xc:=0 to 1 do begin
			for yc:=0 to 31 do begin
				goffs:=(gfx_offs + xc * $40 + yc * $02)+$c000;
				color:= (memoria[goffs + 1] and $3c) shl 2;
        flipx:=(memoria[goffs + 1] and $40)<>0;
        flipy:=(memoria[goffs + 1] and $80)<>0;
        nchar:=memoria[goffs] + 256 * (memoria[goffs + 1] and $03) + 1024 * (gfx_code and $0f);
        x:=sx + xc * 8;
        y:=yc * 8;
        put_gfx_flip(x,y,nchar,color,2,0,flipx,flipy);
			end;
    end;
end;
//hacer el scroll independiente linea a linea
for f:=0 to 15 do begin
  offs:=memoria[$dd00+4*f];
  x:=256-offs;
  actualiza_trozo(f*16,offs,16,x,2,f*16,0,16,x,3);
  if x<>256 then actualiza_trozo(f*16,0,16,offs,2,f*16,x,16,offs,3);
end;
for f:=$0 to $bc do begin
    offs:=(f*4)+$dd00;
    if ((memoria[offs]=0) and (memoria[offs+1]=0) and (memoria[offs+2]=0) and (memoria[offs+3]=0)) then continue;
		gfx_num:=memoria[offs + 1];
		gfx_code:=memoria[offs + 3];
		sx:=memoria[offs + 2];
		if ((gfx_num and $80)=0) then begin	// sprites */
			sy:= 256 - 8*8 - (memoria[offs + 0]);
			gfx_offs:=(((gfx_num and $1f) * $80) + ((gfx_num and $60) shr 1))+$c000;
      for xc:=0 to 1 do begin
 			 for yc:=0 to 7 do begin
				goffs:= gfx_offs + xc * $40 + yc * $02;
        nchar:=memoria[goffs] + 256 * (memoria[goffs + 1] and $03) + 1024 * (gfx_code and $0f);
        color:=(memoria[goffs + 1] and $3c) shl 2;
        flipx:=(memoria[goffs + 1] and $40)<>0;
        flipy:=(memoria[goffs + 1] and $80)<>0;
        x:=-4*(gfx_code and $40) + sx + xc * 8;
        y:=(sy + yc * 8) and $ff;
        put_gfx_sprite(nchar,color,flipx,flipy,0);
        actualiza_gfx_sprite(x,y,3,0);
			 end;
		  end;
		end	else begin	// foreground chars (each "sprite" is one 16x256 column) */
     if f>$40 then begin
			sy:= -(memoria[offs + 0]);
			gfx_offs:= ((gfx_num and $3f) * $80);
      for xc:=0 to 1 do begin
			 for yc:=0 to 31 do begin
				goffs:=(gfx_offs + xc * $40 + yc * $02)+$c000;
        nchar:=memoria[goffs] + 256 * (memoria[goffs + 1] and $03) + 1024 * (gfx_code and $0f);
        color:=(memoria[goffs + 1] and $3c) shl 2;
        flipx:=(memoria[goffs + 1] and $40)<>0;
        flipy:=(memoria[goffs + 1] and $80)<>0;
        x:=-4*(gfx_code and $40) + sx + xc * 8;
        y:=(sy + yc * 8) and $ff;
        put_gfx_trans_flip(x,y,nchar,color,1,0,flipx,flipy);
			 end;
		  end;
     end;
		end;
end;
actualiza_trozo(0,16,256,224,3,0,0,256,224,0);
actualiza_trozo(0,16,256,224,1,0,0,256,224,0);
end;

procedure eventos_bublbobl;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_RIGHT] or joystick.der) then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if (teclado[SDLK_LEFT] or joystick.izq) then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 and $df) else in1:=(in1 or $20);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if teclado[SDLK_5] then  in0:=(in0 or $4) else in0:=(in0 and $fb);
  if teclado[SDLK_1] then in1:=(in1 and $bf) else in1:=(in1 or $40);
  if teclado[SDLK_2] then in2:=(in2 and $bf) else in2:=(in2 or $40);
end;
end;

procedure cerrar_bublbobl;pascal;
begin
ym2203_close(0);
ym3812_close(1);
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_bublbobl;pascal;
begin
 reset_z80(main_z80);
 reset_z80(misc_z80);
 reset_z80(snd_z80);
 ym2203_reset(0);
 YM3812_ResetChip(1);
 reset_audio;
 banco_rom:=0;
 mcu_run:=false;
 sound_nmi:=false;
 pending_nmi:=false;
 sound_status:=0;
 in0:=$b3;
 in1:=$FF;
 in2:=$ff;
 sound_latch:=0;
end;

function iniciar_bublbobl:boolean;pascal;
var
      f:dword;
const
  pc_x:array[0..7] of dword=(3, 2, 1, 0, 8+3, 8+2, 8+1, 8+0);
  pc_y:array[0..7] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16);
begin
iniciar_bublbobl:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=224;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[3].x:=256;
p_final[3].y:=256;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,6000000/llamadas_maquina.fps_max/interleave);
main_z80.daisy:=false;
main_z80_ll.getbyte:=bublbobl_getbyte;
main_z80_ll.putbyte:=bublbobl_putbyte;
main_z80_ll.outbyte:=nil;
main_z80_ll.inbyte:=nil;
//Second CPU
init_cpu(z80_misc,2,6000000/llamadas_maquina.fps_max/interleave);
misc_z80.daisy:=false;
misc_z80_ll.getbyte:=bb_misc_getbyte;
misc_z80_ll.putbyte:=bb_misc_putbyte;
misc_z80_ll.outbyte:=nil;
misc_z80_ll.inbyte:=nil;
//Sound CPU
init_cpu(z80_snd,1,3000000/llamadas_maquina.fps_max/interleave);
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=bbsnd_getbyte;
snd_z80_ll.putbyte:=bbsnd_putbyte;
snd_z80_ll.outbyte:=nil;
snd_z80_ll.inbyte:=nil;
//Sound Chip
ym2203_Init(0,3000000,1,nil,nil,nil,nil);
ym2203_init_timers(3000000,1,0,snd_irq);
ym3812_init(1,3000000);
//Timers
init_timer(0,1,3000000/44100,bb_despues_instruccion,true);
//cargar roms
if not(cargar_roms(@memoria_temp[0],@bublbobl_rom[0],'\bublbobl.zip',0)) then exit;
//poner las roms y los bancos de rom
copymemory(@memoria[0],@memoria_temp[0],$8000);
for f:=0 to 3 do copymemory(@memoria_rom[f,0],@memoria_temp[$8000+(f*$4000)],$4000);
//Segunda CPU
if not(cargar_roms(@mem_misc[0],@bublbobl_rom2,'\bublbobl.zip',1)) then exit;
//sonido
if not(cargar_roms(@mem_snd[0],@bublbobl_snd,'\bublbobl.zip',1)) then exit;
//proms
if not(cargar_roms(@mem_prom[0],@bublbobl_prom,'\bublbobl.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@bublbobl_chars,'\bublbobl.zip',0)) then exit;
init_gfx(0,8,8,16384);
gfx[0].trans[0]:=true;
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=4;
des_sprites.pos_planos[2]:=8*$8000*8;
des_sprites.pos_planos[3]:=8*$8000*8+4;
des_sprites.bit_pixel:=4;
des_sprites.long_sprites:=16*8;
des_sprites.banks:=0;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
for f:=0 to 255 do gfx[0].colores[f]:=gfx[0].colores[f] xor $f;
//final
reset_bublbobl;
iniciar_bublbobl:=true;
end;

procedure mcu_compare_coords;
var
  player,enemy,coord,player_coord,enemy_coord,flag:byte;
  absdiff:integer;
begin
	for player:=0 to 1 do begin
		for coord:=0 to 1 do begin
			player_coord:= memoria[$fc00+$060 + 8 * player + coord];
			for enemy:=0 to 6 do begin
				enemy_coord:=memoria[$fc00+$02 + 4 * enemy + coord];
				if (player_coord=enemy_coord) then flag:=$80
				  else begin
            if (player_coord < enemy_coord) then flag:=$01
				      else flag:=$00;
          end;
				memoria[$fc00+$027 + player + 2 * coord + 8 * enemy]:= flag;
				absdiff:= player_coord - enemy_coord;
				if (absdiff<0) then absdiff:=-absdiff;
				memoria[$fc00+$27+4 + player + 2 * coord + 8 * enemy]:= absdiff;
			end;
		end;
	end;
end;

procedure update_mcu;
begin
  memoria[$fc00]:=$2e;	// IRQ vector
	memoria[$fc00+$1f]:=in0;	// coins
	memoria[$fc00+$20]:= $fe;	// dsw a
	memoria[$fc00+$21]:= $ff;	// dsw b
	memoria[$fc00+$22]:=in1;	// player 1
	memoria[$fc00+$23]:=in2;	// player 2
	mcu_compare_coords();
	if (memoria[$fc00+$07a]=$01) then begin	// timer is stopped
		dec(memoria[$fc00+$78]);
		if (memoria[$fc00+$78]=$ff) then dec(memoria[$fc00+$79]);
		if (memoria[$fc00+$79]=$ff) then begin
			memoria[$fc00+$7a]:=$00;	// restart enemies
			memoria[$fc00+$7b]:=$01;	// restore original screen color
		end;
	end;
	memoria[$fc00+$7c]:= random(6);	// EXTEND randomization (WRONG)
	memoria[$fc00+$7d]:=$00;	// MCU I/O error (must be 00)
	memoria[$fc00+$82]:=$00;	// MCU ROM checksum (must be 00)
	memoria[$fc00+$83]:=$00;	// MCU ROM checksum (must be 00)
	memoria[$fc00+$85]:=$37;	// "running ok" signal to Z80 (must be 37)
end;

procedure bublbobl_mcu;
begin
  if mcu_run then begin
    update_mcu;
    main_z80.im2_lo:=memoria[$fc00];
    main_z80.pedir_irq:=true;
  end;
end;

procedure bublbobl_principal;pascal;
var
  frame_m,frame_mi,frame_s:single;
  f:word;
begin
iniciar_entradas;
frame_m:=0;
frame_mi:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
 for f:=0 to interleave-1 do begin
  //main
  frame_m:=frame_m+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame_m));
  frame_m:=frame_m-main_z80.contador;
  main_z80.contador:=0;
  //segunda cpu
  frame_mi:=frame_mi+misc_z80.tframes;
  run_z80(misc_z80,misc_z80_ll,trunc(frame_mi));
  frame_mi:=frame_mi-misc_z80.contador;
  misc_z80.contador:=0;
  //sonido
  frame_s:=frame_s+snd_z80.tframes;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_s:=frame_s-snd_z80.contador;
  snd_z80.contador:=0;
 end;
 bublbobl_mcu;
 misc_z80.pedir_irq:=true;
 update_video_bublbobl;
 actualiza_video;
 eventos_bublbobl;
 sincronizar;
 evaluar_entradas;
end;
end;

function bbsnd_getbyte(direccion:word): Byte; pascal;
begin
  case direccion of
    $9000:bbsnd_getbyte:=ym2203_read_status(0);
    $9001:bbsnd_getbyte:=ym2203_read_reg(0);
    $a000:bbsnd_getbyte:=yM3812_status_port(1);
    $b000:bbsnd_getbyte:=sound_latch;
    else bbsnd_getbyte:=mem_snd[direccion];
  end;
end;

procedure bbsnd_putbyte(direccion:word;valor:byte);pascal;
begin
case direccion of
  0..$7fff:exit;
  $9000:ym2203_control(0,valor);
  $9001:ym2203_write_reg(0,valor);
  $a000:YM3812_control_port(1,valor);
  $a001:YM3812_write_port(1,valor);
  $b000:sound_status:=valor;
  $b001:begin
          sound_nmi:=true;
          if pending_nmi then begin
              pending_nmi:=false;
              snd_z80.pedir_nmi:=true;
          end;
        end;
  $b002:sound_nmi:=false;
end;
mem_snd[direccion]:=valor;
end;

procedure cambiar_color(dir:word);
var
  tmp_color:byte;
  color:tcolor;
begin
  tmp_color:=memoria[dir];
  color.r:=(tmp_color and $f0)+(tmp_color shr 4);
  color.g:=(tmp_color and $f)+((tmp_color and $f ) shl 4);
  tmp_color:=memoria[dir+1];
  color.b:=(tmp_color and $f0)+(tmp_color shr 4);
  poner_color(color,addr(paleta[(dir-$f800) shr 1]));
  fillmemory(@gfx[0].buffer[0],$400,1);
end;

function bublbobl_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $8000..$bfff:bublbobl_getbyte:=memoria_rom[banco_rom,(direccion and $3fff)];
  $fa00:bublbobl_getbyte:=sound_status;
  else bublbobl_getbyte:=memoria[direccion];
end;
end;

procedure bublbobl_putbyte(direccion:word;valor:byte);pascal;
begin
case direccion of
        $0..$bfff:exit;
        $f800..$f9ff:cambiar_color(direccion and $fffe);
        $fa00:begin
                if sound_nmi then snd_z80.pedir_nmi:=true
                  else pending_nmi:=true;
                sound_latch:=valor;
              end;
        $fa03:if valor<>0 then reset_z80(snd_z80);
        $fb40:begin
                banco_rom:=(valor xor 4) and 7;
                mcu_run:=(valor and $20)<>0;
                if (valor and $10)=0 then reset_z80(misc_z80);
              end;
end;
memoria[direccion]:=valor;
end;

function bb_misc_getbyte(direccion:word): Byte; pascal;
begin
  case direccion of
    $e000..$f7ff:bb_misc_getbyte:=memoria[direccion];
    else bb_misc_getbyte:=mem_misc[direccion];
  end;
end;

procedure bb_misc_putbyte(direccion:word;valor:byte);pascal;
begin
case direccion of
  $0..$7fff:exit;
  $e000..$f7ff:memoria[direccion]:=valor;
end;
mem_misc[direccion]:=valor;
end;

procedure bb_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=ym2203UpdateOne(0);
  tsample[1][posicion_sonido]:=YM3812UpdateOne(1);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

procedure snd_irq(numchip:integer;irqstate:integer);pascal;
begin
  snd_z80.pedir_irq:=(irqstate=1);
end;

end.
