unit burgertime;

interface
uses m6502,constantes,sdl,windows,entradas,ay_8910,arcade_const,timers;

procedure Cargar_btime;
procedure principal_btime;pascal;
function getbyte_btime(direccion:word): Byte; pascal;
procedure putbyte_btime(direccion:word;valor:byte);pascal;
function getbyte_snd_btime(direccion:word): Byte; pascal;
procedure putbyte_snd_btime(direccion:word;valor:byte);pascal;
function iniciar_btime:boolean;pascal;
procedure cerrar_btime;pascal;
procedure desencriptar_btime;pascal;
procedure reset_btime;pascal;
procedure btime_despues_instruccion;pascal;

const
        btime_rom:array[0..4] of tipo_roms=(
        (n:'aa04.9b';l:$1000;p:$c000),(n:'aa06.13b';l:$1000;p:$d000),
        (n:'aa05.10b';l:$1000;p:$e000),(n:'aa07.15b';l:$1000;p:$f000),
        (n:'';l:0;p:0));
        btime_char:array[0..6] of tipo_roms=(
        (n:'aa12.7k';l:$1000;p:$0000),(n:'ab13.9k';l:$1000;p:$1000),
        (n:'ab10.10k';l:$1000;p:$2000),(n:'ab11.12k';l:$1000;p:$3000),
        (n:'aa8.13k';l:$1000;p:$4000),(n:'ab9.15k';l:$1000;p:$5000),
        (n:'';l:0;p:0));
        btime_tiles:array[0..3] of tipo_roms=(
        (n:'ab00.1b';l:$800;p:$0000),(n:'ab01.3b';l:$800;p:$800),
        (n:'ab02.4b';l:$800;p:$1000),(n:'';l:0;p:0));
        btime_snd:tipo_roms=(n:'ab14.12h';l:$1000;p:$f000);
        btime_tiles_mem:tipo_roms=(n:'ab03.6b';l:$800;p:$0);

implementation
uses principal;

var
  memoria_dec:array[0..$ffff] of byte;
  put_byte,haz_nmi,bg_cambiado:boolean;
  sound_latch,haz_vb,scroll_bg:byte;
  video_ram,color_ram:array[0..$3ff] of byte;
  mem_tiles:array[0..$7ff] of byte;

procedure Cargar_btime;
begin
form1.burgertime1.Checked:=true;
llamadas_maquina.caption:='Burger Time';
llamadas_maquina.iniciar:=iniciar_btime;
llamadas_maquina.bucle_general:=principal_btime;
llamadas_maquina.cerrar:=cerrar_btime;
llamadas_maquina.reset:=reset_btime;
llamadas_maquina.fps_max:=57;
llamadas_maquina.canales_usados:=2;
end;

function iniciar_btime:boolean;pascal;
const
    pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
    pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
    ps_x:array[0..15] of dword=(16*8+0, 16*8+1, 16*8+2, 16*8+3, 16*8+4, 16*8+5, 16*8+6, 16*8+7,
			0, 1, 2, 3, 4, 5, 6, 7);
    ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
begin
iniciar_btime:=false;
iniciar_audio(1);
p_final[0].x:=240;
p_final[0].y:=240;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[6].x:=256;
p_final[6].y:=256;
p_final[6].trans:=true;
iniciar_video;
//Main CPU
init_cpu(m6502_main,0,1500000/llamadas_maquina.fps_max/16);
main_6502_ll.getbyte:=getbyte_btime;
main_6502_ll.putbyte:=putbyte_btime;
main_6502_ll.despues_instruccion:=desencriptar_btime;
//Sound CPU
init_cpu(m6502_snd,1,500000/llamadas_maquina.fps_max/16);
snd_6502_ll.getbyte:=getbyte_snd_btime;
snd_6502_ll.putbyte:=putbyte_snd_btime;
//Sound Chip
AY8910_init(1500000,0,nil,nil,nil,nil);
AY8910_init(1500000,1,nil,nil,nil,nil);
//Timers
init_timer(0,1,500000/44100,btime_despues_instruccion,true);
//cargar roms
if not(cargar_roms(@memoria[0],@btime_rom[0],'\btime.zip',0)) then exit;
copymemory(@memoria_dec[0],@memoria[0],$10000);
//cargar roms audio
if not(cargar_roms(@mem_snd[0],@btime_snd,'\btime.zip',1)) then exit;
//Cargar chars
if not(cargar_roms(@memoria_temp[0],@btime_char[0],'\btime.zip',0)) then exit;
init_gfx(0,8,8,1024);
gfx[0].trans[0]:=true;
des_sprites.pos_planos[0]:=2*1024*8*8;
des_sprites.pos_planos[1]:=1024*8*8;
des_sprites.pos_planos[2]:=0;
des_sprites.bit_pixel:=3;
des_sprites.banks:=0;
des_sprites.long_sprites:=8*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,true);
//sprites
init_gfx(1,16,16,256);
gfx[1].trans[0]:=true;
des_sprites.pos_planos[0]:=2*256*16*16;
des_sprites.pos_planos[1]:=256*16*16;
des_sprites.pos_planos[2]:=0;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,true);
//Cargar tiles
if not(cargar_roms(@memoria_temp[0],@btime_tiles[0],'\btime.zip',0)) then exit;
init_gfx(2,16,16,64);
des_sprites.pos_planos[0]:=2*64*16*16;
des_sprites.pos_planos[1]:=64*16*16;
des_sprites.pos_planos[2]:=0;
convert_sprites(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,true);
if not(cargar_roms(@mem_tiles[0],@btime_tiles_mem,'\btime.zip',1)) then exit;
//final
reset_btime;
iniciar_btime:=true;
end;

procedure update_video_btime;
const
  pant_pos:array[0..7] of byte=(1,2,3,0,5,6,7,4);
var
  f,nchar:word;
  x,y:word;
begin
if bg_cambiado then begin
 if (scroll_bg and $10)<>0 then begin
  for f:=0 to $ff do begin
    x:=f mod 16;
    y:=f div 16;
    nchar:=mem_tiles[pant_pos[scroll_bg and $7]*$100+f];
    put_gfx(x*16,y*16,nchar,8,2,2);
  end;
 end;
 bg_cambiado:=false;
end;
actualiza_trozo(0,0,256,256,2,0,0,256,256,1);
for f:=0 to $3ff do begin
 if gfx[0].buffer[f] then begin
    x:=f mod 32;
    y:=f div 32;
    nchar:=video_ram[f]+((color_ram[f] and $3) shl 8);
    put_gfx_trans(x*8,y*8,nchar,0,6,0);
    gfx[0].buffer[f]:=false;
 end;
end;
actualiza_trozo(0,0,256,256,6,0,0,256,256,1);
//Sprites
for f:=0 to 7 do begin
  if (video_ram[f*$80] and 1)<>0 then begin
    x:=240-video_ram[$40+(f*$80)];
    y:=video_ram[$60+(f*$80)];
    nchar:=video_ram[$20+(f*$80)];
    put_gfx_sprite(nchar,0,(video_ram[f*$80] and 2)<>0,(video_ram[f*$80] and 4)<>0,1);
    actualiza_gfx_sprite(x,y,1,1);
  end;
end;
actualiza_trozo(8,8,240,240,1,0,0,240,240,0);
end;

procedure eventos_btime;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=in0 and $fe else in0:=in0 or 1;
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=in0 and $fd else in0:=in0 or 2;
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=in0 and $fb else in0:=in0 or 4;
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=in0 and $f7 else in0:=in0 or 8;
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=in0 and $ef else in0:=in0 or $10;
  if teclado[SDLK_5] then begin
      in2:=(in2 or $40);
      main_6502.pedir_nmi:=true;
  end else in2:=(in2 and $bf);
  if teclado[SDLK_1] then in2:=in2 and $fe else in2:=in2 or $1;
end;
end;

procedure principal_btime;pascal;
var
  f:word;
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
//Cada 16avo de frame se produce una NMI para el 6502 de audio
//14 de ellos para el video y los dos ultimos para el VBLANK
while EmuStatus=EsRuning do begin
 for f:=0 to 15 do begin
  frame_m:=frame_m+main_6502.tframes;
  run_6502(main_6502,main_6502_ll,trunc(frame_m));
  frame_m:=frame_m-main_6502.contador;
  main_6502.contador:=0;
  frame_s:=frame_s+snd_6502.tframes;
  run_6502(snd_6502,snd_6502_ll,trunc(frame_s));
  frame_s:=frame_s-snd_6502.contador;
  snd_6502.contador:=0;
  snd_6502.pedir_nmi:=haz_nmi;
  if f=13 then haz_vb:=haz_vb or $80;
  if f=15 then haz_vb:=haz_vb and $7f;
 end;
 update_video_btime;
 actualiza_video;
 eventos_btime;
 sincronizar;
 evaluar_entradas;
end;
end;

function getbyte_btime(direccion:word): Byte; pascal;
begin
case direccion of
  $4000:getbyte_btime:=in0;
  $4001:getbyte_btime:=in1;
  $4002:getbyte_btime:=in2;
  $4003:getbyte_btime:=haz_vb;
  $4004:getbyte_btime:=$1f;
   else getbyte_btime:=memoria_dec[direccion];
end;
put_byte:=false;
end;

procedure cambiar_paleta(ncolor:byte);
var
  color:tcolor;
  valor:byte;
begin
valor:=not(memoria[$0c00+ncolor]);
color.r:= $21*(valor and 1)+$47*((valor shr 1) and 1)+$97*((valor shr 2) and 1);
color.g:= $21*((valor shr 3) and 1)+$47*((valor shr 4) and 1)+$97*((valor shr 5) and 1);
color.b:= 0+$47*((valor shr 6) and 1)+$97*((valor shr 7) and 1);
poner_color(color,addr(paleta[ncolor]));
if ncolor<8 then fillmemory(@gfx[0].buffer[0],$400,1);
end;

procedure putbyte_btime(direccion:word;valor:byte);pascal;
var
  x,y,pos:word;
begin
memoria[direccion]:=valor;
memoria_dec[direccion]:=valor;
case direccion of
  $1000..$13ff:begin
                  video_ram[direccion and $3ff]:=valor;
                  gfx[0].buffer[direccion and $3ff]:=true;
               end;
  $1400..$17ff:begin
                  color_ram[direccion and $3ff]:=valor;
                  gfx[0].buffer[direccion and $3ff]:=true;
               end;
  //Hay un mirror del video y atributos, pero con las coordenadas
  //invertidas  ?????
  $1800..$1bff:begin
                  x:=(direccion and $3ff) div 32;
                  y:=(direccion and $3ff) mod 32;
                  pos:=y*32+x;
                  video_ram[pos]:=valor;
                  gfx[0].buffer[pos]:=true;
               end;
  $1c00..$1fff:begin
                  x:=(direccion and $3ff) div 32;
                  y:=(direccion and $3ff) mod 32;
                  pos:=y*32+x;
                  color_ram[pos]:=valor;
                  gfx[0].buffer[pos]:=true;
               end;
  $0c00..$0c0f:if buffer_paleta[direccion and $f]<>valor then begin
                  cambiar_paleta(direccion and $f);
                  buffer_paleta[direccion and $f]:=valor;
               end;
  $4003:begin
          sound_latch:=valor;
          snd_6502.pedir_irq:=true;
        end;
  $4004:if scroll_bg<>valor then begin
          scroll_bg:=valor;
          //Si el fondo no esta activo, lo pinto de negro
          if (scroll_bg shr 2 and $10)=0 then pintar_pantalla(2,0);
          bg_cambiado:=true;
        end;
end;
put_byte:=true;
end;

procedure cerrar_btime;pascal;
begin
AY8910_close(0);
AY8910_close(1);
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_btime;pascal;
begin
reset_6502(main_6502,main_6502_ll);
reset_6502(snd_6502,snd_6502_ll);
in0:=$ff;
in1:=$ff;
in2:=$3f;
haz_vb:=$3f;
sound_latch:=0;
put_byte:=false;
end;

procedure desencriptar_btime;pascal;
var
  act_pc,old_pc:word;
begin
//Para desencriptar la ROM hay que tener en cuenta dos cosas, la primera
//solo despues de un opcode de escritura y si el opcode esta en la direccion
//cuya mascara es $0104 se debe desencriptar. Hay que tener cuidado con el
//salto a subrutina (opcode $20) que tambien puede ir encriptado.
act_pc:=main_6502.pc.w;
old_pc:=main_6502.old_pc.w;
if memoria_dec[old_pc]=$20 then
  act_pc:=memoria[old_pc+1]+256*memoria[old_pc+2];
if (((act_pc and $0104)=$0104) and put_byte) then
  memoria_dec[act_pc]:=(memoria[act_pc] and $13) or ((memoria[act_pc] and $80) shr 5) or ((memoria[act_pc] and $64) shl 1) or ((memoria[act_pc] and $08) shl 2);
end;

function getbyte_snd_btime(direccion:word): Byte; pascal;
begin
case direccion of
  $a000..$afff:getbyte_snd_btime:=sound_latch;
   else getbyte_snd_btime:=mem_snd[direccion];
end;
end;

procedure putbyte_snd_btime(direccion:word;valor:byte);pascal;
begin
if direccion>$efff then exit;
mem_snd[direccion]:=valor;
case direccion of
    $2000..$2fff:AYWrite(valor,0);
    $4000..$4fff:AYControl(valor,0);
    $6000..$6fff:AYWrite(valor,1);
    $8000..$8fff:AYControl(valor,1);
    $c000..$cfff:haz_nmi:=valor<>0;
end;
end;

procedure btime_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=renderbyte(0)^;
  tsample[1][posicion_sonido]:=renderbyte(1)^;
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
