unit citycon;

interface
uses sdl,m6809,ay_8910,ym_2203,constantes,windows,entradas,arcade_const,timers;

procedure Cargar_citycon;
procedure citycon_principal;pascal;
function citycon_getbyte(direccion:word): Byte; pascal;
procedure citycon_putbyte(direccion:word;valor:byte);pascal;
function scitycon_getbyte(direccion:word): Byte; pascal;
procedure scitycon_putbyte(direccion:word;valor:byte);pascal;
function citycon_porta:byte;pascal;
function citycon_portb:byte;pascal;
procedure sound_instruccion;pascal;
function iniciar_citycon:boolean;pascal;
procedure reset_citycon;pascal;
procedure cerrar_citycon;pascal;

const
        citycon_rom:array[0..2] of tipo_roms=(
        (n:'c10';l:$4000;p:$4000),(n:'c11';l:$8000;p:$8000),(n:'';l:0;p:0));
        citycon_sonido:tipo_roms=(n:'c1';l:$8000;p:$8000);
        citycon_char:tipo_roms=(n:'c4';l:$2000;p:0);
        citycon_sprites:array[0..2] of tipo_roms=(
        (n:'c12';l:$2000;p:0),(n:'c13';l:$2000;p:$2000),(n:'';l:0;p:0));
        citycon_tiles:array[0..4] of tipo_roms=(
        (n:'c9';l:$8000;p:0),(n:'c8';l:$4000;p:$8000),
        (n:'c6';l:$8000;p:$c000),(n:'c7';l:$4000;p:$14000),(n:'';l:0;p:0));
        citycon_fondo:array[0..3] of tipo_roms=(
        (n:'c2';l:$8000;p:0),(n:'c3';l:$4000;p:$8000),
        (n:'c5';l:$2000;p:$c000),(n:'';l:0;p:0));

var
 fondo,soundlatch,soundlatch2:byte;
 scroll:parejas;
 lines_color_look:array[0..$ff] of byte;
 memoria_fondo:array[0..$dfff] of byte;
 cambia_fondo:boolean;

implementation
uses principal;

procedure Cargar_citycon;
begin
form1.citycon1.Checked:=true;
llamadas_maquina.caption:='City Connection';
llamadas_maquina.iniciar:=iniciar_citycon;
llamadas_maquina.bucle_general:=citycon_principal;
llamadas_maquina.cerrar:=cerrar_citycon;
llamadas_maquina.reset:=reset_citycon;
llamadas_maquina.canales_usados:=2;
end;

function iniciar_citycon:boolean;pascal;
var
      f:word;
const
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 256*8*8+0, 256*8*8+1, 256*8*8+2, 256*8*8+3 );
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
  ps_x:array[0..7] of dword=(0, 1, 2, 3, 128*16*8+0, 128*16*8+1, 128*16*8+2, 128*16*8+3);
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
            8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
begin
iniciar_citycon:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=240;
p_final[0].y:=224;
p_final[1].x:=1024;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[2].x:=1024;
p_final[2].y:=256;
p_final[3].x:=256;
p_final[3].y:=256;
//Cambio el tamao estandar de los sprites
iniciar_video;
//Main CPU
init_cpu(m6809_main,0,2048000/llamadas_maquina.fps_max);
main_6809_ll.getbyte:=citycon_getbyte;
main_6809_ll.putbyte:=citycon_putbyte;
//Sound CPU
init_cpu(m6809_snd,1,640000/llamadas_maquina.fps_max);
snd_6809_ll.getbyte:=scitycon_getbyte;
snd_6809_ll.putbyte:=scitycon_putbyte;
//Sound Chip
ym2203_Init(0,1250000,2,citycon_porta,citycon_portb,nil,nil);
AY8910_init(1250000,1,nil,nil,nil,nil);
//Timers
init_timer(0,1,(640000/44100),sound_instruccion,true);
{cargar roms}
if not(cargar_roms(@memoria[0],@citycon_rom[0],'\citycon.zip',0)) then exit;
//Cargar Sound
if not(cargar_roms(@mem_snd[0],@citycon_sonido,'\citycon.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@citycon_char,'\citycon.zip',1)) then exit;
init_gfx(0,8,8,256);
gfx[0].trans[0]:=true;
des_sprites.pos_planos[0]:=4;
des_sprites.pos_planos[1]:=0;
des_sprites.bit_pixel:=2;
des_sprites.banks:=0;
des_sprites.long_sprites:=8*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//tiles
if not(cargar_roms(@memoria_temp[0],@citycon_tiles[0],'\citycon.zip',0)) then exit;
init_gfx(1,8,8,3072);
des_sprites.banks:=12;
des_sprites.bit_pixel:=4;
for f:=0 to $b do begin
  des_sprites.pos_planos[0]:=4+($1000*f*8);
  des_sprites.pos_planos[1]:=0+($1000*f*8);
  des_sprites.pos_planos[2]:=($c000+($1000*f))*8+4;
  des_sprites.pos_planos[3]:=($c000+($1000*f))*8+0;
  convert_sprites(@gfx[1],$100*8*8*f,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
end;
zeromemory(@memoria_fondo[0],$e000);
zeromemory(@lines_color_look[0],$100);
if not(cargar_roms(@memoria_fondo[0],@citycon_fondo[0],'\citycon.zip',0)) then exit;
//sprites
if not(cargar_roms(@memoria_temp[0],@citycon_sprites[0],'\citycon.zip',0)) then exit;
init_gfx(2,8,16,256);
gfx[2].trans[0]:=true;
des_sprites.long_sprites:=16*8;
des_sprites.banks:=2;
for f:=0 to 1 do begin
  des_sprites.pos_planos[0]:=($1000*f*8)+4;
  des_sprites.pos_planos[1]:=($1000*f*8)+0;
  des_sprites.pos_planos[2]:=($2000+$1000*f)*8+4;
  des_sprites.pos_planos[3]:=($2000+$1000*f)*8+0;
  convert_sprites(@gfx[2],$80*16*8*f,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
end;
//final
reset_citycon;
iniciar_citycon:=true;
end;

procedure cerrar_citycon;pascal;
begin
cerrar_cpus;
YM2203_Close(0);
AY8910_Close(1);
cerrar_audio;
cerrar_video;
end;

procedure reset_citycon;pascal;
begin
 reset_6809(main_6809,main_6809_ll);
 reset_6809(snd_6809,snd_6809_ll);
 YM2203_Reset(0);
 AY8910_Reset(1);
 reset_audio;
 zeromemory(@memoria[0],$3FFF);
 in0:=$FF;
 in1:=$80;
 fondo:=0;
 cambia_fondo:=true;
 soundlatch:=0;
 soundlatch2:=0;
end;

procedure update_video_citycon;
var
  f:word;
  x,y,y2,x2:byte;
  color,nchar:word;
  temp:pword;
  pos:pbyte;
  long_x:word;
begin
if scroll.w>768 then long_x:=1024-scroll.w
  else long_x:=256;
if cambia_fondo then begin
  for f:=$fff downto 0 do begin
    y:=f div 32;
    x:=(f mod 32)+(y and $60);
    y:=y and $1f;
    nchar:=memoria_fondo[$1000*fondo+f]+(fondo*$100);
    color:=((memoria_fondo[$c000+nchar]) shl 4)+256;
    put_gfx(x*8,y*8,nchar,color,2,1);
  end;
  cambia_fondo:=false;
end;
actualiza_trozo(scroll.w,0,long_x,256,2,0,0,long_x,256,3);
if long_x<256 then actualiza_trozo(0,0,256-long_x,256,2,long_x,0,256-long_x,256,3);
for f:=$fff downto 0 do begin
 if gfx[0].buffer[f] then begin
    y:=f div 32;
    x:=(f mod 32)+(y and $60);
    y:=y and $1f;
    nchar:=memoria[$1000+f];
    pos:=gfx[0].datos;
    inc(pos,nchar*8*8);
    for y2:=0 to 7 do begin
      temp:=punbuf;
      color:=(lines_color_look[y2+(y*8)] shl 2)+512;
      for x2:=0 to 7 do begin
        if not(gfx[0].trans[pos^]) then temp^:=pos^+color
          else temp^:=$600;
        inc(temp);
        inc(pos);
      end;
      putpixel_trans(x*8,y*8+y2,8,punbuf,1);
    end;
 gfx[0].buffer[f]:=false;
 end;
end;
actualiza_trozo(0,0,256,48,1,0,0,256,48,3);
actualiza_trozo(scroll.w,48,256,208,1,0,48,256,208,3);
if long_x<256 then actualiza_trozo(0,48,256-long_x,208,1,long_x,48,256-long_x,208,3);
for f:=$3f downto 0 do begin
    x:=memoria[$2803+(f*4)];
    y:=239-memoria[$2800+(f*4)];
    nchar:=memoria[$2801+(f*4)];
    color:=(memoria[$2802+(f*4)] and $f) shl 4;
    put_gfx_sprite(nchar,color,(memoria[$2802+(f*4)] and $10)=0,false,2);
    actualiza_gfx_sprite(x,y,3,2);
end;
actualiza_trozo(8,16,240,224,3,0,0,240,224,0);
end;

procedure eventos_citycon;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in0:=(in0 and $df) else in0:=(in0 or $20);
  if teclado[SDLK_5] then in1:=(in1 and $7f) else in1:=(in1 or $80);
  if teclado[SDLK_1] then in0:=(in0 and $bf) else in0:=(in0 or $40);
  if teclado[SDLK_2] then in0:=(in0 and $7f) else in0:=(in0 or $80);
end;
end;

procedure citycon_principal;pascal;
var
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
  frame_m:=frame_m+main_6809.tframes;
  run_6809(main_6809,main_6809_ll,trunc(frame_m));
  frame_s:=frame_s+snd_6809.tframes;
  run_6809(snd_6809,snd_6809_ll,trunc(frame_s));
  frame_m:=frame_m-main_6809.contador;
  frame_s:=frame_s-snd_6809.contador;
  main_6809.pedir_irq:=true;
  main_6809.contador:=0;
  snd_6809.contador:=0;
  update_video_citycon;
  actualiza_video;
  eventos_citycon;
  sincronizar;
  evaluar_entradas;
end;
end;

function citycon_getbyte(direccion:word): Byte; pascal;
begin
  case direccion of
        $3000:citycon_getbyte:=in0;
        $3001:citycon_getbyte:=in1;
        $3002:citycon_getbyte:=$80;
    else citycon_getbyte:=memoria[direccion];
  end;
end;

procedure cambiar_color(dir:word);
var
        tmp_color:byte;
        color:tcolor;
begin
  tmp_color:=memoria[dir];
  color.r:=(tmp_color and $f0)+(tmp_color shr 4);
  color.g:=(tmp_color and $f)+((tmp_color and $f ) shl 4);
  tmp_color:=memoria[dir+1];
  color.b:=(tmp_color and $f0)+(tmp_color shr 4);
  poner_color(color,addr(paleta[(dir-$3800) shr 1]));
  case ((dir-$3800) shr 1) of
    256..511:cambia_fondo:=true;
    512..639:fillmemory(@gfx[0].buffer[0],$fff,1);
  end;
end;


procedure citycon_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion>$3FFF then exit;
memoria[direccion]:=valor;
case direccion of
  $1000..$1fff:gfx[0].buffer[direccion and $fff]:=true;
  $2000..$20ff:lines_color_look[direccion and $ff]:=valor;
  $3000:if fondo<>(valor shr 4) then begin
          fondo:=valor shr 4;
          cambia_fondo:=true;
        end;
  $3001:soundlatch:=valor;
  $3002:soundlatch2:=valor;
  $3004:scroll.h:=valor and $3;
  $3005:scroll.l:=valor;
  $3007:main_6809.pedir_irq:=false;
  $3800..$3cff:if buffer_paleta[direccion-$3800]<>valor then begin
                  cambiar_color(direccion and $fffe);
                  buffer_paleta[direccion-$3800]:=valor;
               end;
end;
end;

function scitycon_getbyte(direccion:word):Byte; pascal;
begin
if direccion=$6001 then scitycon_getbyte:=ym2203_Read_Reg(0)
  else scitycon_getbyte:=mem_snd[direccion];
end;

procedure scitycon_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion>$7FFF then exit;
case direccion of
  $4000:AYControl(valor,1);
  $4001:AYWrite(valor,1);
  $6000:ym2203_Control(0,valor);
  $6001:ym2203_Write_Reg(0,valor);
end;
mem_snd[direccion]:=valor;
end;

function citycon_porta:byte;pascal;
begin
  citycon_porta:=soundlatch;
end;

function citycon_portb:byte;pascal;
begin
  citycon_portb:=soundlatch2;
end;

procedure sound_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=Renderbyte(1)^*2;
  tsample[1][posicion_sonido]:=ym2203UpdateOne(0);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
