unit commando;

interface
uses sysutils,sdl,z80,constantes,windows,entradas,ym_2203,arcade_const,timers;

procedure Cargar_commando;
procedure commando_principal;pascal;
function commando_getbyte(direccion:word): Byte; pascal;
procedure commando_putbyte(direccion:word;valor:byte);pascal;
function commando_snd_getbyte(direccion:word): Byte; pascal;
procedure commando_snd_putbyte(direccion:word;valor:byte);pascal;
function iniciar_commando:boolean;pascal;
procedure reset_commando;pascal;
procedure cerrar_commando;pascal;
procedure commando_despues_instruccion;pascal;

const
        commando_rom:array[0..2] of tipo_roms=(
        (n:'cm04.9m';l:$8000;p:0),(n:'cm03.8m';l:$4000;p:$8000),
        (n:'';l:0;p:0));
        commando_snd_rom:tipo_roms=(n:'cm02.9f';l:$4000;p:0);
        commando_pal:array[0..3] of tipo_roms=(
        (n:'vtb1.1d';l:$100;p:0),(n:'vtb2.2d';l:$100;p:$100),
        (n:'vtb3.3d';l:$100;p:$200),(n:'';l:0;p:0));
        commando_char:tipo_roms=(n:'vt01.5d';l:$4000;p:0);
        commando_sprites:array[0..6] of tipo_roms=(
        (n:'vt05.7e';l:$4000;p:0),(n:'vt06.8e';l:$4000;p:$4000),
        (n:'vt07.9e';l:$4000;p:$8000),(n:'vt08.7h';l:$4000;p:$c000),
        (n:'vt09.8h';l:$4000;p:$10000),(n:'vt10.9h';l:$4000;p:$14000),(n:'';l:0;p:0));
        commando_tiles:array[0..6] of tipo_roms=(
        (n:'vt11.5a';l:$4000;p:0),(n:'vt12.6a';l:$4000;p:$4000),
        (n:'vt13.7a';l:$4000;p:$8000),(n:'vt14.8a';l:$4000;p:$c000),
        (n:'vt15.9a';l:$4000;p:$10000),(n:'vt16.10a';l:$4000;p:$14000),(n:'';l:0;p:0));

var
 memoria_dec:array[0..$ffff] of byte;
 scroll_x,scroll_y:parejas;
 sound_command:byte;

implementation
uses principal;

procedure Cargar_commando;
begin
form1.commando1.Checked:=true;
llamadas_maquina.caption:='Commando';
llamadas_maquina.iniciar:=iniciar_commando;
llamadas_maquina.bucle_general:=commando_principal;
llamadas_maquina.cerrar:=cerrar_commando;
llamadas_maquina.reset:=reset_commando;
llamadas_maquina.canales_usados:=2;
end;

procedure update_video_commando;
var
        f,color,nchar:word;
        x,y:word;
        attr,bank:byte;
begin
for f:=$3ff downto 0 do begin
  //tiles
  if gfx[2].buffer[f] then begin
      x:=f mod 32;
      y:=31-(f div 32);
      nchar:=memoria[$d800+f]+((memoria[$dc00+f] and $c0) shl 2);
      color:=(memoria[$dc00+f] and $f) shl 3;
      put_gfx_flip(x*16,y*16,nchar,color,2,2,(memoria[$dc00+f] and $20)<>0,(memoria[$dc00+f] and $10)<>0);
      gfx[2].buffer[f]:=false;
  end;
  //Chars
  if gfx[0].buffer[f] then begin
    x:=f div 32;
    y:=31-(f mod 32);
    color:=(memoria[f+$d400] and $F) shl 2;
    nchar:=memoria[f+$d000]+((memoria[f+$d400] and $c0) shl 2);
    put_gfx_trans_flip(x*8,y*8,nchar,color,6,0,(memoria[f+$d400] and $10)<>0,(memoria[f+$d400] and $20)<>0);
    gfx[0].buffer[f]:=false;
  end;
end;
scroll_x_y(2,1,scroll_x.w,256-scroll_y.w);
//sprites
for f:=$7f downto 0 do begin
    attr:=buffer_sprites[1+(f*4)];
    bank:=(attr and $c0) shr 6;
    if bank<3 then begin
      nchar:=buffer_sprites[(f*4)]+256*bank;
      color:=attr and $30;
      x:=buffer_sprites[2+(f*4)];
      y:=240-buffer_sprites[3+(f*4)]+((attr and $1) shl 8);
      put_gfx_sprite(nchar,color,(attr and $8)<>0,(attr and $4)<>0,1);
      actualiza_gfx_sprite(x,y,1,1);
    end;
end;
actualiza_trozo(0,0,256,256,6,0,0,256,256,1);
actualiza_trozo(16,0,224,256,1,0,0,224,256,0);
end;

procedure eventos_commando;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_LEFT] or joystick.izq) then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if (teclado[SDLK_RIGHT] or joystick.der) then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if (teclado[SDLK_UP] or joystick.arriba) then in1:=(in1 and $F7) else in1:=(in1 or $8);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 and $df) else in1:=(in1 or $20);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if teclado[SDLK_1] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if teclado[SDLK_5] then in0:=(in0 and $bf) else in0:=(in0 or $40);
end;
end;

procedure cerrar_commando;pascal;
begin
cerrar_cpus;
YM2203_close(0);
YM2203_close(1);
cerrar_audio;
cerrar_video;
end;

procedure reset_commando;pascal;
begin
 reset_z80(main_z80);
 main_z80.im0:=$d7;  //rst 10
 reset_z80(snd_z80);
 YM2203_reset(0);
 YM2203_reset(1);
 reset_audio;
 zeromemory(@memoria[$c000],$4000);
 in0:=$FF;
 in1:=$FF;
 scroll_x.w:=0;
 scroll_y.w:=0;
end;

function iniciar_commando:boolean;pascal;
var
      colores:tpaleta;
      f:word;
      ctemp1,bit0,bit1,bit2,bit3:byte;
const
    pc_x:array[0..7] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3);
    pc_y:array[0..7] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16);
    ps_x:array[0..15] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3,
			32*8+0, 32*8+1, 32*8+2, 32*8+3, 33*8+0, 33*8+1, 33*8+2, 33*8+3);
    ps_y:array[0..15] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16,
			8*16, 9*16, 10*16, 11*16, 12*16, 13*16, 14*16, 15*16);
    pt_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			16*8+0, 16*8+1, 16*8+2, 16*8+3, 16*8+4, 16*8+5, 16*8+6, 16*8+7);
    pt_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
begin
iniciar_commando:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=512;
p_final[1].y:=512;
p_final[2].x:=512;
p_final[2].y:=512;
p_final[6].x:=256;
p_final[6].y:=256;
p_final[6].trans:=true;
iniciar_video;
//datos del scroll
scroll_data.long_x:=512;
scroll_data.long_y:=512;
scroll_data.max_x:=256;
scroll_data.max_y:=256;
scroll_data.max_scr_x:=255;
scroll_data.max_scr_y:=255;
//Main CPU
init_cpu(z80_main,0,4000000/llamadas_maquina.fps_max/4);
main_z80.daisy:=false;
main_z80_ll.getbyte:=commando_getbyte;
main_z80_ll.putbyte:=commando_putbyte;
main_z80_ll.outbyte:=nil;
main_z80_ll.inbyte:=nil;
//Sound CPU
init_cpu(z80_snd,1,3000000/llamadas_maquina.fps_max/4);
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=commando_snd_getbyte;
snd_z80_ll.putbyte:=commando_snd_putbyte;
snd_z80_ll.outbyte:=nil;
snd_z80_ll.inbyte:=nil;
//Sound Chips
YM2203_Init(0,1500000,2,nil,nil,nil,nil);
YM2203_Init(1,1500000,2,nil,nil,nil,nil);
//Timers
init_timer(0,1,3000000/44100,commando_despues_instruccion,true);
//cargar roms}
if not(cargar_roms(@memoria[0],@commando_rom[0],'\commando.zip',0)) then exit;
//Las ROMS estan encriptadas
memoria_dec[0]:=memoria[0];
for f:=1 to $bfff do begin
  ctemp1:=memoria[f];
  memoria_dec[f]:=(ctemp1 and $11) or ((ctemp1 and $e0) shr 4) or ((ctemp1 and $0e) shl 4);
end;
//cargar ROMS sonido
if not(cargar_roms(@mem_snd[0],@commando_snd_rom,'\commando.zip',1)) then exit;
//poner la paleta
if not(cargar_roms(@memoria_temp[0],@commando_pal[0],'\commando.zip',0)) then exit;
for f:=0 to 255 do begin
    bit0:=(memoria_temp[f] shr 0) and $01;
		bit1:=(memoria_temp[f] shr 1) and $01;
		bit2:=(memoria_temp[f] shr 2) and $01;
		bit3:= (memoria_temp[f] shr 3) and $01;
		colores[f].r:=$0e * bit0 + $1f * bit1 + $43 * bit2 + $8f * bit3;
		bit0:= (memoria_temp[f+256] shr 0) and $01;
		bit1:= (memoria_temp[f+256] shr 1) and $01;
		bit2:= (memoria_temp[f+256] shr 2) and $01;
		bit3:= (memoria_temp[f+256] shr 3) and $01;
		colores[f].g:=$0e * bit0 + $1f * bit1 + $43 * bit2 + $8f * bit3;
		bit0:= (memoria_temp[f+512] shr 0) and $01;
		bit1:= (memoria_temp[f+512] shr 1) and $01;
		bit2:= (memoria_temp[f+512] shr 2) and $01;
		bit3:= (memoria_temp[f+512] shr 3) and $01;
		colores[f].b:=$0e * bit0 + $1f * bit1 + $43 * bit2 + $8f * bit3;
end;
poner_paleta(colores,256);
//convertir chars
if not(cargar_roms(@memoria_temp[0],@commando_char,'\commando.zip',1)) then exit;
init_gfx(0,8,8,1024);
gfx[0].trans[3]:=true;
des_sprites.pos_planos[0]:=4;
des_sprites.pos_planos[1]:=0;
des_sprites.bit_pixel:=2;
des_sprites.banks:=0;
des_sprites.long_sprites:=16*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,true);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@commando_sprites[0],'\commando.zip',0)) then exit;
init_gfx(1,16,16,768);
gfx[1].trans[15]:=true;
des_sprites.pos_planos[0]:=$c000*8+4;
des_sprites.pos_planos[1]:=$c000*8+0;
des_sprites.pos_planos[2]:=4;
des_sprites.pos_planos[3]:=0;
des_sprites.bit_pixel:=4;
des_sprites.long_sprites:=64*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,true);
//tiles
if not(cargar_roms(@memoria_temp[0],@commando_tiles[0],'\commando.zip',0)) then exit;
init_gfx(2,16,16,1024);
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=$8000*8;
des_sprites.pos_planos[2]:=$8000*8*2;
des_sprites.bit_pixel:=3;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[2],0,@memoria_temp[0],@pt_x[0],@pt_y[0],false,true);
//crear la tabla de colores
for f:=0 to 63 do begin
  gfx[1].colores[f]:=f+128;
  gfx[0].colores[f]:=f+192;
end;
//final
reset_commando;
iniciar_commando:=true;
end;

procedure commando_principal;pascal;
var
  f:byte;
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
  for f:=0 to 3 do begin
    frame_m:=frame_m+main_z80.tframes;
    run_z80(main_z80,main_z80_ll,trunc(frame_m));
    frame_s:=frame_s+snd_z80.tframes;
    run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
    snd_z80.pedir_irq:=true;
    frame_m:=frame_m-main_z80.contador;
    main_z80.contador:=0;
    frame_s:=frame_s-snd_z80.contador;
    snd_z80.contador:=0;
  end;
  main_z80.pedir_irq:=true;
  update_video_commando;
  actualiza_video;
  eventos_commando;
  sincronizar;
  evaluar_entradas;
  copymemory(@buffer_sprites[0],@memoria[$fe00],$200);
end;
end;

function commando_snd_getbyte(direccion:word): Byte; pascal;
begin
if direccion=$6000 then commando_snd_getbyte:=sound_command
 else commando_snd_getbyte:=mem_snd[direccion];
end;

procedure commando_snd_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$4000 then exit;
mem_snd[direccion]:=valor;
case direccion of
        $8000:ym2203_Control(0,valor);
        $8001:ym2203_Write_Reg(0,valor);
        $8002:ym2203_Control(1,valor);
        $8003:ym2203_Write_Reg(1,valor);
end;
end;

function commando_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $0..$bfff:if main_z80.opcode then commando_getbyte:=memoria_dec[direccion]
                 else commando_getbyte:=memoria[direccion];
  $c000:commando_getbyte:=in0;
  $c001:commando_getbyte:=in1;
  $c002:commando_getbyte:=$ff;
  $c003:commando_getbyte:=$ff;
  $c004:commando_getbyte:=$1f;
  else commando_getbyte:=memoria[direccion];
end;
end;

procedure commando_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$c000 then exit;
memoria[direccion]:=valor;
case direccion of
        $c800:sound_command:=valor;
        $c808:scroll_y.l:=valor;
        $c809:scroll_y.h:=valor;
        $c80a:scroll_x.l:=valor;
        $c80b:scroll_x.h:=valor;
        $d000..$d7ff:gfx[0].buffer[direccion and $3ff]:=true;
        $d800..$dfff:gfx[2].buffer[direccion and $3ff]:=true;
end;
end;

procedure commando_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=ym2203UpdateOne(0);
  tsample[1][posicion_sonido]:=ym2203UpdateOne(1);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
