unit dkong;

interface
uses sdl,z80,constantes,windows,entradas,arcade_const;

procedure Cargar_dkong;
procedure dkong_principal;pascal;
function dkong_getbyte(direccion:word): Byte; pascal;
procedure dkong_putbyte(direccion:word;valor:byte);pascal;
function iniciar_dkong:boolean;pascal;
procedure reset_dkong;pascal;
procedure cerrar_dkong;pascal;

const
        dkong_rom:array[0..4] of tipo_roms=(
        (n:'c_5et_g.bin';l:$1000;p:0),(n:'c_5ct_g.bin';l:$1000;p:$1000),(n:'c_5bt_g.bin';l:$1000;p:$2000),
        (n:'c_5at_g.bin';l:$1000;p:$3000),(n:'';l:0;p:0));
        dkong_pal:array[0..3] of tipo_roms=(
        (n:'c-2k.bpr';l:$100;p:0),(n:'c-2j.bpr';l:$100;p:$100),(n:'v-5e.bpr';l:$100;p:$200),
        (n:'';l:0;p:0));
        dkong_char:array[0..2] of tipo_roms=(
        (n:'v_5h_b.bin';l:$800;p:0),(n:'v_3pt.bin';l:$800;p:$800),(n:'';l:0;p:0));
        dkong_sprites:array[0..4] of tipo_roms=(
        (n:'l_4m_b.bin';l:$800;p:0),(n:'l_4n_b.bin';l:$800;p:$800),(n:'l_4r_b.bin';l:$800;p:$1000),
        (n:'l_4s_b.bin';l:$800;p:$1800),(n:'';l:0;p:0));
var
 colores_char:array[0..255] of byte;
 haz_nmi:boolean;
 npaleta:array[0..1] of byte;

implementation
uses principal;

procedure Cargar_dkong;
begin
form1.dkong1.Checked:=true;
llamadas_maquina.caption:='Donkey Kong';
llamadas_maquina.iniciar:=iniciar_dkong;
llamadas_maquina.bucle_general:=dkong_principal;
llamadas_maquina.cerrar:=cerrar_dkong;
llamadas_maquina.reset:=reset_dkong;
llamadas_maquina.canales_usados:=0;
end;

procedure update_video_dkong;
var
        f:word;
        x,y:byte;
        color:word;
begin
//Poner chars
for f:=$3ff downto 0 do
 if gfx[0].buffer[f] then begin
  gfx[0].buffer[f]:=false;
  y:=f mod 32;  //tengo que invertir la x y la y
  x:=f div 32;
  color:=((colores_char[y+32*(x div 4)] and $f) shl 2)+((npaleta[0]+(npaleta[1] shl 1)) shl 6);
  put_gfx(248-(x*8),y*8,memoria[$7400+f],color,1,0);
end;;
actualiza_trozo(0,0,256,256,1,0,0,256,256,2);
{Dkonkey Kong Sprites
direccion $6900 a la $6a7f (total 96 sprites)
byte 0 -> pos x
byte 1 -> bit 7:invertir y + bits 6-0 n sprite
byte 2 -> bit 7:invertir x + bits 3-0 n color
byte 3 -> pos y }
for f:=0 to 95 do begin
  put_gfx_sprite(memoria[$6901+(f*4)] and $7f,((memoria[$6902+(f*4)] and $f) shl 2)+(npaleta[0]+(npaleta[1] shl 1)) shl 6,memoria[$6901+(f*4)] and $80<>0,memoria[$6902+(f*4)] and $80<>0,1);
  x:=memoria[$6900+(f*4)]-8;
  y:=memoria[$6903+(f*4)]-8;
  actualiza_gfx_sprite(x,y,2,1);
end;
actualiza_trozo(16,0,224,256,2,0,0,224,256,0);
end;

procedure eventos_dkong;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=(in0 or $4) else in0:=(in0 and $fb);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=(in0 or $8) else in0:=(in0 and $F7);
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=(in0 or $2) else in0:=(in0 and $fd);
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=(in0 or $1) else in0:=(in0 and $Fe);
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=in0 or $10 else in0:=(in0 and $ef);
  if teclado[SDLK_5] then in2:=(in2 or $80) else in2:=(in2 and $7f);
  if teclado[SDLK_1] then in2:=(in2 or $4) else in2:=(in2 and $fb);
  if teclado[SDLK_F12] then pasar_pantalla_completa;
end;
end;

procedure cerrar_dkong;pascal;
begin
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_dkong;pascal;
begin
 reset_z80(main_z80);
 reset_audio;
 in0:=0;
 in1:=0;
 in2:=0;
 haz_nmi:=false
end;

function iniciar_dkong:boolean;pascal;
var
      colores:tpaleta;
      f:word;
      ctemp1,ctemp2:byte;
const
      pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
      pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
      ps_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			64*16*16+0, 64*16*16+1, 64*16*16+2, 64*16*16+3, 64*16*16+4, 64*16*16+5, 64*16*16+6, 64*16*16+7);
      ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
begin
iniciar_dkong:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[2].x:=256;
p_final[2].y:=256;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,3072022.2/llamadas_maquina.fps_max);
main_z80.daisy:=false;
main_z80_ll.getbyte:=dkong_getbyte;
main_z80_ll.putbyte:=dkong_putbyte;
main_z80_ll.outbyte:=nil;
main_z80_ll.inbyte:=nil;
{cargar roms}
if not(cargar_roms(@memoria[0],@dkong_rom[0],'\dkong.zip',0)) then exit;
//poner la paleta
if not(cargar_roms(@memoria_temp[0],@dkong_pal[0],'\dkong.zip',0)) then exit;
for f:=0 to 255 do begin
    ctemp1:=memoria_temp[f+256];
    ctemp2:=memoria_temp[f];
    colores[f].r:=255-(($21*((ctemp1 shr 1) and 1))+($47*((ctemp1 shr 2) and 1))+($97*((ctemp1 shr 3) and 1)));
    colores[f].g:=255-(($21*((ctemp2 shr 2) and 1))+($47*((ctemp2 shr 3) and 1))+($97*(ctemp1 and 1)));
    colores[f].b:=255-(($55*(ctemp2 and 1))+($aa*((ctemp2 shr 1) and 1)));
end;
poner_paleta(colores,256);
copymemory(@colores_char[0],@memoria_temp[$200],$100);
//cargar sonido
{if probar_zip then rom_cargada:=carga_rom_zip(directorio_roms+'\pacman.zip',dkong_sound.n,@onda_namco[dkong_sound.p],dkong_sound.l)
  else rom_cargada:=cargar_rom(directorio_roms+'\'+dkong_sound.n,@onda_namco[dkong_sound.p],dkong_sound.l);
if not(rom_cargada) then begin
        MessageDlg(leng[idioma].errores[0]+' "'+dkong_sound.n+'" '+leng[idioma].errores[1]+' "PACMAN.ZIP"', mtError,[mbOk], 0);
        exit;
end;}
//convertir chars
if not(cargar_roms(@memoria_temp[0],@dkong_char[0],'\dkong.zip',0)) then exit;
init_gfx(0,8,8,256);
des_sprites.pos_planos[0]:=256*8*8;
des_sprites.pos_planos[1]:=0;
des_sprites.bit_pixel:=2;
des_sprites.banks:=0;
des_sprites.long_sprites:=8*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@dkong_sprites[0],'\dkong.zip',0)) then exit;
init_gfx(1,16,16,128);
gfx[1].trans[0]:=true;
des_sprites.pos_planos[0]:=128*16*16;
des_sprites.long_sprites:=16*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
//final
reset_dkong;
iniciar_dkong:=true;
end;

procedure dkong_principal;pascal;
var
  frame:single;
begin
iniciar_entradas;
frame:=0;
while EmuStatus=EsRuning do begin
  frame:=frame+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame));
  main_z80.pedir_nmi:=haz_nmi;
  frame:=frame-main_z80.contador;
  main_z80.contador:=0;
  update_video_dkong;
  actualiza_video;
  eventos_dkong;
  sincronizar;
  evaluar_entradas;
end;
end;

function dkong_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
     $7c00:dkong_getbyte:=in0;
     $7c80:dkong_getbyte:=in1;
     $7d00:dkong_getbyte:=in2;
     $7d80:dkong_getbyte:=$80;
else dkong_getbyte:=memoria[direccion];
end;
end;

procedure dkong_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$6000 then exit;
case direccion of
        $7400..$77ff:gfx[0].buffer[direccion and $3ff]:=true;
        $7d84:haz_nmi:=(valor=1);
        $7d86:npaleta[0]:=valor and 1;
        $7d87:npaleta[1]:=valor and 1;
end;
memoria[direccion]:=valor;
end;

end.
