unit expraid;

interface
uses m6502,m6809,constantes,sdl,windows,entradas,ym_2203,ym_3812,arcade_const,timers;

procedure Cargar_expraid;
procedure principal_expraid;pascal;
function getbyte_expraid(direccion:word): Byte; pascal;
procedure putbyte_expraid(direccion:word;valor:byte);pascal;
function getbyte_snd_expraid(direccion:word): Byte; pascal;
procedure putbyte_snd_expraid(direccion:word;valor:byte);pascal;
function iniciar_expraid:boolean;pascal;
procedure cerrar_expraid;pascal;
procedure desencriptar_expraid;pascal;
procedure reset_expraid;pascal;
procedure expraid_despues_instruccion;pascal;
procedure snd_irq(numchip:integer;irqstate:integer);pascal;

const
        expraid_rom:array[0..2] of tipo_roms=(
        (n:'cz01';l:$4000;p:$4000),(n:'cz00';l:$8000;p:$8000),
        (n:'';l:0;p:0));
        expraid_char:tipo_roms=(n:'cz07';l:$4000;p:$0000);
        expraid_tiles:array[0..3] of tipo_roms=(
        (n:'cz04';l:$8000;p:$0000),(n:'cz05';l:$8000;p:$10000),
        (n:'cz06';l:$8000;p:$18000),(n:'';l:0;p:0));
        expraid_snd:tipo_roms=(n:'cz02';l:$8000;p:$8000);
        expraid_tiles_mem:tipo_roms=(n:'cz03';l:$8000;p:$0000);
        expraid_sprites:array[0..6] of tipo_roms=(
        (n:'cz09';l:$8000;p:$0000),(n:'cz08';l:$8000;p:$8000),
        (n:'cz13';l:$8000;p:$10000),(n:'cz12';l:$8000;p:$18000),
        (n:'cz11';l:$8000;p:$20000),(n:'cz10';l:$8000;p:$28000),
        (n:'';l:0;p:0));
        expraid_proms:array[0..4] of tipo_roms=(
        (n:'cz17.prm';l:$100;p:$000),(n:'cz16.prm';l:$100;p:$100),
        (n:'cz15.prm';l:$100;p:$200),(n:'cz14.prm';l:$100;p:$300),
        (n:'';l:0;p:0));

implementation
uses principal;
var
  vb:byte;
  mem_tiles:array[0..$7fff] of byte;
  scroll_x,scroll_y,scroll_x2:byte;
  bg_tiles:array[0..3] of byte;
  bg_tiles_cam:array[0..3] of boolean;
  sound_latch:byte;

procedure Cargar_expraid;
begin
form1.expressraider1.Checked:=true;
llamadas_maquina.caption:='Express Raider';
llamadas_maquina.iniciar:=iniciar_expraid;
llamadas_maquina.bucle_general:=principal_expraid;
llamadas_maquina.cerrar:=cerrar_expraid;
llamadas_maquina.reset:=reset_expraid;
llamadas_maquina.fps_max:=60;
llamadas_maquina.canales_usados:=2;
end;

function iniciar_expraid:boolean;pascal;
const
    pc_x:array[0..7] of dword=(0+($2000*8),1+($2000*8), 2+($2000*8), 3+($2000*8), 0, 1, 2, 3);
    pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
    ps_x:array[0..15] of dword=(128+0, 128+1, 128+2, 128+3, 128+4, 128+5, 128+6, 128+7,
			0, 1, 2, 3, 4, 5, 6, 7);
    ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
    pt_x:array[0..15] of dword=(0, 1, 2, 3, 1024*32*2,1024*32*2+1,1024*32*2+2,1024*32*2+3,
		128+0,128+1,128+2,128+3,128+1024*32*2,128+1024*32*2+1,128+1024*32*2+2,128+1024*32*2+3);
    pt_y:array[0..15] of dword=(0*8,1*8,2*8,3*8,4*8,5*8,6*8,7*8,
		64+0*8,64+1*8,64+2*8,64+3*8,64+4*8,64+5*8,64+6*8,64+7*8);
var
  colores:tpaleta;
  f:word;
  i,offs:integer;
begin
iniciar_expraid:=false;
iniciar_audio(1);
p_final[0].x:=240;
p_final[0].y:=240;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[2].x:=512;
p_final[2].y:=512;
p_final[3].x:=512;
p_final[3].y:=512;
p_final[3].trans:=true;
p_final[4].x:=512;
p_final[4].y:=512;
p_final[4].trans:=true;
p_final[6].x:=256;
p_final[6].y:=256;
p_final[6].trans:=true;
iniciar_video;
//Main CPU
init_cpu(m6502_main,0,2000000/llamadas_maquina.fps_max);
main_6502_ll.getbyte:=getbyte_expraid;
main_6502_ll.putbyte:=putbyte_expraid;
main_6502_ll.despues_instruccion:=desencriptar_expraid;
//Sound CPU
init_cpu(m6809_snd,1,1500000/llamadas_maquina.fps_max);
snd_6809_ll.getbyte:=getbyte_snd_expraid;
snd_6809_ll.putbyte:=putbyte_snd_expraid;
//Sound Chip
ym2203_Init(0,1500000,2,nil,nil,nil,nil);
ym3812_init(0,1500000);
ym3812_init_timers(1500000,1,0,snd_irq);
//Timers
init_timer(0,1,1500000/44100,expraid_despues_instruccion,true);
//cargar roms
if not(cargar_roms(@memoria[0],@expraid_rom[0],'\exprraid.zip',0)) then exit;
//Los vectores reset,irq y nmi estan movidos
memoria[$fffa]:=memoria[$fff7];
memoria[$fffb]:=memoria[$fff6];
memoria[$fffc]:=memoria[$fff1];
memoria[$fffd]:=memoria[$fff0];
memoria[$fffe]:=memoria[$fff3];
memoria[$ffff]:=memoria[$fff2];
//cargar roms audio
if not(cargar_roms(@mem_snd[0],@expraid_snd,'\exprraid.zip',1)) then exit;
//Cargar chars
if not(cargar_roms(@memoria_temp[0],@expraid_char,'\exprraid.zip',1)) then exit;
init_gfx(0,8,8,1024);
gfx[0].trans[0]:=true;
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=4;
des_sprites.bit_pixel:=2;
des_sprites.banks:=0;
des_sprites.long_sprites:=8*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@expraid_sprites[0],'\exprraid.zip',0)) then exit;
init_gfx(1,16,16,2048);
gfx[1].trans[0]:=true;
des_sprites.pos_planos[0]:=2*2048*32*8;
des_sprites.pos_planos[1]:=2048*32*8;
des_sprites.pos_planos[2]:=0;
des_sprites.bit_pixel:=3;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//Cargar tiles
if not(cargar_roms(@memoria_temp[0],@expraid_tiles[0],'\exprraid.zip',0)) then exit;
//Mover los datos de los tiles para poder usar las rutinas de siempre...
i:=$8000-$1000;
offs:=$10000-$1000;
repeat
	copymemory(@memoria_temp[offs],@memoria_temp[i],$1000 );
	offs:=offs-$1000;
	copymemory(@memoria_temp[offs],@memoria_temp[i],$1000);
  offs:=offs-$1000;
	i:=i-$1000;
until (i<0);
init_gfx(2,16,16,1024);
gfx[2].trans[0]:=true;
des_sprites.bit_pixel:=3;
des_sprites.long_sprites:=32*8;
des_sprites.banks:=8;
for f:=0 to 3 do begin
  des_sprites.pos_planos[0]:=4+(f*$4000)*8;
  des_sprites.pos_planos[1]:=($10000+f*$4000)*8+0;
  des_sprites.pos_planos[2]:=($10000+f*$4000)*8+4;
  convert_sprites(@gfx[2],f*$100*16*16,@memoria_temp[0],@pt_x[0],@pt_y[0],false,false);
  des_sprites.pos_planos[0]:=0+(f*$4000)*8;
  des_sprites.pos_planos[1]:=($11000+f*$4000)*8+0;
  des_sprites.pos_planos[2]:=($11000+f*$4000)*8+4;
  convert_sprites(@gfx[2],(f*$100*16*16)+($80*16*16),@memoria_temp[0],@pt_x[0],@pt_y[0],false,false);
end;
if not(cargar_roms(@mem_tiles[0],@expraid_tiles_mem,'\exprraid.zip',1)) then exit;
//Paleta
if not(cargar_roms(@memoria_temp[0],@expraid_proms[0],'\exprraid.zip',0)) then exit;
for f:=0 to 255 do begin
  colores[f].r:=(memoria_temp[$0+f] and 1)*$e+((memoria_temp[$0+f] shr 1) and 1)*$1f+((memoria_temp[$0+f] shr 2) and 1)*$43+((memoria_temp[$0+f] shr 3) and 1)*$8f;
  colores[f].g:=(memoria_temp[$100+f] and 1)*$e+((memoria_temp[$100+f] shr 1) and 1)*$1f+((memoria_temp[$100+f] shr 2) and 1)*$43+((memoria_temp[$100+f] shr 3) and 1)*$8f;
  colores[f].b:=(memoria_temp[$200+f] and 1)*$e+((memoria_temp[$200+f] shr 1) and 1)*$1f+((memoria_temp[$200+f] shr 2) and 1)*$43+((memoria_temp[$200+f] shr 3) and 1)*$8f;
end;
poner_paleta(colores,256);
//final
reset_expraid;
iniciar_expraid:=true;
end;

procedure update_video_expraid;
var
  f,i,nchar,color,atrib:word;
  x,y,pos_ini:word;
  rest_scroll:word;
begin
//Background
for i:=0 to 3 do begin
 if bg_tiles_cam[i] then begin
  pos_ini:=bg_tiles[i]*$100;
  for f:=0 to $ff do begin
    x:=(f mod 16)*16;
    y:=(f div 16)*16;
    if i>1 then y:=y+256;
    if (i and 1)<>0 then x:=x+256;
    atrib:=mem_tiles[$4000+pos_ini+f];
    nchar:=mem_tiles[pos_ini+f]+((atrib and $03) shl 8);
    color:=atrib and $18;
    if (atrib and $80)<>0 then begin
      put_gfx_trans_flip(x,y,nchar,color,4,2,(atrib and 4)<>0,false)
    end else begin
      put_gfx_flip(x,y,nchar,color,2,2,(atrib and 4)<>0,false);
      put_gfx_trans(x,y,0,0,4,2);
    end;
  end;
  bg_tiles_cam[i]:=false;
 end;
end;
//Para acelerar las cosas (creo)
rest_scroll:=256-scroll_y;
//Express Rider divide en dos la pantalla vertical, con dos scrolls
//diferentes, en total 512x256 y otra de 512x256
actualiza_trozo(scroll_x,scroll_y,256,rest_scroll,2,0,0,256,rest_scroll,1);
actualiza_trozo(scroll_x2,256,256,scroll_y,2,0,rest_scroll,256,scroll_y,1);
//Sprites
for f:=0 to $7f do begin
    x:=((248-memoria[$602+(f*4)]) and $ff)-8;
    y:=memoria[$600+(f*4)];
    nchar:=memoria[$603+(f*4)]+((memoria[$601+(f*4)] and $e0) shl 3);
    color:=((memoria[$601+(f*4)] and $03) + ((memoria[$601+(f*4)] and $08) shr 1)) shl 3;
    put_gfx_sprite(nchar,64+color,(memoria[$601+(f*4)] and 4)<>0,false,1);
    actualiza_gfx_sprite(x,y,1,1);
    if (memoria[$601+(f*4)] and $10)<>0 then begin
        put_gfx_sprite(nchar+1,64+color,(memoria[$601+(f*4)] and 4)<>0,false,1);
        actualiza_gfx_sprite(x,y+16,1,1);
    end;
end;
//Prioridad del fondo
actualiza_trozo(scroll_x,scroll_y,256,rest_scroll,4,0,0,256,rest_scroll,1);
actualiza_trozo(scroll_x2,256,256,scroll_y,4,0,rest_scroll,256,scroll_y,1);
//Foreground
for f:=0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    x:=f mod 32;
    y:=f div 32;
    nchar:=memoria[$800+f]+((memoria[$c00+f] and $07) shl 8);
    color:=(memoria[$c00+f] and $10) shr 2;
    put_gfx_trans(x*8,y*8,nchar,128+color,6,0);
    gfx[0].buffer[f]:=false;
 end;
end;
actualiza_trozo(0,0,256,256,6,0,0,256,256,1);
actualiza_trozo(8,8,240,240,1,0,0,240,240,0);
end;

procedure eventos_expraid;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=in0 and $fe else in0:=in0 or 1;
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=in0 and $fd else in0:=in0 or 2;
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=in0 and $fb else in0:=in0 or 4;
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=in0 and $f7 else in0:=in0 or 8;
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=in0 and $ef else in0:=in0 or $10;
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in0:=in0 and $df else in0:=in0 or $20;
  if teclado[SDLK_5] then begin
      in2:=(in2 and $bf);
      main_6502.pedir_nmi:=true;
  end else in2:=(in2 or $40);
  if teclado[SDLK_1] then in0:=in0 and $bf else in0:=in0 or $40;
end;
end;

procedure principal_expraid;pascal;
var
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
 vb:=0;
 frame_m:=frame_m+main_6502.tframes-2500;
 run_6502(main_6502,main_6502_ll,trunc(frame_m));
 frame_m:=frame_m-main_6502.contador+2500;
 frame_s:=frame_s+snd_6809.tframes-2500;
 run_6809(snd_6809,snd_6809_ll,trunc(frame_s));
 frame_s:=frame_s-snd_6809.contador+2500;
 //Vblank
 vb:=$2;
 run_6502(main_6502,main_6502_ll,trunc(frame_m));
 frame_m:=frame_m-2500;
 main_6502.contador:=0;
 run_6809(snd_6809,snd_6809_ll,trunc(frame_s));
 frame_s:=frame_s-2500;
 snd_6809.contador:=0;
 update_video_expraid;
 actualiza_video;
 eventos_expraid;
 sincronizar;
 evaluar_entradas;
end;
end;

function getbyte_expraid(direccion:word): Byte; pascal;
begin
case direccion of
   $1800:getbyte_expraid:=$bf;
   $1801:getbyte_expraid:=in0;
   $1802:getbyte_expraid:=in2;
   $1803:getbyte_expraid:=$ff;
   $2800:getbyte_expraid:=memoria[$02a9]; //Proteccion (parte 1)
   $2801:getbyte_expraid:=$2; //Proteccion (parte 2)
   else getbyte_expraid:=memoria[direccion];
end;
end;

procedure putbyte_expraid(direccion:word;valor:byte);pascal;
begin
if direccion>$3fff then exit;
memoria[direccion]:=valor;
case direccion of
  $0800..$0fff:gfx[0].buffer[direccion and $3ff]:=true;
  $2001:begin
           sound_latch:=valor;
           snd_6809.pedir_nmi:=true;
        end;
  $2800..$2803:if bg_tiles[direccion and $3]<>(valor and $3f) then begin
                bg_tiles[direccion and $3]:=valor and $3f;
                bg_tiles_cam[direccion and $3]:=true;
               end;
  $2804:scroll_y:=valor;
  $2805:scroll_x:=valor;
  $2806:scroll_x2:=valor;
end;
end;

procedure cerrar_expraid;pascal;
begin
YM2203_Close(0);
YM3812_close(0);
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_expraid;pascal;
begin
reset_6502(main_6502,main_6502_ll);
reset_6809(snd_6809,snd_6809_ll);
YM2203_Reset(0);
in0:=$ff;
in1:=$ff;
in2:=$ff;
vb:=0;
sound_latch:=0;
end;

procedure desencriptar_expraid;pascal;
begin
//En el Express Raider la CPU es una 6502 modificada, tiene alterados
//los vectores de reset,irq y nmi. Ademas tiene un opcode aadido
//el $4b de dos bytes de longitud que utiliza para leer el vblank
if memoria[main_6502.pc.w]=$4b then begin
  inc(main_6502.pc.w,2);
  main_6502.a:=vb;
end;
end;

function getbyte_snd_expraid(direccion:word): Byte; pascal;
begin
  case direccion of
    $2000:getbyte_snd_expraid:=ym2203_read_status(0);
    $2001:getbyte_snd_expraid:=ym2203_Read_Reg(0);
    $4000:getbyte_snd_expraid:=ym3812_status_port(0);
    $6000:getbyte_snd_expraid:=sound_latch;
    else getbyte_snd_expraid:=mem_snd[direccion];
  end;
end;

procedure putbyte_snd_expraid(direccion:word;valor:byte);pascal;
begin
if direccion>$7fff then exit;
mem_snd[direccion]:=valor;
case direccion of
  $2000:ym2203_control(0,valor);
  $2001:ym2203_write_reg(0,valor);
  $4000:ym3812_control_port(0,valor);
  $4001:ym3812_write_port(0,valor);
end;
end;

procedure expraid_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=ym2203UpdateOne(0);
  tsample[1][posicion_sonido]:=ym3812Updateone(0);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

procedure snd_irq(numchip:integer;irqstate:integer);pascal;
begin
  snd_6809.pedir_irq:=(irqstate=1);
end;

end.
