unit frogger;

interface
uses sdl,z80,constantes,windows,entradas,ay_8910,arcade_const,timers;

procedure Cargar_Frogger;
procedure frogger_principal;pascal;
function frogger_getbyte(direccion:word): Byte; pascal;
procedure frogger_putbyte(direccion:word;valor:byte);pascal;
function fsound_getbyte(direccion:word): Byte; pascal;
procedure fsound_putbyte(direccion:word;valor:byte);pascal;
function fsound_inbyte(puerto:word):byte;pascal;
procedure fsound_outbyte(valor:byte;puerto:word);pascal;
procedure frogger_despues_instruccion;pascal;
function frogger_iniciar:boolean;pascal;
procedure frogger_reset;pascal;
procedure frogger_cerrar;pascal;

const
    frogger_rom:array[0..3] of tipo_roms=(
    (n:'frogger.26';l:$1000;p:0),(n:'frogger.27';l:$1000;p:$1000),
    (n:'frsm3.7';l:$1000;p:$2000),(n:'';l:0;p:0));
    frogger_char:array[0..2] of tipo_roms=(
    (n:'frogger.607';l:$800;p:0),(n:'frogger.606';l:$800;p:$800),(n:'';l:0;p:0));
    frogger_pal:tipo_roms=(n:'pr-91.6l';l:32;p:0);
    frogger_sound:array[0..3] of tipo_roms=(
    (n:'frogger.608';l:$800;p:0),(n:'frogger.609';l:$800;p:$800),
    (n:'frogger.610';l:$800;p:$1000),(n:'';l:0;p:0));

var
  lastirq,lastnmi:byte;
  nmi_vblank:boolean;

implementation
uses principal,konami_snd;

procedure Cargar_Frogger;
begin
form1.frogger1.Checked:=true;
llamadas_maquina.caption:='Frogger';
llamadas_maquina.iniciar:=frogger_iniciar;
llamadas_maquina.bucle_general:=frogger_principal;
llamadas_maquina.cerrar:=frogger_cerrar;
llamadas_maquina.reset:=frogger_reset;
llamadas_maquina.canales_usados:=1;
llamadas_maquina.fps_max:=60.60606060;
end;

function frogger_iniciar:boolean;pascal;
const
  pos_pal:array[0..31] of byte=(0,2,1,3,8,10,9,11,16,18,17,19,24,26,25,27,
   4,6,5,7,12,14,13,15,20,22,21,23,28,30,29,31);
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
  ps_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			8*8+0, 8*8+1, 8*8+2, 8*8+3, 8*8+4, 8*8+5, 8*8+6, 8*8+7);
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			16*8, 17*8, 18*8, 19*8, 20*8, 21*8, 22*8, 23*8);
var
        colores:tpaleta;
        f:word;
        ctemp1:byte;
begin
frogger_iniciar:=false;
iniciar_audio(1);
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=256;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,(3072000/llamadas_maquina.fps_max)-2500);
main_z80.daisy:=false;
main_z80_ll.getbyte:=frogger_getbyte;
main_z80_ll.putbyte:=frogger_putbyte;
main_z80_ll.outbyte:=nil;
main_z80_ll.inbyte:=nil;
//Sound CPU
init_cpu(z80_snd,1,(2000000/llamadas_maquina.fps_max)-2500);
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=fsound_getbyte;
snd_z80_ll.putbyte:=fsound_putbyte;
snd_z80_ll.outbyte:=fsound_outbyte;
snd_z80_ll.inbyte:=fsound_inbyte;
//Timer
init_timer(0,1,2000000/44100,frogger_despues_instruccion,true);
//Sound Chip
AY8910_init(1789750,0,konamisnd_porta,konamisnd_portb,nil,nil);
frogger_reset;
//Cargar las roms...
if not(cargar_roms(@memoria[0],@frogger_rom[0],'\frogger.zip',0)) then exit;
//roms de sonido
if not(cargar_roms(@mem_snd[0],@frogger_sound[0],'\frogger.zip',0)) then exit;
//Las ROMS tienen lineas movidas...
for f:=0 to $7FF do begin
  ctemp1:=mem_snd[f];
  ctemp1:=(ctemp1 and $FC) or ((ctemp1 and 2) shr 1) or ((ctemp1 and 1) shl 1);
  mem_snd[f]:=ctemp1;
end;
//cargar chars
if not(cargar_roms(@memoria_temp[0],@frogger_char[0],'\frogger.zip',0)) then exit;
//la rom tiene cambiadas D1 y D0
for f:=$800 to $FFF do begin
  ctemp1:=memoria_temp[f];
  ctemp1:=(ctemp1 and $FC) or ((ctemp1 and 2) shr 1) or ((ctemp1 and 1) shl 1);
  memoria_temp[f]:=ctemp1;
end;
init_gfx(0,8,8,256);
des_sprites.pos_planos[1]:=0;
des_sprites.pos_planos[0]:=$800*8;
des_sprites.bit_pixel:=2;
des_sprites.long_sprites:=8*8;
des_sprites.banks:=0;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//Sprites
init_gfx(1,16,16,64);
gfx[1].trans[0]:=true;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
//paleta de colores... en la posicion segun pos_pal
if not(cargar_roms(@memoria_temp[0],@frogger_pal,'\frogger.zip',1)) then exit;
for f:=0 to 31 do begin
    ctemp1:=memoria_temp[f];
    colores[pos_pal[f]].r:= $21*((ctemp1 shr 0) and 1)+$47*((ctemp1 shr 1) and 1)+$97*((ctemp1 shr 2) and 1);
    colores[pos_pal[f]].g:= $21*((ctemp1 shr 3) and 1)+$47*((ctemp1 shr 4) and 1)+$97*((ctemp1 shr 5) and 1);
    colores[pos_pal[f]].b:= 0+$47*((ctemp1 shr 6) and 1)+$97*((ctemp1 shr 7) and 1);
    colores[pos_pal[f]+32].r:=colores[pos_pal[f]].r;
    colores[pos_pal[f]+32].g:=colores[pos_pal[f]].g;
    colores[pos_pal[f]+32].b:=colores[pos_pal[f]].b;
    if ((colores[pos_pal[f]].r=0) and (colores[pos_pal[f]].g=0) and (colores[pos_pal[f]].b=0)) then inc(colores[pos_pal[f]+32].b,$39);
end;
poner_paleta(colores,64);
//Final
frogger_reset;
frogger_iniciar:=true;
end;

procedure update_video_frogger;
var
        x,y:byte;
        offs:word;
        scroll:byte;
        nchar,color:word;
begin
for offs:=0 to $3ff do begin
 if gfx[0].buffer[offs] then begin
    x:=31-(offs div 32);
    y:=offs mod 32;
    color:=memoria[$b001+(y shl 1)] shl 2;
    if y<16 then inc(color,32); //hacer la zona de arriba azul
    scroll:=(x*8)+((memoria[$b000+(y shl 1)] and $F) shl 4)+(memoria[$b000+(y shl 1)] shr 4);
    put_gfx(scroll,y*8,memoria[$a800+offs],color,1,0);
    gfx[0].buffer[offs]:=false;
  end;
end;
actualiza_trozo(16,0,224,256,1,0,0,224,256,0);
for offs:=0 to 7 do begin
  nchar:=(memoria[$b041+(offs*4)] and $3F);
  x:=((memoria[$b040+(offs*4)] and $F)*16)+(memoria[$b040+(offs*4)] shr 4)-16;
  y:=memoria[$b043+(offs*4)];
  put_gfx_sprite(nchar,memoria[$b042+(offs*4)] shl 2,(memoria[$b041+(offs*4)] and $80)<>0,(memoria[$b041+(offs*4)] and $40)<>0,1);
  actualiza_gfx_sprite(x,y,0,1);
end;
end;

procedure eventos_frogger;
begin
if evento.teclado then begin
  if teclado[SDLK_5] then in0:=(in0 and $7F) else in0:=(in0 or $80);
  if teclado[SDLK_1] then in1:=in1 and $7F else in1:=in1 or $80;
  if (teclado[SDLK_UP] or joystick.arriba) then in2:=in2 and $EF else in2:=in2 or $10;
  if (teclado[SDLK_DOWN] or joystick.abajo) then in2:=in2 and $BF else in2:=in2 or $40;
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=in0 and $DF else in0:=in0 or $20;
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=in0 and $EF else in0:=in0 or $10;
end;
end;

procedure frogger_principal;pascal;
var
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
  frame_m:=frame_m+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame_m));
  main_z80.pedir_nmi:=nmi_vblank;
  frame_s:=frame_s+snd_z80.tframes;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  update_video_frogger;
  //Vsync
  frame_m:=frame_m-main_z80.contador+2500;
  run_z80(main_z80,main_z80_ll,trunc(frame_m));
  frame_s:=frame_s-snd_z80.contador+2500;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_m:=frame_m-2500;
  frame_s:=frame_s-2500;
  main_z80.contador:=0;
  snd_z80.contador:=0;
  actualiza_video;
  eventos_frogger;
  sincronizar;
  evaluar_entradas;
end;
end;

function frogger_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
        $e000:frogger_getbyte:=in0;
        $e002:frogger_getbyte:=in1;
        $e004:frogger_getbyte:=in2;
        else frogger_getbyte:=memoria[direccion];
end;
end;

procedure frogger_putbyte(direccion:word;valor:byte);pascal;
var
  dir:word;
  f:byte;
begin
if direccion<$4000 then exit;
case direccion of
        $a800..$abff:gfx[0].buffer[direccion and $3ff]:=true;
        $b000..$b03F:begin
                      dir:=((direccion and $3F) shr 1);
                      for f:=0 to $1F do gfx[0].buffer[dir+(f shl 5)]:=true;
                     end;
        $B808:nmi_vblank:=valor<>0;
        $d000:konami_sl:=valor;
        $d002:begin
                if ((lastirq=0) and (valor<>0)) then snd_z80.pedir_irq:=true;
                lastirq:=valor;
              end;
  end;
memoria[direccion]:=valor;
end;

function fsound_getbyte(direccion:word): Byte; pascal;
begin
direccion:=direccion and $7fff;
fsound_getbyte:=mem_snd[direccion];
end;

procedure fsound_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$1800 then exit;
direccion:=direccion and $7fff;
mem_snd[direccion]:=valor;
end;

function fsound_inbyte(puerto:word):byte;pascal;
begin
if (puerto and $FF)=$40 then fsound_inbyte:=AYRead(0);
end;

procedure fsound_outbyte(valor:byte;puerto:word);pascal;
begin
case (puerto and $FF) of
  $40:AYWrite(valor,0);
  $80:AYControl(valor,0);
end;
end;

procedure frogger_reset;pascal;
begin
reset_z80(main_z80);
reset_z80(snd_z80);
reset_audio;
ay8910_reset(0);
konami_sl:=0;
zeromemory(@memoria[$4000],$BFFF);
zeromemory(@mem_snd[$1800],$27FF);
pintar_pantalla(0,0);
nmi_vblank:=false;
in0:=$FF;
in1:=$FC;
in2:=$F1;
hi_score:=false;
end;

procedure frogger_cerrar;pascal;
begin
save_hi('frogger.hi',@memoria[$83f1],10);
AY8910_close(0);
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure frogger_despues_instruccion;pascal;
begin
if not(hi_score) then begin
  if ((memoria[$83f1]=$63) and (memoria[$83f2]=$04)) then begin
    load_hi('frogger.hi',@memoria[$83f1],10);
    copymemory(@memoria[$83ef],@memoria[$83f1],2);
    hi_score:=true;
  end;
end;
if hay_sonido then begin
    tsample[0][posicion_sonido]:=renderbyte(0)^*8;
    inc(posicion_sonido);
    if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
