unit galaxian_hardware;

interface
uses sdl,z80,constantes,windows,ay_8910,entradas,arcade_const,timers;

//funciones generales
procedure Cargar_hgalaxian;
procedure hgalaxian_principal;pascal;
function iniciar_hgalaxian:boolean;pascal;
procedure reset_hgalaxian;pascal;
procedure cerrar_hgalaxian;pascal;
procedure stars_galaxian;pascal;
procedure stars_jumpbug;pascal;
//funciones de los drivers
function galaxian_getbyte(direccion:word): Byte; pascal;
procedure galaxian_putbyte(direccion:word;valor:byte);pascal;
function jumpbug_getbyte(direccion:word): Byte; pascal;
procedure jumpbug_putbyte(direccion:word;valor:byte);pascal;
function mooncrst_getbyte(direccion:word): Byte; pascal;
procedure mooncrst_putbyte(direccion:word;valor:byte);pascal;
procedure jumpbug_despues_instruccion;pascal;
procedure jumpbug_blinking;pascal;

type
  tstars=record
          x,y,color:word;
  end;
const
        galaxian_rom:array[0..5] of tipo_roms=(
        (n:'galmidw.u';l:$800;p:0),(n:'galmidw.v';l:$800;p:$800),
        (n:'galmidw.w';l:$800;p:$1000),(n:'galmidw.y';l:$800;p:$1800),
        (n:'7l';l:$800;p:$2000),(n:'';l:0;p:0));
        galaxian_char:array[0..2] of tipo_roms=(
        (n:'1h.bin';l:$800;p:0),(n:'1k.bin';l:$800;p:$800),
        (n:'';l:0;p:0));
        galaxian_pal:tipo_roms=(n:'6l.bpr';l:$20;p:0);
        jumpbug_rom:array[0..7] of tipo_roms=(
        (n:'jb1';l:$1000;p:0),(n:'jb2';l:$1000;p:$1000),
        (n:'jb3';l:$1000;p:$2000),(n:'jb4';l:$1000;p:$3000),
        (n:'jb5';l:$1000;p:$8000),(n:'jb6';l:$1000;p:$9000),
        (n:'jb7';l:$800;p:$a000),(n:'';l:0;p:0));
        jumpbug_char:array[0..6] of tipo_roms=(
        (n:'jbl';l:$800;p:0),(n:'jbm';l:$800;p:$800),
        (n:'jbn';l:$800;p:$1000),(n:'jbi';l:$800;p:$1800),
        (n:'jbj';l:$800;p:$2000),(n:'jbk';l:$800;p:$2800),
        (n:'';l:0;p:0));
        jumpbug_pal:tipo_roms=(n:'l06_prom.bin';l:$20;p:0);
        mooncrst_rom:array[0..8] of tipo_roms=(
        (n:'mc1';l:$800;p:0),(n:'mc2';l:$800;p:$800),
        (n:'mc3';l:$800;p:$1000),(n:'mc4';l:$800;p:$1800),
        (n:'mc5.7r';l:$800;p:$2000),(n:'mc6.8d';l:$800;p:$2800),
        (n:'mc7.8e';l:$800;p:$3000),(n:'mc8';l:$800;p:$3800),
        (n:'';l:0;p:0));
        mooncrst_char:array[0..4] of tipo_roms=(
        (n:'mcs_b';l:$800;p:0),(n:'mcs_d';l:$800;p:$800),
        (n:'mcs_a';l:$800;p:$1000),(n:'mcs_c';l:$800;p:$1800),
        (n:'';l:0;p:0));
        mooncrst_pal:tipo_roms=(n:'l06_prom.bin';l:$20;p:0);
        star_count=252;
var
  //variables de funciones especificas
  eventos_hardware_galaxian:procedure;pascal;
  calc_nchar:function(pant:byte;direccion:word):word;pascal;
  calc_sprite:function(direccion:byte):word;pascal;
  draw_stars:procedure;pascal;
  //Variables globales
  haz_nmi,stars_enable:boolean;
  stars_scrollpos:dword;
  stars_blinking:byte;
  stars:array[0..star_count-1] of tstars;
  videoram_mem:array[0..$3ff] of byte;
  sprite_mem,disparo_mem:array[0..$1f] of byte;
  atributos_mem:array[0..$3f] of byte;
  gfx_bank:array[0..4] of byte;

implementation
uses principal;

//Galaxian
procedure eventos_galaxian;pascal;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=(in0 or $4) else in0:=(in0 and $fb);
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=(in0 or $8) else in0:=(in0 and $f7);
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=(in0 or $10) else in0:=(in0 and $ef);
  if teclado[SDLK_1] then in1:=(in1 or $1) else in1:=(in1 and $fe);
  if teclado[SDLK_5] then in0:=(in0 or $1) else in0:=(in0 and $fe);
end;
end;

function galaxian_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $6000..$67ff:galaxian_getbyte:=in0;
  $6800:galaxian_getbyte:=in1;
  $7000:galaxian_getbyte:=in2;
  else galaxian_getbyte:=memoria[direccion];
end;
end;

procedure galaxian_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$4000 then exit;
case direccion of
  $5000..$53ff:begin
                  gfx[0].buffer[direccion and $3ff]:=true;
                  videoram_mem[direccion and $3ff]:=valor;
               end;
  $5800..$583f:begin
                  atributos_mem[direccion and $3f]:=valor;
                  if (direccion and 1)<>0 then fillmemory(@gfx[0].buffer[(((direccion and $3f)-1) shr 1)*$20],$20,1);
               end;
  $5840..$585f:sprite_mem[direccion and $1f]:=valor;
  $5860..$587f:disparo_mem[direccion and $1f]:=valor;
  $7001:haz_nmi:=((valor and 1)<>0);
  $7004:begin
         stars_enable:=(valor and $1)<>0;
         if not(stars_enable) then stars_scrollpos:=0;
        end;
end;
memoria[direccion]:=valor;
end;

function galaxian_calc_nchar(pant:byte;direccion:word):word;pascal;
begin
  galaxian_calc_nchar:=videoram_mem[direccion];
end;

function galaxian_calc_sprite(direccion:byte):word;pascal;
begin
  galaxian_calc_sprite:=sprite_mem[$1+(direccion*4)] and $3f;
end;

//Jump Bug
procedure eventos_jumpbug;pascal;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=(in0 or $4) else in0:=(in0 and $fb);
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=(in0 or $8) else in0:=(in0 and $f7);
  if (teclado[SDLK_DOWN] or joystick.izq) then in0:=(in0 or $40) else in0:=(in0 and $bf);
  if (teclado[SDLK_UP] or joystick.der) then in0:=(in0 or $80) else in0:=(in0 and $7f);
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=(in0 or $10) else in0:=(in0 and $ef);
  if teclado[SDLK_1] then in1:=(in1 or $1) else in1:=(in1 and $fe);
  if teclado[SDLK_5] then in0:=(in0 or $1) else in0:=(in0 and $fe);
end;
end;

function jumpbug_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $6000..$67ff:jumpbug_getbyte:=in0;
  $6800..$6fff:jumpbug_getbyte:=in1;
  $7000..$77ff:jumpbug_getbyte:=in2;
  $b000..$bfff:case (direccion and $fff) of  //proteccion
                  $114:jumpbug_getbyte:=$4f;
	                $118:jumpbug_getbyte:=$d3;
	                $214:jumpbug_getbyte:=$cf;
	                $235:jumpbug_getbyte:=$02;
                  $311:jumpbug_getbyte:=$ff;
	                else jumpbug_getbyte:=$00;
               end;
  else jumpbug_getbyte:=memoria[direccion];
end;
end;

procedure jumpbug_putbyte(direccion:word;valor:byte);pascal;
begin
case direccion of
  0..$3fff,$8000..$afff:exit;  //rom
  $4800..$4fff:begin
                  gfx[0].buffer[direccion and $3ff]:=true;
                  videoram_mem[direccion and $3ff]:=valor;
               end;
  $5000..$57ff:case direccion and $ff of
                $0..$3f:begin
                          atributos_mem[direccion and $3f]:=valor;
                          if (direccion and 1)<>0 then fillmemory(@gfx[0].buffer[(((direccion and $3f)-1) shr 1)*$20],$20,1);
                        end;
                $40..$5f:sprite_mem[direccion and $1f]:=valor;
                $60..$7f:disparo_mem[direccion and $1f]:=valor;
               end;
  $5800..$58ff:AYWrite(valor,0);
  $5900..$59ff:AYControl(valor,0);
  $6000..$67ff:case direccion and $7 of
                $2..$6:if gfx_bank[(direccion and $7)-2]<>valor then begin
                        gfx_bank[(direccion and $7)-2]:=valor;
                        fillmemory(@gfx[0].buffer[0],$400,1);
                       end;
               end;
  $7000..$77ff:case direccion and $7 of
                $1:haz_nmi:=(valor and 1)<>0;
                $4:begin
                     stars_enable:=(valor and $1)<>0;
                     if not(stars_enable) then stars_scrollpos:=0;
                  end;
                end;
end;
memoria[direccion]:=valor;
end;

function jumpbug_calc_nchar(pant:byte;direccion:word):word;pascal;
var
  charcode:word;
begin
  charcode:=videoram_mem[direccion];
  if (((charcode and $c0)=$80) and ((gfx_bank[2] and 1)<>0)) then begin
		charcode:=charcode+(128 + ((gfx_bank[0] and 1) shl 6) +
				           ((gfx_bank[1] and 1) shl 7) +
						   ((not(gfx_bank[4]) and 1) shl 8));
	end;
  jumpbug_calc_nchar:=charcode;
end;

function jumpbug_calc_sprite(direccion:byte):word;pascal;
var
  spritecode:word;
begin
  spritecode:=sprite_mem[$1+(direccion*4)] and $3f;
  if (((spritecode and $30)=$20) and ((gfx_bank[2] and 1)<>0)) then begin
		spritecode:=spritecode+(32 + ((gfx_bank[0] and 1) shl 4) +
		                    ((gfx_bank[1] and 1) shl 5) +
		                    ((not(gfx_bank[4]) and 1) shl 6));
	end;
  jumpbug_calc_sprite:=spritecode;
end;

procedure jumpbug_blinking;pascal;
begin
  stars_blinking:=stars_blinking+1;
end;

procedure jumpbug_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=renderbyte(0)^;
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

procedure stars_jumpbug;pascal;
var
  f,color:byte;
  x,y:word;
begin
for f:=0 to STAR_COUNT-1 do begin
		x:= stars[f].x shr 1;
		y:= stars[f].y;
		// determine when to skip plotting */
		if ((y and $01) xor ((x shr 3) and $01))<>0 then begin
			case (stars_blinking and $03) of
			0:if (stars[f].color and $01)=0 then continue;
			1:if (stars[f].color and $04)=0 then continue;
			2:if (stars[f].y and $02)=0 then continue;
			end;
			//x:= ((stars[f].x +   stars_scrollpos) and $01ff) shr 1;
			//y:= ( stars[f].y + ((stars_scrollpos + stars[f].x) shr 9)) and $ff;
			// no stars in the status area */
			if (x>=240) then continue;
      color:=stars[f].color;
      putpixel(y,x,1,@color,1);
		end;
end;
end;

//Moon Cresta
function mooncrst_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $a000:mooncrst_getbyte:=in0;
  $a800:mooncrst_getbyte:=in1;
  $b000:mooncrst_getbyte:=in2;
  else mooncrst_getbyte:=memoria[direccion];
end;
end;

procedure mooncrst_putbyte(direccion:word;valor:byte);pascal;
begin
case direccion of
  0..$3fff:exit; //rom
  $9000..$93ff:begin
                  gfx[0].buffer[direccion and $3ff]:=true;
                  videoram_mem[direccion and $3ff]:=valor;
               end;
  $9800..$983f:begin
                  atributos_mem[direccion and $3f]:=valor;
                  if (direccion and 1)<>0 then fillmemory(@gfx[0].buffer[(((direccion and $3f)-1) shr 1)*$20],$20,1);
               end;
  $9840..$985f:sprite_mem[direccion and $1f]:=valor;
  $9860..$987f:disparo_mem[direccion and $1f]:=valor;
  $a000..$a002:if gfx_bank[direccion-$a000]<>valor then begin
                  gfx_bank[direccion-$a000]:=valor;
                  fillmemory(@gfx[0].buffer[0],$400,1);
               end;
  $b000:haz_nmi:=(valor and 1)<>0;
  $b004:begin
         stars_enable:=(valor and $1)<>0;
         if not(stars_enable) then stars_scrollpos:=0;
        end;
end;
memoria[direccion]:=valor;
end;

function mooncrst_calc_nchar(pant:byte;direccion:word):word;pascal;
var
  charcode:word;
begin
  charcode:=videoram_mem[direccion];
  if ((gfx_bank[2]<>0) and ((charcode and $c0)=$80)) then
		charcode:=(charcode and $3f) or (gfx_bank[0] shl 6) or (gfx_bank[1] shl 7) or $0100;
  mooncrst_calc_nchar:=charcode;
end;

function mooncrst_calc_sprite(direccion:byte):word;pascal;
var
  spritecode:word;
begin
  spritecode:=sprite_mem[$1+(direccion*4)] and $3f;
  if ((gfx_bank[2]<>0) and ((spritecode and $30)=$20)) then
		spritecode:=(spritecode and $f) or (gfx_bank[0] shl 4) or (gfx_bank[1] shl 5) or $40;
  mooncrst_calc_sprite:=spritecode;
end;

//Definiciones Hardware General
procedure stars_galaxian;pascal;
var
  f,color:byte;
  x,y:word;
begin
for f:=0 to star_count-1 do begin
		x:=((stars[f].x+stars_scrollpos) and $01ff) shr 1;
		y:=(stars[f].y+((stars_scrollpos+stars[f].x) shr 9)) and $ff;
		if ((y and $01) xor ((x shr 3) and $01))<>0 then begin
      color:=paleta[stars[f].color];
      putpixel(y,x,1,@color,1);
		end;
 end;
end;

procedure update_video_hgalaxian;
var
        f,color,long_x,scroll,nchar:word;
        x,y:byte;
begin
pintar_pantalla(1,0);
//estellas
if stars_enable then draw_stars;
//Chars
for f:=$0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    x:=31-(f div 32);
    y:=f mod 32;
    color:=(atributos_mem[$1+(2*(f mod 32))] and $07) shl 2;
    nchar:=calc_nchar(0,f);
    put_gfx_trans(x*8,y*8,nchar,color,2,0);
    gfx[0].buffer[f]:=false;
  end;
end;
//Scroll
for f:=0 to 31 do begin
  scroll:=atributos_mem[$0+(2*f)];
  long_x:=256-scroll;
  actualiza_trozo(long_x,f*8,scroll,8,2,0,f*8,scroll,8,1);
  if scroll<>255 then actualiza_trozo(0,f*8,long_x,8,2,scroll,f*8,long_x,8,1);
end;
//Disparos
for f:=0 to 7 do begin
  if f=7 then color:=32 else color:=33;
  y:=251-disparo_mem[$3+(f*4)];
  x:=disparo_mem[$1+(f*4)];
  put_gfx_sprite(0,color,false,false,2);
  actualiza_gfx_sprite(x,y,1,2);
end;
//Sprites
for f:=7 downto 0 do begin
  nchar:=calc_sprite(f);
  color:=(sprite_mem[$2+(f*4)] and $7) shl 2;
  y:=sprite_mem[$3+(f*4)]+1;
  if y<16 then continue; //en las dos primeras lineas no hay sprites
  x:=sprite_mem[$0+(f*4)];
  put_gfx_sprite(nchar,color,(sprite_mem[$1+(f*4)] and $80)<>0,(sprite_mem[$1+(f*4)] and $40)<>0,1);
  actualiza_gfx_sprite(x,y,1,1);
end;
actualiza_trozo(16,0,224,256,1,0,0,224,256,0);
end;

procedure Cargar_hgalaxian;
begin
case tipo_maquina of
  47:begin
      form1.galaxian1.Checked:=true;
      llamadas_maquina.caption:='Galaxian';
      eventos_hardware_galaxian:=eventos_galaxian;
      calc_nchar:=galaxian_calc_nchar;
      calc_sprite:=galaxian_calc_sprite;
      draw_stars:=stars_galaxian;
     end;
  48:begin
      form1.jumpb1.Checked:=true;
      llamadas_maquina.caption:='Jump Bug';
      eventos_hardware_galaxian:=eventos_jumpbug;
      calc_nchar:=jumpbug_calc_nchar;
      calc_sprite:=jumpbug_calc_sprite;
      draw_stars:=stars_jumpbug;
  end;
  49:begin
      form1.mooncresta1.Checked:=true;
      llamadas_maquina.caption:='Moon Cresta';
      eventos_hardware_galaxian:=eventos_galaxian;
      calc_nchar:=mooncrst_calc_nchar;
      calc_sprite:=mooncrst_calc_sprite;
      draw_stars:=stars_galaxian;
  end;
end;
llamadas_maquina.bucle_general:=hgalaxian_principal;
llamadas_maquina.iniciar:=iniciar_hgalaxian;
llamadas_maquina.cerrar:=cerrar_hgalaxian;
llamadas_maquina.reset:=reset_hgalaxian;
llamadas_maquina.fps_max:=60.6060606060;
llamadas_maquina.canales_usados:=1;
end;

procedure hgalaxian_principal;pascal;
var
  frame:single;
  f:word;
begin
iniciar_entradas;
frame:=0;
while EmuStatus=EsRuning do begin
  frame:=frame+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame));
  main_z80.pedir_nmi:=haz_nmi;
  frame:=frame-main_z80.contador;
  main_z80.contador:=0;
  update_video_hgalaxian;
  actualiza_video;
  if stars_enable then stars_scrollpos:=stars_scrollpos+1;
  evaluar_entradas;
  eventos_galaxian;
  sincronizar;
end;
end;

procedure cerrar_hgalaxian;pascal;
begin
cerrar_cpus;
if tipo_maquina=48 then AY8910_close(0);
cerrar_audio;
cerrar_video;
end;

procedure reset_hgalaxian;pascal;
begin
 reset_z80(main_z80);
 reset_audio;
 in0:=0;
 stars_scrollpos:=0;
 haz_nmi:=false;
 stars_enable:=false;
 zeromemory(@videoram_mem[0],$400);
 zeromemory(@sprite_mem[0],$20);
 zeromemory(@disparo_mem[0],$20);
 zeromemory(@atributos_mem[0],$40);
 zeromemory(@gfx_bank[0],5);
 case tipo_maquina of
  47:begin
       in1:=0;
       in2:=4;
       zeromemory(@memoria[$4000],$c000);
  end;
  48:begin
       in1:=0;
       in2:=1;
       zeromemory(@memoria[$4000],$4000);
       zeromemory(@memoria[$b000],$5000);
       AY8910_reset(0);
  end;
  49:begin
       in1:=$80;
       in2:=0;
       zeromemory(@memoria[$4000],$c000);
  end;
 end;
end;

function iniciar_hgalaxian:boolean;pascal;
var
      colores:tpaleta;
      f,x,y:word;
      pos:pbyte;
      ctemp1,ctemp2,total_stars:byte;
      bit0,generator:dword;
const
  ps_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			8*8+0, 8*8+1, 8*8+2, 8*8+3, 8*8+4, 8*8+5, 8*8+6, 8*8+7);
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			16*8, 17*8, 18*8, 19*8, 20*8, 21*8, 22*8, 23*8);
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7 );
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
  map:array[0..3] of byte =($00,$88,$cc,$ff);
//pequeas funciones para aclarar el codigo
procedure convert_chars(n:word);
begin
  init_gfx(0,8,8,n);
  gfx[0].trans[0]:=true;
  des_sprites.pos_planos[0]:=0;
  des_sprites.pos_planos[1]:=n*8*8;
  des_sprites.bit_pixel:=2;
  des_sprites.banks:=0;
  des_sprites.long_sprites:=8*8;
  convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
end;
procedure convert_sprt(n:word);
begin
  init_gfx(1,16,16,n);
  gfx[1].trans[0]:=true;
  des_sprites.pos_planos[0]:=0;
  des_sprites.pos_planos[1]:=n*16*16;
  des_sprites.bit_pixel:=2;
  des_sprites.banks:=0;
  des_sprites.long_sprites:=32*8;
  convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
end;
begin
iniciar_hgalaxian:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[2].trans:=true;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,3072000/llamadas_maquina.fps_max);
main_z80.daisy:=false;
main_z80_ll.outbyte:=nil;
main_z80_ll.inbyte:=nil;
case tipo_maquina of
  47:begin
      //funciones Z80
      main_z80_ll.getbyte:=galaxian_getbyte;
      main_z80_ll.putbyte:=galaxian_putbyte;
      //cargar roms
      if not(cargar_roms(@memoria[0],@galaxian_rom[0],'\galaxian.zip',0)) then exit;
      //convertir chars &sprites
      if not(cargar_roms(@memoria_temp[0],@galaxian_char[0],'\galaxian.zip',0)) then exit;
      convert_chars(256);
      convert_sprt(64);
  end;
  48:begin
      //funciones Z80
      main_z80_ll.getbyte:=jumpbug_getbyte;
      main_z80_ll.putbyte:=jumpbug_putbyte;
      //chip de sonido
      AY8910_init(1500000,0,nil,nil,nil,nil);
      //Timers
      init_timer(0,0,3072000/44100,jumpbug_despues_instruccion,true);
      init_timer(1,0,3072000*(0.693*(100000+2*10000)*0.00001),jumpbug_blinking,true);
      //cargar roms
      if not(cargar_roms(@memoria[0],@jumpbug_rom[0],'\jumpbug.zip',0)) then exit;
      //convertir chars &sprites
      if not(cargar_roms(@memoria_temp[0],@jumpbug_char[0],'\jumpbug.zip',0)) then exit;
      convert_chars(768);
      convert_sprt(192);
  end;
  49:begin  //mooncrst
      //funciones Z80
      main_z80_ll.getbyte:=mooncrst_getbyte;
      main_z80_ll.putbyte:=mooncrst_putbyte;
      //cargar roms
      if not(cargar_roms(@memoria[0],@mooncrst_rom[0],'\mooncrst.zip',0)) then exit;
      //Desencriptarlas
      for f:=0 to $3fff do begin
		    ctemp1:=memoria[f];
		    ctemp2:=ctemp1;
		    if ((ctemp1 and 2)<>0) then ctemp2:=ctemp2 xor $40;
		    if ((ctemp1 and $20)<>0) then ctemp2:=ctemp2 xor $04;
		    if ((f and 1)=0) then ctemp1:= BITSWAP8(ctemp2,7,2,5,4,3,6,1,0)
          else ctemp1:=ctemp2;
		    memoria[f]:=ctemp1;
      end;
      //convertir chars & sprites
      if not(cargar_roms(@memoria_temp[0],@mooncrst_char[0],'\mooncrst.zip',0)) then exit;
      convert_chars(512);
      convert_sprt(128);
  end;
end;
//El disparo, creado por hardware aqui lo emulo como si fuera un sprite...
init_gfx(2,1,4,1);
pos:=gfx[2].datos;
for f:=0 to 3 do begin
  pos^:=0;
  inc(pos);
end;
//iniciar las estrellas de fondo
total_stars:=0;
generator:=0;
for y:=0 to 255 do begin
		for x:=0 to 511 do begin
			bit0:=((not(generator) shr 16) and $01) xor ((generator shr 4) and $01);
			generator:= (generator shl 1) or bit0;
			if ((((not(generator) shr 16) and $01)<>0) and ((generator and $ff)=$ff)) then begin
				ctemp1:= (not(generator shr 8)) and $3f;
				if (ctemp1<>0) then begin
					stars[total_stars].x:=x;
					stars[total_stars].y:=y;
					stars[total_stars].color:=ctemp1+64;
					inc(total_stars);
				end;
      end;
		end;
end;
//poner la paleta
case tipo_maquina of
  47:if not(cargar_roms(@memoria_temp[0],@galaxian_pal,'\galaxian.zip',1)) then exit;
  48:if not(cargar_roms(@memoria_temp[0],@jumpbug_pal,'\jumpbug.zip',1)) then exit;
  49:if not(cargar_roms(@memoria_temp[0],@mooncrst_pal,'\mooncrst.zip',1)) then exit;
end;
for f:=0 to 31 do begin
    ctemp1:=memoria_temp[f];
    colores[f].r:=$21*(ctemp1 and 1)+$47*((ctemp1 shr 1) and 1)+$97*((ctemp1 shr 2) and 1);
    colores[f].g:=$21*((ctemp1 shr 3) and 1)+$47*((ctemp1 shr 4) and 1)+$97*((ctemp1 shr 5) and 1);
    colores[f].b:=0+$47*((ctemp1 shr 6) and 1)+$97*((ctemp1 shr 7) and 1);
end;
//y la paleta del disparo
colores[32].r:=$FF;colores[32].g:=$FF;colores[32].b:=$0;
colores[33].r:=$FF;colores[33].g:=$FF;colores[33].b:=$FF;
//y la de las estrellas de fondo
for f:=0 to 63 do begin
		ctemp1:=(f shr 0) and $03;
		colores[f+34].r:=map[ctemp1];
		ctemp1:=(f shr 2) and $03;
		colores[f+34].g:=map[ctemp1];
		ctemp1:=(f shr 4) and $03;
		colores[f+34].b:=map[ctemp1];
end;
poner_paleta(colores,32+2+64);
//final
reset_hgalaxian;
iniciar_hgalaxian:=true;
end;

end.
