unit gng;

interface
uses sdl,m6809,z80,ym_2203,constantes,windows,entradas,arcade_const,timers;

procedure Cargar_gng;
procedure gng_principal;pascal;
function gng_getbyte(direccion:word): Byte; pascal;
procedure gng_putbyte(direccion:word;valor:byte);pascal;
function sound_getbyte(direccion:word):Byte; pascal;
procedure sound_putbyte(direccion:word;valor:byte);pascal;
procedure sound_instruccion;pascal;
function iniciar_gng:boolean;pascal;
procedure reset_gng;pascal;
procedure cerrar_gng;pascal;

const
        gng_rom:array[0..3] of tipo_roms=(
        //(n:'8n.rom';l:$8000;p:$8000),(n:'10n.rom';l:$4000;p:$4000),
        //(n:'12n.rom';l:$8000;p:$10000),(n:'';l:0;p:0));
        (n:'gg3.bin';l:$8000;p:$8000),(n:'gg4.bin';l:$4000;p:$4000),
        (n:'gg5.bin';l:$8000;p:$10000),(n:'';l:0;p:0));
        gng_char:tipo_roms=(n:'gg1.bin';l:$4000;p:0);
        gng_tiles:array[0..6] of tipo_roms=(
        (n:'gg11.bin';l:$4000;p:0),(n:'gg10.bin';l:$4000;p:$4000),(n:'gg9.bin';l:$4000;p:$8000),
        (n:'gg8.bin';l:$4000;p:$c000),(n:'gg7.bin';l:$4000;p:$10000),(n:'gg6.bin';l:$4000;p:$14000),
        (n:'';l:0;p:0));
        gng_sprites:array[0..6] of tipo_roms=(
        (n:'gg17.bin';l:$4000;p:0),(n:'gg16.bin';l:$4000;p:$4000),(n:'gg15.bin';l:$4000;p:$8000),
        (n:'gg14.bin';l:$4000;p:$c000),(n:'gg13.bin';l:$4000;p:$10000),(n:'gg12.bin';l:$4000;p:$14000),
        (n:'';l:0;p:0));
        gng_sound:tipo_roms=(n:'gg2.bin';l:$8000;p:0);

var
 memoria_rom:array[0..4,0..$1FFF] of byte;
 banco,soundlatch:byte;
 scroll_x,scroll_y:parejas;

implementation
uses principal;

procedure Cargar_Gng;
begin
form1.gng1.Checked:=true;
llamadas_maquina.caption:='Ghost''n''Goblins';
llamadas_maquina.iniciar:=iniciar_gng;
llamadas_maquina.bucle_general:=gng_principal;
llamadas_maquina.cerrar:=cerrar_gng;
llamadas_maquina.reset:=reset_gng;
llamadas_maquina.canales_usados:=2;
llamadas_maquina.fps_max:=59.59;
end;

function iniciar_gng:boolean;pascal;
var
  colores:tpaleta;
  f:word;
const
    pc_x:array[0..7] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3 );
    pc_y:array[0..7] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16);
    ps_x:array[0..15] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3,
			32*8+0, 32*8+1, 32*8+2, 32*8+3, 33*8+0, 33*8+1, 33*8+2, 33*8+3);
    ps_y:array[0..15] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16,
			8*16, 9*16, 10*16, 11*16, 12*16, 13*16, 14*16, 15*16);
    pt_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			16*8+0, 16*8+1, 16*8+2, 16*8+3, 16*8+4, 16*8+5, 16*8+6, 16*8+7);
    pt_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
begin
iniciar_gng:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=224;
p_final[1].x:=512;
p_final[1].y:=512;
p_final[2].x:=256;
p_final[2].y:=256;
//Chars trans
p_final[6].x:=256;
p_final[6].y:=256;
p_final[6].trans:=true;
//Foreground
p_final[7].x:=512;
p_final[7].y:=512;
p_final[7].trans:=true;
iniciar_video;
//datos del scroll
scroll_data.long_x:=512;
scroll_data.long_y:=512;
scroll_data.max_x:=256;
scroll_data.max_y:=256;
scroll_data.max_scr_x:=255;
scroll_data.max_scr_y:=255;
//Main CPU
init_cpu(m6809_main,0,1500000/llamadas_maquina.fps_max/4);
main_6809_ll.getbyte:=gng_getbyte;
main_6809_ll.putbyte:=gng_putbyte;
//Sound CPU
init_cpu(z80_snd,1,3000000/llamadas_maquina.fps_max/4);
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=sound_getbyte;
snd_z80_ll.putbyte:=sound_putbyte;
snd_z80_ll.outbyte:=nil;
snd_z80_ll.inbyte:=nil;
//Sound Chip
ym2203_Init(0,1500000,4,nil,nil,nil,nil);
ym2203_Init(1,1500000,4,nil,nil,nil,nil);
//Timers
init_timer(0,1,3000000/44100,sound_instruccion,true);
{cargar roms}
if not(cargar_roms(@memoria_temp[0],@gng_rom[0],'\gng.zip',0)) then exit;
//Pongo las ROMs en su banco
copymemory(@memoria[$8000],@memoria_temp[$8000],$8000);
for f:=0 to 3 do copymemory(@memoria_rom[f,0],@memoria_temp[$10000+(f*$2000)],$2000);
copymemory(@memoria[$6000],@memoria_temp[$6000],$2000);
copymemory(@memoria_rom[4,0],@memoria_temp[$4000],$2000);
//Cargar Sound
if not(cargar_roms(@mem_snd[0],@gng_sound,'\gng.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@gng_char,'\gng.zip',1)) then exit;
init_gfx(0,8,8,1024);
gfx[0].trans[3]:=true;
des_sprites.pos_planos[0]:=4;
des_sprites.pos_planos[1]:=0;
des_sprites.bit_pixel:=2;
des_sprites.banks:=0;
des_sprites.long_sprites:=16*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@gng_sprites[0],'\gng.zip',0)) then exit;
init_gfx(1,16,16,1024);
gfx[1].trans[15]:=true;
des_sprites.pos_planos[0]:=$c000*8+4;
des_sprites.pos_planos[1]:=$c000*8+0;
des_sprites.pos_planos[2]:=4;
des_sprites.pos_planos[3]:=0;
des_sprites.bit_pixel:=4;
des_sprites.long_sprites:=64*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//tiles
if not(cargar_roms(@memoria_temp[0],@gng_tiles[0],'\gng.zip',0)) then exit;
init_gfx(2,16,16,1024);
gfx[2].trans[0]:=true;
gfx[2].trans[6]:=true;
des_sprites.pos_planos[0]:=$10000*8;
des_sprites.pos_planos[1]:=$8000*8;
des_sprites.pos_planos[2]:=0;
des_sprites.bit_pixel:=3;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[2],0,@memoria_temp[0],@pt_x[0],@pt_y[0],false,false);
//Poner colores aleatorios hasta que inicie la paleta
for f:=0 to 255 do begin
  colores[f].r:=random(256);
  colores[f].g:=random(256);
  colores[f].b:=random(256);
end;
poner_paleta(colores,256);
//final
reset_gng;
iniciar_gng:=true;
end;

procedure cerrar_gng;pascal;
begin
cerrar_cpus;
YM2203_close(0);
YM2203_close(1);
cerrar_audio;
cerrar_video;
end;

procedure reset_gng;pascal;
begin
 reset_6809(main_6809,main_6809_ll);
 reset_z80(snd_z80);
 ym2203_reset(0);
 ym2203_reset(1);
 reset_audio;
 banco:=0;
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 soundlatch:=0;
end;

procedure update_video_gng;
var
  x,y,f,color,nchar:word;
  atrib:byte;
begin
//background y foreground
for f:=$0 to $3ff do begin
    if gfx[2].buffer[f] then begin
      x:=f div 32;
      y:=f mod 32;
      color:=(memoria[$2c00+f] and $7) shl 3;
      nchar:=memoria[$2800+f]+(memoria[$2c00+f] and $c0) shl 2;
      put_gfx_flip(x*16,y*16,nchar,color,1,2,(memoria[$2c00+f] and $10)<>0,(memoria[$2c00+f] and $20)<>0);
      if (memoria[$2c00+f] and 8)=0 then put_gfx_trans(x*16,y*16,0,0,7,2)
        else put_gfx_trans_flip(x*16,y*16,nchar,color,7,2,(memoria[$2c00+f] and $10)<>0,(memoria[$2c00+f] and $20)<>0);
      gfx[2].buffer[f]:=false;
    end;
    //chars
    if gfx[0].buffer[f] then begin
      y:=f div 32;
      x:=f mod 32;
      color:=((memoria[$2400+f] and $f) shl 2)+128;
      nchar:=memoria[$2000+f]+((memoria[$2400+f] and $c0) shl 2);
      put_gfx_trans(x*8,y*8,nchar,color,6,0);
      gfx[0].buffer[f]:=false;
    end;
end;
//scroll del fondo
scroll_x_y(1,2,scroll_x.w,scroll_y.w);
//sprites
for f:=$7f downto 0 do begin
  atrib:=buffer_sprites[(f*4)+1];
  nchar:=buffer_sprites[f*4]+((atrib shl 2) and $300);
  color:=(atrib and $30)+64;
  x:=buffer_sprites[$3+(f*4)]+((atrib and $1) shl 8);
  y:=buffer_sprites[$2+(f*4)];
  put_gfx_sprite(nchar,color,(atrib and 4)<>0,(atrib and 8)<>0,1);
  actualiza_gfx_sprite(x,y,2,1);
end;
//scroll del arriba
scroll_x_y(7,2,scroll_x.w,scroll_y.w);
//chars
actualiza_trozo(0,0,256,256,6,0,0,256,256,2);
actualiza_trozo(0,16,256,224,2,0,0,256,224,0);
end;

procedure eventos_gng;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if (teclado[SDLK_LEFT] or joystick.izq) then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if (teclado[SDLK_RIGHT] or joystick.der) then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $df) else in1:=(in1 or $20);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if teclado[SDLK_5] then in0:=(in0 and $7f) else in0:=(in0 or $80);
  if teclado[SDLK_1] then in0:=(in0 and $fe) else in0:=(in0 or 1);
  if teclado[SDLK_2] then in0:=(in0 and $fd) else in0:=(in0 or 2);
end;
end;

procedure gng_principal;pascal;
var
  f:byte;
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
//Por cada frame hay 1 irq del 6809 y 4 del Z80
while EmuStatus=EsRuning do begin
  for f:=0 to 3 do begin
    frame_m:=frame_m+main_6809.tframes;
    run_6809(main_6809,main_6809_ll,trunc(frame_m));
    frame_s:=frame_s+snd_z80.tframes;
    run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
    snd_z80.pedir_irq:=true;
    frame_m:=frame_m-main_6809.contador;
    main_6809.contador:=0;
    frame_s:=frame_s-snd_z80.contador;
    snd_z80.contador:=0;
  end;
  main_6809.pedir_irq:=true;
  update_video_gng;
  actualiza_video;
  eventos_gng;
  sincronizar;
  evaluar_entradas;
  copymemory(@buffer_sprites[0],@memoria[$1e00],$200);
end;
end;

procedure cambiar_color(dir:word);
var
        tmp_color,bit0,bit1,bit2,bit3:byte;
        color:tcolor;
        pos:word;
begin
  pos:=dir-$3800;
  tmp_color:=memoria[dir];
  bit0:=(tmp_color shr 4) and 1;
  bit1:=(tmp_color shr 5) and 1;
  bit2:=(tmp_color shr 6) and 1;
  bit3:=(tmp_color shr 7) and 1;
  color.r:=$0e*bit0+$1f*bit1+$43*bit2+$8f*bit3;
  bit0:=(tmp_color shr 0) and 1;
  bit1:=(tmp_color shr 1) and 1;
  bit2:=(tmp_color shr 2) and 1;
  bit3:=(tmp_color shr 3) and 1;
  color.g:=$0e*bit0+$1f*bit1+$43*bit2+$8f*bit3;
  tmp_color:=memoria[dir+$100];
  bit0:=(tmp_color shr 4) and 1;
  bit1:=(tmp_color shr 5) and 1;
  bit2:=(tmp_color shr 6) and 1;
  bit3:=(tmp_color shr 7) and 1;
  color.b:=$0e*bit0+$1f*bit1+$43*bit2+$8f*bit3;
  poner_color(color,addr(paleta[pos]));
  case pos of
    0..63:fillmemory(@gfx[2].buffer[0],$400,1);
    128..255:fillmemory(@gfx[0].buffer[0],$400,1);
  end;
end;

function gng_getbyte(direccion:word): Byte; pascal;
begin
    case direccion of
        $3000:gng_getbyte:=in0;
        $3001:gng_getbyte:=in1;
        $3002:gng_getbyte:=in2;
        $3003:gng_getbyte:=$DF;
        $3004:gng_getbyte:=$7B;
        $4000..$5fff:gng_getbyte:=memoria_rom[banco,direccion and $1FFF]
    else gng_getbyte:=memoria[direccion];
    end;
end;

procedure gng_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion>$3FFF then exit;
memoria[direccion]:=valor;
case direccion of
  $2000..$27ff:gfx[0].buffer[direccion and $3ff]:=true;
  $2c00..$2fff:gfx[2].buffer[direccion and $3ff]:=true;
  $3800..$39ff:if buffer_paleta[direccion and $1ff]<>valor then begin
                  cambiar_color(direccion and $feff);
                  buffer_paleta[direccion and $1ff]:=valor;
               end;
  $3a00:soundlatch:=valor;
  $3b08:scroll_x.l:=valor;
  $3b09:scroll_x.h:=valor and 1;
  $3b0a:scroll_y.l:=valor;
  $3b0b:scroll_y.h:=valor and 1;
  $3e00:banco:=valor and 7;
end;
end;

function sound_getbyte(direccion:word):Byte; pascal;
begin
if direccion=$c800 then sound_getbyte:=soundlatch
  else sound_getbyte:=mem_snd[direccion];
end;

procedure sound_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$8000 then exit;
mem_snd[direccion]:=valor;
case direccion of
  $e000:ym2203_Control(0,valor);
  $e001:ym2203_Write_Reg(0,valor);
  $e002:ym2203_Control(1,valor);
  $e003:ym2203_Write_Reg(1,valor);
end;
end;

procedure sound_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=ym2203UpdateOne(0);
  tsample[1][posicion_sonido]:=ym2203UpdateOne(1);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
