unit jackal;

interface
uses sdl,m6809,constantes,windows,entradas,arcade_const,timers,ym_2151,dialogs,network;

procedure Cargar_jackal;
procedure jackal_principal;pascal;
function jackal_getbyte(direccion:word): Byte; pascal;
procedure jackal_putbyte(direccion:word;valor:byte);pascal;
function sound_getbyte(direccion:word):Byte; pascal;
procedure sound_putbyte(direccion:word;valor:byte);pascal;
procedure sound_instruccion;pascal;
function iniciar_jackal:boolean;pascal;
procedure reset_jackal;pascal;
procedure cerrar_jackal;pascal;

const
        jackal_rom:array[0..2] of tipo_roms=(
        (n:'j-v02.rom';l:$10000;p:$0),(n:'j-v03.rom';l:$4000;p:$10000),(n:'';l:0;p:0));
        jackal_proms:array[0..2] of tipo_roms=(
        (n:'631r08.bpr';l:$100;p:0),(n:'631r09.bpr';l:$100;p:$100),(n:'';l:0;p:0));
        jackal_chars:array[0..4] of tipo_roms=(
        (n:'631t04.bin';l:$20000;p:0),(n:'631t05.bin';l:$20000;p:$1),
        (n:'631t06.bin';l:$20000;p:$40000),(n:'631t07.bin';l:$20000;p:$40001),
        (n:'';l:0;p:0));
        jackal_sound:tipo_roms=(n:'631t01.bin';l:$8000;p:$8000);

var
 memoria_rom:array[0..1,0..$7FFF] of byte;
 memoria_zram:array[0..1,0..$3f] of byte;
 memoria_sprite:array[0..1,0..$fff] of byte;
 memoria_voram:array[0..1,0..$7ff] of byte;
 banco:byte;
 scroll_x,scroll_y,scroll_crt,sprite_crt:byte;
 irq_enable:boolean;
 ram_bank,sprite_bank:byte;

implementation
uses principal;

procedure Cargar_jackal;
begin
form1.jackal1.Checked:=true;
llamadas_maquina.caption:='Jackal';
llamadas_maquina.iniciar:=iniciar_jackal;
llamadas_maquina.bucle_general:=jackal_principal;
llamadas_maquina.cerrar:=cerrar_jackal;
llamadas_maquina.reset:=reset_jackal;
llamadas_maquina.canales_usados:=1;
stereo:=true;
end;

function iniciar_jackal:boolean;pascal;
var
  f:word;
const
    pc_x:array[0..7] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4);
    pc_y:array[0..7] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32);
    ps_x:array[0..15] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4,
			32*8+0*4, 32*8+1*4, 32*8+2*4, 32*8+3*4, 32*8+4*4, 32*8+5*4, 32*8+6*4, 32*8+7*4);
    ps_y:array[0..15] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32,
			16*32, 17*32, 18*32, 19*32, 20*32, 21*32, 22*32, 23*32);
begin
iniciar_jackal:=false;
iniciar_audio(2);
//Pantallas
p_final[0].x:=224;
p_final[0].y:=240;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[2].x:=256;
p_final[2].y:=256;
iniciar_video;
//datos del scroll
scroll_data.long_x:=256;
scroll_data.ad_x:=256;
scroll_data.max_x:=256;
scroll_data.max_scr_x:=255;
scroll_data.long_y:=256;
scroll_data.ad_y:=256;
scroll_data.max_y:=256;
scroll_data.max_scr_y:=255;
//Main CPU
init_cpu(m6809_main,0,1536000/llamadas_maquina.fps_max/10);
main_6809_ll.getbyte:=jackal_getbyte;
main_6809_ll.putbyte:=jackal_putbyte;
//Sound CPU
init_cpu(m6809_snd,1,2000000/llamadas_maquina.fps_max/10);
snd_6809_ll.getbyte:=sound_getbyte;
snd_6809_ll.putbyte:=sound_putbyte;
//Audio chips
ym2151init(0,3579545);
//Timers
init_timer(0,1,2000000/44100,sound_instruccion,true);
{cargar roms}
if not(cargar_roms(@memoria_temp[0],@jackal_rom[0],'\jackal.zip',0)) then exit;
//Pongo las ROMs en su banco
copymemory(@memoria[$c000],@memoria_temp[$10000],$4000);
copymemory(@memoria_rom[0,0],@memoria_temp[0],$8000);
copymemory(@memoria_rom[1,0],@memoria_temp[$8000],$8000);
//Cargar Sound
if not(cargar_roms(@mem_snd[0],@jackal_sound,'\jackal.zip',1)) then exit;
//convertir chars
if not(cargar_roms16b(@memoria_temp[0],@jackal_chars,'\jackal.zip',0)) then exit;
init_gfx(0,8,8,4096);
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=1;
des_sprites.pos_planos[2]:=2;
des_sprites.pos_planos[3]:=3;
des_sprites.pos_planos[4]:=$40000*8+0;
des_sprites.pos_planos[5]:=$40000*8+1;
des_sprites.pos_planos[6]:=$40000*8+2;
des_sprites.pos_planos[7]:=$40000*8+3;
des_sprites.bit_pixel:=8;
des_sprites.banks:=0;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//sprites 8
init_gfx(1,8,8,4096*2);
gfx[1].trans[0]:=true;
des_sprites.bit_pixel:=4;
des_sprites.banks:=2;
convert_sprites(@gfx[1],0,@memoria_temp[$20000],@pc_x[0],@pc_y[0],true,false);
convert_sprites(@gfx[1],4096*8*8,@memoria_temp[$60000],@pc_x[0],@pc_y[0],true,false);
//tiles
init_gfx(2,16,16,1024*2);
gfx[2].trans[0]:=true;
des_sprites.long_sprites:=32*32;
convert_sprites(@gfx[2],0,@memoria_temp[$20000],@ps_x[0],@ps_y[0],true,false);
convert_sprites(@gfx[2],1024*16*16,@memoria_temp[$60000],@ps_x[0],@ps_y[0],true,false);
//Color lookup
if not(cargar_roms(@memoria_temp[0],@jackal_proms,'\jackal.zip',0)) then exit;
for f:=0 to $ff do gfx[0].colores[f]:=f or $100;
for f:=$100 to $1ff do gfx[1].colores[f]:=memoria_temp[f-$100] and $0f;
for f:=$200 to $2ff do gfx[1].colores[f]:=(memoria_temp[f-$100] and $0f) or $10;
copymemory(@gfx[2].colores,@gfx[1].colores,2048*sizeof(word));
//final
reset_jackal;
iniciar_jackal:=true;
end;

procedure cerrar_jackal;pascal;
begin
ym2151close(0);
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_jackal;pascal;
begin
 reset_6809(main_6809,main_6809_ll);
 reset_6809(snd_6809,snd_6809_ll);
 reset_audio;
 ym2151resetchip(0);
 in0:=$3F;
 in1:=$FF;
 in2:=$FF;
 irq_enable:=false;
 ram_bank:=0;
 sprite_bank:=0;
end;

procedure draw_sprites(bank:byte;pos:word);
var
  sn1,sn2,y,x,attr,sx,sy:byte;
	flipx,flipy:boolean;
  nchar,color:word;
begin
  sn1:=memoria_sprite[bank,pos];
  sn2:=memoria_sprite[bank,pos+1];
  x:=240-memoria_sprite[bank,pos+2];
  y:=memoria_sprite[bank,pos+3];
  attr:=memoria_sprite[bank,pos+4];
  if (attr and 1)<>0 then exit;
  if y>240 then exit;
  flipy:=(attr and $20)<>0;
  flipx:=(attr and $40)<>0;
  color:=(sn2 and $f0)+((bank+1)*$100);
  if (attr and $C)<>0 then begin    // half-size sprite
			nchar:=(sn1*4+((sn2 and (8+4)) shr 2)+((sn2 and (2+1)) shl 10))+(bank*4096);
      if nchar=$25 then nchar:=0;
			case (attr and $0C) of
        $04:begin
              put_gfx_sprite(nchar,color,flipx,flipy,1);
              actualiza_gfx_sprite(x+8,y,2,1);
              put_gfx_sprite(nchar+1,color,flipx,flipy,1);
              actualiza_gfx_sprite(x+8,y+8,2,1);
            end;
        $08:begin
              put_gfx_sprite(nchar,color,flipx,flipy,1);
              actualiza_gfx_sprite(x,y,2,1);
              put_gfx_sprite(nchar-2,color,flipx,flipy,1);
              actualiza_gfx_sprite(x+8,y,2,1);
			      end;
        $0c:begin
              put_gfx_sprite(nchar,color,flipx,flipy,1);
              actualiza_gfx_sprite(x+8,y,2,1);
			      end;
      end;
  end else begin
      nchar:=(sn1 + ((sn2 and $03) shl 8))+(bank*1024);
			if (attr and $10)<>0 then begin
        if flipy then sy:=y+16 else sy:=y;
        if flipx then sx:=x-16 else sx:=x;
        put_gfx_sprite(nchar,color,flipx,flipy,2);
        actualiza_gfx_sprite(sx,sy,2,2);
        if flipx then sx:=x else sx:=x-16;
        put_gfx_sprite(nchar+2,color,flipx,flipy,2);
        actualiza_gfx_sprite(sx,sy,2,2);
        if flipy then sy:=y else sy:=y+16;
        if flipx then sx:=x-16 else sx:=x;
        put_gfx_sprite(nchar+1,color,flipx,flipy,2);
        actualiza_gfx_sprite(sx,sy,2,2);
        if flipx then sx:=x else sx:=x-16;
        put_gfx_sprite(nchar+3,color,flipx,flipy,2);
        actualiza_gfx_sprite(sx,sy,2,2);
			end	else begin
        put_gfx_sprite(nchar,color,flipx,flipy,2);
        actualiza_gfx_sprite(x,y,2,2);
			end;
  end;
end;

procedure update_video_jackal;
var
  x,y,f,nchar,long:word;
  atrib,scroll:byte;
begin
//background
for f:=$0 to $3ff do begin
    if gfx[0].buffer[f] then begin
      x:=31-(f div 32);
      y:=f mod 32;
      atrib:=memoria_voram[ram_bank,f];
      nchar:=memoria_voram[ram_bank,$400+f]+((atrib and $c0) shl 2) + ((atrib and $30) shl 6);
      put_gfx_flip(x*8,y*8,nchar,0,1,0,(atrib and $20)<>0,(atrib and $10)<>0);
      gfx[0].buffer[f]:=false;
    end;
end;
//scroll de varios tipos...
if (scroll_crt and $2)<>0 then begin
  //horizontal 8 lineas independientes
  if (scroll_crt and $4)<>0 then begin
    //eje X
    for f:=0 to 31 do begin
      scroll:=255-memoria_zram[ram_bank,f];
      long:=memoria_zram[ram_bank,f];
      actualiza_trozo(scroll,f*8,long,8,1,0,f*8,long,8,2);
      if long<255 then actualiza_trozo(0,f*8,scroll,8,1,long,f*8,long,8,2);
    end;
  end;
  if (scroll_crt and $8)<>0 then begin
    //Eje Y
    for f:=0 to 31 do begin
      scroll:=memoria_zram[ram_bank,f];
      long:=255-memoria_zram[ram_bank,f];
      actualiza_trozo(f*8,scroll,8,long,1,f*8,0,8,long,2);
      if scroll<>0 then actualiza_trozo(f*8,0,8,scroll,1,f*8,long,8,long,2);
    end;
  end;
end else scroll_x_y(1,2,scroll_x,scroll_y);
//sprites
if (sprite_crt and $8)<>0 then begin
  for f:=0 to 48 do draw_sprites(1,$800+f*5);
  for f:=0 to $ff do draw_sprites(0,$800+f*5);
end else begin
  for f:=0 to 48 do draw_sprites(1,f*5);
  for f:=0 to $ff do draw_sprites(0,f*5);
end;
actualiza_trozo(16,8,224,240,2,0,0,224,240,0);
end;

procedure eventos_jackal;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if (teclado[SDLK_LEFT] or joystick.izq) then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if (teclado[SDLK_RIGHT] or joystick.der) then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $df) else in1:=(in1 or $20);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if teclado[SDLK_1] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if teclado[SDLK_5] then in0:=(in0 and $fe) else in0:=(in0 or 1);
  if teclado[SDLK_2] then in0:=(in0 and $ef) else in0:=(in0 or $10);
end;
end;

procedure jackal_principal;pascal;
var
  f:byte;
  frame_m,frame_s:single;
begin
iniciar_entradas;
open_connection_server;
net_data.master_data:=false;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
  for f:=0 to 9 do begin
    frame_m:=frame_m+main_6809.tframes;
    run_6809(main_6809,main_6809_ll,trunc(frame_m));
    frame_s:=frame_s+snd_6809.tframes;
    run_6809(snd_6809,snd_6809_ll,trunc(frame_s));
    frame_m:=frame_m-main_6809.contador;
    main_6809.contador:=0;
    frame_s:=frame_s-snd_6809.contador;
    snd_6809.contador:=0;
  end;
  main_6809.pedir_irq:=irq_enable;
  snd_6809.pedir_nmi:=irq_enable;
  update_video_jackal;
  actualiza_video;
  eventos_jackal;
  sincronizar;
  evaluar_entradas;
end;
end;

function jackal_getbyte(direccion:word): Byte; pascal;
begin
    case direccion of
        $10,$12:jackal_getbyte:=$ff;
        $11:jackal_getbyte:=in1;
        $13:jackal_getbyte:=in0;
        $18:jackal_getbyte:=$5f;
        $20..$5f:jackal_getbyte:=memoria_zram[ram_bank,direccion-$20];
        $2000..$27ff:jackal_getbyte:=memoria_voram[ram_bank,direccion and $7ff];
        $3000..$3fff:jackal_getbyte:=memoria_sprite[sprite_bank,direccion and $fff];
        $4000..$bfff:jackal_getbyte:=memoria_rom[banco,direccion-$4000];
    else jackal_getbyte:=memoria[direccion];
    end;
end;

procedure jackal_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion>$3FFF then exit;
memoria[direccion]:=valor;
case direccion of
  $0:scroll_x:=255-valor;
  $1:scroll_y:=valor;
  $2:scroll_crt:=valor;
  $3:sprite_crt:=valor;
  $4:irq_enable:=(valor and $2)<>0;
  $1c:begin
          banco:=(valor and $20) shr 5;
          ram_bank:=(valor and $10) shr 4;
          sprite_bank:=(valor and $8) shr 3;
        end;
  $20..$5f:memoria_zram[ram_bank,direccion-$20]:=valor;
  $2000..$27ff:begin
                  memoria_voram[ram_bank,direccion and $7ff]:=valor;
                  gfx[0].buffer[direccion and $3ff]:=true;
               end;
  $3000..$3fff:memoria_sprite[sprite_bank,direccion and $fff]:=valor;
end;
end;

function sound_getbyte(direccion:word):Byte; pascal;
begin
case direccion of
  $2001:sound_getbyte:=ym2151_status_port_read(0);
  $6060..$7fff:sound_getbyte:=memoria[direccion-$6000];
  else sound_getbyte:=mem_snd[direccion];
end;
end;

procedure cambiar_color(dir:word);
var
        data:word;
        color:tcolor;
        valor:byte;
begin
  data:=mem_snd[$4000+dir]+(mem_snd[$4001+dir] shl 8);
  valor:=data and $1f;
  color.r:=(valor shl 3) or (valor shr 2);
  valor:=(data shr 5) and $1f;
  color.g:=(valor shl 3) or (valor shr 2);
  valor:=(data shr 10) and $1f;
  color.b:=(valor shl 3) or (valor shr 2);
  poner_color(color,addr(paleta[dir shr 1]));
  case (dir shr 1) of
    256..511:fillmemory(@gfx[0].buffer[0],$400,1);
  end;
end;

procedure sound_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion>$7fff then exit;
mem_snd[direccion]:=valor;
case direccion of
  $2000:ym2151_register_port_write(0,valor);
  $2001:YM2151_data_port_write(0,valor);
  $4000..$43ff:cambiar_color(direccion and $3fe);
  $6060..$7fff:memoria[direccion-$6000]:=valor;
end;
end;

procedure sound_instruccion;pascal;
var
  salida:array[0..2] of integer;
  audio:pinteger;
begin
if hay_sonido then begin
  audio:=ym2151UpdateOne(0);
  copymemory(@salida[0],audio,3*sizeof(integer));
  tsample[0][posicion_sonido]:=salida[1];
  inc(posicion_sonido);
  tsample[0][posicion_sonido]:=salida[2];
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
