unit karnov_hw;

interface
uses sdl,z80,m68000,constantes,windows,entradas,arcade_const,timers,dialogs,sysutils;

procedure Cargar_snowbros;
procedure snowbros_principal;pascal;
function snowbros_getword(direccion:dword):word;pascal;
procedure snowbros_putword(direccion:dword;valor:word);pascal;
function snowbros_getbyte(direccion:dword):byte;pascal;
procedure snowbros_putbyte(direccion:dword;valor:byte);pascal;
function iniciar_snowbros:boolean;pascal;
procedure reset_snowbros;pascal;
procedure cerrar_snowbros;pascal;
function snowbros_snd_getbyte(direccion:word): Byte; pascal;
procedure snowbros_snd_putbyte(direccion:word;valor:byte);pascal;
procedure snowbros_sound_act;pascal;
function snowbros_snd_inbyte(puerto:word):byte;pascal;
procedure snowbros_snd_outbyte(valor:byte;puerto:word);pascal;

const
        snowbros_rom:array[0..2] of tipo_roms=(
        (n:'sn6.bin';l:$20000;p:0),(n:'sn5.bin';l:$20000;p:$1),(n:'';l:0;p:0));
        snowbros_char:tipo_roms=(n:'sbros-1.41';l:$80000;p:0);
        snowbros_sound:tipo_roms=(n:'sbros-4.29';l:$8000;p:0);

var
 rom:array[0..$3ffff] of byte;
 ram:array[0..$3fff] of byte;
 sprite_ram:array[0..$1dff] of byte;
 palete_ram:array[0..$1ff] of byte;
 sound_latch:byte;

implementation
uses principal;

procedure Cargar_snowbros;
begin
form1.snowbros1.Checked:=true;
llamadas_maquina.caption:='Snow Bros';
llamadas_maquina.iniciar:=iniciar_snowbros;
llamadas_maquina.bucle_general:=snowbros_principal;
llamadas_maquina.cerrar:=cerrar_snowbros;
llamadas_maquina.reset:=reset_snowbros;
llamadas_maquina.canales_usados:=3;
llamadas_maquina.fps_max:=57.5;
end;

function iniciar_snowbros:boolean;pascal;
const
  pc_x:array[0..15] of dword=(0, 4, 8, 12, 16, 20, 24, 28,
		8*32+0, 8*32+4, 8*32+8, 8*32+12, 8*32+16, 8*32+20, 8*32+24, 8*32+28);
  pc_y:array[0..15] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32,
		16*32, 17*32, 18*32, 19*32, 20*32, 21*32, 22*32, 23*32);
begin
iniciar_snowbros:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=224;
p_final[1].x:=512;
p_final[1].y:=512;
p_final[1].trans:=true;
iniciar_video;
//cargar roms
if not(cargar_roms16b(@rom[0],@snowbros_rom[0],'\snowbros.zip',0)) then exit;
//cargar sonido
if not(cargar_roms(@mem_snd[0],@snowbros_sound,'\snowbros.zip',1)) then exit;
//Main CPU
init_cpu(m68000_main,0,(8000000/llamadas_maquina.fps_max/3));
main_68000_ll.getword:=snowbros_getword;
main_68000_ll.putword:=snowbros_putword;
main_68000_ll.getbyte:=snowbros_getbyte;
main_68000_ll.putbyte:=snowbros_putbyte;
//Sound CPU
init_cpu(z80_snd,1,(6000000/llamadas_maquina.fps_max/3));
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=snowbros_snd_getbyte;
snd_z80_ll.putbyte:=snowbros_snd_putbyte;
snd_z80_ll.outbyte:=snowbros_snd_outbyte;
snd_z80_ll.inbyte:=snowbros_snd_inbyte;
{//Sound Chips
YM2203_Init(0,4000000,2,nil,nil,nil,nil);
dac_start(0);
dac_start(1);
//Timers
init_timer(0,1,4000000/44100,snowbros_sound_act,true);}
//convertir chars
if not(cargar_roms(@memoria_temp[0],@snowbros_char,'\snowbros.zip',1)) then exit;
init_gfx(0,16,16,4096);
gfx[0].trans[0]:=true;
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=1;
des_sprites.pos_planos[2]:=2;
des_sprites.pos_planos[3]:=3;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=32*32;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//final
reset_snowbros;
iniciar_snowbros:=true;
end;

procedure update_video_snowbros;
var
        f:word;
        color:word;
        sx,sy,x,y,nchar,atrib:word;
begin
pintar_pantalla(1,0);
for f:=0 to $1df do begin
  sx:=sprite_ram[(f*16)+9];
	sy:=sprite_ram[(f*16)+$b];
  color:=sprite_ram[(f*16)+7];
  if (color and 4)<>0 then begin
    if (color and 2)<>0 then y:=y-(256-sy)
      else y:=y+sy;
  if (color and 1)<>0 then x:=x-(256-sx)
      else x:=x+sx;
  end else begin
    if (color and 2)<>0 then y:=sy-256
      else y:=sy;
    if (color and 1)<>0 then x:=sx-256
      else x:=sx;
  end;
  atrib:=sprite_ram[(f*16)+$f];
  nchar:=((atrib and $0f) shl 8)+(sprite_ram[(f*16)+$d] and $ff);
  put_gfx_sprite(nchar,(color and $f0),(atrib and $80)<>0,(atrib and $40)<>0,0);
  actualiza_gfx_sprite(x and $1ff,y and $1ff,1,0);
end;
actualiza_trozo(0,16,256,224,1,0,0,256,224,0);
//actualiza_trozo(0,0,512,512,1,0,0,512,512,0);
end;

procedure eventos_snowbros;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in1:=(in1 and $Fd) else in1:=(in1 or $2);
  if (teclado[SDLK_LEFT] or joystick.izq) then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if (teclado[SDLK_RIGHT] or joystick.der) then in1:=(in1 and $F7) else in1:=(in1 or $8);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 and $df) else in1:=(in1 or $20);
  if teclado[SDLK_5] then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if teclado[SDLK_1] then in0:=(in0 and $fe) else in0:=(in0 or $1);
end;
end;

procedure cerrar_snowbros;pascal;
begin
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_snowbros;pascal;
begin
 reset_68000(main_68000,main_68000_ll);
 //reset_z80(snd_z80);
 reset_audio;
 zeromemory(@ram[$0],$4000);
 //zeromemory(@mem_snd[$8000],$c000);
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 sound_latch:=0;
end;

procedure snowbros_principal;pascal;
var
  frame_m,frame_s:single;
  f:byte;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
 for f:=0 to 2 do begin
  frame_m:=frame_m+main_68000.tframes;
  run_68000(main_68000,main_68000_ll,trunc(frame_m));
  frame_m:=frame_m-main_68000.contador;
  main_68000.contador:=0;
  {frame_s:=frame_s+snd_z80.tframes;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_s:=frame_s-snd_z80.contador;
  snd_z80.contador:=0;}
  pedir_irq_68000(main_68000,4-f);
 end;
 update_video_snowbros;
 actualiza_video;
 eventos_snowbros;
 sincronizar;
 evaluar_entradas;
end;
end;

procedure cambiar_color(tmp_color,numero:word);
var
        bit0:byte;
        color:tcolor;
begin
  bit0:=(tmp_color shr 10) and $1f;
  color.b:=(bit0 shl 3) or (bit0 shr 2);
  bit0:=(tmp_color shr 5) and $1f;
  color.g:=(bit0 shl 3) or (bit0 shr 2);
  bit0:=tmp_color and $1f;
  color.r:=(bit0 shl 3) or (bit0 shr 2);
  poner_color(color,addr(paleta[numero]));
end;

function snowbros_getword(direccion:dword):word;pascal;
begin
direccion:=direccion and $fffffff;
snowbros_getword:=snowbros_getbyte(direccion+1) or (snowbros_getbyte(direccion) shl 8);
end;

procedure snowbros_putword(direccion:dword;valor:word);pascal;
begin
direccion:=direccion and $fffffff;
  case direccion of
    $600000..$6001ff:begin
                      palete_ram[direccion-$600000]:=valor;
                      cambiar_color(valor,((direccion and $1ff) div 2));
                   end;
  else begin
    snowbros_putbyte(direccion,valor shr 8);
    snowbros_putbyte(direccion+1,valor and $ff);
  end;
  end;
end;

function snowbros_getbyte(direccion:dword):byte;
begin
direccion:=direccion and $fffffff;
case direccion of
  0..$3ffff:snowbros_getbyte:=rom[direccion];
  $100000..$103fff:snowbros_getbyte:=ram[direccion-$100000];
  $300000:snowbros_getbyte:=0;
  $300001:snowbros_getbyte:=3;
  $500000,$500002:snowbros_getbyte:=$7f;
  $500001:snowbros_getbyte:=$fe;
  $500003,$500004:snowbros_getbyte:=$ff;
  $500005:snowbros_getbyte:=0;
  $600000..$6001ff:snowbros_getbyte:=palete_ram[direccion and $1ff];
  $700000..$701dff:snowbros_getbyte:=sprite_ram[direccion-$700000];
end;
end;

procedure snowbros_putbyte(direccion:dword;valor:byte);
begin
direccion:=direccion and $fffffff;
case direccion of
  0..$3ffff:exit;
  $100000..$103fff:begin
                      ram[direccion-$100000]:=valor;
  end;
  $300001:begin
            sound_latch:=valor;
            snd_z80.pedir_nmi:=true;
          end;
  $600000..$6001ff:begin
                      palete_ram[direccion and $1ff]:=valor;
                      cambiar_color((palete_ram[(direccion and $1fe)] shl 8)+palete_ram[(direccion and $1fe)+1],((direccion and $1fe) div 2));
                   end;
  $700000..$701dff:sprite_ram[direccion-$700000]:=valor;
  $800001:main_68000.irq[4]:=false;
  $900001:main_68000.irq[3]:=false;
  $a00001:main_68000.irq[2]:=false;
end;
end;

function snowbros_snd_getbyte(direccion:word): Byte; pascal;
begin
snowbros_snd_getbyte:=mem_snd[direccion];
end;

procedure snowbros_snd_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$8000 then exit
  else mem_snd[direccion]:=valor;
end;

function snowbros_snd_inbyte(puerto:word):byte;pascal;
begin
  case (puerto and $ff) of
  4:snowbros_snd_inbyte:=sound_latch;
  end;
end;

procedure snowbros_snd_outbyte(valor:byte;puerto:word);pascal;
begin
case (puerto and $ff) of
  4:sound_latch:=valor;
end;
end;

procedure snowbros_sound_act;pascal;
begin
if hay_sonido then begin
{  tsample[0][posicion_sonido]:=ym2203UpdateOne(0);
  tsample[1][posicion_sonido]:=DAC_update(0);
  tsample[2][posicion_sonido]:=DAC_update(1);}
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
