unit kungfumaster;
interface
uses sysutils,sdl,z80,constantes,windows,entradas,ay_8910,arcade_const,timers;

procedure Cargar_kungfum;
procedure kungfum_principal;pascal;
function kungfum_getbyte(direccion:word): Byte; pascal;
procedure kungfum_putbyte(direccion:word;valor:byte);pascal;
function kungfum_inbyte(puerto:word):byte;pascal;
procedure kungfum_outbyte(valor:byte;puerto:word);pascal;
function iniciar_kungfum:boolean;pascal;
procedure reset_kungfum;pascal;
procedure cerrar_kungfum;pascal;

const
        kungfum_rom:array[0..2] of tipo_roms=(
        (n:'a-4e-c.bin';l:$4000;p:0),(n:'a-4d-c.bin';l:$4000;p:$4000),
        (n:'';l:0;p:0));
        kungfum_pal:array[0..7] of tipo_roms=(
        (n:'g-1j-.bin';l:$100;p:0),(n:'g-1f-.bin';l:$100;p:$100),
        (n:'g-1h-.bin';l:$100;p:$200),(n:'b-1m-.bin';l:$100;p:$300),
        (n:'b-1n-.bin';l:$100;p:$400),(n:'b-1l-.bin';l:$100;p:$500),
        (n:'b-5f-.bin';l:$20;p:$600),(n:'';l:0;p:0));
        kungfum_char:array[0..3] of tipo_roms=(
        (n:'g-4c-a.bin';l:$2000;p:0),(n:'g-4d-a.bin';l:$2000;p:$2000),
        (n:'g-4e-a.bin';l:$2000;p:$4000),(n:'';l:0;p:0));
        kungfum_sound:tipo_roms=(n:'1b';l:$1000;p:0);
        kungfum_sprites:array[0..12] of tipo_roms=(
        (n:'b-4k-.bin';l:$2000;p:0),(n:'b-4f-.bin';l:$2000;p:$2000),
        (n:'b-4l-.bin';l:$2000;p:$4000),(n:'b-4h-.bin';l:$2000;p:$6000),
        (n:'b-3n-.bin';l:$2000;p:$8000),(n:'b-4n-.bin';l:$2000;p:$a000),
        (n:'b-4m-.bin';l:$2000;p:$c000),(n:'b-3m-.bin';l:$2000;p:$e000),
        (n:'b-4c-.bin';l:$2000;p:$10000),(n:'b-4e-.bin';l:$2000;p:$12000),
        (n:'b-4d-.bin';l:$2000;p:$14000),(n:'b-4a-.bin';l:$2000;p:$16000),
        (n:'';l:0;p:0));
var
 sound_command:byte;
 scroll_x:parejas;
 memoria_sprites:array[0..$1f] of byte;

implementation
uses principal;

procedure Cargar_kungfum;
begin
form1.kungfum1.Checked:=true;
llamadas_maquina.caption:='Kung-Fu Master';
llamadas_maquina.iniciar:=iniciar_kungfum;
llamadas_maquina.bucle_general:=kungfum_principal;
llamadas_maquina.cerrar:=cerrar_kungfum;
llamadas_maquina.reset:=reset_kungfum;
llamadas_maquina.fps_max:=55;
llamadas_maquina.canales_usados:=2;
end;

procedure update_video_kungfum;
var
  f,nchar,y,x,color:word;
  i:byte;
begin
for f:=0 to $7ff do begin
  if gfx[0].buffer[f] then begin
    x:=f mod 64;
    y:=f div 64;
    color:=memoria[$d800+f] and $1f;
    nchar:=memoria[$d000+f]+((memoria[$d800+f] and $c0) shl 2);
    put_gfx_flip(x*8,y*8,nchar,color shl 3,1,0,(memoria[$d800+f] and $20)<>0,false);
    if ((y<6) or not((color shr 1)>$0c)) then put_gfx_trans(x*8,y*8,0,0,3,0)
      else put_gfx_trans_flip(x*8,y*8,nchar,color shl 3,3,0,(memoria[$d800+f] and $20)<>0,false);
    gfx[0].buffer[f]:=false;
  end;
end;
scroll__x(1,2,scroll_x.w);
//Sprites
for f:=0 to $1f do begin
  nchar:=memoria[$c004+(f*8)]+((memoria[$c005+(f*8)] and $07) shl 8);
  color:=(memoria[$c000+(f*8)] and $1f) shl 3;
  x:=256*(memoria[$c007+(f*8)] and 1)+memoria[$c006+(f*8)];
  y:=256+128-15-(256*(memoria[$c003+(f*8)] and 1)+memoria[$c002+(f*8)]);
  i:=memoria_sprites[(nchar shr 5) and $1f];
  case i of
    1:begin //doble
       y:=y-16;
       //Cojo el sprite base
       nchar:=nchar and $fffe;
      end;
    2:begin //Cuadruple
       i:=3;
			 nchar:=nchar and $fffc;
			 y:=y-3*16;
      end;
  end;
  while (i<>$ff) do begin
    put_gfx_sprite(nchar+i,color+256,memoria[$c005+(f*8)] and $40<>0,memoria[$c005+(f*8)] and $80<>0,1);
    actualiza_gfx_sprite(x,y+(16*i),2,1);
    i:=i-1;
  end;
end;
//La parte de arriba tiene prioridad sobre los sprites?
scroll__x(3,2,scroll_x.w);
actualiza_trozo(0,0,512,48,1,0,0,512,48,2);
actualiza_trozo(128,0,256,256,2,0,0,256,256,0);
end;

procedure eventos_kungfum;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if (teclado[SDLK_LEFT] or joystick.izq) then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if (teclado[SDLK_RIGHT] or joystick.der) then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $7f) else in1:=(in1 or $80);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 and $df) else in1:=(in1 or $20);
  if teclado[SDLK_5] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if teclado[SDLK_1] then in0:=(in0 and $fe) else in0:=(in0 or $1);
end;
end;

procedure cerrar_kungfum;pascal;
begin
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_kungfum;pascal;
begin
 reset_z80(main_z80);
 reset_audio;
 zeromemory(@memoria[$8000],$7FFF);
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
end;

function iniciar_kungfum:boolean;pascal;
var
      colores:tpaleta;
      f:word;
      ctemp1,ctemp2,ctemp3,ctemp4:byte;
const
  ps_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			16*8+0, 16*8+1, 16*8+2, 16*8+3, 16*8+4, 16*8+5, 16*8+6, 16*8+7);
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
begin
iniciar_kungfum:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=256;
p_final[1].x:=512;
p_final[1].y:=256;
p_final[2].x:=512;
p_final[2].y:=256;
p_final[3].x:=512;
p_final[3].y:=256;
p_final[3].trans:=true;
iniciar_video;
//datos scroll
scroll_data.long_x:=512;
scroll_data.ad_x:=128;
scroll_data.max_x:=256+128;
scroll_data.max_scr_x:=255;
//Main CPU
init_cpu(z80_main,0,3072000/llamadas_maquina.fps_max);
main_z80.daisy:=false;
main_z80_ll.getbyte:=kungfum_getbyte;
main_z80_ll.putbyte:=kungfum_putbyte;
main_z80_ll.outbyte:=kungfum_outbyte;
main_z80_ll.inbyte:=kungfum_inbyte;
//cargar roms
if not(cargar_roms(@memoria[0],@kungfum_rom[0],'\kungfum.zip',0)) then exit;
//Inmunidad
//memoria[$E709]:=$44;
//cargar sonido
//if not(cargar_roms(@mem_snd[0],@kungfum_sound,'\kungfum.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@kungfum_char[0],'\kungfum.zip',0)) then exit;
init_gfx(0,8,8,1024);
gfx[0].trans[0]:=true;
des_sprites.pos_planos[0]:=2*1024*8*8;
des_sprites.pos_planos[1]:=1024*8*8;
des_sprites.pos_planos[2]:=0;
des_sprites.bit_pixel:=3;
des_sprites.banks:=0;
des_sprites.long_sprites:=8*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@kungfum_sprites[0],'\kungfum.zip',0)) then exit;
init_gfx(1,16,16,1024);
gfx[1].trans[0]:=true;
des_sprites.pos_planos[0]:=2*1024*32*8;
des_sprites.pos_planos[1]:=1024*32*8;
des_sprites.pos_planos[2]:=0;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//poner la paleta
if not(cargar_roms(@memoria_temp[0],@kungfum_pal[0],'\kungfum.zip',0)) then exit;
for f:=0 to 255 do begin
  //Chars
  ctemp1:=(memoria_temp[f] shr 0) and 1;
  ctemp2:=(memoria_temp[f] shr 1) and 1;
  ctemp3:=(memoria_temp[f] shr 2) and 1;
  ctemp4:=(memoria_temp[f] shr 3) and 1;
  colores[f].r:=$0e*ctemp1+$1f*ctemp2+$43*ctemp3+$8f*ctemp4;
  ctemp1:=(memoria_temp[f+$100] shr 0) and 1;
  ctemp2:=(memoria_temp[f+$100] shr 1) and 1;
  ctemp3:=(memoria_temp[f+$100] shr 2) and 1;
  ctemp4:=(memoria_temp[f+$100] shr 3) and 1;
  colores[f].g:=$0e*ctemp1+$1f*ctemp2+$43*ctemp3+$8f*ctemp4;
  ctemp1:=(memoria_temp[f+$200] shr 0) and 1;
  ctemp2:=(memoria_temp[f+$200] shr 1) and 1;
  ctemp3:=(memoria_temp[f+$200] shr 2) and 1;
  ctemp4:=(memoria_temp[f+$200] shr 3) and 1;
  colores[f].b:=$0e*ctemp1+$1f*ctemp2+$43*ctemp3+$8f*ctemp4;
  //Sprites
  ctemp1:=(memoria_temp[f+$300] shr 0) and 1;
  ctemp2:=(memoria_temp[f+$300] shr 1) and 1;
  ctemp3:=(memoria_temp[f+$300] shr 2) and 1;
  ctemp4:=(memoria_temp[f+$300] shr 3) and 1;
  colores[f+$100].r:=$0e*ctemp1+$1f*ctemp2+$43*ctemp3+$8f*ctemp4;
  ctemp1:=(memoria_temp[f+$400] shr 0) and 1;
  ctemp2:=(memoria_temp[f+$400] shr 1) and 1;
  ctemp3:=(memoria_temp[f+$400] shr 2) and 1;
  ctemp4:=(memoria_temp[f+$400] shr 3) and 1;
  colores[f+$100].g:=$0e*ctemp1+$1f*ctemp2+$43*ctemp3+$8f*ctemp4;
  ctemp1:=(memoria_temp[f+$500] shr 0) and 1;
  ctemp2:=(memoria_temp[f+$500] shr 1) and 1;
  ctemp3:=(memoria_temp[f+$500] shr 2) and 1;
  ctemp4:=(memoria_temp[f+$500] shr 3) and 1;
  colores[f+$100].b:=$0e*ctemp1+$1f*ctemp2+$43*ctemp3+$8f*ctemp4;
end;
poner_paleta(colores,512);
copymemory(@memoria_sprites[0],@memoria_temp[$600],$20);
//final
reset_kungfum;
iniciar_kungfum:=true;
end;

procedure kungfum_principal;pascal;
var
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
  frame_m:=frame_m+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame_m));
  main_z80.pedir_irq:=true;
  frame_m:=frame_m-main_z80.contador;
  main_z80.contador:=0;
  update_video_kungfum;
  actualiza_video;
  eventos_kungfum;
  sincronizar;
  evaluar_entradas;
end;
end;

function kungfum_getbyte(direccion:word): Byte; pascal;
begin
kungfum_getbyte:=memoria[direccion];
end;

procedure kungfum_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$8000 then exit;
memoria[direccion]:=valor;
case direccion of
    $a000:scroll_x.l:=valor;
    $b000:scroll_x.h:=(valor and 1);
    $d000..$dfff:gfx[0].buffer[direccion and $7ff]:=true;
end;
end;

function kungfum_inbyte(puerto:word):byte;pascal;
begin
case (puerto and $ff) of
  $0:kungfum_inbyte:=in0;
  $1:kungfum_inbyte:=in1;
  $2,$3:kungfum_inbyte:=$ff;
  $4:kungfum_inbyte:=$fd;
end;
end;

procedure kungfum_outbyte(valor:byte;puerto:word);pascal;
begin
case (puerto and $ff) of
  0:sound_command:=valor;
end;
end;

end.
