unit ladybug;

interface
uses sdl,z80,constantes,windows,sn_76496,entradas,arcade_const,timers;

procedure Cargar_ladybug;
procedure ladybug_principal;pascal;
function ladybug_getbyte(direccion:word): Byte; pascal;
procedure ladybug_putbyte(direccion:word;valor:byte);pascal;
function iniciar_ladybug:boolean;pascal;
procedure reset_ladybug;pascal;
procedure cerrar_ladybug;pascal;
procedure ladybug_sonido;pascal;

const
        ladybug_rom:array[0..6] of tipo_roms=(
        (n:'lb1.cpu';l:$1000;p:0),(n:'lb2.cpu';l:$1000;p:$1000),
        (n:'lb3.cpu';l:$1000;p:$2000),(n:'lb4.cpu';l:$1000;p:$3000),
        (n:'lb5.cpu';l:$1000;p:$4000),(n:'lb6.cpu';l:$1000;p:$5000),
        (n:'';l:0;p:0));
        ladybug_pal:array[0..2] of tipo_roms=(
        (n:'10-2.vid';l:$20;p:0),(n:'10-1.vid';l:$20;p:$20),
        (n:'';l:0;p:0));
        ladybug_char:array[0..2] of tipo_roms=(
        (n:'lb9.vid';l:$1000;p:0),(n:'lb10.vid';l:$1000;p:$1000),
        (n:'';l:0;p:0));
        ladybug_sprites:array[0..2] of tipo_roms=(
        (n:'lb8.cpu';l:$1000;p:0),(n:'lb7.cpu';l:$1000;p:$1000),
        (n:'';l:0;p:0));
var
 irq_vblank:boolean;
 memsprites:array[0..$3ff] of byte;

implementation
uses principal;

procedure Cargar_ladybug;
begin
form1.ladybug1.Checked:=true;
llamadas_maquina.caption:='Lady Bug';
llamadas_maquina.iniciar:=iniciar_ladybug;
llamadas_maquina.bucle_general:=ladybug_principal;
llamadas_maquina.cerrar:=cerrar_ladybug;
llamadas_maquina.reset:=reset_ladybug;
llamadas_maquina.fps_max:=60;
llamadas_maquina.canales_usados:=2;
end;

function iniciar_ladybug:boolean;pascal;
var
      colores:tpaleta;
      f:word;
      ctemp1,ctemp2,ctemp3,ctemp4:byte;
const
  ps_x:array[0..15] of dword=(0, 2, 4, 6, 8, 10, 12, 14,
			8*16+0, 8*16+2, 8*16+4, 8*16+6, 8*16+8, 8*16+10, 8*16+12, 8*16+14);
  ps_y:array[0..15] of dword=(23*16, 22*16, 21*16, 20*16, 19*16, 18*16, 17*16, 16*16,
			7*16, 6*16, 5*16, 4*16, 3*16, 2*16, 1*16, 0*16);
  pc_x:array[0..7] of dword=(7, 6, 5, 4, 3, 2, 1, 0);
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
  pss_x:array[0..7] of dword=(0, 2, 4, 6, 8, 10, 12, 14);
  pss_y:array[0..7] of dword=(7*16, 6*16, 5*16, 4*16, 3*16, 2*16, 1*16, 0*16);
begin
iniciar_ladybug:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=192;
p_final[0].y:=240;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[2].x:=256;
p_final[2].y:=256;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,(4000000/llamadas_maquina.fps_max)-2500);
main_z80.daisy:=false;
main_z80_ll.getbyte:=ladybug_getbyte;
main_z80_ll.putbyte:=ladybug_putbyte;
main_z80_ll.outbyte:=nil;
main_z80_ll.inbyte:=nil;
//Audio chips
SN76496_init(0,4000000);
SN76496_init(1,4000000);
//Timers
//Sampleado del sn76496
init_timer(0,0,4000000/44100,ladybug_sonido,true);
//cargar roms
if not(cargar_roms(@memoria[0],@ladybug_rom[0],'\ladybug.zip',0)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@ladybug_char[0],'\ladybug.zip',0)) then exit;
init_gfx(0,8,8,512);
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=512*8*8;
des_sprites.bit_pixel:=2;
des_sprites.banks:=0;
des_sprites.long_sprites:=8*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,true);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@ladybug_sprites[0],'\ladybug.zip',0)) then exit;
init_gfx(1,16,16,128);
gfx[1].trans[0]:=true;
des_sprites.pos_planos[0]:=1;
des_sprites.pos_planos[1]:=0;
des_sprites.long_sprites:=64*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,true);
//convetir sprites pequeos
init_gfx(2,8,8,512);
des_sprites.long_sprites:=16*8;
convert_sprites(@gfx[2],0,@memoria_temp[0],@pss_x[0],@pss_y[0],false,true);
//poner la paleta
if not(cargar_roms(@memoria_temp[0],@ladybug_pal[0],'\ladybug.zip',0)) then exit;
for f:=0 to 31 do begin
    ctemp1:=(not(memoria_temp[f]) shr 0) and 1;
    ctemp2:=(not(memoria_temp[f]) shr 5) and 1;
    colores[f].r:=$47*ctemp1+$97*ctemp2;
    ctemp1:=(not(memoria_temp[f]) shr 2) and 1;
    ctemp2:=(not(memoria_temp[f]) shr 6) and 1;
    colores[f].g:=$47*ctemp1+$97*ctemp2;
    ctemp1:=(not(memoria_temp[f]) shr 4) and 1;
    ctemp2:=(not(memoria_temp[f]) shr 7) and 1;
    colores[f].b:=$47*ctemp1+$97*ctemp2;
end;
poner_paleta(colores,$20);
for f:=0 to 7 do begin
		gfx[0].colores[4*f]:= 0;
		gfx[0].colores[4*f+1]:=f+$08;
		gfx[0].colores[4*f+2]:=f+$10;
		gfx[0].colores[4*f+3]:=f+$18;
end;
for f:=0 to 31 do begin
		// low 4 bits are for sprite n */
		ctemp1:= (memoria_temp[f+32] shr 3) and $01;
		ctemp2:= (memoria_temp[f+32] shr 2) and $01;
		ctemp3:= (memoria_temp[f+32] shr 1) and $01;
		ctemp4:= (memoria_temp[f+32] shr 0) and $01;
		gfx[1].colores[f+4*8]:=1*ctemp1+2*ctemp2+4*ctemp3+8*ctemp4;
		// high 4 bits are for sprite n + 8 */
		ctemp1:= (memoria_temp[f+32] shr 7) and $01;
		ctemp2:= (memoria_temp[f+32] shr 6) and $01;
		ctemp3:= (memoria_temp[f+32] shr 5) and $01;
		ctemp4:= (memoria_temp[f+32] shr 4) and $01;
		gfx[1].colores[f+4*16]:=1*ctemp1+2*ctemp2+4*ctemp3+8*ctemp4;
end;
//final
reset_ladybug;
iniciar_ladybug:=true;
end;

procedure update_video_ladybug;
var
        f,color,nchar:word;
        x,y,i:byte;
        flipx,flipy:boolean;
begin
for f:=$0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    x:=f div 32;
    y:=31-(f mod 32);
    nchar:=memoria[$d000+f]+(memoria[$d400+f] and $08) shl 5;
    color:=((memoria[$d400+f]) and $7) shl 2;
    put_gfx(x*8,y*8,nchar,color,2,0);
    gfx[0].buffer[f]:=false;
  end;
end;
actualiza_trozo(0,0,256,256,2,0,0,256,256,1);
f:=$400-2*$40;
while (f>=2*$40) do begin
    i:=0;
    f:=f-$40;
		while (i<$40) and (memsprites[f+i]<>0) do i:=i+4;
		while (i>0) do begin
			i:=i-4;
			if (memsprites[f+i] and $80)<>0 then begin
        color:=(memsprites[$2+f+i] and $f) shl 2;
        y:=240-(memsprites[$3+f+i]);
        flipy:=(memsprites[f+i] and $20)<>0;
        flipx:=(memsprites[f+i] and $10)<>0;
				if (memsprites[f+i] and $40)<>0	then begin // 16x16 */
              nchar:=(memsprites[$1+f+i] shr 2)+ 4*(memsprites[$2+f+i] and $10);
							x:=f div 4-8+(memsprites[f+i] and $f);
              put_gfx_sprite(nchar,color+32,flipx,flipy,1);
              actualiza_gfx_sprite(x,y,1,1);
				end else begin  //8x8 Parece ser que LB no usa los sprites pequeos!!!
					    nchar:=memsprites[$1+f+i]+16*(memsprites[$2+f+i] and $10);
							x:=f div 4+(memsprites[f+i] and $f);
              put_gfx_sprite(nchar,color+32,flipx,flipy,2);
							actualiza_gfx_sprite(x,y,1,2);
			  end;
     end;
	end;
end;
actualiza_trozo(32,8,192,240,1,0,0,192,240,0);
end;

procedure eventos_ladybug;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=(in0 and $F7) else in0:=(in0 or $8);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=(in0 and $Fb) else in0:=(in0 or $4);
  if teclado[SDLK_5] then main_z80.pedir_nmi:=true;
  if teclado[SDLK_1] then in0:=(in0 and $df) else in0:=(in0 or $20);
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=(in0 and $ef) else in0:=(in0 or $10);
end;
end;

procedure cerrar_ladybug;pascal;
begin
cerrar_cpus;
SN76496_close(0);
SN76496_close(1);
cerrar_audio;
cerrar_video;
end;

procedure reset_ladybug;pascal;
begin
 reset_z80(main_z80);
 reset_audio;
 zeromemory(@memoria[$6000],$a000);
 irq_vblank:=false;
 in0:=$FF;
 in1:=$3F;
end;

procedure ladybug_principal;pascal;
var
  frame:single;
begin
iniciar_entradas;
frame:=0;
while EmuStatus=EsRuning do begin
  in1:=(in1 and $3f) or $40;
  frame:=frame+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame));
  //Vblank
  in1:=(in1 and $3f) or $80;
  frame:=frame-main_z80.contador+2500;
  run_z80(main_z80,main_z80_ll,trunc(frame));
  frame:=frame-2500;
  main_z80.contador:=0;
  copymemory(@memsprites[0],@memoria[$7000],$400);
  update_video_ladybug;
  actualiza_video;
  eventos_ladybug;
  sincronizar;
  evaluar_entradas;
end;
end;

function ladybug_getbyte(direccion:word):Byte; pascal;
begin
case direccion of
        $9000:ladybug_getbyte:=in0;
        $9001:ladybug_getbyte:=in1;
        $9002:ladybug_getbyte:=$df;
        $9003:ladybug_getbyte:=$ff;
        $e000:ladybug_getbyte:=$ff;
        else ladybug_getbyte:=memoria[direccion];
end;
end;

procedure ladybug_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$6000 then exit;
memoria[direccion]:=valor;
case direccion of
        $b000..$bfff:SN76496Write(0,valor);
        $c000..$cfff:SN76496Write(1,valor);
        $d000..$dfff:gfx[0].buffer[direccion and $3ff]:=true;
end;
end;

procedure ladybug_sonido;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=SN76496Update(0);
  tsample[1][posicion_sonido]:=SN76496Update(1);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
