unit pooyan;

interface
uses sdl,z80,constantes,windows,entradas,arcade_const,timers;

procedure Cargar_pooyan;
procedure pooyan_principal;pascal;
function pooyan_getbyte(direccion:word): Byte; pascal;
procedure pooyan_putbyte(direccion:word;valor:byte);pascal;
function iniciar_pooyan:boolean;pascal;
procedure reset_pooyan;pascal;
procedure cerrar_pooyan;pascal;

const
        pooyan_rom:array[0..4] of tipo_roms=(
        (n:'1.4a';l:$2000;p:0),(n:'2.5a';l:$2000;p:$2000),(n:'3.6a';l:$2000;p:$4000),
        (n:'4.7a';l:$2000;p:$6000),(n:'';l:0;p:0));
        pooyan_pal:array[0..3] of tipo_roms=(
        (n:'pooyan.pr1';l:$20;p:0),(n:'pooyan.pr2';l:$100;p:$20),(n:'pooyan.pr3';l:$100;p:$120),
        (n:'';l:0;p:0));
        pooyan_char:array[0..2] of tipo_roms=(
        (n:'8.10g';l:$1000;p:0),(n:'7.9g';l:$1000;p:$1000),(n:'';l:0;p:0));
        pooyan_sound:array[0..2] of tipo_roms=(
        (n:'xx.7a';l:$1000;p:0),(n:'xx.8a';l:$1000;p:$1000),(n:'';l:0;p:0));
        pooyan_sprites:array[0..2] of tipo_roms=(
        (n:'6.9a';l:$1000;p:0),(n:'5.8a';l:$1000;p:$1000),(n:'';l:0;p:0));
var
 nmi_vblank:boolean;
 last:byte;

implementation
uses principal,konami_snd;

procedure Cargar_pooyan;
begin
form1.pooyan1.Checked:=true;
llamadas_maquina.caption:='Pooyan';
llamadas_maquina.iniciar:=iniciar_pooyan;
llamadas_maquina.bucle_general:=pooyan_principal;
llamadas_maquina.cerrar:=cerrar_pooyan;
llamadas_maquina.reset:=reset_pooyan;
llamadas_maquina.fps_max:=60;
llamadas_maquina.canales_usados:=2;
end;

procedure update_video_pooyan;
var
        f:word;
        x,y,color,nchar:byte;
begin
for f:=$0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    x:=31-(f div 32);
    y:=f mod 32;
    color:=((memoria[$8000+f]) and $f) shl 4;
    nchar:=memoria[$8400+f]+8*(memoria[$8000+f] and $20);
    put_gfx_flip(x*8,y*8,nchar,color,1,0,(memoria[$8000+f] and $80)<>0,(memoria[$8000+f] and $40)<>0);
    gfx[0].buffer[f]:=false;
  end;
end;
actualiza_trozo(0,0,256,256,1,0,0,256,256,2);
for f:=0 to $17 do begin
        nchar:=memoria[$9011+(f*2)] and $3f;
        color:=(memoria[$9410+(f*2)] and $f) shl 4;
        y:=memoria[$9010+(f*2)];
        x:=memoria[$9411+(f*2)];
        put_gfx_sprite(nchar,color,(memoria[$9410+(f*2)] and $80)<>0,(memoria[$9410+(f*2)] and $40)=0,1);
        actualiza_gfx_sprite(x,y,2,1);
end;
actualiza_trozo(16,0,224,256,2,0,0,224,256,0);
end;

procedure eventos_pooyan;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in1:=(in1 and $F7) else in1:=(in1 or $8);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if teclado[SDLK_5] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if teclado[SDLK_1] then in0:=(in0 and $f7) else in0:=(in0 or $8);
end;
end;

procedure cerrar_pooyan;pascal;
begin
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_pooyan;pascal;
begin
 reset_z80(main_z80);
 reset_z80(snd_z80);
 reset_audio;
 konamisnd_reset;
 zeromemory(@memoria[$8000],$7FFF);
 nmi_vblank:=false;
 last:=0;
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
end;

function iniciar_pooyan:boolean;pascal;
var
      colores:tpaleta;
      f:word;
      ctemp1:byte;
const
  ps_x:array[0..15] of dword=(0, 1, 2, 3,  8*8+0, 8*8+1, 8*8+2, 8*8+3,
			16*8+0, 16*8+1, 16*8+2, 16*8+3,  24*8+0, 24*8+1, 24*8+2, 24*8+3);
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			32*8, 33*8, 34*8, 35*8, 36*8, 37*8, 38*8, 39*8);
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 8*8+0,8*8+1,8*8+2,8*8+3);
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
begin
iniciar_pooyan:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[2].x:=256;
p_final[2].y:=256;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,(3072000/llamadas_maquina.fps_max)-2500);
main_z80.daisy:=false;
main_z80_ll.getbyte:=pooyan_getbyte;
main_z80_ll.putbyte:=pooyan_putbyte;
main_z80_ll.outbyte:=nil;
main_z80_ll.inbyte:=nil;
//Sound CPU
init_cpu(z80_snd,1,(1789772/llamadas_maquina.fps_max)-2500);
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=konamisnd_getbyte;
snd_z80_ll.putbyte:=konamisnd_putbyte;
snd_z80_ll.outbyte:=nil;
snd_z80_ll.inbyte:=nil;
//Sound Chip
konamisnd_init(4,1,1789772,konamisnd_despues_instruccion);
//cargar roms
if not(cargar_roms(@memoria[0],@pooyan_rom[0],'\pooyan.zip',0)) then exit;
//cargar sonido
if not(cargar_roms(@mem_snd[0],@pooyan_sound[0],'\pooyan.zip',0)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@pooyan_char[0],'\pooyan.zip',0)) then exit;
init_gfx(0,8,8,256);
des_sprites.pos_planos[0]:=$1000*8+4;
des_sprites.pos_planos[1]:=$1000*8+0;
des_sprites.pos_planos[2]:=4;
des_sprites.pos_planos[3]:=0;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=16*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@pooyan_sprites[0],'\pooyan.zip',0)) then exit;
init_gfx(1,16,16,64);
gfx[1].trans[0]:=true;
des_sprites.long_sprites:=64*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
//poner la paleta
if not(cargar_roms(@memoria_temp[0],@pooyan_pal[0],'\pooyan.zip',0)) then exit;
for f:=0 to 31 do begin
    ctemp1:=memoria_temp[f];
    colores[f].r:= $21*(ctemp1 and 1)+$47*((ctemp1 shr 1) and 1)+$97*((ctemp1 shr 2) and 1);
    colores[f].g:= $21*((ctemp1 shr 3) and 1)+$47*((ctemp1 shr 4) and 1)+$97*((ctemp1 shr 5) and 1);
    colores[f].b:= 0+$47*((ctemp1 shr 6) and 1)+$97*((ctemp1 shr 7) and 1);
end;
poner_paleta(colores,32);
for f:=0 to 255 do begin
  gfx[1].colores[f]:=memoria_temp[$20+f] and $f;
  gfx[0].colores[f]:=(memoria_temp[$120+f] and $f) + $10;
end;
//final
reset_pooyan;
iniciar_pooyan:=true;
end;

procedure pooyan_principal;pascal;
var
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
  frame_m:=frame_m+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame_m));
  main_z80.pedir_nmi:=nmi_vblank;
  frame_s:=frame_s+snd_z80.tframes;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  update_video_pooyan;
  //Vsync
  frame_m:=frame_m-main_z80.contador+2500;
  run_z80(main_z80,main_z80_ll,trunc(frame_m));
  frame_s:=frame_s-snd_z80.contador+2500;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_m:=frame_m-2500;
  frame_s:=frame_s-2500;
  main_z80.contador:=0;
  snd_z80.contador:=0;
  actualiza_video;
  eventos_pooyan;
  sincronizar;
  evaluar_entradas;
end;
end;

function pooyan_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $a000:pooyan_getbyte:=$7b;
  $a080:pooyan_getbyte:=in0;
  $a0a0:pooyan_getbyte:=in1;
  $a0c0:pooyan_getbyte:=in2;
  $a0e0:pooyan_getbyte:=$ff;
    else pooyan_getbyte:=memoria[direccion];
end;
end;

procedure pooyan_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$8000 then exit;
case direccion of
    $8000..$87ff:gfx[0].buffer[direccion and $3ff]:=true;
    $a100:konami_sl:=valor;
    $a180:nmi_vblank:=valor<>0;
    $a181:begin
              if ((last=0) and (valor<>0)) then snd_z80.pedir_irq:=true;
              last:=valor;
          end;
end;
memoria[direccion]:=valor;
end;

end.
