unit popeye;

interface
uses sdl,z80,constantes,windows,entradas,arcade_const,timers,ay_8910,sysutils;

procedure Cargar_popeye;
procedure popeye_principal;pascal;
function popeye_getbyte(direccion:word): Byte; pascal;
procedure popeye_putbyte(direccion:word;valor:byte);pascal;
function popeye_inbyte(puerto:word):byte;pascal;
procedure popeye_outbyte(valor:byte;puerto:word);pascal;
function iniciar_popeye:boolean;pascal;
procedure reset_popeye;pascal;
procedure cerrar_popeye;pascal;
procedure popeye_sonido;pascal;
function popeye_portar:byte;pascal;
procedure popeye_portbw(valor:byte);pascal;

const
        popeye_rom:array[0..4] of tipo_roms=(
        (n:'tpp2-c_f.7a';l:$2000;p:0),(n:'tpp2-c_f.7b';l:$2000;p:$2000),
        (n:'tpp2-c_f.7c';l:$2000;p:$4000),(n:'tpp2-c_f.7e';l:$2000;p:$6000),
        (n:'';l:0;p:0));
        popeye_pal:array[0..4] of tipo_roms=(
        (n:'prom-cpu.4a';l:$20;p:0),(n:'prom-cpu.3a';l:$20;p:$20),
        (n:'prom-cpu.5b';l:$100;p:$40),(n:'prom-cpu.5a';l:$100;p:$140),
        (n:'';l:0;p:0));
        popeye_char:tipo_roms=(n:'v-5n';l:$1000;p:0);
        popeye_sprites:array[0..4] of tipo_roms=(
        (n:'v-1e';l:$2000;p:0),(n:'v-1f';l:$2000;p:$2000),
        (n:'v-1j';l:$2000;p:$4000),(n:'v-1k';l:$2000;p:$6000),
        (n:'';l:0;p:0));

var
  prot0,prot1,prot_shift:integer;
  palette_bank:byte;
  popeye_mem_pal:array[0..$1f] of byte;
  fondo_write:array[0..$1fff] of boolean;
  scroll_x:parejas;
  scroll_y,dswbit:byte;

implementation
uses principal;

procedure Cargar_popeye;
begin
form1.popeye1.Checked:=true;
llamadas_maquina.caption:='Popeye';
llamadas_maquina.iniciar:=iniciar_popeye;
llamadas_maquina.bucle_general:=popeye_principal;
llamadas_maquina.cerrar:=cerrar_popeye;
llamadas_maquina.reset:=reset_popeye;
llamadas_maquina.fps_max:=60;
llamadas_maquina.canales_usados:=1;
end;

function iniciar_popeye:boolean;pascal;
var
      colores:tcolor;
      f,pos:word;
      ctemp1,ctemp2,ctemp3,ctemp4:byte;
      decode:array[0..$ffff] of byte;
const
  ps_x:array[0..15] of dword=(7+($2000*8),6+($2000*8),5+($2000*8),4+($2000*8),
     3+($2000*8),2+($2000*8),1+($2000*8),0+($2000*8),7,6,5,4,3,2,1,0);
  ps_y:array[0..15] of dword=(15*8, 14*8, 13*8, 12*8, 11*8, 10*8, 9*8, 8*8,
	  7*8, 6*8, 5*8, 4*8, 3*8, 2*8, 1*8, 0*8 );
  pc_x:array[0..15] of dword=(7,7, 6,6, 5,5, 4,4, 3,3, 2,2, 1,1, 0,0);
  pc_y:array[0..15] of dword=(0*8,0*8, 1*8,1*8, 2*8,2*8, 3*8,3*8, 4*8,4*8, 5*8,5*8, 6*8,6*8, 7*8,7*8);
begin
iniciar_popeye:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=512;
p_final[0].y:=448;
p_final[1].x:=512;
p_final[1].y:=512;
p_final[2].x:=512;
p_final[2].y:=512;
p_final[2].trans:=true;
p_final[3].x:=512;
p_final[3].y:=512;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,4000000/llamadas_maquina.fps_max);
main_z80.daisy:=false;
main_z80_ll.getbyte:=popeye_getbyte;
main_z80_ll.putbyte:=popeye_putbyte;
main_z80_ll.outbyte:=popeye_outbyte;
main_z80_ll.inbyte:=popeye_inbyte;
//Audio chips
AY8910_init(2000000,0,popeye_portar,nil,nil,popeye_portbw);
//Timers
init_timer(0,0,4000000/44100,popeye_sonido,true);
//cargar roms
if not(cargar_roms(@memoria[0],@popeye_rom[0],'\popeye.zip',0)) then exit;
//decode
for f:=0 to $ffff do begin
  pos:=bitswap16(f,15,14,13,12,11,10,8,7,6,3,9,5,4,2,1,0);
  ctemp1:=memoria[pos xor $3f];
  decode[f]:=bitswap8(ctemp1,3,4,2,5,1,6,0,7);
end;
copymemory(@memoria[0],@decode[0],$10000);
//convertir chars
if not(cargar_roms(@memoria_temp[0],@popeye_char,'\popeye.zip',1)) then exit;
init_gfx(0,16,16,256);
gfx[0].trans[0]:=true;
des_sprites.pos_planos[0]:=0;
des_sprites.bit_pixel:=1;
des_sprites.banks:=0;
des_sprites.long_sprites:=8*8;
convert_sprites(@gfx[0],0,@memoria_temp[$800],@pc_x[0],@pc_y[0],false,false);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@popeye_sprites[0],'\popeye.zip',0)) then exit;
init_gfx(1,16,16,512);
gfx[1].trans[0]:=true;
des_sprites.bit_pixel:=2;
des_sprites.banks:=2;
des_sprites.long_sprites:=16*8;
for f:=0 to 1 do begin
  des_sprites.pos_planos[0]:=0+(f*$1000*8);
  des_sprites.pos_planos[1]:=($4000+f*$1000)*8;
  convert_sprites(@gfx[1],256*f*16*16,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
end;
//poner la paleta chars
if not(cargar_roms(@memoria_temp[0],@popeye_pal[0],'\popeye.zip',0)) then exit;
copymemory(@popeye_mem_pal[0],@memoria_temp[0],$20);
for f:=0 to 15 do begin
		ctemp4:= f or ((f and 8) shl 1);	// address bits 3 and 4 are tied together */
		// red component */
		ctemp1:= ((memoria_temp[ctemp4+$20] xor $ff) shr 0) and $01;
		ctemp2:= ((memoria_temp[ctemp4+$20] xor $ff) shr 1) and $01;
		ctemp3:= ((memoria_temp[ctemp4+$20] xor $ff) shr 2) and $01;
		colores.r:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
		// green component */
		ctemp1:= ((memoria_temp[ctemp4+$20] xor $ff) shr 3) and $01;
		ctemp2:= ((memoria_temp[ctemp4+$20] xor $ff) shr 4) and $01;
		ctemp3:= ((memoria_temp[ctemp4+$20] xor $ff) shr 5) and $01;
		colores.g:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
		// blue component */
		ctemp1:= 0;
		ctemp2:= ((memoria_temp[ctemp4+$20] xor $ff) shr 6) and $01;
		ctemp3:= ((memoria_temp[ctemp4+$20] xor $ff) shr 7) and $01;
		colores.b:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
    poner_color(colores,addr(paleta[16+(2*f)+1]));
end;
//Poner la paleta sprites
ctemp4:=0;
for f:=0 to 255 do begin
		// red component */
		ctemp1:= ((memoria_temp[$40+ctemp4] xor $ff) shr 0) and $01;
		ctemp2:= ((memoria_temp[$40+ctemp4] xor $ff) shr 1) and $01;
		ctemp3:= ((memoria_temp[$40+ctemp4] xor $ff) shr 2) and $01;
		colores.r:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
		// green component */
		ctemp1:= ((memoria_temp[$40+ctemp4] xor $ff) shr 3) and $01;
		ctemp2:= ((memoria_temp[$140+ctemp4] xor $ff) shr 0) and $01;
		ctemp3:= ((memoria_temp[$140+ctemp4] xor $ff) shr 1) and $01;
		colores.g:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
		// blue component */
		ctemp1:=0;
		ctemp2:= ((memoria_temp[$140+ctemp4] xor $ff) shr 2) and $01;
		ctemp3:= ((memoria_temp[$140+ctemp4] xor $ff) shr 3) and $01;
		colores.b:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
    poner_color(colores,addr(paleta[48+f]));
    ctemp4:=ctemp4+1;
end;
//final
reset_popeye;
iniciar_popeye:=true;
end;

procedure update_video_popeye;
var
        f,color,nchar:word;
        x,y:word;
        sc_y,long_x:word;
        sc_x:integer;
        ptemp:pword;
begin
pintar_pantalla(3,0);
//Fondo con scroll (lo escribe directo)
for f:=0 to $1fff do begin
  sc_x:=8*(f mod 64);
  sc_y:=4*(f div 64);
  ptemp:=punbuf;
  if fondo_write[f] then begin
    for y:=0 to 7 do begin
      ptemp^:=paleta[memoria[f+$c000] and $0f];
      inc(ptemp);
    end;
    for y:=0 to 3 do putpixel(sc_x,sc_y+y,8,punbuf,1);
    fondo_write[f]:=false;
  end;
end;
sc_y:=2*(255-scroll_y);
sc_x:=199-scroll_x.w;
if sc_x<0 then sc_x:=512+sc_x;
long_x:=512-sc_x;
actualiza_trozo(sc_x,0,long_x,512-sc_y,1,0,sc_y,long_x,512-sc_y,3);
if sc_x<512 then actualiza_trozo(0,0,sc_x,512-sc_y,1,long_x,sc_y,long_x,512-sc_y,3);
//Sprites
for f:=0 to $9e do begin
  nchar:=((memoria[$8c06+f*4] and $7f)+((memoria[$8c07+f*4] and $10) shl 3)+((memoria[$8c07+f*4] and $04) shl 6)) xor $1ff;
  color:=((memoria[$8c07+f*4] and $7) + (palette_bank and $07) shl 3) shl 2;
  put_gfx_sprite(nchar,color+48,(memoria[$8c06+f*4] and $80)<>0,(memoria[$8c07+f*4] and $08)<>0,1);
  x:=2*(memoria[$8c04+f*4])-8;
  y:=2*(256-memoria[$8c05+f*4]);
  actualiza_gfx_sprite(x,y,3,1);
end;
//Chars
for f:=$0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    x:=f mod 32;
    y:=f div 32;
    nchar:=memoria[$a000+f];
    color:=((memoria[$a400+f]) and $f) shl 1;
    put_gfx_trans(x*16,y*16,nchar,color+16,2,0);
    gfx[0].buffer[f]:=false;
  end;
end;
actualiza_trozo(0,0,512,512,2,0,0,512,512,3);
actualiza_trozo(0,32,512,448,3,0,0,512,448,0);
end;

procedure eventos_popeye;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=(in0 or $4) else in0:=(in0 and $Fb);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=(in0 or $8) else in0:=(in0 and $F7);
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=(in0 or $2) else in0:=(in0 and $fd);
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=(in0 or $1) else in0:=(in0 and $fe);
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=(in0 or $10) else in0:=(in0 and $ef);
  if teclado[SDLK_5] then in2:=(in2 or $80) else in2:=(in2 and $7f);
  if teclado[SDLK_1] then in2:=(in2 or $4) else in2:=(in2 and $fb);
end;
end;

procedure cerrar_popeye;pascal;
begin
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure popeye_principal;pascal;
var
  frame:single;
begin
iniciar_entradas;
frame:=0;
while EmuStatus=EsRuning do begin
  frame:=frame+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame));
  frame:=frame-main_z80.contador;
  main_z80.contador:=0;
  main_z80.pedir_nmi:=(main_z80.i and 1)<>0;
  update_video_popeye;
  actualiza_video;
  eventos_popeye;
  sincronizar;
  evaluar_entradas;
end;
end;

function popeye_getbyte(direccion:word):Byte; pascal;
begin
case direccion of
        $e000:popeye_getbyte:=((prot1 shl prot_shift) or (prot0 shr (8-prot_shift))) and $ff;
        $e001:popeye_getbyte:=0;
        else popeye_getbyte:=memoria[direccion];
end;
end;

procedure cambiar_paleta(valor:byte);
var
  f,ctemp1,ctemp2,ctemp3,ctemp4:byte;
  colores:tcolor;
begin
  for f:=0 to 15 do begin
    ctemp4:=popeye_mem_pal[f+$10*valor];
		// red component */
		ctemp1:= ((ctemp4 xor $ff) shr 0) and $01;
		ctemp2:= ((ctemp4 xor $ff) shr 1) and $01;
		ctemp3:= ((ctemp4 xor $ff) shr 2) and $01;
		colores.r:=$1c*ctemp1+$31*ctemp2+$47*ctemp3;
		// green component */
		ctemp1:= ((ctemp4 xor $ff) shr 3) and $01;
		ctemp2:= ((ctemp4 xor $ff) shr 4) and $01;
		ctemp3:= ((ctemp4 xor $ff) shr 5) and $01;
		colores.g:=$1c*ctemp1+$31*ctemp2+$47*ctemp3;
		// blue component */
		ctemp1:= 0;
		ctemp2:= ((ctemp4 xor $ff) shr 6) and $01;
		ctemp3:= ((ctemp4 xor $ff) shr 7) and $01;
		colores.b:=$1c*ctemp1+$31*ctemp2+$47*ctemp3;
    poner_color(colores,addr(paleta[f]));
end;
    fillmemory(@fondo_write[0],$2000,1);
end;

procedure popeye_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$8000 then exit;
memoria[direccion]:=valor;
case direccion of
        $8c00:scroll_x.l:=valor;
        $8c01:scroll_y:=valor;
        $8c02:scroll_x.h:=valor;
        $8c03:if palette_bank<>valor then begin
                palette_bank:=valor;
                cambiar_paleta((valor shr 3) and 1);
        end;
        $a000..$a7ff:gfx[0].buffer[direccion and $3ff]:=true;
        $c000..$dfff:fondo_write[direccion and $1fff]:=true;
        $e000:prot_shift:=valor and $07;
        $e001:begin
                prot0:=prot1;
		            prot1:=valor;
              end;
end;
end;

procedure reset_popeye;pascal;
begin
 reset_z80(main_z80);
 reset_audio;
 AY8910_reset(0);
 zeromemory(@memoria[$8000],$8000);
 fillmemory(@fondo_write[0],$2000,1);
 in0:=0;
 in1:=0;
 in2:=0;
 palette_bank:=0;
 cambiar_paleta(0);
end;

function popeye_inbyte(puerto:word):byte;pascal;
begin
case (puerto and $ff) of
   0:popeye_inbyte:=in0;
   1:popeye_inbyte:=0;
   2:popeye_inbyte:=in2;
   3:popeye_inbyte:=Ayread(0);
end;
end;

procedure popeye_outbyte(valor:byte;puerto:word);pascal;
begin
case (puerto and $ff) of
  0:aycontrol(valor,0);
  1:aywrite(valor,0);
end;
end;

function popeye_portar:byte;pascal;
var
  res:byte;
begin
  res:=$0c or $40;
	res:=res or (($1 or $0c or $30) shl (7-dswbit)) and $80;
  popeye_portar:=res;
end;

procedure popeye_portbw(valor:byte);pascal;
begin
  dswbit:=valor shr 1;  //El bit que quiere leer
end;

procedure popeye_sonido;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=renderbyte(0)^;
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
