unit prehistoricisle;

interface
uses sdl,z80,m68000,constantes,windows,entradas,arcade_const,timers,ym_2203,dac,sysutils;

procedure Cargar_prehisle;
procedure prehisle_principal;pascal;
function prehisle_getword(direccion:dword):word;pascal;
procedure prehisle_putword(direccion:dword;valor:word);pascal;
function prehisle_getbyte(direccion:dword):byte;pascal;
procedure prehisle_putbyte(direccion:dword;valor:byte);pascal;
function iniciar_prehisle:boolean;pascal;
procedure reset_prehisle;pascal;
procedure cerrar_prehisle;pascal;

const
        prehisle_rom:array[0..2] of tipo_roms=(
        (n:'gt.2';l:$20000;p:0),(n:'gt.3';l:$20000;p:$1),(n:'';l:0;p:0));
        prehisle_char:tipo_roms=(n:'gt15.b15';l:$8000;p:0);
        prehisle_fondo_rom:tipo_roms=(n:'gt.11';l:$10000;p:0);
        prehisle_fondo1:tipo_roms=(n:'pi8914.b14';l:$40000;p:0);
        prehisle_fondo2:tipo_roms=(n:'pi8916.h16';l:$40000;p:0);
        {prehisle_sound:array[0..2] of tipo_roms=(
        (n:'tc2a_15b.bin';l:$4000;p:0),(n:'tc2a_17b.bin';l:$4000;p:$4000),(n:'';l:0;p:0));
        prehisle_fondo:array[0..2] of tipo_roms=(
        (n:'1a_15f.rom';l:$8000;p:0),(n:'1a_17f.rom';l:$8000;p:$8000),(n:'';l:0;p:0));}
        prehisle_sprites:array[0..2] of tipo_roms=(
        (n:'pi8910.k14';l:$80000;p:0),(n:'gt.5';l:$20000;p:$80000),(n:'';l:0;p:0));
var
 rom:array[0..$3ffff] of byte;
 ram:array[0..$3fff] of byte;
 fondo_rom:array[0..$ffff] of byte;
 video_ram,sprite_ram,palette_ram:array[0..$7ff] of byte;
 back_ram:array[0..$3fff] of byte;
 fondo1:boolean;
 scroll_x1,scroll_y1,scroll_x2,scroll_y2:parejas;

implementation
uses principal;

procedure Cargar_prehisle;
begin
form1.prehisle1.Checked:=true;
llamadas_maquina.caption:='Prehistoric Isle';
llamadas_maquina.iniciar:=iniciar_prehisle;
llamadas_maquina.bucle_general:=prehisle_principal;
llamadas_maquina.cerrar:=cerrar_prehisle;
llamadas_maquina.reset:=reset_prehisle;
llamadas_maquina.fps_max:=60;
llamadas_maquina.canales_usados:=3;
end;

function iniciar_prehisle:boolean;pascal;
const
  pf_x:array[0..15] of dword=(4, 0, 12, 8, 20, 16, 28, 24,
		32+4, 32+0, 32+12, 32+8, 32+20, 32+16, 32+28, 32+24);
  pf_y:array[0..15] of dword=(0*64, 1*64, 2*64, 3*64, 4*64, 5*64, 6*64, 7*64,
		8*64, 9*64, 10*64, 11*64, 12*64, 13*64, 14*64, 15*64);
  pc_x:array[0..7] of dword=(0, 4, 8, 12, 16, 20, 24, 28);
  pc_y:array[0..7] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32);
  ps_x:array[0..15] of dword=(0,4,8,12,16,20,24,28,
		0+64*8,4+64*8,8+64*8,12+64*8,16+64*8,20+64*8,24+64*8,28+64*8);
  ps_y:array[0..15] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32,
		8*32, 9*32, 10*32, 11*32, 12*32, 13*32, 14*32, 15*32 );
begin
iniciar_prehisle:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=224;
{p_final[0].x:=512;
p_final[0].y:=512;}
p_final[1].x:=512;
p_final[1].y:=512;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[2].trans:=true;
p_final[3].x:=256;
p_final[3].y:=256;
p_final[4].x:=16383;
p_final[4].y:=512;
p_final[5].x:=4096;
p_final[5].y:=512;
p_final[5].trans:=true;
iniciar_video;
//cargar roms
if not(cargar_roms16b(@rom[0],@prehisle_rom[0],'\prehisle.zip',0)) then exit;
//cargar sonido
//if not(cargar_roms(@mem_snd[0],@prehisle_sound[0],'\prehisle.zip',0)) then exit;
//Main CPU
init_cpu(m68000_main,0,(9000000/llamadas_maquina.fps_max/256));
main_68000_ll.getword:=prehisle_getword;
main_68000_ll.putword:=prehisle_putword;
main_68000_ll.getbyte:=prehisle_getbyte;
main_68000_ll.putbyte:=prehisle_putbyte;
//Sound CPU
{init_cpu(z80_snd,1,(4000000/llamadas_maquina.fps_max/z80irq));
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=prehisle_snd_getbyte;
snd_z80_ll.putbyte:=prehisle_snd_putbyte;
snd_z80_ll.outbyte:=prehisle_snd_outbyte;
snd_z80_ll.inbyte:=prehisle_snd_inbyte;
//Sound Chips
YM2203_Init(0,4000000,2,nil,nil,nil,nil);
dac_start(0);
dac_start(1);
//Timers
init_timer(0,1,4000000/44100,prehisle_sound_act,true);}
//convertir chars
if not(cargar_roms(@memoria_temp[0],@prehisle_char,'\prehisle.zip',1)) then exit;
init_gfx(0,8,8,1024);
gfx[0].trans[15]:=true;
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=1;
des_sprites.pos_planos[2]:=2;
des_sprites.pos_planos[3]:=3;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@prehisle_sprites,'\prehisle.zip',0)) then exit;
init_gfx(1,16,16,5120);
gfx[1].trans[15]:=true;
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=1;
des_sprites.pos_planos[2]:=2;
des_sprites.pos_planos[3]:=3;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=128*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//fondo 1
if not(cargar_roms(@fondo_rom[0],@prehisle_fondo_rom,'\prehisle.zip',1)) then exit;
if not(cargar_roms(@memoria_temp[0],@prehisle_fondo1,'\prehisle.zip',1)) then exit;
init_gfx(2,16,16,$800);
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=1;
des_sprites.pos_planos[2]:=2;
des_sprites.pos_planos[3]:=3;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=128*8;
convert_sprites(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//fondo2
if not(cargar_roms(@memoria_temp[0],@prehisle_fondo2,'\prehisle.zip',1)) then exit;
init_gfx(3,16,16,$800);
gfx[3].trans[15]:=true;
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=1;
des_sprites.pos_planos[2]:=2;
des_sprites.pos_planos[3]:=3;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=128*8;
convert_sprites(@gfx[3],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//final
reset_prehisle;
iniciar_prehisle:=true;
end;

procedure poner_fondo1;
var
  f,j:word;
  nchar,atrib,color:word;
  min,max,min2,max2:word;
begin
min:=scroll_x1.w div 16;
max:=((scroll_x1.w+256) div 16)+1;
min2:=scroll_y1.w div 16;
max2:=((scroll_y1.w+256) div 16)+1;
for j:=min to max do begin
  for f:=min2 to $1f do begin
	  atrib:=fondo_rom[(j*$20*2)+(f*2)+1]+(fondo_rom[(j*$20*2)+(f*2)] shl 8);
	  nchar:=atrib and $7ff;
	  color:=(atrib shr 8) and $f0;
    put_gfx_flip(j*16,f*16,nchar,color+768,4,2,(atrib and $800)<>0,false);
  end;
end;
fondo1:=false;
end;

procedure poner_sprites(pri:byte);
var
  f,atrib,nchar,color,x,y:word;
  prioridad:byte;
begin
for f:=0 to $ff do begin
		atrib:=(sprite_ram[(f*4)+4] shl 8)+sprite_ram[(f*4)+5];
		nchar:=atrib and $1fff;
    if nchar>$1400 then nchar:=0;
		color:=sprite_ram[(f*4)+6] shr 4;
		if (color<$4) then prioridad:=1
      else prioridad:=0;
		x:=(sprite_ram[(f*4)+2] shl 8)+sprite_ram[(f*4)+3];
		y:=(sprite_ram[(f*4)] shl 8)+sprite_ram[(f*4)+1];
    if (x and $200)<>0 then
      x:=(-$ff-(x and $ff)) and $ff;
    if (y and $200)<>0 then
      y:=(-$ff-(y and $ff)) and $ff;
		if ((pri and prioridad) or (not(pri) and not(prioridad)))<>0 then begin
      put_gfx_sprite(nchar,256+(color shl 4),(atrib and $4000)<>0,(atrib and $8000)<>0,1);
      actualiza_gfx_sprite(x,y,1,1);
    end;
end;
end;

procedure update_video_prehisle;
var
        f:word;
        color:word;
        x,y,nchar,atrib:word;
begin
//backgorund 1
if fondo1 then poner_fondo1;
if scroll_y1.w<256 then begin
  actualiza_trozo(scroll_x1.w,scroll_y1.w,256,256,4,0,0,256,256,1);
  end else begin
    actualiza_trozo(scroll_x1.w,scroll_y1.w,256,512-scroll_y1.w,4,0,0,256,512-scroll_y1.w,1);
    actualiza_trozo(scroll_x1.w,0,256,256-(512-scroll_y1.w),4,0,512-scroll_y1.w,256,256-(512-scroll_y1.w),1)
  end;
poner_sprites(0);
//background 2
for f:=$0 to $1fff do begin
  if gfx[3].buffer[f] then begin
    x:=f div 32;
    y:=f div 256;
    atrib:=(back_ram[(f*2)] shl 8)+back_ram[1+(f*2)];
    nchar:=atrib and $7ff;
    color:=(atrib shr 8) and $f0;
    put_gfx_trans(x*16,y*16,nchar,512+color,5,3);
    gfx[3].buffer[f]:=false;
  end;
end;
actualiza_trozo(scroll_x2.w,scroll_y2.w,256,256,5,0,0,256,256,1);
//actualiza_trozo(0,0,512,512,5,0,0,512,512,0);
poner_sprites(1);
//foreground
for f:=$0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    x:=f mod 32;
    y:=f div 32;
    atrib:=(video_ram[(f*2)] shl 8)+video_ram[1+(f*2)];
    nchar:=atrib and $3ff;
    color:=(atrib shr 8) and $f0;
    put_gfx_trans(x*8,y*8,nchar,color,2,0);
    gfx[0].buffer[f]:=false;
  end;
end;
actualiza_trozo(0,0,256,256,2,0,0,256,256,1);
actualiza_trozo(0,16,256,224,1,0,0,256,224,0);
//actualiza_trozo(0,0,1024,512,4,0,0,1024,512,0);
end;

procedure eventos_prehisle;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in1:=(in1 and $Fd) else in1:=(in1 or $2);
  if (teclado[SDLK_LEFT] or joystick.izq) then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if (teclado[SDLK_RIGHT] or joystick.der) then in1:=(in1 and $F7) else in1:=(in1 or $8);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 and $df) else in1:=(in1 or $20);
  if teclado[SDLK_5] then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if teclado[SDLK_1] then in0:=(in0 and $fe) else in0:=(in0 or $1);
end;
end;

procedure cerrar_prehisle;pascal;
begin
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_prehisle;pascal;
begin
 reset_68000(main_68000,main_68000_ll);
 reset_audio;
 zeromemory(@ram[$0],$4000);
 in0:=$FF;
 in1:=$FF;
 in2:=$7F;
 fondo1:=true;
end;

procedure prehisle_principal;pascal;
var
  frame_m,frame_s:single;
  f:byte;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
 for f:=0 to $ff do begin
   frame_m:=frame_m+main_68000.tframes;
   run_68000(main_68000,main_68000_ll,trunc(frame_m));
   frame_m:=frame_m-main_68000.contador;
   main_68000.contador:=0;
   if f=239 then begin
    in2:=$ff;
    if main_68000.cc.im<4 then pedir_irq_68000(main_68000,4); //???????
   end;
 end;
 update_video_prehisle;
 in2:=$7f;
 actualiza_video;
 eventos_prehisle;
 sincronizar;
 evaluar_entradas;
 //form1.statusbar1.Panels[2].Text:=inttostr(scroll_x2.w)+' - '+inttostr(scroll_y2.w);
end;
end;

procedure cambiar_color(tmp_color,numero:word);
var
        bit0,bit1,bit2,bit3:byte;
        color:tcolor;
begin
  bit0:=(tmp_color shr 12) and 1;
  bit1:=(tmp_color shr 13) and 1;
  bit2:=(tmp_color shr 14) and 1;
  bit3:=(tmp_color shr 15) and 1;
  color.r:=$0e*bit0+$1f*bit1+$43*bit2+$8f*bit3;
  bit0:=(tmp_color shr 8) and 1;
  bit1:=(tmp_color shr 9) and 1;
  bit2:=(tmp_color shr 10) and 1;
  bit3:=(tmp_color shr 11) and 1;
  color.g:=$0e*bit0+$1f*bit1+$43*bit2+$8f*bit3;
  bit0:=(tmp_color shr 4) and 1;
  bit1:=(tmp_color shr 5) and 1;
  bit2:=(tmp_color shr 6) and 1;
  bit3:=(tmp_color shr 7) and 1;
  color.b:=$0e*bit0+$1f*bit1+$43*bit2+$8f*bit3;
  poner_color(color,addr(paleta[numero]));
  case numero of
    0..255:fillmemory(@gfx[0].buffer[0],$400,1);
    512..767:fillmemory(@gfx[3].buffer[0],$2000,1);
    768..1023:fondo1:=true;
  end;
end;

function prehisle_getword(direccion:dword):word;pascal;
var
  valor:word;
begin
case direccion of
  $0..$3ffff:valor:=rom[direccion+1] or (rom[direccion] shl 8);
  $90000..$907ff:valor:=video_ram[(direccion and $7ff)+1] or (video_ram[direccion and $7ff] shl 8);
  $b0000..$b3fff:valor:=back_ram[(direccion and $3fff)+1] or (back_ram[direccion and $3fff] shl 8);
  $d0000..$d07ff:valor:=palette_ram[(direccion and $7ff)+1] or (palette_ram[direccion and $7ff] shl 8);
  else begin
    valor:=prehisle_getbyte(direccion+1);
    valor:=valor or (prehisle_getbyte(direccion) shl 8);
  end;
end;
prehisle_getword:=valor;
end;

procedure prehisle_putword(direccion:dword;valor:word);pascal;
begin
case direccion of
    $90000..$907ff:begin
                      video_ram[(direccion and $7ff)+1]:=valor and $ff;
                      video_ram[direccion and $7ff]:=valor shr 8;
                      gfx[0].buffer[(direccion and $7ff) div 2]:=true;
                   end;
    $b0000..$b3fff:begin
                      back_ram[direccion and $3fff+1]:=valor and $ff;
                      back_ram[direccion and $3fff]:=valor shr 8;
                      gfx[3].buffer[(direccion and $3fff) div 2]:=true;
                   end;
    $d0000..$d07ff:begin
                      if valor<>(palette_ram[(direccion and $7ff)+1] or (palette_ram[direccion and $7ff] shl 8)) then begin
                        palette_ram[(direccion and $7ff)+1]:=valor and $ff;
                        palette_ram[direccion and $7ff]:=valor shr 8;
                        cambiar_color(valor,((direccion and $7ff) div 2));
                      end;
                   end;
    $f0000:scroll_y2.w:=(valor and $1ff);
    $f0010:scroll_x2.w:=(valor and $1fff);
    $f0020:if scroll_y1.w<>valor then begin
              scroll_y1.w:=(valor and $1ff);
              fondo1:=true;
           end;
    $f0030:if scroll_x1.w<>valor then begin
              scroll_x1.w:=(valor and $3fff);
              fondo1:=true;
           end;
  else begin
    prehisle_putbyte(direccion+1,valor and $ff);
    prehisle_putbyte(direccion,valor shr 8);
  end;
end;
end;

function prehisle_getbyte(direccion:dword):byte;
begin
case direccion of
  $0..$3ffff:prehisle_getbyte:=rom[direccion];
  $70000..$73fff:prehisle_getbyte:=ram[direccion-$70000];
  $a0000..$a07ff:prehisle_getbyte:=sprite_ram[direccion-$a0000];
  $e0011,$e0021,$e0041,$e0043:prehisle_getbyte:=$ff;
  $e0045:prehisle_getbyte:=in2;
  else prehisle_getbyte:=0;
end;
end;

procedure prehisle_putbyte(direccion:dword;valor:byte);
begin
case direccion of
  $0..$3ffff:exit;
  $70000..$73fff:ram[direccion-$70000]:=valor;
  $a0000..$a07ff:sprite_ram[direccion-$a0000]:=valor;
  else ;
end;
end;

end.
