unit psychic5;

interface
uses sdl,z80,constantes,windows,entradas,ym_2203,arcade_const,timers;

procedure Cargar_psychic5;
procedure psychic5_principal;pascal;
function psychic5_getbyte(direccion:word): Byte; pascal;
procedure psychic5_putbyte(direccion:word;valor:byte);pascal;
function psychic5_snd_getbyte(direccion:word): Byte; pascal;
procedure psychic5_snd_putbyte(direccion:word;valor:byte);pascal;
procedure psychic5_outbyte(valor:byte;puerto:word);pascal;
function iniciar_psychic5:boolean;pascal;
procedure reset_psychic5;pascal;
procedure cerrar_psychic5;pascal;
procedure psychic5_despues_instruccion;pascal;
procedure snd_irq(numchip:integer;irqstate:integer);pascal;

const
        psychic5_rom:array[0..2] of tipo_roms=(
        (n:'p5d';l:$8000;p:0),(n:'p5e';l:$10000;p:$8000),
        (n:'';l:0;p:0));
        psychic5_snd_rom:tipo_roms=(n:'p5a';l:$8000;p:0);
        psychic5_char:tipo_roms=(n:'p5f';l:$8000;p:0);
        psychic5_sprites:array[0..2] of tipo_roms=(
        (n:'p5b';l:$10000;p:0),(n:'p5c';l:$10000;p:$10000),
        (n:'';l:0;p:0));
        psychic5_tiles:array[0..2] of tipo_roms=(
        (n:'p5g';l:$10000;p:0),(n:'p5h';l:$10000;p:$10000),
        (n:'';l:0;p:0));

var
 mem_rom:array[0..3,0..$3fff] of byte;
 banco_rom,banco_vram:byte;
 bg_ram,char_ram,dummy_ram:array[0..$fff] of byte;
 io_ram:array[0..$3ff] of byte;
 palette_ram,jal_blend_table:array[0..$bff] of byte;
 title_screen,paleta_gris:boolean;
 bg_ram_w,char_ram_w:array[0..$fff] of boolean;
 sound_latch,bg_clip_mode,sy1,sy2,sx1:byte;

implementation
uses principal;

procedure Cargar_psychic5;
begin
form1.psychic51.Checked:=true;
llamadas_maquina.caption:='Psychic 5';
llamadas_maquina.iniciar:=iniciar_psychic5;
llamadas_maquina.bucle_general:=psychic5_principal;
llamadas_maquina.cerrar:=cerrar_psychic5;
llamadas_maquina.reset:=reset_psychic5;
llamadas_maquina.canales_usados:=2;
llamadas_maquina.fps_max:=53.8;
end;

procedure update_video_psychic5;
var
        f,color,nchar:word;
        x,y:word;
        attr:byte;
        scroll_x,scroll_y:parejas;
        long_x,long_y:word;
        flip_x:boolean;
        spr1,spr2,spr3,spr4:byte;
        sy1_old,sy2_old,sx1_old:byte;
        min_x,max_x,min_y,max_y:byte;
begin
//fondo
if (io_ram[$30c] and 1)<>0 then begin  //fondo activo?
  scroll_y.l:=io_ram[$308];
  scroll_y.h:=io_ram[$309];
  scroll_y.w:=(768-scroll_y.w) and $3ff;
  scroll_x.l:=io_ram[$30a];
  scroll_x.h:=io_ram[$30b] and 1;
  for f:=0 to $7ff do begin
   if bg_ram_w[f] then begin
    x:=f mod 32;
    y:=63-(f div 32);
    color:=(bg_ram[1+(f*2)] and $f) shl 4;
    if paleta_gris then color:=color+768
      else color:=color+256;
    nchar:=bg_ram[f*2]+((bg_ram[1+(f*2)] and $c0) shl 2);
    put_gfx_flip(x*16,y*16,nchar,color,3,2,(bg_ram[1+(f*2)] and $20)<>0,(bg_ram[1+(f*2)] and $10)<>0);
    bg_ram_w[f]:=false;
   end;
  end;
  if not(title_screen) then scroll_x_y(3,4,scroll_x.w,scroll_y.w)
    else begin
    pintar_pantalla(4,0);
    actualiza_trozo(scroll_x.w,scroll_y.w,256,256,3,0,0,256,256,4);
    end;
end else pintar_pantalla(4,0);
//sprites
if not(title_screen) then begin
 for f:=0 to $44 do begin
    attr:=memoria[$f20d+(f*16)];
    flip_x:=(attr and $20)<>0;
    if flip_x then begin
      spr1:=1;spr2:=0;spr3:=3;spr4:=2;
    end else begin
      spr1:=0;spr2:=1;spr3:=2;spr4:=3;
    end;
    nchar:=memoria[$f20e+(f*16)]+((attr and $c0) shl 2);
    color:=(memoria[$f20f+(f*16)] and $f) shl 4;
    x:=memoria[$f20b+(f*16)]+((attr and 4) shl 6);
    y:=255-(memoria[$f20c+(f*16)]+16);
    if (attr and 1)<>0 then y:=y+256;
    if (attr and 8)<>0 then begin //Sprites grandes
      put_gfx_sprite(nchar+spr1,color,flip_x,(attr and $10)<>0,1);
      actualiza_gfx_sprite(x,y,4,1);
      put_gfx_sprite(nchar+spr2,color,flip_x,(attr and $10)<>0,1);
      actualiza_gfx_sprite(x+16,y,4,1);
      put_gfx_sprite(nchar+spr3,color,flip_x,(attr and $10)<>0,1);
      actualiza_gfx_sprite(x,y-16,4,1);
      put_gfx_sprite(nchar+spr4,color,flip_x,(attr and $10)<>0,1);
      actualiza_gfx_sprite(x+16,y-16,4,1);
    end else begin
      put_gfx_sprite(nchar,color,flip_x,(attr and $10)<>0,1);
      actualiza_gfx_sprite(x,y,4,1);
    end;
 end;
end;
//chars
for f:=0 to $3ff do begin
  if char_ram_w[f] then begin
    x:=f mod 32;
    y:=31-(f div 32);
    color:=(char_ram[1+(f*2)] and $f) shl 4;
    nchar:=char_ram[f*2]+((char_ram[1+(f*2)] and $c0) shl 2);
    put_gfx_trans_flip(x*8,y*8,nchar,color+512,1,0,(char_ram[1+(f*2)] and $20)<>0,(char_ram[1+(f*2)] and $10)<>0);
    char_ram_w[f]:=false;
  end;
end;
actualiza_trozo(0,0,256,256,1,0,0,256,256,4);
actualiza_trozo(16,0,224,256,4,0,0,224,256,0);
end;

procedure eventos_psychic5;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_LEFT] or joystick.izq) then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if (teclado[SDLK_RIGHT] or joystick.der) then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if (teclado[SDLK_UP] or joystick.arriba) then in1:=(in1 and $F7) else in1:=(in1 or $8);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 and $df) else in1:=(in1 or $20);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if teclado[SDLK_1] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if teclado[SDLK_5] then in0:=(in0 and $bf) else in0:=(in0 or $40);
end;
end;

procedure cerrar_psychic5;pascal;
begin
cerrar_cpus;
YM2203_close(0);
YM2203_close(1);
cerrar_audio;
cerrar_video;
end;

procedure reset_psychic5;pascal;
begin
 reset_z80(main_z80);
 reset_z80(snd_z80);
 YM2203_reset(0);
 YM2203_reset(1);
 reset_audio;
 zeromemory(@memoria[$c000],$4000);
 in0:=$FF;
 in1:=$FF;
 banco_rom:=0;
 banco_vram:=0;
 paleta_gris:=false;
 sound_latch:=0;
end;

function iniciar_psychic5:boolean;pascal;
var
      f:word;
const
    pc_x:array[0..7] of dword=(0, 4, 8, 12, 16, 20, 24, 28);
    pc_y:array[0..7] of dword=(0*8, 4*8, 8*8, 12*8, 16*8, 20*8, 24*8, 28*8);
    ps_x:array[0..15] of dword=(0, 4, 8, 12, 16, 20, 24, 28, 64*8, 64*8+4, 64*8+8, 64*8+12, 64*8+16, 64*8+20, 64*8+24, 64*8+28);
    ps_y:array[0..15] of dword=(0*8, 4*8, 8*8, 12*8, 16*8, 20*8, 24*8, 28*8, 32*8, 36*8, 40*8, 44*8, 48*8, 52*8, 56*8, 60*8);
begin
iniciar_psychic5:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[2].x:=512;
p_final[2].y:=512;
p_final[2].trans:=true;
p_final[3].x:=512;
p_final[3].y:=1024;
p_final[4].x:=256;
p_final[4].y:=256;
iniciar_video;
//datos del scroll
scroll_data.long_x:=512;
scroll_data.long_y:=1024;
scroll_data.max_x:=256;
scroll_data.max_y:=256;
scroll_data.max_scr_x:=255;
scroll_data.max_scr_y:=255;
//Main CPU
init_cpu(z80_main,0,6000000/llamadas_maquina.fps_max/2/10);
main_z80.daisy:=false;
main_z80_ll.getbyte:=psychic5_getbyte;
main_z80_ll.putbyte:=psychic5_putbyte;
main_z80_ll.outbyte:=nil;
main_z80_ll.inbyte:=nil;
//Sound CPU
init_cpu(z80_snd,1,4000000/llamadas_maquina.fps_max/2/10);
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=psychic5_snd_getbyte;
snd_z80_ll.putbyte:=psychic5_snd_putbyte;
snd_z80_ll.outbyte:=psychic5_outbyte;
snd_z80_ll.inbyte:=nil;
//Sound Chips
YM2203_Init(0,1500000,2,nil,nil,nil,nil);
ym2203_init_timers(1500000,1,0,snd_irq);
YM2203_Init(1,1500000,2,nil,nil,nil,nil);
//Timers
init_timer(0,1,4000000/44100,psychic5_despues_instruccion,true);
//cargar roms}
if not(cargar_roms(@memoria_temp[0],@psychic5_rom[0],'\psychic5.zip',0)) then exit;
//Poner las ROMS en sus bancos
copymemory(@memoria[0],@memoria_temp[0],$8000);
for f:=0 to 3 do copymemory(@mem_rom[f,0],@memoria_temp[$8000+(f*$4000)],$4000);
//cargar ROMS sonido
if not(cargar_roms(@mem_snd[0],@psychic5_snd_rom,'\psychic5.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@psychic5_char,'\psychic5.zip',1)) then exit;
init_gfx(0,8,8,1024);
gfx[0].trans[15]:=true;
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=1;
des_sprites.pos_planos[2]:=2;
des_sprites.pos_planos[3]:=3;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,true);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@psychic5_sprites[0],'\psychic5.zip',0)) then exit;
init_gfx(1,16,16,1024);
gfx[1].trans[15]:=true;
des_sprites.long_sprites:=128*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,true);
//convertir tiles
if not(cargar_roms(@memoria_temp[0],@psychic5_tiles[0],'\psychic5.zip',0)) then exit;
init_gfx(2,16,16,1024);
convert_sprites(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,true);
//final
reset_psychic5;
iniciar_psychic5:=true;
end;

procedure psychic5_principal;pascal;
var
  f,h:byte;
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
  for h:=0 to 1 do begin
   for f:=0 to 9 do begin
    frame_m:=frame_m+main_z80.tframes;
    run_z80(main_z80,main_z80_ll,trunc(frame_m));
    frame_m:=frame_m-main_z80.contador;
    main_z80.contador:=0;
    frame_s:=frame_s+snd_z80.tframes;
    run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
    frame_s:=frame_s-snd_z80.contador;
    snd_z80.contador:=0;
   end;
   if h=0 then main_z80.im0:=$d7  //rst 10
      else main_z80.im0:=$cf;  //rst 8
   main_z80.pedir_irq:=true;
  end;
  update_video_psychic5;
  actualiza_video;
  eventos_psychic5;
  sincronizar;
  evaluar_entradas;
end;
end;

function ram_paginada_r(direccion:word):byte;
var
  val:byte;
begin
	if (banco_vram=0) then begin
		if (direccion<$1000) then ram_paginada_r:=bg_ram[direccion]
		  else ram_paginada_r:=dummy_ram[direccion and $fff];
	end else begin
		if (direccion<$400) then begin
			case direccion of
				$0:val:=in0;
				$1:val:=in1;
				$2:val:=in2;
				$3:val:=$1+$8+$20+$c0;
				$4:val:=$1+$e0+$18;
				else val:=io_ram[direccion];
			end;
			ram_paginada_r:=val;
    end else if (direccion<$1000) then ram_paginada_r:=palette_ram[direccion-$400]
                else ram_paginada_r:=char_ram[direccion and $fff];
	end;
end;

procedure cambiar_paleta(color_offs,offset:word;data:byte);
var
	a,val:byte;
  color,color_g:tcolor;
  pos:word;
begin
if palette_ram[offset]=data then exit;
palette_ram[offset]:=data;
pos:=(offset div 2)-color_offs;
val:=(palette_ram[offset and $fffe] shr 4) and $0f ;
color.r:=(val shl 4) or val ;
val:=(palette_ram[offset and $fffe]) and $0f ;
color.g:=(val shl 4) or val ;
val:=(palette_ram[offset or 1] shr 4) and $0f ;
color.b:=(val shl 4) or val ;
val:=(palette_ram[offset or 1] and $0f) and $0f ;
a:=(val shl 4) or val;
jal_blend_table[pos]:=a;
case pos of
  512..767:if pos>511 then fillmemory(@char_ram_w[0],$1000,1);
  256..511:begin
    //Paleta gris
    val:=(color.r+color.g+color.b) div 3;
    color_g.r:=val;
    color_g.g:=val;
    color_g.b:=val;
    //con intensidad?
    {if (ix<>0) then begin
      ir:=palette_ram[$1fe] shr 4;
      ir:=(ir shl 4) or ir;
      ig:=palette_ram[$1fe] and 15;
      ig:=(ig shl 4) or ig;
      ib:=palette_ram[$1ff] shr 4;
      ib:=(ib shl 4) or ib;
      //UINT32 result = jal_blend_func(MAKE_RGB(val,val,val), MAKE_RGB(ir, ig, ib), jal_blend_table[0xff]) ;
    end;}
    poner_color(color_g,addr(paleta[pos+512]));
    fillmemory(@bg_ram_w[0],$1000,1);
    end
end;
poner_color(color,addr(paleta[pos]));
end;

procedure ram_paginada_w(direccion:word;valor:byte);
begin
if (banco_vram=0) then begin
		if (direccion<$1000) then begin
      if bg_ram[direccion]<>valor then begin
        bg_ram[direccion]:=valor;
        bg_ram_w[direccion div 2]:=true;
      end;
		end else dummy_ram[direccion and $fff]:=valor;
end else begin
  case direccion of
		$0..$3ff:begin
              io_ram[direccion]:=valor;
              paleta_gris:=(io_ram[$30c] and 2)<>0;
    end;
    $400..$5ff:cambiar_paleta(0,direccion-$400,valor);
    $600..$7ff,$c00..$fff:palette_ram[direccion-$400]:=valor;
    $800..$bff:if buffer_paleta[direccion and $3ff]<>valor then begin
                  cambiar_paleta(256,direccion-$400,valor);
                  buffer_paleta[direccion and $3ff]:=valor;
               end;
		else if char_ram[direccion and $fff]<>valor then begin
      char_ram[direccion and $fff]:=valor;
      char_ram_w[(direccion and $fff) div 2]:=true;
    end;
  end;
end;
end;

function psychic5_getbyte(direccion:word):Byte; pascal;
begin
case direccion of
 $8000..$bfff:psychic5_getbyte:=mem_rom[banco_rom,direccion and $3fff];
 $c000..$dfff:psychic5_getbyte:=ram_paginada_r(direccion and $1fff);
 $f002:psychic5_getbyte:=banco_rom;
 $f003:psychic5_getbyte:=banco_vram;
 else psychic5_getbyte:=memoria[direccion];
end;
end;

procedure psychic5_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$c000 then exit;
memoria[direccion]:=valor;
case direccion of
        $c000..$dfff:ram_paginada_w(direccion and $1fff,valor);
        $f000:sound_latch:=valor;
        $f002:banco_rom:=valor and $3;
        $f003:banco_vram:=valor;
        $f005:title_screen:=(valor<>0);
end;
end;

function psychic5_snd_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $e000:psychic5_snd_getbyte:=sound_latch;
  else psychic5_snd_getbyte:=mem_snd[direccion];
end;
end;

procedure psychic5_snd_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$8000 then exit;
mem_snd[direccion]:=valor;
end;

procedure psychic5_outbyte(valor:byte;puerto:word);pascal;
begin
case (puerto and $FF) of
  0:ym2203_control(0,valor);
  1:ym2203_write_reg(0,valor);
  $80:ym2203_control(1,valor);
  $81:ym2203_write_reg(1,valor);
end;
end;

procedure psychic5_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=ym2203UpdateOne(0);
  tsample[1][posicion_sonido]:=ym2203UpdateOne(1);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

procedure snd_irq(numchip:integer;irqstate:integer);pascal;
begin
  snd_z80.pedir_irq:=(irqstate=1);
end;

end.
