unit rallyx_hardware;
interface
uses sysutils,sdl,z80,constantes,windows,entradas,ay_8910,arcade_const,timers,namco,samples;

//Driver genericas
procedure Cargar_rallyxh;
function iniciar_rallyxh:boolean;pascal;
procedure reset_rallyxh;pascal;
procedure cerrar_rallyxh;pascal;
//especificas
procedure jungler_principal;pascal;
function jungler_getbyte(direccion:word): Byte; pascal;
procedure jungler_putbyte(direccion:word;valor:byte);pascal;
function rallyx_getbyte(direccion:word): Byte; pascal;
procedure rallyx_putbyte(direccion:word;valor:byte);pascal;
procedure rallyx_outbyte(valor:byte;puerto:word);pascal;
procedure rallyx_playsound;pascal;

const
        jungler_rom:array[0..4] of tipo_roms=(
        (n:'jungr1';l:$1000;p:0),(n:'jungr2';l:$1000;p:$1000),(n:'jungr3';l:$1000;p:$2000),
        (n:'jungr4';l:$1000;p:$3000),(n:'';l:0;p:0));
        jungler_pal:array[0..2] of tipo_roms=(
        (n:'18s030.8b';l:$20;p:0),(n:'tbp24s10.9d';l:$100;p:$20),(n:'';l:0;p:0));
        jungler_char:array[0..2] of tipo_roms=(
        (n:'5k';l:$800;p:0),(n:'5m';l:$800;p:$800),(n:'';l:0;p:0));
        jungler_sound:tipo_roms=(n:'1b';l:$1000;p:0);
        jungler_dots:tipo_roms=(n:'82s129.10g';l:$100;p:0);
        rallyx_rom:array[0..4] of tipo_roms=(
        (n:'1b';l:$1000;p:0),(n:'rallyxn.1e';l:$1000;p:$1000),(n:'rallyxn.1h';l:$1000;p:$2000),
        (n:'rallyxn.1k';l:$1000;p:$3000),(n:'';l:0;p:0));
        rallyx_pal:array[0..2] of tipo_roms=(
        (n:'rx-1.11n';l:$20;p:0),(n:'rx-7.8p';l:$100;p:$20),(n:'';l:0;p:0));
        rallyx_char:tipo_roms=(n:'8e';l:$1000;p:0);
        rallyx_sound:tipo_roms=(n:'rx-5.3p';l:$100;p:0);
        rallyx_dots:tipo_roms=(n:'rx-6.8m';l:$100;p:0);
        rallyx_samples:tipo_nombre_samples=(nombre:'bang.wav');
var
 last,scroll_x,scroll_y:byte;
 hacer_int:boolean;
 hay_samples:boolean=false;

implementation
uses principal,konami_snd;

//jungler
procedure update_video_jungler;
var
        f,nchar,y,x,color,h:word;
begin
//Backgorund (256x256)
for f:=0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    x:=f div 32;
    y:=31-(f mod 32);
    color:=(memoria[$8c00+f] and $3f) shl 2;
    nchar:=memoria[$8400+f];
    put_gfx_flip(x*8,y*8,nchar,color,1,0,(memoria[$8c00+f] and $80)=0,(memoria[$8c00+f] and $40)<>0);
    gfx[0].buffer[f]:=false;
  end;
end;
actualiza_trozo(16,0,224,256,1,0,32,224,256,0);
//Disparos
for f:=$14 to $20 do begin
    x:=memoria[$8820+f];
    if x>=16 then begin
      nchar:=(memoria[$a030+f] and $7) xor 7;
      y:=memoria[$8020+f]+((memoria[$a030+f] xor $ff) and $8) shl 5;
      if y>288 then y:=y and $FF;
      put_gfx_trans(0,0,nchar,16,3,2);
      actualiza_trozo(0,0,4,4,3,x-16,y,4,4,0);
    end;
end;
//Sprites
for f:=$1e downto $14 do begin
    nchar:=(memoria[$8000+f] and $fc) shr 2;
    color:=(memoria[$8801+f] and $3f) shl 2;
    x:=memoria[$8800+f]-17;
    y:=memoria[$8001+f]+((memoria[$8801+f] and $80) shl 1);
    put_gfx_sprite_table(nchar,color,(memoria[$8000+f] and 2)<>0,(memoria[$8000+f] and 1)<>0,1,0);
    actualiza_gfx_sprite(x,y,0,1);
end;
//Foreground  (solo 256x64)
f:=$20;
while f<$3ff do begin
for h:=0 to 7 do begin
  if gfx[2].buffer[f] then begin
    x:=f div 32;
    y:=7-(f mod 8);
    color:=(memoria[$8800+f] and $3f) shl 2;
    nchar:=memoria[$8000+f];
    put_gfx(x*8,y*8,nchar,color,2,0);
    gfx[2].buffer[f]:=false;
  end;
  inc(f);
 end;
 inc(f,24);
end;
actualiza_trozo(16,32,224,32,2,0,0,224,32,0);
actualiza_trozo(16,0,224,32,2,0,32,224,32,0);
end;

procedure eventos_jungler;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in2:=(in2 and $7f) else in2:=(in2 or $80);
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=(in0 and $df) else in0:=(in0 or $20);
  if teclado[SDLK_5] then in0:=(in0 and $7f) else in0:=(in0 or $80);
  if teclado[SDLK_1] then in1:=(in1 and $7f) else in1:=(in1 or $80);
end;
end;

procedure jungler_principal;pascal;
var
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
  frame_m:=frame_m+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame_m));
  main_z80.pedir_nmi:=hacer_int;
  frame_s:=frame_s+snd_z80.tframes;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_m:=frame_m-main_z80.contador;
  frame_s:=frame_s-snd_z80.contador;
  main_z80.contador:=0;
  snd_z80.contador:=0;
  update_video_jungler;
  actualiza_video;
  eventos_jungler;
  sincronizar;
  evaluar_entradas;
end;
end;

function jungler_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $a000:jungler_getbyte:=in0;
  $a080:jungler_getbyte:=in1;
  $a100:jungler_getbyte:=in2;
  $a180:jungler_getbyte:=$bf;
    else jungler_getbyte:=memoria[direccion];
end;
end;

procedure jungler_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$4000 then exit;
memoria[direccion]:=valor;
case direccion of
    $8000..$83ff:gfx[2].buffer[direccion and $3ff]:=true;
    $8400..$87ff:gfx[0].buffer[direccion and $3ff]:=true;
    $8800..$8bff:gfx[2].buffer[direccion and $3ff]:=true;
    $8c00..$8fff:gfx[0].buffer[direccion and $3ff]:=true;
    $a100:konami_sl:=valor;
    $a180:begin
              if ((last=0) and (valor<>0)) then snd_z80.pedir_irq:=true;
              last:=valor;
          end;
    $a181:hacer_int:=valor<>0;
end;
end;

//Rally X
procedure update_video_rallyx;
var
  f,nchar,y,x,color,h,atrib:word;
  flipx,flipy:boolean;
begin
//Backgorund (256x256)
for f:=0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    y:=f div 32;
    x:=f mod 32;
    atrib:=memoria[$8c00+f];
    color:=(atrib and $3f) shl 2;
    nchar:=memoria[$8400+f];
    flipx:=(atrib and $40)=0;
    flipy:=(atrib and $80)<>0;
    put_gfx_flip(x*8,y*8,nchar,color,1,0,flipx,flipy);
    gfx[0].buffer[f]:=false;
  end;
end;
scroll_x_y(1,4,scroll_x-3,scroll_y);
actualiza_trozo(0,16,256,224,4,0,0,256,224,0);
//Sprites
for f:=$1e downto $14 do begin
    nchar:=(memoria[$8000+f] and $fc) shr 2;
    color:=(memoria[$8801+f] and $3f) shl 2;
    y:=225-memoria[$8800+f]-1;
    x:=memoria[$8001+f]+((memoria[$8801+f] and $80) shl 1)-4;
    flipx:=(memoria[$8000+f] and 1)<>0;
    flipy:=(memoria[$8000+f] and 2)<>0;
    put_gfx_sprite_table(nchar,color,flipx,flipy,1,0);
    actualiza_gfx_sprite(x,y,0,1);
end;
//Foreground  (solo 256x64)
f:=$20;
while f<$3ff do begin
for h:=0 to 7 do begin
  if gfx[2].buffer[f] then begin
    y:=f div 32;
    x:=f mod 8;
    atrib:=memoria[$8800+f];
    color:=(atrib and $3f) shl 2;
    nchar:=memoria[$8000+f];
    flipx:=(atrib and $40)=0;
    flipy:=(atrib and $80)<>0;
    put_gfx_flip(x*8,y*8,nchar,color,2,0,flipx,flipy);
    gfx[2].buffer[f]:=false;
  end;
  inc(f);
 end;
 inc(f,24);
end;
actualiza_trozo(32,16,32,224,2,224,0,32,224,0);
actualiza_trozo(0,16,32,224,2,256,0,32,224,0);
//Radar
for f:=0 to $b do begin
    y:=237-memoria[$8834+f];
    nchar:=((memoria[$a004+f] and $e) shr 1) xor 7;
    x:=memoria[$8034+f]+(((not(memoria[$a004+f])) and $8) shl 5);
    if x<32 then x:=x+256;
    put_gfx_trans(0,0,nchar,16,3,2);
    actualiza_trozo(0,0,4,4,3,x,y,4,4,0);
end;
end;

procedure eventos_rallyx;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=(in0 and $df) else in0:=(in0 or $20);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if teclado[SDLK_5] then in0:=(in0 and $7f) else in0:=(in0 or $80);
  if teclado[SDLK_1] then in0:=(in0 and $bf) else in0:=(in0 or $40);
end;
end;

procedure rallyx_principal;pascal;
var
  frame:single;
begin
iniciar_entradas;
frame:=0;
while EmuStatus=EsRuning do begin
  frame:=frame+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame));
  main_z80.pedir_irq:=hacer_int;
  frame:=frame-main_z80.contador;
  main_z80.contador:=0;
  update_video_rallyx;
  actualiza_video;
  eventos_rallyx;
  if hay_sonido then namco_playsound;
  sincronizar;
  evaluar_entradas;
end;
end;

function rallyx_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $a000:rallyx_getbyte:=in0;
  $a080:rallyx_getbyte:=in1;
  $a100:rallyx_getbyte:=in2;
  else rallyx_getbyte:=memoria[direccion];
end;
end;

procedure rallyx_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$4000 then exit;
memoria[direccion]:=valor;
case direccion of
  $8000..$83ff:gfx[2].buffer[direccion and $3ff]:=true;
  $8400..$87ff:gfx[0].buffer[direccion and $3ff]:=true;
  $8800..$8bff:gfx[2].buffer[direccion and $3ff]:=true;
  $8c00..$8fff:gfx[0].buffer[direccion and $3ff]:=true;
  $a100..$a11f:registros_namco[direccion and $1f]:=valor;
  $a130:scroll_x:=valor;
  $a140:scroll_y:=valor;
  $a180:begin
          if ((valor=0) and (last<>0) and hay_samples) then start_sample(0);
          last:=valor;
        end;
  $a181:hacer_int:=(valor<>0)
end;
end;
procedure rallyx_outbyte(valor:byte;puerto:word);pascal;
begin
if (puerto and $ff)=0 then main_z80.im0:=valor;
end;

procedure rallyx_playsound;pascal;
begin
if hay_sonido then begin
  if hay_samples then tsample[3][posicion_sonido]:=play_samples;
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

//Funciones genericas
procedure Cargar_rallyxh;
begin
case tipo_maquina of
  29:begin
       form1.jungler1.Checked:=true;
       llamadas_maquina.caption:='Jungler';
       llamadas_maquina.bucle_general:=jungler_principal;
  end;
  50:begin
      form1.rallyx1.Checked:=true;
      llamadas_maquina.caption:='Rally X';
      llamadas_maquina.bucle_general:=rallyx_principal;
  end;
end;
llamadas_maquina.iniciar:=iniciar_rallyxh;
llamadas_maquina.cerrar:=cerrar_rallyxh;
llamadas_maquina.reset:=reset_rallyxh;
llamadas_maquina.fps_max:=60.606060606060;
llamadas_maquina.canales_usados:=4;
end;

procedure cerrar_rallyxh;pascal;
begin
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_rallyxh;pascal;
begin
 reset_z80(main_z80);
 reset_audio;
 zeromemory(@memoria[$4000],$bFFF);
 last:=0;
 in0:=$FF;
 in1:=$FF;
 case tipo_maquina of
  29:begin
        in2:=$FF;
        reset_z80(snd_z80);
        konamisnd_reset;
  end;
  50:begin
        in2:=$cb;
  end;
 end;
end;

function iniciar_rallyxh:boolean;pascal;
var
      colores:tpaleta;
      f:word;
      ctemp1:byte;
const
  ps_rx:array[0..15] of dword=(8*8+0, 8*8+1, 8*8+2, 8*8+3, 16*8+0, 16*8+1, 16*8+2, 16*8+3,
			 24*8+0, 24*8+1, 24*8+2, 24*8+3, 0, 1, 2, 3);
  ps_x:array[0..15] of dword=(8*8, 8*8+1, 8*8+2, 8*8+3, 0, 1, 2, 3,
			24*8+0, 24*8+1, 24*8+2, 24*8+3, 16*8+0, 16*8+1, 16*8+2, 16*8+3);
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			32*8, 33*8, 34*8, 35*8, 36*8, 37*8, 38*8, 39*8);
  pc_x:array[0..7] of dword=(8*8+0, 8*8+1, 8*8+2, 8*8+3, 0, 1, 2, 3);
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
  pd_x:array[0..3] of dword=(0*8, 1*8, 2*8, 3*8);
  pd_y:array[0..3] of dword=(0*32, 1*32, 2*32, 3*32);
procedure cargar_chars(tipo:byte);
begin
init_gfx(0,8,8,256);
gfx[0].trans[3]:=true;
if tipo=1 then begin
  des_sprites.pos_planos[0]:=4;
  des_sprites.pos_planos[1]:=0;
end else begin
  des_sprites.pos_planos[0]:=0;
  des_sprites.pos_planos[1]:=4;
end;
des_sprites.bit_pixel:=2;
des_sprites.banks:=0;
des_sprites.long_sprites:=16*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],(tipo=1),false);
end;
procedure cargar_sprites(tipo:byte);
begin
init_gfx(1,16,16,64);
gfx[1].trans[0]:=true;
des_sprites.bit_pixel:=2;
des_sprites.banks:=0;
des_sprites.long_sprites:=64*8;
if tipo=1 then begin
  des_sprites.pos_planos[0]:=4;
  des_sprites.pos_planos[1]:=0;
  convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
end else begin
  des_sprites.pos_planos[0]:=0;
  des_sprites.pos_planos[1]:=4;
  convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_rx[0],@ps_y[0],false,false);
end;
end;
procedure cargar_disparo;
begin
init_gfx(2,4,4,8);
gfx[2].trans[3]:=true;
des_sprites.pos_planos[0]:=6;
des_sprites.pos_planos[1]:=7;
des_sprites.bit_pixel:=2;
des_sprites.long_sprites:=16*8;
convert_sprites(@gfx[2],0,@memoria_temp[0],@pd_x[0],@pd_y[0],false,false)
end;
begin
iniciar_rallyxh:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
case tipo_maquina of
  29:begin
        p_final[0].x:=224;
        p_final[0].y:=288;
        p_final[2].x:=256;
        p_final[2].y:=64;
  end;
  50:begin
        p_final[0].x:=288;
        p_final[0].y:=224;
        p_final[2].x:=64;
        p_final[2].y:=256;
  end;
end;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[3].x:=4;
p_final[3].y:=4;
p_final[3].trans:=true;
p_final[4].x:=256;
p_final[4].y:=256;
iniciar_video;
//Datos del scroll
scroll_data.long_x:=256;
scroll_data.long_y:=256;
scroll_data.max_x:=255;
scroll_data.max_y:=255;
//Main CPU
init_cpu(z80_main,0,3072000/llamadas_maquina.fps_max);
main_z80.daisy:=false;
main_z80_ll.inbyte:=nil;
case tipo_maquina of
  29:begin //jungler
        main_z80_ll.getbyte:=jungler_getbyte;
        main_z80_ll.putbyte:=jungler_putbyte;
        main_z80_ll.outbyte:=nil;
        //Audio CPU
        init_cpu(z80_snd,1,1789772/llamadas_maquina.fps_max);
        snd_z80.daisy:=false;
        snd_z80_ll.getbyte:=konamisnd_getbyte;
        snd_z80_ll.putbyte:=konamisnd_putbyte;
        snd_z80_ll.outbyte:=nil;
        snd_z80_ll.inbyte:=nil;
        //Sound Chip
        konamisnd_init(1,1,1789772,konamisnd_despues_instruccion);
        //cargar roms
        if not(cargar_roms(@memoria[0],@jungler_rom[0],'\jungler.zip',0)) then exit;
        //cargar sonido
        if not(cargar_roms(@mem_snd[0],@jungler_sound,'\jungler.zip',1)) then exit;
        //convertir chars
        if not(cargar_roms(@memoria_temp[0],@jungler_char[0],'\jungler.zip',0)) then exit;
        cargar_chars(1);
        //convertir sprites
        cargar_sprites(1);
        //Y ahora el'disparo'
        if not(cargar_roms(@memoria_temp[0],@jungler_dots,'\jungler.zip',1)) then exit;
        cargar_disparo;
        //poner la paleta
        if not(cargar_roms(@memoria_temp[0],@jungler_pal[0],'\jungler.zip',0)) then exit;
  end;
  50:begin //rallyx
        main_z80_ll.getbyte:=rallyx_getbyte;
        main_z80_ll.putbyte:=rallyx_putbyte;
        main_z80_ll.outbyte:=rallyx_outbyte;
        //cargar roms
        if not(cargar_roms(@memoria[0],@rallyx_rom[0],'\rallyx.zip',0)) then exit;
        //cargar sonido y samples
        if not(cargar_roms(@onda_namco[0],@rallyx_sound,'\rallyx.zip',1)) then exit;
        hay_samples:=cargar_samples('\rallyx.zip',@rallyx_samples,1);
        init_timer(0,0,3072000/44100,rallyx_playsound,true);
        //convertir chars
        if not(cargar_roms(@memoria_temp[0],@rallyx_char,'\rallyx.zip',1)) then exit;
        cargar_chars(0);
        //convertir sprites
        cargar_sprites(0);
        //Y ahora el'disparo'
        if not(cargar_roms(@memoria_temp[0],@rallyx_dots,'\rallyx.zip',1)) then exit;
        cargar_disparo;
        //poner la paleta
        if not(cargar_roms(@memoria_temp[0],@rallyx_pal[0],'\rallyx.zip',0)) then exit;
  end;
end;
for f:=0 to 31 do begin
    ctemp1:=memoria_temp[f];
    colores[f].r:= $21*(ctemp1 and 1)+$47*((ctemp1 shr 1) and 1)+$97*((ctemp1 shr 2) and 1);
    colores[f].g:= $21*((ctemp1 shr 3) and 1)+$47*((ctemp1 shr 4) and 1)+$97*((ctemp1 shr 5) and 1);
    colores[f].b:= 0+$50*((ctemp1 shr 6) and 1)+$ab*((ctemp1 shr 7) and 1);
end;
poner_paleta(colores,32);
//color lookup
for f:=0 to 255 do begin
  gfx[1].colores[f]:=memoria_temp[$20+f] and $f;
  gfx[0].colores[f]:=memoria_temp[$20+f] and $f;
end;
//final
reset_rallyxh;
iniciar_rallyxh:=true;
end;

end.
