unit rygar;

interface
uses sdl,z80,constantes,windows,entradas,arcade_const,sysutils,timers,msm5205,ym_3812;

procedure Cargar_rygar;
procedure rygar_principal;pascal;
function rygar_getbyte(direccion:word): Byte; pascal;
procedure rygar_putbyte(direccion:word;valor:byte);pascal;
function snd_getbyte(direccion:word): Byte; pascal;
procedure snd_putbyte(direccion:word;valor:byte);pascal;
procedure snd_despues_instruccion;pascal;
function iniciar_rygar:boolean;pascal;
procedure reset_rygar;pascal;
procedure cerrar_rygar;pascal;
procedure snd_adpcm;pascal;
procedure snd_irq(numchip:integer;irqstate:integer);pascal;

const
        rygar_rom:array[0..3] of tipo_roms=(
        (n:'5.5p';l:$8000;p:0),(n:'cpu_5m.bin';l:$4000;p:$8000),
        (n:'cpu_5j.bin';l:$8000;p:$10000),(n:'';l:0;p:0));
        rygar_char:tipo_roms=(n:'cpu_8k.bin';l:$8000;p:0);
        rygar_tiles1:array[0..4] of tipo_roms=(
        (n:'vid_6p.bin';l:$8000;p:0),(n:'vid_6o.bin';l:$8000;p:$8000),
        (n:'vid_6n.bin';l:$8000;p:$10000),(n:'vid_6l.bin';l:$8000;p:$18000),
        (n:'';l:0;p:0));
        rygar_tiles2:array[0..4] of tipo_roms=(
        (n:'vid_6f.bin';l:$8000;p:0),(n:'vid_6e.bin';l:$8000;p:$8000),
        (n:'vid_6c.bin';l:$8000;p:$10000),(n:'vid_6b.bin';l:$8000;p:$18000),
        (n:'';l:0;p:0));
        rygar_adpcm:tipo_roms=(n:'cpu_1f.bin';l:$4000;p:0);
        rygar_sound:tipo_roms=(n:'cpu_4h.bin';l:$2000;p:0);
        rygar_sprites:array[0..4] of tipo_roms=(
        (n:'vid_6k.bin';l:$8000;p:0),(n:'vid_6j.bin';l:$8000;p:$8000),
        (n:'vid_6h.bin';l:$8000;p:$10000),(n:'vid_6g.bin';l:$8000;p:$18000),
        (n:'';l:0;p:0));
var
 rom:array[0..$7FFF] of byte;
 mem_adpcm:array[0..$7fff] of byte;
 adpcm_end,adpcm_pos:word;
 adpcm_data:integer;
 banco_rom:word;
 scroll_x1,scroll_x2:parejas;
 scroll_y1,scroll_y2:byte;
 soundlatch:byte;
 buffer_delante:array[0..$1ff] of boolean;

implementation
uses principal;

procedure Cargar_rygar;
begin
form1.rygar1.Checked:=true;
llamadas_maquina.caption:='Rygar';
llamadas_maquina.iniciar:=iniciar_rygar;
llamadas_maquina.bucle_general:=rygar_principal;
llamadas_maquina.cerrar:=cerrar_rygar;
llamadas_maquina.reset:=reset_rygar;
llamadas_maquina.canales_usados:=2;
end;

procedure draw_sprites(prioridad:byte);
var
  nchar,x,y,f:word;
  flags,bank:byte;
  size:word;
begin
for f:=0 to $ff do begin
 flags:=memoria[$e003+(f*8)];
 if prioridad=(flags shr 6) then begin
  bank:=memoria[$e000+(f*8)];
  if (bank and 4)<>0 then begin //sprite visible
    nchar:=memoria[$e001+(f*8)]+((bank and $f0) shl 4);
    size:=memoria[$e002+(f*8)] and 3;
    x:=memoria[$e005+(f*8)]-((flags and $10) shl 4);
    y:=memoria[$e004+(f*8)]-((flags and $20) shl 3);
    case size of
      2:begin
          nchar:=nchar shr 4;
          put_gfx_sprite(nchar,(flags and $f) shl 4,(bank and $1)<>0,(bank and $2)<>0,2);
          actualiza_gfx_sprite(x+48,y,1,2);
        end;
      1:begin
          nchar:=nchar shr 2;
          put_gfx_sprite(nchar,(flags and $f) shl 4,(bank and $1)<>0,(bank and $2)<>0,1);
          actualiza_gfx_sprite(x+48,y,1,1);
      end;
      0:begin
          put_gfx_sprite(nchar,(flags and $f) shl 4,(bank and $1)<>0,(bank and $2)<>0,4);
          actualiza_gfx_sprite(x+48,y,1,4);
      end;
    end;
  end;
 end;
end;
end;

procedure update_video_rygar;
var
        f,color,nchar:word;
        x,y:word;
begin
//Primero los chars por duplicado (tienen prioridad)
for f:=0 to $3ff do begin
  if gfx[0].buffer[f] then begin
      x:=f mod 32;
      y:=f div 32;
      color:=(memoria[$d400+f] and $f0)+256;
      nchar:=memoria[$d000+f]+((memoria[$d400+f] and $3) shl 8);
      put_gfx_trans(x*8,y*8,nchar,color,6,0);
      put_gfx(x*8,y*8,nchar,color,5,0);
      gfx[0].buffer[f]:=false;
  end;
end;
for f:=0 to $1ff do begin
    //Background
    if gfx[3].buffer[f] then begin
        x:=f mod 32;
        y:=f div 32;
        color:=(memoria[$de00+f] and $f0)+768;
        nchar:=memoria[$dc00+f]+((memoria[$de00+f] and $7) shl 8);
        put_gfx_trans(x*16,y*16,nchar,color,2,3);
        gfx[3].buffer[f]:=false;
    end;
    //Delante
    if buffer_delante[f] then begin
        x:=f mod 32;
        y:=f div 32;
        color:=(memoria[$da00+f] and $f0)+512;
        nchar:=memoria[$d800+f]+((memoria[$da00+f] and $7) shl 8);
        put_gfx_trans(x*16,y*16,nchar+1024,color,7,3);
        buffer_delante[f]:=false;
    end;
end;
//Primero la base de los chars
actualiza_trozo(0,0,256,256,5,48,0,256,256,1);
draw_sprites(3);
scroll_x_y(2,1,scroll_x2.w,scroll_y2);
draw_sprites(2);
scroll_x_y(7,1,scroll_x1.w,scroll_y1);
draw_sprites(1);
//Otra vez los chars transparentes
actualiza_trozo(0,0,256,256,6,48,0,256,256,1);
draw_sprites(0);
actualiza_trozo(48,16,256,224,1,0,0,256,224,0);
end;

procedure eventos_rygar;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=(in0 or 4) else in0:=(in0 and $fb);
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=(in0 or 8) else in0:=(in0 and $f7);
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=(in0 or 1) else in0:=(in0 and $fe);
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=(in0 or 2) else in0:=(in0 and $fd);
  if teclado[SDLK_1] then in2:=(in2 or 2) else in2:=(in2 and $fd);
  if teclado[SDLK_5] then in2:=(in2 or 4) else in2:=(in2 and $fb);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 or $1) else in1:=(in1 and $fe);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 or $2) else in1:=(in1 and $fd);
end;
end;

procedure cerrar_rygar;pascal;
begin
msm5205_close(0);
ym3812_close(0);
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_rygar;pascal;
begin
 reset_z80(main_z80);
 reset_z80(snd_z80);
 reset_audio;
 adpcm_end:=0;
 adpcm_pos:=0;
 adpcm_data:=-1;
 zeromemory(@memoria[$c000],$4000);
 in0:=0;
 in1:=0;
 in2:=0;
 banco_rom:=0;
end;

function iniciar_rygar:boolean;pascal;
const
  ps_x:array[0..15] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4,
			32*8+0*4, 32*8+1*4, 32*8+2*4, 32*8+3*4, 32*8+4*4, 32*8+5*4, 32*8+6*4, 32*8+7*4);
  ps_y:array[0..15] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32,
			16*32, 17*32, 18*32, 19*32, 20*32, 21*32, 22*32, 23*32);
  pt_x:array[0..31] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4,
			32*8+0*4, 32*8+1*4, 32*8+2*4, 32*8+3*4, 32*8+4*4, 32*8+5*4, 32*8+6*4, 32*8+7*4,
			128*8+0*4, 128*8+1*4, 128*8+2*4, 128*8+3*4, 128*8+4*4, 128*8+5*4, 128*8+6*4, 128*8+7*4,
			160*8+0*4, 160*8+1*4, 160*8+2*4, 160*8+3*4, 160*8+4*4, 160*8+5*4, 160*8+6*4, 160*8+7*4);
  pt_y:array[0..31] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32,
			16*32, 17*32, 18*32, 19*32, 20*32, 21*32, 22*32, 23*32,
			64*32, 65*32, 66*32, 67*32, 68*32, 69*32, 70*32, 71*32,
			80*32, 81*32, 82*32, 83*32, 84*32, 85*32, 86*32, 87*32);
  pc_x:array[0..7] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4);
  pc_y:array[0..7] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32);
begin
iniciar_rygar:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=224;
p_final[1].x:=512;
p_final[1].y:=256;
p_final[2].x:=512;
p_final[2].y:=256;
p_final[2].trans:=true;
//chars
p_final[5].x:=256;
p_final[5].y:=256;
p_final[6].x:=256;
p_final[6].y:=256;
p_final[6].trans:=true;
//foreground
p_final[7].x:=512;
p_final[7].y:=256;
p_final[7].trans:=true;
iniciar_video;
//datos del scroll
scroll_data.long_x:=512;
scroll_data.long_y:=256;
scroll_data.ad_x:=48;
scroll_data.max_x:=256+48;
scroll_data.max_y:=256;
scroll_data.max_scr_x:=255;
//Main CPU
init_cpu(z80_main,0,6000000/llamadas_maquina.fps_max);
main_z80.daisy:=false;
main_z80_ll.getbyte:=rygar_getbyte;
main_z80_ll.putbyte:=rygar_putbyte;
main_z80_ll.outbyte:=nil;
main_z80_ll.inbyte:=nil;
//Sound CPU
init_cpu(z80_snd,1,4000000/llamadas_maquina.fps_max);
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=snd_getbyte;
snd_z80_ll.putbyte:=snd_putbyte;
snd_z80_ll.outbyte:=nil;
snd_z80_ll.inbyte:=nil;
init_timer(0,1,4000000/44100,snd_despues_instruccion,true);
//el chip ADPCM controla el tiempo
init_timer(1,1,0,snd_adpcm,true);
//Sound Chip
msm5205_init(0,385000,MSM5205_S48_4B,4000000,1,4);
ym3812_init(0,4000000);
ym3812_init_timers(4000000,1,0,snd_irq);
//cargar roms
if not(cargar_roms(@memoria_temp[0],@rygar_rom[0],'\rygar.zip',0)) then exit;
copymemory(@memoria[0],@memoria_temp[0],$8000);
copymemory(@memoria[$8000],@memoria_temp[$8000],$4000);
copymemory(@rom[0],@memoria_temp[$10000],$8000);
//cargar sonido
if not(cargar_roms(@mem_snd[0],@rygar_sound,'\rygar.zip',1)) then exit;
if not(cargar_roms(@mem_adpcm[0],@rygar_adpcm,'\rygar.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@rygar_char,'\rygar.zip',1)) then exit;
init_gfx(0,8,8,1024);
gfx[0].trans[0]:=true;
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=1;
des_sprites.pos_planos[2]:=2;
des_sprites.pos_planos[3]:=3;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@rygar_sprites[0],'\rygar.zip',0)) then exit;
//Sprites 32x32
init_gfx(2,32,32,256);
gfx[2].trans[0]:=true;
des_sprites.long_sprites:=512*8;
convert_sprites(@gfx[2],0,@memoria_temp[0],@pt_x[0],@pt_y[0],false,false);
//Sprites 16x16
init_gfx(1,16,16,1024);
gfx[1].trans[0]:=true;
des_sprites.long_sprites:=128*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//Sprites 8x8
init_gfx(4,8,8,4096);
gfx[4].trans[0]:=true;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[4],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//foreground
if not(cargar_roms(@memoria_temp[0],@rygar_tiles1[0],'\rygar.zip',0)) then exit;
init_gfx(3,16,16,2048);
gfx[3].trans[0]:=true;
des_sprites.long_sprites:=128*8;
des_sprites.banks:=2;
convert_sprites(@gfx[3],1024*16*16,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//background
if not(cargar_roms(@memoria_temp[0],@rygar_tiles2[0],'\rygar.zip',0)) then exit;
convert_sprites(@gfx[3],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
reset_rygar;
iniciar_rygar:=true;
end;

procedure rygar_principal;pascal;
var
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
  frame_m:=frame_m+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame_m));
  main_z80.pedir_irq:=true;
  frame_s:=frame_s+snd_z80.tframes;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_m:=frame_m-main_z80.contador;
  main_z80.contador:=0;
  frame_s:=frame_s-snd_z80.contador;
  snd_z80.contador:=0;
  update_video_rygar;
  actualiza_video;
  eventos_rygar;
  sincronizar;
  evaluar_entradas;
end;
end;

procedure cambiar_color(numero:word);
var
  color:tcolor;
  bit0,bit1,bit2,bit3:byte;
  pos:word;
begin
  pos:=(numero-$e800) shr 1;
  bit0:=(memoria[numero] shr 0) and 1;
  bit1:=(memoria[numero] shr 1) and 1;
  bit2:=(memoria[numero] shr 2) and 1;
  bit3:=(memoria[numero] shr 3) and 1;
  color.b:=bit0*$e+bit1*$1f+bit2*$43+bit3*$8f;
  bit0:=memoria[numero+1] and $1;
  bit1:=(memoria[numero+1] shr 1) and 1;
  bit2:=(memoria[numero+1] shr 2) and 1;
  bit3:=(memoria[numero+1] shr 3) and 1;
  color.g:=bit0*$e+bit1*$1f+bit2*$43+bit3*$8f;
  bit0:=(memoria[numero+1] shr 4) and 1;
  bit1:=(memoria[numero+1] shr 7) and 1;
  bit2:=(memoria[numero+1] shr 6) and 1;
  bit3:=(memoria[numero+1] shr 7) and 1;
  color.r:=bit0*$e+bit1*$1f+bit2*$43+bit3*$8f;
  poner_color(color,addr(paleta[pos]));
  case pos of
    256..511:fillmemory(@gfx[0].buffer[0],$400,1);
    512..767:fillmemory(@buffer_delante[0],$200,1);
    768..1023:fillmemory(@gfx[3].buffer[0],$200,1);
  end;
end;

function rygar_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $f000..$f7ff:rygar_getbyte:=rom[banco_rom+(direccion and $7ff)];
  $f800:rygar_getbyte:=in0;
  $f801:rygar_getbyte:=in1;
  $f804:rygar_getbyte:=in2;
  $f802..$f803,$f805..$f806,$f808:rygar_getbyte:=0;
  $f807:rygar_getbyte:=4;
  $f809:rygar_getbyte:=8;
  $f80f:rygar_getbyte:=0;
  else rygar_getbyte:=memoria[direccion];
end;
end;

procedure rygar_putbyte(direccion:word;valor:byte);pascal;
begin
if ((direccion<$c000) or ((direccion>$efff) and (direccion<$f800))) then exit;
memoria[direccion]:=valor;
case direccion of
    $d000..$d7ff:gfx[0].buffer[direccion and $3ff]:=true;
    $d800..$dbff:buffer_delante[direccion and $1ff]:=true;
    $dc00..$dfff:gfx[3].buffer[direccion and $1ff]:=true;
    $e800..$efff:if buffer_paleta[direccion and $7ff]<>valor then begin
                    cambiar_color(direccion and $fffe);
                    buffer_paleta[direccion and $7ff]:=valor;
                 end;
    $f800:scroll_x1.l:=valor;
    $f801:scroll_x1.h:=valor and 1;
    $f802:scroll_y1:=valor;
    $f803:scroll_x2.l:=valor;
    $f804:scroll_x2.h:=valor and 1;
    $f805:scroll_y2:=valor;
    $f806:begin
            soundlatch:=valor;
            snd_z80.pedir_nmi:=true;
          end;
    $f808:banco_rom:=(valor and $f8) shl 8;
end;
end;

function snd_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $c000:snd_getbyte:=soundlatch;
  else snd_getbyte:=mem_snd[direccion];
end;
end;

procedure snd_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$4000 then exit;
  case direccion of
     $8000:ym3812_control_port(0,valor);
     $8001:ym3812_write_port(0,valor);
     $c000:begin
              adpcm_pos:=(valor shl 8);
              msm5205_reset_w(0,0);
           end;
     $d000:adpcm_end:=((valor+1) shl 8);
  end;
mem_snd[direccion]:=valor;
end;

procedure snd_irq(numchip:integer;irqstate:integer);pascal;
begin
  snd_z80.pedir_irq:=(irqstate=1);
end;

procedure snd_despues_instruccion;pascal;
begin
  if not(hay_sonido) then exit;
  tsample[1][posicion_sonido]:=YM3812UpdateOne(0);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;

procedure snd_adpcm;pascal;
begin
if ((adpcm_pos>=adpcm_end) or	(adpcm_pos>$3fff)) then begin
		MSM5205_reset_w(0,1);
    exit;
end;
if (adpcm_data<>-1) then begin
		MSM5205_data_w(0,adpcm_data and $0f);
		adpcm_data:=-1;
end	else begin
		adpcm_data:=mem_adpcm[adpcm_pos];
    inc(adpcm_pos);
		MSM5205_data_w(0,(adpcm_data and $f0) shr 4);
end;
MSM5205_update(0,0);
end;

end.
