unit sbasketb;

interface
uses sdl,m6809,z80,constantes,entradas,sn_76496,vlm_5030,arcade_const,windows,timers,dac;

procedure Cargar_sbasketb;
procedure sbasketb_principal;pascal;
function sbasketb_getbyte(direccion:word): Byte; pascal;
procedure sbasketb_putbyte(direccion:word;valor:byte);pascal;
function iniciar_sbasketb:boolean;pascal;
procedure reset_sbasketb;pascal;
procedure cerrar_sbasketb;pascal;
procedure sbasketb_despues_instruccion;pascal;
procedure sbasketb_vlm_5030;pascal;
function sbasketb_snd_getbyte(direccion:word): Byte; pascal;
procedure sbasketb_snd_putbyte(direccion:word;valor:byte);pascal;

const
        sbasketb_rom:array[0..5] of tipo_roms=(
        (n:'405g05';l:$2000;p:$6000),(n:'405g04';l:$2000;p:$8000),
        (n:'405g03';l:$2000;p:$a000),(n:'405g02';l:$2000;p:$c000),
        (n:'405g01';l:$2000;p:$e000),(n:'';l:0;p:0));
        sbasketb_char:tipo_roms=(n:'405e12';l:$4000;p:0);
        sbasketb_sprites:array[0..6] of tipo_roms=(
        (n:'405e06';l:$2000;p:0),(n:'405e07';l:$2000;p:$2000),
        (n:'405e08';l:$2000;p:$4000),(n:'405e09';l:$2000;p:$6000),
        (n:'405e10';l:$2000;p:$8000),(n:'405e11';l:$2000;p:$a000),
        (n:'';l:0;p:0));
        sbasketb_pal:array[0..5] of tipo_roms=(
        (n:'405e17';l:$100;p:$0),(n:'405e16';l:$100;p:$100),
        (n:'405e18';l:$100;p:$200),(n:'405e20';l:$100;p:$300),
        (n:'405e19';l:$100;p:$400),(n:'';l:0;p:0));
        sbasketb_vlm:tipo_roms=(n:'405e15';l:$2000;p:$0);
        sbasketb_snd:tipo_roms=(n:'405e13';l:$2000;p:$0);

var
 pedir_snd_irq,pedir_irq:boolean;
 sound_latch,chip_latch:byte;
 scroll,sbasketb_palettebank,sprite_select:byte;
 mem_vlm:array[0..$1fff] of byte;
 mem_dec:array[0..$ffff] of byte;
 last_addr:word;

implementation
uses principal;

procedure Cargar_sbasketb;
begin
form1.superbasketball1.Checked:=true;
llamadas_maquina.caption:='Super Basketball';
llamadas_maquina.iniciar:=iniciar_sbasketb;
llamadas_maquina.bucle_general:=sbasketb_principal;
llamadas_maquina.cerrar:=cerrar_sbasketb;
llamadas_maquina.reset:=reset_sbasketb;
llamadas_maquina.canales_usados:=3;
end;

function iniciar_sbasketb:boolean;pascal;
var
      colores:tpaleta;
      f,j:word;
      ctemp1,ctemp2,ctemp3,ctemp4:byte;
      xormask:byte;
const
    pc_x:array[0..7] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4);
    pc_y:array[0..7] of dword=(0*4*8, 1*4*8, 2*4*8, 3*4*8, 4*4*8, 5*4*8, 6*4*8, 7*4*8);
    ps_x:array[0..15] of dword=(0*4, 1*4,  2*4,  3*4,  4*4,  5*4,  6*4,  7*4,
			8*4, 9*4, 10*4, 11*4, 12*4, 13*4, 14*4, 15*4);
    ps_y:array[0..15] of dword=(0*4*16, 1*4*16,  2*4*16,  3*4*16,  4*4*16,  5*4*16,  6*4*16,  7*4*16,
			8*4*16, 9*4*16, 10*4*16, 11*4*16, 12*4*16, 13*4*16, 14*4*16, 15*4*16);
begin
iniciar_sbasketb:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[2].x:=256;
p_final[2].y:=256;
iniciar_video;
//datos del scroll
scroll_data.long_x:=256;
scroll_data.ad_x:=256;
scroll_data.max_x:=256;
scroll_data.max_scr_x:=255;
//Main CPU
init_cpu(m6809_main,0,1400000/llamadas_maquina.fps_max);
main_6809_ll.getbyte:=sbasketb_getbyte;
main_6809_ll.putbyte:=sbasketb_putbyte;
//Sound CPU
init_cpu(z80_snd,1,3579545/llamadas_maquina.fps_max);
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=sbasketb_snd_getbyte;
snd_z80_ll.putbyte:=sbasketb_snd_putbyte;
snd_z80_ll.outbyte:=nil;
snd_z80_ll.inbyte:=nil;
//Sound Chip
SN76496_init(0,1789772);
//cargar rom sonido vlm
if not(cargar_roms(@mem_vlm[0],@sbasketb_vlm,'\sbasketb.zip',1)) then exit;
vlm5030_start(0,4,3579545,@mem_vlm[0],$2000);
//iniciar DAC
dac_start(0);
//Timers
//timer del vlm_5030 (tiene un sampleado distinto a lo habitual)
init_timer(0,1,3579545/(3579545/440),sbasketb_vlm_5030,true);
init_timer(1,1,3579545/44100,sbasketb_despues_instruccion,true);
//cargar roms
if not(cargar_roms(@memoria[0],@sbasketb_rom[0],'\sbasketb.zip',0)) then exit;
//desencriptar las roms
for f:=0 to $ffff do begin
  xormask:=0;
	if (f and $02)<>0 then xormask:=xormask or $80
	  else xormask:=xormask or $20;
	if (f and $08)<>0 then xormask:=xormask or $08
	  else xormask:=xormask or $02;
	mem_dec[f]:=memoria[f] xor xormask;
end;
//cargar snd roms
if not(cargar_roms(@mem_snd[0],@sbasketb_snd,'\sbasketb.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@sbasketb_char,'\sbasketb.zip',1)) then exit;
init_gfx(0,8,8,512);
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=1;
des_sprites.pos_planos[2]:=2;
des_sprites.pos_planos[3]:=3;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=8*4*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@sbasketb_sprites[0],'\sbasketb.zip',0)) then exit;
init_gfx(1,16,16,384);
gfx[1].trans[0]:=true;
des_sprites.long_sprites:=32*4*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
//paleta
if not(cargar_roms(@memoria_temp[0],@sbasketb_pal[0],'\sbasketb.zip',0)) then exit;
for f:=0 to $ff do begin
  ctemp1:=memoria_temp[f] and 1;
  ctemp2:=(memoria_temp[f] shr 1) and 1;
  ctemp3:=(memoria_temp[f] shr 2) and 1;
  ctemp4:=(memoria_temp[f] shr 3) and 1;
  colores[f].r:=ctemp1*$e+ctemp2*$1f+ctemp3*$43+ctemp4*$8f;
  ctemp1:=memoria_temp[f+$100] and 1;
  ctemp2:=(memoria_temp[f+$100] shr 1) and 1;
  ctemp3:=(memoria_temp[f+$100] shr 2) and 1;
  ctemp4:=(memoria_temp[f+$100] shr 3) and 1;
  colores[f].g:=ctemp1*$e+ctemp2*$1f+ctemp3*$43+ctemp4*$8f;
  ctemp1:=memoria_temp[f+$200] and 1;
  ctemp2:=(memoria_temp[f+$200] shr 1) and 1;
  ctemp3:=(memoria_temp[f+$200] shr 2) and 1;
  ctemp4:=(memoria_temp[f+$200] shr 3) and 1;
  colores[f].b:=ctemp1*$e+ctemp2*$1f+ctemp3*$43+ctemp4*$8f;
end;
poner_paleta(colores,256);
for f:=0 to 255 do gfx[0].colores[f]:=(memoria_temp[$300+f] and $f) or $f0;
for f:=0 to 255 do begin
		for j:=0 to 15 do
			gfx[1].colores[(j shl 8) or f]:=((j shl 4) or (memoria_temp[f + $400] and $0f));
end;
//final
reset_sbasketb;
iniciar_sbasketb:=true;
end;

procedure cerrar_sbasketb;pascal;
begin
cerrar_cpus;
SN76496_close(0);
vlm5030_close(0);
dac_close(0);
cerrar_audio;
cerrar_video;
end;

procedure reset_sbasketb;pascal;
begin
 reset_6809(main_6809,main_6809_ll);
 reset_audio;
 vlm5030_reset(0);
 dac_reset(0);
 zeromemory(@memoria[0],$5FFF);
 zeromemory(@mem_snd[$2000],$dfff);
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 pedir_snd_irq:=false;
 pedir_irq:=false;
 sound_latch:=0;
end;

procedure update_video_sbasketb;
var
  x,y:byte;
  f:word;
  nchar,color:word;
  long_x,offset:word;
begin
for f:=0 to $3ff do begin
   if gfx[0].buffer[f] then begin
      x:=31-(f div 32);
      y:=f mod 32;
      nchar:=memoria[$3400+f]+((memoria[$3000+f] and $20) shl 3);
      color:=(memoria[$3000+f] and $f) shl 4;
      put_gfx_flip(x*8,y*8,nchar,color,1,0,(memoria[$3000+f] and $80)<>0,(memoria[$3000+f] and $40)<>0);
      gfx[0].buffer[f]:=false;
   end;
end;
scroll__x(1,2,scroll);
offset:=(sprite_select and $1)*$100;
for f:=0 to $3f do begin
  nchar:=memoria[$3800+offset]+((memoria[$3801+offset] and $20) shl 3);
  y:=memoria[$3802+offset];
  x:=240-(memoria[$3803+offset]);
  color:=((memoria[$3801+offset] and $0f) + 16*sbasketb_palettebank) shl 4;
  put_gfx_sprite(nchar,color,(memoria[$3801+offset] and $80)<>0,(memoria[$3801+offset] and $40)<>0,1);
  actualiza_gfx_sprite(x,y,2,1);
  inc(offset,4);
end;
//La parte de arriba es fija...
actualiza_trozo(16,0,224,48,1,0,0,224,48,0);
actualiza_trozo(16,48,224,208,2,0,48,224,208,0);
end;

procedure eventos_sbasketb;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_DOWN] or joystick.arriba) then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if (teclado[SDLK_UP] or joystick.abajo) then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if (teclado[SDLK_RIGHT] or joystick.izq) then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if (teclado[SDLK_LEFT] or joystick.der) then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $df) else in1:=(in1 or $20);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if (teclado[SDLK_LSHIFT] or joystick.boton2) then in1:=(in1 and $bf) else in1:=(in1 or $40);
  if teclado[SDLK_1] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if teclado[SDLK_5] then in0:=(in0 and $fe) else in0:=(in0 or 1);
  if teclado[SDLK_2] then in0:=(in0 and $ef) else in0:=(in0 or $10);
end;
end;

procedure sbasketb_principal;pascal;
var
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
  frame_m:=frame_m+main_6809.tframes;
  run_6809(main_6809,main_6809_ll,trunc(frame_m));
  main_6809.pedir_irq:=pedir_irq;
  frame_m:=frame_m-main_6809.contador;
  main_6809.contador:=0;
  frame_s:=frame_s+snd_z80.tframes;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_s:=frame_s-snd_z80.contador;
  snd_z80.contador:=0;
  update_video_sbasketb;
  actualiza_video;
  eventos_sbasketb;
  sincronizar;
  evaluar_entradas;
end;
end;

function sbasketb_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $3e00:sbasketb_getbyte:=in0;
  $3e01:sbasketb_getbyte:=in1;
  $3e02:sbasketb_getbyte:=$ff;
  $3e80:sbasketb_getbyte:=$68;
  $3f00:sbasketb_getbyte:=$ff;
  else begin
    if main_6809.opcode then sbasketb_getbyte:=mem_dec[direccion]
      else sbasketb_getbyte:=memoria[direccion];
  end;
 end;
end;

procedure sbasketb_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion>$7FFF then exit;
memoria[direccion]:=valor;
case direccion of
  $3000..$37ff:gfx[0].buffer[direccion and $3ff]:=true;
  $3c20:sbasketb_palettebank:=valor;
  $3c81:pedir_irq:=(valor<>0);
  $3c85:sprite_select:=valor;
  $3d00:sound_latch:=valor;
  $3d80:snd_z80.pedir_irq:=true;
  $3f80:scroll:=256-valor;
end;
end;

procedure sbasketb_vlm_5030;pascal;
begin
if hay_sonido then vlm5030_update(0,1);
end;

procedure sbasketb_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=SN76496Update(0);
  tsample[2][posicion_sonido]:=DAC_update(0);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

function sbasketb_snd_getbyte(direccion:word): Byte; pascal;
var
  clock:integer;
begin
case direccion of
  $6000:sbasketb_snd_getbyte:=sound_latch;
  $8000:begin
          clock:=snd_z80.contador div 1024;
          sbasketb_snd_getbyte:=(clock and $3) or ((vLM5030_BSY(0) and 1) shl 2);
        end;
    else sbasketb_snd_getbyte:=mem_snd[direccion];
end;
end;

procedure sbasketb_snd_putbyte(direccion:word;valor:byte);pascal;
var
  changes,offset:integer;
begin
if direccion<$2000 then exit;
mem_snd[direccion]:=valor;
case direccion of
    $a000:VLM5030_data_w(0,valor);
    $c000..$dfff:begin
                  offset:=direccion and $1fff;
                  changes:=offset xor last_addr;
                  // A4 VLM5030 ST pin */
                  if (changes and $10)<>0 then VLM5030_ST(0,(offset and $10) shl 4);
                  // A5 VLM5030 RST pin */
                  if (changes and $20)<>0 then VLM5030_RST(0,(offset and $20) shl 5);
                  last_addr:=offset;
                 end;
    $e000:dac_data_w(0,valor);
    $e001:chip_latch:=valor;
    $e002:SN76496Write(0,chip_latch);
end;
end;

end.
