unit shootout;
interface
uses m6502,constantes,sdl,windows,entradas,ym_2203,arcade_const,timers;

procedure Cargar_shootout;
procedure principal_shootout;pascal;
function getbyte_shootout(direccion:word): Byte; pascal;
procedure putbyte_shootout(direccion:word;valor:byte);pascal;
function getbyte_snd_shootout(direccion:word): Byte; pascal;
procedure putbyte_snd_shootout(direccion:word;valor:byte);pascal;
function iniciar_shootout:boolean;pascal;
procedure cerrar_shootout;pascal;
procedure reset_shootout;pascal;
procedure shootout_despues_instruccion;pascal;
procedure snd_irq(numchip:integer;irqstate:integer);pascal;

const
        shootout_rom:array[0..3] of tipo_roms=(
        (n:'cu00.b1';l:$8000;p:$0),(n:'cu02.c3';l:$8000;p:$8000),
        (n:'cu01.c1';l:$4000;p:$10000),(n:'';l:0;p:0));
        shootout_char:tipo_roms=(n:'cu11.h19';l:$4000;p:$0);
        shootout_sprite:array[0..6] of tipo_roms=(
        (n:'cu04.c7';l:$8000;p:$0),(n:'cu03.c5';l:$8000;p:$8000),
        (n:'cu06.c10';l:$8000;p:$10000),(n:'cu05.c9';l:$8000;p:$18000),
        (n:'cu08.c13';l:$8000;p:$20000),(n:'cu07.c12';l:$8000;p:$28000),
        (n:'';l:0;p:0));
        shootout_audio:tipo_roms=(n:'cu09.j1';l:$4000;p:$c000);
        shootout_tiles:tipo_roms=(n:'cu10.h17';l:$8000;p:$0);
        shootout_pal:tipo_roms=(n:'gb08.k10';l:$100;p:$0);
var
  mem_bank:array[0..2,0..$3fff] of byte;
  mem_bank_dec:array[0..2,0..$3fff] of byte;
  mem_dec:array[0..$7fff] of byte;
  banco,sound_latch:byte;
  bflicker:boolean;

implementation
uses principal;

procedure Cargar_shootout;
begin
form1.shootout1.Checked:=true;
llamadas_maquina.caption:='Shoot Out';
llamadas_maquina.iniciar:=iniciar_shootout;
llamadas_maquina.bucle_general:=principal_shootout;
llamadas_maquina.cerrar:=cerrar_shootout;
llamadas_maquina.reset:=reset_shootout;
llamadas_maquina.fps_max:=60;
llamadas_maquina.canales_usados:=2;
end;

procedure sprites(prioridad:byte);
var
  f:word;
  nchar,x,y,atrib:word;
begin
bflicker:=not(bflicker);
for f:=0 to $127 do begin
 atrib:=memoria[$1801+(f*4)];
 if (atrib and 1)<>0 then begin
    if (bFlicker or ((atrib and $2)=0)) then begin
      if ((atrib and $8) shr 3)=prioridad then begin
        nchar:=memoria[$1803+(f*4)]+((atrib shl 3) and $700);
        x:=(240-memoria[$1802+(f*4)]) and $ff;
        y:=(240-memoria[$1800+(f*4)]) and $ff;
        if (atrib and $10)<>0 then begin //tamao doble
          nchar:=nchar and $fffe;
          put_gfx_sprite(nchar,64,(atrib and $4)<>0,false,1);
          actualiza_gfx_sprite(x,y-16,3,1);
          nchar:=nchar+1;
        end;
        put_gfx_sprite(nchar,64,(atrib and $4)<>0,false,1);
        actualiza_gfx_sprite(x,y,3,1);
      end;
    end;
 end;
end;
end;

procedure update_video_shootout;
var
  f,nchar,color:word;
  x,y:word;
begin
for f:=0 to $3ff do begin
  //tiles
  if gfx[2].buffer[f] then begin
    x:=f mod 32;
    y:=f div 32;
    color:=(memoria[$2c00+f] and $f0) shr 2;
    nchar:=memoria[$2800+f] + 256*(memoria[$2c00+f] and $07);
    put_gfx(x*8,y*8,nchar,color,2,2);
    gfx[2].buffer[f]:=false;
  end;
  //Chars
  if gfx[0].buffer[f] then begin
    x:=f mod 32;
    y:=f div 32;
    color:=(memoria[$2400+f] and $f0) shr 2;
    nchar:=memoria[$2000+f] + 256*(memoria[$2400+f] and $03);
    put_gfx_trans(x*8,y*8,nchar,color+128,1,0);
    gfx[0].buffer[f]:=false;
  end;
end;
actualiza_trozo(0,0,256,256,2,0,0,256,256,3);
sprites(1);
actualiza_trozo(0,0,256,256,1,0,0,256,256,3);
sprites(0);
actualiza_trozo(0,8,256,240,3,0,0,256,240,0);
end;

procedure eventos_shootout;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=in0 and $fe else in0:=in0 or 1;
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=in0 and $fd else in0:=in0 or 2;
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=in0 and $fb else in0:=in0 or 4;
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=in0 and $f7 else in0:=in0 or 8;
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=in0 and $ef else in0:=in0 or $10;
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in0:=in0 and $df else in0:=in0 or $20;
  if teclado[SDLK_5] then begin
      in2:=(in2 and $bf);
      main_6502.pedir_nmi:=true;
  end else in2:=(in2 or $40);
  if teclado[SDLK_1] then in0:=in0 and $bf else in0:=in0 or $40;
end;
end;

procedure principal_shootout;pascal;
var
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
 frame_m:=frame_m+main_6502.tframes;
 run_6502(main_6502,main_6502_ll,trunc(frame_m));
 in2:=in2 and $7f;
 frame_s:=frame_s+snd_6502.tframes;
 run_6502(snd_6502,snd_6502_ll,trunc(frame_s));
 //vblank
 frame_m:=frame_m-main_6502.contador+2500;
 run_6502(main_6502,main_6502_ll,trunc(frame_m));
 frame_m:=frame_m-2500;
 main_6502.contador:=0;
 in2:=in2 or $80;
 frame_s:=frame_s-snd_6502.contador+2500;
 run_6502(snd_6502,snd_6502_ll,trunc(frame_s));
 frame_s:=frame_s-2500;
 snd_6502.contador:=0;
 update_video_shootout;
 actualiza_video;
 eventos_shootout;
 sincronizar;
 evaluar_entradas;
end;
end;

function getbyte_shootout(direccion:word): Byte; pascal;
begin
case direccion of
  $1000:getbyte_shootout:=$bf;
  $1001:getbyte_shootout:=in0;
  $1002:getbyte_shootout:=$3f;
  $1003:getbyte_shootout:=in2;
  $4000..$7fff:if main_6502.opcode then getbyte_shootout:=mem_bank_dec[banco,direccion and $3fff]
                  else getbyte_shootout:=mem_bank[banco,direccion and $3fff];
  $8000..$ffff:if main_6502.opcode then getbyte_shootout:=mem_dec[direccion and $7fff]
                  else getbyte_shootout:=memoria[direccion];
  else getbyte_shootout:=memoria[direccion];
end;
end;

procedure putbyte_shootout(direccion:word;valor:byte);pascal;
begin
if direccion>$3fff then exit;
memoria[direccion]:=valor;
case direccion of
  $1000:banco:=valor and $f;
  $1003:begin
          sound_latch:=valor;
          snd_6502.pedir_nmi:=true;
        end;
  $2000..$27ff:gfx[0].buffer[direccion and $3ff]:=true;
  $2800..$2fff:gfx[2].buffer[direccion and $3ff]:=true;
end;
end;

function getbyte_snd_shootout(direccion:word): Byte; pascal;
begin
case direccion of
  $4000:getbyte_snd_shootout:=ym2203_read_status(0);
  $a000:getbyte_snd_shootout:=sound_latch;
  else getbyte_snd_shootout:=mem_snd[direccion];
end;
end;

procedure putbyte_snd_shootout(direccion:word;valor:byte);pascal;
begin
if direccion>$bfff then exit;
mem_snd[direccion]:=valor;
case direccion of
  $4000:ym2203_control(0,valor);
  $4001:ym2203_write_reg(0,valor);
end;
end;

function iniciar_shootout:boolean;pascal;
var
        colores:tpaleta;
        ctemp1,ctemp2,ctemp3:byte;
        f:word;
        mem_temp:array[0..$7fff] of byte;
const
    pc_x:array[0..7] of dword=(($2000*8)+0, ($2000*8)+1, ($2000*8)+2, ($2000*8)+3, 0, 1, 2, 3);
    pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
    ps_x:array[0..15] of dword=(128+0, 128+1, 128+2, 128+3, 128+4, 128+5, 128+6, 128+7, 0, 1, 2, 3, 4, 5, 6, 7);
    ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8, 8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
    pt_x:array[0..7] of dword=(($4000*8)+0, ($4000*8)+1, ($4000*8)+2, ($4000*8)+3, 0, 1, 2, 3);
    pt_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
begin
iniciar_shootout:=false;
iniciar_audio(1);
p_final[0].x:=256;
p_final[0].y:=240;
//Chars trans
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[3].x:=256;
p_final[3].y:=256;
iniciar_video;
//Main CPU
init_cpu(m6502_main,0,(2000000/llamadas_maquina.fps_max)-2500);
main_6502_ll.getbyte:=getbyte_shootout;
main_6502_ll.putbyte:=putbyte_shootout;
//sound CPU
init_cpu(m6502_snd,1,(1500000/llamadas_maquina.fps_max)-2500);
snd_6502_ll.getbyte:=getbyte_snd_shootout;
snd_6502_ll.putbyte:=putbyte_snd_shootout;
//Sound Chip
YM2203_init(0,2000000,1,nil,nil,nil,nil);
ym2203_init_timers(1500000,1,0,snd_irq);
//Timers
init_timer(0,1,1500000/44100,shootout_despues_instruccion,true);
//cargar roms
if not(cargar_roms(@memoria_temp[0],@shootout_rom[0],'\shootout.zip',0)) then exit;
//Copio las ROM en su sitio
copymemory(@memoria[$8000],@memoria_temp[0],$8000);
copymemory(@mem_bank[0,0],@memoria_temp[$8000],$4000);
copymemory(@mem_bank[1,0],@memoria_temp[$c000],$4000);
copymemory(@mem_bank[2,0],@memoria_temp[$10000],$4000);
//Y las desencripto
for f:=0 to $7fff do mem_dec[f]:=(memoria[f+$8000] and $9f) or ((memoria[f+$8000] and $40) shr 1) or ((memoria[f+$8000] and $20) shl 1);
for f:=0 to $3fff do begin
  mem_bank_dec[0,f]:=(mem_bank[0,f] and $9f) or ((mem_bank[0,f] and $40) shr 1) or ((mem_bank[0,f] and $20) shl 1);
  mem_bank_dec[1,f]:=(mem_bank[1,f] and $9f) or ((mem_bank[1,f] and $40) shr 1) or ((mem_bank[1,f] and $20) shl 1);
  mem_bank_dec[2,f]:=(mem_bank[2,f] and $9f) or ((mem_bank[2,f] and $40) shr 1) or ((mem_bank[2,f] and $20) shl 1);
end;
//Roms audio
if not(cargar_roms(@mem_snd[0],@shootout_audio,'\shootout.zip',1)) then exit;
//Cargar chars
if not(cargar_roms(@memoria_temp[0],@shootout_char,'\shootout.zip',1)) then exit;
init_gfx(0,8,8,1024);
gfx[0].trans[0]:=true;
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=$4;
des_sprites.bit_pixel:=2;
des_sprites.banks:=0;
des_sprites.long_sprites:=8*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@shootout_sprite[0],'\shootout.zip',0)) then exit;
init_gfx(1,16,16,2048);
gfx[1].trans[0]:=true;
des_sprites.bit_pixel:=3;
des_sprites.pos_planos[0]:=0*$10000*8;
des_sprites.pos_planos[1]:=1*$10000*8;
des_sprites.pos_planos[2]:=2*$10000*8;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//tiles
if not(cargar_roms(@memoria_temp[0],@shootout_tiles,'\shootout.zip',1)) then exit;
//mover para sacar tiles
copymemory(@mem_temp[0],@memoria_temp[0],$2000);
copymemory(@mem_temp[$4000],@memoria_temp[$2000],$2000);
copymemory(@mem_temp[$2000],@memoria_temp[$4000],$2000);
copymemory(@mem_temp[$6000],@memoria_temp[$6000],$2000);
init_gfx(2,8,8,2048);
gfx[2].trans[0]:=true;
des_sprites.bit_pixel:=2;
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=4;
des_sprites.long_sprites:=8*8;
convert_sprites(@gfx[2],0,@mem_temp[0],@pt_x[0],@pt_y[0],false,false);
//poner la paleta
if not(cargar_roms(@memoria_temp[0],@shootout_pal,'\shootout.zip',1)) then exit;
for f:=0 to 255 do begin
    ctemp1:=(memoria_temp[f] shr 0) and 1;
    ctemp2:=(memoria_temp[f] shr 1) and 1;
    ctemp3:=(memoria_temp[f] shr 2) and 1;
    colores[f].r:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
    ctemp1:=(memoria_temp[f] shr 3) and 1;
    ctemp2:=(memoria_temp[f] shr 4) and 1;
    ctemp3:=(memoria_temp[f] shr 5) and 1;
    colores[f].g:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
    ctemp1:=0;
    ctemp2:=(memoria_temp[f] shr 6) and 1;
    ctemp3:=(memoria_temp[f] shr 7) and 1;
    colores[f].b:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
end;
poner_paleta(colores,256);
//final
reset_shootout;
iniciar_shootout:=true;
end;

procedure cerrar_shootout;pascal;
begin
YM2203_close(0);
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_shootout;pascal;
begin
reset_6502(main_6502,main_6502_ll);
reset_6502(snd_6502,snd_6502_ll);
in0:=$ff;
in2:=$ff;
bflicker:=false;
end;

procedure shootout_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=YM2203UpdateOne(0);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

procedure snd_irq(numchip:integer;irqstate:integer);pascal;
begin
  snd_6502.pedir_irq:=(irqstate=1);
end;

end.
