unit sonson;

interface
uses sdl,m6809,z80,ay_8910,constantes,windows,entradas,arcade_const,sysutils,timers;

procedure Cargar_sonson;
procedure sonson_principal;pascal;
function sonson_getbyte(direccion:word): Byte; pascal;
procedure sonson_putbyte(direccion:word;valor:byte);pascal;
function ssonson_getbyte(direccion:word): Byte; pascal;
procedure ssonson_putbyte(direccion:word;valor:byte);pascal;
procedure sound_instruccion;pascal;
function iniciar_sonson:boolean;pascal;
procedure reset_sonson;pascal;
procedure cerrar_sonson;pascal;

const
        sonson_rom:array[0..3] of tipo_roms=(
        (n:'ss.01e';l:$4000;p:$4000),(n:'ss.02e';l:$4000;p:$8000),
        (n:'ss.03e';l:$4000;p:$c000),(n:'';l:0;p:0));
        sonson_sonido:tipo_roms=(n:'ss_6.c11';l:$2000;p:$e000);
        sonson_char:array[0..2] of tipo_roms=(
        (n:'ss_7.b6';l:$2000;p:0),(n:'ss_8.b5';l:$2000;p:$2000),
        (n:'';l:0;p:0));
        sonson_sprites:array[0..6] of tipo_roms=(
        (n:'ss_9.m5';l:$2000;p:0),(n:'ss_10.m6';l:$2000;p:$2000),(n:'ss_11.m3';l:$2000;p:$4000),
        (n:'ss_12.m4';l:$2000;p:$6000),(n:'ss_13.m1';l:$2000;p:$8000),(n:'ss_14.m2';l:$2000;p:$a000),
        (n:'';l:0;p:0));
        sonson_prom:array[0..4] of tipo_roms=(
        (n:'ssb4.b2';l:$20;p:0),(n:'ssb5.b1';l:$20;p:$20),
        (n:'ssb2.c4';l:$100;p:$40),(n:'ssb3.h7';l:$100;p:$140),
        (n:'';l:0;p:0));

var
 soundlatch,last:byte;
 scroll:byte;

implementation
uses principal;

procedure Cargar_sonson;
begin
form1.sonson1.Checked:=true;
llamadas_maquina.caption:='Son Son';
llamadas_maquina.iniciar:=iniciar_sonson;
llamadas_maquina.bucle_general:=sonson_principal;
llamadas_maquina.cerrar:=cerrar_sonson;
llamadas_maquina.reset:=reset_sonson;
llamadas_maquina.canales_usados:=2;
end;

function iniciar_sonson:boolean;pascal;
var
      colores:tpaleta;
      f:word;
      ctemp1,ctemp2,ctemp3,ctemp4:byte;
const
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
  ps_x:array[0..15] of dword=(8*16+7, 8*16+6, 8*16+5, 8*16+4, 8*16+3, 8*16+2, 8*16+1, 8*16+0,
			7, 6, 5, 4, 3, 2, 1, 0);
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
begin
iniciar_sonson:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=240;
p_final[0].y:=240;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[2].x:=256;
p_final[2].y:=256;
iniciar_video;
//datos del scroll
scroll_data.long_x:=256;
scroll_data.ad_x:=256;
scroll_data.max_x:=256;
scroll_data.max_scr_x:=255;
//Main CPU
init_cpu(m6809_main,0,2000000/llamadas_maquina.fps_max/4);
main_6809_ll.getbyte:=sonson_getbyte;
main_6809_ll.putbyte:=sonson_putbyte;
//Sound CPU
init_cpu(m6809_snd,1,2000000/llamadas_maquina.fps_max/4);
snd_6809_ll.getbyte:=ssonson_getbyte;
snd_6809_ll.putbyte:=ssonson_putbyte;
//Sound Chip
AY8910_init(1500000,0,nil,nil,nil,nil);
AY8910_init(1500000,1,nil,nil,nil,nil);
//Timers
init_timer(0,1,2000000/44100,sound_instruccion,true);
{cargar roms}
if not(cargar_roms(@memoria[0],@sonson_rom[0],'\sonson.zip',0)) then exit;
//Cargar Sound
if not(cargar_roms(@mem_snd[0],@sonson_sonido,'\sonson.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@sonson_char[0],'\sonson.zip',0)) then exit;
init_gfx(0,8,8,1024);
des_sprites.pos_planos[0]:=$2000*8;
des_sprites.pos_planos[1]:=0*8;
des_sprites.bit_pixel:=2;
des_sprites.banks:=0;
des_sprites.long_sprites:=8*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@sonson_sprites[0],'\sonson.zip',0)) then exit;
init_gfx(1,16,16,512);
gfx[1].trans[0]:=true;
des_sprites.pos_planos[0]:=$8000*8;
des_sprites.pos_planos[1]:=$4000*8;
des_sprites.pos_planos[2]:=0*8;
des_sprites.bit_pixel:=3;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//colores
if not(cargar_roms(@memoria_temp[0],@sonson_prom[0],'\sonson.zip',0)) then exit;
for f:=0 to 31 do begin
  ctemp1:=memoria_temp[$20+f] and 1;
  ctemp2:=(memoria_temp[$20+f] shr 1) and 1;
  ctemp3:=(memoria_temp[$20+f] shr 2) and 1;
  ctemp4:=(memoria_temp[$20+f] shr 3) and 1;
  colores[f].r:=$0e*ctemp1+$1f*ctemp2+$43*ctemp3+$8f*ctemp4;
  ctemp1:=(memoria_temp[f] shr 4) and 1;
  ctemp2:=(memoria_temp[f] shr 5) and 1;
  ctemp3:=(memoria_temp[f] shr 6) and 1;
  ctemp4:=(memoria_temp[f] shr 7) and 1;
  colores[f].g:=$0e*ctemp1+$1f*ctemp2+$43*ctemp3+$8f*ctemp4;
  ctemp1:=memoria_temp[f] and 1;
  ctemp2:=(memoria_temp[f] shr 1) and 1;
  ctemp3:=(memoria_temp[f] shr 2) and 1;
  ctemp4:=(memoria_temp[f] shr 3) and 1;
  colores[f].b:=$0e*ctemp1+$1f*ctemp2+$43*ctemp3+$8f*ctemp4;
end;
poner_paleta(colores,32);
for f:=0 to 255 do begin
  gfx[0].colores[f]:=memoria_temp[$40+f];
  gfx[1].colores[f]:=memoria_temp[$140+f]+16;
end;
//final
reset_sonson;
iniciar_sonson:=true;
end;

procedure cerrar_sonson;pascal;
begin
cerrar_cpus;
AY8910_close(0);
AY8910_close(1);
cerrar_audio;
cerrar_video;
end;

procedure reset_sonson;pascal;
begin
 reset_6809(main_6809,main_6809_ll);
 reset_6809(snd_6809,snd_6809_ll);
 reset_audio;
 AY8910_reset(0);
 AY8910_reset(1);
 zeromemory(@memoria[0],$3FFF);
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
end;

procedure update_video_sonson;
var
  f:word;
  x,y:byte;
  color,nchar:word;
begin
//chars
for f:=$0 to $3ff do begin
 if gfx[0].buffer[f] then begin
    y:=f div 32;
    x:=f mod 32;
    color:=memoria[$1400+f] and $fc;
    nchar:=memoria[$1000+f]+(256*(memoria[$1400+f] and $3));
    put_gfx(x*8,y*8,nchar,color,2,0);
    gfx[0].buffer[f]:=false;
 end;
end;
scroll__x(2,1,scroll);
actualiza_trozo(0,0,256,40,2,0,0,256,40,1);
//sprites
for f:=$17 downto 0 do begin
  nchar:=memoria[$2022+(f*4)]+((memoria[$2021+(f*4)] and $20) shl 3);
  color:=(memoria[$2021+(f*4)] and $1f) shl 3;
  x:=memoria[$2023+(f*4)];
  y:=memoria[$2020+(f*4)];
  put_gfx_sprite(nchar,color,(memoria[$2021+(f*4)] and $40)=0,(memoria[$2021+(f*4)] and $80)=0,1);
  actualiza_gfx_sprite(x,y,1,1);
end;
actualiza_trozo(8,8,240,240,1,0,0,240,240,0);
end;

procedure eventos_sonson;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=(in0 and $df) else in0:=(in0 or $20);
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if teclado[SDLK_5] then in2:=(in2 and $ef) else in2:=(in2 or $10);
  if teclado[SDLK_1] then in2:=(in2 and $fe) else in2:=(in2 or 1);
  if teclado[SDLK_2] then in2:=(in2 and $fd) else in2:=(in2 or 2);
end;
end;

procedure sonson_principal;pascal;
var
  f:byte;
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
  for f:=0 to 3 do begin
    frame_m:=frame_m+main_6809.tframes;
    run_6809(main_6809,main_6809_ll,trunc(frame_m));
    frame_s:=frame_s+snd_6809.tframes;
    run_6809(snd_6809,snd_6809_ll,trunc(frame_s));
    snd_6809.pedir_irq:=true;
    frame_m:=frame_m-main_6809.contador;
    main_6809.contador:=0;
    frame_s:=frame_s-snd_6809.contador;
    snd_6809.contador:=0;
  end;
  main_6809.pedir_irq:=true;
  update_video_sonson;
  actualiza_video;
  eventos_sonson;
  sincronizar;
  evaluar_entradas;
end;
end;

function sonson_getbyte(direccion:word): Byte; pascal;
begin
    case direccion of
        $3002:sonson_getbyte:=in0;
        $3003:sonson_getbyte:=in1;
        $3004:sonson_getbyte:=in2;
        $3005:sonson_getbyte:=$DF;
        $3006:sonson_getbyte:=$EB;
    else sonson_getbyte:=memoria[direccion];
    end;
end;

procedure sonson_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion>$3FFF then exit;
case direccion of
  $1000..$17ff:gfx[0].buffer[direccion and $3ff]:=true;
  $3000:scroll:=valor;
  $3010:soundlatch:=valor;
  $3019:begin
          if ((last=0) and (valor=1)) then snd_6809.pedir_firq:=true;
          last:=valor;
        end;
end;
memoria[direccion]:=valor;
end;

function ssonson_getbyte(direccion:word):Byte; pascal;
begin
if direccion=$a000 then ssonson_getbyte:=soundlatch
  else ssonson_getbyte:=mem_snd[direccion];
end;

procedure ssonson_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion>$dFFF then exit;
case direccion of
  $2000:AYControl(valor,0);
  $2001:AYWrite(valor,0);
  $4000:AYControl(valor,1);
  $4001:AYWrite(valor,1);
end;
mem_snd[direccion]:=valor;
end;

procedure sound_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=Renderbyte(0)^;
  tsample[1][posicion_sonido]:=renderbyte(1)^;
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
