unit starforce; //Senjyo

interface
uses sdl,z80,z80pio,z80daisy,constantes,windows,entradas,arcade_const,sn_76496,timers,z80ctc;

procedure Cargar_starforce;
procedure starforce_principal;pascal;
function starforce_getbyte(direccion:word): Byte; pascal;
procedure starforce_putbyte(direccion:word;valor:byte);pascal;
function snd_getbyte(direccion:word): Byte; pascal;
procedure snd_putbyte(direccion:word;valor:byte);pascal;
function snd_inbyte(puerto:word):byte;pascal;
procedure snd_outbyte(valor:byte;puerto:word);pascal;
procedure snd_despues_instruccion;pascal;
procedure snd_pio_ctc_int(state:byte);pascal;
function iniciar_starforce:boolean;pascal;
procedure reset_starforce;pascal;
procedure cerrar_starforce;pascal;

const
        starforce_rom:array[0..2] of tipo_roms=(
        (n:'starforc.3';l:$4000;p:0),(n:'starforc.2';l:$4000;p:$4000),
        (n:'';l:0;p:0));
        starforce_fg:array[0..3] of tipo_roms=(
        (n:'starforc.7';l:$1000;p:0),(n:'starforc.8';l:$1000;p:$1000),
        (n:'starforc.9';l:$1000;p:$2000),(n:'';l:0;p:0));
        starforce_bg1:array[0..3] of tipo_roms=(
        (n:'starforc.15';l:$2000;p:0),(n:'starforc.14';l:$2000;p:$2000),
        (n:'starforc.13';l:$2000;p:$4000),(n:'';l:0;p:0));
        starforce_bg2:array[0..3] of tipo_roms=(
        (n:'starforc.12';l:$2000;p:0),(n:'starforc.11';l:$2000;p:$2000),
        (n:'starforc.10';l:$2000;p:$4000),(n:'';l:0;p:0));
        starforce_bg3:array[0..3] of tipo_roms=(
        (n:'starforc.18';l:$1000;p:0),(n:'starforc.17';l:$1000;p:$1000),
        (n:'starforc.16';l:$1000;p:$2000),(n:'';l:0;p:0));
        starforce_sound:tipo_roms=(n:'starforc.1';l:$2000;p:0);
        starforce_sprites:array[0..3] of tipo_roms=(
        (n:'starforc.6';l:$4000;p:0),(n:'starforc.5';l:$4000;p:$4000),
        (n:'starforc.4';l:$4000;p:$8000),(n:'';l:0;p:0));
var
 x1,x2,x3:parejas;
 y1,y2,y3:byte;

implementation
uses principal;

procedure Cargar_starforce;
begin
form1.starforce1.Checked:=true;
llamadas_maquina.caption:='Star Force';
llamadas_maquina.iniciar:=iniciar_starforce;
llamadas_maquina.bucle_general:=starforce_principal;
llamadas_maquina.cerrar:=cerrar_starforce;
llamadas_maquina.reset:=reset_starforce;
llamadas_maquina.canales_usados:=3;
end;

procedure draw_sprites(prioridad:byte);
var
  nchar,x,y,color,f:word;
begin
for f:=$1f downto 0 do begin
  if ((memoria[$9801+(f*4)] and $30) shr 4)=prioridad then begin
    nchar:=memoria[$9800+(f*4)];
    y:=memoria[$9803+(f*4)];
    x:=memoria[$9802+(f*4)];
    color:=(memoria[$9801+(f*4)] and 7) shl 3+320;
    if (memoria[$9800+(f*4)] and $c0)<>$c0 then begin
      put_gfx_sprite(nchar,color,(memoria[$9801+(f*1)] and $40)<>0,(memoria[$9801+(f*4)] and $80)<>0,1);
      actualiza_gfx_sprite(x,y,1,1);
    end else begin
      put_gfx_sprite(nchar and $7f,color,(memoria[$9801+(f*1)] and $40)<>0,(memoria[$9801+(f*4)] and $80)<>0,2);
      actualiza_gfx_sprite(x,y,1,2);
    end;
  end;
end;
end;

procedure update_video_starforce;
var
        f,color,nchar:word;
        x,y:byte;
const
        color_code:array[0..7] of byte=(0,2*8,4*8,6*8,1*8,3*8,5*8,7*8);
begin
for f:=0 to $1ff do begin
      //bg3
      if gfx[3].buffer[f] then begin
        x:=31-(f div 16);
        y:=f mod 16;
        color:=((memoria[$a000+f] and $e0) shr 2)+192;
        nchar:=memoria[$a000+f]+512;
        put_gfx(x*16,y*16,nchar,color,2,3);
        gfx[3].buffer[f]:=false;
      end;
      //bg2
      if gfx[4].buffer[f] then begin
        x:=31-(f div 16);
        y:=f mod 16;
        color:=((memoria[$a800+f] and $e0) shr 2)+128;
        nchar:=memoria[$a800+f]+256;
        put_gfx_trans(x*16,y*16,nchar,color,7,3);
        gfx[4].buffer[f]:=false;
     end;
     //bg1
    if gfx[5].buffer[f] then begin
      x:=31-(f div 16);
      y:=f mod 16;
      color:=color_code[((memoria[$b000+f] and $e0) shr 5)]+64;
      nchar:=memoria[$b000+f];
      put_gfx_trans(x*16,y*16,nchar,color,8,3);
      gfx[5].buffer[f]:=false;
    end;
end;
//chars
for f:=0 to $3ff do begin
    if gfx[0].buffer[f] then begin
      x:=31-(f div 32);
      y:=f mod 32;
      color:=(memoria[$9400+f] and $7) shl 3;
      nchar:=memoria[$9000+f]+((memoria[$9400+f] and $10) shl 4);
      put_gfx_trans(x*8,y*8,nchar,color,6,0);
      gfx[0].buffer[f]:=false;
    end;
end;
draw_sprites(0);
scroll_x_y(2,1,x3.w,y3);
draw_sprites(1);
scroll_x_y(7,1,x2.w,y1);
draw_sprites(2);
scroll_x_y(8,1,x1.w,y1);
draw_sprites(3);
actualiza_trozo(0,0,256,256,6,0,0,256,256,1);
actualiza_trozo(16,0,224,256,1,0,0,224,256,0);
end;

procedure eventos_starforce;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=(in0 or 4) else in0:=(in0 and $fb);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=(in0 or 8) else in0:=(in0 and $f7);
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=(in0 or 2) else in0:=(in0 and $fd);
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=(in0 or 1) else in0:=(in0 and $fe);
  if teclado[SDLK_5] then in2:=(in2 or 1) else in2:=(in2 and $fe);
  if teclado[SDLK_1] then in2:=(in2 or 4) else in2:=(in2 and $fb);
  if teclado[SDLK_F12] then pasar_pantalla_completa;
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=(in0 or $10) else in0:=(in0 and $ef);
end;
end;

procedure cerrar_starforce;pascal;
begin
z80pio_close(0);
z80ctc_close(0);
cerrar_cpus;
SN76496_close(0);
SN76496_close(1);
SN76496_close(2);
cerrar_audio;
cerrar_video;
end;

procedure reset_starforce;pascal;
begin
 reset_z80(main_z80);
 reset_z80(snd_z80);
 reset_audio;
 zeromemory(@memoria[$8000],$7FFF);
 in0:=0;
 in1:=0;
 in2:=0;
end;

function iniciar_starforce:boolean;pascal;
const
  ps_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			8*8+0, 8*8+1, 8*8+2, 8*8+3, 8*8+4, 8*8+5, 8*8+6, 8*8+7);
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			16*8, 17*8, 18*8, 19*8, 20*8, 21*8, 22*8, 23*8);
  pbs_x:array[0..31] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			8*8+0, 8*8+1, 8*8+2, 8*8+3, 8*8+4, 8*8+5, 8*8+6, 8*8+7,
			32*8+0, 32*8+1, 32*8+2, 32*8+3, 32*8+4, 32*8+5, 32*8+6, 32*8+7,
			40*8+0, 40*8+1, 40*8+2, 40*8+3, 40*8+4, 40*8+5, 40*8+6, 40*8+7);
  pbs_y:array[0..31] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			16*8, 17*8, 18*8, 19*8, 20*8, 21*8, 22*8, 23*8,
			64*8, 65*8, 66*8, 67*8, 68*8, 69*8, 70*8, 71*8,
			80*8, 81*8, 82*8, 83*8, 84*8, 85*8, 86*8, 87*8);
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
var
  ptemp:pbyte;
begin
iniciar_starforce:=false;
iniciar_audio(1);
SN76496_init(0,2000000);
SN76496_init(1,2000000);
SN76496_init(2,2000000);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=256;
//bg3
p_final[2].x:=512;
p_final[2].y:=256;
//chars
p_final[6].x:=256;
p_final[6].y:=256;
p_final[6].trans:=true;
//bg2
p_final[7].x:=512;
p_final[7].y:=256;
p_final[7].trans:=true;
//bg1
p_final[8].x:=512;
p_final[8].y:=256;
p_final[8].trans:=true;
iniciar_video;
//datos del scroll
scroll_data.long_x:=512;
scroll_data.long_y:=256;
scroll_data.ad_y:=256;
scroll_data.max_x:=256;
scroll_data.max_y:=256;
scroll_data.max_scr_x:=255;
scroll_data.max_scr_y:=255;
//Main CPU
init_cpu(z80_main,0,4000000/llamadas_maquina.fps_max);
main_z80.daisy:=false;
main_z80_ll.getbyte:=starforce_getbyte;
main_z80_ll.putbyte:=starforce_putbyte;
main_z80_ll.outbyte:=nil;
main_z80_ll.inbyte:=nil;
//Sound CPU
init_cpu(z80_snd,1,2000000/llamadas_maquina.fps_max);
snd_z80.daisy:=true;
snd_z80_ll.getbyte:=snd_getbyte;
snd_z80_ll.putbyte:=snd_putbyte;
snd_z80_ll.outbyte:=snd_outbyte;
snd_z80_ll.inbyte:=snd_inbyte;
//Daisy Chain PIO+CTC
z80daisy_init;
z80ctc_add(0,0,1,2000000,NOTIMER_2,snd_pio_ctc_int,z80ctc_trg_w,nil,nil);
z80pio_add(1,0,snd_pio_ctc_int,nil,nil,nil,nil,nil,nil);
z80daisy_reset;
//Timers
init_timer(0,1,2000000/44100,snd_despues_instruccion,true);
//cargar roms
if not(cargar_roms(@memoria[0],@starforce_rom[0],'\starforc.zip',0)) then exit;
//cargar sonido
if not(cargar_roms(@mem_snd[0],@starforce_sound,'\starforc.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@starforce_fg[0],'\starforc.zip',0)) then exit;
init_gfx(0,8,8,512);
gfx[0].trans[0]:=true;
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=512*8*8;
des_sprites.pos_planos[2]:=2*512*8*8;
des_sprites.bit_pixel:=3;
des_sprites.banks:=0;
des_sprites.long_sprites:=8*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//big sprites
if not(cargar_roms(@memoria_temp[0],@starforce_sprites[0],'\starforc.zip',0)) then exit;
init_gfx(2,32,32,128);
gfx[2].trans[0]:=true;
des_sprites.pos_planos[1]:=128*32*32;
des_sprites.pos_planos[2]:=2*128*32*32;
des_sprites.long_sprites:=128*8;
convert_sprites(@gfx[2],0,@memoria_temp[0],@pbs_x[0],@pbs_y[0],true,false);
//sprites
init_gfx(1,16,16,512);
gfx[1].trans[0]:=true;
des_sprites.pos_planos[1]:=512*16*16;
des_sprites.pos_planos[2]:=2*512*16*16;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
//bg1
if not(cargar_roms(@memoria_temp[0],@starforce_bg1[0],'\starforc.zip',0)) then exit;
//Realmente son solo 640 elementos, pero debido al sistema pongo
//768
init_gfx(3,16,16,768);
gfx[3].trans[0]:=true;
des_sprites.pos_planos[1]:=256*16*16;
des_sprites.pos_planos[2]:=2*256*16*16;
des_sprites.banks:=3;
convert_sprites(@gfx[3],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
//bg2
if not(cargar_roms(@memoria_temp[0],@starforce_bg2[0],'\starforc.zip',0)) then exit;
convert_sprites(@gfx[3],256*16*16,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
//bg3
if not(cargar_roms(@memoria_temp[0],@starforce_bg3[0],'\starforc.zip',0)) then exit;
des_sprites.pos_planos[1]:=128*16*16;
des_sprites.pos_planos[2]:=2*128*16*16;
convert_sprites(@gfx[3],512*16*16,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
reset_starforce;
iniciar_starforce:=true;
end;

procedure starforce_principal;pascal;
var
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
  frame_m:=frame_m+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame_m));
  main_z80.pedir_irq:=true;
  frame_s:=frame_s+snd_z80.tframes;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_m:=frame_m-main_z80.contador;
  main_z80.contador:=0;
  frame_s:=frame_s-snd_z80.contador;
  snd_z80.contador:=0;
  update_video_starforce;
  actualiza_video;
  eventos_starforce;
  sincronizar;
  evaluar_entradas;
end;
end;

procedure cambiar_color(numero:word);
var
  i,c,data:byte;
  color:tcolor;
begin
  data:=memoria[numero];
  i:= (data shr 6) and $03;
	c:=(data shl 2) and $0c;
	if (c<>0) then c:=c or i;
	color.r:=c*$11;
	c:=(data shr 0) and $0c;
	if (c<>0) then c:=c or i;
	color.g:=c*$11;
	c:= (data shr 2) and $0c;
	if (c<>0) then c:=c or i;
	color.b:=c*$11;
  poner_color(color,addr(paleta[numero-$9c00]));
  case (numero-$9c00) of
    0..63:fillmemory(@gfx[0].buffer[0],$3ff,1);
    64..127:fillmemory(@gfx[5].buffer[0],$1ff,1);
    128..191:fillmemory(@gfx[4].buffer[0],$1ff,1);
    192..255:fillmemory(@gfx[3].buffer[0],$1ff,1);
  end;
end;

function starforce_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $d000:starforce_getbyte:=in0;
  $d001:starforce_getbyte:=in1;
  $d002:starforce_getbyte:=in2;
  $d004:starforce_getbyte:=0;
  $d005:starforce_getbyte:=$c0;
    else starforce_getbyte:=memoria[direccion];
end;
end;

procedure starforce_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$8000 then exit;
memoria[direccion]:=valor;
case direccion of
        $9000..$93ff:gfx[0].buffer[direccion and $3ff]:=true;
        $9c00..$9dff:if buffer_paleta[direccion and $1ff]<>valor then begin
                        cambiar_color(direccion);
                        buffer_paleta[direccion and $1ff]:=valor;
                     end;
        $9e20:x3.l:=256-valor;
        $9e21:x3.h:=valor;
        $9e25:y3:=valor;
        $9e27:begin
                //bg_stripe:=valor;
                //bg_stripe_mod:=true;
              end;
        $9e28:x2.l:=256-valor;
        $9e29:x2.h:=valor;
        $9e2d:y2:=valor;
        $9e30:x1.l:=256-valor;
        $9e31:x1.h:=valor;
        $9e35:y1:=valor;
        $a000..$a1ff:gfx[3].buffer[direccion and $1ff]:=true;
        $a800..$a9ff:gfx[4].buffer[direccion and $1ff]:=true;
        $b000..$b1ff:gfx[5].buffer[direccion and $1ff]:=true;
        $d004:z80pio_p_w(0,direccion,valor);
end;
end;

function snd_getbyte(direccion:word): Byte; pascal;
begin
//case direccion of
  snd_getbyte:=mem_snd[direccion];
end;

procedure snd_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$4000 then exit;
mem_snd[direccion]:=valor;
case direccion of
  $8000:SN76496Write(0,valor);
  $9000:SN76496Write(1,valor);
  $a000:SN76496Write(2,valor);
end;
end;

function snd_inbyte(puerto:word):byte;pascal;
begin
case (puerto and $FF) of
  0:snd_inbyte:=z80pio_d_r(0,0);
  1:snd_inbyte:=z80pio_c_r(0,0);
  2:snd_inbyte:=z80pio_d_r(0,1);
  3:snd_inbyte:=z80pio_c_r(0,1);
  8:snd_inbyte:=z80ctc_r(0,0);
  9:snd_inbyte:=z80ctc_r(0,1);
  $a:snd_inbyte:=z80ctc_r(0,2);
  $b:snd_inbyte:=z80ctc_r(0,3);
end;
end;

procedure snd_outbyte(valor:byte;puerto:word);pascal;
begin
case (puerto and $FF) of
  0:z80pio_d_w(0,0,valor);
  1:z80pio_c_w(0,0,valor);
  2:z80pio_d_w(0,1,valor);
  3:z80pio_c_w(0,1,valor);
  8:z80ctc_w(0,0,valor);
  9:z80ctc_w(0,1,valor);
  $a:z80ctc_w(0,2,valor);
  $b:z80ctc_w(0,3,valor);
end;
end;

procedure snd_pio_ctc_int(state:byte);pascal;
begin
  snd_z80.pedir_irq:=(state=1);
end;

procedure snd_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=SN76496Update(0);
  tsample[1][posicion_sonido]:=SN76496Update(1);
  tsample[2][posicion_sonido]:=SN76496Update(2);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
