unit system1;

interface
uses system1_misc,system2_misc,sdl,z80,constantes,windows,arcade_const,sn_76496;//,z80pio;

procedure Cargar_system1;
function snd_getbyte(direccion:word): Byte; pascal;
procedure snd_putbyte(direccion:word;valor:byte);pascal;
function system1_inbyte(puerto:word):byte;pascal;
procedure system1_outbyte(valor:byte;puerto:word);pascal;
procedure snd_despues_instruccion;pascal;
procedure reset_system1;pascal;
procedure cerrar_system1;pascal;
procedure draw_sprite(sprite_num:word);

var
 system1_videomode:byte;
 background_collision,sprites_collision:array[0..$3ff] of byte;
 sprite_onscreen_map:array[0..$ffff] of byte;
 memoria_sprites:array[0..$1ffff] of byte;
 mask_sprites:dword;
 mem_dec:array[0..$7fff] of byte;
 system1_sprite_offset:byte;
 sound_latch:byte;

implementation
uses principal;

procedure Cargar_system1;
var
  nombre:string;
begin
llamadas_maquina.iniciar:=iniciar_system1;
llamadas_maquina.bucle_general:=system1_principal;
case tipo_maquina of
  27:begin
        nombre:='Pitfall II';
        form1.PitfallII1.Checked:=true;
     end;
  35:begin
        nombre:='Teddy Boy Blues';
        form1.teddy1.Checked:=true;
     end;
  36:begin
        nombre:='Wonder Boy';
        form1.wboy1.Checked:=true;
     end;
  37:begin
        nombre:='Wonder Boy in Monster Land';
        form1.wbml1.Checked:=true;
        llamadas_maquina.iniciar:=iniciar_system2;
        llamadas_maquina.bucle_general:=system2_principal;
     end;
end;
llamadas_maquina.caption:=nombre;
llamadas_maquina.cerrar:=cerrar_system1;
llamadas_maquina.reset:=reset_system1;
llamadas_maquina.canales_usados:=2;
end;

procedure cerrar_system1;pascal;
begin
cerrar_cpus;
SN76496_close(0);
SN76496_close(1);
//z80pio_close(0);
cerrar_audio;
cerrar_video;
end;

procedure reset_system1;pascal;
begin
reset_z80(main_z80);
reset_z80(snd_z80);
reset_audio;
zeromemory(@memoria[$c000],$4000);
in0:=$ff;
in1:=$ff;
in2:=$ff;
rom_bank:=0;
bg_ram_bank_latch:=0;
bg_ram_bank:=0;
sound_latch:=0;
end;

function snd_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $e000..$efff:snd_getbyte:=sound_latch;
  else snd_getbyte:=mem_snd[direccion];
end;
end;

{function snd_getbyte_new(direccion:word): Byte; pascal;
begin
case direccion of
  $e000..$efff:snd_getbyte:=z80pio_p_r(0,0);
  else snd_getbyte:=mem_snd[direccion];
end;
end;}

procedure snd_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$8000 then exit;
mem_snd[direccion]:=valor;
case direccion of
  $a000..$afff:SN76496Write(0,valor);
  $c000..$cfff:SN76496Write(1,valor);
end;
end;

function system1_inbyte(puerto:word):byte;pascal;
begin
case (puerto and $ff) of
  $0:system1_inbyte:=in1;
  $4:system1_inbyte:=in2;
  $c,$e,$11:system1_inbyte:=$ff;
  $8:system1_inbyte:=in0;
  $d,$10:system1_inbyte:=$df;
  $16:system1_inbyte:=bg_ram_bank_latch;
  $15,$19:system1_inbyte:=system1_videomode;
end;
end;

procedure system1_outbyte(valor:byte;puerto:word);pascal;
begin
case (puerto and $ff) of
  $14,$18:begin
            sound_latch:=valor;
            snd_z80.pedir_nmi:=true;
          end;
  $15:begin
        rom_bank:=(valor and $c) shr 2;
        system1_videomode:=valor;
      end;
  $16:begin
        bg_ram_bank:=(valor shr 1) and $3;
        bg_ram_bank_latch:=valor;
      end;
  $19:system1_videomode:=valor;
end;
end;


{function system1_inbyte_new(puerto:word):byte;pascal;
begin
case (puerto and $1f) of
  $0:system1_inbyte:=in1;
  $4:system1_inbyte:=in2;
  $c,$e,$11:system1_inbyte:=$ff;
  $8:system1_inbyte:=in0;
  $d,$10:system1_inbyte:=$df;
  $18..$1b:z80pio_r(0,puerto and $1f);
end;
end;

procedure system1_outbyte_new(valor:byte;puerto:word);pascal;
begin
case (puerto and $1f) of
  $18..$1b:z80pio_w(0,puerto and $1f,valor);
end;
end;}

procedure snd_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=SN76496Update(0);
  tsample[1][posicion_sonido]:=SN76496Update(1);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

procedure draw_pixel(x,y,spr_number,color:integer);
var
	xr,yr:integer;
	sprite_onscreen:integer;
begin
	if ((x<0) or (x>255) or (y<0) or (y>255)) then exit;
	if (sprite_onscreen_map[256*y+x]<>$ff) then begin
		sprite_onscreen:=sprite_onscreen_map[256*y+x];
		sprites_collision[sprite_onscreen+32*spr_number]:=$ff;
	end;
	sprite_onscreen_map[256*y+x]:=spr_number;
  punbuf^:=paleta[color];
  putpixel(x,y,1,punbuf,2);
	xr:=((x-scroll_x) and $ff) div 8;
	yr:=((y-scroll_y) and $ff) div 8;
	if (memoria[$e000+(2*(32*yr+xr)+1)] and $10)<>0 then background_collision[$20+spr_number]:=$ff;
end;

procedure draw_sprite(sprite_num:word);
var
  sprite_base:integer;
  src,bank,height,row:integer;
  skip:integer;
  sy:integer;
  src2,x,y:integer;
  color1,color2,data:integer;
  gfx,temp:pbyte;
begin
sprite_base:=$10*sprite_num;
src:=memoria[$d006+sprite_base]+(memoria[$d007+sprite_base] shl 8);
bank:=$8000*(((memoria[$d003+sprite_base] and $80) shr 7) + ((memoria[$d003+sprite_base] and $40) shr 5));
bank:=bank and mask_sprites;	// limit to the range of available ROMs */
skip:=memoria[$d004+sprite_base]+(memoria[$d005+sprite_base] shl 8);
height:=memoria[$d001+sprite_base]-memoria[$d000+sprite_base];
sy:=memoria[$d000+sprite_base]+1;
gfx:=@memoria_sprites[bank];
for row:=0 to height-1 do begin
		src:=src+skip;
    src2:=src;
		x:=memoria[$d002+sprite_base]+((memoria[$d003+sprite_base] and $01) shl 8)+system1_sprite_offset;
		y:=sy+row;
		x:=x div 2;	// the hardware has sub-pixel placement, it seems */
    while (true) do begin
      temp:=gfx;
      inc(temp,(src2 and $7fff));
			data:=temp^;
			if (src and $8000)<>0 then begin
				src2:=src2-1;
				color1:=data and $0f;
				color2:=data shr 4;
			end else begin
				src2:=src2+1;
				color1:=data shr 4;
				color2:=data and $0f;
			end;
			if (color1=15) then break;
			if (color1<>0) then draw_pixel(x,y,sprite_num,sprite_base+color1);
			x:=x+1;
      if (color2=15) then break;
			if (color2<>0) then draw_pixel(x,y,sprite_num,sprite_base+color2);
			x:=x+1;
		end; //del while
	end; //del for
end;

end.
