unit system2_misc;

interface
uses sdl,constantes,windows,arcade_const,z80,sn_76496,timers,entradas;

const
    wbml_rom:array[0..3] of tipo_roms=(
        (n:'wbml.01';l:$10000;p:0),(n:'wbml.02';l:$10000;p:$10000),
        (n:'wbml.03';l:$10000;p:$20000),(n:'';l:0;p:0));
    wbml_char:array[0..3] of tipo_roms=(
        (n:'wbml.08';l:$8000;p:0),(n:'wbml.09';l:$8000;p:$8000),
        (n:'wbml.10';l:$8000;p:$10000),(n:'';l:0;p:0));
    wbml_sound:tipo_roms=(n:'epr11037.126';l:$8000;p:0);
    wbml_sprites:array[0..4] of tipo_roms=(
        (n:'epr11028.87';l:$8000;p:0),(n:'epr11027.86';l:$8000;p:$8000),
        (n:'epr11030.89';l:$8000;p:$10000),(n:'epr11029.88';l:$8000;p:$18000),
        (n:'';l:0;p:0));
    wbml_proms:array[0..3] of tipo_roms=(
        (n:'pr11026.20';l:$100;p:0),(n:'pr11025.14';l:$100;p:$100),
        (n:'pr11024.8';l:$100;p:$200),(n:'';l:0;p:0));

var
  bg_ram:array[0..$3fff] of byte;
  bg_ram_bank,bg_ram_bank_latch:byte;
  roms:array[0..3,0..$3fff] of byte;
  roms_dec:array[0..3,0..$3fff] of byte;
  memoria_proms:array[0..$2ff] of byte;
  rom_bank:byte;
  //Todas las pantallas estan en bg_ram por lo que creo un buffer
  //de escritura independiente
  bg_ram_w:array[0..$3fff] of boolean;

function iniciar_system2:boolean;pascal;
procedure system2_principal;pascal;
function wbml_getbyte(direccion:word): Byte; pascal;
procedure wbml_putbyte(direccion:word;valor:byte);pascal;

implementation
uses system1,principal;

procedure update_video_system2;
var
  f,color,nchar:word;
  x,y:integer;
  xscroll,yscroll:integer;
  page,startx,starty,row,col:integer;
  source:word;
  priority:boolean;
begin
//El fondo
xscroll:=(bg_ram[$7c0] shr 1) + ((bg_ram[$7c1] and 1) shl 7) - 256 + 5;
yscroll:=-bg_ram[$7ba];
for page:=0 to 3 do begin
	source:=(bg_ram[$0740+page*2] and $07)*$800;
  if (source>$7ff) then begin
		startx:=(page and 1)*256+xscroll;
		starty:=(page shr 1)*256+yscroll;
    row:=0;
		while (row<32*8) do begin
      col:=0;
			while (col<32*8) do begin
       if ((bg_ram_w[source]) or (bg_ram_w[source+1])) then begin
				x:=(startx+col) and $1ff;
        y:=(starty+row) and $1ff;
				nchar:=bg_ram[source]+(bg_ram[source+1] shl 8);
				priority:=(nchar and $800)<>0;
				nchar:= ((nchar shr 4) and $800) or (nchar and $7ff);
        color:=(((nchar shr 5) and $3f) + 64) shl 3;
        put_gfx(x,y,nchar,512+color,3,0);
        if priority then put_gfx_trans(x,y,nchar,512+color,1,0)
          else put_gfx_trans(x,y,0,512+color,1,0);
        bg_ram_w[source]:=false;
        bg_ram_w[source+1]:=false;
       end;
        inc(source,2);
        inc(col,8);
      end;
      inc(row,8);
		end;
  end;
end;
actualiza_trozo(0,0,256,256,3,0,0,256,256,2);
//Actualizar los sprites
fillmemory(@sprite_onscreen_map[0],256*256,255);
for f:=0 to 31 do
		if ((memoria[$d001+($10*f)]<>0) and ((memoria[$d001+($10*f)]-memoria[$d000+($10*f)])>0)) then draw_sprite(f);
//Prioridad del fondo
actualiza_trozo(0,0,256,256,1,0,0,256,256,2);
//Chars
for f:=0 to $37f do begin
   if ((bg_ram_w[f*2]) or (bg_ram_w[$1+(f*2)])) then begin
      x:=f mod 32;
      y:=f div 32;
      nchar:=(bg_ram[f*2]+(bg_ram[$1+(f*2)] shl 8));
      nchar:=((nchar shr 4) and $800) or (nchar and $7ff);
      color:=((nchar shr 5) and $3f) shl 3;
      put_gfx_trans(x*8,y*8,nchar,512+color,6,0);
      bg_ram_w[f*2]:=false;
      bg_ram_w[$1+(f*2)]:=false;
   end;
end;
actualiza_trozo(0,0,256,224,6,0,0,256,224,2);
//Pantalla final
actualiza_trozo(0,0,256,224,2,0,0,256,224,0);
end;

procedure eventos_system2;inline;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in1:=(in1 and $df) else in1:=(in1 or $20);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if (teclado[SDLK_LEFT] or joystick.izq) then in1:=(in1 and $7f) else in1:=(in1 or $80);
  if (teclado[SDLK_RIGHT] or joystick.der) then in1:=(in1 and $bf) else in1:=(in1 or $40);
  if teclado[SDLK_5] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if teclado[SDLK_1] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $fd) else in1:=(in1 or 2);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 and $fb) else in1:=(in1 or 4);
end;
end;

procedure system2_principal;pascal;
var
  f:byte;
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
  for f:=0 to 3 do begin
    frame_m:=frame_m+main_z80.tframes;
    run_z80(main_z80,main_z80_ll,trunc(frame_m));
    frame_m:=frame_m-main_z80.contador;
    main_z80.contador:=0;
    frame_s:=frame_s+snd_z80.tframes;
    run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
    frame_s:=frame_s-snd_z80.contador;
    snd_z80.contador:=0;
    snd_z80.pedir_irq:=true;
  end;
  main_z80.pedir_irq:=true;
  update_video_system2;
  actualiza_video;
  eventos_system2;
  sincronizar;
  evaluar_entradas;
end;
end;

function wbml_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $0..$7fff:if main_z80.opcode then wbml_getbyte:=mem_dec[direccion]
              else wbml_getbyte:=memoria[direccion];
  $8000..$bfff:if main_z80.opcode then wbml_getbyte:=roms_dec[rom_bank,direccion and $3fff] //Banked ROMS
                  else wbml_getbyte:=roms[rom_bank,direccion and $3fff];
  $e000..$efff:wbml_getbyte:=bg_ram[$1000*bg_ram_bank+(direccion and $fff)]; //banked bg
  $f000..$f3ff:wbml_getbyte:=background_collision[direccion and $3ff];
  $f800..$fbff:wbml_getbyte:=sprites_collision[direccion and $3ff];
  else wbml_getbyte:=memoria[direccion];
end;
end;

procedure cambiar_color(numero:byte;pos:word);inline;
var
  val,bit0,bit1,bit2,bit3:byte;
  color:tcolor;
begin
  val:=memoria_proms[numero+0];
  bit0:=(val shr 0) and $01;
  bit1:=(val shr 1) and $01;
  bit2:=(val shr 2) and $01;
  bit3:=(val shr 3) and $01;
  color.r:=$0e*bit0+$1f*bit1+$43*bit2+$8f*bit3;
  val:=memoria_proms[numero+$100];
  bit0:=(val shr 0) and $01;
  bit1:=(val shr 1) and $01;
  bit2:=(val shr 2) and $01;
  bit3:=(val shr 3) and $01;
  color.g:=$0e*bit0+$1f*bit1+$43*bit2+$8f*bit3;
  val:=memoria_proms[numero+$200];
  bit0:=(val shr 0) and $01;
  bit1:=(val shr 1) and $01;
  bit2:=(val shr 2) and $01;
  bit3:=(val shr 3) and $01;
  color.b:=$0e*bit0+$1f*bit1+$43*bit2+$8f*bit3;
  poner_color(color,addr(paleta[pos]));
  if pos>511 then fillmemory(@bg_ram_w[0],$4000,1);
end;

procedure wbml_putbyte(direccion:word;valor:byte);pascal;
var
  pos_bg:word;
begin
if direccion<$c000 then exit;
memoria[direccion]:=valor;
case direccion of
        $d800..$ddff:if buffer_paleta[direccion and $7ff]<>valor then begin
                        cambiar_color(valor,direccion-$d800);
                        buffer_paleta[direccion and $7ff]:=valor;
                     end;
        $e000..$efff:begin
                        pos_bg:=$1000*bg_ram_bank+(direccion and $fff);
                        bg_ram[pos_bg]:=valor;
                        if ((pos_bg=$0740) or (pos_bg=$0742) or (pos_bg=$0744) or (pos_bg=$0746)) then fillmemory(@bg_ram_w[$800],$3800,1)
                          else bg_ram_w[pos_bg]:=true;
                     end;
        $f000..$f3ff:background_collision[direccion and $3ff]:=$7e;
        $f800..$fbff:sprites_collision[direccion and $3ff]:=$7e;
end;
end;

function iniciar_system2:boolean;pascal;
const
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
var
  nombre_zip:string;
  f:byte;
  system2_rom:array[0..3] of tipo_roms;
  system2_char:array[0..6] of tipo_roms;
  system2_sound:tipo_roms;
  system2_sprites:array[0..4] of tipo_roms;
  system2_proms:array[0..3] of tipo_roms;
begin
mask_sprites:=$1ffff;
system1_sprite_offset:=1+7*2;
case tipo_maquina of
  37:begin
      nombre_zip:='\wbml.zip';
      for f:=0 to 3 do system2_rom[f]:=wbml_rom[f];
      for f:=0 to 4 do system2_char[f]:=wbml_char[f];
      system2_sound:=wbml_sound;
      for f:=0 to 4 do system2_sprites[f]:=wbml_sprites[f];
      for f:=0 to 3 do system2_proms[f]:=wbml_proms[f];
     end;
end;
iniciar_system2:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=224;
//Fondo normal y encima
p_final[1].x:=512+8; //La rutina de actualizacion se sale 8 pixels
p_final[1].y:=512+8;
p_final[1].trans:=true;
p_final[3].x:=512+8;
p_final[3].y:=512+8;
//Temporal
p_final[2].x:=256;
p_final[2].y:=256;
//Chars normal y encima
p_final[6].x:=256;
p_final[6].y:=224;
p_final[6].trans:=true;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,(4000000/llamadas_maquina.fps_max)/4);
main_z80.daisy:=false;
main_z80_ll.getbyte:=wbml_getbyte;
main_z80_ll.putbyte:=wbml_putbyte;
main_z80_ll.outbyte:=system1_outbyte;
main_z80_ll.inbyte:=system1_inbyte;
//Sound CPU
init_cpu(z80_snd,1,(4000000/llamadas_maquina.fps_max/4));
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=snd_getbyte;
snd_z80_ll.putbyte:=snd_putbyte;
snd_z80_ll.outbyte:=nil;
snd_z80_ll.inbyte:=nil;
//Sound Chip
SN76496_init(0,2000000);
SN76496_init(1,4000000);
//Timers
init_timer(0,1,4000000/44100,snd_despues_instruccion,true);
//cargar roms
if not(cargar_roms(@memoria_temp[0],@system2_rom[0],nombre_zip,0)) then exit;
//poner en su sitio las ROMS opcodes y datos
copymemory(@mem_dec[0],@memoria_temp[0],$8000); //opcodes
copymemory(@memoria[0],@memoria_temp[$8000],$8000);  //datos
//Bancos de ROM
copymemory(@roms_dec[0,0],@memoria_temp[$10000],$4000);
copymemory(@roms[0,0],@memoria_temp[$18000],$4000);
copymemory(@roms_dec[1,0],@memoria_temp[$14000],$4000);
copymemory(@roms[1,0],@memoria_temp[$1c000],$4000);
copymemory(@roms_dec[2,0],@memoria_temp[$20000],$4000);
copymemory(@roms[2,0],@memoria_temp[$28000],$4000);
copymemory(@roms_dec[3,0],@memoria_temp[$24000],$4000);
copymemory(@roms[3,0],@memoria_temp[$2c000],$4000);
//cargar sonido
if not(cargar_roms(@mem_snd[0],@system2_sound,nombre_zip,1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@system2_char[0],nombre_zip,0)) then exit;
init_gfx(0,8,8,4096);
gfx[0].trans[0]:=true;
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=$8000*8;
des_sprites.pos_planos[2]:=$10000*8;
des_sprites.bit_pixel:=3;
des_sprites.banks:=0;
des_sprites.long_sprites:=8*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//Meter los sprites en memoria
if not(cargar_roms(@memoria_sprites[0],@system2_sprites[0],nombre_zip,0)) then exit;
//Cargar lookup de la paleta
if not(cargar_roms(@memoria_proms[0],@system2_proms[0],nombre_zip,0)) then exit;
reset_system1;
iniciar_system2:=true;
end;

end.
