unit tehkanwc;

interface
uses sdl,z80,constantes,windows,entradas,arcade_const,timers,sysutils,ay_8910,msm5205;

procedure Cargar_tehkanwc;
procedure tehkanwc_principal;pascal;
function tehkanwc_getbyte(direccion:word): Byte; pascal;
procedure tehkanwc_putbyte(direccion:word;valor:byte);pascal;
function tehkanwc_misc_getbyte(direccion:word): Byte; pascal;
procedure tehkanwc_misc_putbyte(direccion:word;valor:byte);pascal;
function snd_getbyte(direccion:word): Byte; pascal;
procedure snd_putbyte(direccion:word;valor:byte);pascal;
function snd_inbyte(puerto:word):byte;pascal;
procedure snd_outbyte(valor:byte;puerto:word);pascal;
procedure snd_despues_instruccion;pascal;
function iniciar_tehkanwc:boolean;pascal;
procedure reset_tehkanwc;pascal;
procedure cerrar_tehkanwc;pascal;
procedure tehkan_porta_write(valor:byte);pascal;
procedure tehkan_portb_write(valor:byte);pascal;
function tehkan_porta_read:byte;pascal;
function tehkan_portb_read:byte;pascal;
procedure msm5205_sound;pascal;

const
        tehkanwc_rom:array[0..3] of tipo_roms=(
        (n:'twc-1.bin';l:$4000;p:0),(n:'twc-2.bin';l:$4000;p:$4000),
        (n:'twc-3.bin';l:$4000;p:$8000),(n:'';l:0;p:0));
        tehkanwc_cpu2:tipo_roms=(n:'twc-4.bin';l:$8000;p:0);
        tehkanwc_sound:tipo_roms=(n:'twc-6.bin';l:$4000;p:0);
        tehkanwc_chars:tipo_roms=(n:'twc-12.bin';l:$4000;p:0);
        tehkanwc_sprites:array[0..2] of tipo_roms=(
        (n:'twc-8.bin';l:$8000;p:0),(n:'twc-7.bin';l:$8000;p:$8000),
        (n:'';l:0;p:0));
        tehkanwc_tiles:array[0..2] of tipo_roms=(
        (n:'twc-11.bin';l:$8000;p:0),(n:'twc-9.bin';l:$8000;p:$8000),
        (n:'';l:0;p:0));
        tehkanwc_adpcm:tipo_roms=(n:'twc-5.bin';l:$4000;p:0);

var
 mem_misc:array[0..$ffff] of byte;
 scroll_x:parejas;
 sound_latch,sound_latch2,scroll_y:byte;
 sub_cpu_run:boolean;
 joy1:byte;
 msm_pos,msm_toggle,msm_data:word;
 mem_adpcm:array[0..$7fff] of byte;

implementation
uses principal;

procedure Cargar_tehkanwc;
begin
form1.tehkanwc1.Checked:=true;
llamadas_maquina.caption:='Tehkan World Cup';
llamadas_maquina.iniciar:=iniciar_tehkanwc;
llamadas_maquina.bucle_general:=tehkanwc_principal;
llamadas_maquina.cerrar:=cerrar_tehkanwc;
llamadas_maquina.reset:=reset_tehkanwc;
llamadas_maquina.canales_usados:=3;
end;

function iniciar_tehkanwc:boolean;pascal;
const
  ps_x:array[0..15] of dword=(1*4, 0*4, 3*4, 2*4, 5*4, 4*4, 7*4, 6*4,
			8*32+1*4, 8*32+0*4, 8*32+3*4, 8*32+2*4, 8*32+5*4, 8*32+4*4, 8*32+7*4, 8*32+6*4);
  ps_y:array[0..15] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32,
			16*32, 17*32, 18*32, 19*32, 20*32, 21*32, 22*32, 23*32);
  pc_x:array[0..7] of dword=(1*4, 0*4, 3*4, 2*4, 5*4, 4*4, 7*4, 6*4);
  pc_y:array[0..7] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32);
  clock=4608000;
  divisor=100;
begin
iniciar_tehkanwc:=false;
iniciar_audio(1);
p_final[0].x:=256;
p_final[0].y:=224;
p_final[1].x:=512;
p_final[1].y:=256;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[3].x:=256;
p_final[3].y:=256;
p_final[3].trans:=true;
p_final[4].x:=256;
p_final[4].y:=256;
p_final[4].trans:=true;
iniciar_video;
//datos del scroll
scroll_data.long_x:=512;
scroll_data.ad_x:=256;
scroll_data.max_x:=256;
scroll_data.max_scr_x:=255;
scroll_data.long_y:=256;
scroll_data.ad_y:=256;
scroll_data.max_y:=256;
scroll_data.max_scr_y:=255;
//Main CPU
init_cpu(z80_main,0,(clock/llamadas_maquina.fps_max)/divisor);
main_z80.daisy:=false;
main_z80_ll.getbyte:=tehkanwc_getbyte;
main_z80_ll.putbyte:=tehkanwc_putbyte;
main_z80_ll.outbyte:=nil;
main_z80_ll.inbyte:=nil;
//Misc CPU
init_cpu(z80_misc,1,(clock/llamadas_maquina.fps_max)/divisor);
misc_z80.daisy:=false;
misc_z80_ll.getbyte:=tehkanwc_misc_getbyte;
misc_z80_ll.putbyte:=tehkanwc_misc_putbyte;
misc_z80_ll.outbyte:=nil;
misc_z80_ll.inbyte:=nil;
//Sound CPU
init_cpu(z80_snd,2,(clock/llamadas_maquina.fps_max)/divisor);
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=snd_getbyte;
snd_z80_ll.putbyte:=snd_putbyte;
snd_z80_ll.outbyte:=snd_outbyte;
snd_z80_ll.inbyte:=snd_inbyte;
//Timers
init_timer(0,2,clock/44100,snd_despues_instruccion,true);
//No inicializo el tiempo, el msm5205 lo hace
init_timer(1,2,0,msm5205_sound,true);
//Sound Chip
AY8910_init(1536000,0,nil,nil,tehkan_porta_write,tehkan_portb_write);
AY8910_init(1536000,1,tehkan_porta_read,tehkan_portb_read,nil,nil);
Msm5205_init(0,384000,MSM5205_S48_4B,clock*2,1,8);
//cargar roms
if not(cargar_roms(@memoria[0],@tehkanwc_rom[0],'\tehkanwc.zip',0)) then exit;
//cargar cpu 2
if not(cargar_roms(@mem_misc[0],@tehkanwc_cpu2,'\tehkanwc.zip',1)) then exit;
//cargar sonido
if not(cargar_roms(@mem_snd[0],@tehkanwc_sound,'\tehkanwc.zip',1)) then exit;
//Cargar ADPCM
if not(cargar_roms(@mem_adpcm[0],@tehkanwc_adpcm,'\tehkanwc.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@tehkanwc_chars,'\tehkanwc.zip',1)) then exit;
init_gfx(0,8,8,512);
gfx[0].trans[0]:=true;
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=1;
des_sprites.pos_planos[2]:=2;
des_sprites.pos_planos[3]:=3;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@tehkanwc_sprites[0],'\tehkanwc.zip',0)) then exit;
init_gfx(1,16,16,512);
gfx[1].trans[0]:=true;
des_sprites.long_sprites:=128*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//tiles
if not(cargar_roms(@memoria_temp[0],@tehkanwc_tiles[0],'\tehkanwc.zip',0)) then exit;
init_gfx(2,16,8,1024);
gfx[2].trans[0]:=true;
des_sprites.long_sprites:=64*8;
convert_sprites(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
reset_tehkanwc;
iniciar_tehkanwc:=true;
end;

procedure update_video_tehkanwc;
var
        f,color,nchar:word;
        x,y:word;
begin
//background
for f:=0 to $3ff do begin
  if gfx[0].buffer[f] then begin
      x:=f mod 32;
      y:=f div 32;
      color:=(memoria[$e001+(f*2)] and $f) shl 4;
      nchar:=memoria[$e000+(f*2)]+((memoria[$e001+(f*2)] and $30) shl 4);
      put_gfx_flip(x*16,y*8,nchar,color+512,1,2,(memoria[$e001+(f*2)] and $40)<>0,(memoria[$e001+(f*2)] and $80)<>0);
      gfx[0].buffer[f]:=false;
  end;
end;
//chars
for f:=0 to $3ff do begin
  if gfx[2].buffer[f] then begin
      x:=f mod 32;
      y:=f div 32;
      color:=(memoria[$d400+f] and $f) shl 4;
      nchar:=memoria[$d000+f]+((memoria[$d400+f] and $10) shl 4);
      put_gfx_trans_flip(x*8,y*8,nchar,color,3,0,(memoria[$d400+f] and $40)<>0,(memoria[$d400+f] and $80)<>0);
      if (memoria[$d400+f] and $20)=0 then put_gfx_trans_flip(x*8,y*8,nchar,color,4,0,(memoria[$d400+f] and $40)<>0,(memoria[$d400+f] and $80)<>0)
        else put_gfx_trans(x*8,y*8,0,color,4,0);
      gfx[2].buffer[f]:=false;
  end;
end;
//chars de arriba
actualiza_trozo(0,0,256,256,3,0,0,256,256,2);
scroll_x_y(1,2,scroll_x.w,scroll_y);
//Sprites
for f:=0 to $ff do begin
  x:=(memoria[$e802+(f*4)])+(((memoria[$e801+(f*4)] and $20) shl 3)-128);
  y:=memoria[$e803+(f*4)];
  color:=(memoria[$e801+(f*4)] and $7) shl 4;
  nchar:=memoria[$e800+(f*4)]+((memoria[$e801+(f*4)] and $08) shl 5);
  put_gfx_sprite(nchar,color+256,(memoria[$e801+(f*4)] and $40)<>0,(memoria[$e801+(f*4)] and $80)<>0,1);
  actualiza_gfx_sprite(x,y,2,1);
end;
//Prioridad de los chars
actualiza_trozo(0,0,256,256,4,0,0,256,256,2);
actualiza_trozo(0,16,256,224,2,0,0,256,224,0);
end;

procedure eventos_tehkanwc;
begin
if (evento.teclado or evento.joystick) then begin
  //if (teclado[SDLK_UP] or joystick.arriba) then in0:=(in0 or 4) else in0:=(in0 and $fb);
  //if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=(in0 or 8) else in0:=(in0 and $f7);
  //if (teclado[SDLK_LEFT] or joystick.izq) then in0:=(in0 or 2) else in0:=(in0 and $fd);
  //if (teclado[SDLK_RIGHT] or joystick.der) then in0:=(in0 or 1) else in0:=(in0 and $fe);
  if teclado[SDLK_5] then in2:=(in2 and $fe) else in2:=(in2 or 1);
  if teclado[SDLK_1] then in2:=(in2 and $fb) else in2:=(in2 or 4);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $df) else in1:=(in1 or $20);
end;
end;

procedure cerrar_tehkanwc;pascal;
begin
cerrar_cpus;
cerrar_audio;
cerrar_video;
ay8910_close(0);
ay8910_close(1);
msm5205_close(0);
end;

procedure reset_tehkanwc;pascal;
begin
 reset_z80(main_z80);
 reset_z80(misc_z80);
 reset_z80(snd_z80);
 reset_audio;
 sub_cpu_run:=true;
 zeromemory(@memoria[$c000],$4000);
 zeromemory(@mem_misc[$8000],$8000);
 zeromemory(@mem_snd[$4000],$c000);
 in0:=0;
 in1:=$20;
 in2:=$f;
 msm_pos:=0;
 msm_toggle:=0;
end;

procedure tehkanwc_principal;pascal;
var
  frame_m,frame_s,frame_m2:single;
  f:word;
begin
iniciar_entradas;
frame_m:=0;
frame_m2:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
 for f:=0 to 99 do begin
  //CPU 1
  frame_m:=frame_m+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame_m));
  frame_m:=frame_m-main_z80.contador;
  main_z80.contador:=0;
  //CPU Sound
  frame_s:=frame_s+snd_z80.tframes;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_s:=frame_s-snd_z80.contador;
  snd_z80.contador:=0;
  //CPU 2
  frame_m2:=frame_m2+misc_z80.tframes;
  run_z80(misc_z80,misc_z80_ll,trunc(frame_m2));
  frame_m2:=frame_m2-misc_z80.contador;
  misc_z80.contador:=0;
 end;
  main_z80.pedir_irq:=true;
  misc_z80.pedir_irq:=true;
  snd_z80.pedir_irq:=true;
  update_video_tehkanwc;
  actualiza_video;
  eventos_tehkanwc;
  sincronizar;
  evaluar_entradas;
end;
end;

procedure cambiar_color(dir:word);
var
        tmp_color,bit0,bit1,bit2,bit3:byte;
        color:tcolor;
begin
  tmp_color:=memoria[dir+$d800];
  bit0:=((tmp_color shr 0) and 1)*$0e;
  bit1:=((tmp_color shr 1) and 1)*$1f;
  bit2:=((tmp_color shr 2) and 1)*$43;
  bit3:=((tmp_color shr 3) and 1)*$8f;
  color.b:=bit0+bit1+bit2+bit3;
  tmp_color:=memoria[dir+$d801];
  bit0:=((tmp_color shr 4) and 1)*$0e;
  bit1:=((tmp_color shr 5) and 1)*$1f;
  bit2:=((tmp_color shr 6) and 1)*$43;
  bit3:=((tmp_color shr 7) and 1)*$8f;
  color.g:=bit0+bit1+bit2+bit3;
  bit0:=((tmp_color shr 0) and 1)*$0e;
  bit1:=((tmp_color shr 1) and 1)*$1f;
  bit2:=((tmp_color shr 2) and 1)*$43;
  bit3:=((tmp_color shr 3) and 1)*$8f;
  color.r:=bit0+bit1+bit2+bit3;
  poner_color(color,addr(paleta[dir shr 1]));
  case (dir shr 1) of
    0..255:fillmemory(@gfx[0].buffer[0],$400,1);
    512..767:fillmemory(@gfx[2].buffer[0],$400,1);
  end;
end;

procedure mem_shared_w(direccion:word;valor:byte);
begin
case direccion of
    $800..$fff:gfx[2].buffer[direccion and $3ff]:=true;
    $1000..$17ff:cambiar_color(direccion and $7fe);
    $1800..$2000:gfx[0].buffer[(direccion and $7ff) shr 1]:=true;
    $2400:scroll_x.l:=valor;
    $2401:scroll_x.h:=valor and 1;
    $2402:scroll_y:=valor;
end;
end;

function tehkanwc_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $f802,$f806:tehkanwc_getbyte:=in2;
  $f803:tehkanwc_getbyte:=in1;
  $f813:tehkanwc_getbyte:=20;
  $f820:tehkanwc_getbyte:=sound_latch2;
  $f840,$f850,$f860:tehkanwc_getbyte:=$ff;
  $f870:tehkanwc_getbyte:=$f;
    else tehkanwc_getbyte:=memoria[direccion];
end;
end;

procedure tehkanwc_putbyte(direccion:word;valor:byte);pascal;
begin
memoria[direccion]:=valor;
case direccion of
    $0..$bfff:exit;
    $c800..$ec02:mem_shared_w(direccion-$c800,valor);
    $f820:begin
            sound_latch:=valor;
            snd_z80.pedir_nmi:=true;
          end;
    $f840:if valor<>0 then reset_z80(misc_z80);
end;
end;

function tehkanwc_misc_getbyte(direccion:word):Byte; pascal;
begin
case direccion of
  $c800..$ebff:tehkanwc_misc_getbyte:=memoria[direccion];
    else tehkanwc_misc_getbyte:=mem_misc[direccion];
end;
end;

procedure tehkanwc_misc_putbyte(direccion:word;valor:byte);pascal;
begin
case direccion of
    0..$7fff:exit;
    $c800..$ec02:begin
                    memoria[direccion]:=valor;
                    mem_shared_w(direccion-$c800,valor);
                 end;
    else mem_misc[direccion]:=valor;
end;
end;

function snd_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $c000:snd_getbyte:=sound_latch;
  else snd_getbyte:=mem_snd[direccion];
end;

end;

procedure snd_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$4000 then exit;
mem_snd[direccion]:=valor;
case direccion of
  $8001:if valor<>0 then MSM5205_reset_w(0,0)
            else MSM5205_reset_w(0,1);
  $c000:sound_latch2:=valor;
end;
end;

function snd_inbyte(puerto:word):byte;pascal;
begin
case (puerto and $ff) of
 0:snd_inbyte:=AYRead(0);
 1:snd_inbyte:=AYRead(1);
end;
end;

procedure snd_outbyte(valor:byte;puerto:word);pascal;
begin
case (puerto and $ff) of
  $0:AYWrite(valor,0);
  $1:AYControl(valor,0);
  $2:AYWrite(valor,1);
  $3:AYControl(valor,1);
end;
end;

procedure tehkan_porta_write(valor:byte);pascal;
begin
msm_pos:=(msm_pos and $ff00) or valor;
end;

procedure tehkan_portb_write(valor:byte);pascal;
begin
msm_pos:=(msm_pos and $00ff) or (valor shl 8);
end;

function tehkan_porta_read:byte;pascal;
begin
tehkan_porta_read:=msm_pos and $ff;
end;

function tehkan_portb_read:byte;pascal;
begin
tehkan_portb_read:=(msm_pos shr 8) and $ff;
end;

procedure msm5205_sound;pascal;
begin
msm_data:=mem_adpcm[msm_pos and $3fff];
if (msm_toggle=0) then begin
    MSM5205_data_w(0,(msm_data shr 4) and $0f);
end	else begin
    inc(msm_pos);
    MSM5205_data_w(0,msm_data and $f);
end;
msm_toggle:=msm_toggle xor 1;
msm5205_update(0,2);
end;

procedure snd_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=renderbyte(0)^;
  tsample[1][posicion_sonido]:=renderbyte(1)^;
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
