unit terracresta;

interface
uses sdl,z80,m68000,constantes,windows,entradas,arcade_const,timers,ym_2203,dac;

procedure Cargar_terracre;
procedure terracre_principal;pascal;
function terracre_getword(direccion:dword):word;pascal;
procedure terracre_putword(direccion:dword;valor:word);pascal;
function terracre_getbyte(direccion:dword):byte;pascal;
procedure terracre_putbyte(direccion:dword;valor:byte);pascal;
function iniciar_terracre:boolean;pascal;
procedure reset_terracre;pascal;
procedure cerrar_terracre;pascal;
function terracre_snd_getbyte(direccion:word): Byte; pascal;
procedure terracre_snd_putbyte(direccion:word;valor:byte);pascal;
procedure terracre_sound_act;pascal;
function terracre_snd_inbyte(puerto:word):byte;pascal;
procedure terracre_snd_outbyte(valor:byte;puerto:word);pascal;

const
        terracre_rom:array[0..8] of tipo_roms=(
        (n:'1a_4b.rom';l:$4000;p:1),(n:'1a_4d.rom';l:$4000;p:$0),
        (n:'1a_6b.rom';l:$4000;p:$8001),(n:'1a_6d.rom';l:$4000;p:$8000),
        (n:'1a_7b.rom';l:$4000;p:$10001),(n:'1a_7d.rom';l:$4000;p:$10000),
        (n:'1a_9b.rom';l:$4000;p:$18001),(n:'1a_9d.rom';l:$4000;p:$18000),(n:'';l:0;p:0));
        terracre_pal:array[0..5] of tipo_roms=(
        (n:'tc1a_10f.bin';l:$100;p:0),(n:'tc1a_11f.bin';l:$100;p:$100),(n:'tc1a_12f.bin';l:$100;p:$200),
        (n:'tc2a_2g.bin';l:$100;p:$300),(n:'tc2a_4e.bin';l:$100;p:$400),(n:'';l:0;p:0));
        terracre_char:tipo_roms=(n:'2a_16b.rom';l:$2000;p:0);
        terracre_sound:array[0..2] of tipo_roms=(
        (n:'tc2a_15b.bin';l:$4000;p:0),(n:'tc2a_17b.bin';l:$4000;p:$4000),(n:'';l:0;p:0));
        terracre_fondo:array[0..2] of tipo_roms=(
        (n:'1a_15f.rom';l:$8000;p:0),(n:'1a_17f.rom';l:$8000;p:$8000),(n:'';l:0;p:0));
        terracre_sprites:array[0..4] of tipo_roms=(
        (n:'2a_6e.rom';l:$4000;p:0),(n:'2a_7e.rom';l:$4000;p:$4000),(n:'2a_6g.rom';l:$4000;p:$8000),
        (n:'2a_7g.rom';l:$4000;p:$c000),(n:'';l:0;p:0));
        
var
 nmi_vblank:boolean;
 scroll_x,scroll_y:parejas;
 last:byte;
 rom:array[0..$1ffff] of byte;
 ram:array[0..$8fff] of byte;
 spritebank:array[0..$ff] of byte;
 sound_latch:byte;

implementation
uses principal;

procedure Cargar_terracre;
begin
form1.terracre1.Checked:=true;
llamadas_maquina.caption:='Terra Cresta';
llamadas_maquina.iniciar:=iniciar_terracre;
llamadas_maquina.bucle_general:=terracre_principal;
llamadas_maquina.cerrar:=cerrar_terracre;
llamadas_maquina.reset:=reset_terracre;
llamadas_maquina.canales_usados:=3;
end;

function iniciar_terracre:boolean;pascal;
var
      colores:tpaleta;
      f,j:word;
const
  pf_x:array[0..15] of dword=(4, 0, 12, 8, 20, 16, 28, 24,
		32+4, 32+0, 32+12, 32+8, 32+20, 32+16, 32+28, 32+24);
  pf_y:array[0..15] of dword=(0*64, 1*64, 2*64, 3*64, 4*64, 5*64, 6*64, 7*64,
		8*64, 9*64, 10*64, 11*64, 12*64, 13*64, 14*64, 15*64);
  pc_x:array[0..7] of dword=(1*4, 0*4, 3*4, 2*4, 5*4, 4*4, 7*4, 6*4);
  pc_y:array[0..7] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32);
  ps_x:array[0..15] of dword=(4, 0, 4+$8000*8, 0+$8000*8, 12, 8, 12+$8000*8, 8+$8000*8,
		20, 16, 20+$8000*8, 16+$8000*8, 28, 24, 28+$8000*8, 24+$8000*8);
  ps_y:array[0..15] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32,
          8*32, 9*32, 10*32, 11*32, 12*32, 13*32, 14*32, 15*32);
begin
iniciar_terracre:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=512;
p_final[1].y:=1024;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[2].trans:=true;
p_final[3].x:=256;
p_final[3].y:=256;
iniciar_video;
//datos del scroll
scroll_data.long_x:=512;
scroll_data.long_y:=1024;
scroll_data.max_x:=256;
scroll_data.max_y:=256;
scroll_data.max_scr_x:=255;
scroll_data.max_scr_y:=255;
//cargar roms
if not(cargar_roms16b(@rom[0],@terracre_rom[0],'\terracre.zip',0)) then exit;
//cargar sonido
if not(cargar_roms(@mem_snd[0],@terracre_sound[0],'\terracre.zip',0)) then exit;
//Main CPU
init_cpu(m68000_main,0,(8000000/llamadas_maquina.fps_max/128));
main_68000_ll.getword:=terracre_getword;
main_68000_ll.putword:=terracre_putword;
main_68000_ll.getbyte:=terracre_getbyte;
main_68000_ll.putbyte:=terracre_putbyte;
//Sound CPU
init_cpu(z80_snd,1,(4000000/llamadas_maquina.fps_max/128));
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=terracre_snd_getbyte;
snd_z80_ll.putbyte:=terracre_snd_putbyte;
snd_z80_ll.outbyte:=terracre_snd_outbyte;
snd_z80_ll.inbyte:=terracre_snd_inbyte;
//Sound Chips
YM2203_Init(0,4000000,2,nil,nil,nil,nil);
dac_start(0);
dac_start(1);
//Timers
init_timer(0,1,4000000/44100,terracre_sound_act,true);
//convertir chars
if not(cargar_roms(@memoria_temp[0],@terracre_char,'\terracre.zip',1)) then exit;
init_gfx(0,8,8,256);
gfx[0].trans[15]:=true;
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=1;
des_sprites.pos_planos[2]:=2;
des_sprites.pos_planos[3]:=3;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=32*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,true);
//convertir fondo
if not(cargar_roms(@memoria_temp[0],@terracre_fondo[0],'\terracre.zip',0)) then exit;
init_gfx(1,16,16,512);
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=1;
des_sprites.pos_planos[2]:=2;
des_sprites.pos_planos[3]:=3;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=64*16;
convert_sprites(@gfx[1],0,@memoria_temp[0],@pf_x[0],@pf_y[0],false,true);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@terracre_sprites[0],'\terracre.zip',0)) then exit;
init_gfx(2,16,16,512);
gfx[2].trans[0]:=true;
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=1;
des_sprites.pos_planos[2]:=2;
des_sprites.pos_planos[3]:=3;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=32*16;
convert_sprites(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,true);
//poner la paleta
if not(cargar_roms(@memoria_temp[0],@terracre_pal[0],'\terracre.zip',0)) then exit;
copymemory(@spritebank[0],@memoria_temp[$400],$100);
for f:=0 to 255 do begin
  colores[f].r:=$0e*((memoria_temp[f] shr 0) and 1) + $1f*((memoria_temp[f] shr 1) and 1) + $43*((memoria_temp[f] shr 2) and 1) + $8f*((memoria_temp[f] shr 3) and 1);
  colores[f].g:=$0e*((memoria_temp[f+$100] shr 0) and 1) + $1f*((memoria_temp[f+$100] shr 1) and 1) + $43*((memoria_temp[f+$100] shr 2) and 1) + $8f*((memoria_temp[f+$100] shr 3) and 1);
  colores[f].b:=$0e*((memoria_temp[f+$200] shr 0) and 1) + $1f*((memoria_temp[f+$200] shr 1) and 1) + $43*((memoria_temp[f+$200] shr 2) and 1) + $8f*((memoria_temp[f+$200] shr 3) and 1);
end;
poner_paleta(colores,256);
//color lookup de fondo
for f:=0 to 255 do
		if (f and 8)<>0 then gfx[1].colores[f]:=192+(f and $0f)+((f and $c0) shr 2)
		  else gfx[1].colores[f]:=192+(f and $0f)+((f and $30) shr 0);
//color lookup de sprites
for f:=0 to $ff do begin
		for j:=0 to $f do begin
			if (f and $8)<>0 then gfx[2].colores[f+j*$100]:=$80+((j and $0c) shl 2)+(memoria_temp[$300+f] and $0f)
			  else gfx[2].colores[f+j*$100]:=$80+((j and $03) shl 4)+(memoria_temp[$300+f] and $0f);
    end;
end;
//final
reset_terracre;
iniciar_terracre:=true;
end;

procedure update_video_terracre;
var
        f:word;
        color:word;
        x,y,nchar,atrib:word;
begin
//background
for f:=$0 to $7ff do begin
  if gfx[1].buffer[f] then begin
    x:=f mod 32;
    y:=63-(f div 32);
    nchar:=(ram[$2000+(f*2)] shl 8) or ram[$2001+(f*2)];
    color:=((nchar shr 11) and $f) shl 4;
    put_gfx(x*16,y*16,nchar and $1ff,color,1,1);
    gfx[1].buffer[f]:=false;
  end;
end;
scroll_x_y(1,3,scroll_x.w,768-scroll_y.w);
//sprites
for f:=0 to $3f do begin
    atrib:=(ram[(f*8)+4] shl 8)+ram[(f*8)+5];
		nchar:=ram[(f*8)+3]+((atrib and $2) shl 7);
	  y:=240-(ram[(f*8)+7]-$80+((atrib and 1) shl 8));
	  x:=240-(ram[(f*8)+1]);
    color:=((atrib and $f0) shr 4)+16*(spritebank[(nchar shr 1) and $ff] and $0f);
    put_gfx_sprite(nchar,color shl 4,(atrib and 8)<>0,(atrib and 4)<>0,2);
    actualiza_gfx_sprite(x,y,3,2);
end;
//foreground
for f:=$0 to $3ff do begin
 if gfx[0].buffer[f] then begin
    x:=f mod 32;
    y:=31-(f div 32);
    nchar:=ram[$8001+(f*2)];
    put_gfx_trans(x*8,y*8,nchar,0,2,0);
    gfx[0].buffer[f]:=false;
 end;
end;
actualiza_trozo(0,0,256,256,2,0,0,256,256,3);
actualiza_trozo(16,0,224,256,3,0,0,224,256,0);
end;

procedure eventos_terracre;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in1:=(in1 and $Fd) else in1:=(in1 or $2);
  if (teclado[SDLK_LEFT] or joystick.izq) then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if (teclado[SDLK_RIGHT] or joystick.der) then in1:=(in1 and $F7) else in1:=(in1 or $8);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 and $df) else in1:=(in1 or $20);
  if teclado[SDLK_5] then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if teclado[SDLK_1] then in0:=(in0 and $fe) else in0:=(in0 or $1);
end;
end;

procedure cerrar_terracre;pascal;
begin
cerrar_cpus;
YM2203_close(0);
dac_close(0);
dac_close(1);
cerrar_audio;
cerrar_video;
end;

procedure reset_terracre;pascal;
begin
 reset_68000(main_68000,main_68000_ll);
 reset_z80(snd_z80);
 YM2203_reset(0);
 dac_reset(0);
 dac_reset(1);
 reset_audio;
 zeromemory(@ram[$0],$9000);
 zeromemory(@mem_snd[$c000],$4000);
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 scroll_x.w:=0;
 scroll_y.w:=0;
 sound_latch:=0;
end;

procedure terracre_principal;pascal;
var
  frame_m,frame_s:single;
  f:byte;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
 for f:=0 to 127 do begin
  frame_m:=frame_m+main_68000.tframes;
  run_68000(main_68000,main_68000_ll,trunc(frame_m));
  frame_m:=frame_m-main_68000.contador;
  main_68000.contador:=0;
  frame_s:=frame_s+snd_z80.tframes;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  snd_z80.pedir_irq:=true;
  frame_s:=frame_s-snd_z80.contador;
  snd_z80.contador:=0;
 end;
 pedir_irq_68000(main_68000,1);
 update_video_terracre;
 actualiza_video;
 eventos_terracre;
 sincronizar;
 evaluar_entradas;
end;
end;

function terracre_getword(direccion:dword):word;pascal;
begin
case direccion of
    0..$1ffff:terracre_getword:=(rom[direccion] shl 8) or rom[direccion+1];
    $24000:terracre_getword:=in1;
    $24002:terracre_getword:=$ff;
    $24004:terracre_getword:=in0 shl 8;
    $24006:terracre_getword:=$ffdf;
  else terracre_getword:=ram[direccion+1-$20000] or (ram[direccion-$20000] shl 8);
end;
end;

procedure terracre_putword(direccion:dword;valor:word);pascal;
begin
case direccion of
    $0..$1ffff:exit;
    $22000..$22fff:begin
                  gfx[1].buffer[(direccion and $fff) shr 1]:=true;
                  gfx[1].buffer[(direccion+1 and $fff) shr 1]:=true;
                  ram[direccion-$20000]:=valor shr 8;
                  ram[direccion+1-$20000]:=valor and $ff;
                  end;
    $26002:scroll_y.w:=valor;
    $26004:scroll_x.w:=valor;
    $2600c:sound_latch:=((valor and $7f) shl 1) or 1;
    $28000..$287ff:begin
                  gfx[0].buffer[(direccion and $7ff) shr 1]:=true;
                  gfx[0].buffer[(direccion+1 and $7ff) shr 1]:=true;
                  ram[direccion-$20000]:=valor shr 8;
                  ram[direccion+1-$20000]:=valor and $ff;
                  end;
    else begin
      ram[direccion-$20000]:=valor shr 8;
      ram[direccion+1-$20000]:=valor and $ff;
    end;
  end;
end;

function terracre_getbyte(direccion:dword):byte;
begin
if direccion<$20000 then terracre_getbyte:=rom[direccion]
  else terracre_getbyte:=ram[direccion-$20000];
end;

procedure terracre_putbyte(direccion:dword;valor:byte);
begin
if direccion<$20000 then exit
   else ram[direccion-$20000]:=valor;
end;

function terracre_snd_getbyte(direccion:word): Byte; pascal;
begin
terracre_snd_getbyte:=mem_snd[direccion];
end;

procedure terracre_snd_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$c000 then exit
  else mem_snd[direccion]:=valor;
end;

function terracre_snd_inbyte(puerto:word):byte;pascal;
begin
  case (puerto and $ff) of
  4:begin
      sound_latch:=0;
      terracre_snd_inbyte:=0;
    end;
  6:terracre_snd_inbyte:=sound_latch;
  end;
end;

procedure terracre_snd_outbyte(valor:byte;puerto:word);pascal;
begin
case (puerto and $ff) of
  $0:ym2203_Control(0,valor);
  $1:ym2203_Write_Reg(0,valor);
  $2:DAC_signed_data_w(0,valor);
  $3:DAC_signed_data_w(1,valor);
end;
end;

procedure terracre_sound_act;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=ym2203UpdateOne(0);
  tsample[1][posicion_sonido]:=DAC_update(0);
  tsample[2][posicion_sonido]:=DAC_update(1);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
