unit tiger_road;

interface
uses sdl,m68000,constantes,windows,entradas,arcade_const,sysutils,z80,ym_2203,timers;

procedure Cargar_tigeroad;
procedure tigeroad_principal;pascal;
function tigeroad_getword(direccion:dword):word;pascal;
procedure tigeroad_putword(direccion:dword;valor:word);pascal;
function tigeroad_getbyte(direccion:dword):byte;pascal;
procedure tigeroad_putbyte(direccion:dword;valor:byte);pascal;
procedure f1dream_putword(direccion:dword;valor:word);pascal;
procedure f1dream_putbyte(direccion:dword;valor:byte);pascal;
function iniciar_tigeroad:boolean;pascal;
procedure reset_tigeroad;pascal;
procedure cerrar_tigeroad;pascal;
function tigeroad_snd_getbyte(direccion:word): Byte; pascal;
procedure tigeroad_snd_putbyte(direccion:word;valor:byte);pascal;
function tigeroad_snd_inbyte(puerto:word):byte;pascal;
procedure tigeroad_snd_outbyte(valor:byte;puerto:word);pascal;
procedure snd_irq(numchip:integer;irqstate:integer);pascal;
procedure tigeroad_despues_instruccion;pascal;

const
        //Tiger Road
        tigeroad_rom:array[0..2] of tipo_roms=(
        (n:'tru02.bin';l:$20000;p:0),(n:'tru04.bin';l:$20000;p:$1),(n:'';l:0;p:0));
        tigeroad_char:tipo_roms=(n:'tr01.bin';l:$8000;p:0);
        tigeroad_fondo:array[0..8] of tipo_roms=(
        (n:'tr-01a.bin';l:$20000;p:0),(n:'tr-04a.bin';l:$20000;p:$20000),
        (n:'tr-02a.bin';l:$20000;p:$40000),(n:'tr05.bin';l:$20000;p:$60000),
        (n:'tr-03a.bin';l:$20000;p:$80000),(n:'tr-06a.bin';l:$20000;p:$a0000),
        (n:'tr-07a.bin';l:$20000;p:$c0000),(n:'tr08.bin';l:$20000;p:$e0000),
        (n:'';l:0;p:0));
        tigeroad_fondo_rom:tipo_roms=(n:'tr13.bin';l:$8000;p:0);
        tigeroad_sprites:array[0..4] of tipo_roms=(
        (n:'tr-09a.bin';l:$20000;p:0),(n:'tr-10a.bin';l:$20000;p:$20000),
        (n:'tr-11a.bin';l:$20000;p:$40000),(n:'tr-12a.bin';l:$20000;p:$60000),
        (n:'';l:0;p:0));
        tigeroad_sound:tipo_roms=(n:'tru05.bin';l:$8000;p:0);
        //F1 Dream
        {f1dream_rom:array[0..2] of tipo_roms=(
        (n:'06j_02.bin';l:$20000;p:0),(n:'06k_03.bin';l:$20000;p:$1),(n:'';l:0;p:0));}
        f1dream_rom:array[0..4] of tipo_roms=(
        (n:'f1d_04.bin';l:$10000;p:0),(n:'f1d_05.bin';l:$10000;p:$1),
        (n:'f1d_02.bin';l:$10000;p:$20000),(n:'f1d_03.bin';l:$10000;p:$20001),
        (n:'';l:0;p:0));
        f1dream_char:tipo_roms=(n:'10d_01.bin';l:$8000;p:0);
        f1dream_fondo:array[0..6] of tipo_roms=(
        (n:'03f_12.bin';l:$10000;p:0),(n:'01f_10.bin';l:$10000;p:$10000),
        (n:'03h_14.bin';l:$10000;p:$20000),(n:'02f_11.bin';l:$10000;p:$30000),
        (n:'17f_09.bin';l:$10000;p:$40000),(n:'02h_13.bin';l:$10000;p:$50000),
        (n:'';l:0;p:0));
        f1dream_fondo_rom:tipo_roms=(n:'07l_15.bin';l:$8000;p:0);
        f1dream_sprites:array[0..4] of tipo_roms=(
        (n:'03b_06.bin';l:$10000;p:0),(n:'02b_05.bin';l:$10000;p:$10000),
        (n:'03d_08.bin';l:$10000;p:$20000),(n:'02d_07.bin';l:$10000;p:$30000),
        (n:'';l:0;p:0));
        f1dream_sound:tipo_roms=(n:'12k_04.bin';l:$8000;p:0);
        f1dream_613ea_lookup:array[0..15] of byte=(
          $52,$31,$a7,$43,$07,$8a,$b1,$66,$9f,$cc,$09,$4d,$33,$28,$d0,$25);
        f1dream_613eb_lookup:array[0..255] of byte=(
$01, $b5, $b6, $b6, $b6, $b6, $b6, $b6, $b7, $01, $b8, $2f, $2f, $2f, $2f, $b9,
$aa, $31, $ab, $ab, $ab, $ac, $ad, $ad, $ae, $af, $b0, $b1, $b2, $b3, $b4, $91,
$9c, $9d, $9e, $9f, $a0, $a1, $a2, $a3, $a4, $a5, $a6, $a7, $a8, $a9, $9b, $91,
$bc, $92, $0b, $09, $93, $94, $95, $96, $97, $73, $01, $98, $99, $9a, $9b, $91,
$bc, $7b, $0b, $08, $87, $88, $89, $8a, $7f, $8b, $8c, $8d, $8e, $8f, $90, $91,
$bd, $7b, $0b, $07, $7c, $7d, $7e, $01, $7f, $80, $81, $82, $83, $84, $85, $86,
$bc, $70, $0b, $06, $71, $72, $73, $01, $74, $0d, $75, $76, $77, $78, $79, $7a,
$bc, $ba, $0a, $05, $65, $66, $67, $68, $68, $69, $6a, $6b, $6c, $6d, $6e, $6f,
$bc, $59, $01, $04, $5a, $5b, $01, $5c, $5d, $5e, $5f, $60, $61, $62, $63, $64,
$14, $4d, $01, $03, $4e, $4f, $50, $51, $52, $01, $53, $54, $55, $56, $57, $58,
$14, $43, $01, $02, $44, $45, $46, $47, $48, $49, $bb, $4a, $4b, $4c, $01, $01,
$14, $2b, $01, $38, $39, $3a, $3b, $31, $3c, $3d, $3e, $3f, $40, $41, $42, $01,
$14, $2d, $01, $2e, $2f, $30, $31, $32, $33, $34, $35, $36, $01, $14, $37, $01,
$14, $21, $22, $23, $24, $25, $26, $27, $28, $29, $01, $01, $01, $2a, $2b, $2c,
$14, $15, $16, $17, $18, $19, $1a, $1b, $1c, $1d, $1e, $1e, $1e, $1e, $1f, $20,
$0c, $0d, $0e, $01, $0f, $10, $11, $12, $0d, $0d, $0d, $0d, $0d, $0d, $0d, $13);
        f1dream_17b74_lookup:array[0..127] of byte=(
$03, $40, $05, $80, $03, $80, $05, $a0, $03, $40, $05, $c0, $03, $80, $05, $e0,
$03, $40, $06, $00, $03, $80, $06, $20, $03, $40, $06, $40, $03, $80, $06, $60,
$00, $a0, $09, $e0, $00, $e0, $0a, $00, $00, $a0, $0a, $20, $00, $e0, $0a, $40,
$00, $a0, $0a, $60, $00, $e0, $0a, $80, $00, $a0, $0a, $a0, $00, $e0, $0a, $c0,
$03, $40, $05, $80, $03, $80, $05, $a0, $03, $40, $05, $c0, $03, $80, $05, $e0,
$03, $40, $06, $00, $03, $80, $06, $20, $03, $40, $06, $40, $03, $80, $06, $60,
$00, $a0, $09, $e0, $00, $e0, $0a, $00, $00, $a0, $0a, $20, $00, $e0, $0a, $40,
$00, $a0, $0a, $60, $00, $e0, $0a, $80, $00, $a0, $0a, $a0, $00, $e0, $0a, $c0);
        f1dream_2450_lookup:array[0..31] of byte=(
$03, $80, $06, $60, $00, $e0, $0a, $c0, $03, $80, $06, $60, $00, $e0, $0a, $c0,
$03, $80, $06, $60, $00, $e0, $0a, $c0, $03, $80, $06, $60, $00, $e0, $0a, $c0);


var
 scroll_x,scroll_y:parejas;
 rom:array[0..$3ffff] of byte;
 ram:array[0..$3fff] of byte;
 sprite_ram:array[0..$1010] of byte;
 video_ram:array[0..$7ff] of byte;
 palete_ram:array[0..$4ff] of byte;
 fondo_rom:array[0..$7fff] of byte;
 pintar_fondo:boolean;
 fondo_bank,sound_latch:byte;

implementation
uses principal;

procedure Cargar_tigeroad;
begin
case tipo_maquina of
  52:begin
      form1.tigerroad1.Checked:=true;
      llamadas_maquina.caption:='Tiger Road';
     end;
  53:begin
        form1.f1dream1.Checked:=true;
        llamadas_maquina.caption:='F1 Dream';
     end;
end;
llamadas_maquina.iniciar:=iniciar_tigeroad;
llamadas_maquina.bucle_general:=tigeroad_principal;
llamadas_maquina.cerrar:=cerrar_tigeroad;
llamadas_maquina.reset:=reset_tigeroad;
llamadas_maquina.fps_max:=60;
llamadas_maquina.canales_usados:=3;
end;

function iniciar_tigeroad:boolean;pascal;
var
  f:byte;
const
  pb_x:array[0..31] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3,
		64*8+0, 64*8+1, 64*8+2, 64*8+3, 64*8+8+0, 64*8+8+1, 64*8+8+2, 64*8+8+3,
		2*64*8+0, 2*64*8+1, 2*64*8+2, 2*64*8+3, 2*64*8+8+0, 2*64*8+8+1, 2*64*8+8+2, 2*64*8+8+3,
		3*64*8+0, 3*64*8+1, 3*64*8+2, 3*64*8+3, 3*64*8+8+0, 3*64*8+8+1, 3*64*8+8+2, 3*64*8+8+3);
  pb_y:array[0..31] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16,
		8*16, 9*16, 10*16, 11*16, 12*16, 13*16, 14*16, 15*16,
		16*16, 17*16, 18*16, 19*16, 20*16, 21*16, 22*16, 23*16,
		24*16, 25*16, 26*16, 27*16, 28*16, 29*16, 30*16, 31*16);
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3);
  pc_y:array[0..7] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16 );
  ps_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			16*8+0, 16*8+1, 16*8+2, 16*8+3, 16*8+4, 16*8+5, 16*8+6, 16*8+7 );
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8 );
begin
iniciar_tigeroad:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=224;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[2].x:=4096;
p_final[2].y:=4096;
p_final[3].x:=256;
p_final[3].y:=256;
p_final[4].x:=4096;
p_final[4].y:=4096;
p_final[4].trans:=true;
iniciar_video;
//datos del scroll
scroll_data.long_x:=4096;
scroll_data.long_y:=4096;
scroll_data.max_x:=256;
scroll_data.max_y:=256;
scroll_data.max_scr_x:=255;
scroll_data.max_scr_y:=255;
//Main CPU
init_cpu(m68000_main,0,10000000/llamadas_maquina.fps_max);
main_68000_ll.getword:=tigeroad_getword;
main_68000_ll.getbyte:=tigeroad_getbyte;
case tipo_maquina of
  52:begin
        main_68000_ll.putword:=tigeroad_putword;
        main_68000_ll.putbyte:=tigeroad_putbyte;
     end;
  53:begin
        main_68000_ll.putword:=f1dream_putword;
        main_68000_ll.putbyte:=f1dream_putbyte;
     end;
end;
//Sound CPU
init_cpu(z80_snd,1,3579545/llamadas_maquina.fps_max);
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=tigeroad_snd_getbyte;
snd_z80_ll.putbyte:=tigeroad_snd_putbyte;
snd_z80_ll.outbyte:=tigeroad_snd_outbyte;
snd_z80_ll.inbyte:=tigeroad_snd_inbyte;
//sound chips
YM2203_Init(0,3579545,1,nil,nil,nil,nil);
YM2203_Init(1,3579545,1,nil,nil,nil,nil);
ym2203_init_timers(3579545,1,0,snd_irq);
//Timers
init_timer(0,1,3579545/44100,tigeroad_despues_instruccion,true);
case tipo_maquina of
  52:begin
        if not(cargar_roms16b(@rom[0],@tigeroad_rom[0],'\tigeroad.zip',0)) then exit;
        if not(cargar_roms(@mem_snd[0],@tigeroad_sound,'\tigeroad.zip',1)) then exit;
        //convertir chars
        if not(cargar_roms(@memoria_temp[0],@tigeroad_char,'\tigeroad.zip',1)) then exit;
        init_gfx(0,8,8,$800);
        gfx[0].trans[3]:=true;
        des_sprites.pos_planos[0]:=4;
        des_sprites.pos_planos[1]:=0;
        des_sprites.bit_pixel:=2;
        des_sprites.banks:=0;
        des_sprites.long_sprites:=16*8;
        convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
        //background
        if not(cargar_roms(@fondo_rom[0],@tigeroad_fondo_rom,'\tigeroad.zip',1)) then exit;
        if not(cargar_roms(@memoria_temp[0],@tigeroad_fondo,'\tigeroad.zip',0)) then exit;
        init_gfx(1,32,32,$800);
        for f:=0 to 8 do gfx[1].trans[f]:=true;
        des_sprites.pos_planos[0]:=$400000+4;
        des_sprites.pos_planos[1]:=$400000+0;
        des_sprites.pos_planos[2]:=4;
        des_sprites.pos_planos[3]:=0;
        des_sprites.bit_pixel:=4;
        des_sprites.banks:=0;
        des_sprites.long_sprites:=256*8;
        convert_sprites(@gfx[1],0,@memoria_temp[0],@pb_x[0],@pb_y[0],false,false);
        //sprites
        if not(cargar_roms(@memoria_temp[0],@tigeroad_sprites,'\tigeroad.zip',0)) then exit;
        init_gfx(2,16,16,$1000);
        gfx[2].trans[15]:=true;
        des_sprites.pos_planos[0]:=$100000*3;
        des_sprites.pos_planos[1]:=$100000*2;
        des_sprites.pos_planos[2]:=$100000*1;
        des_sprites.pos_planos[3]:=$100000*0;
        des_sprites.bit_pixel:=4;
        des_sprites.banks:=0;
        des_sprites.long_sprites:=32*8;
        convert_sprites(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
     end;
  53:begin
        if not(cargar_roms16b(@rom[0],@f1dream_rom[0],'\f1dream.zip',0)) then exit;
        if not(cargar_roms(@mem_snd[0],@f1dream_sound,'\f1dream.zip',1)) then exit;
        //convertir chars
        if not(cargar_roms(@memoria_temp[0],@f1dream_char,'\f1dream.zip',1)) then exit;
        init_gfx(0,8,8,$800);
        gfx[0].trans[3]:=true;
        des_sprites.pos_planos[0]:=4;
        des_sprites.pos_planos[1]:=0;
        des_sprites.bit_pixel:=2;
        des_sprites.banks:=0;
        des_sprites.long_sprites:=16*8;
        convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
        //background
        if not(cargar_roms(@fondo_rom[0],@f1dream_fondo_rom,'\f1dream.zip',1)) then exit;
        if not(cargar_roms(@memoria_temp[0],@f1dream_fondo,'\f1dream.zip',0)) then exit;
        init_gfx(1,32,32,$300);
        for f:=0 to 8 do gfx[1].trans[f]:=true;
        des_sprites.pos_planos[0]:=$180000+4;
        des_sprites.pos_planos[1]:=$180000+0;
        des_sprites.pos_planos[2]:=4;
        des_sprites.pos_planos[3]:=0;
        des_sprites.bit_pixel:=4;
        des_sprites.banks:=0;
        des_sprites.long_sprites:=256*8;
        convert_sprites(@gfx[1],0,@memoria_temp[0],@pb_x[0],@pb_y[0],false,false);
        //sprites
        if not(cargar_roms(@memoria_temp[0],@f1dream_sprites,'\f1dream.zip',0)) then exit;
        init_gfx(2,16,16,$800);
        gfx[2].trans[15]:=true;
        des_sprites.pos_planos[0]:=$80000*3;
        des_sprites.pos_planos[1]:=$80000*2;
        des_sprites.pos_planos[2]:=$80000*1;
        des_sprites.pos_planos[3]:=$80000*0;
        des_sprites.bit_pixel:=4;
        des_sprites.banks:=0;
        des_sprites.long_sprites:=32*8;
        convert_sprites(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
     end;
end;
//final
reset_tigeroad;
iniciar_tigeroad:=true;
end;

procedure draw_fondo;
var
  f,x,y,nchar,color,atrib,pos:word;
  data:byte;
  y_min:word;
begin
y_min:=(3840-scroll_y.w) div 32;
y:=y_min;
x:=scroll_x.w div 32;
for f:=0 to $50 do begin
  pos:=2*(x mod 8)+16*((127-y) mod 8)+128*(x div 8)+2048*((127-y) div 8);
  data:=fondo_rom[pos];
  atrib:=fondo_rom[pos+1];
  nchar:= data + ((atrib and $c0) shl 2) + (fondo_bank shl 10);
  color:=(atrib and $0f) shl 4;
  put_gfx_flip(x*32,y*32,nchar,color,2,1,(atrib and $20)<>0,false);
  if (atrib and $10)<>0 then put_gfx_trans_flip(x*32,y*32,nchar,color,4,1,(atrib and $20)<>0,false)
    else put_gfx_trans(x*32,y*32,0,0,4,1);
  if (f mod 8)=7 then begin
      x:=(x+1) and $7f;
      y:=y_min;
  end else y:=(y+1) and $7f;
end;
pintar_fondo:=false;
end;

procedure update_video_tigeroad;
var
        f:word;
        color:word;
        x,y,nchar,atrib:word;
begin
//background
if pintar_fondo then draw_fondo;
scroll_x_y(2,3,scroll_x.w,3840-scroll_y.w);
//sprites
for f:=$9f downto 0 do begin
    nchar:=(sprite_ram[(f*8)] shl 8)+sprite_ram[(f*8)+1];
    if nchar=$fff then continue;
    atrib:=(sprite_ram[(f*8)+2] shl 8)+sprite_ram[(f*8)+3];
  	y:=((sprite_ram[(f*8)+4] shl 8)+sprite_ram[(f*8)+5]) and $1ff;
		x:=((sprite_ram[(f*8)+6] shl 8)+sprite_ram[(f*8)+7]) and $1ff;
    if x>240 then continue;
    if y>240 then continue;
		color:=(atrib shr 2) and $0f;
    put_gfx_sprite(nchar,256+(color shl 4),(atrib and 2)<>0,(atrib and 1)<>0,2);
    actualiza_gfx_sprite(x,240-y,3,2);
end;
scroll_x_y(4,3,scroll_x.w,3840-scroll_y.w);
//foreground
for f:=$0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    x:=f mod 32;
    y:=f div 32;
    atrib:=video_ram[f*2];
    nchar:=video_ram[(f*2)+1]+((atrib and $c0) shl 2)+((atrib and $20) shl 5);
    color:=512+((atrib and $f) shl 2);
    put_gfx_trans_flip(x*8,y*8,nchar,color,1,0,false,(atrib and $10)<>0);
    gfx[0].buffer[f]:=false;
  end;
end;
actualiza_trozo(0,0,256,256,1,0,0,256,256,3);
actualiza_trozo(0,16,256,224,3,0,0,256,224,0);
end;

procedure eventos_tigeroad;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=(in0 and $Fb) else in0:=(in0 or $4);
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=(in0 and $Fe) else in0:=(in0 or $1);
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=(in0 and $df) else in0:=(in0 or $20);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if teclado[SDLK_5] then in1:=(in1 and $bf) else in1:=(in1 or $40);
  if teclado[SDLK_1] then in1:=(in1 and $fe) else in1:=(in1 or $1);
end;
end;

procedure cerrar_tigeroad;pascal;
begin
cerrar_cpus;
ym2203_close(0);
ym2203_close(1);
cerrar_audio;
cerrar_video;
end;

procedure reset_tigeroad;pascal;
begin
 reset_68000(main_68000,main_68000_ll);
 reset_z80(snd_z80);
 ym2203_reset(0);
 ym2203_reset(1);
 reset_audio;
 in0:=$FF;
 in1:=$FF;
 if tipo_maquina=52 then in2:=$fb
  else in2:=$bb;
 scroll_x.w:=0;
 scroll_y.w:=0;
 pintar_fondo:=true;
 fondo_bank:=0;
 sound_latch:=0;
end;

procedure tigeroad_principal;pascal;
var
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
  frame_m:=frame_m+main_68000.tframes;
  run_68000(main_68000,main_68000_ll,trunc(frame_m));
  frame_m:=frame_m-main_68000.contador;
  main_68000.contador:=0;
  frame_s:=frame_s+snd_z80.tframes;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_s:=frame_s-snd_z80.contador;
  snd_z80.contador:=0;
  pedir_irq_68000(main_68000,2);
  update_video_tigeroad;
  actualiza_video;
  eventos_tigeroad;
  sincronizar;
  evaluar_entradas;
  //form1.statusbar1.Panels[2].Text:=inttostr(sound_latch);
end;
end;

procedure cambiar_color(tmp_color,numero:word);
var
        bit0,bit1,bit2,bit3:byte;
        color:tcolor;
begin
  bit0:=(tmp_color shr 8) and 1;
  bit1:=(tmp_color shr 9) and 1;
  bit2:=(tmp_color shr 10) and 1;
  bit3:=(tmp_color shr 11) and 1;
  color.r:=$0e*bit0+$1f*bit1+$43*bit2+$8f*bit3;
  bit0:=(tmp_color shr 4) and 1;
  bit1:=(tmp_color shr 5) and 1;
  bit2:=(tmp_color shr 6) and 1;
  bit3:=(tmp_color shr 7) and 1;
  color.g:=$0e*bit0+$1f*bit1+$43*bit2+$8f*bit3;
  bit0:=(tmp_color shr 0) and 1;
  bit1:=(tmp_color shr 1) and 1;
  bit2:=(tmp_color shr 2) and 1;
  bit3:=(tmp_color shr 3) and 1;
  color.b:=$0e*bit0+$1f*bit1+$43*bit2+$8f*bit3;
  poner_color(color,addr(paleta[numero]));
  case numero of
    0..$ff:pintar_fondo:=true;
    512..575:fillmemory(@gfx[0].buffer[0],$400,1);
  end;
end;

function tigeroad_getword(direccion:dword):word;pascal;
var
  valor:word;
begin
direccion:=direccion and $ffffff;
case direccion of
  0..$3ffff:begin
              valor:=rom[direccion+1];
              valor:=valor or (rom[direccion] shl 8);
            end;
  $fe4000:valor:=$ff00 or in0;
  $fe4002:valor:=(in1 shl 8) or $ff;
  $fe4004:valor:=(in2 shl 8) or $ff;
  $fe0800..$fe1807:begin
                      valor:=sprite_ram[(direccion-$fe0800)+1];
                      valor:=valor or (sprite_ram[direccion-$fe0800] shl 8);
                   end;
  $fec000..$fec7ff:begin
                      valor:=video_ram[(direccion and $7ff)+1];
                      valor:=valor or (video_ram[direccion and $7ff] shl 8);
                   end;
  $ff8200..$ff867f:begin
                      valor:=palete_ram[(direccion-$ff8200)+1];
                      valor:=valor or (palete_ram[direccion-$ff8200] shl 8);
                   end;
  $ffc000..$ffffff:begin
                      valor:=ram[(direccion-$ffc000)+1];
                      valor:=valor or (ram[direccion-$ffc000] shl 8);
                   end;
end;
tigeroad_getword:=valor;
end;

procedure tigeroad_putword(direccion:dword;valor:word);pascal;
begin
direccion:=direccion and $ffffff;
case direccion of
  $0..$3ffff:exit;
  $fe0800..$fe1807:begin
                      sprite_ram[(direccion-$fe0800)+1]:=valor and $ff;
                      sprite_ram[direccion-$fe0800]:=valor shr 8;
                   end;
  $ff8200..$ff867f:begin
                      palete_ram[(direccion-$ff8200)+1]:=valor and $ff;
                      palete_ram[direccion-$ff8200]:=valor shr 8;
                      cambiar_color(valor,((direccion-$ff8200) div 2));
                    end;
  $fe8000:scroll_x.w:=valor;
  $fe8002:scroll_y.w:=valor;
  $fec000..$fec7ff:begin
                      video_ram[(direccion and $7ff)+1]:=valor and $ff;
                      video_ram[direccion and $7ff]:=valor shr 8;
                      gfx[0].buffer[(direccion and $7ff) div 2]:=true;
                   end;
  $ffc000..$ffffff:begin
                      ram[(direccion-$ffc000)+1]:=valor and $ff;
                      ram[direccion-$ffc000]:=valor shr 8;
                   end;
end;
end;

function tigeroad_getbyte(direccion:dword):byte;
begin
direccion:=direccion and $ffffff;
case direccion of
  0..$3ffff:tigeroad_getbyte:=rom[direccion];
  $fe4001:tigeroad_getbyte:=in0;
  $fe4000,$fe4003,$fe4005:tigeroad_getbyte:=$ff;
  $fe4002:tigeroad_getbyte:=in1;
  $fe4004:tigeroad_getbyte:=in2;
  $fe0800..$fe1807:tigeroad_getbyte:=sprite_ram[direccion-$fe0800];
  $fec000..$fec7ff:tigeroad_getbyte:=video_ram[direccion and $7ff];
  $ffc000..$ffffff:tigeroad_getbyte:=ram[direccion-$ffc000];
end;
end;

procedure tigeroad_putbyte(direccion:dword;valor:byte);
var
  bank:byte;
begin
direccion:=direccion and $ffffff;
case direccion of
  0..$3ffff:exit;
  $fe0800..$fe1807:sprite_ram[direccion-$fe0800]:=valor;
  $fe4000:begin  //video control
             bank:= (valor and $04) shr 2;
          	 if (fondo_bank<>bank) then begin
			          fondo_bank:=bank;
          			pintar_fondo:=true;
             end;
          end;
  $fe4002:sound_latch:=valor;
  $fec000..$fec7ff:begin
                      video_ram[direccion and $7ff]:=valor;
                      gfx[0].buffer[(direccion and $7ff) div 2]:=true;
                   end;
  $ffc000..$ffffff:ram[direccion-$ffc000]:=valor;
end;
end;

procedure f1dream_protec;
var
  indx,value:word;
begin
	value:=$ff;
  case main_68000.ppc.l of
	  $244c:begin
        		// Called once, when a race is started.*/
            indx:=ram[$3ff1]+(ram[$3ff0] shl 8);
            ram[$3fe6]:=0;
        		ram[$3fe7]:=f1dream_2450_lookup[indx];
            inc(indx);
            ram[$3fe8]:=0;
        		ram[$3fe9]:=f1dream_2450_lookup[indx];
            inc(indx);
            ram[$3fea]:=0;
        		ram[$3feb]:=f1dream_2450_lookup[indx];
            inc(indx);
            ram[$3fec]:=0;
        		ram[$3fed]:=f1dream_2450_lookup[indx];
	        end;
    $613a:begin
        		// Called for every sprite on-screen.*/
        		if ((ram[$3ff7]+(ram[$3ff6] shl 8))<15) then begin
        			indx:=f1dream_613ea_lookup[ram[$3ff7]+(ram[$3ff6] shl 8)]-(ram[$3ff5]+(ram[$3ff4] shl 8));
        			if (indx>255) then begin
        				indx:=indx shl 4;
        				indx:=indx+(ram[$3ff7]+(ram[$3ff6] shl 8)) and $ff;
        				value:=f1dream_613eb_lookup[indx];
        			end;
        		end;
            ram[$3ff2]:=0;
        		ram[$3ff3]:=value;
          end;
	  $17b70:begin
        		// Called only before a real race, not a time trial.*/
            case (ram[$3ff1]+(ram[$3ff0] shl 8)) of
              $00:indx:=0;
              $01:indx:=32;
              $02:indx:=64;
              $03:indx:=96;
                else indx:=128;
            end;
        		indx:=indx+(ram[$3fff]+(ram[$3ffe] shl 8));
        		if (indx<128) then begin
              ram[$3fe6]:=$00;
        			ram[$3fe7]:=f1dream_17b74_lookup[indx];
              inc(indx);
              ram[$3fe8]:=$00;
        			ram[$3fe9]:=f1dream_17b74_lookup[indx];
              inc(indx);
              ram[$3fea]:=$00;
        			ram[$3feb]:=f1dream_17b74_lookup[indx];
              inc(indx);
              ram[$3fec]:=$00;
        			ram[$3fed]:=f1dream_17b74_lookup[indx];
        		end else begin
        			ram[$3fe6]:=$00;
              ram[$3fe7]:=$ff;
              ram[$3fe8]:=$00;
              ram[$3fe9]:=$ff;
              ram[$3fea]:=$00;
              ram[$3feb]:=$ff;
              ram[$3fec]:=$00;
              ram[$3fed]:=$ff;
      		  end;
      end;
	  $27f8,$511a,$5142,$516a:sound_latch:=ram[$3ffd]+(ram[$3ffc] shl 8); // The main CPU stuffs the byte for the soundlatch into 0xfffffd.*/
  end;

end;

procedure f1dream_putword(direccion:dword;valor:word);pascal;
begin
direccion:=direccion and $ffffff;
case direccion of
  $0..$3ffff:exit;
  $fe0800..$fe1807:begin
                      sprite_ram[(direccion-$fe0800)+1]:=valor and $ff;
                      sprite_ram[direccion-$fe0800]:=valor shr 8;
                   end;
  $ff8200..$ff867f:begin
                      palete_ram[(direccion-$ff8200)+1]:=valor and $ff;
                      palete_ram[direccion-$ff8200]:=valor shr 8;
                      cambiar_color(valor,((direccion-$ff8200) div 2));
                    end;
  //$fe4002:f1dream_protec;
  $fe8000:scroll_x.w:=valor;
  $fe8002:scroll_y.w:=valor;
  $fec000..$fec7ff:begin
                      video_ram[(direccion and $7ff)+1]:=valor and $ff;
                      video_ram[direccion and $7ff]:=valor shr 8;
                      gfx[0].buffer[(direccion and $7ff) div 2]:=true;
                   end;
  $ffc000..$ffffff:begin
                      ram[(direccion-$ffc000)+1]:=valor and $ff;
                      ram[direccion-$ffc000]:=valor shr 8;
                   end;
end;
end;


procedure f1dream_putbyte(direccion:dword;valor:byte);
var
  bank:byte;
begin
direccion:=direccion and $ffffff;
case direccion of
  0..$3ffff:exit;
  $fe0800..$fe1807:sprite_ram[direccion-$fe0800]:=valor;
  $fe4000:begin  //video control
             bank:= (valor and $04) shr 2;
          	 if (fondo_bank<>bank) then begin
			          fondo_bank:=bank;
          			pintar_fondo:=true;
             end;
          end;

  $fe4002:f1dream_protec;
  $fec000..$fec7ff:begin
                      video_ram[direccion and $7ff]:=valor;
                      gfx[0].buffer[(direccion and $7ff) div 2]:=true;
                   end;
  $ffc000..$ffffff:ram[direccion-$ffc000]:=valor;
end;
end;

function tigeroad_snd_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
   $8000:tigeroad_snd_getbyte:=ym2203_Read_Status(0);
   $a000:tigeroad_snd_getbyte:=ym2203_Read_Status(1);
   $e000:tigeroad_snd_getbyte:=sound_latch;
   else tigeroad_snd_getbyte:=mem_snd[direccion];
end;
end;

procedure tigeroad_snd_putbyte(direccion:word;valor:byte);pascal;
begin
case direccion of
  $0..$7fff:exit;
  $8000:ym2203_Control(0,valor);
  $8001:ym2203_Write_Reg(0,valor);
  $a000:ym2203_Control(1,valor);
  $a001:ym2203_Write_Reg(1,valor);
  else mem_snd[direccion]:=valor;
end;
end;

procedure snd_irq(numchip:integer;irqstate:integer);pascal;
begin
  snd_z80.pedir_irq:=(irqstate=1);
end;

procedure tigeroad_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=ym2203UpdateOne(0);
  tsample[1][posicion_sonido]:=ym2203UpdateOne(1);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

function tigeroad_snd_inbyte(puerto:word):byte;pascal;
begin
end;

procedure tigeroad_snd_outbyte(valor:byte;puerto:word);pascal;
begin
end;

end.
