unit tokihw;

interface
uses sdl,z80,m68000,constantes,windows,entradas,arcade_const,timers,dialogs,sysutils,ym_3812;

procedure Cargar_toki;
procedure toki_principal;pascal;
function toki_getword(direccion:dword):word;pascal;
procedure toki_putword(direccion:dword;valor:word);pascal;
function toki_getbyte(direccion:dword):byte;pascal;
procedure toki_putbyte(direccion:dword;valor:byte);pascal;
function iniciar_toki:boolean;pascal;
procedure reset_toki;pascal;
procedure cerrar_toki;pascal;
function toki_snd_getbyte(direccion:word): Byte; pascal;
procedure toki_snd_putbyte(direccion:word;valor:byte);pascal;
procedure toki_sound_act;pascal;
procedure snd_irq(numchip:integer;irqstate:integer);pascal;

const
        toki_rom:array[0..4] of tipo_roms=(
        (n:'l10_6.bin';l:$20000;p:0),(n:'k10_4e.bin';l:$20000;p:$1),
        (n:'tokijp.005';l:$10000;p:$40000),(n:'tokijp.003';l:$10000;p:$40001),
        (n:'';l:0;p:0));
        toki_char:array[0..2] of tipo_roms=(
        (n:'tokijp.001';l:$10000;p:0),(n:'tokijp.002';l:$10000;p:$10000),
        (n:'';l:0;p:0));
        toki_sprites:array[0..2] of tipo_roms=(
        (n:'toki.ob1';l:$80000;p:0),(n:'toki.ob2';l:$80000;p:$80000),
        (n:'';l:0;p:0));
        toki_tiles1:tipo_roms=(n:'toki.bk1';l:$80000;p:0);
        toki_tiles2:tipo_roms=(n:'toki.bk2';l:$80000;p:0);
        toki_sound:array[0..2] of tipo_roms=(
        (n:'tokijp.008';l:$2000;p:0),(n:'tokijp.007';l:$10000;p:$10000),
        (n:'';l:0;p:0));

var
 rom:array[0..$5ffff] of byte;
 ram:array[0..$d7ff] of byte;
 sound_rom:array[0..1,0..$7fff] of byte;
 decrypt:array[0..$1fff] of byte;
 snd_bank,irq1,irq2:byte;
 palete_ram,sprite_ram,bg1_ram,bg2_ram,fg_ram:array[0..$7ff] of byte;
 scroll_x1,scroll_y1,scroll_x2,scroll_y2:parejas;
 prioridad_pant,main2sub_pending,sub2main_pending:boolean;
 sound_latch,sub2main:array[0..1] of byte;

implementation
uses principal;

procedure Cargar_toki;
begin
form1.toki1.Checked:=true;
llamadas_maquina.caption:='Toki';
llamadas_maquina.iniciar:=iniciar_toki;
llamadas_maquina.bucle_general:=toki_principal;
llamadas_maquina.cerrar:=cerrar_toki;
llamadas_maquina.reset:=reset_toki;
llamadas_maquina.canales_usados:=1;
llamadas_maquina.fps_max:=59.61;
end;

procedure desencriptar_sonido;
var
  f,pos:dword;
function decrypt_data(a:word;src:byte):byte;
begin
  if (BIT(a,9)  and  BIT(a,8)) then src:=src xor $80;
	if (BIT(a,11) and  BIT(a,4) and BIT(a,1)) then src:=src xor $40;
	if (BIT(a,11) and not(BIT(a,8)) and BIT(a,1)) then src:=src xor $04;
	if (BIT(a,13) and not(BIT(a,6)) and BIT(a,4)) then src:=src xor $02;
	if (not(BIT(a,11)) and  BIT(a,9) and BIT(a,2)) then src:=src xor $01;
	if (BIT(a,13) and  BIT(a,4)) then src:=BITSWAP8(src,7,6,5,4,3,2,0,1);
	if (BIT(a, 8) and  BIT(a,4)) then src:=BITSWAP8(src,7,6,5,4,2,3,1,0);
  decrypt_data:=src;
end;
function decrypt_opcode(a:word;src:byte):byte;
begin
  if (BIT(a,9) and BIT(a,8)) then src:=src xor $80;
	if (BIT(a,11) and  BIT(a,4) and  BIT(a,1)) then src:=src xor $40;
	if (not(BIT(a,13)) and BIT(a,12)) then src:=src xor $20;
	if (not(BIT(a,6)) and BIT(a,1)) then src:=src xor $10;
	if (not(BIT(a,12)) and BIT(a,2)) then src:=src xor $08;
	if (BIT(a,11) and not(BIT(a,8)) and BIT(a,1)) then src:=src xor $04;
	if (BIT(a,13) and not(BIT(a,6)) and BIT(a,4)) then src:=src xor $02;
	if (not(BIT(a,11)) and BIT(a,9) and BIT(a,2)) then src:=src xor $01;

	if (BIT(a,13) and BIT(a,4)) then src:=BITSWAP8(src,7,6,5,4,3,2,0,1);
	if (BIT(a, 8) and BIT(a,4)) then src:=BITSWAP8(src,7,6,5,4,2,3,1,0);
	if (BIT(a,12) and  BIT(a,9)) then src:=BITSWAP8(src,7,6,4,5,3,2,1,0);
	if (BIT(a,11) and not(BIT(a,6))) then src:=BITSWAP8(src,6,7,5,4,3,2,1,0);
  decrypt_opcode:=src;
end;
begin
  for f:=0 to $1fff do begin
    pos:=BITSWAP24(f,23,22,21,20,19,18,17,16,13,14,15,12,11,10,9,8,7,6,5,4,3,2,1,0);
    mem_snd[f]:=decrypt_data(f,memoria_temp[pos]);
		decrypt[f]:=decrypt_opcode(f,memoria_temp[pos]);
  end;
  copymemory(@sound_rom[0,0],@memoria_temp[$10000],$8000);
  copymemory(@sound_rom[1,0],@memoria_temp[$18000],$8000);
end;

function iniciar_toki:boolean;pascal;
const
  pc_x:array[0..7] of dword=(3, 2, 1, 0, 8+3, 8+2, 8+1, 8+0);
  pc_y:array[0..7] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16);
  ps_x:array[0..15] of dword=(3, 2, 1, 0, 16+3, 16+2, 16+1, 16+0,
			64*8+3, 64*8+2, 64*8+1, 64*8+0, 64*8+16+3, 64*8+16+2, 64*8+16+1, 64*8+16+0);
  ps_y:array[0..15] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32,
			8*32, 9*32, 10*32, 11*32, 12*32, 13*32, 14*32, 15*32 );
  audio_speed=3000000;//Deberia ser 3579545 pero va muy rapido ?
begin
iniciar_toki:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=224;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[2].x:=512;
p_final[2].y:=512;
p_final[2].trans:=true;
p_final[3].x:=256;
p_final[3].y:=256;
p_final[4].x:=512;
p_final[4].y:=512;
p_final[4].trans:=true;
iniciar_video;
//datos del scroll
scroll_data.long_x:=512;
scroll_data.long_y:=512;
scroll_data.max_x:=256;
scroll_data.max_y:=256;
scroll_data.max_scr_x:=255;
scroll_data.max_scr_y:=255;
//cargar roms
if not(cargar_roms16b(@rom[0],@toki_rom[0],'\toki.zip',0)) then exit;
//cargar sonido
if not(cargar_roms(@memoria_temp[0],@toki_sound,'\toki.zip',0)) then exit;
//bancos rom sonido
desencriptar_sonido;
//Main CPU
init_cpu(m68000_main,0,(10000000/llamadas_maquina.fps_max));
main_68000_ll.getword:=toki_getword;
main_68000_ll.putword:=toki_putword;
main_68000_ll.getbyte:=toki_getbyte;
main_68000_ll.putbyte:=toki_putbyte;
//Sound CPU
init_cpu(z80_snd,1,audio_speed/llamadas_maquina.fps_max);
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=toki_snd_getbyte;
snd_z80_ll.putbyte:=toki_snd_putbyte;
snd_z80_ll.outbyte:=nil;
snd_z80_ll.inbyte:=nil;
//Sound Chips
ym3812_init(0,3579545);
ym3812_init_timers(3579545,1,0,snd_irq);
//Timers
init_timer(0,1,audio_speed/44100,toki_sound_act,true);
//convertir chars
if not(cargar_roms(@memoria_temp[0],@toki_char,'\toki.zip',0)) then exit;
init_gfx(0,8,8,4096);
gfx[0].trans[15]:=true;
des_sprites.pos_planos[0]:=4096*16*8+0;
des_sprites.pos_planos[1]:=4096*16*8+4;
des_sprites.pos_planos[2]:=0;
des_sprites.pos_planos[3]:=4;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=16*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@toki_sprites,'\toki.zip',0)) then exit;
init_gfx(1,16,16,8192);
gfx[1].trans[15]:=true;
des_sprites.pos_planos[0]:=2*4;
des_sprites.pos_planos[1]:=3*4;
des_sprites.pos_planos[2]:=0*4;
des_sprites.pos_planos[3]:=1*4;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=128*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//tiles
if not(cargar_roms(@memoria_temp[0],@toki_tiles1,'\toki.zip',1)) then exit;
init_gfx(2,16,16,4096);
gfx[2].trans[15]:=true;
convert_sprites(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
if not(cargar_roms(@memoria_temp[0],@toki_tiles2,'\toki.zip',1)) then exit;
init_gfx(3,16,16,4096);
gfx[3].trans[15]:=true;
convert_sprites(@gfx[3],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//final
reset_toki;
iniciar_toki:=true;
end;

procedure update_video_toki;
var
        f:word;
        color:word;
        sy,x,y,nchar,atrib,atrib2,atrib3:word;
begin
for f:=0 to $3ff do begin
  //Background 1
  if gfx[2].buffer[f] then begin
    x:=f mod 32;
    y:=f div 32;
    atrib:=bg1_ram[$1+(f*2)]+(bg1_ram[(f*2)] shl 8);
    color:=(atrib shr 8) and $f0;
    nchar:=atrib and $fff;
    if prioridad_pant then put_gfx(x*16,y*16,nchar,color+512,2,2)
      else put_gfx_trans(x*16,y*16,nchar,color+512,2,2);
    gfx[2].buffer[f]:=false;
  end;
  //Background 2
  if gfx[3].buffer[f] then begin
    x:=f mod 32;
    y:=f div 32;
    atrib:=bg2_ram[$1+(f*2)]+(bg2_ram[(f*2)] shl 8);
    color:=(atrib shr 8) and $f0;
    nchar:=atrib and $fff;
    if prioridad_pant then put_gfx_trans(x*16,y*16,nchar,color+768,4,3)
      else put_gfx(x*16,y*16,nchar,color+768,4,3);
    gfx[3].buffer[f]:=false;
  end;
  //Foreground
  if gfx[0].buffer[f] then begin
    x:=f mod 32;
    y:=f div 32;
    atrib:=fg_ram[$1+(f*2)]+(fg_ram[(f*2)] shl 8);
    color:=(atrib shr 8) and $f0;
    nchar:=atrib and $fff;
    put_gfx_trans(x*8,y*8,nchar,color+256,1,0);
    gfx[0].buffer[f]:=false;
  end;
end;
if prioridad_pant then begin
  scroll_x_y(2,3,scroll_x1.w,scroll_y1.w);
  scroll_x_y(4,3,scroll_x2.w,scroll_y2.w);
end else begin
  scroll_x_y(4,3,scroll_x2.w,scroll_y2.w);
  scroll_x_y(2,3,scroll_x1.w,scroll_y1.w);
end;
for f:=$ff downto 0 do begin
    atrib:=(sprite_ram[(f*8)+0] shl 8)+sprite_ram[(f*8)+1];
    atrib2:=(sprite_ram[(f*8)+4] shl 8)+sprite_ram[(f*8)+5];
		if ((atrib2<>$f000) and (atrib<>$ffff)) then begin
			x:=(atrib2+(atrib and $f0)) and $1ff;
			sy:=(atrib and $0f) shl 4;
			y:=(((sprite_ram[(f*8)+6] shl 8)+sprite_ram[(f*8)+7])+sy) and $1ff;
      atrib3:=(sprite_ram[(f*8)+2] shl 8)+sprite_ram[(f*8)+3];
			color:=(atrib3 shr 8) and $f0;
			nchar:=(atrib3 and $fff)+((atrib2 and $8000) shr 3);
      put_gfx_sprite(nchar,color,(atrib and $100)<>0,false,1);
      actualiza_gfx_sprite(x,y,3,1);
    end;
end;
actualiza_trozo(0,0,256,256,1,0,0,256,256,3);
actualiza_trozo(0,16,256,224,3,0,0,256,224,0);
end;

procedure eventos_toki;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_UP] or joystick.arriba) then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if (teclado[SDLK_DOWN] or joystick.abajo) then in0:=(in0 and $Fd) else in0:=(in0 or $2);
  if (teclado[SDLK_LEFT] or joystick.izq) then in0:=(in1 and $fb) else in0:=(in0 or $4);
  if (teclado[SDLK_RIGHT] or joystick.der) then in0:=(in0 and $F7) else in0:=(in0 or $8);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if (teclado[SDLK_LALT] or joystick.boton0) then in0:=(in0 and $df) else in0:=(in0 or $20);
  if teclado[SDLK_5] then in2:=(in2 or $1) else in2:=(in2 and $fe);
  if teclado[SDLK_1] then in1:=(in1 and $f7) else in1:=(in1 or $8);
end;
end;

procedure cerrar_toki;pascal;
begin
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_toki;pascal;
begin
 reset_68000(main_68000,main_68000_ll);
 reset_z80(snd_z80);
 YM3812_ResetChip(0);
 reset_audio;
 zeromemory(@ram[$0],$d800);
 zeromemory(@mem_snd[$2000],$6000);
 in0:=$FF;
 in1:=$FF;
 in2:=0;
 scroll_x1.w:=0;
 scroll_y1.w:=0;
 scroll_x2.w:=0;
 scroll_y2.w:=0;
 snd_bank:=0;
 irq1:=$ff;
 irq2:=$ff;
 main2sub_pending:=false;
 sub2main_pending:=false;
 sound_latch[0]:=0;
 sound_latch[1]:=0;
end;

procedure toki_principal;pascal;
var
  frame_m,frame_s:single;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
   frame_m:=frame_m+main_68000.tframes;
   run_68000(main_68000,main_68000_ll,trunc(frame_m));
   frame_m:=frame_m-main_68000.contador;
   main_68000.contador:=0;
   pedir_irq_68000(main_68000,1);
   frame_s:=frame_s+snd_z80.tframes;
   run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
   frame_s:=frame_s-snd_z80.contador;
   snd_z80.contador:=0;
   evaluar_entradas;
   eventos_toki;
   update_video_toki;
   actualiza_video;
   sincronizar;
end;
end;

procedure cambiar_color(tmp_color,numero:word);
var
        bit0,bit1,bit2,bit3:byte;
        color:tcolor;
begin
  bit0:=(tmp_color shr 8) and 1;
  bit1:=(tmp_color shr 9) and 1;
  bit2:=(tmp_color shr 10) and 1;
  bit3:=(tmp_color shr 11) and 1;
  color.b:=$0e*bit0+$1f*bit1+$43*bit2+$8f*bit3;
  bit0:=(tmp_color shr 4) and 1;
  bit1:=(tmp_color shr 5) and 1;
  bit2:=(tmp_color shr 6) and 1;
  bit3:=(tmp_color shr 7) and 1;
  color.g:=$0e*bit0+$1f*bit1+$43*bit2+$8f*bit3;
  bit0:=(tmp_color shr 0) and 1;
  bit1:=(tmp_color shr 1) and 1;
  bit2:=(tmp_color shr 2) and 1;
  bit3:=(tmp_color shr 3) and 1;
  color.r:=$0e*bit0+$1f*bit1+$43*bit2+$8f*bit3;
  poner_color(color,addr(paleta[numero]));
  case numero of
    256..511:fillmemory(@gfx[0].buffer[0],$400,1);
    512..767:fillmemory(@gfx[2].buffer[0],$400,1);
    768..1023:fillmemory(@gfx[3].buffer[0],$400,1);
  end;
end;

procedure update_irq_lines(param:byte);
begin
	case param of
		0:begin
        irq1:=$ff;
        irq2:=$ff;
      end;
		//RST10_ASSERT
    1:irq1:=$d7;
		//RST10_CLEAR:
    2:irq1:=$ff;
    //RST18_ASSERT:
		3:irq2:=$df;
		//RST18_CLEAR:
		4:irq2:=$ff;
  end;
  snd_z80.im0:=irq1 and irq2;
	if (irq1 and irq2)=$ff then snd_z80.pedir_irq:=false
  	else snd_z80.pedir_irq:=true;
end;

function toki_getword(direccion:dword):word;pascal;
begin
direccion:=direccion and $fffffff;
case direccion of
    $60000..$6d7ff:toki_getword:=ram[(direccion-$60000)+1] or (ram[(direccion-$60000)] shl 8);
    $6e000..$6e7ff:toki_getword:=palete_ram[(direccion and $7ff)+1] or (palete_ram[direccion and $7ff] shl 8);
    $6e800..$6efff:toki_getword:=bg1_ram[(direccion and $7ff)+1] or (bg1_ram[direccion and $7ff] shl 8);
    $6f000..$6f7ff:toki_getword:=bg2_ram[(direccion and $7ff)+1] or (bg2_ram[direccion and $7ff] shl 8);
    $6f800..$6ffff:toki_getword:=fg_ram[(direccion and $7ff)+1] or (fg_ram[direccion and $7ff] shl 8);
    $6d800..$6dfff:toki_getword:=sprite_ram[(direccion and $7ff)+1] or (sprite_ram[direccion and $7ff] shl 8);
    $80000..$8000d:case (direccion and $e) of
              		4:toki_getword:=sub2main[0];
                  6:toki_getword:=sub2main[1];
		              $a:if main2sub_pending then toki_getword:=1
                      else toki_getword:=0;
                  else toki_getword:=$ffff;
                 end;
    $c0000:toki_getword:=$ffdf;
    $c0002:toki_getword:=$ff00 or in0;
    $c0004:toki_getword:=in1;
  else toki_getword:=toki_getbyte(direccion+1) or (toki_getbyte(direccion) shl 8);
end;
end;

procedure toki_putword(direccion:dword;valor:word);pascal;
begin
direccion:=direccion and $fffffff;
case direccion of
  $60000..$6d7ff:begin
                  ram[direccion-$60000]:=valor shr 8;
                  ram[(direccion-$60000)+1]:=valor and $ff;
                 end;
  $6d800..$6dfff:begin
                    sprite_ram[direccion and $7ff]:=valor shr 8;
                    sprite_ram[(direccion and $7ff)+1]:=valor and $ff;
                 end;
  $6e000..$6e7ff:begin
                    palete_ram[direccion and $7ff]:=valor shr 8;
                    palete_ram[(direccion and $7ff)+1]:=valor and $ff;
                    cambiar_color(valor,((direccion and $7ff) div 2));
                 end;
  $6e800..$6efff:begin
                    bg1_ram[direccion and $7ff]:=valor shr 8;
                    bg1_ram[(direccion and $7ff)+1]:=valor and $ff;
                    gfx[2].buffer[(direccion and $7ff) div 2]:=true;
                 end;
  $6f000..$6f7ff:begin
                    bg2_ram[direccion and $7ff]:=valor shr 8;
                    bg2_ram[(direccion and $7ff)+1]:=valor and $ff;
                    gfx[3].buffer[(direccion and $7ff) div 2]:=true;
                 end;
  $6f800..$6ffff:begin
                    fg_ram[direccion and $7ff]:=valor shr 8;
                    fg_ram[(direccion and $7ff)+1]:=valor and $ff;
                    gfx[0].buffer[(direccion and $7ff) div 2]:=true;
                 end;
  $80000..$8000d:case (direccion and $e) of
			                0:sound_latch[0]:=valor and $ff;
                      2:sound_latch[1]:=valor and $ff;
			                8:update_irq_lines(3);
			                4,$c:begin
                    				sub2main_pending:=false;
                     				main2sub_pending:=true;
                           end;
                 end;
  $a000a:scroll_x1.h:=(valor and $10) shr 4;
  $a000c:scroll_x1.l:=((valor and $7f) shl 1) or ((valor and $80) shr 7);
  $a001a:scroll_y1.h:=(valor and $10) shr 4;
  $a001c:scroll_y1.l:=((valor and $7f) shl 1) or ((valor and $80) shr 7);
  $a002a:scroll_x2.h:=(valor and $10) shr 4;
  $a002c:scroll_x2.l:=((valor and $7f) shl 1) or ((valor and $80) shr 7);
  $a003a:scroll_y2.h:=(valor and $10) shr 4;
  $a003c:scroll_y2.l:=((valor and $7f) shl 1) or ((valor and $80) shr 7);
  else begin
    toki_putbyte(direccion,valor shr 8);
    toki_putbyte(direccion+1,valor and $ff);
  end;
end;
end;

function toki_getbyte(direccion:dword):byte;
begin
direccion:=direccion and $fffffff;
case direccion of
  0..$5ffff:toki_getbyte:=rom[direccion];
  $60000..$6d7ff:toki_getbyte:=ram[direccion-$60000];
end;
end;

procedure toki_putbyte(direccion:dword;valor:byte);
begin
direccion:=direccion and $fffffff;
case direccion of
  0..$5ffff:exit;
  $60000..$6d7ff:ram[direccion-$60000]:=valor;
  $a0050:if prioridad_pant<>((valor and 1)<>0) then begin
            prioridad_pant:=(valor and 1)<>0;
            fillmemory(@gfx[2].buffer[0],$400,1);
            fillmemory(@gfx[3].buffer[0],$400,1);
         end;
end;
end;

function toki_snd_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  0..$1fff:if snd_z80.opcode then toki_snd_getbyte:=decrypt[direccion]
              else toki_snd_getbyte:=mem_snd[direccion];
  $4008:toki_snd_getbyte:=YM3812_status_port(0);
  $4010:toki_snd_getbyte:=sound_latch[0];
  $4011:toki_snd_getbyte:=sound_latch[1];
  $4012:if sub2main_pending then toki_snd_getbyte:=1
          else toki_snd_getbyte:=0;
  $4013:toki_snd_getbyte:=in2;
  $6000:toki_snd_getbyte:=$f0;
  $8000..$ffff:toki_snd_getbyte:=sound_rom[snd_bank,direccion and $7fff];
    else toki_snd_getbyte:=mem_snd[direccion];
end;
end;

procedure toki_snd_putbyte(direccion:word;valor:byte);pascal;
begin
case direccion of
  0..$1fff,$8000..$ffff:exit;
  $4000:begin
          main2sub_pending:=false;
        	sub2main_pending:=true;
        end;
  $4001:update_irq_lines(0);
  $4003:update_irq_lines(4);
  $4007:snd_bank:=valor and 1;
  $4008:ym3812_control_port(0,valor);
  $4009:ym3812_write_port(0,valor);
  $4018:sub2main[0]:=valor;
  $4019:sub2main[1]:=valor;
    else mem_snd[direccion]:=valor;
end;
end;

procedure toki_sound_act;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=ym3812UpdateOne(0);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

procedure snd_irq(numchip:integer;irqstate:integer);pascal;
begin
  if irqstate=0 then update_irq_lines(2)
    else update_irq_lines(1);
end;


end.
