unit vigilante;

interface
uses sdl,z80,constantes,windows,entradas,arcade_const,sysutils,timers,dac,ym_2151;

procedure Cargar_vigilante;
procedure vigilante_principal;pascal;
function vigilante_getbyte(direccion:word): Byte; pascal;
procedure vigilante_putbyte(direccion:word;valor:byte);pascal;
function vigilante_inbyte(puerto:word):byte;pascal;
procedure vigilante_outbyte(valor:byte;puerto:word);pascal;
function snd_getbyte(direccion:word): Byte; pascal;
procedure snd_putbyte(direccion:word;valor:byte);pascal;
function snd_inbyte(puerto:word):byte;pascal;
procedure snd_outbyte(valor:byte;puerto:word);pascal;
procedure snd_despues_instruccion;pascal;
function iniciar_vigilante:boolean;pascal;
procedure reset_vigilante;pascal;
procedure cerrar_vigilante;pascal;
procedure ym2151_snd_irq(numchip:integer;irqstate:integer);pascal;

const
        vigilante_rom:array[0..2] of tipo_roms=(
        (n:'g07_c03.bin';l:$8000;p:0),(n:'j07_c04.bin';l:$10000;p:$8000),
        (n:'';l:0;p:0));
        vigilante_chars:array[0..2] of tipo_roms=(
        (n:'f05_c08.bin';l:$10000;p:0),(n:'h05_c09.bin';l:$10000;p:$10000),
        (n:'';l:0;p:0));
        vigilante_sprites:array[0..8] of tipo_roms=(
        (n:'n07_c12.bin';l:$10000;p:$00000),(n:'k07_c10.bin';l:$10000;p:$10000),
        (n:'o07_c13.bin';l:$10000;p:$20000),(n:'l07_c11.bin';l:$10000;p:$30000),
        (n:'t07_c16.bin';l:$10000;p:$40000),(n:'p07_c14.bin';l:$10000;p:$50000),
        (n:'v07_c17.bin';l:$10000;p:$60000),(n:'s07_c15.bin';l:$10000;p:$70000),
        (n:'';l:0;p:0));
        vigilante_dac:tipo_roms=(n:'d04_c01.bin';l:$10000;p:0);
        vigilante_sound:tipo_roms=(n:'g05_c02.bin';l:$10000;p:0);
        vigilante_tiles:array[0..3] of tipo_roms=(
        (n:'d01_c05.bin';l:$10000;p:$00000),(n:'e01_c06.bin';l:$10000;p:$10000),
        (n:'f01_c07.bin';l:$10000;p:$20000),(n:'';l:0;p:0));
var
 rom_bank:array[0..3,0..$3FFF] of byte;
 banco_rom:word;
 sound_latch,rear_color:byte;
 rear_scroll,scroll_x:parejas;
 rear_disable,rear_ch_color:boolean;
 sample_addr:parejas;
 mem_dac:array[0..$ffff] of byte;

implementation
uses principal;

procedure Cargar_vigilante;
begin
form1.vigilante1.Checked:=true;
llamadas_maquina.caption:='Vigilante';
llamadas_maquina.iniciar:=iniciar_vigilante;
llamadas_maquina.bucle_general:=vigilante_principal;
llamadas_maquina.cerrar:=cerrar_vigilante;
llamadas_maquina.reset:=reset_vigilante;
llamadas_maquina.fps_max:=55;
llamadas_maquina.canales_usados:=2;
stereo:=true;
end;

procedure update_video_vigilante;
var
        f,color,nchar:word;
        x,y,h:word;
        c,i:word;
        flip_y:boolean;
        ccolor:tcolor;
begin
//fondo
if not(rear_disable) then begin
 if rear_ch_color then begin
  for i:=0 to 15 do begin
		ccolor.r:= (memoria[$cc00+16 * rear_color + i] shl 3) and $FF;
		ccolor.g:= (memoria[$cd00+16 * rear_color + i] shl 3) and $FF;
		ccolor.b:= (memoria[$ce00+16 * rear_color + i] shl 3) and $FF;
    poner_color(ccolor,addr(paleta[512+i]));
		ccolor.r:= (memoria[$cc00+16 * rear_color + 32 + i] shl 3) and $FF;
		ccolor.g:= (memoria[$cd00+16 * rear_color + 32 + i] shl 3) and $FF;
		ccolor.b:= (memoria[$ce00+16 * rear_color + 32 + i] shl 3) and $FF;
    poner_color(ccolor,addr(paleta[512+i+16]));
	end;
  nchar:=0;
  for c:=0 to 2 do begin
		for y:=0 to 255 do begin
      x:=0;
      while x<512 do begin
        if y<128 then put_gfx(512*c+x,y,nchar,512+0,4,2)
          else put_gfx(512*c+x,y,nchar,512+16,4,2);
				nchar:=nchar+1;
			  inc(x,32);
      end;
		end;
  end;
  rear_ch_color:=false;
 end;
 actualiza_trozo(rear_scroll.w-(378+16*8),0,256+128,256,4,0,0,256+128,256,3);
end;
//chars
for f:=0 to $7ff do begin
  if gfx[0].buffer[f] then begin
      x:=f mod 64;
      y:=f div 64;
      color:=memoria[$d001+(f*2)] and $f;
      nchar:=memoria[$d000+(f*2)]+((memoria[$d001+(f*2)] and $f0) shl 4);
      if ((color>=4) or rear_disable) then put_gfx(x*8,y*8,nchar,(color shl 4)+256,1,0)
        else put_gfx_trans(x*8,y*8,nchar,(color shl 4)+256,1,0);
      if (color and $c)=$c then put_gfx_trans(x*8,y*8,nchar,(color shl 4)+256,2,3)
        else put_gfx_trans(x*8,y*8,0,0,2,3);
      gfx[0].buffer[f]:=false;
  end;
end;
scroll__x(1,3,scroll_x.w);
//sprites
for f:=0 to $17 do begin
      nchar:=memoria[$c024+(f*8)]+ ((memoria[$c025+(f*8)] and $0f) shl 8);
		  color:=(memoria[$c020+(f*8)] and $0f) shl 4;
		  h:=1 shl ((memoria[$c025+(f*8)] and $30) shr 4);
      nchar:=nchar and not(h-1);
      x:=(memoria[$c026+(f*8)]+((memoria[$c027+(f*8)] and $01) shl 8));
		  y:=(256+128-(memoria[$c022+(f*8)] + ((memoria[$c023+(f*8)] and $01) shl 8)))-(16*h);
      flip_y:=(memoria[$c025+(f*8)] and $80)<>0;
      for i:=0 to (h-1) do begin
        if flip_y then c:=nchar+(h-1-i)
			    else c:=nchar+i;
        put_gfx_sprite(c,color,(memoria[$c025+(f*8)] and $40)<>0,flip_y,1);
        actualiza_gfx_sprite(x,y+(16*i),3,1);
      end;
end;
//Los chars de arriba
scroll__x(2,3,scroll_x.w);
actualiza_trozo(128,0,256,48,1,128,0,256,48,3);
actualiza_trozo(128,0,256,256,3,0,0,256,256,0);
end;

procedure eventos_vigilante;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_DOWN] or joystick.abajo) then in1:=(in1 and $fb) else in1:=(in1 or 4);
  if (teclado[SDLK_UP] or joystick.arriba) then in1:=(in1 and $f7) else in1:=(in1 or 8);
  if (teclado[SDLK_LEFT] or joystick.izq) then in1:=(in1 and $fd) else in1:=(in1 or 2);
  if (teclado[SDLK_RIGHT] or joystick.der) then in1:=(in1 and $fe) else in1:=(in1 or 1);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 and $df) else in1:=(in1 or $20);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $7f) else in1:=(in1 or $80);
  if teclado[SDLK_1] then in0:=(in0 and $fe) else in0:=(in0 or 1);
  if teclado[SDLK_5] then in0:=(in0 and $f7) else in0:=(in0 or 8);
end;
end;

procedure cerrar_vigilante;pascal;
begin
ym2151close(0);
cerrar_cpus;
cerrar_audio;
cerrar_video;
end;

procedure reset_vigilante;pascal;
begin
 reset_z80(main_z80);
 reset_z80(snd_z80);
 ym2151resetchip(0);
 reset_audio;
 zeromemory(@memoria[$8000],$8000);
 in0:=$ff;
 in1:=$ff;
 in2:=$ff;
 banco_rom:=0;
 rear_ch_color:=true;
 snd_z80.im0:=$ff;
 sample_addr.w:=0;
end;

function iniciar_vigilante:boolean;pascal;
const
  ps_x:array[0..15] of dword=($00*8+0,$00*8+1,$00*8+2,$00*8+3,
		                          $10*8+0,$10*8+1,$10*8+2,$10*8+3,
		                          $20*8+0,$20*8+1,$20*8+2,$20*8+3,
		                          $30*8+0,$30*8+1,$30*8+2,$30*8+3);
  ps_y:array[0..15] of dword=($00*8,$01*8,$02*8,$03*8,
                          		$04*8,$05*8,$06*8,$07*8,
                          		$08*8,$09*8,$0A*8,$0B*8,
                           		$0C*8,$0D*8,$0E*8,$0F*8);
  pt_x:array[0..31] of dword=(0*8+1, 0*8,  1*8+1, 1*8, 2*8+1, 2*8, 3*8+1, 3*8, 4*8+1, 4*8, 5*8+1, 5*8,
	6*8+1, 6*8, 7*8+1, 7*8, 8*8+1, 8*8, 9*8+1, 9*8, 10*8+1, 10*8, 11*8+1, 11*8,
	12*8+1, 12*8, 13*8+1, 13*8, 14*8+1, 14*8, 15*8+1, 15*8);
  pt_y:array[0..0] of dword=(0);
  pc_x:array[0..7] of dword=(0,1,2,3, 64+0,64+1,64+2,64+3);
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
var
  f:word;
begin
iniciar_vigilante:=false;
iniciar_audio(2);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=256;
p_final[1].x:=512;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[2].x:=512;
p_final[2].y:=256;
p_final[2].trans:=true;
p_final[3].x:=512;
p_final[3].y:=256;
p_final[4].x:=512*4;
p_final[4].y:=256;
iniciar_video;
//datos scroll
scroll_data.long_x:=512;
scroll_data.ad_x:=128;
scroll_data.max_x:=256+128;
scroll_data.max_scr_x:=255;
//Main CPU
init_cpu(z80_main,0,3579645/llamadas_maquina.fps_max/128);
main_z80.daisy:=false;
main_z80_ll.getbyte:=vigilante_getbyte;
main_z80_ll.putbyte:=vigilante_putbyte;
main_z80_ll.outbyte:=vigilante_outbyte;
main_z80_ll.inbyte:=vigilante_inbyte;
//Sound CPU
init_cpu(z80_snd,1,3579645/llamadas_maquina.fps_max/128);
snd_z80.daisy:=false;
snd_z80_ll.getbyte:=snd_getbyte;
snd_z80_ll.putbyte:=snd_putbyte;
snd_z80_ll.outbyte:=snd_outbyte;
snd_z80_ll.inbyte:=snd_inbyte;
//sound chips
dac_start(0);
ym2151init(0,3579645);
ym2151init_timers(0,ym2151_snd_irq);
init_timer(0,1,3579645/44100,snd_despues_instruccion,true);
//cargar roms y rom en bancos
if not(cargar_roms(@memoria_temp[0],@vigilante_rom[0],'\vigilant.zip',0)) then exit;
copymemory(@memoria[0],@memoria_temp[0],$8000);
for f:=0 to 3 do copymemory(@rom_bank[f,0],@memoria_temp[$8000+(f*$4000)],$4000);
//cargar sonido
if not(cargar_roms(@mem_snd[0],@vigilante_sound,'\vigilant.zip',1)) then exit;
if not(cargar_roms(@mem_dac[0],@vigilante_dac,'\vigilant.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@vigilante_chars[0],'\vigilant.zip',0)) then exit;
init_gfx(0,8,8,4096);
gfx[0].trans[0]:=true;
des_sprites.pos_planos[0]:=64*1024*8;
des_sprites.pos_planos[1]:=(64*1024*8)+4;
des_sprites.pos_planos[2]:=0;
des_sprites.pos_planos[3]:=4;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=128;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
init_gfx(3,8,8,4096);
copymemory(gfx[3].datos,gfx[0].datos,4096*8*8);
for f:=0 to 11 do gfx[3].trans[f]:=true;
//sprites
if not(cargar_roms(@memoria_temp[0],@vigilante_sprites[0],'\vigilant.zip',0)) then exit;
init_gfx(1,16,16,4096);
gfx[1].trans[0]:=true;
des_sprites.pos_planos[0]:=$40000*8;
des_sprites.pos_planos[1]:=$40000*8+4;
des_sprites.pos_planos[2]:=0;
des_sprites.pos_planos[3]:=4;
des_sprites.bit_pixel:=4;
des_sprites.long_sprites:=$40*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@vigilante_tiles[0],'\vigilant.zip',0)) then exit;
init_gfx(2,32,1,3*512*8);
des_sprites.pos_planos[0]:=0;
des_sprites.pos_planos[1]:=2;
des_sprites.pos_planos[2]:=4;
des_sprites.pos_planos[3]:=6;
des_sprites.bit_pixel:=4;
des_sprites.long_sprites:=16*8;
convert_sprites(@gfx[2],0,@memoria_temp[0],@pt_x[0],@pt_y[0],false,false);
//final
reset_vigilante;
iniciar_vigilante:=true;
end;

procedure vigilante_principal;pascal;
var
  frame_m,frame_s:single;
  f:byte;
begin
iniciar_entradas;
frame_m:=0;
frame_s:=0;
while EmuStatus=EsRuning do begin
 for f:=0 to 127 do begin
  frame_m:=frame_m+main_z80.tframes;
  run_z80(main_z80,main_z80_ll,trunc(frame_m));
  frame_m:=frame_m-main_z80.contador;
  main_z80.contador:=0;
  frame_s:=frame_s+snd_z80.tframes;
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_s:=frame_s-snd_z80.contador;
  snd_z80.contador:=0;
  snd_z80.pedir_nmi:=true;
  snd_z80.pedir_irq:=(snd_z80.im0<>$ff);
 end;
  main_z80.pedir_irq:=true;
  update_video_vigilante;
  actualiza_video;
  eventos_vigilante;
  sincronizar;
  evaluar_entradas;
end;
end;

procedure cambiar_color(numero:word);
var
  color:tcolor;
  pos,bank,pos2:word;
begin
  pos:=numero-$c800;
  bank:=pos and $400;
	pos2:=pos and $ff;
	color.r:=((memoria[$c800+(bank+pos2+$000)]) shl 3) and $FF;
	color.g:=((memoria[$c800+(bank+pos2+$100)]) shl 3) and $FF;
	color.b:=((memoria[$c800+(bank+pos2+$200)]) shl 3) and $FF;
  poner_color(color,addr(paleta[(bank shr 2)+pos2]));
  if ((bank shr 2)+pos2)>255 then fillmemory(@gfx[0].buffer[0],$800,1);
  if numero>$cc00 then rear_ch_color:=true;
end;

function vigilante_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $8000..$bfff:vigilante_getbyte:=rom_bank[banco_rom,(direccion and $3fff)];
  else vigilante_getbyte:=memoria[direccion];
end;
end;

procedure vigilante_putbyte(direccion:word;valor:byte);pascal;
begin
if (direccion<$c000) then exit;
memoria[direccion]:=valor;
case direccion of
    $c800..$cfff:if buffer_paleta[direccion and $7ff]<>valor then begin
                    cambiar_color(direccion);
                    buffer_paleta[direccion and $7ff]:=valor;
                 end;
    $d000..$dfff:gfx[0].buffer[(direccion and $0ffe) shr 1]:=true;
end;
end;

procedure snd_irq_set(tipo:byte);
begin
  case tipo of
    0:snd_z80.im0:=snd_z80.im0 or $20; //Clear Z80
    1:snd_z80.im0:=snd_z80.im0 and $df; //Set Z80
    2:snd_z80.im0:=snd_z80.im0 or $10; //Clear YM2151
    3:snd_z80.im0:=snd_z80.im0 and $ef; //Set YM2151
  end;
end;

function vigilante_inbyte(puerto:word):byte;pascal;
begin
case (puerto and $ff) of
  0:vigilante_inbyte:=in0;
  1:vigilante_inbyte:=in1;
  2,3:vigilante_inbyte:=$ff;
  4:vigilante_inbyte:=$fd;
end;
end;

procedure vigilante_outbyte(valor:byte;puerto:word);pascal;
begin
case (puerto and $ff) of
  0:begin
      sound_latch:=valor;
      snd_irq_set(1);
    end;
  4:banco_rom:=valor and $7;
  $80:scroll_x.l:=valor;
  $81:scroll_x.h:=valor and 1;
  $82:rear_scroll.l:=valor;
  $83:rear_scroll.h:=valor and 7;
  $84:begin
        rear_disable:=(valor and $40)<>0;
        rear_color:=valor and $d;
      end;
end;
end;

function snd_getbyte(direccion:word): Byte; pascal;
begin
snd_getbyte:=mem_snd[direccion];
end;

procedure snd_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$c000 then exit;
mem_snd[direccion]:=valor;
end;

function snd_inbyte(puerto:word):byte;pascal;
begin
case (puerto and $ff) of
  $1:snd_inbyte:=YM2151_status_port_read(0);
  $80:snd_inbyte:=sound_latch;
  $84:snd_inbyte:=mem_dac[sample_addr.w];
end;
end;

procedure snd_outbyte(valor:byte;puerto:word);pascal;
begin
case (puerto and $ff) of
  0:YM2151_register_port_write(0,valor);
  1:YM2151_data_port_write(0,valor);
  $80:sample_addr.l:=valor;
  $81:sample_addr.h:=valor;
  $82:begin
        dac_signed_data_w(0,valor);
        sample_addr.w:=(sample_addr.w+1);
      end;
  $83:snd_irq_set(0);
end;
end;

procedure ym2151_snd_irq(numchip:integer;irqstate:integer);pascal;
begin
  snd_irq_set(2+irqstate);
end;

procedure snd_despues_instruccion;pascal;
var
  salida:array[0..2] of integer;
  audio:pinteger;
  tmp:smallint;
begin
if hay_sonido then begin
  audio:=ym2151UpdateOne(0);
  copymemory(@salida[0],audio,3*sizeof(integer));
  tmp:=DAC_update(0);
  tsample[0][posicion_sonido]:=salida[1];
  tsample[1][posicion_sonido]:=tmp;
  inc(posicion_sonido);
  tsample[0][posicion_sonido]:=salida[2];
  tsample[1][posicion_sonido]:=tmp;
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
