unit yiear;

interface
uses sdl,m6809,constantes,entradas,sn_76496,vlm_5030,arcade_const,windows,timers;

procedure Cargar_yiear;
procedure yiear_principal;pascal;
function yiear_getbyte(direccion:word): Byte; pascal;
procedure yiear_putbyte(direccion:word;valor:byte);pascal;
function iniciar_yiear:boolean;pascal;
procedure reset_yiear;pascal;
procedure cerrar_yiear;pascal;
procedure yiear_despues_instruccion;pascal;
procedure yiear_vlm_5030;pascal;
procedure yiear_snd_nmi;pascal;

const
        yiear_rom:array[0..2] of tipo_roms=(
        (n:'i08.10d';l:$4000;p:$8000),(n:'i07.8d';l:$4000;p:$c000),
        (n:'';l:0;p:0));
        yiear_char:array[0..2] of tipo_roms=((n:'g16_1.bin';l:$2000;p:0),
        (n:'g15_2.bin';l:$2000;p:$2000),(n:'';l:0;p:0));
        yiear_sprites:array[0..4] of tipo_roms=(
        (n:'g04_5.bin';l:$4000;p:0),(n:'g03_6.bin';l:$4000;p:$4000),
        (n:'g06_3.bin';l:$4000;p:$8000),(n:'g05_4.bin';l:$4000;p:$c000),(n:'';l:0;p:0));
        yiear_pal:tipo_roms=(n:'yiear.clr';l:$20;p:$0);
        yiear_vlm:tipo_roms=(n:'a12_9.bin';l:$2000;p:$0);

var
 pedir_irq,pedir_nmi:boolean;
 sound_latch:byte;
 mem_vlm:array[0..$1fff] of byte;

implementation
uses principal;

procedure Cargar_yiear;
begin
form1.Yiear1.Checked:=true;
llamadas_maquina.caption:='Yie Ar Kung-Fu';
llamadas_maquina.iniciar:=iniciar_yiear;
llamadas_maquina.bucle_general:=yiear_principal;
llamadas_maquina.cerrar:=cerrar_yiear;
llamadas_maquina.reset:=reset_yiear;
llamadas_maquina.canales_usados:=2;
llamadas_maquina.fps_max:=60.58;
end;

function iniciar_yiear:boolean;pascal;
var
      colores:tpaleta;
      f:word;
      ctemp1,ctemp2,ctemp3:byte;
const
    pc_x:array[0..7] of dword=(0, 1, 2, 3, 8*8+0, 8*8+1, 8*8+2, 8*8+3);
    pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
    ps_x:array[0..15] of dword=(0*8*8+0, 0*8*8+1, 0*8*8+2, 0*8*8+3, 1*8*8+0, 1*8*8+1, 1*8*8+2, 1*8*8+3,
	  2*8*8+0, 2*8*8+1, 2*8*8+2, 2*8*8+3, 3*8*8+0, 3*8*8+1, 3*8*8+2, 3*8*8+3);
    ps_y:array[0..15] of dword=(0*8,  1*8,  2*8,  3*8,  4*8,  5*8,  6*8,  7*8,
	  32*8, 33*8, 34*8, 35*8, 36*8, 37*8, 38*8, 39*8);
begin
iniciar_yiear:=false;
iniciar_audio(1);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=224;
p_final[1].x:=256;
p_final[1].y:=256;
iniciar_video;
//Main CPU
init_cpu(m6809_main,0,1152000/llamadas_maquina.fps_max);
main_6809_ll.getbyte:=yiear_getbyte;
main_6809_ll.putbyte:=yiear_putbyte;
//Sound Chip
SN76496_init(0,1152000);
//cargar rom sonido
if not(cargar_roms(@mem_vlm[0],@yiear_vlm,'\yiear.zip',1)) then exit;
vlm5030_start(0,2,3579545,@mem_vlm[0],$2000);
//Timers
//NMI sonido
init_timer(0,0,2304,yiear_snd_nmi,true);
//timer del vlm_5030 (tiene un sampleado distinto a lo habitual)
init_timer(1,0,1152000/(3579545/440),yiear_vlm_5030,true);
//Sampleado del sn76496
init_timer(2,0,1152000/44100,yiear_despues_instruccion,true);
//cargar roms
if not(cargar_roms(@memoria[0],@yiear_rom[0],'\yiear.zip',0)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@yiear_char[0],'\yiear.zip',0)) then exit;
init_gfx(0,8,8,512);
des_sprites.pos_planos[0]:=4;
des_sprites.pos_planos[1]:=0;
des_sprites.pos_planos[2]:=$2000*8+4;
des_sprites.pos_planos[3]:=$2000*8+0;
des_sprites.bit_pixel:=4;
des_sprites.banks:=0;
des_sprites.long_sprites:=16*8;
convert_sprites(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@yiear_sprites[0],'\yiear.zip',0)) then exit;
init_gfx(1,16,16,512);
gfx[1].trans[0]:=true;
des_sprites.pos_planos[0]:=4;
des_sprites.pos_planos[1]:=0;
des_sprites.pos_planos[2]:=$8000*8+4;
des_sprites.pos_planos[3]:=$8000*8+0;
des_sprites.long_sprites:=64*8;
convert_sprites(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//paleta
if not(cargar_roms(@memoria_temp[0],@yiear_pal,'\yiear.zip',1)) then exit;
for f:=0 to 31 do begin
  ctemp1:=memoria_temp[f] and 1;
  ctemp2:=(memoria_temp[f] shr 1) and 1;
  ctemp3:=(memoria_temp[f] shr 2) and 1;
  colores[f].r:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
  ctemp1:=(memoria_temp[f] shr 3) and 1;
  ctemp2:=(memoria_temp[f] shr 4) and 1;
  ctemp3:=(memoria_temp[f] shr 5) and 1;
  colores[f].g:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
  ctemp1:=0;
  ctemp2:=(memoria_temp[f] shr 6) and 1;
  ctemp3:=(memoria_temp[f] shr 7) and 1;
  colores[f].b:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
end;
poner_paleta(colores,32);
//final
reset_yiear;
iniciar_yiear:=true;
end;

procedure cerrar_yiear;pascal;
begin
cerrar_cpus;
SN76496_close(0);
vlm5030_close(0);
cerrar_audio;
cerrar_video;
end;

procedure reset_yiear;pascal;
begin
 reset_6809(main_6809,main_6809_ll);
 reset_audio;
 vlm5030_reset(0);
 zeromemory(@memoria[0],$7FFF);
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 pedir_irq:=false;
 pedir_nmi:=false;
 sound_latch:=0;
end;

procedure update_video_yiear;
var
  x,y:byte;
  f:word;
  nchar:word;
begin
for f:=0 to $3ff do begin
    if gfx[0].buffer[f] then begin
      x:=f mod 32;
      y:=f div 32;
      nchar:=memoria[$5801+(f*2)]+((memoria[$5800+(f*2)] and $10) shl 4);
      put_gfx_flip(x*8,y*8,nchar,16,1,0,(memoria[$5800+(f*2)] and $80)<>0,(memoria[$5800+(f*2)] and $40)<>0);
      gfx[0].buffer[f]:=false;
    end;
end;
actualiza_trozo(0,16,256,224,1,0,0,256,224,0);
for f:=$17 downto 0 do begin
  nchar:=memoria[$5401+(f*2)]+((memoria[$5000+(f*2)] and 1) shl 8);
  x:=memoria[$5400+(f*2)];
  y:=224-memoria[$5001+(f*2)];
  if f<$13 then inc(y);
  put_gfx_sprite(nchar,0,(memoria[$5000+(f*2)] and $40)=0,(memoria[$5000+(f*2)] and $80)<>0,1);
  actualiza_gfx_sprite(x,y,0,1);
end;
end;

procedure eventos_yiear;
begin
if (evento.teclado or evento.joystick) then begin
  if (teclado[SDLK_DOWN] or joystick.arriba) then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if (teclado[SDLK_UP] or joystick.abajo) then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if (teclado[SDLK_RIGHT] or joystick.izq) then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if (teclado[SDLK_LEFT] or joystick.der) then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if (teclado[SDLK_LALT] or joystick.boton0) then in1:=(in1 and $df) else in1:=(in1 or $20);
  if (teclado[SDLK_LCTRL] or joystick.boton1) then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if teclado[SDLK_1] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if teclado[SDLK_5] then in0:=(in0 and $fe) else in0:=(in0 or 1);
  if teclado[SDLK_2] then in0:=(in0 and $ef) else in0:=(in0 or $10);
end;
end;

procedure yiear_principal;pascal;
var
  frame:single;
begin
iniciar_entradas;
frame:=0;
while EmuStatus=EsRuning do begin
  frame:=frame+main_6809.tframes;
  run_6809(main_6809,main_6809_ll,trunc(frame));
  main_6809.pedir_irq:=pedir_irq;
  frame:=frame-main_6809.contador;
  main_6809.contador:=0;
  update_video_yiear;
  actualiza_video;
  eventos_yiear;
  sincronizar;
  evaluar_entradas;
end;
end;

function yiear_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $0:yiear_getbyte:=VLM5030_BSY(0);
  $4c00:yiear_getbyte:=$59;
  $4d00:yiear_getbyte:=$FF;
  $4e00:yiear_getbyte:=in0;
  $4e01:yiear_getbyte:=in1;
  $4e02:yiear_getbyte:=in2;
  $4e03:yiear_getbyte:=$FF;
  else yiear_getbyte:=memoria[direccion];
end;
end;

procedure yiear_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion>$7FFF then exit;
memoria[direccion]:=valor;
case direccion of
  $4000:begin
          pedir_irq:=((valor and $4)<>0);
          pedir_nmi:=((valor and $2)<>0);
        end;
  $4800:sound_latch:=valor;
  $4900:SN76496Write(0,sound_latch);
  $4a00:begin
           VLM5030_ST(0,(valor shr 1) and 1);
	         VLM5030_RST(0,(valor shr 2 ) and 1 );
        end;
  $4b00:VLM5030_data_w(0,valor);
  $5800..$5fff:gfx[0].buffer[(direccion and $7ff) shr 1]:=true;
end;
end;

procedure yiear_snd_nmi;pascal;
begin
  main_6809.pedir_nmi:=pedir_nmi;
end;

procedure yiear_vlm_5030;pascal;
begin
if hay_sonido then vlm5030_update(0,1);
end;

procedure yiear_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=SN76496Update(0);
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

end.
