unit arcade_const;

interface
uses sdl,windows,constantes,sysutils,dialogs,lenguaje,z80,m6809,m6502,m68000;
const
    max_colors=4096;
type
  scroll_tipo=record
          long_x,long_y:word;  //Longitud de la pantalla
          ad_x,ad_y:word;      //Ajuste inicial del scroll
          max_x,max_y:word;    //Longitud maxima de la ventana del scroll
          max_scr_x,max_scr_y:word;  //Corte de la ventana del scroll
        end;
  tipo_sprites=record
    pos_planos:array[0..7] of dword;
    bit_pixel:byte;
    long_sprites:dword;
    banks:byte;
  end;
  gfx_tipo=record
    x,y:byte;
    datos:pbyte;
    colores:array[0..max_colors-1] of word;
    trans:array[0..31] of boolean;
    buffer:array[0..$7ff] of boolean;
    valor:array[0..$7ff] of byte;
    elements:word;
  end;
  pgfx=^gfx_tipo;
var
  scroll_data:scroll_tipo;
  gfx:array[0..5] of gfx_tipo;
  des_sprites:tipo_sprites;
  memoria_temp:array[0..$fffff] of byte;
  buffer_sprites:array[0..$1fff] of byte;
  in0,in1,in2:byte;
  //cpu's
  main_z80,snd_z80,misc_z80:preg_z80;
  main_z80_ll,snd_z80_ll,misc_z80_ll:llam_z80;
  main_6809,snd_6809:preg_6809;
  main_6809_ll,snd_6809_ll:llam_6809;
  main_6502,snd_6502:preg_6502;
  main_6502_ll,snd_6502_ll:llam_6502;
  main_68000,snd_68000:preg_68000;
  main_68000_ll,snd_68000_ll:llam_68000;
const
  z80_main=0;
  z80_snd=1;
  z80_misc=2;
  m6809_main=3;
  m6809_snd=4;
  m6502_main=5;
  m6502_snd=6;
  m68000_main=7;
  m68000_snd=8;

procedure cerrar_cpus;
function cargar_roms(sitio:pbyte;ctipo_roms:ptipo_roms;nombre_zip:string;cantidad_roms:byte):boolean;
function cargar_roms16b(sitio:pbyte;ctipo_roms:ptipo_roms;nombre_zip:string;cantidad_roms:byte):boolean;
procedure convert_sprites(ngfx:pgfx;increment:dword;SpriteRom:pbyte;cx,cy:pdword;rot90,rol90:boolean);
procedure put_gfx(pos_x,pos_y,nchar,color:word;screen,ngfx:byte);
procedure put_gfx_trans(pos_x,pos_y,nchar,color:word;screen,ngfx:byte);
procedure put_gfx_flip(pos_x,pos_y,nchar,color:word;screen,ngfx:byte;flipx,flipy:boolean);
procedure put_gfx_trans_flip(pos_x,pos_y,nchar,color:word;screen,ngfx:byte;flipx,flipy:boolean);
procedure put_gfx_sprite(nchar,color:word;flipx,flipy:boolean;ngfx:byte);
procedure put_gfx_sprite_table(nchar,color:word;flipx,flipy:boolean;ngfx,trans:byte);
procedure actualiza_gfx_sprite(pos_x,pos_y:word;dest,ngfx:byte);
procedure scroll_x_y(porigen,pdestino:byte;scroll_x,scroll_y:word);pascal;
procedure scroll__x(porigen,pdestino:byte;scroll_x:word);pascal;
procedure scroll__y(porigen,pdestino:byte;scroll_y:word);pascal;
procedure init_cpu(cpu_type,num:byte;tframes:single);
procedure init_gfx(num,x_size,y_size:byte;num_elements:word);
function bit(data:word;bitpos:byte):boolean;
function BITSWAP8(val,B7,B6,B5,B4,B3,B2,B1,B0:byte):byte;
function BITSWAP16(val:word;B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0:byte):word;
function BITSWAP24(val:dword;B23,B22,B21,B20,B19,B18,B17,B16,B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0:byte):dword;

implementation
uses principal;

function bit(data:word;bitpos:byte):boolean;
begin
   bit:=((data shr bitpos) and 1)<>0;
end;

function BITSWAP8(val,B7,B6,B5,B4,B3,B2,B1,B0:byte):byte;
var
  src:byte;
begin
     src:=0;
		 if BIT(val,B7) then src:=src or (1 shl 7);
		 if BIT(val,B6) then src:=src or (1 shl 6);
		 if BIT(val,B5) then src:=src or (1 shl 5);
		 if BIT(val,B4) then src:=src or (1 shl 4);
		 if BIT(val,B3) then src:=src or (1 shl 3);
		 if BIT(val,B2) then src:=src or (1 shl 2);
		 if BIT(val,B1) then src:=src or (1 shl 1);
		 if BIT(val,B0) then src:=src or (1 shl 0);
     bitswap8:=src;
end;

function BITSWAP16(val:word;B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0:byte):word;
var
  src:word;
begin
     src:=0;
     if BIT(val,B15) then src:=src or (1 shl 15);
		 if BIT(val,B14) then src:=src or (1 shl 14);
		 if BIT(val,B13) then src:=src or (1 shl 13);
		 if BIT(val,B12) then src:=src or (1 shl 12);
		 if BIT(val,B11) then src:=src or (1 shl 11);
		 if BIT(val,B10) then src:=src or (1 shl 10);
		 if BIT(val,B9) then src:=src or (1 shl 9);
		 if BIT(val,B8) then src:=src or (1 shl 8);
		 if BIT(val,B7) then src:=src or (1 shl 7);
		 if BIT(val,B6) then src:=src or (1 shl 6);
		 if BIT(val,B5) then src:=src or (1 shl 5);
		 if BIT(val,B4) then src:=src or (1 shl 4);
		 if BIT(val,B3) then src:=src or (1 shl 3);
		 if BIT(val,B2) then src:=src or (1 shl 2);
		 if BIT(val,B1) then src:=src or (1 shl 1);
		 if BIT(val,B0) then src:=src or (1 shl 0);
     bitswap16:=src;
end;

function BITSWAP24(val:dword;B23,B22,B21,B20,B19,B18,B17,B16,B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0:byte):dword;
var
  src:dword;
begin
     src:=0;
     if BIT(val,B23) then src:=src or (1 shl 23);
		 if BIT(val,B22) then src:=src or (1 shl 22);
		 if BIT(val,B21) then src:=src or (1 shl 21);
		 if BIT(val,B20) then src:=src or (1 shl 20);
		 if BIT(val,B19) then src:=src or (1 shl 19);
		 if BIT(val,B18) then src:=src or (1 shl 18);
		 if BIT(val,B17) then src:=src or (1 shl 17);
		 if BIT(val,B16) then src:=src or (1 shl 16);
     if BIT(val,B15) then src:=src or (1 shl 15);
		 if BIT(val,B14) then src:=src or (1 shl 14);
		 if BIT(val,B13) then src:=src or (1 shl 13);
		 if BIT(val,B12) then src:=src or (1 shl 12);
		 if BIT(val,B11) then src:=src or (1 shl 11);
		 if BIT(val,B10) then src:=src or (1 shl 10);
		 if BIT(val,B9) then src:=src or (1 shl 9);
		 if BIT(val,B8) then src:=src or (1 shl 8);
		 if BIT(val,B7) then src:=src or (1 shl 7);
		 if BIT(val,B6) then src:=src or (1 shl 6);
		 if BIT(val,B5) then src:=src or (1 shl 5);
		 if BIT(val,B4) then src:=src or (1 shl 4);
		 if BIT(val,B3) then src:=src or (1 shl 3);
		 if BIT(val,B2) then src:=src or (1 shl 2);
		 if BIT(val,B1) then src:=src or (1 shl 1);
		 if BIT(val,B0) then src:=src or (1 shl 0);
     bitswap24:=src;
end;

procedure scroll_x_y(porigen,pdestino:byte;scroll_x,scroll_y:word);pascal;
var
  long_x,long_y:word;
begin
if scroll_x>scroll_data.long_x then scroll_x:=scroll_data.long_x-($10000-scroll_x);
if scroll_y>scroll_data.long_y then scroll_y:=scroll_data.long_y-($10000-scroll_y);
if scroll_y>(scroll_data.max_scr_y-scroll_data.ad_y) then long_y:=scroll_data.long_y-scroll_y
  else long_y:=scroll_data.max_y;
if scroll_x>(scroll_data.max_scr_x-scroll_data.ad_x) then long_x:=scroll_data.long_x-scroll_x
  else long_x:=scroll_data.max_x;
actualiza_trozo(scroll_x,scroll_y,long_x,long_y,porigen,0,0,long_x,long_y,pdestino);
if long_x<scroll_data.max_x then actualiza_trozo(0,scroll_y,scroll_data.max_x-long_x,long_y,porigen,long_x,0,scroll_data.max_x-long_x,long_y,pdestino);
if long_y<scroll_data.max_y then actualiza_trozo(scroll_x,0,long_x,scroll_data.max_y-long_y,porigen,0,long_y,long_x,scroll_data.max_y-long_y,pdestino);
if ((long_x<scroll_data.max_x) and (long_y<scroll_data.max_y)) then actualiza_trozo(0,0,scroll_data.max_x-long_x,scroll_data.max_y-long_y,porigen,long_x,long_y,scroll_data.max_x-long_x,scroll_data.max_y-long_y,pdestino);
end;

procedure scroll__x(porigen,pdestino:byte;scroll_x:word);pascal;
var
  long_x:word;
begin
if scroll_x>(scroll_data.max_scr_x-scroll_data.ad_x) then long_x:=scroll_data.long_x-scroll_x
  else long_x:=scroll_data.max_x;
actualiza_trozo(scroll_x,0,long_x,256,porigen,0,0,long_x,256,pdestino);
if long_x<scroll_data.max_x then actualiza_trozo(0,0,scroll_data.max_x-long_x,256,porigen,long_x,0,scroll_data.max_x-long_x,256,pdestino);
end;

procedure scroll__y(porigen,pdestino:byte;scroll_y:word);pascal;
var
  long_y:word;
begin
if scroll_y>(scroll_data.max_scr_y-scroll_data.ad_y) then long_y:=scroll_data.long_y-scroll_y
  else long_y:=scroll_data.max_y;
actualiza_trozo(0,scroll_y,256,long_y,porigen,0,0,256,long_y,pdestino);
if long_y<scroll_data.max_y then actualiza_trozo(0,0,256,scroll_data.max_y-long_y,porigen,0,long_y,256,scroll_data.max_y-long_y,pdestino);
end;

procedure put_gfx(pos_x,pos_y,nchar,color:word;screen,ngfx:byte);
var
  x,y:byte;
  temp:pword;
  pos:pbyte;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
for y:=0 to (gfx[ngfx].y-1) do begin
  temp:=punbuf;
  for x:=0 to (gfx[ngfx].x-1) do begin
    temp^:=paleta[gfx[ngfx].colores[pos^+color]];
    inc(pos);
    inc(temp);
  end;
  putpixel(pos_x,pos_y+y,gfx[ngfx].x,punbuf,screen);
end;
end;

procedure put_gfx_trans(pos_x,pos_y,nchar,color:word;screen,ngfx:byte);
var
  x,y:byte;
  temp:pword;
  pos:pbyte;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
for y:=0 to (gfx[ngfx].y-1) do begin
  temp:=punbuf;
  for x:=0 to (gfx[ngfx].x-1) do begin
    if not(gfx[ngfx].trans[pos^]) then temp^:=gfx[ngfx].colores[pos^+color]
      else temp^:=max_colores;
    inc(pos);
    inc(temp);
  end;
  putpixel_trans(pos_x,pos_y+y,gfx[ngfx].x,punbuf,screen);
end;
end;

procedure put_gfx_flip(pos_x,pos_y,nchar,color:word;screen,ngfx:byte;flipx,flipy:boolean);
var
  x,y:byte;
  temp:pword;
  pos,post:pbyte;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
if flipx then begin
  for y:=0 to (gfx[ngfx].y-1) do begin
    post:=pos;
    inc(post,(y*gfx[ngfx].x)+gfx[ngfx].x-1);
    temp:=punbuf;
    for x:=(gfx[ngfx].x-1) downto 0 do begin
      temp^:=paleta[gfx[ngfx].colores[post^+color]];
      dec(post);
      inc(temp);
    end;
    if flipy then putpixel(pos_x,pos_y+(gfx[ngfx].y-1)-y,gfx[ngfx].x,punbuf,screen)
      else putpixel(pos_x,pos_y+y,gfx[ngfx].x,punbuf,screen);
  end;
end else begin
  for y:=0 to (gfx[ngfx].y-1) do begin
    temp:=punbuf;
    for x:=0 to (gfx[ngfx].x-1) do begin
      temp^:=paleta[gfx[ngfx].colores[pos^+color]];
      inc(pos);
      inc(temp);
    end;
    if flipy then putpixel(pos_x,pos_y+(gfx[ngfx].y-1)-y,gfx[ngfx].x,punbuf,screen)
      else putpixel(pos_x,pos_y+y,gfx[ngfx].x,punbuf,screen);
  end;
end;
end;

procedure put_gfx_trans_flip(pos_x,pos_y,nchar,color:word;screen,ngfx:byte;flipx,flipy:boolean);
var
  x,y:byte;
  temp:pword;
  pos,post:pbyte;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
if flipx then begin
  for y:=0 to (gfx[ngfx].y-1) do begin
    post:=pos;
    inc(post,(y*gfx[ngfx].x)+gfx[ngfx].x-1);
    temp:=punbuf;
    for x:=(gfx[ngfx].x-1) downto 0 do begin
      if not(gfx[ngfx].trans[post^]) then temp^:=gfx[ngfx].colores[post^+color]
        else temp^:=max_colores;
      dec(post);
      inc(temp);
    end;
    if flipy then putpixel_trans(pos_x,pos_y+(gfx[ngfx].y-1)-y,gfx[ngfx].x,punbuf,screen)
      else putpixel_trans(pos_x,pos_y+y,gfx[ngfx].x,punbuf,screen);
  end;
end else begin
  for y:=0 to (gfx[ngfx].y-1) do begin
    temp:=punbuf;
    for x:=0 to (gfx[ngfx].x-1) do begin
      if not(gfx[ngfx].trans[pos^]) then temp^:=gfx[ngfx].colores[pos^+color]
        else temp^:=max_colores;
      inc(pos);
      inc(temp);
    end;
    if flipy then putpixel_trans(pos_x,pos_y+(gfx[ngfx].y-1)-y,gfx[ngfx].x,punbuf,screen)
      else putpixel_trans(pos_x,pos_y+y,gfx[ngfx].x,punbuf,screen);
  end;
end;
end;

procedure put_gfx_sprite(nchar,color:word;flipx,flipy:boolean;ngfx:byte);
var
        x,y:byte;
        temp:pword;
        pos,post:pbyte;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
if flipx then begin
  for y:=0 to (gfx[ngfx].y-1) do begin
    post:=pos;
    inc(post,(y*gfx[ngfx].x)+gfx[ngfx].x-1);
    temp:=punbuf;
    for x:=(gfx[ngfx].x-1) downto 0 do begin
      if not(gfx[ngfx].trans[post^]) then temp^:=gfx[ngfx].colores[post^+color]
        else temp^:=max_colores;
      inc(temp);
      dec(post);
    end;
    if flipy then putpixel_trans(0,((gfx[ngfx].y-1)-y),gfx[ngfx].x,punbuf,9)
      else putpixel_trans(0,y,gfx[ngfx].x,punbuf,9);
  end;
end else begin
  for y:=0 to (gfx[ngfx].y-1) do begin
    temp:=punbuf;
    for x:=0 to (gfx[ngfx].x-1) do begin
      if not(gfx[ngfx].trans[pos^]) then temp^:=gfx[ngfx].colores[pos^+color]
        else temp^:=max_colores;
      inc(temp);
      inc(pos);
    end;
    if flipy then putpixel_trans(0,((gfx[ngfx].y-1)-y),gfx[ngfx].x,punbuf,9)
      else putpixel_trans(0,y,gfx[ngfx].x,punbuf,9);
  end;
end;
end;

procedure put_gfx_sprite_table(nchar,color:word;flipx,flipy:boolean;ngfx,trans:byte);
var
        x,y,punto:byte;
        temp:pword;
        pos,post:pbyte;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
if flipx then begin
  for y:=0 to (gfx[ngfx].y-1) do begin
    post:=pos;
    inc(post,(y*gfx[ngfx].x)+gfx[ngfx].x-1);
    temp:=punbuf;
    for x:=(gfx[ngfx].x-1) downto 0 do begin
      punto:=gfx[ngfx].colores[post^+color];
      if punto<>trans then temp^:=punto
        else temp^:=max_colores;
      inc(temp);
      dec(post);
    end;
    if flipy then putpixel_trans(0,((gfx[ngfx].y-1)-y),gfx[ngfx].x,punbuf,9)
      else putpixel_trans(0,y,gfx[ngfx].x,punbuf,9);
  end;
end else begin
  for y:=0 to (gfx[ngfx].y-1) do begin
    temp:=punbuf;
    for x:=0 to (gfx[ngfx].x-1) do begin
      punto:=gfx[ngfx].colores[pos^+color];
      if punto<>trans then temp^:=punto
        else temp^:=max_colores;
      inc(temp);
      inc(pos);
    end;
    if flipy then putpixel_trans(0,((gfx[ngfx].y-1)-y),gfx[ngfx].x,punbuf,9)
      else putpixel_trans(0,y,gfx[ngfx].x,punbuf,9);
  end;
end;
end;

procedure actualiza_gfx_sprite(pos_x,pos_y:word;dest,ngfx:byte);
var
  origen,destino:sdl_rect;
begin
origen.x:=0;
origen.y:=0;
origen.w:=gfx[ngfx].x;
origen.h:=gfx[ngfx].y;
destino.x:=pos_x;
destino.y:=pos_y;
destino.w:=gfx[ngfx].x;
destino.h:=gfx[ngfx].y;
SDL_BlitSurface(pantalla[9],@origen,pantalla[dest],@destino);
end;

function GetBit(bit_nbr:dword;buffer:pbyte):byte;
var
  oct_nbr:dword;
  bit_n:byte;
  pos:pbyte;
begin
pos:=buffer;
oct_nbr:=bit_nbr div 8;
bit_n:=bit_nbr mod 8;
inc(pos,oct_nbr);
getbit:=((pos^ shr (7-bit_n)) and 1);
end;

procedure Rotatel(n:word;ngfx:pgfx;increment:dword);
var
  x,y:byte;
  src,t:array[0..1023] of byte;
  pos:pbyte;
begin
case ngfx.x of
  8:begin
      pos:=ngfx.datos;
      inc(pos,64*n+increment);
      copymemory(@src[0],pos,64);
      for y:=0 to 7 do for x:=0 to 7 do T[x*8+y]:=src[(7-x)+y*8];
      pos:=ngfx.datos;
      inc(pos,64*n+increment);
      copymemory(pos,@t[0],64);
  end;
  16:begin
      pos:=ngfx.datos;
      inc(pos,256*n+increment);
      copymemory(@src[0],pos,256);
      for y:=15 downto 0 do for x:=15 downto 0 do T[x*16+y]:=src[(15-x)+y*16];
      pos:=ngfx.datos;
      inc(pos,256*n+increment);
      copymemory(pos,@t[0],256);
    end;
  32:begin
      pos:=ngfx.datos;
      inc(pos,1024*n+increment);
      copymemory(@src[0],pos,1024);
      for y:=0 to 31 do for x:=0 to 31 do T[x*32+y]:=src[(31-x)+y*32];
      pos:=ngfx.datos;
      inc(pos,1024*n+increment);
      copymemory(pos,@t[0],1024);
    end;
end;
end;

procedure Rotater(n:word;ngfx:pgfx;increment:dword);
var
  x,y:byte;
  src,t:array[0..1023] of byte;
  pos:pbyte;
begin
case ngfx.x of
  8:begin
      pos:=ngfx.datos;
      inc(pos,64*n+increment);
      copymemory(@src[0],pos,64);
      for y:=0 to 7 do for x:=0 to 7 do T[(7-x)+y*8]:=src[x*8+y];
      pos:=ngfx.datos;
      inc(pos,64*n+increment);
      copymemory(pos,@t[0],64);
  end;
  16:begin
      pos:=ngfx.datos;
      inc(pos,256*n+increment);
      copymemory(@src[0],pos,256);
      for y:=0 to 15 do for x:=0 to 15 do T[(15-x)+y*16]:=src[x*16+y];
      pos:=ngfx.datos;
      inc(pos,256*n+increment);
      copymemory(pos,@t[0],256);
    end;
  32:begin
      pos:=ngfx.datos;
      inc(pos,1024*n+increment);
      copymemory(@src[0],pos,1024);
      for y:=0 to 31 do for x:=0 to 31 do T[(31-x)+y*32]:=src[x*32+y];
      pos:=ngfx.datos;
      inc(pos,1024*n+increment);
      copymemory(pos,@t[0],1024);
    end;
end;
end;

procedure convert_sprites(ngfx:pgfx;increment:dword;SpriteRom:pbyte;cx,cy:pdword;rot90,rol90:boolean);
var
  n,elements:word;
  oct,b0,b1,b2,b3,b4,b5,b6,b7,o,i:byte;
  SpriteNbr,Ind:dword;
  pos:pbyte;
  temp_cx,temp_cy:pdword;
begin
b1:=0;
b2:=0;
b3:=0;
b4:=0;
b5:=0;
b6:=0;
b7:=0;
Ind:=0;
temp_cx:=cx;
temp_cy:=cy;
if des_sprites.banks<>0 then elements:=(ngfx.elements div des_sprites.banks)-1
  else elements:=ngfx.elements-1;
for n:=0 to elements do begin
	SpriteNbr:=n*des_sprites.long_sprites;
  cy:=temp_cy;
	for o:=0 to (ngfx.y-1) do begin
    cx:=temp_cx;
		for i:=0 to (ngfx.x-1) do begin
     case des_sprites.bit_pixel of
      1:begin
			    b0:=GetBit(des_sprites.pos_planos[0]+Cy^+Cx^+SpriteNbr,SpriteRom);
        end;
      2:begin
			    b1:=GetBit(des_sprites.pos_planos[0]+Cy^+Cx^+SpriteNbr,SpriteRom);
			    b0:=GetBit(des_sprites.pos_planos[1]+Cy^+Cx^+SpriteNbr,SpriteRom);
        end;
      3:begin
          b2:=GetBit(des_sprites.pos_planos[0]+Cy^+Cx^+SpriteNbr,SpriteRom);
			    b1:=GetBit(des_sprites.pos_planos[1]+Cy^+Cx^+SpriteNbr,SpriteRom);
          b0:=GetBit(des_sprites.pos_planos[2]+Cy^+Cx^+SpriteNbr,SpriteRom);
        end;
      4:begin
          b3:=GetBit(des_sprites.pos_planos[0]+Cy^+Cx^+SpriteNbr,SpriteRom);
			    b2:=GetBit(des_sprites.pos_planos[1]+Cy^+Cx^+SpriteNbr,SpriteRom);
			    b1:=GetBit(des_sprites.pos_planos[2]+Cy^+Cx^+SpriteNbr,SpriteRom);
			    b0:=GetBit(des_sprites.pos_planos[3]+Cy^+Cx^+SpriteNbr,SpriteRom);
      end;
     8:begin
          b7:=GetBit(des_sprites.pos_planos[0]+Cy^+Cx^+SpriteNbr,SpriteRom);
          b6:=GetBit(des_sprites.pos_planos[1]+Cy^+Cx^+SpriteNbr,SpriteRom);
          b5:=GetBit(des_sprites.pos_planos[2]+Cy^+Cx^+SpriteNbr,SpriteRom);
          b4:=GetBit(des_sprites.pos_planos[3]+Cy^+Cx^+SpriteNbr,SpriteRom);
          b3:=GetBit(des_sprites.pos_planos[4]+Cy^+Cx^+SpriteNbr,SpriteRom);
			    b2:=GetBit(des_sprites.pos_planos[5]+Cy^+Cx^+SpriteNbr,SpriteRom);
			    b1:=GetBit(des_sprites.pos_planos[6]+Cy^+Cx^+SpriteNbr,SpriteRom);
			    b0:=GetBit(des_sprites.pos_planos[7]+Cy^+Cx^+SpriteNbr,SpriteRom);
      end;
     end;
			oct:=(b7 shl 7) or (b6 shl 6) or (b5 shl 5) or (b4 shl 4) or (b3 shl 3) or (b2 shl 2) or (b1 shl 1) or (b0 shl 0);
      pos:=ngfx.datos;
      inc(pos,ind+increment);
			pos^:=oct;
      inc(ind);
      inc(cx);
    end;  //del i
    inc(cy);
  end; //del o
	if rot90 then Rotater(n,ngfx,increment);
  if rol90 then Rotatel(n,ngfx,increment);
end;
end;

function cargar_roms(sitio:pbyte;ctipo_roms:ptipo_roms;nombre_zip:string;cantidad_roms:byte):boolean;
var
  f:byte;
  rom_cargada:boolean;
  ptemp:pbyte;
  troms:ptipo_roms;
begin
cargar_roms:=false;
if not(fileexists(Directory.Arcade_roms+nombre_zip)) then begin
  MessageDlg('Fichero '+nombre_zip+' no encontrado.', mtError,[mbOk], 0);
  exit;
end;
troms:=ctipo_roms;
f:=0;
repeat
    ptemp:=sitio;
    inc(ptemp,troms.p);
    rom_cargada:=carga_rom_zip(Directory.Arcade_roms+nombre_zip,troms.n,ptemp,troms.l);
    if not(rom_cargada) then begin
      MessageDlg(leng[idioma].errores[0]+' "'+troms.n+'" '+leng[idioma].errores[1]+' "'+nombre_zip+'" ', mtError,[mbOk], 0);
      exit;
    end;
    inc(troms);
    inc(f);
until ((troms.n='') or (f=cantidad_roms));
cargar_roms:=true;
end;

function cargar_roms16b(sitio:pbyte;ctipo_roms:ptipo_roms;nombre_zip:string;cantidad_roms:byte):boolean;
var
  f:byte;
  rom_cargada:boolean;
  ptemp:pbyte;
  troms:ptipo_roms;
  mem_temp:array[0..$1ffff] of byte;
  h:dword;
begin
cargar_roms16b:=false;
if not(fileexists(Directory.Arcade_roms+nombre_zip)) then begin
  MessageDlg('Fichero '+nombre_zip+' no encontrado.', mtError,[mbOk], 0);
  exit;
end;
troms:=ctipo_roms;
f:=0;
repeat
    ptemp:=sitio;
    inc(ptemp,troms.p);
    rom_cargada:=carga_rom_zip(Directory.Arcade_roms+nombre_zip,troms.n,@mem_temp,troms.l);
    for h:=0 to (troms.l-1) do begin
      ptemp^:=mem_temp[h];
      inc(ptemp,2);
    end;
    if not(rom_cargada) then begin
      MessageDlg(leng[idioma].errores[0]+' "'+troms.n+'" '+leng[idioma].errores[1]+' "'+nombre_zip+'" ', mtError,[mbOk], 0);
      exit;
    end;
    inc(troms);
    inc(f);
until ((troms.n='') or (f=cantidad_roms));
cargar_roms16b:=true;
end;

procedure cerrar_cpus;
var
  f:byte;
  g:word;
begin
if main_z80<>nil then freemem(main_z80);
main_z80:=nil;
if snd_z80<>nil then freemem(snd_z80);
snd_z80:=nil;
if misc_z80<>nil then freemem(misc_z80);
misc_z80:=nil;
if main_6809<>nil then freemem(main_6809);
main_6809:=nil;
if snd_6809<>nil then freemem(snd_6809);
snd_6809:=nil;
if main_6502<>nil then freemem(main_6502);
main_6502:=nil;
if snd_6502<>nil then freemem(snd_6502);
snd_6502:=nil;
if main_68000<>nil then freemem(main_68000);
main_68000:=nil;
if snd_68000<>nil then freemem(snd_68000);
snd_68000:=nil;
for f:=0 to 4 do begin
  if gfx[f].datos<>nil then begin
    freemem(gfx[f].datos);
    gfx[f].datos:=nil;
  end;
  for g:=0 to max_colors-1 do gfx[f].colores[g]:=g;
  zeromemory(@gfx[f].trans,32);
  fillmemory(@gfx[f].buffer,$800,1);
  zeromemory(@gfx[f].valor,$800);
end;
zeromemory(@paleta[0],max_colores*4);
zeromemory(@memoria[0],$ffff);
zeromemory(@mem_snd[0],$ffff);
fillmemory(@buffer_paleta[0],max_colores*2,1);
end;

procedure init_cpu(cpu_type,num:byte;tframes:single);
begin
  case cpu_type of
    z80_main:begin
                getmem(main_z80,sizeof(reg_z80));
                zeromemory(main_z80,sizeof(reg_z80));
                main_z80.numero_cpu:=num;
                main_z80.tframes:=tframes;
             end;
    z80_snd:begin
                getmem(snd_z80,sizeof(reg_z80));
                zeromemory(snd_z80,sizeof(reg_z80));
                snd_z80.numero_cpu:=num;
                snd_z80.tframes:=tframes;
             end;
    z80_misc:begin
                getmem(misc_z80,sizeof(reg_z80));
                zeromemory(misc_z80,sizeof(reg_z80));
                misc_z80.numero_cpu:=num;
                misc_z80.tframes:=tframes;
             end;
    m6809_main:begin
                getmem(main_6809,sizeof(reg_6809));
                zeromemory(main_6809,sizeof(reg_6809));
                main_6809.numero_cpu:=num;
                main_6809.tframes:=tframes;
               end;
    m6809_snd:begin
                getmem(snd_6809,sizeof(reg_6809));
                zeromemory(snd_6809,sizeof(reg_6809));
                snd_6809.numero_cpu:=num;
                snd_6809.tframes:=tframes;
               end;
    m6502_main:begin
                getmem(main_6502,sizeof(reg_6502));
                zeromemory(main_6502,sizeof(reg_6502));
                main_6502.numero_cpu:=num;
                main_6502.tframes:=tframes;
               end;
    m6502_snd:begin
                getmem(snd_6502,sizeof(reg_6502));
                zeromemory(snd_6502,sizeof(reg_6502));
                snd_6502.numero_cpu:=num;
                snd_6502.tframes:=tframes;
               end;
    m68000_main:begin
               getmem(main_68000,sizeof(reg_68000));
                zeromemory(main_68000,sizeof(reg_68000));
                main_68000.numero_cpu:=num;
                main_68000.tframes:=tframes;
    end;
    m68000_snd:begin
               getmem(snd_68000,sizeof(reg_68000));
                zeromemory(snd_68000,sizeof(reg_68000));
                snd_68000.numero_cpu:=num;
                snd_68000.tframes:=tframes;
    end;
  end;
end;

procedure init_gfx(num,x_size,y_size:byte;num_elements:word);
begin
  if gfx[num].datos<>nil then freemem(gfx[num].datos);
  gfx[num].x:=x_size;
  gfx[num].y:=y_size;
  gfx[num].elements:=num_elements;
  getmem(gfx[num].datos,num_elements*x_size*y_size);
end;

end.
