unit cargar_spec;

interface

uses
  sdl,Windows, Messages,sysutils,Forms,constantes,Controls, StdCtrls, ExtCtrls,
  FileCtrl,zipforge,entradas, Classes,spectrum_48k,lenguaje,zlibex, ComCtrls;

type
  TForm2 = class(TForm)
    Button1: TButton;
    GroupBox1: TGroupBox;
    Image1: TImage;
    Button2: TButton;
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    procedure FileListBox1DblClick(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  datos,datos_rom:pbyte;
  extension,nombre,nombre_rom:string;
  file_size,rom_size:integer;
  todo_correcto:boolean=false;
  salir_tload,hay_rom:boolean;

implementation
uses principal,spectrum_misc,tap_tzx,snapshot;
{$R *.dfm}

procedure comprobar_rom;
var
  rom_crc:cardinal;
  pos_rom:pbyte;
begin
rom_crc:=calcCRC32(datos_rom,rom_size);
case rom_crc of
   $7BCD642C:begin  //Knight Lore
                   interface2.hay_if2:=true;
                   interface2.cargado:=false;
                   pos_rom:=datos_rom;
                   copymemory(@interface2.rom_l[0],pos_rom,$4000);
                   inc(pos_rom,$4000);
                   copymemory(@interface2.rom_h[0],pos_rom,$4000);
                   interface2.retraso:=10500000;
             end;
   else begin
          copymemory(@memoria[0],datos_rom,$4000);
          interface2.hay_if2:=false;
   end;
end;
end;

procedure TForm2.FileListBox1DblClick(Sender: TObject);
var
  resultado,cinta:boolean;
  cadena:string;
  ancho:word;
begin
if ((datos=nil) and not(hay_rom)) then exit;
cinta:=false;
resultado:=false;
if hay_rom then begin
  comprobar_rom;
  spec48k_reset;
  rom_cambiada_48:=true;
  todo_correcto:=true;
  resultado:=true;
  child.Caption:=llamadas_maquina.caption+' - ROM: '+nombre_rom;
  cadena:=' - ROM: ';
end else cadena:=' - Snap: ';
if not(todo_correcto) then exit;
form1.BitBtn15.Enabled:=true;
if extension='TAP' then begin
  resultado:=abrir_tap(datos,file_size);
  cinta:=true;
end;
if extension='TZX' then begin
  resultado:=abrir_tzx(datos,file_size);
  cinta:=true;
end;
if extension='PZX' then begin
  resultado:=abrir_pzx(datos,file_size);
  cinta:=true;
end;
if extension='CSW' then begin
  resultado:=abrir_csw(datos,file_size);
  cinta:=true;
end;
if extension='WAV' then begin
  resultado:=abrir_wav(datos,file_size);
  cinta:=true;
end;
if extension='Z80' then resultado:=abrir_z80(datos,file_size,false);
if extension='DSP' then resultado:=abrir_z80(datos,file_size,true);
if extension='SNA' then resultado:=abrir_sna(datos,file_size);
if extension='SP' then resultado:=abrir_sp(datos,file_size);
if extension='ZX' then resultado:=abrir_zx(datos,file_size);
if extension='SZX' then resultado:=abrir_szx(datos,file_size);
if not(resultado) then MessageBox(0, 'No es una cinta o un snapshot vlido.','Error', MB_OK or MB_ICONHAND)
  else begin
    if cinta then begin
      form1.edit1.Text:=nombre;
      form1.GroupBox1.Visible:=true;
      form1.BitBtn16.Enabled:=false;
    case video of
      1:begin
          ancho:=757;
          form1.groupbox1.left:=375;
        end;
      2:begin
          ancho:=1036;
          form1.groupbox1.left:=725;
        end;
    end;
    arregla_pos(ancho,0);
    end else child.Caption:=llamadas_maquina.caption+cadena+nombre;
    if datos<>nil then freemem(datos);
    datos:=nil;
    if datos_rom<>nil then freemem(datos_rom);
    datos_rom:=nil;
    Directory.spectrum_tap:=form2.FileListBox1.Directory;
    salir_tload:=true;
    form2.close;
   end;
end;

procedure TForm2.FileListBox1Click(Sender: TObject);
var
  g:integer;
  long_bloque:dword;
  f,h,pagina:byte;
  t1,t2,t3,t4,t5:integer;
  lbloque:dword;
  fichero:file of byte;
  hay_imagen,salida,hay_scr:boolean;
  temp,temp2,temp3,datos_scr:pbyte;
  ArchiveItem: TZFArchiveItem;
  cadena:string;
  zip_obj:tzipforge;
begin
todo_correcto:=false;
hay_imagen:=false;
hay_rom:=false;
hay_scr:=false;
nombre:=filelistbox1.FileName;
extension:=extension_fichero(filelistbox1.FileName);
if extension='ZIP' then begin
  zip_obj:=tzipforge.Create(nil);
  zip_obj.CleanupInstance;
  zip_obj.FileName:=nombre;
  zip_obj.OpenArchive;
  zip_obj.FindFirst('*.rom',archiveitem);
  if ((archiveitem.filename<>'') and (tipo_maquina=0)) then hay_rom:=true;
  //primero busco un SCR
  zip_obj.FindFirst('*.SCR',archiveitem);
  if (archiveitem.filename<>'') then begin
    hay_scr:=true;
    getmem(datos_scr,archiveitem.UncompressedSize);
    extension:=extension_fichero(nombre);
    zip_obj.ExtractTobuffer(archiveitem.StoredPath+archiveitem.FileName,datos_scr^,archiveitem.UncompressedSize);
  end;
  zip_obj.FindFirst('*.*',archiveitem);
  repeat
    nombre:=archiveitem.FileName;
    file_size:=archiveitem.UncompressedSize;
    getmem(datos,file_size);
    temp:=datos;
    extension:=extension_fichero(nombre);
    if ((extension='TAP') or (extension='TZX') or (extension='PZX') or (extension='CSW') or (extension='WAV') or (extension='DSP') or (extension='SZX') or (extension='ZX') or (extension='Z80') or (extension='SP') or (extension='SNA')) then begin
      try
        zip_obj.ExtractTobuffer(archiveitem.StoredPath+archiveitem.FileName,temp^,file_size);
      except
        break;
      end;
      todo_correcto:=true;
      break;
    end;
  until not(zip_obj.FindNext(archiveitem));
  if hay_rom then begin
      zip_obj.FindFirst('*.rom',archiveitem);
      nombre_rom:=archiveitem.filename;
      rom_size:=archiveitem.UncompressedSize;
      getmem(datos_rom,rom_size);
      temp:=datos_rom;
      zip_obj.ExtractTobuffer(archiveitem.StoredPath+archiveitem.FileName,temp^,archiveitem.UncompressedSize);
  end;
   zip_obj.CloseArchive;
   zip_obj.Destroy;
end else begin  //fichero normal
  {$I-}
  filemode:=fmOpenRead;
  assignfile(fichero,nombre);
  reset(fichero);
  if ioresult<>0 then exit;
  file_size:=filesize(fichero);
  if extension='ROM' then begin
    if datos_rom<>nil then freemem(datos_rom);
    getmem(datos_rom,file_size);
    blockread(fichero,datos_rom^,file_size);
    hay_rom:=true;
    nombre:=extractfilename(nombre);
    exit;
  end else begin
    if datos<>nil then freemem(datos);
    getmem(datos,file_size);
    blockread(fichero,datos^,file_size);
  end;
  closefile(fichero);
  todo_correcto:=true;
  filemode:=fmOpenReadWrite;
  {$I+}
end;
if datos=nil then exit;
temp:=datos;
temp2:=nil;
nombre:=extractfilename(nombre);
if extension='SZX' then begin
  g:=0;
  inc(temp,8);inc(g,8);
  while (not(hay_imagen) and (g<file_size)) do begin
    cadena:='';
    for f:=0 to 3 do begin
      cadena:=cadena+chr(temp^);
      inc(temp);inc(g);
    end;
    lbloque:=sacar_word(temp);
    inc(temp,2);inc(g,2);
    lbloque:=sacar_word(temp)*65535+lbloque;
    inc(temp,2);inc(g,2);
    if cadena='RAMP' then begin
      long_bloque:=sacar_word(temp);
      inc(temp,2);
      pagina:=temp^;
      inc(temp);
      getmem(temp2,16384);
      if long_bloque=1 then ZDecompress(temp,lbloque-3,pointer(temp2),t2,16384);
      if pagina=5 then begin
            hay_imagen:=true;
            temp:=temp2;
      end else begin
        inc(temp,lbloque-3);
        inc(g,lbloque);
      end;
    end else begin
      inc(temp,lbloque);
      inc(g,lbloque);
    end;
  end;
end;
if extension='TAP' then begin
  g:=0;
  while (not(hay_imagen) and (g<file_size)) do begin
    long_bloque:=sacar_word(temp);
    inc(g,long_bloque+2);
    if long_bloque>6911 then begin
      hay_imagen:=true;
      inc(temp,3);
      break;
    end;
    inc(temp,long_bloque+2);
  end;
end;
if extension='TZX' then begin
  inc(temp,10);
  g:=0;
  salida:=false;
  while (not(hay_imagen) and (g<file_size)) do begin
    f:=temp^;
    inc(temp);inc(g);
    case f of
      $10:begin
          inc(temp,2);inc(g,2);
          long_bloque:=sacar_word(temp);
          inc(temp,2);inc(g,2);
          salida:=true;
         end;
      $11:begin
          inc(temp,15);inc(g,15);
          long_bloque:=sacar_word(temp);
          inc(temp,2);inc(g,2);
          inc(long_bloque,temp^*65536);
          inc(temp);inc(g);
          salida:=true;
         end;
      $12,$2a:long_bloque:=4;
      $13:long_bloque:=temp^*2+1;
      $14:begin
           inc(temp,7);inc(g,7);
           long_bloque:=sacar_word(temp);
           inc(temp,2);inc(g,2);
           inc(long_bloque,temp^*65536);
           inc(temp);inc(g);
           salida:=true;
          end;
      $19:begin
           inc(temp,6);inc(g,6);
           t5:=sacar_word(temp);
           inc(temp,2);inc(g,2);
           t5:=t5+(sacar_word(temp)*65536);
           inc(temp,2);inc(g,2);
           t1:=temp^;
           inc(temp);inc(g);
           t2:=temp^;
           inc(temp);inc(g);
           long_bloque:=sacar_word(temp);
           inc(temp,2);inc(g,2);
           long_bloque:=long_bloque+(sacar_word(temp)*65536);
           long_bloque:=long_bloque div 8;
           inc(temp,2);inc(g,2);
           t3:=temp^;
           inc(temp);inc(g);
           t4:=temp^;
           inc(temp);inc(g);
           for f:=1 to t2 do begin
            inc(temp);inc(g);
            for h:=1 to t1 do begin
              inc(temp,2);
              inc(g,2);
            end;
           end;
           for f:=1 to t5 do begin
            inc(temp);inc(g);
            inc(temp,2);inc(g,2);
           end;
           for f:=0 to (t4-1) do begin
            inc(temp);inc(g);
            for h:=t3 downto 1 do begin
              inc(temp,2);inc(g,2);
            end;
           end;
           if t4=2 then salida:=true;
      end;
      $20,$23,$24:long_bloque:=2;
      $21,$30:long_bloque:=temp^+1;
      $32:long_bloque:=sacar_word(temp)+2;
      $33:long_bloque:=temp^*3+1;
      $34:long_bloque:=8;
        else long_bloque:=0;
    end;
    inc(g,long_bloque);
    if ((long_bloque>6911) and salida) then begin
      hay_imagen:=true;
      if ((f<>$14) or (f<>$19)) then inc(temp);
    end else inc(temp,long_bloque);
  end;
end;
if extension='PZX' then begin
  g:=0;
  inc(temp,4);inc(g,4);
  long_bloque:=sacar_word(temp);
  inc(temp,2);inc(g,2);
  long_bloque:=long_bloque+(sacar_word(temp)*65536);
  inc(temp,2);inc(g,2);
  inc(temp,long_bloque);inc(g,long_bloque);
  while (not(hay_imagen) and (g<file_size)) do begin
    cadena:='';
    for f:=0 to 3 do begin
      cadena:=cadena+chr(temp^);
      inc(temp);inc(g);
    end;
    long_bloque:=sacar_word(temp);
    inc(temp,2);inc(g,2);
    long_bloque:=long_bloque+(sacar_word(temp)*65536);
    inc(temp,2);inc(g,2);
    temp3:=temp;
    inc(temp,long_bloque);inc(g,long_bloque);
    if cadena='DATA' then begin
      lbloque:=sacar_word(temp3);
      inc(temp3,2);
      lbloque:=lbloque+(sacar_word(temp3)*65536);
      inc(temp3,2);
      {if (temp3 and $7FFFFFFF)<>0 then cinta_tzx.datos_tzx[contador].inicial:=64
        else cinta_tzx.datos_tzx[contador].inicial:=0;}
      lbloque:=lbloque and $7FFFFFFF;
      //cinta_tzx.datos_tzx[contador].tail:=sacar_word(ptemp);
      inc(temp3,2);
      t1:=temp3^;
      inc(temp3);  //cantidad para formar la longitud del 0
      t2:=temp3^;
      inc(temp3);  //cantidad para formar la longitud del 1
      inc(temp3,t1*2);
      inc(temp3,t2*2);
      if (lbloque div 8)>6911 then begin
            hay_imagen:=true;
            temp:=temp3;
            inc(temp);
            temp3:=nil;
      end;
    end;
  end;
end;
if ((extension='Z80') or (extension='DSP')) then begin
  inc(temp,6);
  g:=sacar_word(temp);
  inc(temp,24);
  if g=0 then begin
    getmem(temp2,16384);
    g:=sacar_word(temp);
    inc(temp,g+2);
    f:=0;
    while f<>8 do begin
      g:=sacar_word(temp);
      inc(temp,2);
      f:=temp^;
      inc(temp);
      if f=8 then begin
        if g=$FFFF then copymemory(temp2,temp,$4000)
          else begin
            if extension='DSP' then ZDecompress(temp,g,pointer(temp2),g,16384)
              else descomprimir_z80(temp2,temp,g);
          end;
      end;
      if g=$FFFF then inc(temp,$4000)
        else inc(temp,g);
    end;
  end else begin
    getmem(temp2,49192);
    descomprimir_z80(temp2,temp,file_size-34);
  end;
  temp:=temp2;
  hay_imagen:=true;
end;
if extension='SNA' then begin
  inc(temp,27);
  hay_imagen:=true;
end;
if extension='SP' then begin
  inc(temp,38);
  hay_imagen:=true;
end;
if extension='ZX' then begin
  inc(temp,132);
  hay_imagen:=true;
end;
if hay_scr then begin
  temp:=datos_scr;
  hay_imagen:=true;
end;
//mostrar imagen si hay...
if hay_imagen then begin
  spec_a_pantalla(temp);
  image1.Picture.Graphic:=imagen1;
end;
if temp2<>nil then begin
  freemem(temp2);
  temp2:=nil;
end;
if datos_scr<>nil then begin
  freemem(datos_scr);
  datos_scr:=nil;
end;

end;

procedure TForm2.Button1Click(Sender: TObject);
begin
if datos<>nil then freemem(datos);
datos:=nil;
if datos_rom<>nil then freemem(datos_rom);
datos_rom:=nil;
Directory.spectrum_tap:=form2.FileListBox1.Directory;
salir_tload:=true;
form2.close;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
FileListBox1DblClick(self);
end;

procedure TForm2.FormDeactivate(Sender: TObject);
begin
if not(salir_tload) then form2.Show;
end;

procedure TForm2.FormShow(Sender: TObject);
begin
salir_tload:=false;
form2.FileListBox1.Mask:='*.zip;*.sp;*.zx;*.sna;*.z80;*.tzx;*.tap;*.csw;*.dsp;*.wav;*.szx;*.pzx';
if tipo_maquina=0 then form2.FileListBox1.Mask:=form2.FileListBox1.Mask+';*.rom';
form2.DirectoryListBox1.Directory:=Directory.spectrum_tap;
form2.Button2.Caption:=leng[idioma].mensajes[7];
form2.Button1.Caption:=leng[idioma].mensajes[8];
end;

procedure TForm2.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
case key of
  13:Button2Click(sender);
  27:button1click(sender);
end;
end;

end.
