unit constantes;

interface
uses menus,sdl,windows,forms,mmsystem,dialogs,sysutils,uchild,zipforge,pngimage;

const
        max_audio_buffer=15;  //Windows Vista necesita esto
        max_canales=3;
        max_pantalla=11;
        long_max_audio=1800;
        set_trans_color=$FFF0;
        max_colores=$600;

type
        Parejas = record
          case byte of
             0: (l, h: byte);
             1: (w: Word);
        end;
        pparejas=^parejas;
        tcolor=record
                r,g,b:byte;
        end;
        tpaleta=array[0..max_colores] of tcolor;
        tipo_roms=record
                n:string;
                l:dword;
                p:dword;
        end;
        ptipo_roms=^tipo_roms;
        tpantalla=record
                x:word;  //ancho
                y:word;  //alto
                trans:boolean;  //es transparente?
        end;
        TEmuStatus = (EsPause, EsRuning, EsStoped);

function sacar_word(datos:pbyte):word;pascal;
procedure iniciar_video;
procedure cambiar_video;
function iniciar_audio(canales:byte):boolean;
procedure reset_audio;
procedure play_sonido;
procedure putpixel_trans(x,y,cantidad:word;pixels:pword;sitio:byte);
procedure putpixel(x,y:dword;cantidad:word;pixel:pword;sitio:byte);
procedure linea_recta(x,y:word;color:byte;longitud:word;pant:byte);
procedure linea(x0,y0,x1,y1:integer;color:word);
procedure poner_paleta(ppaleta:tpaleta;numero_colores:word);
procedure poner_color(pcolor:tcolor;ppaleta:puint32);
procedure actualiza_trozo_principal(x1,y1,x2,y2:word);
procedure actualiza_trozo(o_x1,o_y1,o_x2,o_y2:word;sitio:byte;d_x1,d_y1,d_x2,d_y2:word;dest:byte);
procedure actualiza_video;
procedure pintar_pantalla(sitio:byte;color:word);
procedure cerrar_video;
procedure cerrar_audio;
procedure arregla_pos(ancho,alto:word);
function extension_fichero(nombre:string):string;
function cargar_rom(nombre:string;posicion:pointer;longitud:integer):boolean;
function carga_rom_zip(nombre_zip,nombre_rom:string;donde:pointer;longitud:integer):boolean;
procedure pasar_pantalla_completa;
procedure sincronizar;
function CalcCRC32(p: pointer; ByteCount:dword):dword;
procedure save_hi(nombre:string;posicion:pbyte;longitud:word);
function load_hi(nombre:string;posicion:pbyte;longitud:word):boolean;
function sshr(num,fac:integer):integer;
function dame_x_total:word;
function dame_y_total:word;
function getosversion:byte;

var
        //video
        p_final:array[0..max_pantalla] of tpantalla;
        paleta:array[0..max_colores] of Uint32;
        buffer_paleta:array[0..max_colores*2] of byte;
        rapido:boolean;
        pantalla:array[0..max_pantalla] of PSDL_Surface;
        punbuf:pword;
        video:byte;
        videoflags:dword=0;
        //audio
        posicion_sonido:word=0;
        audio:array[0..max_canales] of integer;
        num_buffer:byte;
        long_sample,sample_final:word;
        cab_audio:array[0..max_canales,0..max_audio_buffer] of wavehdr;
        tsample:array[0..6,0..long_max_audio] of smallint;
        //Misc
        cont_sincroniza,cont_micro:int64;
        hi_score:boolean;
        valor_sync:single;
        RAM,memoria,mem_snd:array[0..$ffff] of byte;
        EmuStatus: TEmuStatus;

implementation
uses principal,spectrum_misc,tap_tzx,arcade_const;

function getosversion:byte;
type
  POSVersionInfoEx = ^TOSVersionInfoEx;
  TOSVersionInfoEx = packed record
    dwOSVersionInfoSize: DWORD;
    dwMajorVersion     : DWORD;
    dwMinorVersion     : DWORD;
    dwBuildNumber      : DWORD;
    dwPlatformId       : DWORD;
    szCSDVersion       : array [0..127] of AnsiChar;
    wServicePackMajor  : Word;
    wServicePackMinor  : Word;
    wSuiteMask         : Word;
    wProductType       : Byte;
    wReserved          : Byte;
  end;
var
  Info: TOSVersionInfoEx;
  res:byte;
begin
  FillChar(Info, SizeOf(TOSVersionInfoEx), 0);
  Info.dwOSVersionInfoSize := SizeOf(TOSVersionInfoEx);
  GetVersionEx(TOSVersionInfo(Addr(Info)^));
  case info.dwMajorVersion of
    4:res:=10;
    6:if tipo_maquina=11 then res:=36 else res:=27;
     else res:=18;
  end;
  if ((tipo_maquina<9) or (tipo_maquina>99)) then inc(res,50); //si es es spectrum ajusto la vista...
  getosversion:=res;
end;

function CalcCRC32(p:pointer;ByteCount:dword):dword;
begin
CalcCRC32:=not(update_crc($FFFFFFFF,p,bytecount));
end;

procedure arregla_pos(ancho,alto:word);
begin
if ancho<>0 then form1.Width:=ancho;
if alto<>0 then form1.Height:=alto;
form1.Left:=(screen.Width div 2)-(form1.Width div 2);
form1.top:=(screen.Height div 2)-(form1.Height div 2)-10;
form1.statusbar1.Panels[2].Width:=form1.statusbar1.width-60-100-25-25;
form1.statusbar1.Panels[0].Width:=60;
form1.statusbar1.Panels[1].Width:=100;
form1.statusbar1.Panels[3].Width:=25;
form1.statusbar1.Panels[4].Width:=25;
end;

function carga_rom_zip(nombre_zip,nombre_rom:string;donde:pointer;longitud:integer):boolean;
var
  zip_obj:tzipforge;
begin
carga_rom_zip:=false;
if not(FileExists(nombre_zip)) then exit;
zip_obj:=tzipforge.Create(nil);
zip_obj.CleanupInstance;
zip_obj.FileName:=nombre_zip;
zip_obj.OpenArchive;
carga_rom_zip:=true;
try
  zip_obj.ExtractTobuffer(nombre_rom,donde^,longitud);
except
  carga_rom_zip:=false;
end;
zip_obj.CloseArchive;
zip_obj.Destroy;
end;

procedure sincronizar;
var
        l2:int64;
        res:single;
begin
if rapido then exit;
repeat
  QueryPerformanceCounter(Int64((@l2)^));
  res:=(l2-cont_sincroniza);
until (res>=valor_sync);
QueryPerformanceCounter(Int64((@cont_sincroniza)^));
end;

function sacar_word(datos:pbyte):word;pascal;
var
        salida:word;
begin
salida:=datos^;
inc(datos);
sacar_word:=salida+(datos^ shl 8);
end;

function iniciar_audio(canales:byte):boolean;
var
        format:TWaveFormatEx;
        f,g:byte;
        res:boolean;
begin
iniciar_audio:=false;
if not(hay_sonido) then begin
        iniciar_audio:=true;
        exit;
end;
zeromemory(@Format,SizeOf(TWaveFormatEx));
Format.wFormatTag:=WAVE_FORMAT_PCM;
Format.nChannels:=canales;
case calidad_audio of
  0:Format.nSamplesPerSec:=11025;
  1:Format.nSamplesPerSec:=22050;
  2:Format.nSamplesPerSec:=44100;
end;
Format.wBitsPerSample:=16;
Format.nBlockAlign:=Format.nChannels*(Format.wBitsPerSample div 8);
Format.nAvgBytesPerSec:=Format.nSamplesPerSec*Format.nBlockAlign;
format.cbSize:=0;
long_sample:=round(44100/llamadas_maquina.fps_max)*canales;
sample_final:=round(Format.nSamplesPerSec/llamadas_maquina.fps_max)*canales;
for g:=0 to max_canales do begin
  res:=waveoutopen(@audio[g],WAVE_MAPPER,@format,0,1,CALLBACK_NULL)=0;
  if not(res) then begin
    hay_tsonido:=false;
    exit;
  end;
  For f:= 0 To max_audio_buffer do begin
        getmem(cab_audio[g][f].lpData,sample_final*2);
        cab_audio[g][f].dwBufferLength:=sample_final*2;
        cab_audio[g][f].dwUser := 0;
        cab_audio[g][f].dwFlags := 0;
        cab_audio[g][f].dwLoops := 0;
        cab_audio[g][f].lpNext := nil;
        res:=waveOutPrepareHeader(audio[g],@cab_audio[g][f],sizeof(WAVEHDR))=0;
        if not(res) then exit;
  end;
end;
reset_audio;
iniciar_audio:=true;
hay_tsonido:=true;
end;

procedure reset_audio;
var
  f:byte;
begin
posicion_sonido:=0;
num_buffer:=0;
for f:=0 to 5 do zeromemory(@tsample[f],long_max_audio);
end;

function cargar_rom(nombre:string;posicion:pointer;longitud:integer):boolean;
var
        fichero:file of byte;
        l:integer;
begin
cargar_rom:=false;
if not(FileExists(nombre)) then exit;
{$I-}
assignfile(fichero,nombre);
reset(fichero);
blockread(fichero,posicion^,longitud,l);
closefile(fichero);
if l<>longitud then exit;
{$I+}
cargar_rom:=true;
end;

function dame_x_total:word;
var
  video_m:byte;
begin
case video of
   1,3,6:video_m:=1;
   2,4:video_m:=2;
   5:video_m:=3;
end;
dame_x_total:=p_final[0].x*video_m;
end;

function dame_y_total:word;
var
  video_m:byte;
begin
case video of
   1,3,6:video_m:=1;
   2,4:video_m:=2;
   5:video_m:=3;
end;
dame_y_total:=p_final[0].y*video_m;
end;

procedure cambiar_video;
var
  x,y:word;
begin
x:=dame_x_total;
y:=dame_y_total;
pantalla[0]:=SDL_SetVideoMode(x,y,16,videoflags);
//Si el video el *2 necesito una temporal
pantalla[11]:=SDL_AllocSurface(videoflags,x,y,16,pantalla[0].format.RMask,pantalla[0].format.GMask,pantalla[0].format.BMask,pantalla[0].format.AMask);
if x<193 then x:=193;
if cinta_tzx.cargada then begin
  form1.groupbox1.Left:=x+23;
  x:=x+350;
end;
x:=x+getosversion;
y:=y+150;
arregla_pos(x,y);
//pongo el nombre de la maquina y coloco los botones...
if not(pantalla_completa) then begin
  child.Width:=x;
  child.Height:=y;
end else begin
  child.Width:=50;
  child.Height:=50;
end;
child.Caption:=llamadas_maquina.caption;
form1.BitBtn2.left:=(x div 2)-120;
form1.BitBtn3.left:=(x div 2)-90;
form1.BitBtn4.left:=(x div 2)-62;
form1.BitBtn5.left:=(x div 2)-31;
form1.BitBtn6.left:=(x div 2)-3;
form1.btncfg.left:=(x div 2)+27;
form1.BitBtn8.left:=(x div 2)+57;
form1.BitBtn13.left:=(x div 2)+88;
if tipo_maquina>9 then form1.BitBtn19.left:=(x div 2)+57
  else form1.BitBtn19.left:=(x div 2)+120;
end;

procedure InicializeSDL;
var
  videoInfo:PSDL_VideoInfo;
begin
// Initialize the SDL library
  if (SDL_init(SDL_INIT_VIDEO or SDL_INIT_JOYSTICK or SDL_INIT_NOPARACHUTE) < 0) then halt(0);
  // Fetch the video info
  videoInfo:=SDL_GetVideoInfo;
  videoFlags:=videoFlags or SDL_DOUBLEBUF;  // Enable double buffering
  videoFlags:=videoFlags or SDL_HWPALETTE;  // Store the palette in hardware
  // This checks to see if surfaces can be stored in memory
  if pantalla_completa then videoFlags:=videoFlags or SDL_FULLSCREEN;
  if (videoInfo.hw_available<>0) then videoFlags:=videoFlags or SDL_HWSURFACE
    else videoFlags := videoFlags or SDL_SWSURFACE;
  // This checks if hardware blits can be done * /
  if (videoInfo.blit_hw<>0) then videoFlags:=videoFlags or SDL_HWACCEL;
  SDL_JoystickOpen(0);
end;

procedure iniciar_video;
var
  f:byte;
begin
if videoflags=0 then inicializeSDL;
//Puntero general del pixels
getmem(punbuf,512);
//creo la pantalla general
cambiar_video;
if p_final[1].x=0 then exit;
//Creo la pantalla de los sprites
pantalla[9]:=SDL_AllocSurface(videoflags,32,32,16,pantalla[0].format.RMask,pantalla[0].format.GMask,pantalla[0].format.BMask,pantalla[0].format.AMask);
SDL_Setcolorkey(pantalla[9],SDL_SRCCOLORKEY,set_trans_color);
paleta[$600]:=set_trans_color;
//Pantallas restantes
for f:=1 to 8 do
  if p_final[f].x<>0 then begin
    pantalla[f]:=SDL_AllocSurface(videoflags,p_final[f].x,p_final[f].y,16,pantalla[0].format.RMask,pantalla[0].format.GMask,pantalla[0].format.BMask,pantalla[0].format.AMask);
    //Y si son transparentes las creo
    if p_final[f].trans then SDL_Setcolorkey(pantalla[f],SDL_SRCCOLORKEY,set_trans_color);
  end;
zeromemory(@scroll_data,sizeof(scroll_tipo));
end;

procedure pasar_pantalla_completa;
begin
exit;
if not(pantalla_completa) then pantalla[0]:=SDL_SetVideoMode(p_final[0].x,p_final[0].y,16,SDL_FULLSCREEN)
  else pantalla[0]:=SDL_SetVideoMode(p_final[0].x,p_final[0].y,16,SDL_HWSURFACE);
pantalla_completa:=not(pantalla_completa);
end;

procedure fillword(dest:pword;cantidad:cardinal;valor:word);
asm
        cmp cantidad,0
        je @@salir
        push eax
        push ebx
        mov ebx,cantidad
@@repetir:
        mov word ptr[eax],cx
        inc eax
        inc eax
        dec ebx
        jnz @@repetir
        pop ebx
        pop eax
@@salir:
end;

procedure putpixel(x,y:dword;cantidad:word;pixel:pword;sitio:byte);
var
        punt:pword;
begin
punt:=Pword(integer(pantalla[sitio].pixels) + y * pantalla[sitio].pitch + x*2);
copymemory(punt,pixel,cantidad*2);
end;

procedure putpixel_trans(x,y,cantidad:word;pixels:pword;sitio:byte);
var
  punt:pword;
  f:word;
begin
punt:=Pword(integer(pantalla[sitio].pixels) + y * pantalla[sitio].pitch + x*2);
for f:=1 to cantidad do begin
  //if (pixels^<>$400) then
  punt^:=paleta[pixels^];
  inc(punt);
  inc(pixels);
end;
end;

procedure linea_recta(x,y:word;color:byte;longitud:word;pant:byte);
var
        punt:pword;
begin
punt:=pword(integer(pantalla[pant].pixels) + y * pantalla[pant].pitch + x*2);
fillword(punt,longitud,paleta[color]);
end;

procedure linea(x0,y0,x1,y1:integer;color:word);
var
  dy,dx,stepx,stepy,fraction:integer;
  temp:pword;
begin
temp:=punbuf;
temp^:=paleta[color];
//Metodo Bresenham
dy:=y1-y0;
dx:=x1-x0;
if (dy < 0) then begin
  dy:=-dy;
  stepy:=-1;
end else stepy:=1;
if (dx < 0) then begin
  dx:= -dx;
  stepx:= -1;
end else stepx:=1;
dy:=dy shl 1; // dy is now 2*dy
dx:=dx shl 1; // dx is now 2*dx
putpixel(x0,y0,1,punbuf,0);
if (dx > dy) then begin
  fraction:=dy-(dx shr 1); // same as 2*dy - dx
  while (x0<>x1) do begin
    if (fraction >= 0) then begin
      y0:=y0+stepy;
      fraction:=fraction-dx; // same as fraction -= 2*dx
    end;
    x0:=x0+stepx;
    fraction:=fraction+dy;  // same as fraction -= 2*dy
    putpixel(x0,y0,1,punbuf,0);
  end;
end else begin
  fraction:= dx - (dy shr 1);
  while (y0<>y1) do begin
    if (fraction >= 0) then begin
      x0:=x0+stepx;
      fraction:=fraction-dy;
    end;
    y0:=y0+stepy;
    fraction:=fraction+dx;
    putpixel(x0,y0,1,punbuf,0);
  end;
end;
end;

procedure poner_paleta(ppaleta:tpaleta;numero_colores:word);
var
        colores:word;
begin
for colores:=0 to numero_colores-1 do
        paleta[colores]:=SDL_MapRGB(pantalla[0].format, ppaleta[colores].r, ppaleta[colores].g, ppaleta[colores].b);
end;

procedure poner_color(pcolor:tcolor;ppaleta:puint32);
begin
ppaleta^:=SDL_MapRGB(pantalla[0].format, pcolor.r, pcolor.g, pcolor.b);
end;

procedure actualiza_trozo_principal(x1,y1,x2,y2:word);
begin
SDL_UpdateRect(pantalla[0],x1,y1,x2,y2);
end;

procedure actualiza_trozo(o_x1,o_y1,o_x2,o_y2:word;sitio:byte;d_x1,d_y1,d_x2,d_y2:word;dest:byte);
var
  origen,destino:sdl_rect;
begin
origen.x:=o_x1;
origen.y:=o_y1;
origen.w:=o_x2;
origen.h:=o_y2;
destino.x:=d_x1;
destino.y:=d_y1;
destino.w:=d_x2;
destino.h:=d_y2;
SDL_BlitSurface(pantalla[sitio],@origen,pantalla[dest],@destino);
end;

procedure actualiza_video;
var
  punt,punt2,punt3,punt4:pword;
  f,i,h:word;
begin
case video of
  1:;
  2:begin
        for i:=0 to p_final[0].y-1 do begin
         punt:=Pword(integer(pantalla[0].pixels) + i* pantalla[0].pitch + 0*2);
         punt2:=pword(integer(pantalla[11].pixels) + (i*2)* pantalla[11].pitch + 0*2);
         punt3:=pword(integer(pantalla[11].pixels) + ((i*2)+1) * pantalla[11].pitch + 0*2);
         for f:=0 to p_final[0].x-1 do begin
          punt2^:=punt^;
          punt3^:=punt^;
          inc(punt2);
          inc(punt3);
          punt2^:=punt^;
          punt3^:=punt^;
          inc(punt2);
          inc(punt3);
          inc(punt);
         end;
        end;
          actualiza_trozo(0,0,p_final[0].x*2,p_final[0].y*2,11,0,0,p_final[0].x*2,p_final[0].y*2,0);
        end;
  3:begin
        for i:=0 to (p_final[0].y div 2)-1 do begin
         punt:=Pword(integer(pantalla[0].pixels) + (i*2)* pantalla[0].pitch + 0*2);
         punt2:=pword(integer(pantalla[11].pixels) + (i*2)* pantalla[11].pitch + 0*2);
         copymemory(punt2,punt,p_final[0].x*2);
        end;
          actualiza_trozo(0,0,p_final[0].x,p_final[0].y,11,0,0,p_final[0].x,p_final[0].y,0);
        end;
  4:begin
        for i:=0 to p_final[0].y-1 do begin
         punt:=Pword(integer(pantalla[0].pixels) + i* pantalla[0].pitch + 0*2);
         punt2:=pword(integer(pantalla[11].pixels) + (i*2)* pantalla[11].pitch + 0*2);
         for f:=0 to p_final[0].x-1 do begin
          punt2^:=punt^;
          inc(punt2);
          punt2^:=punt^;
          inc(punt2);
          inc(punt);
         end;
        end;
          actualiza_trozo(0,0,p_final[0].x*2,p_final[0].y*2,11,0,0,p_final[0].x*2,p_final[0].y*2,0);
        end;
  5:begin
        for i:=0 to p_final[0].y-1 do begin
         punt:=Pword(integer(pantalla[0].pixels) + i* pantalla[0].pitch + 0*3);
         punt2:=pword(integer(pantalla[11].pixels) + (i*3)* pantalla[11].pitch + 0*3);
         punt3:=pword(integer(pantalla[11].pixels) + ((i*3)+1) * pantalla[11].pitch + 0*3);
         punt4:=pword(integer(pantalla[11].pixels) + ((i*3)+2) * pantalla[11].pitch + 0*3);
         for f:=0 to p_final[0].x-1 do begin
          for h:=0 to 2 do begin
            punt2^:=punt^;
            punt3^:=punt^;
            punt4^:=punt^;
            inc(punt2);
            inc(punt3);
            inc(punt4);
          end;
          inc(punt);
         end;
        end;
          actualiza_trozo(0,0,p_final[0].x*3,p_final[0].y*3,11,0,0,p_final[0].x*3,p_final[0].y*3,0);
        end;
  end;
SDL_Flip(pantalla[0])
end;

procedure pintar_pantalla(sitio:byte;color:word);
var
        punt:pword;
begin
punt:=Pword(integer(pantalla[sitio].pixels));
fillword(punt,pantalla[sitio].w*pantalla[sitio].h,paleta[color]);
end;

procedure cerrar_video;
var
  f:byte;
begin
for f:=0 to max_pantalla do begin
  if pantalla[f]<>nil then SDL_FreeSurface(pantalla[f]);
  pantalla[f]:=nil;
  zeromemory(@p_final[f],sizeof(tpantalla));
end;
if punbuf<>nil then freemem(punbuf);
punbuf:=nil;
end;

procedure cerrar_audio;
var
  j,f:byte;
begin
for j:=0 to max_canales do begin
  waveOutReset(audio[j]);
  for f:=0 to max_audio_buffer do waveoutunprepareheader(audio[j],@cab_audio[0][f],sizeof(cab_audio[0][f]));
  for f:=0 to max_audio_buffer do begin
    freemem(cab_audio[0][f].lpData);
    cab_audio[0][f].lpData:=nil;
  end;
  waveoutclose(audio[j]);
end;
end;

procedure play_sonido;
var
  f:byte;
  g,h:word;
begin
if hay_tsonido then begin
for f:=0 to llamadas_maquina.canales_usados-1 do begin
  h:=0;
  //Resampleado
  case calidad_audio of
    0:if stereo then begin
        g:=0;
        while g<>sample_final do begin
          tsample[f][g]:=(tsample[f][h]+tsample[f][h+2]+tsample[f][h+4]+tsample[f][h+6]) div 4;
          tsample[f][g+1]:=(tsample[f][h+1]+tsample[f][h+3]+tsample[f][h+5]+tsample[f][h+7]) div 4;
          inc(h,8);
          inc(g,2);
        end;
      end else begin
         for g:=0 to sample_final do begin
          tsample[f][g]:=(tsample[f][h]+tsample[f][h+1]+tsample[f][h+2]+tsample[f][h+3]) div 4;
          inc(h,4);
         end;
      end;
    1:if stereo then begin
          g:=0;
          while g<>sample_final do begin
            tsample[f][g]:=(tsample[f][h]+tsample[f][h+2]) div 2;
            tsample[f][g+1]:=(tsample[f][h+1]+tsample[f][h+3]) div 2;
            inc(h,4);
            inc(g,2);
          end;
       end else begin
          for g:=0 to sample_final do begin
            tsample[f][g]:=(tsample[f][h]+tsample[f][h+1]) div 2;
            inc(h,2);
          end;
      end;
    2:;
  end;
  CopyMemory(cab_audio[f][num_buffer].lpData, @tsample[f],sample_final*2);
  waveOutWrite(audio[f],@cab_audio[f][num_buffer],sizeof(WAVEHDR));
  zeromemory(@tsample[f],long_sample*2);
end;
end;
num_buffer:=(num_buffer+1);
if num_buffer=max_audio_buffer then num_buffer:=0;
//form1.statusbar1.Panels[2].Text:=inttostr(gs_x)+' - '+inttostr(gs_y)+' : '+inttostr(gunstick);
//form1.statusbar1.Panels[2].Text:=inttostr(long_sample-posicion_sonido);
posicion_sonido:=0;
end;

function extension_fichero(nombre:string):string;
var
  f:word;
  final,final2:string;
begin
final:=extractfileext(nombre);
final2:='';
if final<>'' then for f:=1 to length(final) do begin
  final[f]:=upcase(final[f]);
  if final[f]<>'.' then final2:=final2+final[f];
end;
extension_fichero:=final2;
end;

procedure save_hi(nombre:string;posicion:pbyte;longitud:word);
var
  fichero:file of byte;
begin
{$I-}
assignfile(fichero,Directory.Arcade_hi+'\'+nombre);
rewrite(fichero);
blockwrite(fichero,posicion^,longitud);
closefile(fichero);
{$I+}
end;

function load_hi(nombre:string;posicion:pbyte;longitud:word):boolean;
var
  fichero:file of byte;
  l:integer;
begin
load_hi:=false;
{$I-}
assignfile(fichero,Directory.Arcade_hi+'\'+nombre);
reset(fichero);
blockread(fichero,posicion^,longitud,l);
closefile(fichero);
{$I+}
if l<>longitud then exit;
load_hi:=true;
end;

function sshr(num,fac:integer):integer;
var
  h:word;
  tmp:integer;
begin
  tmp:=num;
  for h:=0 to fac-1 do tmp:=tmp div 2;
  sshr:=tmp;
end;

end.
