unit M6502;

interface
uses constantes,dialogs,sysutils,timers,windows;
type
        band_6502=record
                n,o_v,t,brk,dec,int,z,c:boolean;
        end;
        reg_6502=record
                pc:parejas;
                old_pc:parejas;
                a,x,y:byte;
                sp:byte;
                p:band_6502;
                contador:integer;
                pedir_nmi,pedir_irq:boolean;
                numero_cpu:byte;
                tframes:single;
                opcode:boolean;
        end;
        preg_6502=^reg_6502;
        pband_6502=^band_6502;
        llam_6502 = record
            getbyte: function (direccion: Word): Byte; pascal;
            putbyte: procedure (direccion:word;valor:byte);pascal;
            despues_instruccion: procedure;pascal;
  end;

const
        tipo_dir:array[0..255] of byte=(
      //0  1  2 3 4  5 6 7 8  9 a b c  d e f
        0,$a, 0,0,7, 7,7,0,0, 1,0,0,2, 2,2,0, //$00
       $d,$b,$c,0,7, 8,8,0,0, 6,0,0,2, 5,5,0, //$10
        0,$a, 0,0,7, 7,7,0,0, 1,0,0,2, 2,2,0, //$20
       $d,$b,$c,0,8, 8,8,0,0, 6,0,0,5, 5,5,0, //$30
        0,$a, 0,0,0, 7,7,0,0, 1,0,0,2, 2,2,0, //$40
       $d,$b,$c,0,0, 8,8,0,0, 6,0,0,0, 5,5,0, //$50
        0,$a, 0,0,7, 7,7,0,0, 1,0,0,0, 2,2,0, //$60
       $d,$b,$c,0,8, 8,8,0,0, 6,0,0,3, 5,5,0, //$70
       $d,$a, 0,0,7, 7,7,0,0, 1,0,0,2, 2,2,0, //$80
       $d,$b,$c,0,8, 8,9,0,0, 6,0,0,2, 5,5,0, //$90
        1,$a, 1,0,7, 7,7,0,0, 1,0,0,2, 2,2,0, //$A0
       $d,$b,$c,0,8, 8,9,0,0, 6,0,0,5, 5,6,0, //$B0
        1,$a, 0,0,7, 7,7,0,0, 1,0,0,2, 2,2,0, //$C0
       $d,$b,$c,0,0, 8,8,0,0, 6,0,0,0, 5,5,0, //$D0
        1,$a, 0,0,7, 7,7,0,0, 1,0,0,2, 2,2,0, //$E0
       $d,$b,$c,0,0, 8,8,0,0, 6,0,0,0, 5,5,0); //$F0

        estados_t:array[0..255] of byte=(
        7, 6, 2, 8, 3, 3, 5, 5, 3, 2, 2, 2, 4, 4, 6, 6,
        2, 5, 3, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7,
        6, 6, 2, 8, 3, 3, 5, 5, 4, 2, 2, 2, 4, 4, 6, 6,
        2, 5, 3, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7,
        6, 6, 2, 8, 3, 3, 5, 5, 3, 2, 2, 2, 3, 4, 6, 6,
        2, 5, 3, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7,
        6, 6, 2, 8, 3, 3, 5, 5, 4, 2, 2, 2, 5, 4, 6, 6,
        2, 5, 3, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7,
        2, 6, 2, 6, 3, 3, 3, 3, 2, 2, 2, 2, 4, 4, 4, 4,
        2, 6, 3, 6, 4, 4, 4, 4, 2, 5, 2, 5, 5, 5, 5, 5,
        2, 6, 2, 6, 3, 3, 3, 3, 2, 2, 2, 2, 4, 4, 4, 4,
        2, 5, 3, 5, 4, 4, 4, 4, 2, 4, 2, 4, 4, 4, 4, 4,
        2, 6, 2, 8, 3, 3, 5, 5, 2, 2, 2, 2, 4, 4, 6, 6,
        2, 5, 3, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7,
        2, 6, 2, 8, 3, 3, 5, 5, 2, 2, 2, 2, 4, 4, 6, 6,
        2, 5, 3, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7 );

        {7,6,2,2,3,3,5,2,3,3,2,2,4,4,6,2, //$00
        2,5,3,2,3,4,6,2,2,4,2,2,4,4,7,2, //$10
        6,6,2,2,3,3,5,2,4,3,2,2,4,4,6,2, //$20
        2,5,3,2,4,4,6,2,2,4,2,2,4,4,7,2, //$30
        6,6,2,2,2,3,5,2,3,3,2,2,3,4,6,2, //$40
        2,5,3,2,2,4,6,2,2,4,3,2,4,2,7,2, //$50
        6,6,2,2,3,3,5,2,4,3,2,2,5,4,6,2, //$60
        2,5,3,2,4,4,6,2,2,4,4,2,6,4,7,2, //$70
        2,6,2,2,2,2,2,2,2,2,2,2,4,4,4,2, //$80
        2,6,3,2,4,4,4,2,2,5,2,2,4,5,2,2, //$90
        3,6,3,2,3,3,3,2,2,3,2,2,4,4,4,2, //$a0
        2,5,3,2,4,4,4,2,2,4,2,2,4,4,4,2, //$b0
        3,6,2,2,3,3,5,2,2,3,2,2,4,4,6,2, //$c0
        2,5,3,2,2,4,6,2,2,4,3,2,2,4,7,2, //$d0
        3,6,2,2,3,3,5,2,2,3,2,2,4,4,6,2, //$e0
        2,5,3,2,2,4,6,2,2,4,4,2,2,4,7,2); //$f0}

procedure reset_6502(r:preg_6502;ll:llam_6502);
procedure run_6502(r:preg_6502;ll:llam_6502;maximo:dword);
function irq_6502(r:preg_6502;ll:llam_6502):byte;
function nmi_6502(r:preg_6502;ll:llam_6502):byte;


implementation

procedure push_sp(r:preg_6502;ll:llam_6502;reg:byte);
begin
ll.putbyte($100+r.sp,reg);
dec(r.sp);
end;

function pop_sp(r:preg_6502;ll:llam_6502):byte;
begin
inc(r.sp);
pop_sp:=ll.getbyte($100+r.sp);
end;

function dame_pila(r:preg_6502):byte;
var
  temp:byte;
begin
  temp:=0;
  if r.p.n then temp:=temp or $80;
  if r.p.o_v then temp:=temp or $40;
  if r.p.t then temp:=temp or $20;
  if r.p.brk then temp:=temp or $10;
  if r.p.dec then temp:=temp or 8;
  if r.p.int then temp:=temp or 4;
  if r.p.z then temp:=temp or 2;
  if r.p.c then temp:=temp or 1;
  dame_pila:=temp;
end;

procedure reset_6502(r:preg_6502;ll:llam_6502);
begin
r.pc.l:=ll.getbyte($FFFC);
r.pc.h:=ll.getbyte($FFFD);
r.a:=0;
r.x:=0;
r.y:=0;
r.contador:=0;
r.sp:=$FF;
r.p.c:=false;r.p.z:=true;r.p.int:=true;r.p.t:=true;
r.p.dec:=false;r.p.brk:=false;r.p.o_v:=false;r.p.n:=false;
r.pedir_nmi:=false;r.pedir_irq:=false;
end;

function nmi_6502(r:preg_6502;ll:llam_6502):byte;
begin
r.pedir_nmi:=false;
push_sp(r,ll,r.pc.h);
push_sp(r,ll,r.pc.l);
push_sp(r,ll,(dame_pila(r) and $ef));
r.pc.l:=ll.getbyte($FFFA);
r.pc.h:=ll.getbyte($FFFB);
nmi_6502:=7;
r.p.int:=true;
end;

function irq_6502(r:preg_6502;ll:llam_6502):byte;
begin
if r.p.int then begin
  irq_6502:=0;
  exit;
end;
r.pedir_irq:=false;
push_sp(r,ll,r.pc.h);
push_sp(r,ll,r.pc.l);
push_sp(r,ll,(dame_pila(r) and $ef));
r.pc.l:=ll.getbyte($FFFE);
r.pc.h:=ll.getbyte($FFFF);
irq_6502:=7;
r.p.int:=true;
end;

procedure pon_pila(r:preg_6502;valor:byte);
begin
  r.p.n:=(valor and $80)<>0;
  r.p.o_v:=(valor and $40)<>0;
  r.p.t:=(valor and $20)<>0;
  r.p.brk:=(valor and $10)<>0;
  r.p.dec:=(valor and 8)<>0;
  r.p.int:=(valor and 4)<>0;
  r.p.z:=(valor and 2)<>0;
  r.p.c:=(valor and 1)<>0;
end;

function asl_8(r:preg_6502;valor:byte):byte;
begin
r.p.c:=(valor and $80)<>0;
valor:=valor shl 1;
r.p.z:=(valor=0);
r.p.n:=(valor and $80)<>0;
asl_8:=valor;
end;

procedure cmp(r:preg_6502;registro,valor:byte);
var
        temp:parejas;
begin
temp.w:=registro-valor;
if temp.h<>0 then r.p.c:=false
  else r.p.c:=true;
r.p.z:=(temp.l=0);
r.p.n:=(temp.l and $80)<>0;
end;

function lsr_8(r:preg_6502;valor:byte):byte;
begin
r.p.c:=(valor and $1)<>0;
valor:=valor shr 1;
r.p.z:=(valor=0);
r.p.n:=false;
lsr_8:=valor;
end;

function rol_8(r:preg_6502;valor:byte):byte;
var
  carry:byte;
begin
if r.p.c then carry:=1 else carry:=0;
r.p.c:=(valor and $80)<>0;
valor:=((valor shl 1) or carry);
r.p.z:=(valor=0);
r.p.n:=(valor and $80)<>0;
rol_8:=valor;
end;

function ror_8(r:preg_6502;valor:byte):byte;
var
  carry:byte;
begin
if r.p.c then carry:=$80 else carry:=0;
r.p.c:=(valor and $1)<>0;
valor:=((valor shr 1) or carry);
r.p.z:=(valor=0);
r.p.n:=(valor and $80)<>0;
ror_8:=valor;
end;

procedure run_6502(r:preg_6502;ll:llam_6502;maximo:dword);
var
    instruccion,numero,temp,carry,estados_demas:byte;
    temp2,temp3:word;
    desplazamiento:smallint;
    posicion:parejas;
    contador:dword;
begin
contador:=0;
while contador<maximo do begin
estados_demas:=0;
r.old_pc:=r.pc;
if r.pedir_nmi then estados_demas:=nmi_6502(r,ll);
r.opcode:=true;
instruccion:=ll.getbyte(r.pc.w);
r.opcode:=false;
inc(r.pc.w);
case tipo_dir[instruccion] of
        $00:;  //**implicito
        $01:begin //inmediato opcode+valor 8bits (rev)
                posicion.w:=r.pc.w;
                inc(r.pc.w);
          end;
        $02:begin //absoluto opcode+direccion 16bits (rev)
                posicion.l:=ll.getbyte(r.pc.w);
                posicion.h:=ll.getbyte(r.pc.w+1);
                inc(r.pc.w,2);
            end;
        $03,$04:begin  //desconocido!!!! -> MAL
                MessageDlg('Modo dir. mal, intruccion: '+inttostr(instruccion)+'. PC='+inttostr(r.pc.w), mtInformation,[mbOk], 0)
            end;
        $05:begin //absoluto indexado por X (rev)
                posicion.l:=ll.getbyte(r.pc.w);
                posicion.h:=ll.getbyte(r.pc.w+1);
                inc(r.pc.w,2);
                inc(posicion.w,r.x);
            end;
        $06:begin //absoluto indexado por Y (rev)
                posicion.l:=ll.getbyte(r.pc.w);
                posicion.h:=ll.getbyte(r.pc.w+1);
                inc(r.pc.w,2);
                inc(posicion.w,r.y);
            end;
        $07:begin //pagina 0  opcode+direccion 8bits (rev)
                posicion.l:=ll.getbyte(r.pc.w);
                inc(r.pc.w);
                posicion.h:=0;
            end;
        $08:begin  //pagina cero indexado por X (rev)
                temp:=ll.getbyte(r.pc.w);
                inc(r.pc.w);
                posicion.w:=temp+r.x;
                posicion.h:=0;
            end;
        $09:begin  //pagina cero indexado por Y (rev)
                temp:=ll.getbyte(r.pc.w);
                inc(r.pc.w);
                posicion.w:=temp+r.y;
                posicion.h:=0;
            end;
        $0a:begin //indirecto indexado por X (rev)
                temp:=ll.getbyte(r.pc.w);
                inc(r.pc.w);
                inc(temp,r.x);
                posicion.l:=ll.getbyte(temp);
                posicion.h:=ll.getbyte(temp+1);
            end;
        $0b:begin  //indirecto indexado por Y (rev)
                temp:=ll.getbyte(r.pc.w);
                inc(r.pc.w);
                posicion.l:=ll.getbyte(temp);
                posicion.h:=ll.getbyte(temp+1);
                inc(posicion.w,r.y);
            end;
        $0c:begin //indexado pagina 0 opcode+puntero 8bits (rev)
                temp:=ll.getbyte(r.pc.w);
                inc(r.pc.w);
                posicion.l:=ll.getbyte(temp);
                posicion.h:=ll.getbyte(temp+1);
            end;
        $0d:begin //relativo
                temp:=ll.getbyte(r.pc.w);
                inc(r.pc.w);
                if (temp>=128) then desplazamiento:=-(256-temp)
                        else desplazamiento:=temp;
            end;

end;                // del tipo de direccionamiento
case instruccion of
      $00:begin  //brk
            inc(r.pc.w);
            push_sp(r,ll,r.pc.h);
            push_sp(r,ll,r.pc.l);
            temp:=(dame_pila(r) or $10);
            push_sp(r,ll,temp);
            r.p.dec:=false;
            r.p.int:=true;
            r.pc.l:=ll.getbyte($FFFE);
            r.pc.h:=ll.getbyte($FFFF);
          end;
      $01,$05,$09,$0d,$11,$12,$15,$19,$1d:begin //ORA
            r.a:=r.a or ll.getbyte(posicion.w);
            r.p.z:=(r.a=0);
            r.p.n:=(r.a and $80)<>0;
          end;
      $06,$0e,$16,$1e:begin //asl
                numero:=asl_8(r,ll.getbyte(posicion.w));
                ll.putbyte(posicion.w,numero);
          end;
      $08:push_sp(r,ll,dame_pila(r)); //PHP
      $0a:r.a:=asl_8(r,r.a); //asl A
      $10:if not(r.p.n) then inc(r.pc.w,desplazamiento); //BPL salta si n false
      $18:r.p.c:=false; //CLC
      $20:begin // JSR absoluto
            posicion.l:=ll.getbyte(r.pc.w);
            posicion.h:=ll.getbyte(r.pc.w+1);
            inc(r.pc.w);
            push_sp(r,ll,r.pc.h);
            push_sp(r,ll,r.pc.l);
            r.pc:=posicion;
          end;
      $21,$25,$29,$2d,$31,$35,$39,$3d:begin  //AND
            r.a:=r.a and ll.getbyte(posicion.w);
            r.p.z:=(r.a=0);
            r.p.n:=(r.a and $80)<>0;
        end;
      $24,$2c:begin  //BIT
            numero:=ll.getbyte(posicion.w);
            r.p.z:=(r.a and numero)=0;
            r.p.n:=(numero and $80)<>0;
            r.p.o_v:=(numero and $40)<>0;
        end;
      $26,$2e,$36,$3e:begin //ROL
            numero:=rol_8(r,ll.getbyte(posicion.w));
            ll.putbyte(posicion.w,numero);
         end;
      $28:pon_pila(r,pop_sp(r,ll));//PLP
      $2a:r.a:=rol_8(r,r.a); //ROL A
      $30:if r.p.n then inc(r.pc.w,desplazamiento); //BMI salta si n false
      $38:r.p.c:=true; //SEC
      $40:begin //RTI
                temp:=pop_sp(r,ll);
                pon_pila(r,temp);
                r.p.t:=true;
                r.pc.l:=pop_sp(r,ll);
                r.pc.h:=pop_sp(r,ll);
          end;
      $41,$45,$49,$4d,$51,$55,$59,$5d:begin //EOR
            r.a:=r.a xor ll.getbyte(posicion.w);
            r.p.z:=(r.a=0);
            r.p.n:=(r.a and $80)<>0;
          end;
      $46,$4e,$56,$5e:begin  //LSR
            numero:=lsr_8(r,ll.getbyte(posicion.w));
            ll.putbyte(posicion.w,numero);
          end;
      $48:push_sp(r,ll,r.a);  //PHA
      $4a:r.a:=lsr_8(r,r.a);  //LSR A
      $4c:r.pc.w:=posicion.w; //JMP absoluto
      $50:if not(r.p.o_v) then inc(r.pc.w,desplazamiento); //BVC salta si Overflow false
      $58:r.p.int:=false; //CLI
      $60:begin  //RTS
             r.pc.l:=pop_sp(r,ll);
             r.pc.h:=pop_sp(r,ll);
             inc(r.pc.w);
           end;
      $61,$65,$69,$6d,$71,$75,$79,$7d:begin //ADC
            numero:=ll.getbyte(posicion.w);
            if r.p.c then carry:=1 else carry:=0;
            if ((r.a xor numero) and $80)<>0 then R.p.o_v:=false
             else R.P.o_v:=true;
            if (R.p.dec) then begin
              temp2:=(R.a and $f) + (numero and $f) + carry;
              if (temp2 >= 10) then temp2:=$10 or ((temp2+6) and $f);
              temp2:=temp2 + (R.A and $f0) + (numero and $f0);
              if (temp2 >= 160) then begin
                R.P.c:=true;
                if ((R.P.o_v) and (temp2 >= $180)) then R.P.o_v:=false;
                temp2:=temp2+$60;
              end else begin
                r.p.c:=false;
                if ((R.p.o_v) and (temp2 < $80)) then R.P.o_v:=false;
              end;
            end else begin
              temp2:= R.a + numero + carry;
              if (temp2 >= $100) then begin
                R.P.c:=true;
                if ((R.p.o_v) and (temp2 >= $180)) then r.p.o_v:=false;
              end else begin
                R.P.c:=false;
                if ((R.P.o_v) and (temp2 < $80)) then R.P.o_v:=false;
              end;
            end;
            R.A:=temp2 and $FF;
            r.p.z:=(r.a=0);
            r.p.n:=(r.a and $80)<>0;
           end;
      $66,$6e,$76,$7e:begin //ROR
              numero:=ror_8(r,ll.getbyte(posicion.w));
              ll.putbyte(posicion.w,numero);
         end;
      $68:begin //PLA
            r.a:=pop_sp(r,ll);
            r.p.z:=(r.a=0);
            r.p.n:=(r.a and $80)<>0;
          end;
      $6a:r.a:=ror_8(r,r.a); //ROR A
      $6c:begin  //jmp rel
            posicion.l:=ll.getbyte(r.pc.w);
            posicion.h:=ll.getbyte(r.pc.w+1);
            r.pc.l:=ll.getbyte(posicion.w);
            r.pc.h:=ll.getbyte(posicion.w+1);
          end;
      $70:if r.p.o_v then inc(r.pc.w,desplazamiento); //BVS salta si Overflow true
      $78:r.p.int:=true;  //SEI
      $81,$85,$8d,$91,$95,$99,$9d:ll.putbyte(posicion.w,r.a); //STA
      $84,$8c,$94:ll.putbyte(posicion.w,r.y); //STY
      $86,$8e,$96:ll.putbyte(posicion.w,r.x); //STX
      $88:begin  //DEY
             dec(r.y);
             r.p.z:=(r.y=0);
             r.p.n:=(r.y and $80)<>0;
           end;
      $8a:begin //TXA
             r.a:=r.x;
             r.p.z:=(r.a=0);
             r.p.n:=(r.a and $80)<>0;
           end;
      $90:if not(r.p.c) then inc(r.pc.w,desplazamiento); //BCC salta si c false
      $98:begin  //TYA
             r.a:=r.y;
             r.p.z:=(r.y=0);
             r.p.n:=(r.y and $80)<>0;
           end;
      $9A:r.sp:=r.x; //TXS
      $A0,$a4,$ac,$b4,$bc:begin //LDY
             r.y:=ll.getbyte(posicion.w);
             r.p.z:=(r.y=0);
             r.p.n:=(r.y and $80)<>0;
           end;
      $A1,$a5,$a9,$ad,$b1,$b5,$b9,$bd:begin //LDA
            r.a:=ll.getbyte(posicion.w);
            r.p.z:=(r.a=0);
            r.p.n:=(r.a and $80)<>0;
          end;
      $A2,$a6,$ae,$b6,$be:begin //LDX
             r.x:=ll.getbyte(posicion.w);
             r.p.z:=(r.x=0);
             r.p.n:=(r.x and $80)<>0;
           end;
      $A8:begin  //TAY
             r.y:=r.a;
             r.p.z:=(r.y=0);
             r.p.n:=(r.y and $80)<>0;
           end;
      $AA:begin  //TAX
             r.x:=r.a;
             r.p.z:=(r.x=0);
             r.p.n:=(r.x and $80)<>0;
           end;
      $B0:if r.p.c then inc(r.pc.w,desplazamiento); //BCS salta si c true
      $B8:r.p.o_v:=false; //CLV
      $BA:begin  //TSX
            r.x:=r.sp;
            r.p.z:=(r.x=0);
            r.p.n:=(r.x and $80)<>0;
          end;
      $C0,$C4,$CC:cmp(r,r.y,ll.getbyte(posicion.w));  //CPY
      $C6,$ce,$d6,$de:begin   //DEC
            numero:=ll.getbyte(posicion.w);
            dec(numero);
            r.p.z:=(numero=0);
            r.p.n:=(numero and $80)<>0;
            ll.putbyte(posicion.w,numero);
           end;
      $C8:begin  //INY
             inc(r.y);
             r.p.z:=(r.y=0);
             r.p.n:=(r.y and $80)<>0;
           end;
      $c1,$c5,$c9,$cd,$d1,$d5,$d9,$dd:cmp(r,r.a,ll.getbyte(posicion.w));  //CMP
      $CA:begin  //DEX
             dec(r.x);
             r.p.z:=(r.x=0);
             r.p.n:=(r.x and $80)<>0;
           end;
      $D0:if not(r.p.z) then inc(r.pc.w,desplazamiento); //BNE si z false
      $D8:r.p.dec:=false; //CLD
      $E0,$e4,$ec:cmp(r,r.x,ll.getbyte(posicion.w));  //CPX
      $E1,$e5,$e9,$ed,$f1,$f5,$f9,$fd:begin //SBC
        numero:=ll.getbyte(posicion.w);
        if r.p.c then carry:=1 else carry:=0;
        if ((r.a xor numero) and $80)<>0 then R.p.o_v:=false
             else R.P.o_v:=true;
        if (R.p.dec) then begin
          temp3:= $f + (R.A and $f) - (numero and $f) + carry;
          if (temp3 < $10) then begin
            temp2:= 0;
            temp3:=temp3-6;
          end else begin
            temp2:=$10;
            temp3:=temp3-$10;
          end;
          temp2:=temp2+ $f0 + (R.A and $f0) - (numero and $f0);
          if (temp2 < $100) then begin
            R.P.c:=false;
            if ((R.P.o_v) and (temp2 < $80)) then R.p.o_v:=false;
            temp2:=temp2-$60;
          end else begin
            R.P.c:=true;
            if ((R.p.o_v) and (temp2 >= $180)) then R.p.o_v:=false;
          end;
          temp2:=temp2+temp3;
        end else begin
          temp2:=$ff + R.A - numero + carry;
          if (temp2 < $100) then begin
            R.p.c:=false;
            if ((R.p.o_v) and (temp2 < $80)) then R.p.o_v:=false;
          end else begin
            R.p.c:=true;
            if ((R.p.o_v) and (temp2 >= $180)) then r.p.o_v:=false;
          end;
        end;
        R.A:=temp2 and $FF;
        r.p.z:=(r.a=0);
        r.p.n:=(r.a and $80)<>0;
      end;
      $E6,$ee,$F6,$fe:begin  //INC
             numero:=ll.getbyte(posicion.w);
             inc(numero);
             r.p.z:=(numero=0);
             r.p.n:=(numero and $80)<>0;
             ll.putbyte(posicion.w,numero);
           end;
      $E8:begin  //INX
             inc(r.x);
             r.p.z:=(r.x=0);
             r.p.n:=(r.x and $80)<>0;
           end;
      $ea:; //NOP
      $F0:if r.p.z then inc(r.pc.w,desplazamiento); //BEQ salta si z true
      $F8:r.p.dec:=true; //SED
      else
        MessageDlg('Instruccion: '+inttostr(instruccion)+' desconocida. PC='+inttostr(r.pc.w), mtInformation,[mbOk], 0)
end; //del case!!
if r.pedir_irq then inc(estados_demas,irq_6502(r,ll));
inc(contador,estados_t[instruccion]+estados_demas);
inc(r.contador,estados_t[instruccion]+estados_demas);
if addr(ll.despues_instruccion)<>nil then ll.despues_instruccion;
update_timer(estados_t[instruccion],r.numero_cpu);
end; //del while!!
end;

end.
