unit m68000;

interface
uses windows,sysutils,dialogs,constantes;

const
    b_ciclos:array[0..63] of byte=(                   //probados
     //0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f
       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    	 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, //10-1f
    	 6, 6, 6, 6, 6, 6, 6, 6, 8, 8, 8, 8, 8, 8, 8, 8, //20-2f
      10,10,10,10,10,10,10,10, 8,12, 8,10, 4, 0, 0, 0); //30-37,38,39,3c
    w_ciclos:array[0..63] of byte=(
     //0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f
       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, //0-7
    	 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, //10-1f
       6, 6, 6, 6, 6, 6, 6, 6, 8, 8, 8, 8, 8, 8, 8, 8, //20-2f
      10,10,10,10,10,10,10,10, 0,12, 8,10, 4, 0, 0, 0); //30-37,39,3a,3c
    l_ciclos:array[0..63] of byte=(
     //0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f
    	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, //0-7
    	 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, //10-1f
    	 0, 0, 0, 0, 0, 0, 0, 0,12,12,12,12,12,12,12,12, //28-2f
      14,14,14,14,14,14,14,14,12,16,12,14, 8, 0, 0, 0); //30-37,38,39,3a,3b,3c
    ea_ciclos:array[0..63] of byte=(
     //0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f
    	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
       0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 0);

type
        band_68000=record
                t,s,i,x,n,z,v,c:boolean;
                im:byte;
        end;
        DParejas = record
          case byte of
             0: (l0,h0,l1,h1: byte);
             1: (wl,wh: Word);
             2: (l:dword);
        end;
        pdparejas=^dparejas;
        reg_68000=record
                pc:dparejas;
                ppc:dparejas;
                d:array[0..7] of dparejas;
                a:array[0..7] of dparejas;
                usp,isp:dparejas;
                sp:pdparejas;
                cc:band_68000;
                contador:integer;
                numero_cpu:byte;
                tframes:single;
                opcode:boolean;
                irq:array[0..7] of boolean;
        end;
        preg_68000=^reg_68000;
        pband_68000=^band_68000;
        llam_68000 = record
            getword: function (direccion: dWord): word; pascal;
            putword: procedure (direccion:dword;valor:word);pascal;
            getbyte: function (direccion: dWord): byte; pascal;
            putbyte: procedure (direccion:dword;valor:byte);pascal;
        end;

procedure reset_68000(r:preg_68000;ll:llam_68000);
procedure run_68000(r:preg_68000;ll:llam_68000;maximo:dword);
procedure pedir_irq_68000(r:preg_68000;irq:byte);

implementation

procedure reset_68000(r:preg_68000;ll:llam_68000);
var
  f:byte;
begin
r.cc.s:=true;
r.cc.z:=true;
r.cc.im:=7;
r.sp:=addr(r.a[7]);
r.sp.wh:=ll.getword(0);
r.sp.wl:=ll.getword(2);
r.pc.wh:=ll.getword(4);
r.pc.wl:=ll.getword(6);
for f:=0 to 7 do r.irq[f]:=false;
end;

procedure poner_band(r:preg_68000;pila:word);
begin
if (r.cc.s and ((pila and $2000)=0)) then begin //quita supervisor
  r.isp.l:=r.a[7].l;
  r.a[7].l:=r.usp.l;
  r.cc.s:=false;
end;
if (not(r.cc.s) and ((pila and $2000)<>0)) then begin //pone supervisor
  r.usp.l:=r.a[7].l;
  r.a[7].l:=r.isp.l;
  r.cc.s:=true;
end;
r.cc.t:=(pila and $8000)<>0;
r.cc.im:=(pila shr 8) and 7;
r.cc.x:=(pila and $10)<>0;
r.cc.n:=(pila and $8)<>0;
r.cc.z:=(pila and $4)<>0;
r.cc.v:=(pila and $2)<>0;
r.cc.c:=(pila and $1)<>0;
end;

function coger_band(r:preg_68000):word;
var
  pila:word;
begin
pila:=0;
if r.cc.t then pila:=$8000;
if r.cc.s then pila:=pila or $2000;
pila:=pila or (r.cc.im shl 8);
if r.cc.x then pila:=pila or $10;
if r.cc.n then pila:=pila or $8;
if r.cc.z then pila:=pila or $4;
if r.cc.v then pila:=pila or $2;
if r.cc.c then pila:=pila or $1;
coger_band:=pila;
end;

function leerdir_b(r:preg_68000;ll:llam_68000;dir:byte;ciclos:boolean):byte;
var
  res,des:byte;
  desp:word;
  temp:dword;
begin
if ciclos then inc(r.contador,b_ciclos[dir]);
case dir of
  $0..$7:res:=r.d[dir and $7].l0;  //registro DX
  $8..$f:res:=r.a[dir and $7].l0;  //registro AX
  $10..$17:res:=ll.getbyte(r.a[dir and $7].l); //Registro indirecto AX
  $18..$1f:begin  //indirecto con postincremento
              res:=ll.getbyte(r.a[dir and $7].l);
              inc(r.a[dir and $7].l);
           end;
  $20..$27:begin //AX predecremento
              dec(r.a[(dir and $7)].l);
              res:=ll.getbyte(r.a[(dir and $7)].l);
           end;
  $28..$2f:begin  ////AX indirecto con desplazamiento
              temp:=r.a[dir and $7].l;
              desp:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              if ((desp and $8000)<>0) then dec(temp,($10000-desp))
                else inc(temp,desp);
              res:=ll.getbyte(temp);
           end;
  $30..$37:begin  //AX indirecto indexado con desplazamiento
              desp:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              des:=desp and $ff;
              if (r.d[(desp shr 12) and $7].wl and $8000)<>0 then MessageDlg('Mierda > $8000 ori b', mtInformation,[mbOk], 0);
              temp:=r.a[dir and $7].l+r.d[(desp shr 12) and $7].wl;
              if ((des and $80)<>0) then dec(temp,($100-des))
                else inc(temp,des);
              res:=ll.getbyte(temp);
           end;
  $38:begin //word indirecto
        temp:=ll.getword(r.pc.l);
        inc(r.pc.l,2);
        if (temp and $8000)<>0 then temp:=$FFFF0000 or temp;
        res:=ll.getbyte(temp);
      end;
  $39:begin  //indirecto long
        temp:=ll.getword(r.pc.l) shl 16;
        temp:=temp or ll.getword(r.pc.l+2);
        inc(r.pc.l,4);
        res:=ll.getbyte(temp);
      end;
  $3a:begin
        desp:=ll.getword(r.pc.l);
        if (desp and $8000)<>0 then temp:=r.pc.l-($10000-desp)
          else temp:=r.pc.l+desp;
        inc(r.pc.l,2);
        res:=ll.getbyte(temp);
      end;
  $3b:begin
        desp:=ll.getword(r.pc.l);
        des:=desp and $ff;
        if (r.d[(desp shr 12) and $7].wl and $8000)<>0 then temp:=r.pc.l-($10000-r.d[(desp shr 12) and $7].wl)
          else temp:=r.pc.l+r.d[(desp shr 12) and $7].wl;
        inc(r.pc.l,2);
        if ((des and $80)<>0) then dec(temp,($100-des))
          else inc(temp,des);
        res:=ll.getbyte(temp);
      end;
  $3c:begin  //inmediato word
        res:=ll.getword(r.pc.l) and $ff;
        inc(r.pc.l,2);
      end
  else MessageDlg('Mierda direccionamiento origen.b - '+inttostr(r.pc.l)+' - '+inttostr(dir), mtInformation,[mbOk], 0);
end;
leerdir_b:=res;
end;

function leerdir_w(r:preg_68000;ll:llam_68000;dir:byte;ciclos:boolean):word;
var
  res:word;
  temp,desp:dword;
  des:byte;
begin
if ciclos then inc(r.contador,w_ciclos[dir]);
case dir of
  $0..$7:res:=r.d[dir and $7].wl; //registro DX
  $8..$f:res:=r.a[dir and $7].wl; //registro AX
  $10..$17:res:=ll.getword(r.a[dir and $7].l); //Registro indirecto AX
  $18..$1f:begin // (registro de direccion)+
            res:=ll.getword(r.a[(dir and $7)].l);
            inc(r.a[(dir and $7)].l,2);
           end;
  $20..$27:begin //AX predecremento
              dec(r.a[(dir and $7)].l,2);
              res:=ll.getword(r.a[(dir and $7)].l);
           end;
  $28..$2f:begin  ////AX indirecto con desplazamiento
              temp:=r.a[dir and $7].l;
              desp:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              if ((desp and $8000)<>0) then dec(temp,($10000-desp))
                else inc(temp,desp);
              res:=ll.getword(temp);
           end;
  $30..$37:begin  //AX indirecto indexado con desplazamiento
              desp:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              des:=desp and $ff;
              if (r.d[(desp shr 12) and $7].wl and $8000)<>0 then
                MessageDlg('Mierda > $8000 ori w', mtInformation,[mbOk], 0);
              temp:=r.a[dir and $7].l+r.d[(desp shr 12) and $7].wl;
              if ((des and $80)<>0) then dec(temp,($100-des))
                else inc(temp,des);
              res:=ll.getword(temp);
           end;
  $38:begin //word indirecto
        temp:=ll.getword(r.pc.l);
        inc(r.pc.l,2);
        if (temp and $8000)<>0 then temp:=$FFFF0000 or temp;
        res:=ll.getword(temp);
      end;
  $39:begin  //indirecto inmediato l
        temp:=ll.getword(r.pc.l) shl 16;
        temp:=temp or ll.getword(r.pc.l+2);
        inc(r.pc.l,4);
        res:=ll.getword(temp);
     end;
  $3a:begin
        desp:=ll.getword(r.pc.l);
        if (desp and $8000)<>0 then temp:=r.pc.l-($10000-desp)
          else temp:=r.pc.l+desp;
        inc(r.pc.l,2);
        res:=ll.getword(temp);
      end;
  $3b:begin
        desp:=ll.getword(r.pc.l);
        des:=desp and $ff;
        if (r.d[(desp shr 12) and $7].wl and $8000)<>0 then temp:=r.pc.l-($10000-r.d[(desp shr 12) and $7].wl)
          else temp:=r.pc.l+r.d[(desp shr 12) and $7].wl;
        inc(r.pc.l,2);
        if ((des and $80)<>0) then dec(temp,($100-des))
          else inc(temp,des);
        res:=ll.getword(temp);
      end;
  $3c:begin  //inmediato
        res:=ll.getword(r.pc.l);
        inc(r.pc.l,2);
      end;
else MessageDlg('Mierda error de direccionamiento origen.w - '+inttostr(r.pc.l)+' - '+inttostr(dir), mtInformation,[mbOk], 0);
end;
leerdir_w:=res
end;

function leerdir_l(r:preg_68000;ll:llam_68000;dir:byte;ciclos:boolean):dword;
var
  res,temp:dword;
  desp:word;
  des:byte;
begin
if ciclos then inc(r.contador,l_ciclos[dir]);
case dir of
  $0..$7:res:=r.d[dir and 7].l; //registro DX
  $8..$f:res:=r.a[dir and 7].l; //registro AX
  $10..$17:begin  //Registro indirecto AX
              res:=ll.getword(r.a[(dir and $7)].l) shl 16;
              res:=res or ll.getword(r.a[(dir and $7)].l+2);
           end;
  $18..$1f:begin // registro AX con post incremento
            res:=ll.getword(r.a[(dir and $7)].l) shl 16;
            res:=res or ll.getword(r.a[(dir and $7)].l+2);
            inc(r.a[(dir and $7)].l,4);
           end;
  $20..$27:begin //AX predecremento
            dec(r.a[(dir and $7)].l,4);
            res:=ll.getword(r.a[(dir and $7)].l) shl 16;
            res:=res or ll.getword(r.a[(dir and $7)].l+2);
           end;
  $28..$2f:begin  ////AX indirecto con desplazamiento
              temp:=r.a[dir and $7].l;
              desp:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              if ((desp and $8000)<>0) then dec(temp,($10000-desp))
                else inc(temp,desp);
              res:=ll.getword(temp) shl 16;
              res:=res or ll.getword(temp+2);
           end;
  $30..$37:begin  //AX indirecto indexado con desplazamiento
              desp:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              des:=desp and $ff;
              if (r.d[(desp shr 12) and $7].wl and $8000)<>0 then MessageDlg('Mierda > $8000 ori l', mtInformation,[mbOk], 0);
              temp:=r.a[dir and $7].l+r.d[(desp shr 12) and $7].wl;
              if ((des and $80)<>0) then dec(temp,($100-des))
                else inc(temp,des);
              res:=ll.getword(temp) shl 16;
              res:=res or ll.getword(temp+2);
           end;
  $38:begin //word indirecto
        temp:=ll.getword(r.pc.l);
        inc(r.pc.l,2);
        if (temp and $8000)<>0 then temp:=$FFFF0000 or temp;
        res:=ll.getword(temp) shl 16;
        res:=res or ll.getword(temp+2);
      end;
  $39:begin  //indirecto long
        temp:=ll.getword(r.pc.l) shl 16;
        temp:=temp or ll.getword(r.pc.l+2);
        inc(r.pc.l,4);
        res:=ll.getword(temp) shl 16;
        res:=res or ll.getword(temp+2);
      end;
  $3a:begin
        desp:=ll.getword(r.pc.l);
        if (desp and $8000)<>0 then temp:=r.pc.l-($10000-desp)
          else temp:=r.pc.l+desp;
        inc(r.pc.l,2);
        res:=ll.getword(temp) shl 16;
        res:=res or ll.getword(temp+2);
      end;
  $3b:begin
        desp:=ll.getword(r.pc.l);
        des:=desp and $ff;
        if (r.d[(desp shr 12) and $7].wl and $8000)<>0 then temp:=r.pc.l-($10000-r.d[(desp shr 12) and $7].wl)
          else temp:=r.pc.l+r.d[(desp shr 12) and $7].wl;
        inc(r.pc.l,2);
        if ((des and $80)<>0) then dec(temp,($100-des))
          else inc(temp,des);
        res:=ll.getword(temp) shl 16;
        res:=res or ll.getword(temp+2);
      end;
  $3c:begin // inmediato
        res:=ll.getword(r.pc.l) shl 16;
        res:=res or ll.getword(r.pc.l+2);
        inc(r.pc.l,4);
      end;
  else MessageDlg('Mierda error de direccionamiento origen.l - '+inttostr(dir)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
end;
leerdir_l:=res;
end;

procedure ponerdir_b(r:preg_68000;ll:llam_68000;des,res:byte;misma_instruccion,ciclos:boolean);
var
  temp:dword;
  desp:word;
  despl:byte;
begin
if ciclos then inc(r.contador,b_ciclos[des]);
case des of
           $0..$7:r.d[des and $7].l0:=res;  //registro DX
           $8..$f:begin
                    if (res and $80)<>0 then MessageDlg('Mierda > $8000 ponerdir.b', mtInformation,[mbOk], 0);
                    r.a[des and $7].l0:=res;  //registro AX
                  end;
           $10..$17:ll.putbyte(r.a[des and $7].l,res);  //Registro indirecto AX
           $18..$1f:begin  //indirecto con postincremento
                      if misma_instruccion then dec(r.a[des and $7].l);
                      ll.putbyte(r.a[des and $7].l,res);
                      inc(r.a[des and $7].l);
                    end;
           $20..$27:begin //AX predecremento
                      dec(r.a[(des and $7)].l);
                      if misma_instruccion then inc(r.a[des and $7].l);
                      ll.putbyte(r.a[(des and $7)].l,res);
                    end;
           $28..$2f:begin  ////AX indirecto con desplazamiento
                      temp:=r.a[des and $7].l;
                      if misma_instruccion then dec(r.pc.l,2);
                      desp:=ll.getword(r.pc.l);
                      inc(r.pc.l,2);
                      if ((desp and $8000)<>0) then dec(temp,($10000-desp))
                        else inc(temp,desp);
                      ll.putbyte(temp,res);
                    end;
           $30..$37:begin  //AX indirecto indexado con desplazamiento
                      if misma_instruccion then dec(r.pc.l,2);
                      desp:=ll.getword(r.pc.l);
                      inc(r.pc.l,2);
                      despl:=desp and $ff;
                      if (r.d[(desp shr 12) and $7].wl and $8000)<>0 then MessageDlg('Mierda > $8000 dest b', mtInformation,[mbOk], 0);
                      temp:=r.a[des and $7].l+r.d[(desp shr 12) and $7].wl;
                      if ((despl and $80)<>0) then dec(temp,($100-despl))
                        else inc(temp,despl);
                      ll.putbyte(temp,res);
           end;
           $39:begin //indirecto long
                  if misma_instruccion then dec(r.pc.l,4);
                  temp:=ll.getword(r.pc.l) shl 16;
                  temp:=temp or ll.getword(r.pc.l+2);
                  inc(r.pc.l,4);
                  ll.putbyte(temp,res);
                 end;
           else MessageDlg('Mierda direccionamiento destino.b - '+inttostr(des)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
        end;
end;

procedure ponerdir_w(r:preg_68000;ll:llam_68000;des:byte;res:word;misma_instruccion,ciclos:boolean);
var
  temp:dword;
  desp:word;
  despl:byte;
begin
if ciclos then inc(r.contador,w_ciclos[des]);
case des of
  $0..$7:r.d[des and $7].wl:=res; //registro DX
  $8..$f:begin
            if (res and $8000)<>0 then MessageDlg('Mierda > $8000 ponerdir.w', mtInformation,[mbOk], 0);
            r.a[des and $7].wl:=res; //registro AX
         end;
  $10..$17:ll.putword(r.a[(des and $7)].l,res);  // indirecto con AX
  $18..$1f:begin // (registro de direccion)+
              if misma_instruccion then dec(r.a[(des and $7)].l,2);
              ll.putword(r.a[(des and $7)].l,res);
              inc(r.a[(des and $7)].l,2);
           end;
  $20..$27:begin //AX predecremento
              dec(r.a[(des and $7)].l,2);
              if misma_instruccion then inc(r.a[(des and $7)].l,2);
              ll.putword(r.a[(des and $7)].l,res);
           end;
  $28..$2f:begin  //  AX indirecto con desplazamiento
              temp:=r.a[des and $7].l;
              if misma_instruccion then dec(r.pc.l,2);
              desp:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              if ((desp and $8000)<>0) then dec(temp,(65536-desp))
                else inc(temp,desp);
              ll.putword(temp,res);
           end;
  $30..$37:begin  //AX indirecto indexado con desplazamiento
              if misma_instruccion then dec(r.pc.l,2);
              desp:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              despl:=desp and $ff;
              if (r.d[(desp shr 12) and $7].wl and $8000)<>0 then MessageDlg('Mierda > $8000 dest w', mtInformation,[mbOk], 0);
              temp:=r.a[des and $7].l+r.d[(desp shr 12) and $7].wl;
              if ((despl and $80)<>0) then dec(temp,($100-despl))
                else inc(temp,despl);
              ll.putword(temp,res);
           end;
  $38:begin //word indirecto
        if misma_instruccion then dec(r.pc.l,2);
        temp:=ll.getword(r.pc.l);
        inc(r.pc.l,2);
        if (temp and $8000)<>0 then temp:=$FFFF0000 or temp;
        ll.putword(temp,res);
      end;
  $39:begin  //indirecto long
        if misma_instruccion then dec(r.pc.l,4);
        temp:=ll.getword(r.pc.l) shl 16;
        temp:=temp or ll.getword(r.pc.l+2);
        inc(r.pc.l,4);
        ll.putword(temp,res);
      end;
  else MessageDlg('Mierda error de direccionamiento destino.w - '+inttostr(des)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
end;
end;

procedure ponerdir_l(r:preg_68000;ll:llam_68000;des:byte;res:dword;misma_instruccion,ciclos:boolean);
var
  temp:dword;
  desp:word;
  despl:byte;
begin
if ciclos then inc(r.contador,l_ciclos[des]);
case des of
  $0..$7:r.d[des and $7].l:=res;
  $8..$f:r.a[des and $7].l:=res; //registro AX
  $10..$17:begin //indirecto AX
            ll.putword(r.a[des and $7].l,res shr 16);
            ll.putword(r.a[des and $7].l+2,res and $FFFF);
           end;
  $18..$1f:begin // (registro de direccion)+
              if misma_instruccion then dec(r.a[(des and $7)].l,4);
              ll.putword(r.a[(des and $7)].l,res shr 16);
              ll.putword(r.a[(des and $7)].l+2,res and $FFFF);
              inc(r.a[(des and $7)].l,4);
           end;
  $20..$27:begin // -(registro de direccion)
              dec(r.a[(des and $7)].l,4);
              if misma_instruccion then inc(r.a[(des and $7)].l,4);
              ll.putword(r.a[(des and $7)].l,res shr 16);
              ll.putword(r.a[(des and $7)].l+2,res and $FFFF);
           end;
  $28..$2f:begin  //  AX indirecto con desplazamiento
              temp:=r.a[des and $7].l;
              if misma_instruccion then dec(r.pc.l,2);
              desp:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              if ((desp and $8000)<>0) then dec(temp,($10000-desp))
                else inc(temp,desp);
              ll.putword(temp,res shr 16);
              ll.putword(temp+2,res and $FFFF);
           end;
  $30..$37:begin  //AX indirecto indexado con desplazamiento
              if misma_instruccion then dec(r.pc.l,2);
              desp:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              despl:=desp and $ff;
              if (r.d[(desp shr 12) and $7].wl and $8000)<>0 then MessageDlg('Mierda > $8000 dest l', mtInformation,[mbOk], 0);
              temp:=r.a[des and $7].l+r.d[(desp shr 12) and $7].wl;
              if ((despl and $80)<>0) then dec(temp,($100-despl))
                else inc(temp,despl);
              ll.putword(temp,res shr 16);
              ll.putword(temp+2,res and $FFFF);
           end;
  $39:begin  //indirecto inmediato l
        if misma_instruccion then dec(r.pc.l,4);
        temp:=ll.getword(r.pc.l) shl 16;
        temp:=temp or ll.getword(r.pc.l+2);
        inc(r.pc.l,4);
        ll.putword(temp,res shr 16);
        ll.putword(temp+2,res and $FFFF);
      end;
  else MessageDlg('Mierda error de direccionamiento destino.l - '+inttostr(des)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
end;
end;

function leerdir_ea(r:preg_68000;ll:llam_68000;dir:byte):dword;
var
  res:dword;
  tempw:word;
  tempb:byte;
begin
inc(r.contador,ea_ciclos[dir]);
case dir of
  $10..$1f:res:=r.a[dir and 7].l;
  $28..$2f:begin
              res:=r.a[dir and $7].l;
              tempw:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              if ((tempw and $8000)<>0) then dec(res,($10000-tempw))
                else inc(res,tempw);
            end;
  $30..$37:begin
              tempw:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              tempb:=tempw and $ff;
              if (r.d[(tempw shr 12) and $7].wl and $8000)<>0 then res:=r.a[dir and $7].l-($10000-r.d[(tempw shr 12) and $7].wl)
                else res:=r.a[dir and $7].l+r.d[(tempw shr 12) and $7].wl;
              if ((tempb and $80)<>0) then dec(res,($100-tempb))
                else inc(res,tempb);
            end;
  $38:begin
        tempw:=ll.getword(r.pc.l);
        inc(r.pc.l,2);
        if (tempw and $8000)<>0 then res:=$ffff0000 or tempw
          else res:=tempw;
      end;
  $39:begin
        res:=ll.getword(r.pc.l) shl 16;
        res:=res or ll.getword(r.pc.l+2);
        inc(r.pc.l,4);
      end;
  $3a:begin
        tempw:=ll.getword(r.pc.l);
        if (tempw and $8000)<>0 then res:=r.pc.l-($10000-tempw)
          else res:=r.pc.l+tempw;
        inc(r.pc.l,2);
      end;
  $3b:begin
        tempw:=ll.getword(r.pc.l);
        tempb:=tempw and $ff;
        if (r.d[(tempw shr 12) and $7].wl and $8000)<>0 then res:=r.pc.l-($10000-r.d[(tempw shr 12) and $7].wl)
          else res:=r.pc.l+r.d[(tempw shr 12) and $7].wl;
        inc(r.pc.l,2);
        if ((tempb and $80)<>0) then dec(res,($100-tempb))
          else inc(res,tempb);
      end;
  else MessageDlg('Mierda EA error en dir '+inttostr(dir)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
end;
leerdir_ea:=res;
end;

procedure pedir_irq_68000(r:preg_68000;irq:byte);
begin
r.irq[irq]:=true;
end;

function condicion(r:preg_68000;tipo:byte):boolean;
begin
  case tipo of
    $00:condicion:=true;
    $01:condicion:=false;
    $02:condicion:=(not(r.cc.c) and not(r.cc.z)); //hi
    $03:condicion:=(r.cc.c or r.cc.z); //LS
    $04:condicion:=not(r.cc.c); //cc
    $05:condicion:=r.cc.c;  //cs
    $06:condicion:=not(r.cc.z); //ne
    $07:condicion:=r.cc.z;  //eq
    $08:condicion:=not(r.cc.v); //vc
    $09:condicion:=r.cc.v; //vs
    $0a:condicion:=not(r.cc.n); //plus
    $0b:condicion:=r.cc.n; //mi
    $0c:condicion:=not(r.cc.n xor r.cc.v); //ge
    $0d:condicion:=r.cc.n xor r.cc.v;  //lt
    $0e:condicion:=(not(r.cc.n xor r.cc.v) and not(r.cc.z)); //gt
    $0f:condicion:=((r.cc.n xor r.cc.v)) or r.cc.z; //le
  end;
end;

procedure run_68000(r:preg_68000;ll:llam_68000;maximo:dword);
var
  instruccion,tempw,tempw2,prev_inst:word;
  dir,dest,tempb,tempb2,f:byte;
  templ,templ2,templ3:dword;
begin
while r.contador<maximo do begin
r.ppc:=r.pc;
prev_inst:=instruccion;
for f:=7 downto 0 do begin
    if ((r.cc.im<f) and r.irq[f]) then begin
      inc(r.contador,44);
      tempw:=coger_band(r);
      poner_band(r,tempw or $2000);
      dec(r.sp.l,6);
      ll.putword(r.sp.l,tempw);
      ll.putword(r.sp.l+2,r.pc.l shr 16);
      ll.putword(r.sp.l+4,r.pc.l and $FFFF);
      r.pc.l:=ll.getword($64+((f-1)*4)) shl 16;
      r.pc.l:=r.pc.l or ll.getword($64+2+((f-1)*4));
      r.irq[f]:=false;
      r.cc.im:=f;
      break;
    end;
end;
r.opcode:=true;
instruccion:=ll.getword(r.pc.l);
inc(r.pc.l,2);
r.opcode:=false;
dir:=instruccion and $3f;
case (instruccion shr 12) of //cojo solo el primer nibble
   $0:case (instruccion shr 6) and $3f of
        $0:begin //++++++++++ ori.b
            tempb:=ll.getword(r.pc.l) and $ff;
            inc(r.pc.l,2);
            if dir<>$3c then begin
              if (dir shr 3)<>0 then inc(r.contador,12)
                else inc(r.contador,8);
              tempb2:=leerdir_b(r,ll,dir,true) or tempb;
              ponerdir_b(r,ll,dir,tempb2,true,false);
              r.cc.n:=(tempb2 and $80)<>0;
              r.cc.z:=(tempb2=0);
              r.cc.c:=false;
              r.cc.v:=false;
            end else begin
              inc(r.contador,20);
              tempb2:=(coger_band(r) and $ff) or tempb;
              r.cc.x:=(tempb2 and $10)<>0;
              r.cc.n:=(tempb2 and $8)<>0;
              r.cc.z:=(tempb2 and $4)<>0;
              r.cc.v:=(tempb2 and $2)<>0;
              r.cc.c:=(tempb2 and $1)<>0;
            end;
           end;
        $1:begin  //ori.w
            tempw:=ll.getword(r.pc.l);
            inc(r.pc.l,2);
            if dir<>$3c then begin
              if (dir shr 3)<>0 then inc(r.contador,12)
                else inc(r.contador,8);
              tempw2:=leerdir_w(r,ll,dir,true) or tempw;
              ponerdir_w(r,ll,dir,tempw2,true,false);
              r.cc.n:=(tempw2 and $8000)<>0;
              r.cc.z:=(tempw2=0);
              r.cc.c:=false;
              r.cc.v:=false;
            end else begin
              if r.cc.s then begin
                inc(r.contador,20);
                tempw2:=coger_band(r) or tempw;
                poner_band(r,tempw2);
              end else MessageDlg('Mierda error de privilegio OR SR'+inttostr(r.pc.l), mtInformation,[mbOk], 0);
            end;
           end;
        $2:begin  //ori.l
            if (dir shr 3)<>0 then inc(r.contador,20)
              else inc(r.contador,16);
            templ:=ll.getword(r.pc.l) shl 16;
            templ:=templ or ll.getword(r.pc.l+2);
            inc(r.pc.l,4);
            templ2:=leerdir_l(r,ll,dir,true) or templ;
            ponerdir_l(r,ll,dir,templ2,true,false);
            r.cc.n:=((templ2 shr 24) and $80)<>0;
            r.cc.z:=(templ2=0);
            r.cc.c:=false;
            r.cc.v:=false;
           end;
  $4,$c,$14,$1c,$24,$2c,$34,$3c:begin  //btst dinamico
              if ((instruccion shr 3) and $7)=1 then begin
                MessageDlg('Mierda movep btst', mtInformation,[mbOk], 0);
              end;
              tempb:=r.d[(instruccion shr 9) and 7].l0;
              if dir<8 then begin  //D0-D7
                inc(r.contador,6);
                r.cc.z:=((r.d[dir and $7].l shr (tempb and $1f)) and 1)=0
              end else begin
                inc(r.contador,4);
                tempb2:=leerdir_b(r,ll,dir,true);
                r.cc.z:=((tempb2 shr (tempb and $7)) and 1)=0;
              end;
           end;
  $6,$e,$16,$1e,$26,$2e,$36,$3e:if ((instruccion shr 3) and $7)=1 then begin //+++ movep.w
                                  inc(r.contador,16);
                                  tempw:=ll.getword(r.pc.l);
                                  inc(r.pc.l,2);
                                  if (tempw and $8000)<>0 then MessageDlg('Mierda movep bclr $8000', mtInformation,[mbOk], 0);
                                  templ:=r.a[instruccion and $7].l+tempw;
                                  ll.putbyte(templ,r.d[(instruccion shr 9) and $7].h0);
                                  inc(templ,2);
                                  ll.putbyte(templ,r.d[(instruccion shr 9) and $7].l0);
               end else begin  //bclr dinamico
                tempb:=r.d[(instruccion shr 9) and 7].l0;
                if dir<8 then begin
                  inc(r.contador,10);
                  MessageDlg('Mierda bclr dinamico error de direccionamiento', mtInformation,[mbOk], 0);
                end else begin //indirecto long
                  inc(r.contador,8);
                  tempb2:=leerdir_b(r,ll,dir,true);
                  r.cc.z:=((tempb2 shr (tempb and $7)) and 1)=0;
                  tempb2:=tempb2 and not(1 shl (tempb and $7));
                  ponerdir_b(r,ll,dir,tempb2,true,false);
                end;
           end;
        $8:begin  //++++++ andi.b
            tempb:=ll.getword(r.pc.l) and $ff;
            inc(r.pc.l,2);
            if dir<>$3c then begin
              if (dir shr 3)<>0 then inc(r.contador,12)
                  else inc(r.contador,8);
              tempb2:=leerdir_b(r,ll,dir,true) and tempb;
              ponerdir_b(r,ll,dir,tempb2,true,false);
              r.cc.v:=false;
              r.cc.c:=false;
              r.cc.z:=(tempb2=0);
              r.cc.n:=(tempb2 and $80)<>0;
            end else begin
              inc(r.contador,20);
              tempb2:=(coger_band(r) and $ff) and tempb;
              r.cc.x:=(tempb2 and $10)<>0;
              r.cc.n:=(tempb2 and $8)<>0;
              r.cc.z:=(tempb2 and $4)<>0;
              r.cc.v:=(tempb2 and $2)<>0;
              r.cc.c:=(tempb2 and $1)<>0;
            end;
          end;
        $9:begin  //++++++ andi.w
            tempw:=ll.getword(r.pc.l);
            inc(r.pc.l,2);
            if dir<>$3c then begin
              if (dir shr 3)<>0 then inc(r.contador,12)
                else inc(r.contador,8);
              tempw2:=leerdir_w(r,ll,dir,true) and tempw;
              ponerdir_w(r,ll,dir,tempw2,true,false);
              r.cc.v:=false;
              r.cc.c:=false;
              r.cc.z:=(tempw2=0);
              r.cc.n:=(tempw2 and $8000)<>0;
            end else begin
              if r.cc.s then begin
                 inc(r.contador,20);
                 tempw2:=coger_band(r) and tempw;
                  poner_band(r,tempw2);
              end else MessageDlg('Mierda error de privilegio AND SR'+inttostr(r.pc.l), mtInformation,[mbOk], 0);
            end;
          end;
        $a:begin  //++++++ andi.l
            if (dir shr 3)<>0 then inc(r.contador,20)
              else inc(r.contador,14);
            templ:=ll.getword(r.pc.l) shl 16;
            templ:=templ or ll.getword(r.pc.l+2);
            inc(r.pc.l,4);
            templ2:=leerdir_l(r,ll,dir,true) and templ;
            ponerdir_l(r,ll,dir,templ2,true,false);
            r.cc.v:=false;
            r.cc.c:=false;
            r.cc.z:=(templ2=0);
            r.cc.n:=((templ2 shr 24) and $80)<>0;
          end;
        $10:begin //++++++ subi.b
              if (dir shr 3)<>0 then inc(r.contador,12)
                else inc(r.contador,8);
              tempb:=ll.getword(r.pc.l) and $ff;
              inc(r.pc.l,2);
              tempb2:=leerdir_b(r,ll,dir,true);
              tempw:=tempb2-tempb;
              ponerdir_b(r,ll,dir,(tempw and $ff),true,false);
              r.cc.v:=(((tempb xor tempb2) and (tempw xor tempb2)) and $80)<>0;
              r.cc.c:=(tempw and $100)<>0;
              r.cc.x:=r.cc.c;
              r.cc.n:=(tempw and $80)<>0;
              r.cc.z:=((tempw and $ff)=0);
            end;
        $11:begin //++++++ subi.w
              if (dir shr 3)<>0 then inc(r.contador,12)
                else inc(r.contador,8);
              tempw:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              tempw2:=leerdir_w(r,ll,dir,true);
              templ:=tempw2-tempw;
              ponerdir_w(r,ll,dir,(templ and $ffff),true,false);
              r.cc.v:=((((tempw xor tempw2) and (templ xor tempw2)) shr 8) and $80)<>0;
              r.cc.c:=(templ and $10000)<>0;
              r.cc.x:=r.cc.c;
              r.cc.n:=(templ and $8000)<>0;
              r.cc.z:=((templ and $ffff)=0);
            end;
        $12:begin //++++++ subi.l
              if (dir shr 3)<>0 then inc(r.contador,20)
                else inc(r.contador,16);
              templ:=ll.getword(r.pc.l) shl 16;
              templ:=templ or ll.getword(r.pc.l+2);
              inc(r.pc.l,4);
              templ2:=leerdir_l(r,ll,dir,true);
              templ3:=templ2-templ;
              ponerdir_l(r,ll,dir,templ3,true,false);
              r.cc.n:=((templ3 shr 24) and $80)<>0;
	            r.cc.z:=(templ3=0);
	            r.cc.v:=((((templ xor templ2) and (templ3 xor templ2)) shr 24) and $80)<>0;
	            r.cc.c:=((((templ and templ3) or (not(templ2) and (templ or templ3))) shr 23) and $100)<>0;
              r.cc.x:=r.cc.c;
            end;
        $18:begin //+++++++ addi.b
              if (dir shr 3)<>0 then inc(r.contador,12)
                else inc(r.contador,8);
              tempb:=ll.getword(r.pc.l) and $ff;
              inc(r.pc.l,2);
              tempb2:=leerdir_b(r,ll,dir,true);
              tempw:=tempb+tempb2;
              ponerdir_b(r,ll,dir,(tempw and $ff),true,false);
              r.cc.v:=(((tempb xor tempw) and (tempb2 xor tempw)) and $80)<>0;
              r.cc.c:=(tempw and $100)<>0;
              r.cc.x:=r.cc.c;
              r.cc.n:=(tempw and $80)<>0;
              r.cc.z:=((tempw and $ff)=0);
            end;
        $19:begin //+++++++ addi.w
              if (dir shr 3)<>0 then inc(r.contador,12)
                else inc(r.contador,8);
              tempw:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              tempw2:=leerdir_w(r,ll,dir,true);
              templ:=tempw+tempw2;
              ponerdir_w(r,ll,dir,(templ and $ffff),true,false);
              r.cc.v:=((((tempw xor templ) and (tempw2 xor templ)) shr 8) and $80)<>0;
              r.cc.c:=(templ and $10000)<>0;
              r.cc.x:=r.cc.c;
              r.cc.n:=(templ and $8000)<>0;
              r.cc.z:=((templ and $ffff)=0);
            end;
        $1a:begin //+++++++ addi.l
              if (dir shr 3)<>0 then inc(r.contador,20)
                else inc(r.contador,16);
              templ:=ll.getword(r.pc.l) shl 16;
              templ:=templ or ll.getword(r.pc.l+2);
              inc(r.pc.l,4);
              templ2:=leerdir_l(r,ll,dir,true);
              templ3:=templ+templ2;
              ponerdir_l(r,ll,dir,templ3,true,false);
              r.cc.n:=((templ3 shr 24) and $80)<>0;
              r.cc.v:=((((templ xor templ3) and (templ2 xor templ3)) shr 24) and $80)<>0;
              r.cc.c:=(((((templ and templ3) or (not(templ2) and (templ or templ3)))) shr 23) and $100)<>0;
              r.cc.x:=r.cc.c;
              r.cc.z:=(templ3=0);
            end;
  7,$f,$17,$1f,$27,$2f,$37,$3f:begin //+++++++ bset dinamico
              if ((instruccion shr 3) and $7)=1 then begin
                MessageDlg('Mierda movep bset', mtInformation,[mbOk], 0);
              end;
              inc(r.contador,8);
              tempb:=r.d[(instruccion shr 9) and 7].l0;
              if dir<8 then begin
                r.cc.z:=((r.d[instruccion and 7].l shr (tempb and $1f)) and 1)=0;
                r.d[instruccion and 7].l:=r.d[instruccion and 7].l or (1 shl (tempb and $1f));
              end else begin //indirecto long
                tempb2:=leerdir_b(r,ll,dir,true);
                r.cc.z:=((tempb2 shr (tempb and $7)) and 1)=0;
                tempb2:=tempb2 or (1 shl (tempb and $7));
                ponerdir_b(r,ll,dir,tempb2,true,false);
              end;
            end;
        $20:begin //+++++++ btst
              tempw:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              if dir<8 then begin
                inc(r.contador,10);
                r.cc.z:=((r.d[dir and $7].l shr (tempw and $1f)) and 1)=0
              end else begin
                   inc(r.contador,8);
                   tempb:=leerdir_b(r,ll,dir,true);
                   r.cc.z:=((tempb shr (tempw and $7)) and 1)=0;
              end;
            end;
        $21:begin //+++++ bchg
              inc(r.contador,12);
              tempw:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              if dir<8 then begin
                r.cc.z:=((r.d[dir].l shr (tempw and $1f)) and 1)=0;
                r.d[dir].l:=r.d[dir].l xor (1 shl (tempw and $1f));
              end else begin
                tempb:=leerdir_b(r,ll,dir,true);
                r.cc.z:=((tempb shr (tempw and $7)) and 1)=0;
                tempb:=tempb xor (1 shl (tempw and $7));
                ponerdir_b(r,ll,dir,tempb,true,false);
              end;
            end;
        $22:begin //+++++ bclr
              tempw:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              if dir<8 then begin
                inc(r.contador,14);
                r.cc.z:=((r.d[dir].l shr (tempw and $1f)) and 1)=0;
                r.d[dir].l:=r.d[dir].l and not(1 shl (tempw and $1f));
              end else begin //indirecto long
                inc(r.contador,12);
                tempb:=leerdir_b(r,ll,dir,true);
                r.cc.z:=((tempb shr (tempw and $7)) and 1)=0;
                tempb:=tempb and not(1 shl (tempw and $7));
                ponerdir_b(r,ll,dir,tempb,true,false);
              end;
            end;
        $23:begin //++++++ bset
              inc(r.contador,12);
              tempw:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              if dir<8 then begin
                r.cc.z:=((r.d[dir].l shr (tempw and $1f)) and 1)=0;
                r.d[dir].l:=r.d[dir].l or (1 shl (tempw and $1f));
              end else begin //indirecto long
                tempb:=leerdir_b(r,ll,dir,true);
                r.cc.z:=((tempb shr (tempw and $7)) and 1)=0;
                tempb:=tempb or (1 shl (tempw and $7));
                ponerdir_b(r,ll,dir,tempb,true,false);
              end;
            end;
        $28:begin  //+++++ eori.b
              tempb:=ll.getword(r.pc.l) and $ff;
              inc(r.pc.l,2);
              if dir<>$3c then begin
                if (dir shr 3)<>0 then inc(r.contador,12)
                  else inc(r.contador,8);
                tempb2:=leerdir_b(r,ll,dir,true) xor tempb;
                ponerdir_b(r,ll,dir,tempb2,true,false);
                r.cc.v:=false;
                r.cc.c:=false;
                r.cc.z:=(tempb2=0);
                r.cc.n:=(tempb2 and $80)<>0;
              end else begin
                inc(r.contador,20);
                MessageDlg('Mierda eori.b error de direccionamiento', mtInformation,[mbOk], 0);
              end;
            end;
        $29:begin  //+++++ eori.w
              tempw:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              if dir<>$3c then begin
                if (dir shr 3)<>0 then inc(r.contador,12)
                  else inc(r.contador,8);
                tempw2:=leerdir_w(r,ll,dir,true) xor tempw;
                ponerdir_w(r,ll,dir,tempw2,true,false);
                r.cc.v:=false;
                r.cc.c:=false;
                r.cc.z:=(tempw2=0);
                r.cc.n:=(tempw2 and $8000)<>0;
              end else begin
                inc(r.contador,20);
                MessageDlg('Mierda eori.w error de direccionamiento', mtInformation,[mbOk], 0);
              end;
            end;
        $2a:begin  //eori.l
              if (dir shr 3)<>0 then inc(r.contador,20)
                else inc(r.contador,16);
              templ:=ll.getword(r.pc.l) shl 16;
              templ:=templ or ll.getword(r.pc.l+2);
              inc(r.pc.l,4);
              templ2:=leerdir_l(r,ll,dir,true) xor templ;
              ponerdir_l(r,ll,dir,templ2,true,false);
              r.cc.v:=false;
              r.cc.c:=false;
              r.cc.z:=(templ2=0);
              r.cc.n:=((templ2 shr 24) and $80)<>0;
            end;
        $30:begin //  cmpi.b
              inc(r.contador,8);
              tempb:=ll.getword(r.pc.l) and $ff;
              inc(r.pc.l,2);
              tempb2:=leerdir_b(r,ll,dir,true);
              tempw:=tempb2-tempb;
              r.cc.n:=(tempw and $80)<>0;
	            r.cc.z:=((tempw and $ff)=0);
	            r.cc.v:=(((tempb xor tempb2) and (tempw xor tempb2)) and $80)<>0;
	            r.cc.c:=(tempw and $100)<>0;
              end;
        $31:begin // +++++ cmpi.w
              inc(r.contador,8);
              tempw:=ll.getword(r.pc.l);
              inc(r.pc.l,2);
              tempw2:=leerdir_w(r,ll,dir,true);
              templ:=tempw2-tempw;
              r.cc.n:=(templ and $8000)<>0;
	            r.cc.z:=((templ and $ffff)=0);
	            r.cc.v:=((((tempw xor tempw2) and (templ xor tempw2)) shr 8) and $80)<>0;
	            r.cc.c:=(templ and $10000)<>0;
            end;
        $32:begin  //++++ cmpi.l
              if (dir shr 3)<>0 then inc(r.contador,12)
                else inc(r.contador,14);
              templ:=ll.getword(r.pc.l) shl 16;
              templ:=templ or ll.getword(r.pc.l+2);
              inc(r.pc.l,4);
              templ2:=leerdir_l(r,ll,dir,true);
              templ3:=templ2-templ;
              r.cc.n:=((templ3 shr 24) and $80)<>0;
	            r.cc.z:=(templ3=0);
	            r.cc.v:=((((templ xor templ2) and (templ3 xor templ2)) shr 24) and $80)<>0;
	            r.cc.c:=((((templ and templ3) or (not(templ2) and (templ or templ3))) shr 23))<>0;
            end;
        else MessageDlg('Instruccion $0: '+inttostr((instruccion shr 6) and $3f)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
      end;
   $1:if (instruccion shr 6) and $7=1 then begin //++++++++  movea.b
        MessageDlg('movea.b imposible!', mtInformation,[mbOk], 0);
      end else begin  //+++++++++++++++ move.b
        case (instruccion shr 6) and $7 of
            0:tempb:=4;
            2,3,4:tempb:=8;
            5:tempb:=12;
            6:tempb:=14;
            7:if ((instruccion shr 9) and 1)=1 then tempb:=16
                else tempb:=12;
        end;
        inc(r.contador,tempb);
        case (instruccion shr 3) and $7 of
            0:tempb:=4;
            2,3,4:tempb:=8;
            5:tempb:=12;
            6:tempb:=14;
            7:if ((instruccion shr 9) and 1)=1 then tempb:=16
                else tempb:=12;
        end;
        inc(r.contador,tempb);
        //evaluar origen
        tempb:=leerdir_b(r,ll,dir,true);
        //evaluar destino
        dest:=((instruccion shr 9) and $7) or (((instruccion shr 6) and $7) shl 3);
        ponerdir_b(r,ll,dest,tempb,false,false);
        r.cc.v:=false;
        r.cc.c:=false;
        r.cc.z:=(tempb=0);
        r.cc.n:=(tempb and $80)<>0;
      end;
   $2:if (instruccion shr 6) and $7=1 then begin //++++++++  movea.l
        inc(r.contador,4);
        r.a[(instruccion shr 9) and $7].l:=leerdir_l(r,ll,dir,true);
      end else begin // ++++++++++++++  move.l
        case (instruccion shr 6) and $7 of
            0:tempb:=4;
            2,3,4:tempb:=12;
            5:tempb:=16;
            6:tempb:=18;
            7:if ((instruccion shr 9) and 1)=1 then tempb:=20
                else tempb:=16;
        end;
        inc(r.contador,tempb);
        case (instruccion shr 3) and $7 of
            0:tempb:=4;
            2,3,4:tempb:=12;
            5:tempb:=16;
            6:tempb:=18;
            7:if ((instruccion shr 9) and 1)=1 then tempb:=20
                else tempb:=16;
        end;
        inc(r.contador,tempb);
        //evaluar origen
        templ:=leerdir_l(r,ll,dir,true);
        //evaluar destino
        dest:=((instruccion shr 9) and $7) or (((instruccion shr 6) and $7) shl 3);
        ponerdir_l(r,ll,dest,templ,false,false);
        r.cc.v:=false;
        r.cc.c:=false;
        r.cc.z:=(templ=0);
        r.cc.n:=((templ shr 24) and $80)<>0;
      end;
   $3:if (instruccion shr 6) and $7=1 then begin //+++++++++++++++ movea.w
        inc(r.contador,4);
        tempw:=leerdir_w(r,ll,dir,false);
        if (tempw and $8000)<>0 then r.a[(instruccion shr 9) and $7].wh:=$ffff
          else r.a[(instruccion shr 9) and $7].wh:=0;
        r.a[(instruccion shr 9) and $7].wl:=tempw;
      end else begin //++++++++++++++++++++ move.w
        case (instruccion shr 6) and $7 of
            0:tempb:=4;
            2,3,4:tempb:=8;
            5:tempb:=12;
            6:tempb:=14;
            7:if ((instruccion shr 9) and 1)=1 then tempb:=16
                else tempb:=12;
        end;
        inc(r.contador,tempb);
        case (instruccion shr 3) and $7 of
            0:tempb:=4;
            2,3,4:tempb:=8;
            5:tempb:=12;
            6:tempb:=14;
            7:if ((instruccion shr 9) and 1)=1 then tempb:=16
                else tempb:=12;
        end;
        inc(r.contador,tempb);
        //Evaluar origen
        tempw:=leerdir_w(r,ll,dir,true);
        //destino
        dest:=((instruccion shr 9) and $7) or (((instruccion shr 6) and $7) shl 3);
        ponerdir_w(r,ll,dest,tempw,false,false);
        r.cc.v:=false;
        r.cc.c:=false;
        r.cc.z:=(tempw=0);
        r.cc.n:=(tempw and $8000)<>0;
      end;
   $4:case (instruccion shr 6) and $3f of
          $03:if r.cc.s then begin //++++++++  move from sr
                if dir<8 then inc(r.contador,6)
                  else inc(r.contador,8);
                ponerdir_w(r,ll,dir,coger_band(r),false,true);
              end else MessageDlg('Mierda error de privilegio MOVE FROM SR'+inttostr(r.pc.l), mtInformation,[mbOk], 0);
   $7,$f,$17,$1f,$27,$2f,$37,$3f:r.a[(instruccion shr 9) and $7].l:=leerdir_ea(r,ll,dir); //++++++++ lea
          $08:begin //++++++  clr.b
                if (dir shr 3)<>0 then inc(r.contador,8)
                  else inc(r.contador,4);
                ponerdir_b(r,ll,dir,0,false,true);
                r.cc.n:=false;
                r.cc.v:=false;
                r.cc.c:=false;
                r.cc.z:=true;
              end;
          $09:begin //++++++ clr.w
                if (dir shr 3)<>0 then inc(r.contador,8)
                  else inc(r.contador,4);
                ponerdir_w(r,ll,dir,0,false,true);
                r.cc.n:=false;
                r.cc.v:=false;
                r.cc.c:=false;
                r.cc.z:=true;
              end;
          $0a:begin //++++++  clr.l
                if (dir shr 3)<>0 then inc(r.contador,12)
                  else inc(r.contador,6);
                ponerdir_l(r,ll,dir,0,false,true);
                r.cc.n:=false;
                r.cc.v:=false;
                r.cc.c:=false;
                r.cc.z:=true;
              end;
          $10:begin  //++++ neg.b
                if (dir shr 3)<>0 then inc(r.contador,8)
                  else inc(r.contador,4);
                tempb:=leerdir_b(r,ll,dir,true);
                tempw:=0-tempb;
                r.cc.n:=(tempw and $80)<>0;
                r.cc.c:=(tempw and $100)<>0;
                r.cc.x:=r.cc.c;
                r.cc.z:=(tempw and $ff)=0;
                r.cc.v:=((tempb and tempw) and $80)<>0;
                ponerdir_b(r,ll,dir,tempw and $ff,true,false);
              end;
          $11:begin  //++++ neg.w
                if (dir shr 3)<>0 then inc(r.contador,8)
                  else inc(r.contador,4);
                tempw:=leerdir_w(r,ll,dir,true);
                templ:=0-tempw;
                r.cc.n:=(templ and $8000)<>0;
                r.cc.c:=(templ and $10000)<>0;
                r.cc.x:=r.cc.c;
                r.cc.z:=(templ and $ffff)=0;
                r.cc.v:=(((tempw and templ) shr 8) and $80)<>0;
                ponerdir_w(r,ll,dir,templ and $ffff,true,false);
              end;
          $12:begin  //++++ neg.l
                if (dir shr 3)<>0 then inc(r.contador,12)
                  else inc(r.contador,6);
                templ:=leerdir_l(r,ll,dir,true);
                templ2:=0-templ;
                r.cc.n:=((templ2 shr 24) and $80)<>0;
                r.cc.c:=((((templ and templ2) or (not(0) and (templ or templ2))) shr 23) and $100)<>0;
                r.cc.x:=r.cc.c;
                r.cc.z:=(templ2=0);
                r.cc.v:=(((templ and templ2) shr 24) and $80)<>0;
                ponerdir_l(r,ll,dir,templ2,true,false);
              end;
          $13:begin  //++++ move to ccr
                inc(r.contador,12);
                tempw:=leerdir_w(r,ll,dir,true);
                r.cc.x:=(tempw and $10)<>0;
                r.cc.n:=(tempw and $8)<>0;
                r.cc.z:=(tempw and $4)<>0;
                r.cc.v:=(tempw and $2)<>0;
                r.cc.c:=(tempw and $1)<>0;
              end;
          $18:begin //not.b
                if (dir shr 3)<>0 then inc(r.contador,8)
                  else inc(r.contador,4);
                tempb:=not(leerdir_b(r,ll,dir,true));
                ponerdir_b(r,ll,dir,tempb,true,false);
                r.cc.c:=false;
                r.cc.v:=false;
                r.cc.n:=(tempb and $80)<>0;
                r.cc.z:=(tempb=0);
              end;
          $19:begin //not.w
                if (dir shr 3)<>0 then inc(r.contador,8)
                  else inc(r.contador,4);
                tempw:=not(leerdir_w(r,ll,dir,true));
                ponerdir_w(r,ll,dir,tempw,true,false);
                r.cc.c:=false;
                r.cc.v:=false;
                r.cc.n:=(tempw and $8000)<>0;
                r.cc.z:=(tempw=0);
              end;
          $1a:begin //not.l
                if (dir shr 3)<>0 then inc(r.contador,12)
                  else inc(r.contador,6);
                templ:=not(leerdir_l(r,ll,dir,true));
                ponerdir_l(r,ll,dir,templ,true,false);
                r.cc.c:=false;
                r.cc.v:=false;
                r.cc.n:=((templ shr 24) and $80)<>0;
                r.cc.z:=(templ=0);
              end;
          $1b:if r.cc.s then begin //++++ move to sr
                inc(r.contador,12);
                tempw:=leerdir_w(r,ll,dir,true);
                poner_band(r,tempw);
              end else MessageDlg('Mierda error de privilegio MOVE TO SR'+inttostr(r.pc.l), mtInformation,[mbOk], 0);
          $21:begin //+++++ pea
                inc(r.contador,6);
                case dir of
               $0..$7:begin  //+++++++++ swap!!!
                        dec(r.contador,2);
                        templ:=(r.d[dir and 7].wl shl 16) or r.d[dir and 7].wh;
                        r.cc.c:=false;
                        r.cc.v:=false;
                        r.cc.n:=((templ shr 24) and $80)<>0;
                        r.cc.z:=(templ=0);
                        r.d[dir and 7].l:=templ;
                   end;
                   $39:begin
                        templ:=ll.getword(r.pc.l) shl 16;
                        templ:=templ or ll.getword(r.pc.l+2);
                        inc(r.pc.l,4);
                        dec(r.sp.l,4);
                        ll.putword(r.sp.l,templ shr 16);
                        ll.putword(r.sp.l+2,templ and $FFFF);
                      end;
                   $3a:begin
                          tempw:=ll.getword(r.pc.l);
                          if (tempw and $8000)<>0 then templ:=r.pc.l-($10000-tempw)
                            else templ:=r.pc.l+tempw;
                          inc(r.pc.l,2);
                          dec(r.sp.l,4);
                          ll.putword(r.sp.l,templ shr 16);
                          ll.putword(r.sp.l+2,templ and $FFFF);
                       end;
                   else MessageDlg('Mierda pea error de direccionamiento '+inttostr(dir)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                end;
              end;
          $22:begin
                if (dir shr 3)=0 then begin //+++++ ext.w
                   inc(r.contador,4);
                   tempb:=r.d[instruccion and 7].l0;
                   if (tempb and $80)<>0 then tempw:=$FF00 or tempb
                      else tempw:=tempb;
                   r.cc.c:=false;
                   r.cc.v:=false;
                   r.cc.n:=(tempw and $8000)<>0;
                   r.cc.z:=(tempw=0);
                   r.d[instruccion and 7].wl:=tempw;
                end else begin  //++++ movem.w
                  inc(r.contador,8);
                  tempw:=ll.getword(r.pc.l);
                  inc(r.pc.l,2);
                  tempw2:=tempw;
                  tempb2:=0;
                  for tempb:=0 to 15 do begin
                    if (tempw2 and 1)<>0 then inc(tempb2);
                    tempw2:=tempw2 shr 1;
                  end;
                  inc(r.contador,tempb2 shl 2);
                  case dir of
                    $10..$17:begin
                              templ:=leerdir_ea(r,ll,dir);
                              if (tempw and $0001)<>0 then begin
                                ll.putword(templ,r.d[0].wl);
                                inc(templ,2);
                              end;
                              if (tempw and $0002)<>0 then begin
                                ll.putword(templ,r.d[1].wl);
                                inc(templ,2);
                              end;
                              if (tempw and $0004)<>0 then begin
                                ll.putword(templ,r.d[2].wl);
                                inc(templ,2);
                              end;
                              if (tempw and $0008)<>0 then begin
                                ll.putword(templ,r.d[3].wl);
                                inc(templ,2);
                              end;
                              if (tempw and $0010)<>0 then begin
                                ll.putword(templ,r.d[4].wl);
                                inc(templ,2);
                              end;
                              if (tempw and $0020)<>0 then begin
                                ll.putword(templ,r.d[5].wl);
                                inc(templ,2);
                              end;
                              if (tempw and $0040)<>0 then begin
                                ll.putword(templ,r.d[6].wl);
                                inc(templ,2);
                              end;
                              if (tempw and $0080)<>0 then begin
                                ll.putword(templ,r.d[7].wl);
                                inc(templ,2);
                              end;
                              if (tempw and $0100)<>0 then begin
                                ll.putword(templ,r.a[0].wl);
                                inc(templ,2);
                              end;
                              if (tempw and $0200)<>0 then begin
                                ll.putword(templ,r.a[1].wl);
                                inc(templ,2);
                              end;
                              if (tempw and $0400)<>0 then begin
                                ll.putword(templ,r.a[2].wl);
                                inc(templ,2);
                              end;
                              if (tempw and $0800)<>0 then begin
                                ll.putword(templ,r.a[3].wl);
                                inc(templ,2);
                              end;
                              if (tempw and $1000)<>0 then begin
                                ll.putword(templ,r.a[4].wl);
                                inc(templ,2);
                              end;
                              if (tempw and $2000)<>0 then begin
                                ll.putword(templ,r.a[5].wl);
                                inc(templ,2);
                              end;
                              if (tempw and $4000)<>0 then begin
                                ll.putword(templ,r.a[6].wl);
                                inc(templ,2);
                              end;
                              if (tempw and $8000)<>0 then begin
                                ll.putword(templ,r.a[7].wl);
                                inc(templ,2);
                              end;
                             end;
                    $20..$27:begin
                            if (tempw and $8000)<>0 then ponerdir_w(r,ll,dir,r.d[0].wl,false,false); //D0
                            if (tempw and $4000)<>0 then ponerdir_w(r,ll,dir,r.d[1].wl,false,false);
                            if (tempw and $2000)<>0 then ponerdir_w(r,ll,dir,r.d[2].wl,false,false);
                            if (tempw and $1000)<>0 then ponerdir_w(r,ll,dir,r.d[3].wl,false,false);
                            if (tempw and $0800)<>0 then ponerdir_w(r,ll,dir,r.d[4].wl,false,false);
                            if (tempw and $0400)<>0 then ponerdir_w(r,ll,dir,r.d[5].wl,false,false);
                            if (tempw and $0200)<>0 then ponerdir_w(r,ll,dir,r.d[6].wl,false,false);
                            if (tempw and $0100)<>0 then ponerdir_w(r,ll,dir,r.d[7].wl,false,false);
                            if (tempw and $0080)<>0 then ponerdir_w(r,ll,dir,r.a[0].wl,false,false);
                            if (tempw and $0040)<>0 then ponerdir_w(r,ll,dir,r.a[1].wl,false,false);
                            if (tempw and $0020)<>0 then ponerdir_w(r,ll,dir,r.a[2].wl,false,false);
                            if (tempw and $0010)<>0 then ponerdir_w(r,ll,dir,r.a[3].wl,false,false);
                            if (tempw and $0008)<>0 then ponerdir_w(r,ll,dir,r.a[4].wl,false,false);
                            if (tempw and $0004)<>0 then ponerdir_w(r,ll,dir,r.a[5].wl,false,false);
                            if (tempw and $0002)<>0 then ponerdir_w(r,ll,dir,r.a[6].wl,false,false);
                            if (tempw and $0001)<>0 then ponerdir_w(r,ll,dir,r.a[7].wl,false,false);
                          end;
                    else MessageDlg('Mierda movem.w poner '+inttostr(dir)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                  end;
                end;
              end;
          $23:if (dir shr 3)=0 then begin //+++++ ext.l
                   inc(r.contador,4);
                   tempw:=r.d[instruccion and 7].wl;
                   if (tempw and $8000)<>0 then templ:=$FFFF0000 or tempw
                      else templ:=tempw;
                   r.cc.c:=false;
                   r.cc.v:=false;
                   r.cc.n:=((templ shr 24) and $80)<>0;
                   r.cc.z:=(templ=0);
                   r.d[instruccion and 7].l:=templ;
              end else begin //+++++ movem.l d=0 los bits de dir son destino
                inc(r.contador,12);
                tempw:=ll.getword(r.pc.l);
                inc(r.pc.l,2);
                tempw2:=tempw;
                tempb2:=0;
                for tempb:=0 to 15 do begin
                  if (tempw2 and 1)<>0 then inc(tempb2);
                  tempw2:=tempw2 shr 1;
                end;
                inc(r.contador,tempb2 shl 3);
                case dir of
                  $70..$77:begin
                              tempw2:=tempw;
                              tempb2:=0;
                              for tempb:=0 to 15 do begin
                                if (tempw2 and 1)<>0 then inc(tempb2);
                                tempw2:=tempw2 shr 1;
                              end;
                              templ:=leerdir_ea(r,ll,dir)+((tempb2-1)*2);
                              if (tempw and $8000)<>0 then begin
                                ll.putword(templ+2,r.a[7].wl);
                                ll.putword(templ,r.a[7].wh);
                                dec(templ,4);
                              end;
                              if (tempw and $4000)<>0 then begin
                                ll.putword(templ+2,r.a[6].wl);
                                ll.putword(templ,r.a[6].wh);
                                dec(templ,4);
                              end;
                              if (tempw and $2000)<>0 then begin
                                ll.putword(templ+2,r.a[5].wl);
                                ll.putword(templ,r.a[5].wh);
                                dec(templ,4);
                              end;
                              if (tempw and $1000)<>0 then begin
                                ll.putword(templ+2,r.a[4].wl);
                                ll.putword(templ,r.a[4].wh);
                                dec(templ,4);
                              end;
                              if (tempw and $0800)<>0 then begin
                                ll.putword(templ+2,r.a[3].wl);
                                ll.putword(templ,r.a[3].wh);
                                dec(templ,4);
                              end;
                              if (tempw and $0400)<>0 then begin
                                ll.putword(templ+2,r.a[2].wl);
                                ll.putword(templ,r.a[2].wh);
                                dec(templ,4);
                              end;
                              if (tempw and $0200)<>0 then begin
                                ll.putword(templ+2,r.a[1].wl);
                                ll.putword(templ,r.a[1].wh);
                                dec(templ,4);
                              end;
                              if (tempw and $0100)<>0 then begin
                                ll.putword(templ+2,r.a[0].wl);
                                ll.putword(templ,r.a[0].wh);
                                dec(templ,4);
                              end;
                              if (tempw and $0080)<>0 then begin
                                ll.putword(templ+2,r.d[7].wl);
                                ll.putword(templ,r.d[7].wh);
                                dec(templ,4);
                              end;
                              if (tempw and $0040)<>0 then begin
                                ll.putword(templ+2,r.d[6].wl);
                                ll.putword(templ,r.d[6].wh);
                                dec(templ,4);
                              end;
                              if (tempw and $0020)<>0 then begin
                                ll.putword(templ+2,r.d[5].wl);
                                ll.putword(templ,r.d[5].wh);
                                dec(templ,4);
                              end;
                              if (tempw and $0010)<>0 then begin
                                ll.putword(templ+2,r.d[4].wl);
                                ll.putword(templ,r.d[4].wh);
                                dec(templ,4);
                              end;
                              if (tempw and $0008)<>0 then begin
                                ll.putword(templ+2,r.d[3].wl);
                                ll.putword(templ,r.d[3].wh);
                                dec(templ,4);
                              end;
                              if (tempw and $0004)<>0 then begin
                                ll.putword(templ+2,r.d[2].wl);
                                ll.putword(templ,r.d[2].wh);
                                dec(templ,4);
                              end;
                              if (tempw and $0002)<>0 then begin
                                ll.putword(templ+2,r.d[1].wl);
                                ll.putword(templ,r.d[1].wh);
                                dec(templ,4);
                              end;
                              if (tempw and $0001)<>0 then begin
                                ll.putword(templ+2,r.d[0].wl);
                                ll.putword(templ,r.d[0].wh);
                                dec(templ,4);
                              end;
                             end;
                  $20..$27:begin
                            if (tempw and $8000)<>0 then ponerdir_l(r,ll,dir,r.d[0].l,false,false); //D0
                            if (tempw and $4000)<>0 then ponerdir_l(r,ll,dir,r.d[1].l,false,false);
                            if (tempw and $2000)<>0 then ponerdir_l(r,ll,dir,r.d[2].l,false,false);
                            if (tempw and $1000)<>0 then ponerdir_l(r,ll,dir,r.d[3].l,false,false);
                            if (tempw and $0800)<>0 then ponerdir_l(r,ll,dir,r.d[4].l,false,false);
                            if (tempw and $0400)<>0 then ponerdir_l(r,ll,dir,r.d[5].l,false,false);
                            if (tempw and $0200)<>0 then ponerdir_l(r,ll,dir,r.d[6].l,false,false);
                            if (tempw and $0100)<>0 then ponerdir_l(r,ll,dir,r.d[7].l,false,false);
                            if (tempw and $0080)<>0 then ponerdir_l(r,ll,dir,r.a[0].l,false,false);
                            if (tempw and $0040)<>0 then ponerdir_l(r,ll,dir,r.a[1].l,false,false);
                            if (tempw and $0020)<>0 then ponerdir_l(r,ll,dir,r.a[2].l,false,false);
                            if (tempw and $0010)<>0 then ponerdir_l(r,ll,dir,r.a[3].l,false,false);
                            if (tempw and $0008)<>0 then ponerdir_l(r,ll,dir,r.a[4].l,false,false);
                            if (tempw and $0004)<>0 then ponerdir_l(r,ll,dir,r.a[5].l,false,false);
                            if (tempw and $0002)<>0 then ponerdir_l(r,ll,dir,r.a[6].l,false,false);
                            if (tempw and $0001)<>0 then ponerdir_l(r,ll,dir,r.a[7].l,false,false);
                          end;
                    else MessageDlg('Mierda movem.l poner '+inttostr(dir)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                  end;
                end;
          $28:begin //+++++ tst.b
                inc(r.contador,4);
                tempb:=leerdir_b(r,ll,dir,true);
                r.cc.v:=false;
                r.cc.c:=false;
                r.cc.n:=(tempb and $80)<>0;
  	            r.cc.z:=(tempb=0);
              end;
          $29:begin //+++++ tst.w
                inc(r.contador,4);
                tempw:=leerdir_w(r,ll,dir,true);
                r.cc.v:=false;
                r.cc.c:=false;
                r.cc.n:=(tempw and $8000)<>0;
  	            r.cc.z:=(tempw=0);
              end;
          $2a:begin //+++++ tst.l
                inc(r.contador,4);
                templ:=leerdir_l(r,ll,dir,true);
                r.cc.v:=false;
                r.cc.c:=false;
                r.cc.n:=((templ shr 24) and $80)<>0;
  	            r.cc.z:=(templ=0);
              end;
          $32:begin //movem.w  bits dir son origen
                inc(r.contador,12);
                tempw:=ll.getword(r.pc.l);
                inc(r.pc.l,2);
                tempw2:=tempw;
                  tempb2:=0;
                  for tempb:=0 to 15 do begin
                    if (tempw2 and 1)<>0 then inc(tempb2);
                    tempw2:=tempw2 shr 1;
                  end;
                  inc(r.contador,tempb2 shl 2);
                case dir of
                  $10..$17,$28..$37:begin
                            templ:=leerdir_ea(r,ll,dir);
                            if (tempw and $0001)<>0 then begin
                              r.d[0].wl:=ll.getword(templ);
                              if (r.d[0].wl and $8000)<>0 then r.d[0].wh:=$ffff
                                else r.d[0].wh:=0;
                              inc(templ,2);
                            end;
                            if (tempw and $0002)<>0 then begin
                              r.d[1].wl:=ll.getword(templ);
                              if (r.d[1].wl and $8000)<>0 then r.d[1].wh:=$ffff
                                else r.d[1].wh:=0;
                              inc(templ,2);
                            end;
                            if (tempw and $0004)<>0 then begin
                              r.d[2].wl:=ll.getword(templ);
                              if (r.d[2].wl and $8000)<>0 then r.d[2].wh:=$ffff
                                else r.d[2].wh:=0;
                              inc(templ,2);
                            end;
                            if (tempw and $0008)<>0 then begin
                              r.d[3].wl:=ll.getword(templ);
                              if (r.d[3].wl and $8000)<>0 then r.d[3].wh:=$ffff
                                else r.d[3].wh:=0;
                              inc(templ,2);
                            end;
                            if (tempw and $0010)<>0 then begin
                              r.d[4].wl:=ll.getword(templ);
                              if (r.d[4].wl and $8000)<>0 then r.d[4].wh:=$ffff
                                else r.d[4].wh:=0;
                              inc(templ,2);
                            end;
                            if (tempw and $0020)<>0 then begin
                              r.d[5].wl:=ll.getword(templ);
                              if (r.d[5].wl and $8000)<>0 then r.d[5].wh:=$ffff
                                else r.d[5].wh:=0;
                              inc(templ,2);
                            end;
                            if (tempw and $0040)<>0 then begin
                              r.d[6].wl:=ll.getword(templ);
                              if (r.d[6].wl and $8000)<>0 then r.d[6].wh:=$ffff
                                else r.d[6].wh:=0;
                              inc(templ,2);
                            end;
                            if (tempw and $0080)<>0 then begin
                              r.d[7].wl:=ll.getword(templ);
                              if (r.d[7].wl and $8000)<>0 then r.d[7].wh:=$ffff
                                else r.d[7].wh:=0;
                              inc(templ,2);
                            end;
                            if (tempw and $0100)<>0 then begin
                              if (r.a[0].wl and $8000)<>0 then r.a[0].wh:=$ffff
                                 else r.a[0].wh:=0;
                              r.a[0].wl:=ll.getword(templ);
                              inc(templ,2);
                            end;
                            if (tempw and $0200)<>0 then begin
                              r.a[1].wl:=ll.getword(templ);
                              if (r.a[1].wl and $8000)<>0 then r.a[1].wh:=$ffff
                                else r.a[1].wh:=0;
                              inc(templ,2);
                            end;
                            if (tempw and $0400)<>0 then begin
                              r.a[2].wl:=ll.getword(templ);
                              if (r.a[2].wl and $8000)<>0 then r.a[2].wh:=$ffff
                                else r.a[2].wh:=0;
                              inc(templ,2);
                            end;
                            if (tempw and $0800)<>0 then begin
                              r.a[3].wl:=ll.getword(templ);
                              if (r.a[3].wl and $8000)<>0 then r.a[3].wh:=$ffff
                                else r.a[3].wh:=0;
                              inc(templ,2);
                            end;
                            if (tempw and $1000)<>0 then begin
                              r.a[4].wl:=ll.getword(templ);
                              if (r.a[4].wl and $8000)<>0 then r.a[4].wh:=$ffff
                                else r.a[4].wh:=0;
                              inc(templ,2);
                            end;
                            if (tempw and $2000)<>0 then begin
                              r.a[5].wl:=ll.getword(templ);
                              if (r.a[5].wl and $8000)<>0 then r.a[5].wh:=$ffff
                                else r.a[5].wh:=0;
                              inc(templ,2);
                            end;
                            if (tempw and $4000)<>0 then begin
                              r.a[6].wl:=ll.getword(templ);
                              if (r.a[6].wl and $8000)<>0 then r.a[6].wh:=$ffff
                                else r.a[6].wh:=0;
                              inc(templ,2);
                            end;
                            if (tempw and $8000)<>0 then begin
                              r.a[7].wl:=ll.getword(templ);
                              if (r.a[7].wl and $8000)<>0 then r.a[7].wh:=$ffff
                                else r.a[7].wh:=0;
                              inc(templ,2);
                            end;
                           end;
                  $18..$1f:begin
                            if (tempw and $8000)<>0 then begin
                              tempw2:=leerdir_w(r,ll,dir,true);
                              if (tempw2 and $8000)<>0 then r.a[7].l:=$FFFF0000 or tempw2
                                else r.a[7].l:=tempw2;
                            end;
                            if (tempw and $4000)<>0 then begin
                              tempw2:=leerdir_w(r,ll,dir,true);
                              if (tempw2 and $8000)<>0 then r.a[6].l:=$FFFF0000 or tempw2
                                else r.a[6].l:=tempw2;
                            end;
                            if (tempw and $2000)<>0 then begin
                              tempw2:=leerdir_w(r,ll,dir,true);
                              if (tempw2 and $8000)<>0 then r.a[5].l:=$FFFF0000 or tempw2
                                else r.a[5].l:=tempw2;
                            end;
                            if (tempw and $1000)<>0 then begin
                              tempw2:=leerdir_w(r,ll,dir,true);
                              if (tempw2 and $8000)<>0 then r.a[4].l:=$FFFF0000 or tempw2
                                else r.a[4].l:=tempw2;
                            end;
                            if (tempw and $0800)<>0 then begin
                              tempw2:=leerdir_w(r,ll,dir,true);
                              if (tempw2 and $8000)<>0 then r.a[3].l:=$FFFF0000 or tempw2
                                else r.a[3].l:=tempw2;
                            end;
                            if (tempw and $0400)<>0 then begin
                              tempw2:=leerdir_w(r,ll,dir,true);
                              if (tempw2 and $8000)<>0 then r.a[2].l:=$FFFF0000 or tempw2
                                else r.a[2].l:=tempw2;
                            end;
                            if (tempw and $0200)<>0 then begin
                              tempw2:=leerdir_w(r,ll,dir,true);
                              if (tempw2 and $8000)<>0 then r.a[1].l:=$FFFF0000 or tempw2
                                else r.a[1].l:=tempw2;
                            end;
                            if (tempw and $0100)<>0 then begin
                              tempw2:=leerdir_w(r,ll,dir,true);
                              if (tempw2 and $8000)<>0 then r.a[0].l:=$FFFF0000 or tempw2
                                else r.a[0].l:=tempw2;
                            end;
                            if (tempw and $0080)<>0 then begin
                              tempw2:=leerdir_w(r,ll,dir,true);
                              if (tempw2 and $8000)<>0 then r.d[7].l:=$FFFF0000 or tempw2
                                else r.d[7].l:=tempw2;
                            end;
                            if (tempw and $0040)<>0 then begin
                              tempw2:=leerdir_w(r,ll,dir,true);
                              if (tempw2 and $8000)<>0 then r.d[6].l:=$FFFF0000 or tempw2
                                else r.d[6].l:=tempw2;
                            end;
                            if (tempw and $0020)<>0 then begin
                              tempw2:=leerdir_w(r,ll,dir,true);
                              if (tempw2 and $8000)<>0 then r.d[5].l:=$FFFF0000 or tempw2
                                else r.d[5].l:=tempw2;
                            end;
                            if (tempw and $0010)<>0 then begin
                              tempw2:=leerdir_w(r,ll,dir,true);
                              if (tempw2 and $8000)<>0 then r.d[4].l:=$FFFF0000 or tempw2
                                else r.d[4].l:=tempw2;
                            end;
                            if (tempw and $0008)<>0 then begin
                              tempw2:=leerdir_w(r,ll,dir,true);
                              if (tempw2 and $8000)<>0 then r.d[3].l:=$FFFF0000 or tempw2
                                else r.d[3].l:=tempw2;
                            end;
                            if (tempw and $0004)<>0 then begin
                              tempw2:=leerdir_w(r,ll,dir,true);
                              if (tempw2 and $8000)<>0 then r.d[2].l:=$FFFF0000 or tempw2
                                else r.d[2].l:=tempw2;
                            end;
                            if (tempw and $0002)<>0 then begin
                              tempw2:=leerdir_w(r,ll,dir,true);
                              if (tempw2 and $8000)<>0 then r.d[1].l:=$FFFF0000 or tempw2
                                else r.d[1].l:=tempw2;
                            end;
                            if (tempw and $0001)<>0 then begin
                              tempw2:=leerdir_w(r,ll,dir,true);
                              if (tempw2 and $8000)<>0 then r.d[0].l:=$FFFF0000 or tempw2
                                else r.d[0].l:=tempw2;
                            end;
                        end
                  else MessageDlg('Mierda movem.w leer '+inttostr(dir)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                end;
              end;
          $33:begin //movem.l  bits dir son origen
                inc(r.contador,12);
                tempw:=ll.getword(r.pc.l);
                inc(r.pc.l,2);
                tempw2:=tempw;
                tempb2:=0;
                for tempb:=0 to 15 do begin
                    if (tempw2 and 1)<>0 then inc(tempb2);
                    tempw2:=tempw2 shr 1;
                end;
                inc(r.contador,tempb2 shl 3);
                case dir of
                $70..$77:begin
                      templ:=leerdir_ea(r,ll,dir);
                      if (tempw and $8000)<>0 then begin
                         r.a[7].wh:=ll.getword(templ);
                         r.a[7].wl:=ll.getword(templ+2);
                         inc(templ,4);
                      end;
                      if (tempw and $4000)<>0 then begin
                         r.a[6].wh:=ll.getword(templ);
                         r.a[6].wl:=ll.getword(templ+2);
                         inc(templ,4);
                      end;
                      if (tempw and $2000)<>0 then begin
                         r.a[5].wh:=ll.getword(templ);
                         r.a[5].wl:=ll.getword(templ+2);
                         inc(templ,4);
                      end;
                      if (tempw and $1000)<>0 then begin
                         r.a[4].wh:=ll.getword(templ);
                         r.a[4].wl:=ll.getword(templ+2);
                         inc(templ,4);
                      end;
                      if (tempw and $0800)<>0 then begin
                         r.a[3].wh:=ll.getword(templ);
                         r.a[3].wl:=ll.getword(templ+2);
                         inc(templ,4);
                      end;
                      if (tempw and $0400)<>0 then begin
                         r.a[2].wh:=ll.getword(templ);
                         r.a[2].wl:=ll.getword(templ+2);
                         inc(templ,4);
                      end;
                      if (tempw and $0200)<>0 then begin
                         r.a[1].wh:=ll.getword(templ);
                         r.a[1].wl:=ll.getword(templ+2);
                         inc(templ,4);
                      end;
                      if (tempw and $0100)<>0 then begin
                         r.a[0].wh:=ll.getword(templ);
                         r.a[0].wl:=ll.getword(templ+2);
                         inc(templ,4);
                      end;
                      if (tempw and $0080)<>0 then begin
                         r.d[7].wh:=ll.getword(templ);
                         r.d[7].wl:=ll.getword(templ+2);
                         inc(templ,4);
                      end;
                      if (tempw and $0040)<>0 then begin
                         r.d[6].wh:=ll.getword(templ);
                         r.d[6].wl:=ll.getword(templ+2);
                         inc(templ,4);
                      end;
                      if (tempw and $0020)<>0 then begin
                         r.d[5].wh:=ll.getword(templ);
                         r.d[5].wl:=ll.getword(templ+2);
                         inc(templ,4);
                      end;
                      if (tempw and $0010)<>0 then begin
                         r.d[4].wh:=ll.getword(templ);
                         r.d[4].wl:=ll.getword(templ+2);
                         inc(templ,4);
                      end;
                      if (tempw and $0008)<>0 then begin
                         r.d[3].wh:=ll.getword(templ);
                         r.d[3].wl:=ll.getword(templ+2);
                         inc(templ,4);
                      end;
                      if (tempw and $0004)<>0 then begin
                         r.d[2].wh:=ll.getword(templ);
                         r.d[2].wl:=ll.getword(templ+2);
                         inc(templ,4);
                      end;
                      if (tempw and $0002)<>0 then begin
                         r.d[1].wh:=ll.getword(templ);
                         r.d[1].wl:=ll.getword(templ+2);
                         inc(templ,4);
                      end;
                      if (tempw and $0001)<>0 then begin
                         r.d[0].wh:=ll.getword(templ);
                         r.d[0].wl:=ll.getword(templ+2);
                         inc(templ,4);
                      end;
                end;
                $18..$1f:begin
                            if (tempw and $8000)<>0 then r.a[7].l:=leerdir_l(r,ll,dir,true); //D0
                            if (tempw and $4000)<>0 then r.a[6].l:=leerdir_l(r,ll,dir,true);
                            if (tempw and $2000)<>0 then r.a[5].l:=leerdir_l(r,ll,dir,true);
                            if (tempw and $1000)<>0 then r.a[4].l:=leerdir_l(r,ll,dir,true);
                            if (tempw and $0800)<>0 then r.a[3].l:=leerdir_l(r,ll,dir,true);
                            if (tempw and $0400)<>0 then r.a[2].l:=leerdir_l(r,ll,dir,true);
                            if (tempw and $0200)<>0 then r.a[1].l:=leerdir_l(r,ll,dir,true);
                            if (tempw and $0100)<>0 then r.a[0].l:=leerdir_l(r,ll,dir,true);
                            if (tempw and $0080)<>0 then r.d[7].l:=leerdir_l(r,ll,dir,true);
                            if (tempw and $0040)<>0 then r.d[6].l:=leerdir_l(r,ll,dir,true);
                            if (tempw and $0020)<>0 then r.d[5].l:=leerdir_l(r,ll,dir,true);
                            if (tempw and $0010)<>0 then r.d[4].l:=leerdir_l(r,ll,dir,true);
                            if (tempw and $0008)<>0 then r.d[3].l:=leerdir_l(r,ll,dir,true);
                            if (tempw and $0004)<>0 then r.d[2].l:=leerdir_l(r,ll,dir,true);
                            if (tempw and $0002)<>0 then r.d[1].l:=leerdir_l(r,ll,dir,true);
                            if (tempw and $0001)<>0 then r.d[0].l:=leerdir_l(r,ll,dir,true);
                        end
                 else MessageDlg('Mierda movem.l poner '+inttostr(dir)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                end;
              end;
          $39:case (instruccion and $3f) of
           $0..$f:begin //trap
                     inc(r.contador,4+34);
                     tempw:=coger_band(r);
                     poner_band(r,tempw or $2000);
                     dec(r.sp.l,6);
                     ll.putword(r.sp.l+4,r.pc.wl);
                     ll.putword(r.sp.l+2,r.pc.wh);
                     ll.putword(r.sp.l,tempw);
                     r.pc.l:=ll.getword($80+((instruccion and $f)*4)) shl 16;
                     r.pc.l:=r.pc.l or ll.getword($80+2+((instruccion and $f)*4));
                  end;
         $10..$17:begin //link
                    inc(r.contador,16);
                    tempw:=ll.getword(r.pc.l);
                    inc(r.pc.l,2);
                    dec(r.sp.l,4);
                    ll.putword(r.sp.l,r.a[instruccion and $7].wh);
                    ll.putword(r.sp.l+2,r.a[instruccion and $7].wl);
                    r.a[instruccion and $7].l:=r.sp.l;
                    if (tempw and $8000)<>0 then r.sp.l:=r.sp.l-($10000-tempw)
                      else r.sp.l:=r.sp.l+tempw;
                  end;
          $18..$1f:begin  //ulnk
                    inc(r.contador,12);
                    r.sp.l:=r.a[instruccion and $7].l;
                    r.a[instruccion and $7].wh:=ll.getword(r.sp.l);
                    r.a[instruccion and $7].wl:=ll.getword(r.sp.l+2);
                    inc(r.sp.l,4);
                  end;
          $20..$2f:begin
                    inc(r.contador,4);
                    if ((instruccion shr 3) and 1)=1 then r.a[instruccion and 7].l:=r.usp.l //+++ move usp
                        else r.usp.l:=r.a[instruccion and 7].l;
                   end;
              $31:begin  //++++ nop
                    inc(r.contador,4);
                  end;
              $33:begin  //++++ rte
                    inc(r.contador,20);
                    tempw:=ll.getword(r.sp.l);
                    r.pc.wh:=ll.getword(r.sp.l+2);
                    r.pc.wl:=ll.getword(r.sp.l+4);
                    inc(r.sp.l,6);
                    poner_band(r,tempw);
                  end;
              $35:begin //+++++ rts
                    inc(r.contador,16);
                    r.pc.wh:=ll.getword(r.sp.l);
                    r.pc.wl:=ll.getword(r.sp.l+2);
                    inc(r.sp.l,4);
                  end;
              $37:begin //++++++ rtr
                    inc(r.contador,20);
                    poner_band(r,ll.getword(r.sp.l));
                    r.pc.wh:=ll.getword(r.sp.l+2);
                    r.pc.wl:=ll.getword(r.sp.l+4);
                    inc(r.sp.l,6);
                  end
                else MessageDlg('Instruccion $4b - $39 desconocida - '+inttostr(instruccion and $3f)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
              end;
          $3a:begin //jsr
                inc(r.contador,12);
                templ:=leerdir_ea(r,ll,dir);
                dec(r.sp.l,4);
                ll.putword(r.sp.l,r.pc.wh);
                ll.putword(r.sp.l+2,r.pc.wl);
                r.pc.l:=templ;
              end;
          $3b:begin //jmp
                inc(r.contador,4);
                r.pc.l:=leerdir_ea(r,ll,dir);
              end;
          else MessageDlg('Instruccion $4: '+inttostr((instruccion shr 6) and $3f)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
      end;
   $5:if (instruccion shr 3) and $1f=$19 then begin //++++++ DBcc
          inc(r.contador,12);
          if not(condicion(r,(instruccion shr 8) and $7)) then begin
            tempb:=instruccion and $7;
            r.d[tempb].wl:=r.d[tempb].wl-1;
            if r.d[tempb].wl<>$FFFF then begin
              dec(r.contador,2);
              tempw:=ll.getword(r.pc.l);
              if ((tempw and $8000)<>0) then dec(r.pc.l,(65536-tempw))
                else inc(r.pc.l,tempw);
            end else begin
              inc(r.pc.l,2);
              inc(r.contador,2);
            end;
          end else inc(r.pc.l,2);
      end else if (instruccion shr 6) and $3=$3 then begin
          if condicion(r,(instruccion shr 8) and $7) then ponerdir_b(r,ll,dir,$ff,false,true)
            else ponerdir_b(r,ll,dir,0,false,true);
      end else begin
          if ((instruccion shr 8) and 1)=1 then begin
            tempb:=(instruccion shr 9) and $7;
            if tempb=0 then tempb:=8;
            case (instruccion shr 6) and $3 of
              0:begin  //++++++++++++ subq.b
                  if (dir shr 3)<>0 then inc(r.contador,8)
                    else inc(r.contador,4);
                  if (dir shr 3)<>1 then begin
                    tempb2:=leerdir_b(r,ll,dir,true);
                    tempw:=tempb2-tempb;
                    ponerdir_b(r,ll,dir,(tempw and $ff),true,false);
                    r.cc.n:=(tempw and $80)<>0;
    	              r.cc.z:=((tempw and $ff)=0);
                    r.cc.c:=(tempw and $100)<>0;
                    r.cc.x:=r.cc.c;
                    r.cc.v:=(((tempb xor tempb2) and (tempw xor tempb2)) and $80)<>0;
                  end else begin
                    MessageDlg('Instruccion subq.b error AX '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                  end;
                end;
              1:begin  //++++++++++++ subq.w
                  if (dir shr 3)<>0 then inc(r.contador,8)
                    else inc(r.contador,4);
                  if (dir shr 3)<>1 then begin
                    tempw:=leerdir_w(r,ll,dir,true);
                    templ:=tempw-tempb;
                    ponerdir_w(r,ll,dir,(templ and $ffff),true,false);
                    r.cc.n:=(templ and $8000)<>0;
    	              r.cc.z:=((templ and $ffff)=0);
                    r.cc.c:=(templ and $10000)<>0;
                    r.cc.x:=r.cc.c;
                    r.cc.v:=((((tempb xor tempw) and (templ xor tempw)) shr 8) and $80)<>0;
                  end else begin
                    r.a[dir and $7].l:=r.a[dir and $7].l-tempb;
                  end;
               end;
              2:begin  //++++++++++++ subq.l
                  inc(r.contador,8);
                  if (((dir shr 3)<>0) or ((dir shr 3)<>1)) then inc(r.contador,12)
                    else inc(r.contador,8);
                  if (dir shr 3)<>1 then begin
                    templ2:=leerdir_l(r,ll,dir,true);
                    templ:=templ2-tempb;
                    ponerdir_l(r,ll,dir,templ,true,false);
                    r.cc.n:=((templ shr 24) and $80)<>0;
      	            r.cc.z:=(templ=0);
	                  r.cc.v:=((((tempb xor templ2) and (templ xor templ2)) shr 24) and $80)<>0;
	                  r.cc.c:=((((tempb and templ) or (not(templ2) and (tempb or templ))) shr 23) and $100)<>0;
                    r.cc.x:=r.cc.c;
                  end else begin
                    r.a[dir and $7].l:=r.a[dir and $7].l-tempb;
                  end;
               end;
          end;
        end else begin
          tempb:=(instruccion shr 9) and $7;
          if tempb=0 then tempb:=8;
          case (instruccion shr 6) and $3 of
            0:begin //addq.b
                if (dir shr 3)<>0 then inc(r.contador,8)
                  else inc(r.contador,4);
                if (dir shr 3)<>1 then begin
                  tempb2:=leerdir_b(r,ll,dir,true);
                  tempw:=tempb+tempb2;
                  ponerdir_b(r,ll,dir,(tempw and $ff),true,false);
                  r.cc.n:=(tempw and $80)<>0;
    	            r.cc.z:=((tempw and $ff)=0);
                  r.cc.c:=(tempw and $100)<>0;
                  r.cc.x:=r.cc.c;
                  r.cc.v:=(((tempb xor tempw) and (tempb2 xor tempw)) and $80)<>0;
                end else begin
                  MessageDlg('Instruccion addq.b error AX '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                end;
              end;
            1:begin //addq.w
                if (((dir shr 3)<>0) or ((dir shr 3)<>1)) then inc(r.contador,8)
                  else inc(r.contador,4);
                if (dir shr 3)<>1 then begin
                  tempw:=leerdir_w(r,ll,dir,true);
                  templ:=tempw+tempb;
                  ponerdir_w(r,ll,dir,(templ and $ffff),true,false);
                  r.cc.n:=(templ and $8000)<>0;
    	            r.cc.z:=((templ and $ffff)=0);
                  r.cc.c:=(templ and $10000)<>0;
                  r.cc.x:=r.cc.c;
                  r.cc.v:=((((tempb xor templ) and (tempw xor templ)) shr 8) and $80)<>0;
                end else begin
                  r.a[dir and $7].l:=r.a[dir and $7].l+tempb;
                end;
              end;
            2:begin //addq.l
                if (((dir shr 3)<>0) or ((dir shr 3)<>1)) then inc(r.contador,12)
                  else inc(r.contador,8);
                if (dir shr 3)<>1 then begin
                  templ:=leerdir_l(r,ll,dir,true);
                  templ2:=templ+tempb;
                  ponerdir_l(r,ll,dir,templ2,true,false);
                  r.cc.n:=((templ shr 24) and $80)<>0;
    	            r.cc.z:=(templ=0);
                  r.cc.c:=((((tempb and templ2) or (not(templ) and (tempb or templ2))) shr 23) and $100)<>0;
                  r.cc.x:=r.cc.c;
                  r.cc.v:=((((tempb xor templ2) and (templ xor templ2)) shr 24) and $80)<>0;
                end else begin
                  r.a[dir and $7].l:=r.a[dir and $7].l+tempb;
                end;
              end;
          end;
        end;
      end;
   $6:begin
        case (instruccion shr 8) and $f of
          0:begin  //+++++ BRA
              inc(r.contador,10);
              tempb:=instruccion and $FF;
              if tempb=0 then begin //desplazamiento 16bits
                tempw:=ll.getword(r.pc.l);
                if ((tempw and $8000)<>0) then dec(r.pc.l,(65536-tempw))
                    else inc(r.pc.l,tempw);
              end else begin //desplazamiento 8bits
                if ((tempb and $80)<>0) then dec(r.pc.l,(256-tempb))
                     else inc(r.pc.l,tempb);
              end;
            end;
          1:begin  //+++++ BSR
              tempb:=instruccion and $FF;
              inc(r.contador,18);
              if tempb=0 then begin //desplazamiento 16bits
                tempw:=ll.getword(r.pc.l);
                dec(r.sp.l,4);
                ll.putword(r.sp.l,(r.pc.l+2) shr 16);
                ll.putword(r.sp.l+2,(r.pc.l+2) and $FFFF);
                if ((tempw and $8000)<>0) then dec(r.pc.l,(65536-tempw))
                    else inc(r.pc.l,tempw);
              end else begin //desplazamiento 8bits
                dec(r.sp.l,4);
                ll.putword(r.sp.l,r.pc.l shr 16);
                ll.putword(r.sp.l+2,r.pc.l and $FFFF);
                if ((tempb and $80)<>0) then dec(r.pc.l,(256-tempb))
                     else inc(r.pc.l,tempb);
              end;
            end
          else if condicion(r,(instruccion shr 8) and $f) then begin  //++++++ Bcc
                inc(r.contador,10);
                tempb:=(instruccion and $ff);
                if tempb=0 then begin  //desplazamiento de 16bits
                  tempw:=ll.getword(r.pc.l);
                  if ((tempw and $8000)<>0) then dec(r.pc.l,(65536-tempw))
                    else inc(r.pc.l,tempw);
                end else begin  //desplazamiento de 8bits
                  if ((tempb and $80)<>0) then dec(r.pc.l,(256-tempb))
                     else inc(r.pc.l,tempb);
                end;
          end else begin //sino hace el salto comprobar si hay 16bits de desplazamiento
              inc(r.contador,8);
              tempb:=(instruccion and $ff);
              if tempb=0 then inc(r.pc.l,2);
          end;
        end;
      end;
   $7:begin //+++++++++++++++++ moveq
        inc(r.contador,4);
        tempb:=(instruccion shr 9) and $7;
        tempb2:=(instruccion and $ff);
        if (tempb2 and $80)<>0 then r.d[tempb].l:=$FFFFFF00 or tempb2
          else r.d[tempb].l:=tempb2;
        r.cc.c:=false;
        r.cc.v:=false;
        r.cc.z:=(r.d[tempb].l=0);
        r.cc.n:=((r.d[tempb].l shr 24) and $80)<>0;
      end;
   $8:if ((instruccion shr 4) and $1f)=$10 then begin //+++++ sbcd
        if ((instruccion shr 3) and 1)=1 then begin
          MessageDlg('Instruccion sbcd con ''1''. '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
          inc(r.contador,18);
        end else begin
          inc(r.contador,6);
          tempb:=r.d[(instruccion shr 9) and $7].l0;
          tempb2:=r.d[instruccion and $7].l0;
        end;
        if r.cc.x then tempw:=(tempb and $f)-(tempb2 and $f)-1
          else tempw:=(tempb and $f)-(tempb2 and $f);
        r.cc.v:=false;
        if tempw>9 then tempw:=tempw-6;
        tempw:=(tempw and $ff)+(tempb and $f0)-(tempb2 and $f0);
        if ((tempw and $ff)>$99) then begin
          tempw:=tempw+$a0;
          r.cc.x:=true;
          r.cc.c:=true;
          r.cc.n:=true;
        end else begin
          r.cc.n:=false;
          r.cc.x:=false;
          r.cc.c:=false;
        end;
        if ((instruccion shr 3) and 1)=1 then begin
            halt(0);
        end else r.d[(instruccion shr 9) and $7].l0:=tempw and $ff;
      end else begin
        if ((instruccion shr 6) and 3)=3 then begin
          case (instruccion shr 8) and 1 of
            0:begin  //++++++ divu (siempre es w)
                inc(r.contador,140);
                tempw:=leerdir_w(r,ll,dir,true);
                if tempw<>0 then begin
                  templ:=r.d[(instruccion shr 9) and 7].l div tempw;
                  if(templ<$10000) then begin
              			r.cc.z:=(templ<>0);
                    r.cc.n:=(templ and $8000)<>0;
              			r.cc.v:=false;
              			r.cc.c:=false;
                    templ2:=r.d[(instruccion shr 9) and 7].l mod tempw;
                    templ3:=(templ and $ffff) or ((templ2 and $ffff) shl 16);
                    r.d[(instruccion shr 9) and 7].l:=templ3;
                  end else begin
                    r.cc.v:=true;
                  end;
                end else begin
                  MessageDlg('Mierda! Division por 0'+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                end;
              end;
            1:begin //divs
                inc(r.contador,158);
                tempw:=leerdir_w(r,ll,dir,true);
                if (tempw and $8000)<>0 then MessageDlg('Divs! Divisior >$8000'+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                if tempw<>0 then begin
                  templ:=r.d[(instruccion shr 9) and 7].l;
                  if(templ and $80000000)<>0 then begin
                    templ:=$100000000-templ;
                    templ2:=$100000000-(templ div tempw);
                    templ3:=$100000000-(templ mod tempw);
                    if (templ2 shr 16)<>$FFFF then r.cc.v:=true
                      else r.cc.v:=false;
                  end else begin
                    templ2:=templ div tempw;
                    templ3:=templ mod tempw;
                    if (templ2 shr 16)<>0 then r.cc.v:=true
                      else r.cc.v:=false;
                  end;
                  if not(r.cc.v) then begin //no hay overflow!
              			r.cc.z:=(templ2<>0);
                    r.cc.n:=(templ2 and $8000)<>0;
              			r.cc.c:=false;
                    r.d[(instruccion shr 9) and 7].l:=(templ2 and $ffff) or ((templ3 and $ffff) shl 16);
                  end;
                end else begin
                  MessageDlg('Mierda! Division por 0'+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                end;
              end;
          end;
        end else begin //++++  or
          case (instruccion shr 6) and 3 of
            0:begin //++++ or.b
                if ((instruccion shr 8) and 1)=1 then begin
                  inc(r.contador,8);
                  tempb:=r.d[(instruccion shr 9) and 7].l0;
                  tempb2:=leerdir_b(r,ll,dir,true) or tempb;
                  ponerdir_b(r,ll,dir,tempb2,true,false);
                end else begin
                  inc(r.contador,4);
                  tempb:=leerdir_b(r,ll,dir,true);
                  tempb2:=r.d[(instruccion shr 9) and 7].l0 or tempb;
                  r.d[(instruccion shr 9) and 7].l0:=tempb2;
                end;
                r.cc.n:=(tempb2 and $80)<>0;
              	r.cc.z:=(tempb2=0);
              	r.cc.c:=false;
              	r.cc.v:=false;
              end;
            1:begin //++++ or.w
                if ((instruccion shr 8) and 1)=1 then begin
                  inc(r.contador,8);
                  tempw:=r.d[(instruccion shr 9) and 7].wl;
                  tempw2:=leerdir_w(r,ll,dir,true) or tempw;
                  ponerdir_w(r,ll,dir,tempw2,true,false);
                end else begin
                  inc(r.contador,4);
                  tempw:=leerdir_w(r,ll,dir,true);
                  tempw2:=r.d[(instruccion shr 9) and 7].wl or tempw;
                  r.d[(instruccion shr 9) and 7].wl:=tempw2;
                end;
                r.cc.n:=(tempw2 and $8000)<>0;
              	r.cc.z:=(tempw2=0);
              	r.cc.c:=false;
              	r.cc.v:=false;
              end;
            2:begin //++++ or.l
                if ((instruccion shr 8) and 1)=1 then begin
                  inc(r.contador,12);
                  templ:=r.d[(instruccion shr 9) and 7].l;
                  templ2:=leerdir_l(r,ll,dir,true) or templ;
                  ponerdir_l(r,ll,dir,templ2,true,false);
                end else begin
                  inc(r.contador,6);
                  templ:=leerdir_l(r,ll,dir,true);
                  templ2:=r.d[(instruccion shr 9) and 7].l or templ;
                  r.d[(instruccion shr 9) and 7].l:=templ2;
                end;
                r.cc.n:=((templ2 shr 24) and $80)<>0;
              	r.cc.z:=(templ2=0);
              	r.cc.c:=false;
              	r.cc.v:=false;
              end;
          end;
        end;
      end;
   $9:if (instruccion shr 6) and $3=$3 then begin
        case (instruccion shr 8) and 1 of
          0:begin //++++ suba.w
              inc(r.contador,8);
              tempw:=leerdir_w(r,ll,dir,true);
              if (tempw and $8000)<>0 then r.a[(instruccion shr 9) and $7].l:=r.a[(instruccion shr 9) and $7].l+($10000-tempw)
                else r.a[(instruccion shr 9) and $7].l:=r.a[(instruccion shr 9) and $7].l-tempw;
            end;
          1:begin //++++ suba.l
              inc(r.contador,6);
              r.a[(instruccion shr 9) and $7].l:=r.a[(instruccion shr 9) and $7].l-leerdir_l(r,ll,dir,true);
            end;
        end;
      end else begin
        if ((((instruccion shr 8) and 1) shl 2) or ((instruccion shr 4) and 3))=$4 then begin
          case (instruccion shr 6) and $3 of
            0:begin   //  subx.b
                inc(r.contador,4);
                if ((instruccion shr 3) and 1)=0 then begin
                  tempb:=r.d[instruccion and $7].l0;
                  tempb2:=r.d[(instruccion shr 9) and $7].l0;
                  if r.cc.x then tempw:=tempb2-tempb-1
                    else tempw:=tempb2-tempb;
                  r.d[(instruccion shr 9) and $7].l0:=tempw and $ff;
                  r.cc.n:=(tempw and $80)<>0;
                  r.cc.c:=(tempw and $100)<>0;
                  r.cc.x:=r.cc.c;
                  r.cc.v:=(((tempb xor tempb2) and (tempw xor tempb2)) and $80)<>0;
                  r.cc.z:=(tempw and $ff)=0;
                end else begin
                  inc(r.contador,18);
                  MessageDlg('Instruccion subx.b postdec '+inttostr((instruccion shr 6) and $3)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                end;
              end;
            else MessageDlg('Instruccion $9. subx '+inttostr((instruccion shr 6) and $3)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
          end;
        end else begin
          case (instruccion shr 6) and 3 of
            0:begin //++++ sub.b
                 if ((instruccion shr 8) and 1)=1 then begin
                    inc(r.contador,8);
                    tempb:=r.d[(instruccion shr 9) and 7].l0;
                    tempb2:=leerdir_b(r,ll,dir,true);
                    tempw:=tempb2-tempb;
                    ponerdir_b(r,ll,dir,tempw and $ff,true,false);
                 end else begin
                    inc(r.contador,4);
                    tempb:=leerdir_b(r,ll,dir,true);
                    tempb2:=r.d[(instruccion shr 9) and 7].l0;
                    tempw:=tempb2-tempb;
                    r.d[(instruccion shr 9) and 7].l0:=tempw and $ff;
                 end;
                 r.cc.n:=(tempw and $80)<>0;
                 r.cc.c:=(tempw and $100)<>0;
                 r.cc.x:=r.cc.c;
                 r.cc.v:=(((tempb xor tempb2) and (tempw xor tempb2)) and $80)<>0;
                 r.cc.z:=(tempw and $ff)=0;
              end;
            1:begin //++++ sub.w
                 if ((instruccion shr 8) and 1)=1 then begin
                   inc(r.contador,8);
                   tempw:=r.d[(instruccion shr 9) and 7].wl;
                   tempw2:=leerdir_w(r,ll,dir,true);
                   templ:=tempw2-tempw;
                   ponerdir_w(r,ll,dir,templ and $ffff,true,false)
                 end else begin
                   inc(r.contador,4);
                   tempw:=leerdir_w(r,ll,dir,true);
                   tempw2:=r.d[(instruccion shr 9) and 7].wl;
                   templ:=tempw2-tempw;
                   r.d[(instruccion shr 9) and 7].wl:=templ and $ffff;
                 end;
                 r.cc.n:=(templ and $8000)<>0;
                 r.cc.c:=(templ and $10000)<>0;
                 r.cc.x:=r.cc.c;
                 r.cc.v:=((((tempw xor tempw2) and (templ xor tempw2)) shr 8) and $80)<>0;
                 r.cc.z:=(templ and $ffff)=0;
              end;
            2:begin //++++ sub.l
                 if ((instruccion shr 8) and 1)=1 then begin
                   inc(r.contador,12);
                   templ:=r.d[(instruccion shr 9) and 7].l;
                   templ2:=leerdir_l(r,ll,dir,true);
                   templ3:=templ2-templ;
                   ponerdir_l(r,ll,dir,templ3,true,false)
                 end else begin
                   inc(r.contador,6);
                   templ:=leerdir_l(r,ll,dir,true);
                   templ2:=r.d[(instruccion shr 9) and 7].l;
                   templ3:=templ2-templ;
                   r.d[(instruccion shr 9) and 7].l:=templ3;
                 end;
                 r.cc.n:=((templ3 shr 24) and $80)<>0;
                 r.cc.z:=(templ3=0);
                 r.cc.v:=((((templ xor templ2) and (templ3 xor templ2)) shr 24) and $80)<>0;
                 r.cc.c:=((((templ and templ3) or (not(templ2) and (templ or templ3))) shr 23) and $100)<>0;
              end;
          end;
        end;
      end;
   $b:if ((instruccion shr 6) and $3)=$3 then begin
        case (instruccion shr 8) and 1 of
           0:begin //+++++cmpa.w
                inc(r.contador,6);
                tempw:=leerdir_w(r,ll,dir,true);
                if (tempw and $8000)<>0 then templ:=$ffff0000 or tempw
                  else templ:=tempw;
                templ2:=r.a[(instruccion shr 9) and $7].l;
                templ3:=templ2-templ;
                r.cc.n:=((templ3 shr 24) and $80)<>0;
	              r.cc.z:=(templ3=0);
  	            r.cc.v:=((((templ xor templ2) and (templ3 xor templ2)) shr 24) and $80)<>0;
	              r.cc.c:=((((templ and templ3) or (not(templ2) and (templ or templ3))) shr 23) and $100)<>0;
              end;
          1:begin //+++++cmpa.l
              inc(r.contador,6);
              templ:=leerdir_l(r,ll,dir,true);
              templ2:=r.a[(instruccion shr 9) and $7].l;
              templ3:=templ2-templ;
              r.cc.n:=((templ3 shr 24) and $80)<>0;
	            r.cc.z:=(templ3=0);
	            r.cc.v:=((((templ xor templ2) and (templ3 xor templ2)) shr 24) and $80)<>0;
	            r.cc.c:=((((templ and templ3) or (not(templ2) and (templ or templ3))) shr 23) and $100)<>0;
             end;
        end;
      end else if ((instruccion shr 8) and 1)=0 then begin
                  case (instruccion shr 6) and 3 of
                    0:begin //+++++++ cmp.b
                        inc(r.contador,4);
                        tempb:=leerdir_b(r,ll,dir,true);
                        tempb2:=r.d[(instruccion shr 9) and $7].l0;
                        tempw:=tempb2-tempb;
                        r.cc.n:=(tempw and $80)<>0;
        	              r.cc.z:=((tempw and $ff)=0);
        	              r.cc.v:=(((tempb xor tempb2) and (tempw xor tempb2)) and $80)<>0;
	                      r.cc.c:=(tempw and $100)<>0;
                      end;
                    1:begin //+++++++ cmp.w
                        inc(r.contador,4);
                        tempw:=leerdir_w(r,ll,dir,true);
                        tempw2:=r.d[(instruccion shr 9) and $7].wl;
                        templ:=tempw2-tempw;
                        r.cc.n:=(templ and $8000)<>0;
	                      r.cc.z:=((templ and $ffff)=0);
	                      r.cc.v:=((((tempw xor tempw2) and (templ xor tempw2)) shr 8) and $80)<>0;
        	              r.cc.c:=(templ and $10000)<>0;
                      end;
                    2:begin //++++++ cmp.l
                        inc(r.contador,6);
                        templ:=leerdir_l(r,ll,dir,true);
                        templ2:=r.d[(instruccion shr 9) and $7].l;
                        templ3:=templ2-templ;
                        r.cc.n:=((templ3 shr 24) and $80)<>0;
	                      r.cc.z:=(templ3=0);
          	            r.cc.v:=((((templ xor templ2) and (templ3 xor templ2)) shr 24) and $80)<>0;
	                      r.cc.c:=((((templ and templ3) or (not(templ2) and (templ or templ3))) shr 23) and $100)<>0;
                      end;
                  end;
               end else if ((instruccion shr 3) and $7)=1 then begin
                          case (instruccion shr 6) and 3 of
                            1:begin //+++++++ cmpm.w
                                inc(r.contador,12);
                                tempw:=ll.getword(r.a[instruccion and $7].l);
                                inc(r.a[instruccion and $7].l,2);
                                tempw2:=ll.getword(r.a[(instruccion shr 9) and $7].l);
                                inc(r.a[(instruccion shr 9) and $7].l,2);
                                templ:=tempw2-tempw;
                                r.cc.n:=(templ and $8000)<>0;
        	                      r.cc.z:=((templ and $ffff)=0);
        	                      r.cc.v:=((((tempw xor tempw2) and (templ xor tempw2)) shr 8) and $80)<>0;
                	              r.cc.c:=(templ and $10000)<>0;
                              end;
                            else MessageDlg('Instruccion cmpm. '+inttostr(r.pc.l)+' - '+inttostr((instruccion shr 6) and 3), mtInformation,[mbOk], 0);
                          end;
                        end else begin
                          case (instruccion shr 6) and 3 of
                             0:begin  //eor.b
                                 if (dir shr 3)<>0 then inc(r.contador,8)
                                    else inc(r.contador,4);
                                 tempb:=leerdir_b(r,ll,dir,true);
                                 tempb2:=tempb xor r.d[(instruccion shr 9) and 7].l0;
                                 ponerdir_b(r,ll,dir,tempb2,true,false);
                                 r.cc.n:=(tempb2 and $80)<>0;
                                 r.cc.z:=(tempb2=0);
	                               r.cc.v:=false;
        	                       r.cc.c:=false;
                              end;
                            1:begin  //eor.w
                                 if (dir shr 3)<>0 then inc(r.contador,8)
                                    else inc(r.contador,4);
                                 tempw:=leerdir_w(r,ll,dir,true);
                                 tempw2:=tempw xor r.d[(instruccion shr 9) and 7].wl;
                                 ponerdir_w(r,ll,dir,tempw2,true,false);
                                 r.cc.n:=(tempw2 and $8000)<>0;
                                 r.cc.z:=(tempw2=0);
	                               r.cc.v:=false;
        	                       r.cc.c:=false;
                              end;
                            else MessageDlg('Instruccion eor. '+inttostr(r.pc.l)+' - '+inttostr((instruccion shr 6) and 3), mtInformation,[mbOk], 0);
                          end;
                       end;
   $c:if (instruccion shr 4) and $1f=$10 then begin //+++++ abcd
        if ((instruccion shr 3) and 1)=1 then begin //con predecremento
          dec(r.a[instruccion and $7].l);
          tempb:=ll.getbyte(r.a[instruccion and $7].l);
          dec(r.a[(instruccion shr 9) and $7].l);
          tempb2:=ll.getbyte(r.a[(instruccion shr 9) and $7].l);
          inc(r.contador,18);
        end else begin  //data
          inc(r.contador,6);
          tempb:=r.d[instruccion and $7].l0;
          tempb2:=r.d[(instruccion shr 9) and $7].l0;
        end;
        if r.cc.x then tempw:=(tempb and $f)+(tempb2 and $f)+1
          else tempw:=(tempb and $f)+(tempb2 and $f);
        r.cc.v:=(tempw and $80)<>0;
      	if (tempw>9) then tempw:=tempw+6;
      	tempw:=(tempw and $ff)+(tempb and $f0)+(tempb2 and $f0);
        r.cc.c:=((tempw and $ff)>$99);
        r.cc.x:=r.cc.c;
      	if r.cc.c then tempw:=tempw-$a0;
        r.cc.v:=r.cc.v and ((tempw and $80)<>0);
	      r.cc.n:=(tempw and $80)<>0;
        r.cc.z:=(tempw and $ff)=0;
        if ((instruccion shr 3) and 1)=1 then ll.putbyte(r.a[(instruccion shr 9) and $7].l,tempw and $ff)
         else r.d[(instruccion shr 9) and $7].l0:=tempw and $ff;
      end else begin
        if (instruccion shr 6) and 3=3 then begin
          case (instruccion shr 8) and 1 of
            0:begin  //++++++ mulu
                inc(r.contador,54);
                tempw:=leerdir_w(r,ll,dir,true);
                tempw2:=r.d[(instruccion shr 9) and 7].wl;
                templ:=tempw*tempw2;
                r.d[(instruccion shr 9) and 7].l:=templ;
                r.cc.z:=(templ=0);
              	r.cc.n:=((templ shr 24) and $80)<>0;
                r.cc.v:=false;
                r.cc.c:=false;
              end;
            1:begin  //+++++++  muls
                inc(r.contador,54);
                tempw:=leerdir_w(r,ll,dir,true);
                if (templ2 and $8000)<>0 then templ2:=$FFFF0000 or tempw
                  else templ2:=tempw;
                tempw2:=r.d[(instruccion shr 9) and 7].wl;
                if (tempw2 and $8000)<>0 then templ3:=$FFFF0000 or tempw2
                  else templ3:=tempw2;
                templ:=(templ2*templ3);
                r.d[(instruccion shr 9) and 7].l:=templ;
                r.cc.z:=(templ=0);
              	r.cc.n:=((templ shr 24) and $80)<>0;
                r.cc.v:=false;
                r.cc.c:=false;
              end;
          end;
        end else begin
          if ((((instruccion shr 8) and 1) shl 2)  or ((instruccion shr 4) and 3))=4 then begin
            //++++ exg
            inc(r.contador,6);
            case (instruccion shr 3) and $1f of
              $8:begin //DX y DX
                    templ:=r.d[(instruccion shr 9) and $7].l; //RX
                    templ2:=r.d[instruccion and $7].l; //RY;
                    r.d[(instruccion shr 9) and $7].l:=templ2;
                    r.d[instruccion and $7].l:=templ;
                 end;
              $9:begin //AX y AX
                    templ:=r.a[(instruccion shr 9) and $7].l; //RX
                    templ2:=r.a[instruccion and $7].l; //RY;
                    r.a[(instruccion shr 9) and $7].l:=templ2;
                    r.a[instruccion and $7].l:=templ;
                 end;
              $11:begin //DX y AX
                    templ:=r.d[(instruccion shr 9) and $7].l; //RX
                    templ2:=r.a[instruccion and $7].l; //RY;
                    r.d[(instruccion shr 9) and $7].l:=templ2;
                    r.a[instruccion and $7].l:=templ;
                  end;
            end;
          end else begin
            case (instruccion shr 6) and 3 of
              0:begin //++++ and.b
                  if ((instruccion shr 8) and 1)=1 then begin
                    inc(r.contador,8);
                    tempb:=r.d[(instruccion shr 9) and 7].l0;
                    tempb2:=leerdir_b(r,ll,dir,true) and tempb;
                    ponerdir_b(r,ll,dir,tempb2,true,false);
                  end else begin
                    inc(r.contador,4);
                    tempb:=leerdir_b(r,ll,dir,true);
                    tempb2:=r.d[(instruccion shr 9) and 7].l0 and tempb;
                    r.d[(instruccion shr 9) and 7].l0:=tempb2;
                  end;
                  r.cc.n:=(tempb2 and $80)<>0;
                	r.cc.z:=(tempb2=0);
                	r.cc.c:=false;
                	r.cc.v:=false;
               end;
              1:begin //++++ and.w
                  if ((instruccion shr 8) and 1)=1 then begin
                    inc(r.contador,8);
                    tempw:=r.d[(instruccion shr 9) and 7].wl;
                    tempw2:=leerdir_w(r,ll,dir,true) and tempw;
                    ponerdir_w(r,ll,dir,tempw2,true,false);
                  end else begin
                    inc(r.contador,4);
                    tempw:=leerdir_w(r,ll,dir,true);
                    tempw2:=r.d[(instruccion shr 9) and 7].wl and tempw;
                    r.d[(instruccion shr 9) and 7].wl:=tempw2;
                  end;
                  r.cc.n:=(tempw2 and $8000)<>0;
                	r.cc.z:=(tempw2=0);
                	r.cc.c:=false;
                	r.cc.v:=false;
               end;
              2:begin //++++ and.l
                  if ((instruccion shr 8) and 1)=1 then begin
                    inc(r.contador,12);
                    templ:=r.d[(instruccion shr 9) and 7].l;
                    templ2:=leerdir_l(r,ll,dir,true) and templ;
                    ponerdir_l(r,ll,dir,templ2,true,false);
                  end else begin
                    inc(r.contador,6);
                    templ:=leerdir_l(r,ll,dir,true);
                    templ2:=r.d[(instruccion shr 9) and 7].l and templ;
                    r.d[(instruccion shr 9) and 7].l:=templ2;
                  end;
                  r.cc.n:=((templ2 shr 24) and $80)<>0;
                	r.cc.z:=(templ2=0);
                	r.cc.c:=false;
                	r.cc.v:=false;
               end;
            end;
          end;
        end;
      end;
   $d:if (instruccion shr 6) and $3=$3 then begin
        case (instruccion shr 8) and 1 of
          0:begin //++++ adda.w
              inc(r.contador,8);
              tempw:=leerdir_w(r,ll,dir,true);
              if (tempw and $8000)<>0 then r.a[(instruccion shr 9) and $7].l:=r.a[(instruccion shr 9) and $7].l-($10000-tempw)
                else r.a[(instruccion shr 9) and $7].l:=tempw+r.a[(instruccion shr 9) and $7].l;
            end;
          1:begin //++++ adda.l
              inc(r.contador,6);
              r.a[(instruccion shr 9) and $7].l:=r.a[(instruccion shr 9) and $7].l+leerdir_l(r,ll,dir,true);
            end;
        end;
      end else begin
        if ((((instruccion shr 8) and 1) shl 2) or ((instruccion shr 4) and 3))=$4 then begin
          case (instruccion shr 6) and 3 of
            0:begin //addx.b
                if ((instruccion shr 3) and 1)=0 then begin
                  inc(r.contador,4);
                  tempb:=r.d[instruccion and $7].l0;
                  tempb2:=r.d[(instruccion shr 9) and $7].l0;
                  if r.cc.x then tempw:=1+tempb+tempb2
                    else tempw:=tempb+tempb2;
                  r.d[(instruccion shr 9) and $7].l0:=tempw and $ff;
                end else begin
                  inc(r.contador,18);
                  MessageDlg('Instruccion addx.b postdec '+inttostr((instruccion shr 6) and $3)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                end;
                r.cc.n:=(tempw and $80)<>0;
                r.cc.z:=((tempw and $ff)=0);
	              r.cc.v:=((((tempb xor tempw) and (tempb2 xor tempw))) and $80)<>0;
                r.cc.c:=(tempw and $100)<>0;
	              r.cc.x:=r.cc.c;
              end;
            1:begin  //+++++ addx.w
                if ((instruccion shr 3) and 1)=0 then begin
                  inc(r.contador,4);
                  tempw:=r.d[instruccion and $7].wl;
                  tempw2:=r.d[(instruccion shr 9) and $7].wl;
                  if r.cc.x then templ:=1+tempw+tempw2
                    else templ:=tempw+tempw2;
                  r.d[(instruccion shr 9) and $7].wl:=templ and $ffff;
                end else begin
                  inc(r.contador,18);
                  MessageDlg('Instruccion addx.w postdec '+inttostr((instruccion shr 6) and $3)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                end;
                r.cc.n:=(templ and $8000)<>0;
                r.cc.z:=((templ and $ffff)=0);
	              r.cc.v:=((((tempw xor templ) and (tempw2 xor templ))) and $8000)<>0;
                r.cc.c:=(templ and $10000)<>0;
	              r.cc.x:=r.cc.c;
              end;
            else MessageDlg('Instruccion $d. addx '+inttostr((instruccion shr 6) and $3)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
          end;
        end else begin
          case (instruccion shr 6) and 3 of
            0:begin //++++ add.b
                if ((instruccion shr 8) and 1)=1 then begin
                  inc(r.contador,8);
                  tempb:=r.d[(instruccion shr 9) and $7].l0;
                  tempb2:=leerdir_b(r,ll,dir,true);
                  tempw:=tempb+tempb2;
                  ponerdir_b(r,ll,dir,tempw and $ff,true,false)
                end else begin
                  inc(r.contador,4);
                  tempb:=leerdir_b(r,ll,dir,true);
                  tempb2:=r.d[(instruccion shr 9) and $7].l0;
                  tempw:=tempb+tempb2;
                  r.d[(instruccion shr 9) and $7].l0:=tempw and $ff;
                end;
                r.cc.n:=(tempw and $80)<>0;
                r.cc.z:=((tempw and $ff)=0);
	              r.cc.v:=((((tempb xor tempw) and (tempb2 xor tempw))) and $80)<>0;
                r.cc.c:=(tempw and $100)<>0;
	              r.cc.x:=r.cc.c;
              end;
            $1:begin // ++++++ add.w
                if ((instruccion shr 8) and 1)=1 then begin
                  inc(r.contador,8);
                  tempw:=r.d[(instruccion shr 9) and $7].wl;
                  tempw2:=leerdir_w(r,ll,dir,true);
                  templ:=tempw+tempw2;
                  ponerdir_w(r,ll,dir,templ and $ffff,true,false)
                end else begin
                  inc(r.contador,4);
                  tempw:=leerdir_w(r,ll,dir,true);
                  tempw2:=r.d[(instruccion shr 9) and $7].wl;
                  templ:=tempw+tempw2;
                  r.d[(instruccion shr 9) and $7].wl:=templ and $ffff;
                end;
                r.cc.n:=(templ and $8000)<>0;
                r.cc.c:=(templ and $10000)<>0;
	              r.cc.x:=r.cc.c;
                r.cc.v:=((((tempw xor templ) and (tempw2 xor templ)) shr 8) and $80)<>0;
        	      r.cc.z:=((templ and $ffff)=0);
               end;
            $2:begin // +++++ add.l
                if ((instruccion shr 8) and 1)=1 then begin
                  inc(r.contador,12);
                  templ:=r.d[(instruccion shr 9) and $7].l;
                  templ2:=leerdir_l(r,ll,dir,true);
                  templ3:=templ+templ2;
                  ponerdir_l(r,ll,dir,templ3,true,false)
                end else begin
                  inc(r.contador,6);
                  templ:=leerdir_l(r,ll,dir,true);
                  templ2:=r.d[(instruccion shr 9) and $7].l;
                  templ3:=templ+templ2;
                  r.d[(instruccion shr 9) and $7].l:=templ3;
                end;
                r.cc.n:=((templ3 shr 24) and $80)<>0;
                r.cc.z:=(templ3=0);
	              r.cc.v:=((((templ xor templ3) and (templ2 xor templ3)) shr 24) and $80)<>0;
                r.cc.c:=((((templ and templ2) or (not(templ3) and (templ or templ2))) shr 23) and $100)<>0;
	              r.cc.x:=r.cc.c;
               end;
          end;
        end;
      end;
   $e:if (instruccion shr 6) and $3=$3 then begin
        case (instruccion shr 8) and $f of
               $3:begin  //lsl.w
                    inc(r.contador,8);
                    tempw:=leerdir_w(r,ll,dir,true);
                    r.cc.c:=(tempw and $8000)<>0;
                    tempw:=tempw shl 1;
                    ponerdir_w(r,ll,dir,tempw,true,false);
                    r.cc.n:=(tempw and $8000)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(tempw=0);
                    r.cc.x:=r.cc.c;
                 end;
               $4:begin //roxr.w
                    inc(r.contador,8);
                    tempw:=leerdir_w(r,ll,dir,true);
                    r.cc.c:=(tempw and $1)<>0;
                    tempw:=tempw shr 1;
                    if r.cc.x then tempw:=tempw or $8000;
                    r.cc.x:=r.cc.c;
                    ponerdir_w(r,ll,dir,tempw,true,false);
                    r.cc.n:=(tempw and $8000)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(tempw=0);
                 end;
          else MessageDlg('Instruccion $E ''11''. '+inttostr((instruccion shr 8) and $f)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
        end;
      end else begin
          if ((instruccion shr 5) and 1)=1 then tempb:=r.d[(instruccion shr 9)and 7].l0
            else tempb:=(instruccion shr 9) and $7;
          if tempb=0 then tempb:=8;
          inc(r.contador,tempb*2);
          case (instruccion shr $3) and $3f of
           $01,$05:begin //++++++ lsr.b
                    inc(r.contador,6);
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(r.d[dir and $7].l0 and 1)<>0;
                      r.d[dir and $7].l0:=r.d[dir and $7].l0 shr 1;
                    end;
                    r.cc.n:=false;
                    r.cc.v:=false;
                    r.cc.x:=r.cc.c;
                    r.cc.z:=(r.d[dir and $7].l0=0);
                 end;
         $02,$06:begin //roxr.b
                    inc(r.contador,6);
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(r.d[dir and $7].l0 and $1)<>0;
                      r.d[dir and $7].l0:=r.d[dir and $7].l0 shr 1;
                      if r.cc.x then r.d[dir and $7].l0:=r.d[dir and $7].l0 or $80;
                      r.cc.x:=r.cc.c;
                    end;
                    r.cc.n:=(r.d[dir and $7].l0 and $80)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(r.d[dir and $7].l0=0);
                 end;
         $03,$07:begin // +++++ ror.b
                  inc(r.contador,6);
                  for tempb2:=1 to tempb do begin
                    r.cc.c:=(r.d[dir and $7].l0 and 1)<>0;
                    r.d[dir and $7].l0:=r.d[dir and $7].l0 shr 1;
                    if r.cc.c then r.d[dir and $7].l0:=r.d[dir and $7].l0 or $80;
                  end;
                  r.cc.n:=(r.d[dir and $7].l0 and $80)<>0;
                  r.cc.v:=false;
                  r.cc.z:=(r.d[dir and $7].l0=0);
                end;
        $08,$0c:begin //+++++ asr.w
                    inc(r.contador,6);
                    r.cc.n:=(r.d[dir and $7].wl and $8000)<>0;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(r.d[dir and $7].wl and 1)<>0;
                      r.d[dir and $7].wl:=r.d[dir and $7].wl shr 1;
                      if r.cc.n then r.d[dir and $7].wl:=r.d[dir and $7].wl or $8000;
                    end;
                    r.cc.v:=false;
                    r.cc.x:=r.cc.c;
                    r.cc.z:=(r.d[dir and $7].wl=0)
                 end;
         $09,$0d:begin //++++++ lsr.w
                    inc(r.contador,6);
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(r.d[dir and $7].wl and 1)<>0;
                      r.d[dir and $7].wl:=r.d[dir and $7].wl shr 1;
                    end;
                    r.cc.n:=false;
                    r.cc.v:=false;
                    r.cc.x:=r.cc.c;
                    r.cc.z:=(r.d[dir and $7].wl=0);
                 end;
         $0a,$0e:begin //roxr.w
                    inc(r.contador,6);
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(r.d[dir and $7].wl and $1)<>0;
                      r.d[dir and $7].wl:=r.d[dir and $7].wl shr 1;
                      if r.cc.x then r.d[dir and $7].wl:=r.d[dir and $7].wl or $8000;
                      r.cc.x:=r.cc.c;
                    end;
                    r.cc.n:=(r.d[dir and $7].wl and $8000)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(r.d[dir and $7].wl=0);
                 end;
         $0b,$0f:begin  //++++ ror.w
                    inc(r.contador,6);
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(r.d[dir and $7].wl and 1)<>0;
                      r.d[dir and $7].wl:=r.d[dir and $7].wl shr 1;
                      if r.cc.c then r.d[dir and $7].wl:=r.d[dir and $7].wl or $8000;
                    end;
                    r.cc.n:=(r.d[dir and $7].wl and $8000)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(r.d[dir and $7].wl=0);
                 end;
         $10,$14:begin //++++++ asr.l
                    inc(r.contador,8);
                    r.cc.n:=(r.d[dir and $7].l and $80000000)<>0;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(r.d[dir and $7].l and 1)<>0;
                      r.d[dir and $7].l:=r.d[dir and $7].l shr 1;
                      if r.cc.n then r.d[dir and $7].l:=r.d[dir and $7].l or $80000000;
                    end;
                    r.cc.v:=false;
                    r.cc.x:=r.cc.c;
                    r.cc.z:=(r.d[dir and $7].l=0)
                 end;
         $11,$15:begin //++++++ lsr.l
                    inc(r.contador,8);
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(r.d[dir and $7].l and 1)<>0;
                      r.d[dir and $7].l:=r.d[dir and $7].l shr 1;
                    end;
                    r.cc.n:=false;
                    r.cc.v:=false;
                    r.cc.x:=r.cc.c;
                    r.cc.z:=(r.d[dir and $7].l=0);
                 end;
         $13,$17:begin //ror.l
                    inc(r.contador,8);
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(r.d[dir and $7].l and 1)<>0;
                      r.d[dir and $7].l:=r.d[dir and $7].l shr 1;
                      if r.cc.c then r.d[dir and $7].l:=r.d[dir and $7].l or $80000000;
                    end;
                    r.cc.n:=((r.d[dir and $7].l shr 24) and $80)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(r.d[dir and $7].l=0);
                 end;
         $21,$25:begin  //lsl.b
                    inc(r.contador,6);
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(r.d[dir and $7].l0 and $80)<>0;
                      r.d[dir and $7].l0:=r.d[dir and $7].l0 shl 1;
                    end;
                    r.cc.n:=(r.d[dir and $7].l0 and $80)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(r.d[dir and $7].l0=0);
                    r.cc.x:=r.cc.c;
                 end;
         $22,$26:begin //roxl.b
                    inc(r.contador,6);
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(r.d[dir and $7].l0 and $80)<>0;
                      r.d[dir and $7].l0:=r.d[dir and $7].l0 shl 1;
                      if r.cc.x then r.d[dir and $7].l0:=r.d[dir and $7].l0 or 1;
                      r.cc.x:=r.cc.c;
                    end;
                    r.cc.n:=(r.d[dir and $7].l0 and $80)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(r.d[dir and $7].l0=0);
                 end;
         $23,$27:begin //++++ rol.b
                    inc(r.contador,6);
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(r.d[dir and $7].l0 and $80)<>0;
                      r.d[dir and $7].l0:=r.d[dir and $7].l0 shl 1;
                      if r.cc.c then r.d[dir and $7].l0:=r.d[dir and $7].l0 or 1;
                    end;
                    r.cc.n:=(r.d[dir and $7].l0 and $80)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(r.d[dir and $7].l0=0);
                 end;
         $28,$2c:begin  //++++ asl.w
                    inc(r.contador,6);
                    r.cc.v:=false;
                    for tempb2:=1 to tempb do begin
                      //if r.cc.c<>((r.d[dir and $7].wl and $8000)<>0) then r.cc.v:=true;
                      r.cc.c:=(r.d[dir and $7].wl and $8000)<>0;
                      r.d[dir and $7].wl:=r.d[dir and $7].wl shl 1;
                    end;
                    r.cc.n:=(r.d[dir and $7].wl and $8000)<>0;
                    r.cc.z:=(r.d[dir and $7].wl=0);
                    r.cc.x:=r.cc.c;
                 end;
         $29,$2d:begin  //lsl.w
                    inc(r.contador,6);
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(r.d[dir and $7].wl and $8000)<>0;
                      r.d[dir and $7].wl:=r.d[dir and $7].wl shl 1;
                    end;
                    r.cc.n:=(r.d[dir and $7].wl and $8000)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(r.d[dir and $7].wl=0);
                    r.cc.x:=r.cc.c;
                 end;
         $2a,$2e:begin //roxl.w
                    inc(r.contador,6);
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(r.d[dir and $7].wl and $8000)<>0;
                      r.d[dir and $7].wl:=r.d[dir and $7].wl shl 1;
                      if r.cc.x then r.d[dir and $7].wl:=r.d[dir and $7].wl or 1;
                      r.cc.x:=r.cc.c;
                    end;
                    r.cc.n:=(r.d[dir and $7].wl and $8000)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(r.d[dir and $7].wl=0);
                 end;
         $2b,$2f:begin  //++++ rol.w
                    inc(r.contador,6);
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(r.d[dir and $7].wl and $8000)<>0;
                      r.d[dir and $7].wl:=r.d[dir and $7].wl shl 1;
                      if r.cc.c then r.d[dir and $7].wl:=r.d[dir and $7].wl or 1;
                    end;
                    r.cc.n:=(r.d[dir and $7].wl and $8000)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(r.d[dir and $7].wl=0);
                 end;
         $30,$34:begin  //++++ asl.l
                    inc(r.contador,8);
                    r.cc.v:=false;
                    for tempb2:=1 to tempb do begin
                      //if r.cc.c<>(((r.d[dir and $7].l shr 24) and $80)<>0) then r.cc.v:=true;
                      r.cc.c:=((r.d[dir and $7].l shr 24) and $80)<>0;
                      r.d[dir and $7].l:=r.d[dir and $7].l shl 1;
                    end;
                    r.cc.n:=((r.d[dir and $7].l shr 24) and $80)<>0;
                    r.cc.z:=(r.d[dir and $7].l=0);
                    r.cc.x:=r.cc.c;
                 end;
         $31,$35:begin  //++++ lsl.l
                    inc(r.contador,8);
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=((r.d[dir and $7].l shr 24) and $80)<>0;
                      r.d[dir and $7].l:=r.d[dir and $7].l shl 1;
                    end;
                    r.cc.n:=((r.d[dir and $7].l shr 24) and $80)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(r.d[dir and $7].l=0);
                    r.cc.x:=r.cc.c;
                 end;
         $33,$37:begin  //++++ rol.l
                    inc(r.contador,8);
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(r.d[dir and $7].l and $80000000)<>0;
                      r.d[dir and $7].l:=r.d[dir and $7].l shl 1;
                      if r.cc.c then r.d[dir and $7].l:=r.d[dir and $7].l or 1;
                    end;
                    r.cc.n:=((r.d[dir and $7].l shr 24) and $80)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(r.d[dir and $7].l=0);
                 end;
             else MessageDlg('Instruccion $E no es ''11''. '+inttostr((instruccion shr 3) and $3f)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
          end;
      end;
   else MessageDlg('Instruccion: '+inttostr(instruccion)+' (primer nibble). PC='+inttostr(r.pc.l), mtInformation,[mbOk], 0);
end;
{if r.pc.l=$6622 then begin
  MessageDlg('Break '+inttostr(r.d[0].l), mtInformation,[mbOk], 0);
  //save_hi('dani2.ram',@ram[0],$9000);
end;}
end;  //del while
end;

end.
