unit m6809;

interface
uses windows,constantes,dialogs,sysutils,timers;
type
        band_6809=record
                e,f,h,i,n,z,v,c:boolean;
        end;
        Parejas6809 = record
          case byte of
             0: (b, a: byte);
             1: (w: Word);
        end;
        reg_6809=record
                pc:parejas;
                d:parejas6809;
                u,s,x,y:parejas;
                sp:word;
                dp:byte;
                cc:band_6809;
                contador:integer;
                pedir_nmi,pedir_firq,pedir_irq:boolean;
                cwai:boolean;
                numero_cpu:byte;
                tframes:single;
                opcode:boolean;
        end;
        preg_6809=^reg_6809;
        pband_6809=^band_6809;
        llam_6809 = record
            getbyte: function (direccion: Word): Byte; pascal;
            putbyte: procedure (direccion:word;valor:byte);pascal;
  end;

const
        estados_t:array[0..255] of byte=(
      //0 1 2 3 4 5 6 7 8 9 a b c d e f
      6,0,0,6,6,0,6,6,6,6,6,0,6,6,3,6,  //$00
      0,0,2,4,0,0,5,9,0,2,3,0,3,2,8,6,  //$10
      3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,  //$20
      4,4,4,4,5,5,5,5,0,5,3,6,20,11,0,19, //$30
      2,0,0,2,2,0,2,2,2,2,2,0,2,2,0,2,  //$40
      2,0,0,2,2,0,2,2,2,2,2,0,2,2,0,2,  //$50
      6,0,0,6,6,0,6,6,6,6,6,0,6,6,3,6,  //$60
      7,0,0,7,7,0,7,7,7,7,7,0,7,7,4,7,  //$70
      2,2,2,4,2,2,2,2,2,2,2,2,4,7,3,0,  //$80
      4,4,4,6,4,4,4,4,4,4,4,4,6,7,5,5,  //$90
      4,4,4,6,4,4,4,4,4,4,4,4,6,7,5,5,  //$A0
      5,5,5,7,5,5,5,5,5,5,5,5,7,8,6,6,  //$B0
      2,2,2,4,2,2,2,2,2,2,2,2,3,0,3,3,  //$C0
      4,4,4,6,4,4,4,4,4,4,4,4,5,5,5,5,  //$D0
      4,4,4,6,4,4,4,4,4,4,4,4,5,5,5,5,  //$E0
      5,5,5,7,5,5,5,5,5,5,5,5,6,6,6,6); //$F0

        paginacion:array[0..255] of byte=(
      //0 1 2 3 4 5 6 7 8 9 a b c d e f
        1,0,0,1,1,0,1,1,1,1,1,0,1,1,1,1, //$00
        0,0,0,0,0,0,3,3,0,0,2,0,2,0,2,2, //$10
        2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2, //$20
        4,4,4,4,2,2,2,2,0,0,0,0,2,0,0,0, //$30
        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, //$40
        0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, //$50
        4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4, //$60
        3,0,0,3,3,0,3,3,3,3,3,0,3,3,3,3, //$70
        2,2,2,3,2,2,2,0,2,2,2,2,3,2,3,0, //$80
        1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, //$90
        4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4, //$a0
        3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3, //$b0
        2,2,2,3,2,2,2,0,2,2,2,2,3,0,3,0, //$c0
        1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, //$d0
        4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4, //$e0
        3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3); //$f0

var
  estados_demas:byte;
  pila_init:boolean;

procedure reset_6809(r:preg_6809;ll:llam_6809);
procedure run_6809(r:preg_6809;ll:llam_6809;maximo:dword);
function irq_6809(r:preg_6809;ll:llam_6809):byte;
function nmi_6809(r:preg_6809;ll:llam_6809):byte;

//funciones
procedure cmp16(r:preg_6809;valor,valor2:word);
function get_indexed(r:preg_6809;ll:llam_6809):word;
procedure set_nz16(r:preg_6809;valor:word);
procedure set_nz8(r:preg_6809;valor:byte);
procedure lbranch(r:preg_6809;numero:word);
procedure putword(direccion:word;valor:word;ll:llam_6809);pascal;
function getword(direccion:word;ll:llam_6809):word; pascal;


implementation
uses m6809_10,m6809_11;

function dame_pila(r:preg_6809):byte;
var
  temp:byte;
begin
  temp:=0;
  if r.cc.e then temp:=temp or $80;
  if r.cc.f then temp:=temp or $40;
  if r.cc.h then temp:=temp or $20;
  if r.cc.i then temp:=temp or $10;
  if r.cc.n then temp:=temp or 8;
  if r.cc.z then temp:=temp or 4;
  if r.cc.v then temp:=temp or 2;
  if r.cc.c then temp:=temp or 1;
  dame_pila:=temp;
end;

procedure pon_pila(r:preg_6809;valor:byte);
begin
  r.cc.e:=(valor and $80)<>0;
  r.cc.f:=(valor and $40)<>0;
  r.cc.h:=(valor and $20)<>0;
  r.cc.i:=(valor and $10)<>0;
  r.cc.n:=(valor and 8)<>0;
  r.cc.z:=(valor and 4)<>0;
  r.cc.v:=(valor and 2)<>0;
  r.cc.c:=(valor and 1)<>0;
end;

procedure reset_6809(r:preg_6809;ll:llam_6809);
begin
r.opcode:=false;
r.pc.w:=getword($FFFE,ll);
r.d.w:=0;
r.x.w:=0;
r.y.w:=0;
r.contador:=0;
r.sp:=0;
r.u.w:=0;
r.s.w:=0;
pon_pila(r,$50);
r.pedir_nmi:=false;
r.pedir_irq:=false;
r.pedir_firq:=false;
r.cwai:=false;
pila_init:=false;
end;

procedure push_s(r:preg_6809;ll:llam_6809;reg:byte);
begin
dec(r.s.w);
ll.putbyte(r.s.w,reg);
end;

function pop_s(r:preg_6809;ll:llam_6809):byte;
begin
pop_s:=ll.getbyte(r.s.w);
inc(r.s.w);
end;

procedure push_sw(r:preg_6809;ll:llam_6809;reg:word);
begin
dec(r.s.w);
ll.putbyte(r.s.w,reg and $FF);
dec(r.s.w);
ll.putbyte(r.s.w,(reg shr 8));
end;

function pop_sw(r:preg_6809;ll:llam_6809):word;
var
  temp:word;
begin
temp:=ll.getbyte(r.s.w) shl 8;
inc(r.s.w);
temp:=temp or ll.getbyte(r.s.w);
inc(r.s.w);
pop_sw:=temp;
end;

procedure push_u(r:preg_6809;ll:llam_6809;reg:byte);
begin
dec(r.u.w);
ll.putbyte(r.u.w,reg);
end;

function pop_u(r:preg_6809;ll:llam_6809):byte;
begin
pop_u:=ll.getbyte(r.u.w);
inc(r.u.w);
end;

procedure push_uw(r:preg_6809;ll:llam_6809;reg:word);
begin
dec(r.u.w);
ll.putbyte(r.u.w,reg and $FF);
dec(r.u.w);
ll.putbyte(r.u.w,(reg shr 8));
end;

function pop_uw(r:preg_6809;ll:llam_6809):word;
var
  temp:word;
begin
temp:=ll.getbyte(r.u.w) shl 8;
inc(r.u.w);
temp:=temp or ll.getbyte(r.u.w);
inc(r.u.w);
pop_uw:=temp;
end;

function nmi_6809(r:preg_6809;ll:llam_6809):byte;
begin
if not(pila_init) then exit;
if r.cwai then begin
  r.cwai:=false;
  nmi_6809:=7;
end else begin
  push_sw(r,ll,r.pc.w);
  push_sw(r,ll,r.u.w);
  push_sw(r,ll,r.y.w);
  push_sw(r,ll,r.x.w);
  push_s(r,ll,r.dp);
  push_s(r,ll,r.d.b);
  push_s(r,ll,r.d.a);
  r.cc.e:=true;
  push_s(r,ll,dame_pila(r));
  nmi_6809:=19;
end;
r.cc.i:=true;
r.cc.f:=true;
r.pc.w:=getword($FFFC,ll);
r.pedir_nmi:=false;
end;

function irq_6809(r:preg_6809;ll:llam_6809):byte;
begin
if r.cc.i then begin
  irq_6809:=0;
  exit;
end;
if r.cwai then begin
  r.cwai:=false;
  irq_6809:=7;
end else begin
  push_sw(r,ll,r.pc.w);
  push_sw(r,ll,r.u.w);
  push_sw(r,ll,r.y.w);
  push_sw(r,ll,r.x.w);
  push_s(r,ll,r.dp);
  push_s(r,ll,r.d.b);
  push_s(r,ll,r.d.a);
  r.cc.e:=true;
  push_s(r,ll,dame_pila(r));
  irq_6809:=19;
end;
r.pc.w:=getword($FFF8,ll);
r.cc.i:=true;
r.pedir_irq:=false;
end;

function firq_6809(r:preg_6809;ll:llam_6809):byte;
begin
if r.cc.f then begin
  firq_6809:=0;
  exit;
end;
if r.cwai then begin
  r.cwai:=false;
  firq_6809:=7;
end else begin
  r.cc.e:=false;
  push_sw(r,ll,r.pc.w);
  push_s(r,ll,dame_pila(r));
  firq_6809:=10;
end;
r.pedir_firq:=false;
r.cc.f:=true;
r.cc.i:=true;
r.pc.w:=getword($FFF6,ll);
end;

function get_indexed(r:preg_6809;ll:llam_6809):word;
var
  iindexed,temp:byte;
  origen:pparejas;
  direccion,temp2:word;
begin
iindexed:=ll.getbyte(r.pc.w);
inc(r.pc.w);
case (iindexed and $60) of
  $00:origen:=@r.x;
  $20:origen:=@r.y;
  $40:origen:=@r.u;
  $60:origen:=@r.s;
end;
if (iindexed and $80)<>0 then begin
  case (iindexed and $f) of
      0:begin  //reg+
          direccion:=origen.w;
          inc(origen.w);
          estados_demas:=2;
      end;
      1:begin  //reg++
          direccion:=origen.w;
          inc(origen.w,2);
          estados_demas:=3;
      end;
      2:begin  //-reg
          dec(origen.w);
          direccion:=origen.w;
          estados_demas:=2;
      end;
      3:begin //--reg
          dec(origen.w,2);
          direccion:=origen.w;
          estados_demas:=3;
      end;
      4:direccion:=origen.w;  // =
      5:begin  //reg + r.d.b
          if ((r.d.b and $80)<>0) then direccion:=origen.w-(256-r.d.b)
            else direccion:=origen.w+r.d.b;
          estados_demas:=1;
      end;
      6:begin  // reg + r.d.a
          if ((r.d.a and $80)<>0) then direccion:=origen.w-(256-r.d.a)
            else direccion:=origen.w+r.d.a;
          estados_demas:=1;
      end;
      8:begin  //reg + deplazamiento 8bits
          temp:=ll.getbyte(r.pc.w);
          inc(r.pc.w);
          if ((temp and $80)<>0) then direccion:=origen.w-(256-temp)
            else direccion:=origen.w+temp;
          estados_demas:=1;
      end;
      9:begin  //reg + deplazamiento 16bits
          temp2:=getword(r.pc.w,ll);
          inc(r.pc.w,2);
          if ((temp2 and $8000)<>0) then direccion:=origen.w-(65536-temp2)
            else direccion:=origen.w+temp2;
          estados_demas:=4;
      end;
      $b:begin //reg + r.d.w
          if ((r.d.w and $8000)<>0) then direccion:=origen.w-(65536-r.d.w)
            else direccion:=origen.w+r.d.w;
          estados_demas:=4;
      end;
      $d:begin  //pc + desplazamiento 16 bits
          temp2:=getword(r.pc.w,ll);
          inc(r.pc.w,2);
          if ((temp2 and $8000)<>0) then direccion:=r.pc.w-(65536-temp2)
            else direccion:=r.pc.w+temp2;
          estados_demas:=5;
      end;
      $f:begin
          direccion:=getword(r.pc.w,ll);
          inc(r.pc.w,2);
          estados_demas:=5;
      end
   else MessageDlg('Indexed desconocido: '+inttostr((iindexed and $f))+' desconocido. PC='+inttostr(r.pc.w), mtInformation,[mbOk], 0)
  end;
  if (iindexed and $10)<>0 then begin
      direccion:=getword(direccion,ll);
      inc(estados_demas,3);
  end;
end else begin
  temp:=iindexed and $1f;
  if (temp and $10)=0 then direccion:=origen.w+(temp and $f)
    else direccion:=origen.w-(16-(temp and $f));
  estados_demas:=1;
end;
get_indexed:=direccion;
end;

function add8(r:preg_6809;valor,valor2:byte):byte;
var
  temp:word;
begin
temp:=valor+valor2;
r.cc.c:=(temp and $100)<>0;
r.cc.h:=((valor xor valor2 xor temp) and $10)<>0;
set_nz8(r,temp);
r.cc.v:=(((valor xor valor2 xor temp xor (temp shr 1)) and $80))<>0;
add8:=temp;
end;

function adc(r:preg_6809;valor,valor2:byte):byte;
var
  temp:word;
  carry:byte;
begin
if r.cc.c then carry:=1
  else carry:=0;
temp:=valor+valor2+carry;
r.cc.c:=(temp and $100)<>0;
r.cc.h:=((valor xor valor2 xor temp) and $10)<>0;
set_nz8(r,temp);
r.cc.v:=(((valor xor valor2 xor temp xor (temp shr 1)) and $80))<>0;
adc:=temp;
end;

function sbc(r:preg_6809;valor,valor2:byte):byte;
var
  temp:word;
  carry:byte;
begin
if r.cc.c then carry:=1
  else carry:=0;
temp:=valor-valor2-carry;
r.cc.c:=valor<(valor2+carry);
set_nz8(r,temp);
r.cc.v:=(((valor xor valor2 xor temp xor (temp shr 1)) and $80))<>0;
sbc:=temp;
end;

function sub8(r:preg_6809;valor,valor2:byte):byte;
var
  temp:word;
begin
temp:=valor-valor2;
r.cc.c:=valor<valor2;
set_nz8(r,temp);
r.cc.v:=(((valor xor valor2 xor temp xor (temp shr 1)) and $80))<>0;
sub8:=temp;
end;

function add16(r:preg_6809;valor,valor2:word):word;
var
  temp:dword;
begin
temp:=valor+valor2;
r.cc.c:=(temp and $10000)<>0;
set_nz16(r,temp);
r.cc.v:=((valor xor valor2 xor temp xor (temp shr 1)) and $8000)<>0;
add16:=temp;
end;

function sub16(r:preg_6809;valor,valor2:word):word;
var
  temp:dword;
begin
temp:=valor-valor2;
r.cc.c:=(temp and $10000)<>0;
set_nz16(r,temp);
r.cc.v:=((valor xor valor2 xor temp xor (temp shr 1)) and $8000)<>0;
sub16:=temp;
end;

procedure cmp8(r:preg_6809;valor,valor2:byte);
var
  temp:word;
begin
temp:=valor-valor2;
r.cc.c:=(temp and $100)<>0;
set_nz8(r,temp);
r.cc.v:=(((valor xor valor2 xor temp xor (temp shr 1)) and $80))<>0;
end;

procedure cmp16(r:preg_6809;valor,valor2:word);
var
  temp:dword;
begin
temp:=valor-valor2;
r.cc.c:=(temp and $10000)<>0;
set_nz16(r,temp);
r.cc.v:=((valor xor valor2 xor temp xor (temp shr 1)) and $8000)<>0;
end;

function lsr(r:preg_6809;valor:byte):byte;
var
  res:byte;
begin
res:=valor shr 1;
r.cc.c:=(valor and $1)<>0;
r.cc.z:=(res=0);
r.cc.n:=false;
lsr:=res;
end;

function asr(r:preg_6809;valor:byte):byte;
var
  res:byte;
begin
res:=(valor and $80) or (valor shr 1);
r.cc.c:=(valor and $1)<>0;
set_nz8(r,res);
asr:=res;
end;

function asl(r:preg_6809;valor:byte):byte;
var
  res:word;
begin
res:=valor shl 1;
set_nz8(r,res);
r.cc.c:=(res and $100)<>0;
r.cc.v:=((valor xor valor xor res xor (res shr 1)) and $80)<>0;
asl:=res;
end;

function rol(r:preg_6809;valor:byte):byte;
var
  res:word;
begin
if r.cc.c then res:=1
  else res:=0;
res:=(valor shl 1) or res;
r.cc.c:=(res and $100)<>0;
r.cc.v:=((valor xor valor xor res xor (res shr 1)) and $80)<>0;
set_nz8(r,res);
rol:=res;
end;

function ror(r:preg_6809;valor:byte):byte;
var
  res:byte;
begin
if r.cc.c then res:=$80
  else res:=0;
r.cc.c:=(valor and $1)<>0;
res:=(valor shr 1) or res;
set_nz8(r,res);
ror:=res;
end;

function eor(r:preg_6809;valor,valor2:byte):byte;
var
  temp:byte;
begin
r.cc.v:=false;
temp:=valor xor valor2;
set_nz8(r,temp);
eor:=temp;
end;

function or_8(r:preg_6809;valor,valor2:byte):byte;
var
  temp:byte;
begin
r.cc.v:=false;
temp:=valor or valor2;
set_nz8(r,temp);
or_8:=temp;
end;

function and_8(r:preg_6809;valor,valor2:byte):byte;
var
  res:byte;
begin
res:=valor and valor2;
set_nz8(r,res);
r.cc.v:=false;
and_8:=res;
end;

function com(r:preg_6809;valor:byte):byte;
var
  res:byte;
begin
res:=not(valor);
r.cc.v:=false;
r.cc.c:=true;
set_nz8(r,res);
com:=res;
end;

function neg(r:preg_6809;valor:byte):byte;
var
  temp:word;
begin
temp:=-valor;
set_nz8(r,temp);
r.cc.c:=(temp and $100)<>0;
r.cc.v:=(((0 xor valor xor temp xor (temp shr 1)) and $80))<>0;
neg:=temp;
end;

function inc_8(r:preg_6809;valor:byte):byte;
var
  res:byte;
begin
res:=valor+1;
r.cc.z:=(res=0);
r.cc.n:=(res and $80)<>0;
r.cc.v:=(res=$80);
inc_8:=res;
end;

function dec_8(r:preg_6809;valor:byte):byte;
var
  res:byte;
begin
res:=valor-1;
r.cc.z:=(res=0);
r.cc.n:=(res and $80)<>0;
r.cc.v:=(res=$7f);
dec_8:=res;
end;

procedure trf(r:preg_6809;valor:byte);
var
  temp:word;
begin
if ((valor xor (valor shr 4)) and $08)<>0 then begin
  temp:=$ff
end else begin
  case (valor shr 4) of
    $0:temp:=r.d.w; //D
    $1:temp:=r.x.w;  //X
    $2:temp:=r.y.w; //Y
    $3:temp:=r.u.w; //U
    $4:temp:=r.s.w; //S
    $5:temp:=r.pc.w; //pc
    $8:temp:=r.d.a; //a
    $9:temp:=r.d.b; //b
    $a:temp:=dame_pila(r);  //cc
    $b:temp:=r.dp; //dp
  end;
end;
case (valor and 15) of
    $0:r.d.w:=temp; //D
    $1:r.x.w:=temp;  //X
    $2:r.y.w:=temp; //Y
    $3:r.u.w:=temp; //U
    $4:r.s.w:=temp; //S
    $5:r.pc.w:=temp; //pc
    $8:r.d.a:=temp; //a
    $9:r.d.b:=temp; //b
    $a:pon_pila(r,temp);  //cc
    $b:r.dp:=temp; //dp
end;
end;

procedure trf_ex(r:preg_6809;valor:byte);
var
  temp1,temp2:word;
begin
if ((valor xor (valor shr 4)) and $08)<>0 then begin
    temp1:=$ff;
    temp2:=$ff;
end else begin
  case (valor shr 4) of
    $0:temp1:=r.d.w; //D
    $1:temp1:=r.x.w;  //X
    $2:temp1:=r.y.w; //Y
    $3:temp1:=r.u.w; //U
    $4:temp1:=r.s.w; //S
    $5:temp1:=r.pc.w; //pc
    $8:temp1:=r.d.a; //a
    $9:temp1:=r.d.b; //b
    $a:temp1:=dame_pila(r);  //cc
    $b:temp1:=r.dp; //dp
  end;
  case (valor and 15) of
    $0:temp2:=r.d.w; //D
    $1:temp2:=r.x.w;  //X
    $2:temp2:=r.y.w; //Y
    $3:temp2:=r.u.w; //U
    $4:temp2:=r.s.w; //S
    $5:temp2:=r.pc.w; //pc
    $8:temp2:=r.d.a; //a
    $9:temp2:=r.d.b; //b
    $a:temp2:=dame_pila(r);  //cc
    $b:temp2:=r.dp; //dp
  end;
end;
case (valor shr 4) of
    $0:r.d.w:=temp2; //D
    $1:r.x.w:=temp2;  //X
    $2:r.y.w:=temp2; //Y
    $3:r.u.w:=temp2; //U
    $4:r.s.w:=temp2; //S
    $5:r.pc.w:=temp2; //pc
    $8:r.d.a:=temp2; //a
    $9:r.d.b:=temp2; //b
    $a:pon_pila(r,temp2);  //cc
    $b:r.dp:=temp2; //dp
end;
case (valor and 15) of
    $0:r.d.w:=temp1; //D
    $1:r.x.w:=temp1;  //X
    $2:r.y.w:=temp1; //Y
    $3:r.u.w:=temp1; //U
    $4:r.s.w:=temp1; //S
    $5:r.pc.w:=temp1; //pc
    $8:r.d.a:=temp1; //a
    $9:r.d.b:=temp1; //b
    $a:pon_pila(r,temp1);  //cc
    $b:r.dp:=temp1; //dp
end;
end;

procedure set_nz16(r:preg_6809;valor:word);
begin
r.cc.n:=(valor and $8000)<>0;
r.cc.z:=(valor=0);
end;

procedure set_nz8(r:preg_6809;valor:byte);
begin
r.cc.n:=(valor and $80)<>0;
r.cc.z:=(valor=0);
end;

procedure branch(r:preg_6809;numero:byte);
begin
if ((numero and $80)<>0) then dec(r.pc.w,(256-numero))
  else inc(r.pc.w,numero);
end;

procedure lbranch(r:preg_6809;numero:word);
begin
if ((numero and $8000)<>0) then dec(r.pc.w,(65536-numero))
  else inc(r.pc.w,numero);
end;

procedure putword(direccion:word;valor:word;ll:llam_6809);pascal;
begin
ll.putbyte(direccion,valor shr 8);
ll.putbyte(direccion+1,valor and $FF);
end;

function getword(direccion:word;ll:llam_6809):word; pascal;
var
  valor:word;
begin
valor:=ll.getbyte(direccion) shl 8;
valor:=valor+(ll.getbyte(direccion+1));
getword:=valor;
end;

procedure run_6809(r:preg_6809;ll:llam_6809;maximo:dword);
var
    instruccion,temp,temp2,numero:byte;
    temp3,cf:word;
    msn,lsn:byte;
    posicion:parejas;
begin
while r.contador<maximo do begin
estados_demas:=0;
if r.pedir_nmi then estados_demas:=nmi_6809(r,ll)
  else if r.pedir_firq then estados_demas:=firq_6809(r,ll)
       else if r.pedir_irq then estados_demas:=irq_6809(r,ll);
if r.cwai then begin
  r.contador:=maximo;
  exit;
end;
r.opcode:=true;
instruccion:=ll.getbyte(r.pc.w);
inc(r.pc.w);
r.opcode:=false;
//tipo de paginacion
case paginacion[instruccion] of
    0:; //implicito
    1:begin //direct page
        posicion.h:=r.dp;
        posicion.l:=ll.getbyte(r.pc.w);
        inc(r.pc.w);
      end;
    2:begin  //inmediato byte
        numero:=ll.getbyte(r.pc.w);
        inc(r.pc.w);
      end;
    3:begin  //extendido
         posicion.w:=getword(r.pc.w,ll);
         inc(r.pc.w,2);
      end;
    4:posicion.w:=get_indexed(r,ll);
end;
case instruccion of
      $0,$60,$70:begin  //neg
            temp:=ll.getbyte(posicion.w);
            ll.putbyte(posicion.w,neg(r,temp));
      end;
      $3,$63,$73:begin  //com
            temp:=ll.getbyte(posicion.w);
            ll.putbyte(posicion.w,com(r,temp));
      end;
      $4,$64,$74:begin  //lsr
            temp:=ll.getbyte(posicion.w);
            ll.putbyte(posicion.w,lsr(r,temp));
      end;
      $6,$66,$76:begin  //ror
            temp:=ll.getbyte(posicion.w);
            ll.putbyte(posicion.w,ror(r,temp));
      end;
      $7,$67,$77:begin  //asr
            temp:=ll.getbyte(posicion.w);
            ll.putbyte(posicion.w,asr(r,temp));
      end;
      $8,$68,$78:begin  //asl
            temp:=ll.getbyte(posicion.w);
            ll.putbyte(posicion.w,asl(r,temp));
      end;
      $9,$69,$79:begin  //rol
            temp:=ll.getbyte(posicion.w);
            ll.putbyte(posicion.w,rol(r,temp));
      end;
      $a,$6a,$7a:begin  //dec
            temp:=ll.getbyte(posicion.w);
            ll.putbyte(posicion.w,dec_8(r,temp));
      end;
      $c,$6c,$7c:begin  //inc
            temp:=ll.getbyte(posicion.w);
            ll.putbyte(posicion.w,inc_8(r,temp));
      end;
      $d,$6d,$7d:begin //tst
            temp:=ll.getbyte(posicion.w);
            r.cc.v:=false;
            set_nz8(r,temp);
      end;
      $e,$6e,$7e:r.pc.w:=posicion.w;  //jmp
      $f,$6f,$7f:begin //clr
          ll.getbyte(posicion.w);
          ll.putbyte(posicion.w,0);
          r.cc.n:=false;
          r.cc.v:=false;
          r.cc.c:=false;
          r.cc.z:=true;
      end;
      $10:inc(estados_demas,exec_10(r,ll));
      $11:inc(estados_demas,exec_11(r,ll));
      $12:; //nop
      $13:begin //sync
            r.contador:=maximo;
            exit;
          end;
      $16:lbranch(r,posicion.w);  //lbra
      $17:begin  //lbsr
            push_sw(r,ll,r.pc.w);
            lbranch(r,posicion.w);
      end;
      $19:begin //daa
            cf:=0;
            msn:=r.d.a and $f0;
            lsn:=r.d.a and $0f;
	          if ((lsn>$09) or r.cc.h) then cf:=cf or $06;
	          if ((msn>$80) and (lsn>$09)) then cf:=cf or $60;
	          if ((msn>$90) or r.cc.c) then cf:=cf or $60;
	          temp3:=cf+r.d.a;
	          r.cc.v:=false;
	          set_nz8(r,temp3);
            r.cc.c:=(temp3 and $100)<>0;
	          r.d.a:=temp3;
          end;
      $1a:begin //orcc
            temp:=dame_pila(r) or numero;
            pon_pila(r,temp);
            if r.pedir_firq then estados_demas:=firq_6809(r,ll)
              else if r.pedir_irq then estados_demas:=irq_6809(r,ll);
          end;
      $1c:begin //andcc
            temp:=dame_pila(r) and numero;
            pon_pila(r,temp);
            if r.pedir_firq then estados_demas:=firq_6809(r,ll)
              else if r.pedir_irq then estados_demas:=irq_6809(r,ll);
          end;
      $1d:begin //sex
            if (r.d.b and $80)<>0 then r.d.a:=$ff
              else r.d.a:=0;
            set_nz16(r,r.d.w);
      end;
      $1e:trf_ex(r,numero); //exg
      $1f:trf(r,numero); //trf
      $20:branch(r,numero); //bra
      $21:; //brn
      $22:if not(r.cc.c or r.cc.z) then branch(r,numero);  //bhi
      $23:if (r.cc.c or r.cc.z) then branch(r,numero);//bls
      $24:if not(r.cc.c) then branch(r,numero);  //bcc
      $25:if r.cc.c then branch(r,numero);  //bcs
      $26:if not(r.cc.z) then branch(r,numero);  //bne
      $27:if r.cc.z then branch(r,numero);  //beq
      $2a:if not(r.cc.n) then branch(r,numero);  //bpl
      $2b:if r.cc.n then branch(r,numero);  //bmi
      $2c:if not(r.cc.n xor r.cc.v) then branch(r,numero);//bge
      $2d:if (r.cc.n xor r.cc.v) then branch(r,numero);//blt
      $2e:if not((r.cc.n xor r.cc.v) or r.cc.z) then branch(r,numero); //bgt
      $2f:if ((r.cc.n xor r.cc.v) or r.cc.z) then branch(r,numero); //ble
      $30:begin //leax
            r.x.w:=posicion.w;
            r.cc.z:=(r.x.w=0);
          end;
      $31:begin //leay
            r.y.w:=posicion.w;
            r.cc.z:=(r.y.w=0);
          end;
      $32:r.s.w:=posicion.w; //leas
      $33:r.u.w:=posicion.w; //leau
      $34:begin //pshs
            if (numero and $80)<>0 then begin
              push_sw(r,ll,r.pc.w);
              inc(estados_demas,2);
            end;
            if (numero and $40)<>0 then begin
              push_sw(r,ll,r.u.w);
              inc(estados_demas,2);
            end;
            if (numero and $20)<>0 then begin
              push_sw(r,ll,r.y.w);
              inc(estados_demas,2);
            end;
            if (numero and $10)<>0 then begin
              push_sw(r,ll,r.x.w);
              inc(estados_demas,2);
            end;
            if (numero and $8)<>0 then begin
              push_s(r,ll,r.dp);
              inc(estados_demas);
            end;
            if (numero and $4)<>0 then begin
              push_s(r,ll,r.d.b);
              inc(estados_demas);
            end;
            if (numero and $2)<>0 then begin
              push_s(r,ll,r.d.a);
              inc(estados_demas);
            end;
            if (numero and $1)<>0 then begin
              push_s(r,ll,dame_pila(r));
              inc(estados_demas);
            end;
      end;
      $35:begin //puls
            if (numero and $1)<>0 then begin
              pon_pila(r,pop_s(r,ll));
              inc(estados_demas);
            end;
            if (numero and $2)<>0 then begin
              r.d.a:=pop_s(r,ll);
              inc(estados_demas);
            end;
            if (numero and $4)<>0 then begin
              r.d.b:=pop_s(r,ll);
              inc(estados_demas);
            end;
            if (numero and $8)<>0 then begin
              r.dp:=pop_s(r,ll);
              inc(estados_demas);
            end;
            if (numero and $10)<>0 then begin
              r.x.w:=pop_sw(r,ll);
              inc(estados_demas,2);
            end;
            if (numero and $20)<>0 then begin
              r.y.w:=pop_sw(r,ll);
              inc(estados_demas,2);
            end;
            if (numero and $40)<>0 then begin
              r.u.w:=pop_sw(r,ll);
              inc(estados_demas,2);
            end;
            if (numero and $80)<>0 then begin
              r.pc.w:=pop_sw(r,ll);
              inc(estados_demas,2);
            end;
            if r.pedir_firq then estados_demas:=firq_6809(r,ll)
              else if r.pedir_irq then estados_demas:=irq_6809(r,ll);
      end;
      $36:begin //pshu
            if (numero and $80)<>0 then begin
              push_uw(r,ll,r.pc.w);
              inc(estados_demas,2);
            end;
            if (numero and $40)<>0 then begin
              push_uw(r,ll,r.s.w);
              inc(estados_demas,2);
            end;
            if (numero and $20)<>0 then begin
              push_uw(r,ll,r.y.w);
              inc(estados_demas,2);
            end;
            if (numero and $10)<>0 then begin
              push_uw(r,ll,r.x.w);
              inc(estados_demas,2);
            end;
            if (numero and $8)<>0 then begin
              push_u(r,ll,r.dp);
              inc(estados_demas);
            end;
            if (numero and $4)<>0 then begin
              push_u(r,ll,r.d.b);
              inc(estados_demas);
            end;
            if (numero and $2)<>0 then begin
              push_u(r,ll,r.d.a);
              inc(estados_demas);
            end;
            if (numero and $1)<>0 then begin
              push_u(r,ll,dame_pila(r));
              inc(estados_demas);
            end;
      end;
      $37:begin //pulu
            if (numero and $1)<>0 then begin
              pon_pila(r,pop_u(r,ll));
              inc(estados_demas);
            end;
            if (numero and $2)<>0 then begin
              r.d.a:=pop_u(r,ll);
              inc(estados_demas);
            end;
            if (numero and $4)<>0 then begin
              r.d.b:=pop_u(r,ll);
              inc(estados_demas);
            end;
            if (numero and $8)<>0 then begin
              r.dp:=pop_u(r,ll);
              inc(estados_demas);
            end;
            if (numero and $10)<>0 then begin
              r.x.w:=pop_uw(r,ll);
              inc(estados_demas,2);
            end;
            if (numero and $20)<>0 then begin
              r.y.w:=pop_uw(r,ll);
              inc(estados_demas,2);
            end;
            if (numero and $40)<>0 then begin
              r.s.w:=pop_uw(r,ll);
              inc(estados_demas,2);
            end;
            if (numero and $80)<>0 then begin
              r.pc.w:=pop_uw(r,ll);
              inc(estados_demas,2);
            end;
            if r.pedir_firq then estados_demas:=firq_6809(r,ll)
              else if r.pedir_irq then estados_demas:=irq_6809(r,ll);
      end;
      $39:r.pc.w:=pop_sw(r,ll); //rts
      $3a:r.x.w:=r.x.w+r.d.b;  //abx
      $3b:begin  //rti
          pon_pila(r,pop_s(r,ll));
          if r.cc.e then begin
            inc(estados_demas,9);
            r.d.a:=pop_s(r,ll);
            r.d.b:=pop_s(r,ll);
            r.dp:=pop_s(r,ll);
            r.x.w:=pop_sw(r,ll);
            r.y.w:=pop_sw(r,ll);
            r.u.w:=pop_sw(r,ll);
          end;
          r.pc.w:=pop_sw(r,ll);
          if r.pedir_firq then estados_demas:=firq_6809(r,ll)
              else if r.pedir_irq then estados_demas:=irq_6809(r,ll);
      end;
      $3c:begin //cwai
          pon_pila(r,dame_pila(r) and numero);
          r.cc.e:=true;
          push_sw(r,ll,r.pc.w);
          push_sw(r,ll,r.u.w);
          push_sw(r,ll,r.y.w);
          push_sw(r,ll,r.x.w);
          push_s(r,ll,r.dp);
          push_s(r,ll,r.d.b);
          push_s(r,ll,r.d.a);
          push_s(r,ll,dame_pila(r));
          r.cwai:=true;
          if r.pedir_firq then estados_demas:=firq_6809(r,ll)
              else if r.pedir_irq then estados_demas:=irq_6809(r,ll);
      end;
      $3d:begin  //mul
          r.d.w:=r.d.a*r.d.b;
          r.cc.c:=(r.d.b and $80)<>0;
          r.cc.z:=(r.d.w=0);
      end;
      $40:r.d.a:=neg(r,r.d.a);  //nega
      $43:r.d.a:=com(r,r.d.a);  //coma
      $44:r.d.a:=lsr(r,r.d.a); //lsra
      $46:r.d.a:=ror(r,r.d.a); //rora
      $47:r.d.a:=asr(r,r.d.a);  //asra
      $48:r.d.a:=asl(r,r.d.a); //asla
      $49:r.d.a:=rol(r,r.d.a); //rola
      $4a:r.d.a:=dec_8(r,r.d.a); //deca
      $4c:r.d.a:=inc_8(r,r.d.a);  //inca
      $4d:begin //tsta
            r.cc.v:=false;
            set_nz8(r,r.d.a);
          end;
      $4f:begin //clra
            r.d.a:=0;
            r.cc.z:=true;
            r.cc.n:=false;
            r.cc.v:=false;
            r.cc.c:=false;
          end;
      $50:r.d.b:=neg(r,r.d.b);  //negb
      $53:r.d.b:=com(r,r.d.b);  //comb
      $54:r.d.b:=lsr(r,r.d.b);  //lsrb
      $56:r.d.b:=ror(r,r.d.b); //rorb
      $57:r.d.b:=asr(r,r.d.b); //asrb
      $58:r.d.b:=asl(r,r.d.b);  //aslb
      $59:r.d.b:=rol(r,r.d.b);  //rolb
      $5a:r.d.b:=dec_8(r,r.d.b);  //decb
      $5c:r.d.b:=inc_8(r,r.d.b);  //incb
      $5d:begin //tstb
           r.cc.v:=false;
           set_nz8(r,r.d.b);
      end;
      $5f:begin //clrb
            r.d.b:=0;
            r.cc.z:=true;
            r.cc.n:=false;
            r.cc.v:=false;
            r.cc.c:=false;
          end;
      $80:r.d.a:=sub8(r,r.d.a,numero);  //suba
      $81:cmp8(r,r.d.a,numero);  //cmpa
      $82:r.d.a:=sbc(r,r.d.a,numero); //sbca
      $83:r.d.w:=sub16(r,r.d.w,posicion.w); //subd
      $84:r.d.a:=and_8(r,r.d.a,numero); //anda
      $85:and_8(r,r.d.a,numero); //bita
      $86:begin  //lda
            r.d.a:=numero;
            r.cc.v:=false;
            set_nz8(r,r.d.a);
          end;
      $88:r.d.a:=eor(r,r.d.a,numero); //eora
      $89:r.d.a:=adc(r,r.d.a,numero); //adca
      $8a:r.d.a:=or_8(r,r.d.a,numero); //ora
      $8b:r.d.a:=add8(r,r.d.a,numero); //adda
      $8c:cmp16(r,r.x.w,posicion.w);   //cmpx
      $8d:begin  //bsr
            push_sw(r,ll,r.pc.w);
            branch(r,numero);
      end;
      $8e:begin  //ldx
            r.x.w:=posicion.w;
            set_nz16(r,r.x.w);
            r.cc.v:=false;
          end;
      $90,$a0,$b0:begin  //suba
            temp:=ll.getbyte(posicion.w);
            r.d.a:=sub8(r,r.d.a,temp);
      end;
      $91,$a1,$b1:begin  //cmpa
            temp:=ll.getbyte(posicion.w);
            cmp8(r,r.d.a,temp);
      end;
      $92,$a2,$b2:begin  //sbca
            temp:=ll.getbyte(posicion.w);
            r.d.a:=sbc(r,r.d.a,temp);
      end;
      $93,$a3,$b3:begin //subd
            temp3:=getword(posicion.w,ll);
            r.d.w:=sub16(r,r.d.w,temp3);
      end;
      $94,$a4,$b4:begin  //anda
            temp:=ll.getbyte(posicion.w);
            r.d.a:=and_8(r,r.d.a,temp);
      end;
      $95,$a5,$b5:begin  //bita
            temp:=ll.getbyte(posicion.w);
            and_8(r,r.d.a,temp);
      end;
      $96,$a6,$b6:begin //lda
            r.d.a:=ll.getbyte(posicion.w);
            set_nz8(r,r.d.a);
            r.cc.v:=false;
          end;
      $97,$a7,$b7:begin  //sta
            set_nz8(r,r.d.a);
            r.cc.v:=false;
            ll.putbyte(posicion.w,r.d.a);
          end;
      $98,$a8,$b8:begin  //eora
            temp:=ll.getbyte(posicion.w);
            r.d.a:=eor(r,r.d.a,temp);
          end;
      $99,$a9,$b9:begin  //adca
            temp:=ll.getbyte(posicion.w);
            r.d.a:=adc(r,r.d.a,temp);
          end;
      $9a,$aa,$ba:begin  //ora
            temp:=ll.getbyte(posicion.w);
            r.d.a:=or_8(r,r.d.a,temp);
          end;
      $9b,$ab,$bb:begin //adda
            temp:=ll.getbyte(posicion.w);
            r.d.a:=add8(r,r.d.a,temp);
          end;
      $9c,$ac,$bc:begin //cmpx
            temp3:=getword(posicion.w,ll);
            cmp16(r,r.x.w,temp3);
      end;
      $9d,$ad,$bd:begin //jsr
            push_sw(r,ll,r.pc.w);
            r.pc.w:=posicion.w;
      end;
      $9e,$ae,$be:begin //ldx
            r.x.w:=getword(posicion.w,ll);
            set_nz16(r,r.x.w);
            r.cc.v:=false;
      end;
      $9f,$af,$bf:begin //stx
            set_nz16(r,r.x.w);
            r.cc.v:=false;
            putword(posicion.w,r.x.w,ll);
      end;
      $c0:r.d.b:=sub8(r,r.d.b,numero); //subb
      $c1:cmp8(r,r.d.b,numero); //cmpb
      $c2:r.d.b:=sbc(r,r.d.b,numero); //sbcb
      $c3:r.d.w:=add16(r,r.d.w,posicion.w);  //addd
      $c4:r.d.b:=and_8(r,r.d.b,numero);  //andb
      $c5:and_8(r,r.d.b,numero);  //bitb
      $c6:begin //ldb
            r.d.b:=numero;
            set_nz8(r,r.d.b);
            r.cc.v:=false;
          end;
      $c8:r.d.b:=eor(r,r.d.b,numero);  //eorb
      $c9:r.d.b:=adc(r,r.d.b,numero);  //adcb
      $ca:r.d.b:=or_8(r,r.d.b,numero);  //orb
      $cb:r.d.b:=add8(r,r.d.b,numero); //addb
      $cc:begin  //ldd
            r.d.w:=posicion.w;
            set_nz16(r,r.d.w);
            r.cc.v:=false;
          end;
      $ce:begin  //ldu
            r.u.w:=posicion.w;
            set_nz16(r,r.u.w);
            r.cc.v:=false;
          end;
      $d0,$e0,$f0:begin //subb
            temp:=ll.getbyte(posicion.w);
            r.d.b:=sub8(r,r.d.b,temp);
      end;
      $d1,$e1,$f1:begin  //cmpb
            temp:=ll.getbyte(posicion.w);
            cmp8(r,r.d.b,temp);
      end;
      $d2,$e2,$f2:begin  //sbcb
            temp:=ll.getbyte(posicion.w);
            r.d.b:=sbc(r,r.d.b,temp);
      end;
      $d3,$e3,$f3:begin //addd
            temp3:=getword(posicion.w,ll);
            r.d.w:=add16(r,r.d.w,temp3);
      end;
      $d4,$e4,$f4:begin //andb
            temp:=ll.getbyte(posicion.w);
            r.d.b:=and_8(r,r.d.b,temp);
      end;
      $d5,$e5,$f5:begin //bitb
            temp:=ll.getbyte(posicion.w);
            and_8(r,r.d.b,temp);
      end;
      $d6,$e6,$f6:begin  //ldb
            r.d.b:=ll.getbyte(posicion.w);
            set_nz8(r,r.d.b);
            r.cc.v:=false;
      end;
      $d7,$e7,$f7:begin  //stb
            set_nz8(r,r.d.b);
            r.cc.v:=false;
            ll.putbyte(posicion.w,r.d.b);
      end;
      $d8,$e8,$f8:begin //eorb
            temp:=ll.getbyte(posicion.w);
            r.d.b:=eor(r,r.d.b,temp);
      end;
      $d9,$e9,$f9:begin //adcb
            temp:=ll.getbyte(posicion.w);
            r.d.b:=adc(r,r.d.b,temp);
      end;
      $da,$ea,$fa:begin //orb
            temp:=ll.getbyte(posicion.w);
            r.d.b:=or_8(r,r.d.b,temp);
      end;
      $db,$eb,$fb:begin //addb
            temp:=ll.getbyte(posicion.w);
            r.d.b:=add8(r,r.d.b,temp);
      end;
      $dc,$ec,$fc:begin  //ldd
            r.d.w:=getword(posicion.w,ll);
            set_nz16(r,r.d.w);
            r.cc.v:=false;
      end;
      $dd,$ed,$fd:begin  //std
            set_nz16(r,r.d.w);
            r.cc.v:=false;
            putword(posicion.w,r.d.w,ll);
      end;
      $de,$ee,$fe:begin  //ldu
            r.u.w:=getword(posicion.w,ll);
            set_nz16(r,r.u.w);
            r.cc.v:=false;
      end;
      $df,$ef,$ff:begin //sdu
            set_nz16(r,r.u.w);
            r.cc.v:=false;
            putword(posicion.w,r.u.w,ll);
      end;
      else
        MessageDlg('Instruccion: '+inttostr(instruccion)+' desconocida. PC='+inttostr(r.pc.w), mtInformation,[mbOk], 0)
end; //del case!!
//inc(contador,estados_t[instruccion]+estados_demas);
inc(r.contador,estados_t[instruccion]+estados_demas);
update_timer(estados_t[instruccion]+estados_demas,r.numero_cpu);
end; //del while!!
end;

end.
