unit z80_ed;

interface
uses z80,dialogs,constantes,sysutils,z80daisy;

function exec_ed(r:preg_z80;ll:llam_z80):byte;
procedure adc_16(f:pband_z80;reg:pparejas;valor:word);
procedure sbc_16(f:pband_z80;reg:pparejas;valor:word);

const z80t_ed:array[0..1,0..255] of byte=(
      //0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f
        (8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
         8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
         8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
         8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
        12,12,15,20, 8,14, 8, 9,12,12,15,20, 8,14, 8, 9,
        12,12,15,20, 8,14, 8, 9,12,12,15,20, 8,14, 8, 9,
        12,12,15,20, 8,14, 8,18,12,12,15,20, 8,14, 8,18,
        12,12,15,20, 8,14, 8, 8,12,12,15,20, 8,14, 8, 8,
         8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
         8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
        16,16,16,16, 8, 8, 8, 8,16,16,16,16, 8, 8, 8, 8,
        16,16,16,16, 8, 8, 8, 8,16,16,16,16, 8, 8, 8, 8,
         8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
         8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
         8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
         8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8), //$F0
        ( 4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
	 4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
	 4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
	 4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
	12, 12, 12, 20,  4, 12,  4,  8, 12, 12, 12, 20,  4, 12,  4,  8,
	12, 12, 12, 20,  4, 12,  4,  8, 12, 12, 12, 20,  4, 12,  4,  8,
	12, 12, 12, 20,  4, 12,  4, 16, 12, 12, 12, 20,  4, 12,  4, 16,
	12, 12, 12, 20,  4, 12,  4,  4, 12, 12, 12, 20,  4, 12,  4,  4,
	 4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
	 4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
	16, 12, 16, 16,  4,  4,  4,  4, 16, 12, 16, 16,  4,  4,  4,  4,
	16, 12, 16, 16,  4,  4,  4,  4, 16, 12, 16, 16,  4,  4,  4,  4,
	 4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
	 4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
	 4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
	 4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4));

implementation

procedure adc_16(f:pband_z80;reg:pparejas;valor:word);
var
        temp:parejas;
        carry:byte;
begin
 if f.c then carry:=1 else carry:=0;
 temp.w:=reg.w+valor+carry;
 f.p_v := ((reg.w Xor ((Not valor) And $0FFFF)) And (reg.w Xor temp.w) And $8000) <> 0;
 f.h := (((reg.w And $0FFF) + (valor And $0FFF) + carry) And $1000) <> 0;
 f.s:= (temp.h and 128) <> 0;
 f.z:=(temp.w=0);
 f.bit5:=(temp.h and 32) <> 0;
 f.bit3:=(temp.h and 8) <> 0;
 f.n:=false;
 f.c:=((reg.w+valor+carry) and $10000)<>0;
 reg^.w:=temp.w;
end;

procedure sbc_16(f:pband_z80;reg:pparejas;valor:word);
var
        carry:byte;
        temp:word;
begin

    If f.c Then carry:=1 else carry:=0;
    temp:= reg^.w - valor - carry;
    f.s:=(temp And $8000) <> 0;
    f.bit3:=(temp And $800) <> 0;
    f.bit5:=(temp And $2000) <> 0;
    f.z:=(temp = 0);
    f.c:=((reg^.w - valor - carry) And $10000) <> 0;
    f.P_V:=((reg^.w Xor valor) And (reg^.w Xor temp) And $8000) <> 0;
    f.h:= (((reg^.w And $0FFF) - (valor And $0FFF) - carry) And $1000) <> 0;
    f.n:=True;
    reg^.w:=temp;
end;

function exec_ed(r:preg_z80;ll:llam_z80):byte;
var
        instruccion,temp,temp2,temp3:byte;
        posicion:parejas;
        estados_demas:byte;
        band_temp:boolean;
begin
estados_demas:=0;
r.opcode:=true;
instruccion:=ll.getbyte(r.pc.w);
r.opcode:=false;
inc(r.pc.w);
r.r:=((r.r+1) and $7f) or (r.r and $80);
case instruccion of
        $00..$3f,$77,$7f..$9f,$a4..$a7,$ac..$af,$b4..$b7,$bc..$ff:; {nop*2}
        $40:begin {in B,(c)}
                r.bc.h:=ll.inbyte(r.bc.w);
                r.f.z:=(r.bc.h=0);
                r.f.s:=(r.bc.h And $80) <> 0;
                r.f.bit3:=(r.bc.h And 8) <> 0;
                r.f.bit5:=(r.bc.h And $20) <> 0;
                r.f.p_v:= paridad[r.bc.h];
                r.f.n:=false;
                r.f.h:=false;
            end;
        $41:ll.outbyte(r.bc.h,r.bc.w); {out (C),B}
        $42:sbc_16(@r.f,@r.hl,r.bc.w); {sbc HL,BC}
        $43:begin {ld (nn),BC}
                posicion.h:=ll.getbyte(r.pc.w+1);
                posicion.l:=ll.getbyte(r.pc.w);
                inc(r.pc.w,2);
                ll.putbyte(posicion.w,r.bc.l);
                ll.putbyte(posicion.w+1,r.bc.h);
            end;
        $44,$4c,$54,$5c,$64,$6c,$74,$7c:begin  {neg}
                temp:=r.a;
                r.a:=0;
                sub_8(r,temp);
            end;
        $45,$55,$65,$75:begin  {retn}
                pop_sp(@r.sp,ll,@r.pc);
                r.iff1:=r.iff2;
            end;
        $46,$4e,$66,$6e:r.im:=0; {im 0}
        $47:r.i:=r.a;  {ld I,A}
        $48:begin {in C,(C)}
                r.bc.l:=ll.inbyte(r.bc.w);
                r.f.z:=(r.bc.l=0);
                r.f.s:=(r.bc.l And $80) <> 0;
                r.f.bit3:=(r.bc.l And 8) <> 0;
                r.f.bit5:=(r.bc.l And $20) <> 0;
                r.f.p_v:=paridad[r.bc.l];
                r.f.n:=false;
                r.f.h:=false;
            end;
        $49:ll.outbyte(r.bc.l,r.bc.w); {out (C),C}
        $4a:adc_16(@r.f,@r.hl, r.bc.w); {adc HL,BC}
        $4b:begin  {ld BC,(nn)}
                posicion.h:=ll.getbyte(r.pc.w+1);
                posicion.l:=ll.getbyte(r.pc.w);
                inc(r.pc.w,2);
                r.bc.l:=ll.getbyte(posicion.w);
                r.bc.h:=ll.getbyte(posicion.w+1);
            end;
        {4c: neg}
        $4d,$5d,$6d,$7d:begin   {reti}
                r.iff1:=r.iff2;
                pop_sp(@r.sp,ll,@r.pc);
                if r.daisy then z80daisy_reti;
            end;
        {4e: im 0}
        $4f:r.r:=r.a; {ld R,A}
        $50:begin {in D,(c)}
                r.de.h:=ll.inbyte(r.bc.w);
                r.f.z:=(r.de.h=0);
                r.f.s:=(r.de.h And $80) <> 0;
                r.f.bit3:=(r.de.h And 8) <> 0;
                r.f.bit5:=(r.de.h And $20) <> 0;
                r.f.p_v:= paridad[r.de.h];
                r.f.n:=false;
                r.f.h:=false;
            end;
        $51:ll.outbyte(r.de.h,r.bc.w); {out (C),D}
        $52:sbc_16(@r.f,@r.hl,r.de.w); {sbc HL,DE}
        $53:begin {ld (nn),DE}
                posicion.h:=ll.getbyte(r.pc.w+1);
                posicion.l:=ll.getbyte(r.pc.w);
                inc(r.pc.w,2);
                ll.putbyte(posicion.w,r.de.l);
                ll.putbyte(posicion.w+1,r.de.h);
            end;
        {54: neg
        $55:retn}
        $56,$76:r.im:=1; {im 1}
        $57:begin  {ld A,I}
                r.a:=r.i;
                r.f.s:=(r.a and $80)<>0;
                r.f.z:=(r.a=0);
                r.f.bit5:=(r.a and $20)<>0;
                r.f.h:=false;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.p_v:=r.iff2;
                r.f.n:=false;
            end;
        $58:begin  {in E,(C)}
                r.de.l:=ll.inbyte(r.bc.w);
                r.f.z:=(r.de.l=0);
                r.f.s:=(r.de.l And $80) <> 0;
                r.f.bit3:=(r.de.l And 8) <> 0;
                r.f.bit5:=(r.de.l And $20) <> 0;
                r.f.p_v:= paridad[r.de.l];
                r.f.n:=false;
                r.f.h:=false;
            end;
        $59:ll.outbyte(r.de.l,r.bc.w); {out (C),E}
        $5a:adc_16(@r.f,@r.hl,r.de.w); {adc HL,DE}
        $5b:begin  {ld DE,(nn)}
                posicion.h:=ll.getbyte(r.pc.w+1);
                posicion.l:=ll.getbyte(r.pc.w);
                inc(r.pc.w,2);
                r.de.l:=ll.getbyte(posicion.w);
                r.de.h:=ll.getbyte(posicion.w+1);
            end;
        {5c:neg
        5d:reti}
        $5e,$7e:r.im:=2; {im 2}
        $5f:begin  {ld A,R}
                r.a:=r.r;
                r.f.h:=false;
                r.f.n:=false;
                r.f.p_v:=r.iff2;
                r.f.bit5:=(r.a and $20)<>0;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.s:=(r.a and $80)<>0;
                r.f.z:=(r.a=0);
            end;
        $60:begin  {in H,(c)}
                r.hl.h:=ll.inbyte(r.bc.w);
                r.f.z:=(r.hl.h=0);
                r.f.s:=(r.hl.h And $80) <> 0;
                r.f.bit3:=(r.hl.h And 8) <> 0;
                r.f.bit5:=(r.hl.h And $20) <> 0;
                r.f.p_v:= paridad[r.hl.h];
                r.f.n:=false;
                r.f.h:=false;
            end;
        $61:ll.outbyte(r.hl.h,r.bc.w); {out (C),H}
        $62:sbc_16(@r.f,@r.hl,r.hl.w); {sbc HL,HL}
        $63:begin {ld (nn),HL}
                posicion.h:=ll.getbyte(r.pc.w+1);
                posicion.l:=ll.getbyte(r.pc.w);
                inc(r.pc.w,2);
                ll.putbyte(posicion.w,r.hl.l);
                ll.putbyte(posicion.w+1,r.hl.h);
            end;
        {64:neg
        $65:retn
        $66:im 0}
        $67:begin {rrd}
                temp2:=ll.getbyte(r.hl.w);
                temp:=(r.a and $F)*16;
                r.a:=(r.a and $F0)+ (temp2 and $F);
                temp2:=(temp2 div 16) + temp;
                ll.putbyte(r.hl.w,temp2);
                r.f.s:=(r.a and $80)<>0;
                r.f.z:=(r.a=0);
                r.f.bit5:=(r.a and $20)<>0;
                r.f.h:=false;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.p_v:=paridad[r.a];
                r.f.n:=false;
            end;
        $68:begin {in L,(c)}
                r.hl.l:=ll.inbyte(r.bc.w);
                r.f.z:=(r.hl.l=0);
                r.f.s:=(r.hl.l And $80) <> 0;
                r.f.bit3:=(r.hl.l And 8) <> 0;
                r.f.bit5:=(r.hl.l And $20) <> 0;
                r.f.p_v:= paridad[r.hl.l];
                r.f.n:=false;
                r.f.h:=false;
             end;
        $69:ll.outbyte(r.hl.l,r.bc.w); {out (C),L}
        $6a:adc_16(@r.f,@r.hl,r.hl.w); {adc HL,HL}
        $6b:begin  {ld HL,(nn)}
                posicion.h:=ll.getbyte(r.pc.w+1);
                posicion.l:=ll.getbyte(r.pc.w);
                inc(r.pc.w,2);
                r.hl.l:=ll.getbyte(posicion.w);
                r.hl.h:=ll.getbyte(posicion.w+1);
            end;
        {6c:neg
        $6d:reti
        $6e:im 0}
        $6f:begin  {rld}
                temp2:=ll.getbyte(r.hl.w);
                temp:=r.a and $0f;
                r.a:=(r.a  and $F0)+ (temp2 div 16);
                temp2:=(temp2*16) + temp;
                ll.putbyte(r.hl.w,temp2);
                r.f.s:=(r.a and $80)<>0;
                r.f.z:=(r.a=0);
                r.f.bit5:=(r.a and $20)<>0;
                r.f.h:=false;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.p_v:=paridad[r.a];
                r.f.n:=false;
            end;
        $70:begin  {in (C)}
                temp:=ll.inbyte(r.bc.w);
                r.f.z:=(temp=0);
                r.f.s:=(temp And $80) <> 0;
                r.f.bit3:=(temp And 8) <> 0;
                r.f.bit5:=(temp And $20) <> 0;
                r.f.p_v:= paridad[temp];
                r.f.n:=false;
                r.f.h:=false;
            end;
        $71:ll.outbyte(0,r.bc.w); {out (C),0}
        $72:sbc_16(@r.f,@r.hl,r.sp.w); {sbc HL,SP}
        $73:begin {ld (nn),SP}
                posicion.h:=ll.getbyte(r.pc.w+1);
                posicion.l:=ll.getbyte(r.pc.w);
                inc(r.pc.w,2);
                ll.putbyte(posicion.w,r.sp.l);
                ll.putbyte(posicion.w+1,r.sp.h);
            end;
        {74:neg
        $75:retn
        $76:im 1
        $77:nop*2}
        $78:begin       {in A,(C)}
                r.a:=ll.inbyte(r.bc.w);
                r.f.z:=(r.a=0);
                r.f.s:=(r.a And $80) <> 0;
                r.f.bit3:=(r.a And 8) <> 0;
                r.f.bit5:=(r.a And $20) <> 0;
                r.f.p_v:= paridad[r.a];
                r.f.n:=false;
                r.f.h:=false;
            end;
        $79:ll.outbyte(r.a,r.bc.w); {out (C),A}
        $7a:adc_16(@r.f,@r.hl,r.sp.w); {adc HL,SP}
        $7b:begin  {ld SP,(nn)}
                posicion.h:=ll.getbyte(r.pc.w+1);
                posicion.l:=ll.getbyte(r.pc.w);
                inc(r.pc.w,2);
                r.sp.l:=ll.getbyte(posicion.w);
                r.sp.h:=ll.getbyte(posicion.w+1);
            end;
        {7c:neg
        $7d:reti
        $7e:im 2
        $7f..9c:nop*2}
        $a0:begin   {ldi}
                 temp:=ll.getbyte(r.hl.w);
                 inc(r.hl.w);
                 ll.putbyte(r.de.w,temp);
                 inc(r.de.w);
                 dec(r.bc.w);
                 r.f.p_v:=(r.bc.w<>0);
                 temp:=temp+r.a;
                 r.f.bit5:=(temp and 2)<>0;
                 r.f.bit3:=(temp and 8)<>0;
                 r.f.h:=false;
                 r.f.n:=false;
            end;
        $a1:begin  //cpi el primer programa que lo usa una demo!!!
                 //08 de feb 2003
                 temp2:=ll.getbyte(r.hl.w);
                 temp:=r.a-temp2;
                 temp3:=r.a xor temp2 xor temp;
                 inc(r.hl.w);
                 dec(r.bc.w);
                 r.f.s:=(temp and $80) <>0;
                 r.f.z:=(temp=0);
                 r.f.h:=(temp3 and 16) <> 0;
                 r.f.p_v:=(r.bc.w<>0);
                 r.f.n:=true;
                 r.f.bit5:=((temp - ((temp3 and 16) shr 4)) and 2)<>0;
                 r.f.bit3:=((temp - ((temp3 shr 4) and 1)) and 8)<>0;
             end;
        $a2:begin  //ini
                   //Primer juego que lo usa Titan 09 de Sep 2006
                 temp:=ll.inbyte(r.bc.w);
                 ll.putbyte(r.hl.w,temp);
                 dec(r.bc.h);
                 inc(r.hl.w);
                 r.f.z:=(r.bc.h=0);
                 r.f.n:= True;
            end;
        $a3:begin //outi el primer programa que lo usa una demo!!!
                 //08 de feb 2003
                 dec(r.bc.h);
                 ll.outbyte(ll.getbyte(r.hl.w),r.bc.w);
                 inc(r.hl.w);
                 r.f.z:=(r.bc.h=0);
                 r.f.n:= True;
             end;
        {$a4..$a7:nop*2}
        $a8:begin  {ldd}
                temp:=ll.getbyte(r.hl.w);
                dec(r.hl.w);
                ll.putbyte(r.de.w,temp);
                dec(r.de.w);
                dec(r.bc.w);
                if (r.bc.w<>0) then r.f.p_v:=true else r.f.p_v:=false;
                temp:=temp+r.a;
                r.f.bit5:=(temp and 2)<>0;
                r.f.bit3:=(temp and 8)<>0;
                r.f.h:=false;
                r.f.n:=false;
            end;
        $a9:begin //cpd el primer juego que la usa Ace 2
                 //20-09-04
                 temp2:=ll.getbyte(r.hl.w);
                 temp:=r.a-temp2;
                 temp3:=r.a xor temp2 xor temp;
                 dec(r.hl.w);
                 dec(r.bc.w);
                 r.f.s:=(temp and $80) <>0;
                 r.f.z:=(temp=0);
                 r.f.h:=(temp3 and 16) <> 0;
                 r.f.p_v:=(r.bc.w<>0);
                 r.f.n:=true;
                 r.f.bit5:=((temp - ((temp3 and 16) shr 4)) and 2)<>0;
                 r.f.bit3:=((temp - ((temp3 shr 4) and 1)) and 8)<>0;
           end;
        $aa:begin   //ind aadido el 03-12-08 usado por CPC test
                temp:=ll.inbyte(r.bc.w);
                dec(r.bc.h);
                ll.putbyte(r.hl.w,temp);
                dec(r.hl.w);
                r.f.z:=(r.bc.h=0);
                r.f.n:= True;
            end;
        $ab:begin   {outd}
                dec(r.bc.h);
                ll.outbyte(ll.getbyte(r.hl.w),r.bc.w);
                dec(r.hl.w);
                r.f.z:=(r.bc.h=0);
                r.f.n:= True;
            end;
        {ac..$af:nop*2}
        $b0:begin {ldir}
                 temp:=ll.getbyte(r.hl.w);
                 inc(r.hl.w);
                 ll.putbyte(r.de.w,temp);
                 inc(r.de.w);
                 dec(r.bc.w);
                 if (r.bc.w<>0) then begin
                        dec(r.pc.w,2);
                        estados_demas:=5;
                        r.f.p_v:=true;
                 end else r.f.p_v:=false;
                 temp:=temp+r.a;
                 r.f.bit5:=(temp and 2)<>0;
                 r.f.bit3:=(temp and 8)<>0;
                 r.f.h:=false;
                 r.f.n:=false;
             end;
        $b1:begin  {cpir}
                temp2:=ll.getbyte(r.hl.w);
                temp:=r.a-temp2;
                temp3:=r.a xor temp2 xor temp;
                inc(r.hl.w);
                dec(r.bc.w);
                r.f.s:=(temp and $80) <>0;
                r.f.z:=(temp=0);
                r.f.h:=(temp3 and 16) <> 0;
                r.f.p_v:=(r.bc.w<>0);
                r.f.n:=true;
                r.f.bit5:=((temp-((temp3 and 16) shr 4)) and 2)<>0;
                r.f.bit3:=((temp-((temp3 shr 4) and 1)) and 8)<>0;
                If (r.f.p_v And not(r.f.z)) then begin
                        estados_demas:=5;
                        dec(r.pc.w,2);
                end;
            end;
        $b2:begin  //inir aadido el 05-10-08, lo usa una rom de Coleco!
                temp:=ll.inbyte(r.bc.w);
                ll.putbyte(r.hl.w,temp);
                dec(r.bc.h);
                inc(r.hl.w);
                r.f.z:=(r.bc.h=0);
                r.f.n:= True;
                if r.bc.h<>0 then begin
                  dec(r.pc.w,2);
                  estados_demas:=5;
                end;
           end;
        $b3:begin //otir aadido el dia 18-09-04
                dec(r.bc.h);
                ll.outbyte(ll.getbyte(r.hl.w),r.bc.w);
                inc(r.hl.w);
                r.f.z:=true;
                r.f.n:= True;
                if r.bc.h<>0 then begin
                  dec(r.pc.w,2);
                  estados_demas:=5;
                end;
            end;
        { $b4..$b7:nop*2}
        $0b8:begin {lddr}
                 temp:=ll.getbyte(r.hl.w);
                 dec(r.hl.w);
                 ll.putbyte(r.de.w,temp);
                 dec(r.de.w);
                 dec(r.bc.w);
                 if (r.bc.w<>0) then begin
                        dec(r.pc.w,2);
                        estados_demas:=5;
                        r.f.p_v:=true;
                 end else r.f.p_v:=false;
                 temp:=temp+r.a;
                 r.f.bit5:=(temp and 2)<>0;
                 r.f.bit3:=(temp and 8)<>0;
                 r.f.h:=false;
                 r.f.n:=false;
             end;
        $b9:begin   {cpdr}
                 temp2:=ll.getbyte(r.hl.w);
                 temp:=r.a-temp2;
                 temp3:=r.a xor temp2 xor temp;
                 dec(r.hl.w);
                 dec(r.bc.w);
                 r.f.s:=(temp and $80) <>0;
                 r.f.z:=(temp=0);
                 r.f.h:=(temp3 and 16) <> 0;
                 r.f.p_v:=(r.bc.w<>0);
                 r.f.n:=true;
                 r.f.bit5:=((temp - ((temp3 and 16) shr 4)) and 2)<>0;
                 r.f.bit3:=((temp - ((temp3 shr 4) and 1)) and 8)<>0;
                 if r.f.p_v and not(r.f.z) then begin
                     dec(r.pc.w,2);
                     estados_demas:=5;
                 end;
             end;
        {ba:indr
        $bb:otdr}

else
        MessageDlg('Instruccion: '+inttostr(instruccion)+' desconocida ED. PC='+inttostr(r.pc.w), mtInformation,[mbOk], 0)
end;
exec_ed:=z80t_ed[r.tabla,instruccion]+estados_demas;
end;

end.
