unit pia8255;

interface
uses windows,dialogs;

type
  tpia8255=record
		wreg:array[0..2] of byte;
		rreg:array[0..2] of byte;
		rmask:array[0..2] of byte;
		mode:array[0..2] of byte;
		first:array[0..2] of boolean;
  end;
  ptpia8255=^tpia8255;

var
  pia_8255:array[0..1] of ptpia8255;

procedure reset_8255(num:byte);
procedure init_8255(num:byte);
procedure write_8255(addr:word;data,num:byte);
function read_8255(addr:word;num:byte):byte;

implementation


procedure reset_8255(num:byte);
var
  i:byte;
  pia:ptpia8255;
begin
  pia:=pia_8255[num];
	for i:=0 to 2 do begin
		pia.rmask[i]:=$ff;
		pia.first[i]:=true;
		pia.mode[i]:=0;
  end;
end;

procedure init_8255(num:byte);
begin
  getmem(pia_8255[num],sizeof(tpia8255));
  zeromemory(pia_8255[num],sizeof(tpia8255));
end;

procedure write_8255(addr:word;data,num:byte);
var
  ch,i:byte;
  pia:ptpia8255;
  bit:integer;
  val:byte;
begin
  pia:=pia_8255[num];
	ch:= addr and 3;
	case ch of
	0,1,2:begin
		      if ((pia.wreg[ch]<>data) or pia.first[ch]) then begin
			      pia.wreg[ch]:=data;
			      pia.first[ch]:=false;
          end;
        end;
	3:begin
		if (data and $80)<>0 then begin
			if (data and $10)<>0 then pia.rmask[0]:=$ff
        else pia.rmask[0]:=0;
			pia.mode[0]:= (data shr 5) and 3;
      if (data and 2)<>0 then pia.rmask[1]:=$ff
        else pia.rmask[1]:=0;
			pia.mode[1]:= (data shr 2) and 1;
      if (data and 8)<>0 then pia.rmask[2]:=$f0
        else pia.rmask[2]:=0;
      if (data and 1)<>0 then pia.rmask[2]:=pia.rmask[2] or $f
        else pia.rmask[2]:=pia.rmask[2] or 0;
		end else begin
			val:=pia.wreg[2];
			bit:= (data shl 1) and 7;
			if(data and 1)<>0 then val:=val or (1 shl bit)
			  else val:=val and not(1 shl bit);
			write_8255(2,val,num);
    end;
    end;
  end;
end;

function read_8255(addr:word;num:byte):byte;
var
  ret:byte;
  ch:byte;
  pia:ptpia8255;
begin
  pia:=pia_8255[num];
  ret:=$ff;
  ch:=addr and $3;
  ret:=(pia.rreg[ch] and pia.rmask[ch]) or (pia.wreg[ch] and not(pia.rmask[ch]));
end;

end.
