unit entradas;

interface

uses sdl,constantes;

type
    def_raton = record
        x,y:word;
        boton1,boton2:boolean;
    end;
    def_joystick = record
        arriba,abajo,izq,der,boton0,boton1,boton2,boton3:boolean;
        val_centrado:integer;
        eje_una,eje_centrado:boolean;
    end;
    def_evento = record
        raton,joystick,teclado:boolean;
    end;

procedure evaluar_entradas;
procedure iniciar_entradas;

var
    joystick:def_joystick;
    raton:def_raton;
    evento:def_evento;
    teclado:array [0..65000] of boolean;

implementation
uses principal;

procedure iniciar_entradas;
var
  f:word;
begin
if(SDL_NumJoysticks>0) then begin
  joystick.val_centrado:=0;
  joystick.eje_una:=false;
  joystick.eje_centrado:=false;
  joystick.arriba:=false;
  joystick.abajo:=false;
  joystick.izq:=false;
  joystick.der:=false;
  joystick.boton0:=false;
  joystick.boton1:=false;
  joystick.boton2:=false;
  joystick.boton3:=false;
end;
raton.boton1:=false;
raton.boton2:=false;
raton.x:=0;
raton.y:=0;
evento.raton:=false;
evento.joystick:=false;
for f:=0 to 65000 do teclado[f]:=false;
end;

procedure evaluar_entradas;
var
  keystate:PKeyStateArr;
  jvalor:integer;
begin
inc(frames_sec);
evento.raton:=false;
evento.joystick:=false;
evento.teclado:=false;
if SDL_PollEvent(@event)<>0 then begin
  case event.type_ of
    SDL_MOUSEMOTION:begin
      raton.x:=event.motion.x;
      raton.y:=event.motion.y;
      evento.raton:=true;
    end;
    SDL_MOUSEBUTTONUP:begin
        evento.raton:=true;
        case event.button.button of
          SDL_BUTTON_LEFT:raton.boton1:=false;
          SDL_BUTTON_RIGHT:raton.boton2:=false;
        end;
    end;
    SDL_MOUSEBUTTONDOWN:begin
       evento.raton:=true;
       case event.button.button of
          SDL_BUTTON_LEFT:raton.boton1:=true;
          SDL_BUTTON_RIGHT:raton.boton2:=true;
       end;
    end;
    SDL_KEYUP:begin
    keystate := PKeyStateArr(SDL_GetKeyState(nil));
    evento.teclado:=true;
    if (keystate[SDLK_ESCAPE]=0) then teclado[SDLK_ESCAPE]:=false;
    if (keystate[SDLK_CAPSLOCK]=0) then teclado[SDLK_CAPSLOCK]:=false;
    if (keystate[SDLK_TAB]=0) then teclado[SDLK_TAB]:=false;
    if (keystate[SDLK_SLASH]=0) then teclado[SDLK_SLASH]:=false;
    if (keystate[SDLK_QUOTE]=0) then teclado[SDLK_QUOTE]:=false;
    if (keystate[SDLK_SEMICOLON]=0) then teclado[SDLK_SEMICOLON]:=false;
    if (keystate[SDLK_BACKSLASH]=0) then teclado[SDLK_BACKSLASH]:=false;
    if (keystate[SDLK_LESS]=0) then teclado[SDLK_LESS]:=false;
    if (keystate[SDLK_HOME]=0) then teclado[SDLK_HOME]:=false;
    if (keystate[SDLK_RIGHT]=0) then teclado[SDLK_RIGHT]:=false;
    if (keystate[SDLK_LEFT]=0) then teclado[SDLK_LEFT]:=false;
    if (keystate[SDLK_DOWN]=0) then teclado[SDLK_DOWN]:=false;
    if (keystate[SDLK_UP]=0) then teclado[SDLK_UP]:=false;
    if (keystate[SDLK_RALT]=0) then teclado[SDLK_RALT]:=false;
    if (keystate[SDLK_LALT]=0) then teclado[SDLK_LALT]:=false;
    if (keystate[SDLK_RSHIFT]=0) then teclado[SDLK_RSHIFT]:=false;
    if (keystate[SDLK_LSHIFT]=0) then teclado[SDLK_LSHIFT]:=false;
    if (keystate[SDLK_RCTRL]=0) then teclado[SDLK_RCTRL]:=false;
    if (keystate[SDLK_LCTRL]=0) then teclado[SDLK_LCTRL]:=false;
    if (keystate[SDLK_RETURN]=0) then teclado[SDLK_RETURN]:=false;
    if (keystate[SDLK_BACKSPACE]=0) then teclado[SDLK_BACKSPACE]:=false;
    if (keystate[SDLK_MINUS]=0) then teclado[SDLK_MINUS]:=false;
    if (keystate[SDLK_COMMA]=0) then teclado[SDLK_COMMA]:=false;
    if (keystate[SDLK_SPACE]=0) then teclado[SDLK_SPACE]:=false;
    if (keystate[SDLK_0]=0) then teclado[SDLK_0]:=false;
    if (keystate[SDLK_1]=0) then teclado[SDLK_1]:=false;
    if (keystate[SDLK_2]=0) then teclado[SDLK_2]:=false;
    if (keystate[SDLK_3]=0) then teclado[SDLK_3]:=false;
    if (keystate[SDLK_4]=0) then teclado[SDLK_4]:=false;
    if (keystate[SDLK_5]=0) then teclado[SDLK_5]:=false;
    if (keystate[SDLK_6]=0) then teclado[SDLK_6]:=false;
    if (keystate[SDLK_7]=0) then teclado[SDLK_7]:=false;
    if (keystate[SDLK_8]=0) then teclado[SDLK_8]:=false;
    if (keystate[SDLK_9]=0) then teclado[SDLK_9]:=false;
    if (keystate[SDLK_F1]=0) then teclado[SDLK_F1]:=false;
    if (keystate[SDLK_F2]=0) then teclado[SDLK_F2]:=false;
    if (keystate[SDLK_F3]=0) then teclado[SDLK_F3]:=false;
    if (keystate[SDLK_F4]=0) then teclado[SDLK_F4]:=false;
    if (keystate[SDLK_F5]=0) then teclado[SDLK_F5]:=false;
    if (keystate[SDLK_F6]=0) then teclado[SDLK_F6]:=false;
    if (keystate[SDLK_F7]=0) then teclado[SDLK_F7]:=false;
    if (keystate[SDLK_F8]=0) then teclado[SDLK_F8]:=false;
    if (keystate[SDLK_F9]=0) then teclado[SDLK_F9]:=false;
    if (keystate[SDLK_F10]=0) then teclado[SDLK_F10]:=false;
    if (keystate[SDLK_F11]=0) then teclado[SDLK_F11]:=false;
    if (keystate[SDLK_F12]=0) then teclado[SDLK_F12]:=false;
    if (keystate[SDLK_A]=0) then teclado[SDLK_A]:=false;
    if (keystate[SDLK_B]=0) then teclado[SDLK_B]:=false;
    if (keystate[SDLK_C]=0) then teclado[SDLK_C]:=false;
    if (keystate[SDLK_D]=0) then teclado[SDLK_D]:=false;
    if (keystate[SDLK_E]=0) then teclado[SDLK_E]:=false;
    if (keystate[SDLK_F]=0) then teclado[SDLK_F]:=false;
    if (keystate[SDLK_G]=0) then teclado[SDLK_G]:=false;
    if (keystate[SDLK_H]=0) then teclado[SDLK_H]:=false;
    if (keystate[SDLK_I]=0) then teclado[SDLK_I]:=false;
    if (keystate[SDLK_J]=0) then teclado[SDLK_J]:=false;
    if (keystate[SDLK_K]=0) then teclado[SDLK_K]:=false;
    if (keystate[SDLK_L]=0) then teclado[SDLK_L]:=false;
    if (keystate[SDLK_M]=0) then teclado[SDLK_M]:=false;
    if (keystate[SDLK_N]=0) then teclado[SDLK_N]:=false;
    if (keystate[SDLK_O]=0) then teclado[SDLK_O]:=false;
    if (keystate[SDLK_P]=0) then teclado[SDLK_P]:=false;
    if (keystate[SDLK_Q]=0) then teclado[SDLK_Q]:=false;
    if (keystate[SDLK_R]=0) then teclado[SDLK_R]:=false;
    if (keystate[SDLK_S]=0) then teclado[SDLK_S]:=false;
    if (keystate[SDLK_T]=0) then teclado[SDLK_T]:=false;
    if (keystate[SDLK_U]=0) then teclado[SDLK_U]:=false;
    if (keystate[SDLK_V]=0) then teclado[SDLK_V]:=false;
    if (keystate[SDLK_W]=0) then teclado[SDLK_W]:=false;
    if (keystate[SDLK_X]=0) then teclado[SDLK_X]:=false;
    if (keystate[SDLK_Y]=0) then teclado[SDLK_Y]:=false;
    if (keystate[SDLK_Z]=0) then teclado[SDLK_Z]:=false;
    end;
    SDL_KEYDOWN:begin
    keystate := PKeyStateArr(SDL_GetKeyState(nil));
    evento.teclado:=true;
    if (keystate[SDLK_ESCAPE]<>0) then teclado[SDLK_ESCAPE]:=true;
    if (keystate[SDLK_CAPSLOCK]<>0) then teclado[SDLK_CAPSLOCK]:=true;
    if (keystate[SDLK_TAB]<>0) then teclado[SDLK_TAB]:=true;
    if (keystate[SDLK_SLASH]<>0) then teclado[SDLK_SLASH]:=true;
    if (keystate[SDLK_QUOTE]<>0) then teclado[SDLK_QUOTE]:=true;
    if (keystate[SDLK_LESS]<>0) then teclado[SDLK_LESS]:=true;
    if (keystate[SDLK_SEMICOLON]<>0) then teclado[SDLK_SEMICOLON]:=true;
    if (keystate[SDLK_BACKSLASH]<>0) then teclado[SDLK_BACKSLASH]:=true;
    if (keystate[SDLK_HOME]<>0) then teclado[SDLK_HOME]:=true;
    if (keystate[SDLK_RIGHT]<>0) then teclado[SDLK_RIGHT]:=true;
    if (keystate[SDLK_LEFT]<>0) then teclado[SDLK_LEFT]:=true;
    if (keystate[SDLK_DOWN]<>0) then teclado[SDLK_DOWN]:=true;
    if (keystate[SDLK_UP]<>0) then teclado[SDLK_UP]:=true;
    if (keystate[SDLK_RALT]<>0) then teclado[SDLK_RALT]:=true;
    if (keystate[SDLK_LALT]<>0) then teclado[SDLK_LALT]:=true;
    if (keystate[SDLK_RSHIFT]<>0) then teclado[SDLK_RSHIFT]:=true;
    if (keystate[SDLK_LSHIFT]<>0) then teclado[SDLK_LSHIFT]:=true;
    if (keystate[SDLK_RCTRL]<>0) then teclado[SDLK_RCTRL]:=true;
    if (keystate[SDLK_LCTRL]<>0) then teclado[SDLK_LCTRL]:=true;
    if (keystate[SDLK_RETURN]<>0) then teclado[SDLK_RETURN]:=true;
    if (keystate[SDLK_BACKSPACE]<>0) then teclado[SDLK_BACKSPACE]:=true;
    if (keystate[SDLK_MINUS]<>0) then teclado[SDLK_MINUS]:=true;
    if (keystate[SDLK_COMMA]<>0) then teclado[SDLK_COMMA]:=true;
    if (keystate[SDLK_SPACE]<>0) then teclado[SDLK_SPACE]:=true;
    if (keystate[SDLK_0]<>0) then teclado[SDLK_0]:=true;
    if (keystate[SDLK_1]<>0) then teclado[SDLK_1]:=true;
    if (keystate[SDLK_2]<>0) then teclado[SDLK_2]:=true;
    if (keystate[SDLK_3]<>0) then teclado[SDLK_3]:=true;
    if (keystate[SDLK_4]<>0) then teclado[SDLK_4]:=true;
    if (keystate[SDLK_5]<>0) then teclado[SDLK_5]:=true;
    if (keystate[SDLK_6]<>0) then teclado[SDLK_6]:=true;
    if (keystate[SDLK_7]<>0) then teclado[SDLK_7]:=true;
    if (keystate[SDLK_8]<>0) then teclado[SDLK_8]:=true;
    if (keystate[SDLK_9]<>0) then teclado[SDLK_9]:=true;
    if (keystate[SDLK_F1]<>0) then teclado[SDLK_F1]:=true;
    if (keystate[SDLK_F2]<>0) then begin
      if not(teclado[SDLK_RSHIFT]) then Form1.fFast(nil)
        else teclado[SDLK_F2]:=true;
    end;
    if (keystate[SDLK_F3]<>0) then begin
      if not(teclado[SDLK_RSHIFT]) then Form1.Reset1Click(nil)
        else teclado[SDLK_F3]:=true;
    end;
    if ((keystate[SDLK_F4]<>0) and not(pantalla_completa)) then begin
      if not(teclado[SDLK_RSHIFT]) then begin
        if addr(llamadas_maquina.grabar_snapshot)<>nil then llamadas_maquina.grabar_snapshot;
        keystate[SDLK_F4]:=0;
      end else teclado[SDLK_F4]:=true;
    end;
    if (keystate[SDLK_F5]<>0) then teclado[SDLK_F5]:=true;
    if (keystate[SDLK_F6]<>0) then teclado[SDLK_F6]:=true;
    if (keystate[SDLK_F7]<>0) then teclado[SDLK_F7]:=true;
    if (keystate[SDLK_F8]<>0) then teclado[SDLK_F8]:=true;
    if (keystate[SDLK_F9]<>0) then teclado[SDLK_F9]:=true;
    if (keystate[SDLK_F10]<>0) then teclado[SDLK_F10]:=true;
    if (keystate[SDLK_F11]<>0) then form1.fSlow(nil);
    if (keystate[SDLK_F12]<>0) then teclado[SDLK_F12]:=true;
    if (keystate[SDLK_A]<>0) then teclado[SDLK_A]:=true;
    if (keystate[SDLK_B]<>0) then teclado[SDLK_B]:=true;
    if (keystate[SDLK_C]<>0) then teclado[SDLK_C]:=true;
    if (keystate[SDLK_D]<>0) then teclado[SDLK_D]:=true;
    if (keystate[SDLK_E]<>0) then teclado[SDLK_E]:=true;
    if (keystate[SDLK_F]<>0) then teclado[SDLK_F]:=true;
    if (keystate[SDLK_G]<>0) then teclado[SDLK_G]:=true;
    if (keystate[SDLK_H]<>0) then teclado[SDLK_H]:=true;
    if (keystate[SDLK_I]<>0) then teclado[SDLK_I]:=true;
    if (keystate[SDLK_J]<>0) then teclado[SDLK_J]:=true;
    if (keystate[SDLK_K]<>0) then teclado[SDLK_K]:=true;
    if (keystate[SDLK_L]<>0) then teclado[SDLK_L]:=true;
    if (keystate[SDLK_M]<>0) then teclado[SDLK_M]:=true;
    if (keystate[SDLK_N]<>0) then teclado[SDLK_N]:=true;
    if (keystate[SDLK_O]<>0) then teclado[SDLK_O]:=true;
    if (keystate[SDLK_P]<>0) then teclado[SDLK_P]:=true;
    if (keystate[SDLK_Q]<>0) then teclado[SDLK_Q]:=true;
    if (keystate[SDLK_R]<>0) then teclado[SDLK_R]:=true;
    if (keystate[SDLK_S]<>0) then teclado[SDLK_S]:=true;
    if (keystate[SDLK_T]<>0) then teclado[SDLK_T]:=true;
    if (keystate[SDLK_U]<>0) then teclado[SDLK_U]:=true;
    if (keystate[SDLK_V]<>0) then teclado[SDLK_V]:=true;
    if (keystate[SDLK_W]<>0) then teclado[SDLK_W]:=true;
    if (keystate[SDLK_X]<>0) then teclado[SDLK_X]:=true;
    if (keystate[SDLK_Y]<>0) then teclado[SDLK_Y]:=true;
    if (keystate[SDLK_Z]<>0) then teclado[SDLK_Z]:=true;
    end;
    SDL_JOYBUTTONUP:begin
      evento.joystick:=true;
      case event.jbutton.button of
        0:joystick.boton0:=false;
        1:joystick.boton1:=false;
        2:joystick.boton2:=false;
        3:joystick.boton3:=false;
      end;
      exit;
    end;
    SDL_JOYBUTTONDOWN:begin
      evento.joystick:=true;
      case event.jbutton.button of
        0:joystick.boton0:=true;
        1:joystick.boton1:=true;
        2:joystick.boton2:=true;
        3:joystick.boton3:=true;
      end;
      exit;
    end;
    SDL_JOYAXISMOTION:begin
        evento.joystick:=true;
        jvalor:=event.jaxis.value+32768;
          case event.jaxis.axis of
            0:begin
                if not(joystick.eje_centrado) then begin
                  if not(joystick.eje_una) then begin
                    joystick.eje_una:=true;
                    exit;
                  end;
                  joystick.val_centrado:=jvalor;
                  joystick.eje_centrado:=true;
                  exit;
                end;
                if ((jvalor>=(joystick.val_centrado-2000)) and (jvalor<=(joystick.val_centrado+2000))) then begin
                  joystick.izq:=false;
                  joystick.der:=false;
                  exit;
                end;
                if (jvalor<=(joystick.val_centrado-2000)) then joystick.izq:=true;
                if (jvalor>=(joystick.val_centrado+2000)) then joystick.der:=true;
              end;
            1:begin
              if not(joystick.eje_centrado) then begin
                  if not(joystick.eje_una) then begin
                    joystick.eje_una:=true;
                    exit;
                  end;
                  joystick.val_centrado:=jvalor;
                  joystick.eje_centrado:=true;
                  exit;
                end;
                if ((jvalor>=(joystick.val_centrado-2000)) and (jvalor<=(joystick.val_centrado+2000))) then begin
                  joystick.arriba:=false;
                  joystick.abajo:=false;
                  exit;
                end;
                if (jvalor<=(joystick.val_centrado-2000)) then joystick.arriba:=true;
                if (jvalor>=(joystick.val_centrado+2000)) then joystick.abajo:=true;
            end;
          end;
    end;
  end;
end;
end;

end.
