unit init_games;

interface
uses sysutils;

type
  tgame_desc=record
              name,year:string;
              snd,hi:boolean;
              zip:string;
            end;
const
  games_cont=54;
  games_grid:array[1..games_cont] of word=(0,1,2,3,4,5,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,
                            32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,100,101);
  games_desc:array[1..games_cont] of tgame_desc=(
  (name:'Spectrum 48K';year:'1982';snd:true;hi:false;zip:'spectrum.zip'),
  (name:'Spectrum 128K';year:'1986';snd:true;hi:false;zip:'spec128.zip'),
  (name:'Spectrum +3';year:'1987';snd:true;hi:false;zip:'plus3.zip'),
  (name:'Amstrad CPC 464';year:'1984';snd:true;hi:false;zip:'cpc464.zip'),
  (name:'Amstrad CPC 664';year:'1984';snd:true;hi:false;zip:'cpc664.zip'),
  (name:'Amstrad CPC 6128';year:'1985';snd:true;hi:false;zip:'cpc6128.zip'),
  (name:'Pacman';year:'1980';snd:true;hi:false;zip:'pacman.zip'),
  (name:'Phoenix';year:'1980';snd:true;hi:false;zip:'phoenix.zip'),
  (name:'Mysterious Stones';year:'1984';snd:true;hi:false;zip:'mystston.zip'),
  (name:'Bomb Jack';year:'1984';snd:true;hi:false;zip:'bombjack.zip'),
  (name:'Frogger';year:'1981';snd:true;hi:true;zip:'frogger.zip'),
  (name:'Donkey Kong';year:'1981';snd:false;hi:false;zip:'dkong.zip'),
  (name:'Black Tiger';year:'1986';snd:true;hi:true;zip:'blktiger.zip'),
  (name:'Green Beret';year:'1985';snd:true;hi:true;zip:'gberet.zip'),
  (name:'Commando';year:'1985';snd:true;hi:false;zip:'commando.zip'),
  (name:'Ghost and Goblins';year:'1985';snd:true;hi:false;zip:'gng.zip'),
  (name:'Mikie';year:'1985';snd:true;hi:false;zip:'mikie.zip'),
  (name:'Shaolin''s Road';year:'1985';snd:true;hi:false;zip:'shaolins.zip'),
  (name:'Yie Ar Kung-Fu';year:'1985';snd:true;hi:false;zip:'yiear.zip'),
  (name:'Asteroids';year:'1979';snd:true;hi:false;zip:'asteroid.zip'),
  (name:'Son Son';year:'1984';snd:true;hi:false;zip:'sonson.zip'),
  (name:'Star Force';year:'1984';snd:false;hi:false;zip:'starforc.zip'),
  (name:'Rygar';year:'1986';snd:true;hi:false;zip:'rygar.zip'),
  (name:'Pitfall II';year:'1984';snd:true;hi:false;zip:'pitfall2.zip'),
  (name:'Pooyan';year:'1982';snd:true;hi:false;zip:'pooyan.zip'),
  (name:'Jungler';year:'1981';snd:true;hi:false;zip:'jungler.zip'),
  (name:'City Connection';year:'1986';snd:true;hi:false;zip:'citycon.zip'),
  (name:'Burger Time';year:'1982';snd:true;hi:false;zip:'btime.zip'),
  (name:'Express Raider';year:'1986';snd:true;hi:false;zip:'exprraid.zip'),
  (name:'Super Basketball';year:'1984';snd:true;hi:false;zip:'sbasketb.zip'),
  (name:'Lady Bug';year:'1981';snd:true;hi:false;zip:'ladybug.zip'),
  (name:'Teddy Boy Blues';year:'1985';snd:true;hi:false;zip:'teddybb.zip'),
  (name:'Wonder Boy';year:'1986';snd:true;hi:false;zip:'wboy.zip'),
  (name:'Wonder Boy in Monster Land';year:'1987';snd:true;hi:false;zip:'wbml.zip'),
  (name:'Tehkan World Cup';year:'1985';snd:true;hi:false;zip:'tehkanwc.zip'),
  (name:'Popeye';year:'1982';snd:true;hi:false;zip:'popeye.zip'),
  (name:'Psychic 5';year:'1987';snd:true;hi:false;zip:'psychic5.zip'),
  (name:'Terra Cresta';year:'198X';snd:false;hi:false;zip:'terracre.zip'),
  (name:'Kung-Fu Master';year:'1987';snd:false;hi:false;zip:'kungfum.zip'),
  (name:'Shoot Out';year:'1985';snd:true;hi:false;zip:'shootout.zip'),
  (name:'Vigilante';year:'1988';snd:true;hi:false;zip:'vigilant.zip'),
  (name:'Jackal';year:'1986';snd:true;hi:false;zip:'jackal.zip'),
  (name:'Bubble Bobble';year:'1986';snd:false;hi:false;zip:'bublbobl.zip'),
  (name:'Galaxian';year:'1980';snd:false;hi:false;zip:'galaxian.zip'),
  (name:'Jump Bug';year:'1981';snd:true;hi:false;zip:'jumpbug.zip'),
  (name:'Moon Cresta';year:'1980';snd:false;hi:false;zip:'mooncrst.zip'),
  (name:'Rally X';year:'1980';snd:true;hi:false;zip:'rallyx.zip'),
  (name:'Prehistoric Isle 1930';year:'1980';snd:false;hi:false;zip:'prehisle.zip'),
  (name:'Tiger Road';year:'1987';snd:true;hi:false;zip:'tigeroad.zip'),
  (name:'F1 Dream';year:'1988';snd:true;hi:false;zip:'f1dream.zip'),
  (name:'Snowbros';year:'1980';snd:false;hi:false;zip:'snowbros.zip'),
  (name:'Toki';year:'1989';snd:true;hi:false;zip:'toki.zip'),
  (name:'NES';year:'198X';snd:false;hi:false;zip:''),
  (name:'ColecoVision';year:'1980';snd:true;hi:false;zip:'coleco.zip'));

procedure load_game(numero:word);

implementation

uses principal;

procedure load_game(numero: word);
begin
case games_grid[numero] of
  0:form1.CambiarMaquina(form1.Spectrum48K1);
  1:form1.CambiarMaquina(form1.Spectrum128K1);
  2:form1.CambiarMaquina(form1.Spectrum31);
  3:form1.CambiarMaquina(form1.cpc1);
  4:form1.CambiarMaquina(form1.cpc6641);
  5:form1.CambiarMaquina(form1.cpc61281);
  10:form1.CambiarMaquina(form1.Pacman1);
  11:form1.CambiarMaquina(form1.Phoenix1);
  12:form1.CambiarMaquina(form1.MisteriousStone1);
  13:form1.CambiarMaquina(form1.BombJack1);
  14:form1.CambiarMaquina(form1.Frogger1);
  15:form1.CambiarMaquina(form1.Dkong1);
  16:form1.CambiarMaquina(form1.Blacktiger1);
  17:form1.CambiarMaquina(form1.Gberet1);
  18:form1.CambiarMaquina(form1.Commando1);
  19:form1.CambiarMaquina(form1.gng1);
  20:form1.CambiarMaquina(form1.Mikie1);
  21:form1.CambiarMaquina(form1.Shaolin1);
  22:form1.CambiarMaquina(form1.Yiear1);
  23:form1.CambiarMaquina(form1.Asteroids1);
  24:form1.CambiarMaquina(form1.SonSon1);
  25:form1.CambiarMaquina(form1.StarForce1);
  26:form1.CambiarMaquina(form1.Rygar1);
  27:form1.CambiarMaquina(form1.PitfallII1);
  28:form1.CambiarMaquina(form1.Pooyan1);
  29:form1.CambiarMaquina(form1.jungler1);
  30:form1.CambiarMaquina(form1.citycon1);
  31:form1.CambiarMaquina(form1.burgertime1);
  32:form1.CambiarMaquina(form1.expressraider1);
  33:form1.CambiarMaquina(form1.superbasketball1);
  34:form1.CambiarMaquina(form1.ladybug1);
  35:form1.CambiarMaquina(form1.teddy1);
  36:form1.CambiarMaquina(form1.wboy1);
  37:form1.CambiarMaquina(form1.wbml1);
  38:form1.CambiarMaquina(form1.tehkanwc1);
  39:form1.CambiarMaquina(form1.popeye1);
  40:form1.CambiarMaquina(form1.psychic51);
  41:form1.CambiarMaquina(form1.terracre1);
  42:form1.CambiarMaquina(form1.kungfum1);
  43:form1.CambiarMaquina(form1.shootout1);
  44:form1.CambiarMaquina(form1.vigilante1);
  45:form1.CambiarMaquina(form1.jackal1);
  46:form1.CambiarMaquina(form1.bubblebobble1);
  47:form1.CambiarMaquina(form1.galaxian1);
  48:form1.CambiarMaquina(form1.jumpb1);
  49:form1.CambiarMaquina(form1.mooncresta1);
  50:form1.CambiarMaquina(form1.rallyx1);
  51:form1.CambiarMaquina(form1.prehisle1);
  52:form1.CambiarMaquina(form1.tigerRoad1);
  53:form1.CambiarMaquina(form1.f1dream1);
  54:form1.CambiarMaquina(form1.snowbros1);
  55:form1.CambiarMaquina(form1.toki1);
  100:form1.CambiarMaquina(form1.NES1);
  101:form1.CambiarMaquina(form1.colecovision1);
end;
end;



end.
