unit spectrum_128k;

interface
uses sdl,constantes,ay_8910,z80_sp,z80,windows,sysutils,entradas,dialogs,lenguaje;

var
   memoria_128k:array[0..9,0..16384] of byte;

procedure Cargar_Spectrum128K;
procedure spectrum128_main;pascal;
function spec128_getbyte(direccion:word): Byte; pascal;
procedure spec128_putbyte(direccion:word;valor:byte);pascal;
function spec128_inbyte(puerto:word):byte;pascal;
procedure spec128_outbyte(valor:byte;puerto:word);pascal;
function iniciar_128k:boolean;pascal;
function get_context_128k:preg_z80;
procedure spec128k_reset;pascal;
procedure spec128_retraso_memoria(direccion:word);pascal;
procedure spec128_retraso_puerto(puerto:word;primero:boolean);pascal;
function spec128_lg():byte;pascal;

implementation
uses tap_tzx,principal,spectrum_misc;

function spec128_lg:byte;pascal;
begin
spec128_lg:=mouse.lg_val;
end;

procedure Cargar_Spectrum128K;
begin
form1.Spectrum128K1.Checked:=true;
form1.panel2.Visible:=true;
llamadas_maquina.caption:='Spectrum 128K';
llamadas_maquina.iniciar:=iniciar_128k;
llamadas_maquina.bucle_general:=spectrum128_main;
llamadas_maquina.reset:=spec128k_reset;
llamadas_maquina.cintas:=spectrum_tapes;
llamadas_maquina.grabar_snapshot:=grabar_spec;
llamadas_maquina.fps_max:=50;
llamadas_maquina.canales_usados:=2;
llamadas_maquina.cerrar:=spec_cerrar_comun;
llamadas_maquina.configurar:=spectrum_config;
llamadas_maquina.velocidad_cpu:=3546900;
samples_audio:=llamadas_maquina.velocidad_cpu/44100;
samples_beeper:=llamadas_maquina.velocidad_cpu/(44100*beeper_oversample);
spec_retraso.retraso:=spec128_retraso_memoria;
spec_retraso.retraso_puerto:=spec128_retraso_puerto;
stereo:=(audio_128k>0);
tipo_maquina:=1;
end;

procedure spectrum128_main;pascal;
begin
iniciar_entradas;
while EmuStatus=EsRuning do begin
  linea:=0;
  while linea<311 do begin  //16 lineas despues IRQ
    run_z80_sp(spec_z80,spec_llamadas,228);
    borde.borde_spectrum(linea);
    video_128k(@memoria_128k[pantalla_128k,0]);
    dec(spec_z80.contador,228);
    inc(linea);
  end;
  spec_z80.pedir_irq:=true;
  spectrum_irq_long:=spec_z80.contador;
  {gunstick}
  flash:=(flash+1) and $0F;
  if flash=0 then haz_flash:=not(haz_flash);
  if mouse.tipo=1 then evalua_gunstick;
  eventos_spectrum;
  sincronizar;
  evaluar_entradas;
end;
end;

procedure spec128_retraso_memoria(direccion:word);pascal;
var
  temp:byte;
begin
temp:=marco[direccion shr 14];
if (((direccion shr 14)=1) or (((direccion shr 14)=3) and ((temp=1) or (temp=3) or (temp=5) or (temp=7)))) then begin
  temp:=retraso[linea*228+spec_z80.contador];
  inc(testados,temp);
  inc(spec_z80.contador,temp);
end;
end;

procedure spec128_retraso_puerto(puerto:word;primero:boolean);pascal;
var
  temp:byte;
  posicion:dword;
begin
temp:=marco[puerto shr 14];
if not(((puerto shr 14)=1) or (((puerto shr 14)=3) and ((temp=1) or (temp=3) or (temp=5) or (temp=7)))) then exit;
posicion:=linea*228;
if primero then begin //antes del OUT 1t
  if ((puerto and $c000)=$4000) then begin
    inc(testados,retraso[posicion+spec_z80.contador]);
    inc(spec_z80.contador,retraso[posicion+spec_z80.contador]);
  end;
  inc(spec_z80.contador);inc(testados);
end else begin //despues del OUT 3t
  if (puerto and 1)=0 then begin
    inc(testados,retraso[posicion+spec_z80.contador]);
    inc(spec_z80.contador,retraso[posicion+spec_z80.contador]);
    inc(spec_z80.contador,3);inc(testados,3);
  end else begin
    if ((puerto and $c000)=$4000) then begin
      inc(testados,retraso[posicion+spec_z80.contador]);
      inc(spec_z80.contador,retraso[posicion+spec_z80.contador]);
      inc(spec_z80.contador);inc(testados);
      inc(testados,retraso[posicion+spec_z80.contador]);
      inc(spec_z80.contador,retraso[posicion+spec_z80.contador]);
      inc(spec_z80.contador);inc(testados);
      inc(testados,retraso[posicion+spec_z80.contador]);
      inc(spec_z80.contador,retraso[posicion+spec_z80.contador]);
      inc(spec_z80.contador);inc(testados);
    end else begin
      inc(spec_z80.contador,3);inc(testados,3);
    end;
  end;
end;
end;

function spec128_getbyte(direccion:Word): Byte; pascal;
var
        temp:byte;
        temp2:word;
begin
temp:=direccion shr 14;
temp2:=direccion and $3fff;
spec128_getbyte:=memoria_128k[marco[temp],temp2];
end;

procedure spec128_putbyte(direccion:word;valor:byte);pascal;
var
        temp,temp3,dir2:word;
        dir1,f:byte;
begin
dir1:=direccion shr 14;
dir2:=direccion and $3fff;
case dir1 of
  0:exit;
  1:memoria_128k[5,dir2]:=valor;
  2:memoria_128k[2,dir2]:=valor;
  3:memoria_128k[marco[dir1],dir2]:=valor;
end;
if (pantalla_128k=marco[dir1]) then begin
  case dir2 of
    0..$17ff:buffer_video[dir2]:=true;
    $1800..$1aff:begin
                  temp:=((dir2-$1800) shr 5) shl 3;
                  temp3:=(dir2-$1800) and $1f;
                  for f:=0 to 7 do buffer_video[tabla_scr[temp+f]+temp3]:=true;
               end;
  end;
end;
end;

function spec128_inbyte(puerto:word):byte;pascal;
var
        temp:byte;
begin
if (puerto and 1)=0 then begin
  temp:=$FF;
  If (puerto And $8000)=0 Then temp:=temp And keyB_SPC;
  If (puerto And $4000)=0 Then temp:=temp And keyH_ENT;
  If (puerto And $2000)=0 Then temp:=temp And keyY_P;
  If (puerto And $1000)=0 Then temp:=temp And key6_0;
  If (puerto And $800)=0 Then temp:=temp And key1_5;
  If (puerto And $400)=0 Then temp:=temp And keyQ_T;
  If (puerto And $200)=0 Then temp:=temp And keyA_G;
  If (puerto And $100)=0 Then temp:=temp and keyCAPS_V;
  spec128_inbyte:=(temp and $bf) or ear or altavoz;
  exit;
end;
if (((puerto and $30)=$10) and jkempston) then begin
  spec128_inbyte:=kempston;
  exit;
end;
case (puerto and $F002) of
  $C000,$D000,$E000,$F000:begin  //fffd
    spec128_inbyte:=AYRead(0);
    exit;
  end;
end;
if ft_bus[linea*228+spec_z80.contador]=0 then spec128_inbyte:=$FF
  else spec128_inbyte:=memoria_128k[pantalla_128k,ft_bus[linea*228+spec_z80.contador]];
end;

procedure spec128_outbyte(valor:byte;puerto:word);pascal;
var
        old_pant:byte;
begin
        if (puerto and $1)=0 then begin
          if borde.tipo=2 then begin
            fillmemory(@borde.buffer[linea,borde.posicion],spec_z80.contador-borde.posicion,borde.color);
            borde.posicion:=spec_z80.contador;
          end;
          borde.color:=valor and 7;
          altavoz:=(valor and $10) shl 2;
          exit;
        end;
        case (puerto and $F002) of
          $C000,$D000,$E000,$F000:AYControl(valor,0); //fffd
          $8000,$9000,$A000,$B000:AYWrite(valor,0); //bffd
          $1000,$4000,$5000,$6000,$7000:begin //7ffd
                  old_pant:=((valor and 8) shr 2)+5;
                  if old_pant<>pantalla_128k then begin
                    pantalla_128k:=old_pant;
                    fillmemory(@buffer_video[0],6144,1);
                  end;
                  old_7ffd:=valor;
                  if not(paginacion_activa) then exit;
                  paginacion_activa:=(old_7ffd and $20)=0;
                  marco[0]:=((old_7ffd shr 4) and $1)+8;
                  marco[3]:=old_7ffd and $7;
                end;
        end;
end;

function iniciar_128k:boolean;pascal;
var
 f,g,pos:integer;
 h,m:byte;
 rom_cargada:boolean;
 mem_temp:array[0..32767] of byte;
 cadena:string;
begin
iniciar_128k:=false;
zeromemory(@retraso[0],71000);
f:=14361-24;
for h:=0 to 191 do begin
  inc(f,24);
  copymemory(@retraso[f],@cmemory[0],128);
  inc(f,76);
end;
pos:=14368;
for h:=0 to 191 do begin
  f:=f*$100;
  g:=$1800;
  for m:=0 to 7 do begin
    ft_bus[pos]:=f; //4000
    inc(pos);inc(f);
    ft_bus[pos]:=g; //5800
    inc(pos);inc(g);
    ft_bus[pos]:=f; //4001
    inc(pos);inc(f);
    ft_bus[pos]:=g; //5801
    inc(pos);inc(g);
    ft_bus[pos]:=0; //idle
    ft_bus[pos]:=0; //idle
    ft_bus[pos]:=0; //idle
    ft_bus[pos]:=0; //idle
  end;
end;
if not(spec_comun) then exit;
case audio_128k of
  0:iniciar_audio(1);
  1,2:iniciar_audio(2);
end;
spec_llamadas.getbyte:=spec128_getbyte;
spec_llamadas.putbyte:=spec128_putbyte;
spec_llamadas.outbyte:=spec128_outbyte;
spec_llamadas.inbyte:=spec128_inbyte;
getmem(spec_z80,sizeof(reg_z80));
zeromemory(spec_z80,sizeof(reg_z80));
AY8910_init(1773400,0,spec128_lg,nil,nil,nil);
cadena:=changefileext(extractfilename(Directory.spectrum_128),'');
if fileexists(Directory.spectrum_128) then rom_cargada:=carga_rom_zip(Directory.spectrum_128,cadena+'.ROM',@mem_temp[0],$8000)
  else rom_cargada:=cargar_rom(Directory.spectrum_128,@mem_temp[0],$8000);
if not(rom_cargada) then begin
  MessageDlg(leng[idioma].errores[0]+' "'+Directory.spectrum_128+'"', mtError,[mbOk], 0);
  exit;
end;
copymemory(@memoria_128k[8,0],@mem_temp[0],16384);
copymemory(@memoria_128k[9,0],@mem_temp[16384],16384);
spec128k_reset;
iniciar_128k:=true;
end;

procedure spec128k_reset;pascal;
var
        f:word;
begin
reset_misc;
child.Caption:=llamadas_maquina.caption;
for f:=0 to 7 do zeromemory(@memoria_128k[f],16384);
reset_z80(spec_z80);
ay8910_reset(0);
marco[0]:=8;
marco[1]:=5;
marco[2]:=2;
marco[3]:=0;
pantalla_128k:=5;
paginacion_activa:=true;
end;

function get_context_128k:preg_z80;
begin
get_context_128k:=spec_z80;
end;

end.
