unit spectrum_3;

interface
uses sdl,constantes,ay_8910,z80,z80_sp,spectrum_48k,windows,sysutils,upd765,entradas,spectrum_128k,dialogs,lenguaje,cargar_dsk,forms;

var
   old_1ffd:byte;
   memoria_3:array[0..11,0..16383] of byte;
   paginacion_especial:boolean;

procedure Cargar_Spectrum3;
procedure spectrum3_main;pascal;
procedure spec3_putbyte(direccion:word;valor:byte);pascal;
function spec3_inbyte(puerto:word):byte;pascal;
procedure spec3_outbyte(valor:byte;puerto:word);pascal;
function spec3_getbyte(direccion: Word): Byte; pascal;
function iniciar_3:boolean;pascal;
procedure spec3_reset;pascal;
procedure spec3_retraso_memoria(direccion:word);pascal;
procedure spec3_retraso_puerto(puerto:word;primero:boolean);pascal;
function get_context_3:preg_z80;
procedure spectrum3_loaddisk;pascal;

implementation
uses tap_tzx,principal,spectrum_misc;

procedure Cargar_Spectrum3;
begin
form1.Spectrum31.Checked:=true;
llamadas_maquina.caption:='Spectrum +3';
llamadas_maquina.iniciar:=iniciar_3;
llamadas_maquina.cartuchos:=spectrum3_loaddisk;
llamadas_maquina.bucle_general:=spectrum3_main;
llamadas_maquina.cerrar:=spec_cerrar_comun;
llamadas_maquina.cintas:=spectrum_tapes;
llamadas_maquina.reset:=spec3_reset;
llamadas_maquina.grabar_snapshot:=grabar_spec;
llamadas_maquina.canales_usados:=2;
llamadas_maquina.fps_max:=50;
llamadas_maquina.velocidad_cpu:=3546900;
samples_audio:=llamadas_maquina.velocidad_cpu/44100;
samples_beeper:=llamadas_maquina.velocidad_cpu/(44100*beeper_oversample);
llamadas_maquina.configurar:=spectrum_config;
spec_retraso.retraso:=spec3_retraso_memoria;
spec_retraso.retraso_puerto:=spec3_retraso_puerto;
stereo:=audio_128k>0;
tipo_maquina:=2;
end;

procedure spec3_retraso_memoria(direccion:word);pascal;
var
  temp:byte;
begin
exit;
temp:=marco[direccion shr 14];
if ((temp<4) or (temp>7)) then exit;
temp:=retraso[linea*228+spec_z80.contador];
inc(testados,temp);
inc(spec_z80.contador,temp);
end;

procedure spec3_retraso_puerto(puerto:word;primero:boolean);pascal;
begin
exit;
end;

procedure spectrum3_main;pascal;
begin
iniciar_entradas;
while EmuStatus=EsRuning do begin
  linea:=0;
  while linea<311 do begin  //16 lineas despues IRQ
    run_z80_sp(spec_z80,spec_llamadas,228);
    borde.borde_spectrum(linea);
    video_128k(@memoria_3[pantalla_128k,0]);
    dec(spec_z80.contador,228);
    inc(linea);
  end;
  spec_z80.pedir_irq:=true;
  spectrum_irq_long:=spec_z80.contador;
  flash:=(flash+1) and $0F;
  if flash=0 then haz_flash:=not(haz_flash);
  if mouse.tipo=1 then evalua_gunstick;
  eventos_spectrum;
  sincronizar;
  evaluar_entradas;
end;
end;

function spec3_inbyte(puerto:word):byte;pascal;
var
        temp:byte;
begin
spec3_inbyte:=$ff;
if (puerto and 1)=0 then begin
  temp:=$FF;
  If (puerto And $8000)=0 Then temp:=temp And keyB_SPC;
  If (puerto And $4000)=0 Then temp:=temp And keyH_ENT;
  If (puerto And $2000)=0 Then temp:=temp And keyY_P;
  If (puerto And $1000)=0 Then temp:=temp And key6_0;
  If (puerto And $800)=0 Then temp:=temp And key1_5;
  If (puerto And $400)=0 Then temp:=temp And keyQ_T;
  If (puerto And $200)=0 Then temp:=temp And keyA_G;
  If (puerto And $100)=0 Then temp:=temp and keyCAPS_V;
  spec3_inbyte:=(temp and $BF) or ear or altavoz;
  exit;
end;
if (((puerto and $30)=$10) and jkempston) then begin
  spec3_inbyte:=kempston;
  exit;
end;
case (puerto and $F002) of
  $C000,$D000,$E000,$F000:spec3_inbyte:=AYRead(0); //fffd
  $3000,$1000:spec3_inbyte:=ReadFDCData; //3ffd
  $2000:spec3_inbyte:=ReadFDCStatus; //2ffd
end;
end;

procedure memoria_spectrum3;
begin
if not(paginacion_activa) then exit;
paginacion_activa:=(old_7ffd and $20)=0;
paginacion_especial:=(old_1ffd and $1)<>0;
if not(paginacion_especial) then begin //Paginacion normal
  marco[0]:=((old_7ffd shr 4) and $1)+((old_1ffd shr 1) and $2)+8;
  marco[1]:=5;
  marco[2]:=2;
  marco[3]:=old_7ffd and $7;
end else case ((old_1ffd shr 1) and $3) of
  0:begin
      marco[0]:=0;marco[1]:=1;marco[2]:=2;marco[3]:=3;
    end;
  1:begin
      marco[0]:=4;marco[1]:=5;marco[2]:=6;marco[3]:=7;
    end;
  2:begin
      marco[0]:=4;marco[1]:=5;marco[2]:=6;marco[3]:=3;
    end;
  3:begin
      marco[0]:=4;marco[1]:=7;marco[2]:=6;marco[3]:=3;
    end;
end;
end;

procedure spec3_outbyte(valor:byte;puerto:word);pascal;
var
        old_pant:byte;
begin
        if (puerto and 1)=0 then begin
          if borde.tipo=2 then begin
            fillmemory(@borde.buffer[linea,borde.posicion],spec_z80.contador-borde.posicion,borde.color);
            borde.posicion:=spec_z80.contador;
          end;
          borde.color:=valor and 7;
          altavoz:=(valor and $10) shl 2;
          exit;
        end;
        case (puerto and $F002) of
          $C000,$D000,$E000,$F000:AYControl(valor,0); //fffd
          $8000,$9000,$A000,$B000:AYWrite(valor,0); //bffd
          $4000,$5000,$6000,$7000:begin //7ffd
                  old_pant:=((valor and 8) shr 2)+5;
                  if old_pant<>pantalla_128k then begin
                    pantalla_128k:=old_pant;
                    fillmemory(@buffer_video[0],6144,1);
                  end;
                  old_7ffd:=valor;
                  memoria_spectrum3;
                end;
          $3000:WriteFDCData(valor); //3ffd
          $1000:begin //1ffd
                   old_1ffd:=valor;
                   memoria_spectrum3;
                end;
        end;
end;

procedure spec3_putbyte(direccion:word;valor:byte);pascal;
var
  temp,temp3:word;
  f:byte;
  dir1,dir2:word;
begin
dir1:=direccion shr 14;
dir2:=direccion and $3fff;
if (not(paginacion_especial) and (dir1=0)) then exit;
memoria_3[marco[dir1],dir2]:=valor;
if (pantalla_128k=marco[dir1]) then begin
  case dir2 of
    0..$17ff:buffer_video[dir2]:=true;
    $1800..$1aff:begin
                    temp:=((dir2-$1800) shr 5) shl 3;
                    temp3:=((dir2-$1800) and $1f);
                    for f:=0 to 7 do buffer_video[tabla_scr[temp+f]+temp3]:=true;
                  end;
  end;
end;
end;

function spec3_getbyte(direccion: Word): Byte; pascal;
var
        temp:byte;
        temp2:word;
begin
temp:=direccion shr 14;
temp2:=direccion and $3fff;
spec3_getbyte:=memoria_3[marco[temp],temp2];
end;

function iniciar_3:boolean;pascal;
const
  cmem3:array[0..127] of byte=(
   1,0,7,6,5,4,3,2,1,0,7,6,5,4,3,2,1,0,7,6,5,4,3,2,1,0,7,6,5,4,3,2,
   1,0,7,6,5,4,3,2,1,0,7,6,5,4,3,2,1,0,7,6,5,4,3,2,1,0,7,6,5,4,3,2,
   1,0,7,6,5,4,3,2,1,0,7,6,5,4,3,2,1,0,7,6,5,4,3,2,1,0,7,6,5,4,3,2,
   1,0,7,6,5,4,3,2,1,0,7,6,5,4,3,2,1,0,7,6,5,4,3,2,1,0,7,6,5,4,3,2);
var
  f:integer;
  h:byte;
  rom_cargada:boolean;
  mem_temp:array[0..$FFFF] of byte;
  cadena:string;
begin
iniciar_3:=false;
zeromemory(@retraso[0],71000);
f:=14362-24;
for h:=0 to 191 do begin
  inc(f,24);
  copymemory(@retraso[f],@cmem3[0],128);
  inc(f,76);
end;
if not(spec_comun) then exit;
case audio_128k of
  0:iniciar_audio(1);
  1,2:iniciar_audio(2);
end;
spec_llamadas.getbyte:=spec3_getbyte;
spec_llamadas.putbyte:=spec3_putbyte;
spec_llamadas.outbyte:=spec3_outbyte;
spec_llamadas.inbyte:=spec3_inbyte;
getmem(spec_z80,sizeof(reg_z80));
zeromemory(spec_z80,sizeof(reg_z80));
AY8910_init(1773400,0,spec128_lg,nil,nil,nil);
cadena:=changefileext(extractfilename(Directory.spectrum_3),'');
if extension_fichero(Directory.spectrum_3)='ZIP' then rom_cargada:=carga_rom_zip(Directory.spectrum_3,cadena+'.rom',@mem_temp[0],$10000)
  else rom_cargada:=cargar_rom(Directory.spectrum_3,@mem_temp[0],$10000);
if not(rom_cargada) then begin
  MessageDlg(leng[idioma].errores[0]+' "'+Directory.spectrum_3+'" '+leng[idioma].errores[1]+' "PLUS3.ZIP"', mtError,[mbOk], 0);
  exit;
end;
copymemory(@memoria_3[8,0],@mem_temp[0],$4000);
copymemory(@memoria_3[9,0],@mem_temp[$4000],$4000);
copymemory(@memoria_3[10,0],@mem_temp[$8000],$4000);
copymemory(@memoria_3[11,0],@mem_temp[$c000],$4000);
spec3_reset;
iniciar_3:=true;
end;

procedure spec3_reset;pascal;
var
  f:byte;
begin
reset_misc;
for f:=0 to 7 do zeromemory(@memoria_3[f],16384);
reset_z80(spec_z80);
ay8910_reset(0);
marco[0]:=8;
marco[1]:=5;
marco[2]:=2;
marco[3]:=0;
pantalla_128k:=5;
old_1ffd:=0;
old_7ffd:=7;
paginacion_activa:=true;
ResetFDC;
if dsk[0].abierto then child.Caption:=llamadas_maquina.caption+' - DSK: '+dsk[0].ImageName
  else child.Caption:=llamadas_maquina.caption;
end;

function get_context_3:preg_z80;
begin
get_context_3:=spec_z80;
end;

procedure spectrum3_loaddisk;pascal;
begin
Application.createform(Tform6, form6);
try
  form6.showmodal;
finally
  form6.Release;
  FreeAndNil(form6);
end;
end;

end.
