unit spectrum_48k;

interface
uses z80,z80_sp,sdl,constantes,windows,entradas,zipforge,dialogs,lenguaje,sysutils,spectrum_128k;

var
    rom_cambiada_48:boolean=false;

procedure Cargar_Spectrum48K;
function spec48_getbyte(direccion:word): Byte; pascal;
procedure spec48_putbyte(direccion:word;valor:byte);pascal;
function spec48_inbyte(puerto:word):byte;pascal;
procedure spec48_outbyte(valor:byte;puerto:word);pascal;
function iniciar_48k:boolean;pascal;
procedure spectrum48_main;pascal;
function get_context_48k:preg_z80;
procedure spec48k_reset;pascal;
procedure spec48_retraso_memoria(direccion:word);pascal;
procedure spec48_retraso_puerto(puerto:word;primero:boolean);pascal;
procedure borde_48_full(linea:word);
procedure borde_48_normal(linea:word);
procedure sens_lock;

implementation
uses tap_tzx,principal,spectrum_misc,spectrum_3;

procedure Cargar_Spectrum48K;
begin
form1.Spectrum48K1.Checked:=true;
llamadas_maquina.caption:='Spectrum 48K';
llamadas_maquina.iniciar:=iniciar_48k;
llamadas_maquina.bucle_general:=spectrum48_main;
llamadas_maquina.cintas:=spectrum_tapes;
llamadas_maquina.reset:=spec48k_reset;
llamadas_maquina.grabar_snapshot:=grabar_spec;
llamadas_maquina.fps_max:=50;
llamadas_maquina.canales_usados:=2;
llamadas_maquina.cerrar:=spec_cerrar_comun;
llamadas_maquina.configurar:=spectrum_config;
llamadas_maquina.velocidad_cpu:=3500000;
samples_audio:=llamadas_maquina.velocidad_cpu/44100;
samples_beeper:=llamadas_maquina.velocidad_cpu/(44100*beeper_oversample);
spec_retraso.retraso:=spec48_retraso_memoria;
spec_retraso.retraso_puerto:=spec48_retraso_puerto;
tipo_maquina:=0;
interface2.hay_if2:=false;
if not(cinta_tzx.cargada) then sd_1:=false;
end;

procedure borde_48_normal(linea:word);
var
        linea_actual:word;
begin
if ((rapido and ((linea and 7)<>0)) or (borde.tipo=0) or (linea<16) or (linea>303)) then exit;
if borde.buffer[linea,0]=borde.color then exit;
borde.buffer[linea,0]:=borde.color;
linea_actual:=linea-16;
case linea of
        16..63,256..303:begin
                    linea_recta(0,linea_actual,borde.color,352,0);
                    actualiza_trozo_principal(0,linea_actual,352,1);
                end;
        64..255:begin
                    linea_recta(0,linea_actual,borde.color,48,0);
                    linea_recta(304,linea_actual,borde.color,48,0);
                    actualiza_trozo_principal(0,linea_actual,48,1);
                    actualiza_trozo_principal(304,linea_actual,48,1);
                end;
        else exit;
end;
end;

procedure borde_48_full(linea:word);
var
        linea_actual:word;
        ptemp:pword;
        f:word;
begin
if ((rapido and ((linea and 7)<>0)) or (borde.tipo=0) or (linea<16) or (linea>303)) then exit;
if borde.posicion<175 then fillmemory(@borde.buffer[linea,borde.posicion],176-borde.posicion,borde.color);
borde.posicion:=0;
linea_actual:=linea-16;
//24t borde iqz --> 48pixels
ptemp:=punbuf;
for f:=0 to 23 do begin
  ptemp^:=paleta[borde.buffer[linea,f]];
  inc(ptemp);
  ptemp^:=paleta[borde.buffer[linea,f]];
  inc(ptemp);
end;
putpixel(0,linea_actual,48,punbuf,0);
actualiza_trozo_principal(0,linea_actual,48,1);
//24t borde der --> 48 pixels
ptemp:=punbuf;
for f:=152 to 175 do begin
  ptemp^:=paleta[borde.buffer[linea,f]];
  inc(ptemp);
  ptemp^:=paleta[borde.buffer[linea,f]];
  inc(ptemp);
end;
putpixel(304,linea_actual,48,punbuf,0);
actualiza_trozo_principal(304,linea_actual,48,1);
//128t Centro pantalla --> 256 pixels
if ((linea>63) and (linea<256)) then exit;
ptemp:=punbuf;
for f:=24 to 151 do begin
    ptemp^:=paleta[borde.buffer[linea,f]];
    inc(ptemp);
    ptemp^:=paleta[borde.buffer[linea,f]];
    inc(ptemp);
end;
putpixel(48,linea_actual,256,punbuf,0);
actualiza_trozo_principal(48,linea_actual,256,1);
end;

procedure video48k(linea:word);
var
        x,color2,color,atrib,video,temp:byte;
        pant_x,pos_video:word;
        poner_linea:boolean;
        ptemp:pword;
begin
if ((linea<64) or (linea>255)) then exit
  else linea:=linea-64;
poner_linea:=false;
pos_video:=(linea and $f8) shl 2;
for x:=0 to 31 do begin
  atrib:=memoria[$5800+pos_video];
  if ((spec_z80.i>=$40) and (spec_z80.i<=$7F)) then video:=memoria[$4000+tabla_scr[linea]+x+spec_z80.r]
    else video:=memoria[$4000+tabla_scr[linea]+x];
  if (buffer_video[tabla_scr[linea]+x] or (((atrib and $80)<>0)) and not(rapido)) then begin
    buffer_video[tabla_scr[linea]+x]:=false;
    poner_linea:=true;
    pant_x:=48+(x shl 3);
    color2:=(atrib shr 3) and 7;color:=atrib and 7;
    if (atrib and 64)<>0 then begin inc(color,8);inc(color2,8);end;
    if (((atrib and 128)<>0) and haz_flash) then begin temp:=color;color:=color2;color2:=temp;end;
    ptemp:=punbuf;
    if (video and 128)<>0 then ptemp^:=paleta[color] else ptemp^:=paleta[color2];inc(ptemp);
    if (video and 64)<>0 then ptemp^:=paleta[color] else ptemp^:=paleta[color2];inc(ptemp);
    if (video and 32)<>0 then ptemp^:=paleta[color] else ptemp^:=paleta[color2];inc(ptemp);
    if (video and 16)<>0 then ptemp^:=paleta[color] else ptemp^:=paleta[color2];inc(ptemp);
    if (video and 8)<>0 then ptemp^:=paleta[color] else ptemp^:=paleta[color2];inc(ptemp);
    if (video and 4)<>0 then ptemp^:=paleta[color] else ptemp^:=paleta[color2];inc(ptemp);
    if (video and 2)<>0 then ptemp^:=paleta[color] else ptemp^:=paleta[color2];inc(ptemp);
    if (video and 1)<>0 then ptemp^:=paleta[color] else ptemp^:=paleta[color2];
    putpixel(pant_x,linea+48,8,punbuf,0);
  end;
  inc(pos_video);
end;
if poner_linea then actualiza_trozo_principal(48,linea+48,256,1);
end;

procedure spectrum48_main;pascal;
begin
iniciar_entradas;
while EmuStatus=EsRuning do begin
  linea:=0;
  while linea<312 do begin
    run_z80_sp(spec_z80,spec_llamadas,224);
    dec(spec_z80.contador,224);
    borde.borde_spectrum(linea);
    video48k(linea);
    inc(linea);
  end;
  spec_z80.pedir_irq:=true;
  spectrum_irq_long:=spec_z80.contador;
  flash:=(flash+1) and $F;
  if flash=0 then haz_flash:=not(haz_flash);
  spec_z80.im2_lo:=$FF;
  case mouse.tipo of
    1:evalua_gunstick;
    3:begin
        if (mouse.generar_inta and mouse.ie_a) then begin
          spec_z80.im2_lo:=mouse.vec_a;
          mouse.generar_inta:=false;
        end else if (mouse.generar_intb and mouse.ie_b) then begin
          spec_z80.im2_lo:=mouse.vec_b;
          mouse.generar_intb:=false;
        end;
      end;
  end;
  eventos_spectrum;
  sincronizar;
  evaluar_entradas;
end;
end;

procedure spec48_retraso_memoria(direccion:word);pascal;
begin
if (((direccion and $c000)<>$4000) or ((linea<63) and (linea>256))) then exit;
inc(testados,retraso[linea*224+spec_z80.contador]);
inc(spec_z80.contador,retraso[linea*224+spec_z80.contador]);
end;

procedure spec48_retraso_puerto(puerto:word;primero:boolean);pascal;
var
  posicion:dword;
begin
posicion:=linea*224;
if primero then begin //antes del OUT 1t
  if ((puerto and $c000)=$4000) then begin
    inc(testados,retraso[posicion+spec_z80.contador]);
    inc(spec_z80.contador,retraso[posicion+spec_z80.contador]);
  end;
  inc(spec_z80.contador);inc(testados);
end else begin //despues del OUT 3t
  if (puerto and 1)=0 then begin
    inc(testados,retraso[posicion+spec_z80.contador]);
    inc(spec_z80.contador,retraso[posicion+spec_z80.contador]);
    inc(spec_z80.contador,3);inc(testados,3);
  end else begin
    if ((puerto and $c000)=$4000) then begin
      inc(testados,retraso[posicion+spec_z80.contador]);
      inc(spec_z80.contador,retraso[posicion+spec_z80.contador]);
      inc(spec_z80.contador);inc(testados);
      inc(testados,retraso[posicion+spec_z80.contador]);
      inc(spec_z80.contador,retraso[posicion+spec_z80.contador]);
      inc(spec_z80.contador);inc(testados);
      inc(testados,retraso[posicion+spec_z80.contador]);
      inc(spec_z80.contador,retraso[posicion+spec_z80.contador]);
      inc(spec_z80.contador);inc(testados);
    end else begin
      inc(spec_z80.contador,3);inc(testados,3);
    end;
  end;
end;
end;

function spec48_getbyte(direccion:Word): Byte; pascal;
begin
spec48_getbyte:=memoria[direccion];
end;

procedure spec48_putbyte(direccion:word;valor:byte);pascal;
var
        temp,temp2:word;
        f:byte;
begin
if memoria[direccion]=valor then exit; //Si es igual me salgo
case direccion of
        0..$3FFF:exit;
        $4000..$57ff:buffer_video[direccion-$4000]:=true;
        $5800..$5aff:begin
                        temp:=((direccion-$5800) shr 5) shl 3;
                        temp2:=(direccion-$5800) and $1F;
                        for f:=0 to 7 do buffer_video[tabla_scr[temp+f]+temp2]:=true;
                     end;
end;
memoria[direccion]:=valor;
end;

function spec48_inbyte(puerto:word):byte;pascal;
var
  temp:byte;
begin
if (puerto and 1)=0 then begin
  if sd_1 then
    temp:=$DF
    else temp:=$FF;
  If (puerto And $8000)=0 Then temp:=temp And keyB_SPC;
  If (puerto And $4000)=0 Then temp:=temp And keyH_ENT;
  If (puerto And $2000)=0 Then temp:=temp And keyY_P;
  If (puerto And $1000)=0 Then temp:=temp And key6_0;
  If (puerto And $800)=0 Then temp:=temp And key1_5;
  If (puerto And $400)=0 Then temp:=temp And keyQ_T;
  If (puerto And $200)=0 Then temp:=temp And keyA_G;
  If (puerto And $100)=0 Then temp:=temp and keyCAPS_V;
  spec48_inbyte:=(temp and $bf) or ear or altavoz;
  exit;
end;
if (((puerto and $30)=$10) and jkempston and (mouse.tipo<>3)) then begin
  spec48_inbyte:=kempston;
  exit;
end;
if mouse.tipo=3 then begin //AMX Mouse
  case (puerto and $FF) of
    $1f:spec48_inbyte:=mouse.data_a;
    $3f:spec48_inbyte:=mouse.data_b;
    $df:spec48_inbyte:=mouse.botones;
  end;
  exit;
end;
if mouse.tipo=2 then begin //Kempston Mouse
  case puerto of
    $FADF:spec48_inbyte:=mouse.botones;
    $FBDF:spec48_inbyte:=mouse.x;
    $FFDF:spec48_inbyte:=mouse.y;
  end;
  exit;
end;
if ft_bus[linea*224+spec_z80.contador]=0 then spec48_inbyte:=$FF
  else spec48_inbyte:=memoria[ft_bus[linea*224+spec_z80.contador]];
end;

procedure spec48_outbyte(valor:byte;puerto:word);pascal;
begin
if (puerto and 1)=0 then begin
  if borde.tipo=2 then begin
      fillmemory(@borde.buffer[linea,borde.posicion],spec_z80.contador-borde.posicion,borde.color);
      borde.posicion:=spec_z80.contador;
    end;
  borde.color:=valor and 7;
  altavoz:=(valor and $10) shl 2;
  //Aqui se puede ver la dependencia del puerto $FE del
  //altavoz y del ear (Issue 2 y 3). Lo que entra por el
  //altavoz,el ear o el mic afecta a el bit 6... por
  //ejemplo en 'Ole toro' solo acepta pulsaciones de
  //teclado cuando suena la musica, Abu Simbel no empieza
  //correctamente, Rasputin no suena la musica y no
  //empieza al pulsar 0 --> Gracias Pera Putnik!!
  if not(cinta_tzx.play_tape) then begin
    if issue2 then begin
      if (valor and $18)=0 then ear:=0 else ear:=$40;
    end else begin
      if (valor and $10)=0 then ear:=0 else ear:=$40;
    end;
  end;
  exit;
end;
if mouse.tipo=3 then begin  //AMX Mouse
  case (puerto and $FF) of
    $5F:begin
         if (valor and 1)=0 then mouse.vec_a:=valor;
         if (valor and 9)=1 then mouse.ie_a:=(valor and $80)<>0;
        end;
    $7f:begin
         if (valor and 1)=0 then mouse.vec_b:=valor;
         if (valor and 9)=1 then mouse.ie_b:=(valor and $80)<>0;
        end;
  end;
end;
end;

function iniciar_48k:boolean;pascal;
var
        rom_cargada:boolean;
        f,g,pos:integer;
        h,m:byte;
        cadena:string;
begin
iniciar_48k:=false;
zeromemory(@retraso[0],70000);
f:=14335-24;
for h:=0 to 191 do begin
  inc(f,24);
  copymemory(@retraso[f],@cmemory[0],128);
  inc(f,72);
end;
pos:=14347;
for h:=0 to 191 do begin
  f:=$4000+(f*$100);
  g:=$5800;
  for m:=0 to 7 do begin
    ft_bus[pos]:=f; //4000
    inc(pos);inc(f);
    ft_bus[pos]:=g; //5800
    inc(pos);inc(g);
    ft_bus[pos]:=f; //4001
    inc(pos);inc(f);
    ft_bus[pos]:=g; //5801
    inc(pos);inc(g);
    ft_bus[pos]:=0; //idle
    ft_bus[pos]:=0; //idle
    ft_bus[pos]:=0; //idle
    ft_bus[pos]:=0; //idle
  end;
end;
if not(spec_comun) then exit;
iniciar_audio(1);
spec_llamadas.getbyte:=spec48_getbyte;
spec_llamadas.putbyte:=spec48_putbyte;
spec_llamadas.outbyte:=spec48_outbyte;
spec_llamadas.inbyte:=spec48_inbyte;
cadena:=changefileext(extractfilename(Directory.spectrum_48),'');
if extension_fichero(Directory.spectrum_48)='ZIP' then rom_cargada:=carga_rom_zip(Directory.spectrum_48,cadena+'.ROM',@memoria[0],$4000)
  else rom_cargada:=cargar_rom(Directory.spectrum_48,@memoria[0],$4000);
if not(rom_cargada) then begin
  MessageDlg(leng[idioma].errores[0]+' "'+Directory.spectrum_48+'"', mtError,[mbOk], 0);
  exit;
end;
getmem(spec_z80,sizeof(reg_z80));
zeromemory(spec_z80,sizeof(reg_z80));
spec48k_reset;
iniciar_48k:=true;
end;

function get_context_48k:preg_z80;
begin
get_context_48k:=spec_z80;
end;

procedure spec48k_reset;pascal;
begin
reset_misc;
if not(rom_cambiada_48) then child.Caption:=llamadas_maquina.caption;
reset_z80(spec_z80);
zeromemory(@memoria[16384],49152);
end;

procedure sens_lock;
var
  i:byte;
  noffset:integer;
begin
case tipo_maquina of
  0:spec_a_pantalla(@memoria[$4000]);
  1:spec_a_pantalla(@memoria_128k[pantalla_128k,0]);
  2:spec_a_pantalla(@memoria_3[pantalla_128k,0]);
end;
for i:=0 to 15 do begin
  if decode_lenslok[lenslok.indice,i]<>0 then noffset:=round((57*decode_lenslok[lenslok.indice,i])/100)
    else noffset:=round((57*101) div 100);
  StretchBlt(imagen1.canvas.handle, i, 0,1, 32,imagen1.Canvas.Handle,127+noffset, 54+1, 1, 21-2, SRCCOPY);
end;
StretchBlt(form1.image1.canvas.handle, 0, 0,129, 57,imagen1.Canvas.Handle,0, 0, 16, 32, SRCCOPY);
form1.Image1.Visible:=false;
form1.Image1.Visible:=true;
end;

end.
