unit konami_snd;

interface
uses z80,arcade_const,ay_8910,constantes,principal,windows,timers;

type
  konami_call=procedure;pascal;

var
  konami_sl:byte;
  last_totalcycles,clock:integer;
  amplification:byte;

function konamisnd_porta:byte;pascal;
function konamisnd_portb:byte;pascal;
function konamisnd_getbyte(direccion:word):Byte; pascal;
procedure konamisnd_putbyte(direccion:word;valor:byte);pascal;
procedure konamisnd_despues_instruccion;pascal;
procedure konamisnd_init(amp,cpu:byte;clock:single;call:konami_call);pascal;
procedure konamisnd_reset;pascal;

implementation

function konamisnd_porta:byte;pascal;
begin
  konamisnd_porta:=konami_sl;
end;

function konamisnd_portb:byte;pascal;
//const reloj:array[0..9] of byte=(0,$10,$20,$30,$40,$90,$a0,$b0,$a0,$d0);
const reloj:array[0..9] of byte=(0,$10,8,$18,$40,$90,$88,$98,$88,$d0);
var
  current_totalcycles:integer;
begin
current_totalcycles:=snd_z80.contador;
clock:=(clock+(current_totalcycles-last_totalcycles)) mod 5120;
last_totalcycles:=current_totalcycles;
konamisnd_portb:=reloj[clock div 512];
end;

function konamisnd_getbyte(direccion:word): Byte; pascal;
begin
case direccion of
  $4000:konamisnd_getbyte:=AYRead(0);
  $6000:konamisnd_getbyte:=AYRead(1);
    else konamisnd_getbyte:=mem_snd[direccion];
end;
end;

procedure konamisnd_putbyte(direccion:word;valor:byte);pascal;
begin
if direccion<$2000 then exit;
case direccion of
        $4000:AYWrite(valor,0);
        $5000:AYControl(valor,0);
        $6000:AYWrite(valor,1);
        $7000:AYControl(valor,1);
end;
mem_snd[direccion]:=valor;
end;

procedure konamisnd_despues_instruccion;pascal;
begin
if hay_sonido then begin
  tsample[0][posicion_sonido]:=renderbyte(0)^*amplification;
  tsample[1][posicion_sonido]:=renderbyte(1)^*amplification;
  inc(posicion_sonido);
  if posicion_sonido=long_sample then play_sonido;
end;
end;

procedure konamisnd_init(amp,cpu:byte;clock:single;call:konami_call);pascal;
begin
AY8910_init(1789772,0,konamisnd_porta,konamisnd_portb,nil,nil);
AY8910_init(1789772,1,nil,nil,nil,nil);
amplification:=amp;
init_timer(5,cpu,clock/44100,call,true);
end;

procedure konamisnd_reset;pascal;
begin
ay8910_reset(0);
ay8910_reset(1);
konami_sl:=0;
end;

end.
