unit namco;

interface
uses constantes,windows;

procedure namco_playsound;

type
  nvoice=record
          volume:byte;
          numero_onda:byte;
          frecuencia:integer;
          activa:boolean;
          dentro_onda:integer;
         end;

var
  registros_namco:array[0..$1F] of byte;
  voice:array[0..2] of nvoice;
  onda_namco:array[0..255] of byte;

implementation
uses principal;

procedure getvoice(numero_voz:byte);
var
  base:byte;
  f:integer;
begin
    base:=5*numero_voz;
    // Registro $5 --> Elegir la onda a reproducir
    voice[numero_voz].numero_onda:= registros_namco[$5+base] and 7;
    // Registro $15 --> Volumen de la onda
    voice[numero_voz].volume:=(registros_namco[$15 + base ] and $F)div 2;
    // Resgistros $11, $12 y $14 --> Frecuencia
    // Si la voz es la 0 hay un registro mas de frecuencia
    f:=(registros_namco[$14+base] and $F) shl 16;
    f:=f+((registros_namco[$13+base] and $F) shl 12);
    f:=f or ((registros_namco[$12+base] and $F) shl 8);
    f:=f or ((registros_namco[$11+base] and $F) shl 4);
    if numero_voz=0 then f:=f or(registros_namco[$10] and $F);
    voice[numero_voz].frecuencia:=f;
    if ((voice[numero_voz].frecuencia=0) or (voice[numero_voz].volume=0)) then begin
        voice[numero_voz].activa:=false;
        voice[numero_voz].dentro_onda:=0;
    end else voice[numero_voz].activa:=true;
end;

procedure namco_playsound;
var
  numero_voz:byte;
  wave_data:byte;
  i:word;
  offset,offset_step:integer;
  sample:array[0..800] of word;
begin
    for numero_voz:=0 to 2 do begin
        getvoice(numero_voz);
        if voice[numero_voz].activa then begin
            offset:=voice[numero_voz].dentro_onda;
            offset_step:=voice[numero_voz].frecuencia*2177; //resample -> (96Mhz/44100)
            wave_data:=32*voice[numero_voz].numero_onda;
            for i:=0 to long_sample do begin
                sample[i]:=trunc(onda_namco[wave_data+((offset shr 25) and $1F)]*voice[numero_voz].volume);
                inc(offset,offset_step);
                tsample[numero_voz][i]:=sample[i] shl 8;
            end;
            voice[numero_voz].dentro_onda:=offset;
        end;
    end;
end;


end.
