unit tms36xx;

interface
uses windows;

const
   VMIN=$0000;
   VMAX=$7fff;
   A_1=0;A_2=1;A_3=2;A_4=3;A_5=4;
   Ax_1=5;Ax_2=6;Ax_3=7;Ax_4=8;Ax_5=9;
   B_1=10;B_2=11;B_3=12;B_4=13;B_5=14;B_0=60;
   C_1=15;C_2=16;C_3=17;C_4=18;C_5=19;
   Cx_1=20;Cx_2=21;Cx_3=22;Cx_4=23;Cx_5=24;
   D_1=25;D_2=26;D_3=27;D_4=28;D_5=29;
   Dx_1=30;Dx_2=31;Dx_3=32;Dx_4=33;Dx_5=34;
   E_1=35;E_2=36;E_3=37;E_4=38;E_5=39;
   F_1=40;F_2=41;F_3=42;F_4=43;F_5=44;
   Fx_1=45;Fx_2=46;Fx_3=47;Fx_4=48;Fx_5=49;
   G_1=50;G_2=51;G_3=52;G_4=53;G_5=54;
   Gx_1=55;Gx_2=56;Gx_3=57;Gx_4=58;Gx_5=59;
// the frequencies are later adjusted by "* clock / FSCALE" */
  FSCALE=1024;
  tune1_d:array[0..191] of byte=(
	C_3,	0,		0,		C_2,	0,		0,
	G_3,	0,		0,		0,		0,		0,
	C_3,	0,		0,		0,		0,		0,
	G_3,	0,		0,		0,		0,		0,
	C_3,	0,		0,		0,		0,		0,
	G_3,	0,		0,		0,		0,		0,
	C_3,	0,		0,		0,		0,		0,
	G_3,	0,		0,		0,		0,		0,
	C_3,	0,		0,		C_4,	0,		0,
	G_3,	0,		0,		0,		0,		0,
	C_3,	0,		0,		0,		0,		0,
	G_3,	0,		0,		0,		0,		0,
	C_3,	0,		0,		0,		0,		0,
	G_3,	0,		0,		0,		0,		0,
	C_3,	0,		0,		0,		0,		0,
	G_3,	0,		0,		0,		0,		0,
	C_3,	0,		0,		C_2,	0,		0,
	G_3,	0,		0,		0,		0,		0,
	C_3,	0,		0,		0,		0,		0,
	G_3,	0,		0,		0,		0,		0,
	C_3,	0,		0,		0,		0,		0,
	G_3,	0,		0,		0,		0,		0,
	C_3,	0,		0,		0,		0,		0,
	G_3,	0,		0,		0,		0,		0,
	C_3,	0,		0,		C_4,	0,		0,
	G_3,	0,		0,		0,		0,		0,
	C_3,	0,		0,		0,		0,		0,
	G_3,	0,		0,		0,		0,		0,
	C_3,	0,		0,		0,		0,		0,
	G_3,	0,		0,		0,		0,		0,
	C_3,	0,		0,		0,		0,		0,
	G_3,	0,		0,		0,		0,		0);

  tune2_d:array[0..287] of byte=(
	D_3,	D_4,	D_5,	0,		0,		0,
	Cx_3,	Cx_4,	Cx_5,	0,		0,		0,
	D_3,	D_4,	D_5,	0,		0,		0,
	Cx_3,	Cx_4,	Cx_5,	0,		0,		0,
	D_3,	D_4,	D_5,	0,		0,		0,
	A_2,	A_3,	A_4,	0,		0,		0,
	C_3,	C_4,	C_5,	0,		0,		0,
	Ax_2,	Ax_3,	Ax_4,	0,		0,		0,
	G_2,	G_3,	G_4,	0,		0,		0,
	D_1,	D_2,	D_3,	0,		0,		0,
	G_1,	G_2,	G_3,	0,		0,		0,
	Ax_1,	Ax_2,	Ax_3,	0,		0,		0,

	D_2,	D_3,	D_4,	0,		0,		0,
	G_2,	G_3,	G_4,	0,		0,		0,
	A_2,	A_3,	A_4,	0,		0,		0,
	D_1,	D_2,	D_3,	0,		0,		0,
	A_1,	A_2,	A_3,	0,		0,		0,
	D_2,	D_3,	D_4,	0,		0,		0,
	Fx_2,	Fx_3,	Fx_4,	0,		0,		0,
	A_2,	A_3,	A_4,	0,		0,		0,
	Ax_2,	Ax_3,	Ax_4,	0,		0,		0,
	D_1,	D_2,	D_3,	0,		0,		0,
	G_1,	G_2,	G_3,	0,		0,		0,
	Ax_1,	Ax_2,	Ax_3,	0,		0,		0,

	D_3,	D_4,	D_5,	0,		0,		0,
	Cx_3,	Cx_4,	Cx_5,	0,		0,		0,
	D_3,	D_4,	D_5,	0,		0,		0,
	Cx_3,	Cx_4,	Cx_5,	0,		0,		0,
	D_3,	D_4,	D_5,	0,		0,		0,
	A_2,	A_3,	A_4,	0,		0,		0,
	C_3,	C_4,	C_5,	0,		0,		0,
	Ax_2,	Ax_3,	Ax_4,	0,		0,		0,
	G_2,	G_3,	G_4,	0,		0,		0,
	D_1,	D_2,	D_3,	0,		0,		0,
	G_1,	G_2,	G_3,	0,		0,		0,
	Ax_1,	Ax_2,	Ax_3,	0,		0,		0,

	D_2,	D_3,	D_4,	0,		0,		0,
	G_2,	G_3,	G_4,	0,		0,		0,
	A_2,	A_3,	A_4,	0,		0,		0,
	D_1,	D_2,	D_3,	0,		0,		0,
	A_1,	A_2,	A_3,	0,		0,		0,
	D_2,	D_3,	D_4,	0,		0,		0,
	Ax_2,	Ax_3,	Ax_4,	0,		0,		0,
	A_2,	A_3,	A_4,	0,		0,		0,
	0,		0,		0,		G_2,	G_3,	G_4,
	D_1,	D_2,	D_3,	0,		0,		0,
	G_1,	G_2,	G_3,	0,		0,		0,
	0,		0,		0,		0,		0,		0);

  tune3_d:array[0..(96*6)-1] of byte = (
	A_2,	A_3,	A_4,	D_1,	 D_2,	  D_3,
	0,		0,		0,		0,		 0, 	  0,
	A_2,	A_3,	A_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,
	A_2,	A_3,	A_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,

	A_2,	A_3,	A_4,	A_1,	 A_2,	  A_3,
	0,		0,		0,		0,		 0, 	  0,
	G_2,	G_3,	G_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,
	F_2,	F_3,	F_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,

	F_2,	F_3,	F_4,	F_1,	 F_2,	  F_3,
	0,		0,		0,		0,		 0, 	  0,
	E_2,	E_3,	E_4,	F_1,	 F_2,	  F_3,
	0,		0,		0,		0,		 0, 	  0,
	D_2,	D_3,	D_4,	F_1,	 F_2,	  F_3,
	0,		0,		0,		0,		 0, 	  0,

	D_2,	D_3,	D_4,	A_1,	 A_2,	  A_3,
	0,		0,		0,		0,		 0, 	  0,
	F_2,	F_3,	F_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,
	A_2,	A_3,	A_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,

	D_3,	D_4,	D_5,	D_1,	 D_2,	  D_3,
	0,		0,		0,		0,		 0, 	  0,
	0,		0,		0,		D_1,	 D_2,	  D_3,
	0,		0,		0,		F_1,	 F_2,	  F_3,
	0,		0,		0,		A_1,	 A_2,	  A_3,
	0,		0,		0,		D_2,	 D_2,	  D_2,

	D_3,	D_4,	D_5,	D_1,	 D_2,	  D_3,
	0,		0,		0,		0,		 0, 	  0,
	C_3,	C_4,	C_5,	0,		 0, 	  0,
	0,		0,		0, 	  0,		 0, 	  0,
	Ax_2,	Ax_3,	Ax_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,

	Ax_2,	Ax_3,	Ax_4,	Ax_1,	 Ax_2,   Ax_3,
	0,		0,		0,		0,		 0, 	  0,
	A_2,	A_3,	A_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,
	G_2,	G_3,	G_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,

	G_2,	G_3,	G_4,	G_1,	 G_2,	  G_3,
	0,		0,		0,		0,		 0, 	  0,
	A_2,	A_3,	A_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,
	Ax_2,	Ax_3,	Ax_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,

	A_2,	A_3,	A_4,	A_1,	 A_2,	  A_3,
	0,		0,		0,		0,		 0, 	  0,
	Ax_2,	Ax_3,	Ax_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,
	A_2,	A_3,	A_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,

	Cx_3,	Cx_4,	Cx_5,	A_1,	 A_2,	  A_3,
	0,		0,		0,		0,		 0, 	  0,
	Ax_2,	Ax_3,	Ax_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,
	A_2,	A_3,	A_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,

	A_2,	A_3,	A_4,	F_1,	 F_2,	  F_3,
	0,		0,		0,		0,		 0, 	  0,
	G_2,	G_3,	G_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,
	F_2,	F_3,	F_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,

	F_2,	F_3,	F_4,	D_1,	 D_2,	  D_3,
	0,		0,		0,		0,		 0, 	  0,
	E_2,	E_3,	E_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,
	D_2,	D_3,	D_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,

	E_2,	E_3,	E_4,	E_1,	 E_2,	  E_3,
	0,		0,		0,		0,		 0, 	  0,
	E_2,	E_3,	E_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,
	E_2,	E_3,	E_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,

	E_2,	E_3,	E_4,	Ax_1,	 Ax_2,   Ax_3,
	0,		0,		0,		0,		 0, 	  0,
	F_2,	F_3,	F_4,	0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,
	E_2,	E_3,	E_4,	F_1,	 F_2,	  F_3,
	0,		0,		0,		0,		 0, 	  0,

	D_2,	D_3,	D_4,	D_1,	 D_2,	  D_3,
	0,		0,		0,		0,		 0, 	  0,
	F_2,	F_3,	F_4,	A_1,	 A_2,	  A_3,
	0,		0,		0,		0,		 0, 	  0,
	A_2,	A_3,	A_4,	F_1,	 F_2,	  F_3,
	0,		0,		0,		0,		 0, 	  0,

	D_3,	D_4,	D_5,	D_1,	 D_2,	  D_3,
	0,		0,		0,		0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0,
	0,		0,		0,		0,		 0, 	  0);

  tune4_d:array [0..(13*6)-1] of byte = (
//  16'     8'      5 1/3'  4'      2 2/3'  2'      */
	B_0,	B_1,	Dx_2,	B_2,	Dx_3,	B_3,
	C_1,	C_2,	E_2,	C_3,	E_3,	C_4,
	Cx_1,	Cx_2,	F_2,	Cx_3,	F_3,	Cx_4,
	D_1,	D_2,	Fx_2,	D_3,	Fx_3,	D_4,
	Dx_1,	Dx_2,	G_2,	Dx_3,	G_3,	Dx_4,
	E_1,	E_2,	Gx_2,	E_3,	Gx_3,	E_4,
	F_1,	F_2,	A_2,	F_3,	A_3,	F_4,
	Fx_1,	Fx_2,	Ax_2,	Fx_3,	Ax_3,	Fx_4,
	G_1,	G_2,	B_2,	G_3,	B_3,	G_4,
	Gx_1,	Gx_2,	C_3,	Gx_3,	C_4,	Gx_4,
	A_1,	A_2,	Cx_3,	A_3,	Cx_4,	A_4,
	Ax_1,	Ax_2,	D_3,	Ax_3,	D_4,	Ax_4,
	B_1,	B_2,	Dx_3,	B_3,	Dx_4,	B_4);


type

  TMS36XX_dat=record
	  samplerate:integer; 	// from Machine->sample_rate */

	  basefreq:integer;		// chip's base frequency */
	  octave:integer; 		// octave select of the TMS3615 */

	  speed:integer;			// speed of the tune */
	  tune_counter:integer;	// tune counter */
	  note_counter:integer;	// note counter */

	  voices:integer; 		// active voices */
	  shift:integer;			// shift toggles between 0 and 6 to allow decaying voices */
	  vol:array[0..12-1] of integer;		// (decaying) volume of harmonics notes */
	  vol_counter:array[0..12-1] of integer;// volume adjustment counter */
	  decay:array[0..12-1] of integer;		// volume adjustment rate - dervied from decay */

	  counter:array[0..12-1] of integer;	// tone frequency counter */
	  frequency:array[0..12-1] of integer;	// tone frequency */
	  output:integer; 		// output signal bits */
	  enable:integer; 		// mask which harmoics */

	  tune_num:integer;		// tune currently playing */
	  tune_ofs:integer;		// note currently playing */
	  tune_max:integer;		// end of tune */
  end;
  ptms36xx=^tms36xx_dat;
var
  tms_chip:array[0..2] of ptms36xx;
  tunes:array[0..4,0..(96*6)-1] of integer;
  sum:integer;

function tms36xx_sound_update(numero:byte):integer;
procedure tms36xx_start(numero:byte;clock:integer;speed:extended;pdecay:pextended);
procedure mm6221aa_tune_w(numero,tune:integer);
procedure tms36xx_close(numero:byte);

implementation

function C(n:byte):integer;
var
  temp:extended;
begin
	temp:=(FSCALE shl (n-1))*1.18921;	// 2^(3/12) */
  c:=trunc(temp);
end;

function Cx(n:byte):integer;
var
  temp:extended;
begin
	temp:=(FSCALE shl (n-1))*1.25992;	// 2^(4/12) */
  cx:=trunc(temp);
end;

function D(n:byte):integer;
var
  temp:extended;
begin
	temp:=(FSCALE shl (n-1))*1.33484;	// 2^(5/12) */
  d:=trunc(temp);
end;

function Dx(n:byte):integer;
var
  temp:extended;
begin
	temp:=(FSCALE shl (n-1))*1.41421;	// 2^(6/12) */
  Dx:=trunc(temp);
end;

function E(n:byte):integer;
var
  temp:extended;
begin
	temp:=(FSCALE shl (n-1))*1.49831;	// 2^(7/12) */
  e:=trunc(temp);
end;

function F_n(n:byte):integer;
var
  temp:extended;
begin
	temp:=(FSCALE shl (n-1))*1.58740;	// 2^(8/12) */
  f_n:=trunc(temp);
end;

function Fx(n:byte):integer;
var
  temp:extended;
begin
	temp:=(FSCALE shl (n-1))*1.68179;	// 2^(9/12) */
  fx:=trunc(temp);
end;

function G(n:byte):integer;
var
  temp:extended;
begin
	temp:=(FSCALE shl (n-1))*1.78180;	// 2^(10/12) */
  g:=trunc(temp);
end;
function Gx(n:byte):integer;
var
  temp:extended;
begin
	temp:=(FSCALE shl (n-1))*1.88775;	// 2^(11/12) */
  gx:=trunc(temp);
end;
function A(n:byte):integer;
var
  temp:extended;
begin
	temp:=(FSCALE shl n);
  a:=trunc(temp);
end;
function Ax(n:byte):integer;
var
  temp:extended;
begin
	temp:=(FSCALE shl n)*1.05946;		// 2^(1/12) */
  ax:=trunc(temp);
end;

function B(n:byte):integer;
var
  temp:extended;
begin
	temp:=(FSCALE shl n)*1.12246;		// 2^(2/12) */
  b:=trunc(temp);
end;

procedure DECAY(numero:byte;voice:integer);
var
  tms:ptms36xx;
begin
  tms:=tms_chip[numero];
	if (tms.vol[voice] > VMIN )	then begin
		// decay of first voice */
		tms.vol_counter[voice]:=tms.vol_counter[voice]-tms.decay[voice];
		while (tms.vol_counter[voice]<= 0 ) do begin
			tms.vol_counter[voice]:=tms.vol_counter[voice]+44100;//samplerate;
      tms.vol[voice]:=tms.vol[voice]-1;
			if( tms.vol[voice]<= VMIN ) then begin
				tms.frequency[voice]:= 0;
				tms.vol[voice]:= VMIN;
				break;
			end;
		end;
  end;
end;

procedure RESTART(numero:byte;voice:integer);
var
  tms:ptms36xx;
  temp:extended;
begin
  tms:=tms_chip[numero];
	if (tunes[tms.tune_num][tms.tune_ofs*6+voice]<>0) then begin
    temp:=tunes[tms.tune_num][tms.tune_ofs*6+voice] *
			(tms.basefreq shl tms.octave) / FSCALE;
    tms.frequency[tms.shift+voice]:=round(temp);
		tms.vol[tms.shift+voice]:= VMAX;
	end;
end;

procedure TONE(numero:byte;voice:integer);
var
  tms:ptms36xx;
begin
  tms:=tms_chip[numero];
	if (((tms.enable and (1 shl voice))<>0) and (tms.frequency[voice]<>0)) then begin
		// first note */
		tms.counter[voice]:=tms.counter[voice]-tms.frequency[voice];
		while (tms.counter[voice]<=0) do begin
			tms.counter[voice]:=tms.counter[voice]+44100;//= samplerate;
			tms.output:=tms.output xor (1 shl voice);
		end;
		if (tms.output and tms.enable and (1 shl voice)) <>0 then
			sum:=sum+tms.vol[voice];
	end;
end;

function tms36xx_sound_update(numero:byte):integer;
var
  tms:ptms36xx;
  n:integer;
  temp:extended;
begin
  tms:=tms_chip[numero];
    // no tune played? */
	if ((tms.tune_num=0) or (tms.voices=0)) then begin
		tms36xx_sound_update:=0;
    exit;
  end;
	//while( length-- > 0 )
		sum:= 0;

		// decay the twelve voices */
		DECAY(numero,0); DECAY(numero,1); DECAY(numero,2); DECAY(numero,3); DECAY(numero,4); DECAY(numero,5);
		DECAY(numero,6); DECAY(numero,7); DECAY(numero,8); DECAY(numero,9); DECAY(numero,10); DECAY(numero,11);

		// musical note timing */
		tms.tune_counter:=tms.tune_counter-tms.speed;
		if (tms.tune_counter <= 0 ) then begin
			temp:=(-tms.tune_counter/44100) + 1; //samplerate
      n:=trunc(temp);
			tms.tune_counter:=tms.tune_counter+(n * 44100);//samplerate;
      tms.note_counter:=tms.note_counter-n;
			if (tms.note_counter<=0) then begin
				tms.note_counter:=tms.note_counter+VMAX;
				if (tms.tune_ofs < tms.tune_max) then begin
					// shift to the other 'bank' of voices */
          tms.shift:=tms.shift xor 6;
					// restart one 'bank' of voices */
					RESTART(numero,0); RESTART(numero,1); RESTART(numero,2);
					RESTART(numero,3); RESTART(numero,4); RESTART(numero,5);
					tms.tune_ofs:=tms.tune_ofs+1;
				end;
			end;
		end;

   // update the twelve voices */
		TONE(numero,0); TONE(numero,1); TONE(numero,2); TONE(numero,3); TONE(numero,4); TONE(numero,5);
		TONE(numero,6); TONE(numero,7); TONE(numero,8); TONE(numero,9); TONE(numero,10); TONE(numero,11);

    tms36xx_sound_update:=trunc(sum / tms.voices);
end;

procedure mm6221aa_tune_w(numero,tune:integer);
var
  tms:ptms36xx;
begin
    tms:=tms_chip[numero];
    // which tune? */
    tune:=tune and 3;
    if (tune=tms.tune_num) then exit;
    tms.tune_num:= tune;
    tms.tune_ofs:= 0;
    tms.tune_max:= 96; // fixed for now */
end;

procedure tms36xx_reset_counters(numero:byte);
var
  tms:ptms36xx;
begin
    tms:=tms_chip[numero];
    tms.tune_counter:= 0;
    tms.note_counter:= 0;
	  zeromemory(@tms.vol_counter[0],sizeof(tms.vol_counter));
	  zeromemory(@tms.counter[0],sizeof(tms.counter));
end;

procedure tms36xx_note_w(numero:byte;octave,note:integer);
var
  tms:ptms36xx;
begin
  tms:=tms_chip[numero];
	octave:=octave and 3;
	note:=note and 15;

	if (note > 12) then exit;

	// play a single note from 'tune 4', a list of the 13 tones */
	tms36xx_reset_counters(numero);
	tms.octave:= octave;
  tms.tune_num:=4;
	tms.tune_ofs:= note;
	tms.tune_max:= note + 1;
end;

procedure tms3617_enable(numero:byte;enable:integer);
var
  tms:ptms36xx;
  i,bits:integer;
begin
  tms:=tms_chip[numero];
  bits:= 0;

	// duplicate the 6 voice enable bits */
  enable:= (enable and $3f) or ((enable and $3f) shl 6);
	if (enable=tms.enable) then exit;

    for i:=0 to 5 do begin
		  if (enable and (1 shl i))<>0 then bits:=bits+2;	// each voice has two instances */
    end;
	// set the enable mask and number of active voices */
	tms.enable:= enable;
  tms.voices:= bits;
end;

procedure tms36xx_start(numero:byte;clock:integer;speed:extended;pdecay:pextended);
var
  tms:ptms36xx;
	j,f:integer;
	enable:integer;
  p:pextended;
  temp:extended;
begin
  //Primero las tablas
  zeromemory(@tunes[0][0],sizeof(tunes));
  //tune 1
  for f:=0 to 191 do begin
   case tune1_d[f] of
     A_1:tunes[1][f]:=A(1);A_2:tunes[1][f]:=A(2);A_3:tunes[1][f]:=A(3);A_4:tunes[1][f]:=A(4);A_5:tunes[1][f]:=A(5);
     Ax_1:tunes[1][f]:=Ax(1);Ax_2:tunes[1][f]:=Ax(2);Ax_3:tunes[1][f]:=Ax(3);Ax_4:tunes[1][f]:=Ax(4);Ax_5:tunes[1][f]:=Ax(5);
     B_1:tunes[1][f]:=B(1);B_2:tunes[1][f]:=B(2);B_3:tunes[1][f]:=B(3);B_4:tunes[1][f]:=B(4);B_5:tunes[1][f]:=B(5);
     C_1:tunes[1][f]:=C(1);C_2:tunes[1][f]:=C(2);C_3:tunes[1][f]:=C(3);C_4:tunes[1][f]:=C(4);C_5:tunes[1][f]:=C(5);
     Cx_1:tunes[1][f]:=Cx(1);Cx_2:tunes[1][f]:=Cx(2);Cx_3:tunes[1][f]:=Cx(3);Cx_4:tunes[1][f]:=Cx(4);Cx_5:tunes[1][f]:=Cx(5);
     D_1:tunes[1][f]:=D(1);D_2:tunes[1][f]:=D(2);D_3:tunes[1][f]:=D(3);D_4:tunes[1][f]:=D(4);D_5:tunes[1][f]:=D(5);
     Dx_1:tunes[1][f]:=Dx(1);Dx_2:tunes[1][f]:=Dx(2);Dx_3:tunes[1][f]:=Dx(3);Dx_4:tunes[1][f]:=Dx(4);Dx_5:tunes[1][f]:=Dx(5);
     E_1:tunes[1][f]:=E(1);E_2:tunes[1][f]:=E(2);E_3:tunes[1][f]:=E(3);E_4:tunes[1][f]:=E(4);E_5:tunes[1][f]:=E(5);
     F_1:tunes[1][f]:=F_n(1);F_2:tunes[1][f]:=F_n(2);F_3:tunes[1][f]:=F_n(3);F_4:tunes[1][f]:=F_n(4);F_5:tunes[1][f]:=F_n(5);
     Fx_1:tunes[1][f]:=Fx(1);Fx_2:tunes[1][f]:=Fx(2);Fx_3:tunes[1][f]:=Fx(3);Fx_4:tunes[1][f]:=Fx(4);Fx_5:tunes[1][f]:=Fx(5);
     G_1:tunes[1][f]:=G(1);G_2:tunes[1][f]:=G(2);G_3:tunes[1][f]:=G(3);G_4:tunes[1][f]:=G(4);G_5:tunes[1][f]:=G(5);
     Gx_1:tunes[1][f]:=Gx(1);Gx_2:tunes[1][f]:=Gx(2);Gx_3:tunes[1][f]:=Gx(3);Gx_4:tunes[1][f]:=Gx(4);Gx_5:tunes[1][f]:=Gx(5);
   end;
  end;
  //tune 2
  for f:=0 to 287 do begin
   case tune2_d[f] of
     A_1:tunes[2][f]:=A(1);A_2:tunes[2][f]:=A(2);A_3:tunes[2][f]:=A(3);A_4:tunes[2][f]:=A(4);A_5:tunes[2][f]:=A(5);
     Ax_1:tunes[2][f]:=Ax(1);Ax_2:tunes[2][f]:=Ax(2);Ax_3:tunes[2][f]:=Ax(3);Ax_4:tunes[2][f]:=Ax(4);Ax_5:tunes[2][f]:=Ax(5);
     B_1:tunes[2][f]:=B(1);B_2:tunes[2][f]:=B(2);B_3:tunes[2][f]:=B(3);B_4:tunes[2][f]:=B(4);B_5:tunes[2][f]:=B(5);
     C_1:tunes[2][f]:=C(1);C_2:tunes[2][f]:=C(2);C_3:tunes[2][f]:=C(3);C_4:tunes[2][f]:=C(4);C_5:tunes[2][f]:=C(5);
     Cx_1:tunes[2][f]:=Cx(1);Cx_2:tunes[2][f]:=Cx(2);Cx_3:tunes[2][f]:=Cx(3);Cx_4:tunes[2][f]:=Cx(4);Cx_5:tunes[2][f]:=Cx(5);
     D_1:tunes[2][f]:=D(1);D_2:tunes[2][f]:=D(2);D_3:tunes[2][f]:=D(3);D_4:tunes[2][f]:=D(4);D_5:tunes[2][f]:=D(5);
     Dx_1:tunes[2][f]:=Dx(1);Dx_2:tunes[2][f]:=Dx(2);Dx_3:tunes[2][f]:=Dx(3);Dx_4:tunes[2][f]:=Dx(4);Dx_5:tunes[2][f]:=Dx(5);
     E_1:tunes[2][f]:=E(1);E_2:tunes[2][f]:=E(2);E_3:tunes[2][f]:=E(3);E_4:tunes[2][f]:=E(4);E_5:tunes[2][f]:=E(5);
     F_1:tunes[2][f]:=F_n(1);F_2:tunes[2][f]:=F_n(2);F_3:tunes[2][f]:=F_n(3);F_4:tunes[2][f]:=F_n(4);F_5:tunes[2][f]:=F_n(5);
     Fx_1:tunes[2][f]:=Fx(1);Fx_2:tunes[2][f]:=Fx(2);Fx_3:tunes[2][f]:=Fx(3);Fx_4:tunes[2][f]:=Fx(4);Fx_5:tunes[2][f]:=Fx(5);
     G_1:tunes[2][f]:=G(1);G_2:tunes[2][f]:=G(2);G_3:tunes[2][f]:=G(3);G_4:tunes[2][f]:=G(4);G_5:tunes[2][f]:=G(5);
     Gx_1:tunes[2][f]:=Gx(1);Gx_2:tunes[2][f]:=Gx(2);Gx_3:tunes[2][f]:=Gx(3);Gx_4:tunes[2][f]:=Gx(4);Gx_5:tunes[2][f]:=Gx(5);
   end;
  end;
  //tune 3
  for f:=0 to 575 do begin
   case tune3_d[f] of
     A_1:tunes[3][f]:=A(1);A_2:tunes[3][f]:=A(2);A_3:tunes[3][f]:=A(3);A_4:tunes[3][f]:=A(4);A_5:tunes[3][f]:=A(5);
     Ax_1:tunes[3][f]:=Ax(1);Ax_2:tunes[3][f]:=Ax(2);Ax_3:tunes[3][f]:=Ax(3);Ax_4:tunes[3][f]:=Ax(4);Ax_5:tunes[3][f]:=Ax(5);
     B_1:tunes[3][f]:=B(1);B_2:tunes[3][f]:=B(2);B_3:tunes[3][f]:=B(3);B_4:tunes[3][f]:=B(4);B_5:tunes[3][f]:=B(5);
     C_1:tunes[3][f]:=C(1);C_2:tunes[3][f]:=C(2);C_3:tunes[3][f]:=C(3);C_4:tunes[3][f]:=C(4);C_5:tunes[3][f]:=C(5);
     Cx_1:tunes[3][f]:=Cx(1);Cx_2:tunes[3][f]:=Cx(2);Cx_3:tunes[3][f]:=Cx(3);Cx_4:tunes[3][f]:=Cx(4);Cx_5:tunes[3][f]:=Cx(5);
     D_1:tunes[3][f]:=D(1);D_2:tunes[3][f]:=D(2);D_3:tunes[3][f]:=D(3);D_4:tunes[3][f]:=D(4);D_5:tunes[3][f]:=D(5);
     Dx_1:tunes[3][f]:=Dx(1);Dx_2:tunes[3][f]:=Dx(2);Dx_3:tunes[3][f]:=Dx(3);Dx_4:tunes[3][f]:=Dx(4);Dx_5:tunes[3][f]:=Dx(5);
     E_1:tunes[3][f]:=E(1);E_2:tunes[3][f]:=E(2);E_3:tunes[3][f]:=E(3);E_4:tunes[3][f]:=E(4);E_5:tunes[3][f]:=E(5);
     F_1:tunes[3][f]:=F_n(1);F_2:tunes[3][f]:=F_n(2);F_3:tunes[3][f]:=F_n(3);F_4:tunes[3][f]:=F_n(4);F_5:tunes[3][f]:=F_n(5);
     Fx_1:tunes[3][f]:=Fx(1);Fx_2:tunes[3][f]:=Fx(2);Fx_3:tunes[3][f]:=Fx(3);Fx_4:tunes[3][f]:=Fx(4);Fx_5:tunes[3][f]:=Fx(5);
     G_1:tunes[3][f]:=G(1);G_2:tunes[3][f]:=G(2);G_3:tunes[3][f]:=G(3);G_4:tunes[3][f]:=G(4);G_5:tunes[3][f]:=G(5);
     Gx_1:tunes[3][f]:=Gx(1);Gx_2:tunes[3][f]:=Gx(2);Gx_3:tunes[3][f]:=Gx(3);Gx_4:tunes[3][f]:=Gx(4);Gx_5:tunes[3][f]:=Gx(5);
   end;
  end;
  //tune 4
  for f:=0 to 77 do begin
   case tune4_d[f] of
     A_1:tunes[4][f]:=A(1);A_2:tunes[4][f]:=A(2);A_3:tunes[4][f]:=A(3);A_4:tunes[4][f]:=A(4);A_5:tunes[4][f]:=A(5);
     Ax_1:tunes[4][f]:=Ax(1);Ax_2:tunes[4][f]:=Ax(2);Ax_3:tunes[4][f]:=Ax(3);Ax_4:tunes[4][f]:=Ax(4);Ax_5:tunes[4][f]:=Ax(5);
     B_1:tunes[4][f]:=B(1);B_2:tunes[4][f]:=B(2);B_3:tunes[4][f]:=B(3);B_4:tunes[4][f]:=B(4);B_5:tunes[4][f]:=B(5);
     C_1:tunes[4][f]:=C(1);C_2:tunes[4][f]:=C(2);C_3:tunes[4][f]:=C(3);C_4:tunes[4][f]:=C(4);C_5:tunes[4][f]:=C(5);
     Cx_1:tunes[4][f]:=Cx(1);Cx_2:tunes[4][f]:=Cx(2);Cx_3:tunes[4][f]:=Cx(3);Cx_4:tunes[4][f]:=Cx(4);Cx_5:tunes[4][f]:=Cx(5);
     D_1:tunes[4][f]:=D(1);D_2:tunes[4][f]:=D(2);D_3:tunes[4][f]:=D(3);D_4:tunes[4][f]:=D(4);D_5:tunes[4][f]:=D(5);
     Dx_1:tunes[4][f]:=Dx(1);Dx_2:tunes[4][f]:=Dx(2);Dx_3:tunes[4][f]:=Dx(3);Dx_4:tunes[4][f]:=Dx(4);Dx_5:tunes[4][f]:=Dx(5);
     E_1:tunes[4][f]:=E(1);E_2:tunes[4][f]:=E(2);E_3:tunes[4][f]:=E(3);E_4:tunes[4][f]:=E(4);E_5:tunes[4][f]:=E(5);
     F_1:tunes[4][f]:=F_n(1);F_2:tunes[4][f]:=F_n(2);F_3:tunes[4][f]:=F_n(3);F_4:tunes[4][f]:=F_n(4);F_5:tunes[4][f]:=F_n(5);
     Fx_1:tunes[4][f]:=Fx(1);Fx_2:tunes[4][f]:=Fx(2);Fx_3:tunes[4][f]:=Fx(3);Fx_4:tunes[4][f]:=Fx(4);Fx_5:tunes[4][f]:=Fx(5);
     G_1:tunes[4][f]:=G(1);G_2:tunes[4][f]:=G(2);G_3:tunes[4][f]:=G(3);G_4:tunes[4][f]:=G(4);G_5:tunes[4][f]:=G(5);
     Gx_1:tunes[4][f]:=Gx(1);Gx_2:tunes[4][f]:=Gx(2);Gx_3:tunes[4][f]:=Gx(3);Gx_4:tunes[4][f]:=Gx(4);Gx_5:tunes[4][f]:=Gx(5);
   end;
  end;
  p:=pdecay;
  if tms_chip[numero]=nil then begin
    getmem(tms_chip[numero],sizeof(tms36xx_dat));
    zeromemory(tms_chip[numero],sizeof(tms36xx_dat));
  end;
  tms:=tms_chip[numero];
	tms.samplerate:=44100;
	tms.basefreq:=clock;
	enable:=0;
   for j:=0 to 5 do begin
		if (p^>0) then begin
      temp:=VMAX/p^;
			tms.decay[j+0]:=trunc(temp);
      tms.decay[j+6]:=trunc(temp);
			enable:=enable or ($41 shl j);
		end;
    inc(p);
	end;
  temp:=VMAX/speed;
	if (speed > 0) then tms.speed:=trunc(temp)
    else tms.speed:=VMAX;
	tms3617_enable(numero,enable);
end;

procedure tms36xx_close(numero:byte);
begin
    freemem(tms_chip[numero]);
    tms_chip[numero]:=nil;
end;

end.
