unit ym_2151;

interface
uses fm_2151;
type
  IRQ_Handler=procedure (numchip:integer;irqstate:integer);pascal;

function YM2151_status_port_read(num:byte):byte;
procedure YM2151Init(num:byte;clock:integer);
procedure YM2151Init_timers(num:byte;irq_func:IRQ_Handler);
procedure YM2151_register_port_write(num,data:byte);
procedure YM2151_data_port_write(num,data:byte);
procedure YM2151ResetChip(num:byte);
function YM2151UpdateOne(num:byte):pinteger;
procedure YM2151Close(num:byte);

implementation

procedure YM2151Init_timers(num:byte;irq_func:IRQ_Handler);
var
  chip:pYM2151;
begin
  chip:=FM2151[num];
  chip.IRQ_Handler:=irq_func;
end;

function YM2151_status_port_read(num:byte):byte;
begin
	YM2151_status_port_read:=YM_2151ReadStatus(num);
end;

procedure YM2151_register_port_write(num,data:byte);
var
  chip:pYM2151;
begin
  chip:=FM2151[num];
	chip.lastreg:=data;
end;

procedure YM2151_data_port_write(num,data:byte);
var
  chip:pYM2151;
begin
  chip:=FM2151[num];
	YM_2151WriteReg(num,chip.lastreg,data);
end;

procedure YM2151Init(num:byte;clock:integer);
begin
  YM_2151Init(num,clock);
end;

procedure YM2151ResetChip(num:byte);
begin
  YM_2151ResetChip(num);
end;

function YM2151UpdateOne(num:byte):pinteger;
begin
  YM2151UpdateOne:=YM_2151UpdateOne(num);
end;

procedure YM2151Close(num:byte);
begin
  YM_2151Close(num);
end;

end.
