unit timers;

interface
const
  MAX_TIMERS=14;
type
  exec_type=procedure;pascal;
  ttimers=record
           ejecutar:exec_type;  //funcion que hay que llamar
           tiempo:single;     //Tiempo que ha de transcurrir
           tactual:single;    //Tiempo transcurrido
           cpu,dev_asociado:byte;        //CPU asociada al timer y dispositivo asociado
           enabled:boolean; //En marcha?
        end;
var
  //Los temporizadores 5 y 6 son internos para los YMXXX
  //los temporizadores de 7 al 14 son para el Z80CTC
  timer:array[0..MAX_TIMERS] of ttimers;


procedure reset_timer;
procedure update_timer(tiempo,cpu:byte);
procedure init_timer(num,cpu:byte;time:single;exec:exec_type;ena:boolean);

implementation

procedure init_timer(num,cpu:byte;time:single;exec:exec_type;ena:boolean);
begin
timer[num].cpu:=cpu;
timer[num].tiempo:=time;
timer[num].ejecutar:=exec;
timer[num].enabled:=ena;
end;

procedure update_timer(tiempo,cpu:byte);
var
  f:byte;
begin
for f:=0 to MAX_TIMERS do begin
  if (timer[f].enabled and (cpu=timer[f].cpu)) then begin
    timer[f].tactual:=timer[f].tactual+tiempo;
    if timer[f].tactual>=timer[f].tiempo then begin
      timer[f].ejecutar;
      timer[f].tactual:=timer[f].tactual-timer[f].tiempo;
    end;
  end;
end;
end;

procedure reset_timer;
var
  f:byte;
begin
for f:=0 to MAX_TIMERS do begin
  timer[f].tiempo:=0;
  timer[f].tactual:=0;
  timer[f].ejecutar:=nil;
  timer[f].cpu:=0;
  timer[f].enabled:=false;
end;
end;

end.
